/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File:         BlodKorvDebugFlags.h
// Description:  Debugging flags for BlodKorv
// Created:      Feb 10, 2000, 21:00
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//=================================================================== 

#ifdef NO_DEBUG
 #undef NO_DEBUG_VIS
 #define NO_DEBUG_VIS       
#endif

                                        
#define DEBUG_ALLOC_ALL  
//#define DEBUG_ALLOC_OBJ_PTR
//#define DEBUG_ALLOC_OBJ_SIZE
#define DEBUG_ALLOC_OBJ_STATUS
//#define DEBUG_ALLOC_OBJ_TYPE
//#define DEBUG_ALLOC_EVENT_ID
#define DEBUG_ALLOC_NO_REUSE
#define DEBUG_MEMORY_LEAKS

//#define DEBUG_ALLOCATION_FAILURE_HANDLING
//#define DEBUG_ALLOCATOR
#define DEBUG_ARRAY
//#define DEBUG_BIT_SET
//#define DEBUG_BIT_STRING
//#define DEBUG_BIT_WORD
#define DEBUG_BUFFERED_ALLOCATION_STATISTICS
//#define DEBUG_COMMAND_LINE
//#define DEBUG_COMPARISON
//#define DEBUG_EQUIVALENCE_RELATION
#define DEBUG_ERROR_SIGNALS
//#define DEBUG_EXIT 
#define DEBUG_EXPANDING_STACK
#define DEBUG_EXPANDING_MULTISET
//#define DEBUG_FIFO
#define DEBUG_FLOAT
//#define DEBUG_FORMAT_TEXT
//#define DEBUG_G_D_L_LIST
//#define DEBUG_G_INC_COUNTING_SORT
//#define DEBUG_G_LIST
//#define DEBUG_G_SORT_TREE
//#define DEBUG_GLOB_ALLOC
#define DEBUG_GLOBAL_STOP_FLAG
#define DEBUG_LINEAR_COMBINATION
#define DEBUG_LINEAR_POLYNOMIAL
//#define DEBUG_MALLOC
//#define DEBUG_MULTISET
//#define DEBUG_MULTISET_OF_VARIABLES
#define DEBUG_NONSTANDARD_INT
#define DEBUG_OBJECT_POOL
//#define DEBUG_ORD_LIST
//#define DEBUG_PAGE_QUEUE_DISCIPLINE_STORAGE
//#define DEBUG_PROGRESS
#define DEBUG_SHARED_LINEAR_POLYNOMIAL
//#define DEBUG_SKIP_LIST
//#define DEBUG_SMALL_HEADER_SKIP_LIST 
//#define DEBUG_SMALL_HEADER_SKIP_LIST_OF_ARRAYS 
//#define DEBUG_STACK 
#define DEBUG_STATIC_CELL_ARRAY
//#define DEBUG_TIMER

#ifdef NO_DEBUG
 #undef DEBUG_ALLOC_ALL
 #undef DEBUG_ALLOC_OBJ_PTR
 #undef DEBUG_ALLOC_OBJ_SIZE
 #undef DEBUG_ALLOC_OBJ_STATUS
 #undef DEBUG_ALLOC_OBJ_TYPE
 #undef DEBUG_ALLOC_EVENT_ID
 #undef DEBUG_ALLOC_NO_REUSE
 #undef DEBUG_MEMORY_LEAKS
 #undef DEBUG_ALLOCATION_FAILURE_HANDLING
 #undef DEBUG_ALLOCATOR
 #undef DEBUG_ARRAY
 #undef DEBUG_BIT_SET
 #undef DEBUG_BIT_STRING
 #undef DEBUG_BIT_WORD
 #undef DEBUG_BUFFERED_ALLOCATION_STATISTICS
 #undef DEBUG_COMMAND_LINE
 #undef DEBUG_COMPARISON
 #undef DEBUG_EQUIVALENCE_RELATION
 #undef DEBUG_ERROR_SIGNALS
 #undef DEBUG_EXIT  
 #undef DEBUG_EXPANDING_STACK
 #undef DEBUG_EXPANDING_MULTISET
 #undef DEBUG_FIFO
 #undef DEBUG_FLOAT
 #undef DEBUG_FORMAT_TEXT
 #undef DEBUG_G_D_L_LIST
 #undef DEBUG_G_INC_COUNTING_SORT
 #undef DEBUG_G_LIST
 #undef DEBUG_G_SORT_TREE
 #undef DEBUG_GLOB_ALLOC
 #undef DEBUG_GLOBAL_STOP_FLAG
 #undef DEBUG_LINEAR_COMBINATION
 #undef DEBUG_LINEAR_POLYNOMIAL
 #undef DEBUG_MALLOC
 #undef DEBUG_MULTISET
 #undef DEBUG_MULTISET_OF_VARIABLES
 #undef DEBUG_NONSTANDARD_INT
 #undef DEBUG_OBJECT_POOL
 #undef DEBUG_ORD_LIST
 #undef DEBUG_PAGE_QUEUE_DISCIPLINE_STORAGE
 #undef DEBUG_PROGRESS
 #undef DEBUG_SHARED_LINEAR_POLYNOMIAL
 #undef DEBUG_SKIP_LIST
 #undef DEBUG_SMALL_HEADER_SKIP_LIST 
 #undef DEBUG_SMALL_HEADER_SKIP_LIST_OF_ARRAYS 
 #undef DEBUG_STACK 
 #undef DEBUG_STATIC_CELL_ARRAY
 #undef DEBUG_TIMER
#else
 #ifdef DEBUG_ALL
  #define DEBUG_ALLOCATION_FAILURE_HANDLING
  #define DEBUG_ALLOCATOR
  #define DEBUG_ARRAY
  #define DEBUG_BIT_SET
  #define DEBUG_BIT_STRING
  #define DEBUG_BIT_WORD
  #define DEBUG_BUFFERED_ALLOCATION_STATISTICS
  #define DEBUG_COMMAND_LINE
  #define DEBUG_COMPARISON
  #define DEBUG_EQUIVALENCE_RELATION
  #define DEBUG_ERROR_SIGNALS
  #define DEBUG_EXIT 
  #define DEBUG_EXPANDING_STACK
  #define DEBUG_EXPANDING_MULTISET
  #define DEBUG_FIFO
  #define DEBUG_FLOAT
  #define DEBUG_FORMAT_TEXT
  #define DEBUG_G_D_L_LIST
  #define DEBUG_G_INC_COUNTING_SORT
  #define DEBUG_G_LIST
  #define DEBUG_G_SORT_TREE
  #define DEBUG_GLOB_ALLOC  
  #define DEBUG_GLOBAL_STOP_FLAG
  #define DEBUG_LINEAR_COMBINATION
  #define DEBUG_LINEAR_POLYNOMIAL
  #define DEBUG_MALLOC
  #define DEBUG_MULTISET
  #define DEBUG_MULTISET_OF_VARIABLES
  #define DEBUG_NONSTANDARD_INT
  #define DEBUG_OBJECT_POOL
  #define DEBUG_ORD_LIST 
  #define DEBUG_PAGE_QUEUE_DISCIPLINE_STORAGE
  #define DEBUG_PROGRESS
  #define DEBUG_SHARED_LINEAR_POLYNOMIAL
  #define DEBUG_SKIP_LIST
  #define DEBUG_SMALL_HEADER_SKIP_LIST 
  #define DEBUG_SMALL_HEADER_SKIP_LIST_OF_ARRAYS 
  #define DEBUG_STACK 
  #define DEBUG_STATIC_CELL_ARRAY
  #define DEBUG_TIMER
 #endif
#endif

#ifdef DEBUG_ALLOC_ALL
 #undef DEBUG_ALLOC_OBJ_PTR
 #undef DEBUG_ALLOC_OBJ_SIZE
 #undef DEBUG_ALLOC_OBJ_STATUS
 #undef DEBUG_ALLOC_OBJ_TYPE
 #undef DEBUG_ALLOC_EVENT_ID
 
 #define DEBUG_ALLOC_OBJ_PTR
 #define DEBUG_ALLOC_OBJ_SIZE
 #define DEBUG_ALLOC_OBJ_STATUS
 #define DEBUG_ALLOC_OBJ_TYPE
 #define DEBUG_ALLOC_EVENT_ID
#endif

#undef DEBUG_ALLOC

#if ((defined DEBUG_ALLOC_OBJ_PTR) \
     || (defined DEBUG_ALLOC_OBJ_SIZE) \
     || (defined DEBUG_ALLOC_OBJ_STATUS) \
     || (defined DEBUG_ALLOC_OBJ_TYPE) \
     || (defined DEBUG_ALLOC_EVENT_ID) \
     || (defined DEBUG_ALLOC_NO_REUSE))
 #define DEBUG_ALLOC
#endif





//==========================================================================

