/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File:         ClassDesc.cpp
// Description:  Structure for class descriptors used in dynamic type control.
// Created:      Mar 2, 2000, 17:10
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//====================================================

#ifndef NO_DEBUG
//====================================================
#include "ClassDesc.h"
//====================================================
using namespace BK;

long ClassDesc::InitStatic::_count; // Implicitely initialised to 0L
ClassDesc::List* ClassDesc::_registered;
ClassDesc ClassDesc::_universal("UniversalClass");
//====================================================
ostream& ClassDesc::outputAll(ostream& str,bool objectStatistics)
{
 str << "************* Registered classes: ***************\n";
 for (const List* cd = registeredClasses(); cd; cd = cd->next())
  {   
   str << cd->hd()->name() << ": min.size = " << cd->hd()->minSize() << ", max.size = " << cd->hd()->maxSize() << "\n";
   if (objectStatistics)
    {
     for (const SizeAllocDeallocList* obj =  cd->hd()->registeredObjects(); obj; obj = obj->next())
      {
       str << "     objects of the size " << obj->size() 
           << ": persistent " << obj->numOfAllocated() - obj->numOfDeallocated()
           << " = allocated " << obj->numOfAllocated()
           << " - deallocated " << obj->numOfDeallocated()
           << "\n"; 
      };
    };
  };
 str << "************* End of registered classes. ********\n"; 
 return str;
}; // ostream& ClassDesc::outputAll(ostream& str,bool objectStatistics)

//====================================================
#endif
