/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File:         DestructionMode.h
// Description:  Global flag, regulating destruction. 
// Created:      May 23, 2002, Alexandre Riazanov, riazanov@cs.man.ac.uk
//====================================================
#ifndef DESTRUCTION_MODE_H
#define DESTRUCTION_MODE_H
//=================================================
namespace BK 
{

class DestructionMode
{
 public:
  class InitStatic
  {
   public:
    InitStatic() 
     {    
      if (!_count) { _isThorough = true; _count++; }; 
     };
    ~InitStatic() {};
   private:
    static long _count; 
  };
 public:
  static bool isFast() { return !_isThorough; };
  static bool isThorough() { return _isThorough; };
  static void makeFast() { _isThorough = false; };
  static void makeThorough() { _isThorough = true; };
 private:
  static bool _isThorough;
};

static DestructionMode::InitStatic destructionModeInitStatic;


}; // namespace BK

//=================================================
#endif
