/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
// File:         RuntimeError.hpp
// Description:  
// Created:      Oct 31, 2000, 18:05
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//
#ifndef RUNTIME_ERROR_H 
//======================================================================
#define RUNTIME_ERROR_H
#include "jargon.hpp"
//=====================================================================


namespace BK 
{

class RuntimeError
{
 public:
  static void report(const char* msg) 
    { 
      if (errorHook) 
	{
	  void (*tmpErrorHook)();
	  tmpErrorHook = errorHook;
	  errorHook = 0;
	  tmpErrorHook();
	};
      reportFun(msg); 
    };
  static void defaultReport(const char* msg);
  static void report(const char* msg1,const char* msg2) 
    {  
      if (errorHook) 
	{
	  void (*tmpErrorHook)();
	  tmpErrorHook = errorHook;
	  errorHook = 0;
	  tmpErrorHook();
	};
      reportFun2(msg1,msg2); 
    };
  static void defaultReport2(const char* msg1,const char* msg2);
  static void report(const char* msg1,const char* msg2,const char* msg3) 
    { 
      if (errorHook) 
	{
	  void (*tmpErrorHook)();
	  tmpErrorHook = errorHook;
	  errorHook = 0;
	  tmpErrorHook();
	};
      reportFun3(msg1,msg2,msg3); 
    };
  static void defaultReport3(const char* msg1,const char* msg2,const char* msg3);
  
  static void (*reportFun)(const char* msg);
  static void (*reportFun2)(const char* msg1,const char* msg2);
  static void (*reportFun3)(const char* msg1,const char* msg2,const char* msg3);
  static void (*errorHook)();
};

}; // namespace BK

//===================================================================
#endif
