/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
#include <iostream.h>
#include <stdlib.h>
#include "Timer.hpp"
using namespace BK;

long randomNumber()
{
  int base = rand() % 256;
  int bit = rand() % 2;
  if (bit) return base;
  return -base;
};


#define DIFF_NUMBERS 100000
#define ITERATIONS 10000

long arg1[DIFF_NUMBERS];
long arg2[DIFF_NUMBERS];
float farg1[DIFF_NUMBERS];
float farg2[DIFF_NUMBERS];
double darg1[DIFF_NUMBERS];
double darg2[DIFF_NUMBERS];

int main()
{
  for (int i = 0; i < DIFF_NUMBERS; ++i)
    {
      arg1[i] = randomNumber();
      arg2[i] = randomNumber();
      
      farg1[i] = (float)arg1[i];
      farg2[i] = (float)arg2[i];
      
      darg1[i] = (double)arg1[i];
      darg2[i] = (double)arg2[i];      
    };
  
  Timer timer;
  long n;
  float fn;
  double dn;
  bool b;


  cout << "MULTIPLICATION\n";
  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        n = arg1[i] * arg2[i];
      };

  timer.stop();
  cout << "   long   " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        fn = farg1[i] * farg2[i];
      };
  timer.stop();
  cout << "   float  " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        dn = darg1[i] * darg2[i];
      };
  timer.stop();
  cout << "   double " << timer.elapsed() << "\n";




  cout << "ADDITION\n";
  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        n = arg1[i] + arg2[i];
      };

  timer.stop();
  cout << "   long   " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        fn = farg1[i] + farg2[i];
      };
  timer.stop();
  cout << "   float  " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        dn = darg1[i] + darg2[i];
      };
  timer.stop();
  cout << "   double " << timer.elapsed() << "\n";



  cout << "SUBTRACTION\n";
  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        n = arg1[i] - arg2[i];
      };

  timer.stop();
  cout << "   long   " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        fn = farg1[i] - farg2[i];
      };
  timer.stop();
  cout << "   float  " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        dn = darg1[i] - darg2[i];
      };
  timer.stop();
  cout << "   double " << timer.elapsed() << "\n";



  cout << "EQUALITY\n";
  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        b = (arg1[i] == arg2[i]);
      };

  timer.stop();
  cout << "   long   " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        b = (farg1[i] == farg2[i]);
      };
  timer.stop();
  cout << "   float  " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        b = (darg1[i] == darg2[i]);
      };
  timer.stop();
  cout << "   double " << timer.elapsed() << "\n";


  cout << "GREATER\n";
  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        b = (arg1[i] > arg2[i]);
      };

  timer.stop();
  cout << "   long   " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        b = (farg1[i] > farg2[i]);
      };
  timer.stop();
  cout << "   float  " << timer.elapsed() << "\n";

  timer.reset();
  timer.start();
  for (int j = 0; j < ITERATIONS; ++j)
    for (int i = 0; i < DIFF_NUMBERS; ++i)
      {
        b = (darg1[i] > darg2[i]);
      };
  timer.stop();
  cout << "   double " << timer.elapsed() << "\n";

  
};
