/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File:         jargon.h
// Description:  Frequently used definitions.
// Created:      May 5, 2000, 20:20
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//============================================================================
#ifndef JARGON_H
//============================================================================
#define JARGON_H
#include "target.h"
#include "compiler.h"
typedef unsigned long ulong;


namespace BK 
{

class DummyArgument
{
 public:
  DummyArgument() {};
  void touch() const {};
};

static DummyArgument dummyArgument;


inline
void init(long& x) {};
inline
void init(long& x,const long& y) 
{
  x = y;
};
inline
void init(long& x,const DummyArgument& da) 
{
#if (!defined NO_DEBUG) || (defined _SUPPRESS_WARNINGS_)
  da.touch();
#endif
  x = 0L;
};

inline
void destroy(long& x) {};
inline
void relocateFrom(long& x,long& y)
{
  x = y;
};

inline
void init(ulong& x) {};
inline
void init(ulong& x,const ulong& y) 
{
  x = y;
};
inline
void init(ulong& x,const DummyArgument& da) 
{
#if (!defined NO_DEBUG) || (defined _SUPPRESS_WARNINGS_)
  da.touch();
#endif
  x = 0UL;
};
inline
void destroy(ulong& x) {};
inline
void relocateFrom(ulong& x,ulong& y)
{
  x = y;
};

template <class T>
inline
void init(T*& x) {};

template <class T>
inline
void init(T*& x,const T*& y) 
{
  x = y;
};

template <class T>
inline
void init(T*& x,const DummyArgument& da) 
{
#if (!defined NO_DEBUG) || (defined _SUPPRESS_WARNINGS_)
  da.touch();
#endif
  x = (T*)0;
};

template <class T>
inline
void destroy(T*& x) {};

template <class T>
inline
void relocateFrom(T*& x,T*& y)
{
  x = y;
};


template <class T>
inline
void touch(const T& x) 
{
};


}; // namespace BK




//============================================================================
#endif
