;==================================================================
;
;                          resini.scm
;
;                   Gandalf version c-2.6 r1
;
;
;  Top-level initialisation for compiled version only.
;
;  Other files: resbase.scm
;              (basic operations, incl subst. unif. and subsumption)
;               resio.scm
;
;====================================================================



;;;;;;;;; *********************************************************

(define user-interrupt quit)

; top-level-actions calls the prover with command line arguments
; interpreted as problem file names, instead of reading these
; as scheme source and entering top level loop.

(define (top-level-actions)
  (verbose 0)
  (let ((filename '())
        (prog-args (program-arguments))
        (timelimit 300)
        (tmp '()) )
    (if (and (pair? prog-args)
             (pair? (cdr prog-args))
             (equal? "-time" (cadr prog-args))
             (pair? (cddr prog-args)) )
        (begin
          (set! timelimit (caddr prog-args))
          (if (not (string->number timelimit))
              (begin
                (newline)
	              (display "Wrong time format: use a number.")
	              (newline)
	              (quit) ))
          (set! *timelimit* timelimit)
          (set! *args-timelimit* timelimit)
          (set! prog-args (cons (car prog-args) (cdddr prog-args))) ))
    (cond
      ; no input
      ((or (null? prog-args)
	    (null? (cdr prog-args)) )
	  (newline)
    (display "Gandalf c-2.6 r1 starting, but no input files given:")
    (newline)
    (display "halting.")
	  (newline)
	  (quit) )
      ; try to show satisfiability
      ((and (not (null? (cddr prog-args)))
            (equal? "-sat" (cadr prog-args)) )
          (set! filename (caddr prog-args))
          (display "Gandalf c-2.6 r1 starting to show satisfiability: ")
	  (display filename)
	  (newline)
	  (set! *sat-strategy-flag* #t)
	  (set! *full-proof-strategy-flag* #f)
	  (fprove filename) )
      ((and (not (null? (cddr prog-args)))
            (equal? "-proof" (cadr prog-args)) )
          (set! filename (caddr prog-args))
          (display "Gandalf c-2.6 r1 starting to prove (full proof mode): ")
	  (display filename)
	  (newline)
	  (set! *sat-strategy-flag* #f)
	  (set! *full-proof-strategy-flag* #t)
	  (fprove filename) )
      ; refute
      (else
      	  (set! filename (cadr prog-args))
	  (newline)
	  ; (display "*******************************************")
	  ; (newline)
	  (display "Gandalf c-2.6 r1 starting to prove: ")
	  (display filename)
	  (newline)
	  (set! *sat-strategy-flag* #f)
	  (set! *full-proof-strategy-flag* #f)
	  (fprove filename)
    	  (newline)
	  (quit) ))))

; the following call always exits the whole program

; (top-level-actions)
