// prototypes shared by SCOTT and FINDER sources

// main calls from SCOTT.c
boolean model(char clause[], int in_theory, boolean test_only);
void output_the_model(int new_theory);
boolean equality_is_present();
void add_declaration(unsigned char declaration[]);
void set_time_limit(int limit);
void inc_time_limit();
void dec_min_prob_extn();
void inc_cardinality();
void reset_optimal();

// main calls from FINDER.c
void message(int priority, char *msg, ...);
void record_event(char *event, ...);
int get_num_maxisets();

// Initing routines
boolean declare_otter_symbols();
boolean init_finder(char filename[]);
void set_backtrack_limit(int new_limit, int new_theory);
void set_min_prob_extn(float min_prob_extn);
void set_min_backtrack_limit(int maxiset);
void set_max_backtrack_limit(int maxiset);
void set_min_time_limit(int limit);
void set_max_time_limit(int limit);
void set_tolerance(float limit);
void init_theory(int theory);

// FINDER.c called by output_finder_stats()
boolean get_old_optimal(int theory);
int get_clauses_modelled(int theory);
int get_failed_searches(int theory);
int get_last_default_size(int theory);
int get_max_backtracks_in(int theory);
int get_max_time_in(int theory);
int get_searches(int theory);
int get_size(int theory);
int get_successful_searches(int theory);
int get_tests(int theory);
int get_time_outs();
int get_time_outs_in_test();
int get_updates(int theory);
int get_time_limit();
int get_time_limit_resets(int theory);
