;;;*************************************************************************
;; ------------------------
;; GENERAL GLOBAL VARIABLES
;; ------------------------
(module globals
(include "setheo.sch")
(export 

actual-c-stack
actual-copy 
actual-depth
all-global-subgoals
antilemmas
antilemma-test
bound-fail
c-stack
c-stack-root
clause-reordering
clause-type-reliable
conjecture-value
conjecture-value1
constraint-fails
constraints
current-complexity
current-copy
current-subgoal
current-vars
debug
decomposition-cost
depth
d-pairs
eager-vel
eq-clause
eq-links
eq-predicate
eq-subgoal-stack
equal-predecessor-fail
equality
error-on-empty
extension-limit
extension-steps
failed-inferences
failinfo
failinfo-pruning
ff
fff
filename
final-depth
foldup
foldup-root
formula
free-sig
global-reordering
global-subgoals
glob-inf
in-index? 
index
index-bindings
index-foldup
index-root
index-size
inf
infix
lemmas
lemmatype
loc-index
matings-pruning
maxinput-lemmas
max-lemmas
max-variables
new-complexity
new-vars
norel
nr-lemmas
nr-matchings
nr-reduction-steps
nr-subgoals
nth-variable
old-copy-subgoals
old-free-sig
old-sig-trail-position
optimized-unification
printindex
printlemmas
proof-output
regularity
regularity-only-for-subgoals
sgindex
side-reordering
sig-trail
sig-trail-position
sig-vector
signature-bound
start-clauses
strong-regularity
subgoal-alternation
subgoal-complexity-measure
subgoal-reordering
subgoals-stack
successful-inferences
successful-matchings
successful-reduction-steps
test-grounding
total-constraint-fails
total-failed-inferences
total-successful-inferences
total-successful-matchings
trail 
trail-root 
unif-trail
unif-trail-root
units-double
ulemmas
uselemmas
var2
v-trail
v-trail-root
variable-names
var-assoc
var-assoc-nr?
wd1
wd2
wd3
weighted-depth
weighted-depth-entered

)
(export (update-defaults args)))

(define trail-root (list (cons #f #f)))
(define trail trail-root)
(define v-trail-root (list (vector #f #f #f #f)))
(define v-trail v-trail-root)
(define unif-trail-root (list (cons #f #f)))
(define unif-trail unif-trail-root)
(define c-stack-root (list #f))
(define c-stack c-stack-root)
(define actual-c-stack c-stack)
(define eq-links '())
(define filename #f)
(define formula (make-vector 3))
(set-formula-lemmas formula '()) ;; macro
(define start-clauses '())
(define norel #f)
(define global-subgoals #f)
(define actual-copy (make-vector 10))
(define all-global-subgoals #f)
(define current-subgoal #f)
(define current-complexity #f)
(define subgoal-complexity-measure 0)
(define new-complexity #f)
(define current-vars #f)
(define new-vars #f)
(define optimized-unification #f)
(define bound-fail #f)
(define actual-depth 0)
(define free-sig 0)
(define old-free-sig 0)
(define sig-vector #f)
(define sig-trail #f)
(define sig-trail-position 0)
(define old-sig-trail-position 0)
(define proof-output #f)
(define successful-inferences 0)
(define successful-matchings 0)
(define successful-reduction-steps 0)
(define inf 0)
(define nr-reduction-steps 0)
(define nr-matchings 0)
(define failed-inferences 0)
(define constraint-fails 0)
(define total-successful-inferences 0)
(define total-successful-matchings 0)
(define total-failed-inferences 0)
(define total-constraint-fails 0)
(define index-root #f)
(define index #f)
(define in-index? #t)
(define index-bindings (make-vector 100 #f))
(define max-variables 0) 
(define nth-variable 0)
(define var-assoc-nr? #f)
(define constraints #f)
(define regularity #f)
(define regularity-only-for-subgoals #t)
(define sgindex #f)
(define nr-subgoals 0)
(define index-size 0)
(define test-grounding #f)
(define foldup #f)
(define foldup-root (make-vector 10 #f))
(define strong-regularity #f)
(define index-foldup #f)
(define printindex #f)
(define nr-lemmas 0)
(define lemmatype 0)
(define extension-steps 0)
(define extension-limit #f)
(define error-on-empty #t)
(define eq-subgoal-stack '())
(define d-pairs '())
(define eq-predicate #f)
(define debug #f)
(define infix #f)
(define eq-clause #f)
(define old-copy-subgoals #f)
(define antilemma-test #t)
(define antilemmas #f)
(define current-copy #f)
(define units-double #f)
(define side-reordering #f)
(define var2 0)
(define ff #f)
(define fff #f)
(define eager-vel #f)
(define failinfo #f)
(define failinfo-pruning 0)
(define loc-index '())
(define lemmas #f)
(define max-lemmas 0)
(define conjecture-value 100)
(define conjecture-value1 100)
(define printlemmas 0)
(define uselemmas 0)
(define ulemmas #f)
(define var-assoc '())
(define maxinput-lemmas 0)
(define glob-inf 1)

;;;*************************************************************************
;; -----------------------------------------
;; DEFAULTS SETTINGS FOR THE SEARCH STRATEGY
;; -----------------------------------------

(define clause-reordering #f)
(define subgoal-alternation #f)
(define subgoal-reordering #f)
(define global-reordering #f)
(define clause-type-reliable #t)
(define signature-bound #f)
(define equality #f)
(define equal-predecessor-fail #f)
(define depth 1)
(define final-depth 0)
(define weighted-depth #f)
(define weighted-depth-entered 0)
(define wd1 90)
(define wd2 100)
(define wd3 90)
(define matings-pruning #f)
(define subgoals-stack #f)
(define variable-names '())
(define decomposition-cost #f)

;;;*************************************************************************
;; ---------------------------
;; UPDATE OF DEFAULTS SETTINGS
;; ---------------------------

(define (update-defaults args)
 (if (pair? (cdr args))
     (cond ((equal? (car args) "-d")
            (set! final-depth (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-id")
            (set! depth (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-noclreord")
            (set! clause-reordering #f)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-wdr")
            (set! weighted-depth #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-wd1")
            (set! weighted-depth #t)
            (set! wd1 (string->integer (cadr args)))
            (update-defaults (cddr args)))
           ((equal? (car args) "-wd2")
            (set! weighted-depth #t)
            (set! wd2 (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-wd3")
            (set! weighted-depth #t)
            (set! wd3 (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-sig")
            (set! signature-bound #t)
            (set! free-sig (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-dynsgreord")
            (set! subgoal-reordering (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-units-double")
            (set! units-double #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-complexity")
            (set! subgoal-complexity-measure (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-singledelay")
            (set! subgoal-alternation 1)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-reg")
            (set! constraints #t) (set! regularity #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-hreg")
            (set! constraints #t) (set! regularity #t)
	    (set! regularity-only-for-subgoals #f)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-anl")
            (set! constraints #t) (set! antilemmas #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-decomp-cost")
            (set! decomposition-cost (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-cons")
            (set! constraints #t) (set! antilemmas #t) (set! regularity #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-multidelay")
            (set! subgoal-alternation 2)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-globreord")
            (set! global-reordering #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-mate")
            (set! matings-pruning #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-proof")
            (set! proof-output '())
	    (update-defaults (cdr args)))
           ((equal? (car args) "-debug")
	    (set! debug #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-sgindex")
            (set! sgindex #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-equality")
            (set! equality #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-norel")
            (set! norel #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-foldup")
            (set! foldup #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-indexfoldup")
            (set! index-foldup #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-printindex")
            (set! printindex #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-lemmas")
            (set! max-lemmas (string->integer (cadr args)))
            (set! conjecture-value (string->integer (caddr args)))
	    (set! lemmas '())
	    (update-defaults (cdddr args)))
           ((equal? (car args) "-input-lemmas")
            (set! maxinput-lemmas (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-uselemmas")
            (set! uselemmas (string->integer (cadr args)))
	    (if (> uselemmas 0)
		(begin (set! conjecture-value1 (string->integer (caddr args)))
		       (set! ulemmas '())))
	    (update-defaults (cdddr args)))
           ((equal? (car args) "-vel")
            (set! eager-vel #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-ff")
            (set! ff #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-fff")
            (set! fff (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-sreg")
	    (set! constraints #t) (set! strong-regularity #t)
	    (set! regularity #t) (set! foldup #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-side-reordering")
	    (set! side-reordering #t) 
	    (update-defaults (cdr args)))
           ((equal? (car args) "-elimit")
	    (set! extension-limit (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-var2")
	    (set! var2 (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-empty-input")
	    (set! error-on-empty #f)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-failinfo")
            (set! failinfo (string->integer (cadr args)))
	    (update-defaults (cddr args)))
           ((equal? (car args) "-fvector")
            (make-vector (string->integer (cadr args)) #f)
	    (update-defaults (cddr args)))
           ((equal? (car args) "-eqpred")
            (let ((option (string->integer (cadr args))))
             (if (= option 0)
                 (begin (set! equal-predecessor-fail 0)
                        (update-defaults (cdr args)))
                 (begin (set! equal-predecessor-fail 1)
                        (update-defaults (cddr args))))))
           ((equal? (car args) "-grounding")
            (set! test-grounding #t)
	    (update-defaults (cdr args)))
           ((equal? (car args) "-infix")
            (set! infix #t)
	    (update-defaults (cdr args)))
	   (else (display "Abort: error in parameter list") 
	         (newline) (exit 1))
)))

;;;*************************************************************************
;; -------------
;; FOR DEBUGGING
;; -------------

; (define l1 #f)
; (define l2 #f)
; (define cl #f)
; (define d #f)
; (define i 0)

; (define (make-list n e) (if (= n 0) '() (cons e (make-list (- n 1) e))))