(define (merge-sort unsorted-list)
; outputs a sorted list of input:
;   procedure is externally side-effect free;
;   elements are listed in decreasing order according
;   to the function merge-sort->=
 (if (pair? unsorted-list)
     (merge-sort-divide unsorted-list (length unsorted-list))
     unsorted-list))

(define (merge-sort-divide unsorted up2l)
; up2l must be <= (length unsorted) and unsorted must be non-empty
 (if (> up2l 2)
     (begin
       (let* ((l2 (quotient up2l 2)) (l1 (- up2l l2)))
	 (merge-sort-merge (merge-sort-divide unsorted l1)
			   (merge-sort-divide (list-tail unsorted l1) l2))))
     (if (= up2l 2)
	 (if (merge-sort->= (car unsorted) (cadr unsorted))
	     (list (car unsorted) (cadr unsorted))
	     (list (cadr unsorted) (car unsorted)))
	 (list (car unsorted)))))

(define (merge-sort-merge sorted1 sorted2)
; sorted1 and sorted2 must be non-empty
 (if (merge-sort->= (car sorted1) (car sorted2))
     (begin (merge-sort-merge1 (cdr sorted1) sorted2 sorted1)
            sorted1)
     (begin (merge-sort-merge1 (cdr sorted2) sorted1 sorted2)
            sorted2)))

(define (merge-sort-merge1 sorted1 sorted2 sorted1pred)
; sorted2 must be non-empty and sorted1 = (list-tail sorted1pred 1)
 (if (pair? sorted1)
     (if (merge-sort->= (car sorted1) (car sorted2))
         (merge-sort-merge1 (cdr sorted1) sorted2 sorted1)
         (begin (set-cdr! sorted1pred sorted2)
		(merge-sort-merge1 (cdr sorted2) sorted1 sorted2)))
     (set-cdr! sorted1pred sorted2)))
         
(define (merge-sort->= m n) (>= m n))
