(module misc
	(include "setheo.sch")
	(export (nconc l1 l2) (last l) (nreverse list) (clause-bigger? c1 c2) (sort-clauses clauselist) 
		(select-smallest-clause clauselist restlist tmp) (set-union list1 list2) (element e list)))


(define (nconc l1 l2)
  (if (null? l2)
      l1
      (if (null? l1)
	  l2
	  (set-cdr! (last l1) l2))))

(define (last l)
  (if (null? (cdr l))
      l
      (last (cdr l))))

(define (nreverse list)
  (if (null? list)
      list
      (nreverse1 list '() '())))

(define (nreverse1 list prev tmp)
  (set! tmp (cdr list))
  (set-cdr! list prev)
  (if (null? tmp)
      list
      (nreverse1 tmp list '())))

(define (clause-bigger? c1 c2)
  (if (> (clause-length c1) (clause-length c2))
      #t
      (if (< (clause-length c1) (clause-length c2))
	  #f
	  (if (> (clause-complexity c1) (clause-complexity c2))
	      #t
	      #f))))

(define (sort-clauses clauselist)
  (if (or (null? clauselist) (null? (cdr clauselist)))
      clauselist
      (begin
	(select-smallest-clause clauselist (cdr clauselist) '())
	(sort-clauses (cdr clauselist)))))

(define (select-smallest-clause clauselist restlist tmp)
  (if (clause-bigger? (car clauselist) (car restlist))
      (begin
	(set! tmp (car clauselist))
	(set-car! clauselist (car restlist))
	(set-car! restlist tmp)))
  (if (not (null? (cdr restlist)))
      (select-smallest-clause clauselist (cdr restlist) '())))

(define (set-union list1 list2)
 (if (pair? list1)
     (if (element (car list1) list2)
	 (set-union (cdr list1) list2)
	 (begin (set! list2 (cons (car list1) list2))
		(set-union (cdr list1) (list2))))
     list2))

(define (element e list)
 (if (pair? list)
     (if (eq? e (car list)) 
	 list
	 (element e (cdr list)))
     #f))
