;;;*************************************************************************
;; ---------------------------------------------------------------
;; FORMULA, CLAUSE, SUBGOAL, AND SIGNATURE ACCESS AND MODIFICATION
;; ---------------------------------------------------------------

(define-macro (var-binding var)		`(car  ,var))
(define-macro (var-constraints var)	`(cadr ,var))
(define-macro (var-name var)		`(cddr ,var))

(define-macro (formula-clauses f)       `(vector-ref ,f 0))      
(define-macro (formula-statistics f)    `(vector-ref ,f 1))      
(define-macro (formula-lemmas f)        `(vector-ref ,f 2))      

(define-macro (set-formula-clauses f arg)     `(vector-set! ,f 0 ,arg))      
(define-macro (set-formula-statistics f arg)  `(vector-set! ,f 1 ,arg))      
(define-macro (set-formula-lemmas f arg)      `(vector-set! ,f 2 ,arg))      

(define-macro (copy-subgoals cp)        `(vector-ref ,cp 0))      
(define-macro (copy-variables cp)       `(vector-ref ,cp 1))      
(define-macro (copy-path cp)            `(vector-ref ,cp 2))      
(define-macro (copy-clause cp)          `(vector-ref ,cp 3))      
(define-macro (copy-constraints cp)     `(vector-ref ,cp 4))      
(define-macro (copy-depth cp)           `(vector-ref ,cp 5))      
(define-macro (copy-inference cp)       `(vector-ref ,cp 6))      
(define-macro (copy-free-depth100 cp)   `(vector-ref ,cp 7))      
(define-macro (copy-eq-trail cp)        `(vector-ref ,cp 8))      
;(define-macro (copy-eq-counter cp)     `(vector-ref ,cp 9))      

(define-macro (set-copy-subgoals cp arg)       `(vector-set! ,cp 0 ,arg)) 
(define-macro (set-copy-variables cp arg)      `(vector-set! ,cp 1 ,arg))
(define-macro (set-copy-path cp arg)           `(vector-set! ,cp 2 ,arg))
(define-macro (set-copy-clause cp arg)         `(vector-set! ,cp 3 ,arg))
(define-macro (set-copy-constraints cp arg)    `(vector-set! ,cp 4 ,arg))
(define-macro (set-copy-depth cp arg)          `(vector-set! ,cp 5 ,arg))
(define-macro (set-copy-inference cp arg)      `(vector-set! ,cp 6 ,arg))
(define-macro (set-copy-free-depth100 cp arg)  `(vector-set! ,cp 7 ,arg))
(define-macro (set-copy-eq-trail cp arg)       `(vector-set! ,cp 8 ,arg))
;(define-macro (set-copy-eq-counter cp arg)    `(vector-set! ,cp 9 ,arg))

(define-macro (clause-copies cl)        `(vector-ref ,cl 0))      
(define-macro (clause-generic cl)       `(vector-ref ,cl 1))      
(define-macro (clause-length cl)        `(vector-ref ,cl 2))      
(define-macro (clause-nr-variables cl)  `(vector-ref ,cl 3))      
(define-macro (clause-variables cl)     `(vector-ref ,cl 4))      
(define-macro (clause-constraints cl)   `(vector-ref ,cl 5))      
(define-macro (clause-type cl)          `(vector-ref ,cl 6))      
(define-macro (clause-number cl)        `(vector-ref ,cl 7))      
(define-macro (clause-name cl)          `(vector-ref ,cl 8))      
(define-macro (clause-all-copies cl)    `(vector-ref ,cl 9))      
(define-macro (clause-complexity cl)    `(vector-ref ,cl 10))      
(define-macro (clause-signature cl)     `(vector-ref ,cl 11))      

(define-macro (set-clause-copies cl arg)        `(vector-set! ,cl 0 ,arg))
(define-macro (set-clause-generic cl arg)       `(vector-set! ,cl 1 ,arg))
(define-macro (set-clause-length cl arg)        `(vector-set! ,cl 2 ,arg))
(define-macro (set-clause-nr-variables cl arg)  `(vector-set! ,cl 3 ,arg))
(define-macro (set-clause-variables cl arg)     `(vector-set! ,cl 4 ,arg))
(define-macro (set-clause-constraints cl arg)   `(vector-set! ,cl 5 ,arg))
(define-macro (set-clause-type cl arg)          `(vector-set! ,cl 6 ,arg))
(define-macro (set-clause-number cl arg)        `(vector-set! ,cl 7 ,arg))
(define-macro (set-clause-name cl arg)          `(vector-set! ,cl 8 ,arg))
(define-macro (set-clause-all-copies cl arg)    `(vector-set! ,cl 9 ,arg))
(define-macro (set-clause-complexity cl arg)    `(vector-set! ,cl 10 ,arg))
(define-macro (set-clause-signature cl arg)     `(vector-set! ,cl 11 ,arg))

(define-macro (subgoal-sign sg)     `(vector-ref ,sg 0))
(define-macro (subgoal-pred sg)     `(vector-ref ,sg 1))
(define-macro (subgoal-terms sg)    `(vector-ref ,sg 2))
(define-macro (subgoal-links sg)    `(vector-ref ,sg 3))
(define-macro (subgoal-copy sg)     `(vector-ref ,sg 4))
(define-macro (subgoal-selected sg) `(vector-ref ,sg 5))
(define-macro (subgoal-next sg)     `(vector-ref ,sg 6))
(define-macro (subgoal-number sg)   `(vector-ref ,sg 7))
(define-macro (subgoal-foldup-predecessor sg)   `(vector-ref ,sg 8))
(define-macro (subgoal-time-stamp sg)  `(vector-ref ,sg 9))

(define-macro (subgoal-depth sg)    `(copy-depth (subgoal-copy ,sg)))
(define-macro (subgoal-predecessor sg) `(copy-path (subgoal-copy ,sg)))
(define-macro (subgoal-clause-number sg) 
			 `(clause-number (copy-clause (subgoal-copy ,sg))))
;; only for eq-subgoals
(define-macro (subgoal-other-subgoals sg)     `(vector-ref ,sg 7))
; (define-macro (subgoal-next-inference sg)
;  `(copy-inference (subgoal-copy (subgoal-next ,sg))))

(define-macro (set-subgoal-sign sg arg)     `(vector-set! ,sg 0 ,arg))
(define-macro (set-subgoal-pred sg arg)     `(vector-set! ,sg 1 ,arg))
(define-macro (set-subgoal-terms sg arg)    `(vector-set! ,sg 2 ,arg))
(define-macro (set-subgoal-links sg arg)    `(vector-set! ,sg 3 ,arg))
(define-macro (set-subgoal-copy sg arg)     `(vector-set! ,sg 4 ,arg))
(define-macro (set-subgoal-selected sg arg) `(vector-set! ,sg 5 ,arg))
(define-macro (set-subgoal-next sg arg)     `(vector-set! ,sg 6 ,arg))
(define-macro (set-subgoal-number sg arg)   `(vector-set! ,sg 7 ,arg))
(define-macro (set-subgoal-foldup-predecessor sg arg)  `(vector-set! ,sg 8 ,arg))
(define-macro (set-subgoal-time-stamp sg arg)  `(vector-set! ,sg 9 ,arg))
;; and, only for eq-subgoals
(define-macro (set-subgoal-other-subgoals sg arg)  `(vector-set! ,sg 7 ,arg))

(define-macro (predsym-symbol p)        `(vector-ref ,p 0))
(define-macro (predsym-arity p)         `(vector-ref ,p 1))
(define-macro (predsym-number p)        `(vector-ref ,p 2))
(define-macro (predsym-weight p)        `(vector-ref ,p 3))
(define-macro (predsym-pos-index p)     `(vector-ref ,p 4))
(define-macro (predsym-neg-index p)     `(vector-ref ,p 5))
(define-macro (predsym-pos-infindex p)  `(vector-ref ,p 6))
(define-macro (predsym-neg-infindex p)  `(vector-ref ,p 7))
(define-macro (predsym-poslinks p)      `(vector-ref ,p 8))
(define-macro (predsym-neglinks p)      `(vector-ref ,p 9))

(define-macro (set-predsym-symbol p arg)        `(vector-set! ,p 0 ,arg))
(define-macro (set-predsym-arity p arg)         `(vector-set! ,p 1 ,arg))
(define-macro (set-predsym-number p arg)        `(vector-set! ,p 2 ,arg))
(define-macro (set-predsym-weight p arg)        `(vector-set! ,p 3 ,arg))
(define-macro (set-predsym-pos-index p arg)     `(vector-set! ,p 4 ,arg))
(define-macro (set-predsym-neg-index p arg)     `(vector-set! ,p 5 ,arg))
(define-macro (set-predsym-pos-infindex p arg)  `(vector-set! ,p 6 ,arg))
(define-macro (set-predsym-neg-infindex p arg)  `(vector-set! ,p 7 ,arg))
(define-macro (set-predsym-poslinks p arg)      `(vector-set! ,p 8,arg))
(define-macro (set-predsym-neglinks p arg)      `(vector-set! ,p 9 ,arg))

(define-macro (functor-symbol sg)     `(vector-ref ,sg 0))
(define-macro (functor-arity sg)      `(vector-ref ,sg 1))
(define-macro (functor-number sg)     `(vector-ref ,sg 2))
(define-macro (functor-weight sg)     `(vector-ref ,sg 3))
(define-macro (functor-frequency sg)  `(vector-ref ,sg 4))

(define-macro (set-functor-symbol sg arg)     `(vector-set! ,sg 0 ,arg))
(define-macro (set-functor-arity sg arg)      `(vector-set! ,sg 1 ,arg))
(define-macro (set-functor-number sg arg)     `(vector-set! ,sg 2 ,arg))
(define-macro (set-functor-weight sg arg)     `(vector-set! ,sg 3 ,arg))
(define-macro (set-functor-frequency sg arg)  `(vector-set! ,sg 4 ,arg))

(define-macro (signature-symbol sg)     `(vector-ref ,sg 0))
(define-macro (signature-arity sg)      `(vector-ref ,sg 1))
(define-macro (signature-number sg)     `(vector-ref ,sg 2))
(define-macro (signature-weight sg)     `(vector-ref ,sg 3))

(define-macro (set-signature-symbol sg arg)     `(vector-set! ,sg 0 ,arg))
(define-macro (set-signature-arity sg arg)      `(vector-set! ,sg 1 ,arg))
(define-macro (set-signature-number sg arg)     `(vector-set! ,sg 2 ,arg))
(define-macro (set-signature-weight sg arg)     `(vector-set! ,sg 3 ,arg))

(define-macro (clause-generic-subgoal clause offset) 
; returns generic subgoal with offset in clause; 
; note: first subgoal has offset 0
`(vector-ref (clause-generic ,clause) ,offset))

(define-macro (subgoals-offset-copy generic offset) 
; given a <generic> and an offset, the respective subgoal in the first
; clause copy is returned; note: first subgoal has offset 0
`(vector-ref                                      
    (copy-subgoals                                       
        (car (clause-copies (subgoal-copy (vector-ref ,generic ,offset)))))
    ,offset))

(define-macro (clause-copy-subgoal clause offset)
; returns entry subgoal with offset in clause; note: first subgoal has offset 0
`(vector-ref (copy-subgoals (car (clause-copies ,clause))) ,offset))

;;;*************************************************************************
;; ---------------
;; TERM TYPE TESTS
;; ---------------

(define-macro (constant term) `(null? (cdr ,term)))

(define-macro (complex term) 
`(and (not (variable ,term)) (pair? (cdr ,term))))

(define-macro (variable term) `(not (vector? (car ,term))))

(define-macro (non-variable term) `(vector? (car ,term)))

(define-macro (free-variable term) `(eq? (car ,term) '()))

;;;*************************************************************************
;; ------------------------------------------------------------
;; VARIABLE BINDING, EQUATION EXTRACTION AND TRAIL MODIFICATION
;; ------------------------------------------------------------

(define-macro (push-trail data)
`(begin (trail-next) (set-car! (car trail) ,data)))

(define-macro (trail-next)
`(if (null? (cdr trail))
     (begin (set-cdr! trail (list (cons #f trail)))
            (set! trail (cdr trail)))
     (set! trail (cdr trail))))

(define-macro (unif-trail-next)
`(if (null? (cdr unif-trail))
     (begin (set-cdr! unif-trail (list (cons #f unif-trail)))
            (set! unif-trail (cdr unif-trail)))
     (set! unif-trail (cdr unif-trail))))

(define-macro (trail-stop)
`(begin (trail-next) (set-car! (car trail) #f)))

(define-macro (trail-previous) `(set! trail (cdar trail)))
(define-macro (unif-trail-previous) `(set! unif-trail (cdar unif-trail)))
(define-macro (trail-previous-loc loc-trail) `(cdar ,loc-trail))

(define-macro (trail-content) `(caar trail))
(define-macro (trail-content-loc loc-trail) `(caar ,loc-trail))

(define-macro (bind var term)
;; binds var to term destructively, next trail position is used
`(begin (set-car! ,var ,term)
        (trail-next)
        (set-car! (car trail) ,var)
	#t))

(define-macro (unbind s t) `(unbind-vars))

(define-macro (unify-lists-stop k l)
`(begin (trail-stop) (unify-lists ,k ,l)))

(define-macro (unify-terms-stop s t)
`(begin (trail-stop) (unify-terms ,s ,t)))

(define-macro (extension-unify-lists-stop k l)
`(begin (trail-stop) 
        (set! optimized-unification 0) 
        (extension-unify-lists ,k ,l)))

;;;*************************************************************************
;; -----------------------------
;; CONSTRAINT STACK MODIFICATION
;; -----------------------------

(define-macro (constraint-stack-next)
`(if (null? (cdr c-stack))
     (begin (set-cdr! c-stack (list (make-vector 3)))
            (set! c-stack (cdr c-stack)))
     (set! c-stack (cdr c-stack))))

;;;*************************************************************************
;; ------------------------
;; VALUE TRAIL MODIFICATION 
;; ------------------------

(define-macro (v-trail-next)
`(if (null? (cdr v-trail))
     (begin (set-cdr! v-trail (list (make-vector 4)))
            (vector-set! (cadr v-trail) 3 v-trail)
	    (set! v-trail (cdr v-trail)))
     (set! v-trail (cdr v-trail))))

(define-macro (v-trail-stop)
`(begin (v-trail-next) (vector-set! (car v-trail) 0 #f)))

(define-macro (v-trail-previous) `(set! v-trail (vector-ref (car v-trail) 3)))

(define-macro (v-trail-content) `(vector-ref (car v-trail) 0))

(define-macro (is-passiv-constraint? constraint)
`(vector-ref (vector-ref ,constraint 1) 1))

;;;*************************************************************************
;; ---------------
;; COPY PROCEDURES
;; ---------------

(define-macro (new-clause-copy clause)
`(if (null? (cdr (clause-copies ,clause)))
     (set-cdr! (clause-copies ,clause) 
	       (list (make-clause-copy (clause-generic ,clause)
		                       (clause-length ,clause)
		                       (clause-variables ,clause)
                                       ,clause
                                       (clause-constraints ,clause))))))

;;;*************************************************************************
;; ------------------------
;; COMPUTE AND CHECK BOUNDS
;; ------------------------

(define-macro (check-bounds clause depth)
`(if (<= ,depth 0) 
     (if (= (clause-length ,clause) 1) 
         #t
	 (begin (set! bound-fail #t) #f))
     #t))

;;;*************************************************************************
;; ---------------------------------
;; SUBGOAL SELECTION AND PREPARATION
;; ---------------------------------

(define-macro (next-subgoal-call new-inf new-sg new-links new-depth
				 old-global-subgoals new-nr-sgs)
`(begin (set! current-subgoal #f) (set! current-complexity #f) 
   (set! glob-inf 1)
   (set! ,new-sg (select-subgoal global-subgoals 0 
                            (- (vector-length global-subgoals) 1) new-inf))
  (if 
   (and ,new-sg (equal-predecessor-check ,new-sg))
;   (if (and sgindex (find-matching-lemma ,new-sg))
;       (skip-subgoal ,new-sg)
       (begin
	 (set! ,new-depth (subgoal-depth ,new-sg))
	 (if debug (begin (display "SUBGOAL: ")
			  (display-subgoal ,new-sg) (newline)))
	 (if ulemmas
	     (if (eq? (subgoal-sign ,new-sg) '+)
		 (set! ,new-links
		       (append
			       (predsym-neglinks (subgoal-pred ,new-sg))
			       (subgoal-links ,new-sg)
			       ))
		 (set! ,new-links
		       (append
			       (predsym-poslinks (subgoal-pred ,new-sg))
			       (subgoal-links ,new-sg)
			       )))
	     (set! ,new-links (subgoal-links ,new-sg)))
	 (if (and failinfo (> ,new-depth 0))
	     (begin ; (display "Checks failinfo for sg: ")
	       ; (display-subgoal ,new-sg)
	       (in-infindex-subgoal ,new-sg)
	       (if (and (not (null? (cdr index))) (<= ,new-depth (cdr index)))
		   (begin ; (display " FAILINFO PRUNING: ")
		          ; (set! failinfo-pruning (+ 1 failinfo-pruning))
			  ; (display ,new-depth) (display " reduced to ")
			  (set! ,new-depth (- ,new-depth failinfo))
			  ; (display ,new-depth) (newline)
			  ))
	     ))
	  (if weighted-depth
              (set! ,new-depth (compute-weighted-depth
				,new-depth
				(copy-free-depth100 (subgoal-copy ,new-sg))
				(copy-inference (subgoal-copy ,new-sg))
				,new-inf)))
	  (set! actual-depth ,new-depth)
	  (set-subgoal-selected ,new-sg 0)
	  (if antilemmas (v-trail-stop))
	  (let ((old-c-stack c-stack))
	    (if (and equality side-reordering
		     (eq? (subgoal-pred ,new-sg) eq-predicate))
		(reorder-sides ,new-sg 0 0))
;	    (if (or (not failinfo) (>= actual-depth 0)) ;
;	     (begin ;
	    (solve ,new-sg ,new-links ,new-depth ,new-inf ,new-nr-sgs '())
	    (if (and units-double antilemmas equality)
		(solve ,new-sg ,new-links ,new-depth ,new-inf ,new-nr-sgs #f))
;	    )) ;
	    (if antilemmas (begin (undo-v-trail) (set! c-stack old-c-stack))))
	  (if failinfo
	      (begin ; (display-subgoal ,new-sg)
		(if (= (subgoal-selected ,new-sg) 0)
		    (begin ; (display " not")
		      (in-infindex-subgoal ,new-sg)   
		      (if (or (null? (cdr index)) (< (cdr index) ,new-depth))
			  (set-cdr! index ,new-depth))))
		; (display " solved with depth resource: ")
		; (print (subgoal-depth ,new-sg))
		))
	  (set-subgoal-selected ,new-sg #f)
	  (set-subgoal-links ,new-sg ,new-links)))
   (set! global-subgoals ,old-global-subgoals)))

;;;*************************************************************************
;; -----------------------------
;; SUBGOAL REORDERING CONDITIONS
;; -----------------------------

(define-macro (subgoal-conditions subgoal)
`(cond ((eq? subgoal-reordering 0)
        (if (and global-reordering (> (subgoal-depth ,subgoal) 0))
            (> (* new-complexity (subgoal-depth current-subgoal))
               (* current-complexity (subgoal-depth ,subgoal)))
            (or (> new-complexity current-complexity)
	        (and (= new-complexity current-complexity)
	             (< new-vars current-vars)))))
       ((eq? subgoal-reordering 1)
	(or (< new-vars current-vars)
	    (and (= new-vars current-vars)
	         (> new-complexity current-complexity))))
       ((eq? subgoal-reordering 2)
        (and (eq? (subgoal-pred ,subgoal) (subgoal-pred current-subgoal))
             (or (> new-complexity current-complexity)
                 (and (= new-complexity current-complexity)
	              (< new-vars current-vars)))))
       ((eq? subgoal-reordering 3)
        (and (eq? (subgoal-pred ,subgoal) (subgoal-pred current-subgoal))
             (or (< new-vars current-vars)
	         (and (= new-vars current-vars)
	              (> new-complexity current-complexity)))))
       ((eq? subgoal-reordering 4)
        (and (or (eq? (subgoal-pred ,subgoal) (subgoal-pred current-subgoal))
	         (<= (length (subgoal-links ,subgoal))
	             (length (subgoal-links current-subgoal))))
             (or (> new-complexity current-complexity)
                 (and (= new-complexity current-complexity)
	              (< new-vars current-vars)))))
       ((eq? subgoal-reordering 5)
        (and (or (eq? (subgoal-pred ,subgoal) (subgoal-pred current-subgoal))
	         (<= (length (subgoal-links ,subgoal))
	             (length (subgoal-links current-subgoal))))
             (or (< new-vars current-vars)
	         (and (= new-vars current-vars)
	              (> new-complexity current-complexity)))))
))

(define-macro (subgoal-instantiation subgoal)
`(if (null? (subgoal-terms ,subgoal))
     1000
     (if (= 0 subgoal-complexity-measure)
         (quotient (termlist-instantiation (subgoal-terms ,subgoal))
                   (functor-arity (subgoal-pred ,subgoal)))
         (begin (termlist-var-occ (subgoal-terms ,subgoal))
                (quotient (termlist-instantiation1 (subgoal-terms ,subgoal))
                          (functor-arity (subgoal-pred ,subgoal)))))))

;;;*************************************************************************
;; -------------------
;; SUBGOAL ALTERNATION
;; -------------------

; (define-macro (alternate-subgoals sg links depth inference nr-sgs)
; `(if (and (> (clause-length (caar (cdr ,links))) 1)
; ;; WARNING: previous line may cause an error when reduction steps are 
; ;;          moved away from top of the lX1ink list
;           (or (eq? (car ,links) 'reduction)
;               (= (clause-length (caar ,links)) 1)))
;      (begin (print "Subgoal alternation: not implemented!") (exit 1))
;      (solve ,sg (cdr ,links) ,depth ,inference ,nr-sgs)))
     
;;;*************************************************************************
;; ------------------
;; PRUNING CONDITIONS
;; ------------------

(define-macro (equal-predecessor-check new-sg)
`(or (not equal-predecessor-fail)
     (no-equal-predecessor ,new-sg (subgoal-terms ,new-sg)
                           (subgoal-predecessor ,new-sg))))

(define-macro (regularity entry subgoals predsg max-index)
`(or (not regularity)
     (make-regularity-constraints-clause ,entry ,subgoals ,predsg 0
					 ,max-index)))

;;;*************************************************************************
;; --------------
;; DEBUG DISPLAYS
;; --------------

(define-macro (debug-extension1)
`(begin (newline) (display "----------------- ")
        (display successful-inferences)
        (display ": clause number: ")
        (display (clause-number clause))
        (display " -----------------") 
        (if sg (begin (newline) (display-subgoal sg) (newline)
                      (display-subgoal entry))
               (display "top clause"))
        (newline)
;             (display (subgoal-terms sg)) (newline)
;             (display (subgoal-terms entry)) (newline)
))

(define-macro (debug-extension2)
`(begin
    (if sg 
        (begin  (newline) (display "UNIFICATION SUCCESSFUL, ") ; (newline)
;                (display-subgoal sg) (newline)
;                (display-subgoal entry) (newline)
		(print "CONSTRAINTS OF LAST SUBSTITUTION DOMAIN:")
		(display-constraints (last-binding-variables))
		(set! l1 (copy-subgoals actual-copy))
		(display "ALL SUBGOALS: ") (display-subgoals l1 0)
;     (display successful-inferences) (newline)
))))

(define-macro (debug-extension43-29)
`(if (and (= successful-inferences 43) (= (clause-number clause) 29))
     (begin 
       (set! l1 (subgoal-terms sg)) (set! l2 (subgoal-terms entry))
       (set! cl clause)
       (repl))))

;    (if sgindex 
;        (begin (set! nr-subgoals (+ 1 nr-subgoals))
;;	       (if (or #f (= nr-subgoals 17))
;;		   (begin (set! i new-sg) 
;;			  (print-or-node '()
;;					 (car (vector-ref (subgoal-pred i) 5)))
;;			  (newline) (display "NEW SG: ")
;;			  (display-subgoal i) 
;;			  (repl)))
;	       (if (eq? '- (subgoal-sign new-sg))
;                   (in-index-root (subgoal-terms new-sg)
;				  (ref (car (subgoal-terms new-sg)))
;				  (predsym-neg-index (subgoal-pred new-sg)))
;                   (in-index-root (subgoal-terms new-sg)
;				  (ref (car (subgoal-terms new-sg)))
;				  (predsym-pos-index (subgoal-pred new-sg))))
;               (if (not in-index?) (set! index-size (+ 1 index-size)))))

;;;*************************************************************************


