(module semprop-main 
	(main call-semprop)    ;; this is the main procedure
	(import 
	 (semprop "semprop.scm"))
	)
      
(define (call-semprop argv) 
 (if (pair? (cdr argv)) 
     (semprop (cdr argv))
     (begin ; declaration of usage
(print
"*** semprop is a propositional decision procedure using semantic branching *** ") 
(print 
"*** Usage: semprop <option>s <filename> *** ") 
(newline)
(print
"<filename> must contain input <clause>s") 
(print
"Input syntax: there are two options:")
(print
"either <clause> ::= (I_1 ... I_n), any I_i an integer != 0 and |I_i| < 2^16")
(print
"                    example: (234 -34 1 33 34 -2 1 8)")
(print
"or     <clause> ::= (<pos> <neg>), <pos> and <neg> lists of strings \"...\"")
(print 
"                    or Lisp symbols denoting the pos. resp. neg. literals")
(print
"                    example: ((p234 p1 p33 p34 p1 p8) (p34 p2))")
(print
"Note: syntax formats must not be mixed!")
(newline)
(print
"Default model output: only the positive literals in model are displayed")
(newline) (newline) (display
"Default branching criterion: branches first to negative valuation except")
(newline) (display
"        the literal occurs with a higher weight positively in the formula")
(newline) (newline) (display 
"<option>s:") 
(newline) (display
"-allmodels:     computes all models")
(newline) (display
"-noverbose:     only number of models displayed")
(newline) (display
"-verbose 0:     only number of models displayed")
(newline) (display
"-verbose 1:     only first model and number of models displayed")
(newline) (display
"-verbose 2:     all models displayed")
(newline) (display
"-negmodel:      also negated literals in model displayed")
(newline) (display
"-neg:           branches always first to negative literal")
(newline) (display
"-pos:           branches always first to positive literal if -pos is off")
(newline) (display
"-div {0-6}:     different weight functions w: c clause, l length of c")
(newline) (display
"                div = i: w(c) = 1/(l^i), default is -div 3,")
(newline) (display
"                atom selection is acc. to maximal weight, atom weight is the")
(newline) (display
"                sum of the weights of the clauses in which the atom occurs")
(newline) (display
"-max:           atom weight is maximum of the weights")
(newline) (newline) (display
"General remark: later options overwrite earlier ones")
(newline))))


