(module subsumption
	(include "dctp.sch")
	(export (clause-variant-subsumed clause) (sign-predsym< sga sgb) (set-linked-clauses-tested clausea clauseb)
		(unset-linked-clauses clausea clauseb) (sign-predsym> sga sgb) (set-clause-tested clause)
		(unset-clause-tested clause) (clause-full-subsumed-by-clauselist clause clauses) (sign-predsym= sga sgb)
		(backsubsume-clauses-with-new-clause clause clauses) (clause-path-subsumed unsimplifieds)
		(clause-full-subsumed-by-path-clause linked-subgoal path-subgoal))
	(import (globals "globals.scm") (unification "unification.scm") (display "display.scm") (index "index.scm")
		(normal-form "normal-form.scm") (rewrite "rewrite.scm") (delete-subgoals-from-path-index preprocess "preprocess.scm")
		(variables-in-subgoals dctp "dctp.scm")))

;;;*************************************************************************
;; ------------------------------------------------------------
;; Variables global to this module
;; ------------------------------------------------------------

(define path-clause-test-vector (make-vector 5000 #f))
(define tested-path-clauses '())

;;;*************************************************************************
;; ------------------------------------------------------------
;; Variant subsumption functions
;; ------------------------------------------------------------

(define (clause-variant-subsumed unsimplifieds)
  (if (pair? unsimplifieds)
      (let ((result (test-potential-path-variants unsimplifieds (length unsimplifieds) unsimplifieds)))
	(unset-tested-path-clauses)
	(if result
	    (begin
	      (if dewey-numbers
		  (begin
		    (display "variant ") 
		    (display-clause (subgoal-clause (car unsimplifieds)))
		    (display " subsumed by ") 
		    (display-clause result)
		    (newline)))
	      (set! variant-subsumptions (+ variant-subsumptions 1))))
	result)
      #f))

(define (test-potential-path-variants subgoals clause-length unsimplifieds)
  (if (pair? subgoals)
      (let ((result (subgoal-in-path-index (car subgoals))))
	(if result
	    (set! result (test-path-clauses result clause-length unsimplifieds)))
	(if result
	    result
	    (test-potential-path-variants (cdr subgoals) clause-length unsimplifieds)))
      #f))

(define (test-path-clauses path-subgoals clause-length unsimplifieds)
  (if (pair? path-subgoals)
      (if (or (subgoal-unlinkable (car path-subgoals))
	      (clause-initial (subgoal-clause (car path-subgoals)))
	      (path-subgoal-clause-tested (car path-subgoals))
	      (and no-foreign-variants (not (eq? (clause-input (subgoal-clause (car unsimplifieds))) (clause-input (car path-subgoals))))))
	  (test-path-clauses (cdr path-subgoals) clause-length unsimplifieds)
	  (let ((p-subgoals (unsimplifiable-subgoals (clause-subgoals (subgoal-clause (car path-subgoals))))))
	    (if (> debug-level 5)
		(begin
		  (display "vs-test with ")
		  (display-clause (subgoal-clause (car path-subgoals)))
		  (display " ")))
	    (set! variant-subsumption-tests (+ variant-subsumption-tests 1))
	    (set-path-subgoal-clause-tested (car path-subgoals))
	    (if (or (and path-subsumption (= clause-length (length p-subgoals))) (and (not path-subsumption) (>= clause-length (length p-subgoals))))
	    ;;(if (= clause-length (length p-subgoals))
		(if (predicates-match-individually unsimplifieds p-subgoals)
		    (if (subgoals-variant-match-individually unsimplifieds p-subgoals)
			(begin
			  (set! var-counter 1)
			  (if (> debug-level 5)
			      (begin
				(display "testing new subgoals ")
				(display-subgoal-list unsimplifieds)
				(newline)))
			  (if (permutation-variant-subsumed unsimplifieds p-subgoals)
			      (begin
; 				(if (> clause-length (length p-subgoals))
; 				    (let ((clause (subgoal-clause (car unsimplifieds))) (path-clause (subgoal-clause (car p-subgoals))))
; 				      (display-clause clause)
; 				      (display " variant subsumed by smaller path ")
; 				      (display-clause path-clause)
; 				      (newline)
; 				      (set! debug-level 6)
; 				      (if (clause-full-subsumed-by-clause clause path-clause)
; 					  (print "full subsumption test succeeded")
; 					  (print "!!!!! full subsumption test failed!"))
; 				      (set! debug-level 0)))
				(subgoal-clause (car path-subgoals)))
			      (begin
				(if (> debug-level 5) (print "fail: full test"))
				(set! full-fails (+ full-fails 1))
				(test-path-clauses (cdr path-subgoals) clause-length unsimplifieds))))
			(begin 
			  (if (> debug-level 5) (print "fail: single match"))
			  (set! single-match-fails (+ single-match-fails 1))
			  (test-path-clauses (cdr path-subgoals) clause-length unsimplifieds)))
		    (begin 
		      (if (> debug-level 5) (print "fail: signature match"))
		      (set! signature-fails (+ signature-fails 1))
		      (test-path-clauses (cdr path-subgoals) clause-length unsimplifieds)))
		(begin 
		  (if (> debug-level 5) (print "fail: length"))
		  (set! length-fails (+ length-fails 1))
		  (test-path-clauses (cdr path-subgoals) clause-length unsimplifieds)))))
      #f))

(define (unsimplifieds-minus-subgoal subgoal subgoals)
  (if (pair? subgoals)
      (if (not (or (subgoal-simplified (car subgoals)) (eq? subgoal (car subgoals))))
	  (cons (car subgoals) (unsimplifieds-minus-subgoal subgoal (cdr subgoals)))
	  (unsimplifieds-minus-subgoal subgoal (cdr subgoals)))
      '()))

(define (predicates-match-individually subgoals path-subgoals)
  (if (pair? path-subgoals)
      (let ((result (predicate-matches-individually subgoals (car path-subgoals))))
	(if result
	    (predicates-match-individually result (cdr path-subgoals))
	    #f))
      #t))

(define (predicate-matches-individually subgoals path-subgoal)
  (let ((valid-subgoals (do ((sg-pointer subgoals (cdr sg-pointer)))
			    ((or (null? sg-pointer) (sign-predsym>= (car sg-pointer) path-subgoal))
			     (if (and (pair? sg-pointer) (sign-predsym= (car sg-pointer) path-subgoal))
				 sg-pointer
				 '())))))
    (if (pair? valid-subgoals)
	(cdr valid-subgoals)
	#f)))

; (define (subgoals-variant-match-individually subgoals path-subgoals)
;   (if (pair? path-subgoals)
;       (let ((result (subgoal-variant-matches-individually subgoals (car path-subgoals))))
; 	(if result
; 	    (subgoals-variant-match-individually result (cdr path-subgoals))
; 	    #f))
;       #t))

(define (subgoals-variant-match-individually subgoals path-subgoals)
  (if (pair? path-subgoals)
      (let ((result (subgoal-variant-matches-individually subgoals (car path-subgoals))))
	(if result
	    (subgoals-variant-match-individually result (cdr path-subgoals))
	    (if (and #f (eq-subgoal? (car path-subgoals)) (not (subgoal-ordered-eq (car path-subgoals))))
		(begin
		  (set-subgoal-terms (car path-subgoals) (list (cadr (subgoal-terms (car path-subgoals)))
							       (car (subgoal-terms (car path-subgoals)))))
		  (set! result (subgoal-variant-matches-individually subgoals (car path-subgoals)))
		  (set-subgoal-terms (car path-subgoals) (list (cadr (subgoal-terms (car path-subgoals)))
							       (car (subgoal-terms (car path-subgoals)))))
		  (if result
		      (begin
			(print "successful individual match by switched equation!")
			(subgoals-variant-match-individually result (cdr path-subgoals)))
		      #f))
		#f)))
      #t))

(define (subgoal-variant-matches-individually subgoals path-subgoal)
;   (if (pair? subgoals)
;       (begin
; 	(display "trying to match ")
; 	(display-subgoal path-subgoal)
; 	(display " against ")
; 	(display-subgoal (car subgoals))
; 	(newline)))
  (let ((valid-subgoals (do ((sg-pointer subgoals (cdr sg-pointer)))
			    ((or (null? sg-pointer) (sign-predsym>= (car sg-pointer) path-subgoal))
			     (if (and (pair? sg-pointer) (sign-predsym= (car sg-pointer) path-subgoal))
				 sg-pointer
				 '())))))
    (if (pair? valid-subgoals)
	(if (= (subgoal-weight path-subgoal) (subgoal-misc (car valid-subgoals)))
	    (let ((result (non-equivalent-termlists (subgoal-terms path-subgoal) (subgoal-terms (car valid-subgoals)))))
	      (if result
		  (begin
		    (set! result (subgoal-variant-matches-individually (cdr valid-subgoals) path-subgoal))
		    (if result
			(cons (car valid-subgoals) result)
			#f))
		  (cdr valid-subgoals)))
	    (let ((result (subgoal-variant-matches-individually (cdr valid-subgoals) path-subgoal)))
		    (if result
			(cons (car valid-subgoals) result)
			#f)))
	#f)))

(define (permutation-variant-subsumed subgoals path-subgoals)
  (if (pair? path-subgoals)
      (do ((success #f) (fail #f) (possible-matches subgoals) (rest-subgoals '()) (v #f) (switch #f))
	  ((or success fail) success)
	(if (> debug-level 5)
	    (begin
	      (display "...searching global match for subgoal ")
	      (display-subgoal (car path-subgoals))))
	(if (and switch (eq-subgoal? (car path-subgoals)))
	    (set-subgoal-terms (car path-subgoals) (list (cadr (subgoal-terms (car path-subgoals)))
							 (car (subgoal-terms (car path-subgoals))))))
	(set! v (get-globally-matching-subgoal possible-matches (car path-subgoals)))
	(if (and switch (eq-subgoal? (car path-subgoals)))
	    (set-subgoal-terms (car path-subgoals) (list (cadr (subgoal-terms (car path-subgoals)))
							 (car (subgoal-terms (car path-subgoals))))))
	(if v
	    (begin
	      (if (> debug-level 5)
		(begin
		  (display "...found global match ")
		  (display-subgoal v)
		  (newline)))
	      (set! rest-subgoals (remq v subgoals))
	      (if (permutation-variant-subsumed rest-subgoals (cdr path-subgoals))
		  (begin
		    (set! success #t)
		    (if (and dewey-numbers switch)
			(print "successful subsumption by switched equation!")))
		  (if (and (not switch)
			   (eq-subgoal? (car path-subgoals))
			   (not (subgoal-ordered-eq (car path-subgoals))))
		      (set! switch #t)
		      (begin
			(set! possible-matches (remq v possible-matches))
			(set! switch #f))))
	      (unbind-vars-and-undo-var-counter))
	    (begin
	      (if (> debug-level 5)
		(begin
		  (display "...could not find global match for path subgoal ")
		  (display-subgoal (car path-subgoals))
		  (newline)))
	      (set! fail #t))))
      #t))
		    
(define (get-globally-matching-subgoal possible-matches path-subgoal)
  (if (and (pair? possible-matches) (not (sign-predsym> (car possible-matches) path-subgoal)))
      (let ((result (globally-non-equivalent-subgoals path-subgoal (car possible-matches))))
	(if (> debug-level 5)
	    (begin
	      (display "...testing possible match ")
	      (display-subgoal (car possible-matches))))
	(if result
	    (if (sign-predsym> (car possible-matches) path-subgoal)
		#f
		(get-globally-matching-subgoal (cdr possible-matches) path-subgoal))
	    (car possible-matches)))
      #f))

(define (globally-non-equivalent-subgoals a b)
  (if (eq? (subgoal-sign a) (subgoal-sign b))
      (if (eq? (subgoal-pred a) (subgoal-pred b))
	  (begin
	    (trail-stop)
	    (non-equivalent-termlists-1 (subgoal-terms a) (subgoal-terms b)))
	  (if (> (predsym-number (subgoal-pred a)) (predsym-number (subgoal-pred b)))
	      1
	      -1))
      (if (eq? '+ (subgoal-sign a))
	  -1
	  1)))

(define (sign-predsym< sga sgb)
  (if (and (eq? (subgoal-sign sga) '+) (eq? (subgoal-sign sgb) '-))
      #t
      (if (and (eq? (subgoal-sign sga) (subgoal-sign sgb)) 
	       (< (predsym-number (subgoal-pred sga)) (predsym-number (subgoal-pred sgb))))
	  #t
	  #f)))

(define (sign-predsym> sga sgb)
  (if (and (eq? (subgoal-sign sga) '-) (eq? (subgoal-sign sgb) '+))
      #t
      (if (and (eq? (subgoal-sign sga) (subgoal-sign sgb))
	       (> (predsym-number (subgoal-pred sga)) (predsym-number (subgoal-pred sgb))))
	  #t
	  #f)))

(define (sign-predsym>= sga sgb)
  (if (and (eq? (subgoal-sign sga) '-) (eq? (subgoal-sign sgb) '+))
      #t
      (if (and (eq? (subgoal-sign sga) (subgoal-sign sgb))
	       (>= (predsym-number (subgoal-pred sga)) (predsym-number (subgoal-pred sgb))))
	  #t
	  #f)))

(define (sign-predsym= sga sgb)
  (if (and (eq? (subgoal-sign sga) (subgoal-sign sgb)) 
	   (= (predsym-number (subgoal-pred sga)) (predsym-number (subgoal-pred sgb))))
      #t
      #f))

(define (set-clause-tested clause)
  (if (>= (clause-depth clause) 0)
      (path-clause-tested-set (clause-depth clause) #t)))

(define (unset-clause-tested clause)
  (if (>= (clause-depth clause) 0)
      (path-clause-tested-set (clause-depth clause) #f)))

(define (set-linked-clauses-tested clausea clauseb)
  (let ((deptha (clause-depth clausea)) (depthb (clause-depth clauseb)))
    (if (>= deptha 0)
	(path-clause-tested-set deptha #t))
    (if (>= depthb 0)
	(path-clause-tested-set depthb #t))))

(define (unset-linked-clauses clausea clauseb)
  (let ((deptha (clause-depth clausea)) (depthb (clause-depth clauseb)))
    (if (>= deptha 0)
	(path-clause-tested-set deptha #f))
    (if (>= depthb 0)
	(path-clause-tested-set depthb #f))))

(define (path-subgoal-clause-tested subgoal)
  (let ((depth (subgoal-depth subgoal)))
    (if (>= depth 0) 
	(path-clause-tested-ref depth)
	#t)))

(define (set-path-subgoal-clause-tested subgoal)
  (let ((depth (subgoal-depth subgoal)))
    (if (>= depth 0) 
	(if (path-clause-tested-ref depth)
	    #f
	    (begin
	      (path-clause-tested-set depth #t)
	      (set! tested-path-clauses (cons depth tested-path-clauses))
	      #t))
	#f)))

(define (unset-tested-path-clauses)
  (undo-vector-settings tested-path-clauses)
  (set! tested-path-clauses '()))

(define (undo-vector-settings path-clauses)
  (if (pair? path-clauses)
      (begin
	(undo-vector-settings (cdr path-clauses))
	(set-cdr! path-clauses '())
	(path-clause-tested-set (car path-clauses) #f))))

(define (path-clause-tested-ref i)
  (if (< i (vector-length path-clause-test-vector))
      (vector-ref path-clause-test-vector i)
      (let (new-test-vector)
	(do ((j 2 (+ j 1)))
	    ((> (* j (vector-length path-clause-test-vector)) i) (set! new-test-vector (make-vector (* j (vector-length path-clause-test-vector)) #f))))
	(do ((j 0 (+ j 1)))
	    ((= j (vector-length path-clause-test-vector)) #f)
	  (vector-set! new-test-vector j (vector-ref path-clause-test-vector j)))
	(set! path-clause-test-vector new-test-vector)
	#f)))
	
(define (path-clause-tested-set i value)
  (if (< i (vector-length path-clause-test-vector))
      (vector-set! path-clause-test-vector i value)
      (let (new-test-vector)
	(do ((j 2 (+ j 1)))
	    ((> (* j (vector-length path-clause-test-vector)) i) (set! new-test-vector (make-vector (* j (vector-length path-clause-test-vector)) #f))))
	(do ((j 0 (+ j 1)))
	    ((= j (vector-length path-clause-test-vector)) #f)
	  (vector-set! new-test-vector j (vector-ref path-clause-test-vector j)))
	(set! path-clause-test-vector new-test-vector)
	(vector-set! path-clause-test-vector i value)
	#t)))

;;;*************************************************************************
;; ------------------------------------------------------------
;; Full preprocessing subsumption functions
;; ------------------------------------------------------------

(define (clause-full-subsumed-by-clauselist clause clauses)
  (if (pair? clauses)
      (if (and (not (eq? clause (car clauses)))
	       (non-unit-clause (car clauses))
	       (clause-full-subsumed-by-clause clause (car clauses)))
	  (car clauses)
	  (clause-full-subsumed-by-clauselist clause (cdr clauses)))
      #f))

(define (clause-full-subsumed-by-path-clause linked-subgoal path-subgoal)
  (let ((clause (subgoal-clause linked-subgoal)))
    (if path-subgoal
	     ;;(>= (subgoal-depth path-subgoal) 0))
	     ;;(> (subgoal-depth path-subgoal) (clause-depth clause)))
	(let ((result #f))
	  (if (and (or total-subsumption (eq? (clause-input clause) (clause-input (subgoal-clause path-subgoal))))
		   (not (path-subgoal-clause-tested path-subgoal))
		   (not (subgoal-unlinkable path-subgoal))
		   (subgoals-match linked-subgoal path-subgoal))
	      (set! result (clause-full-subsumed-by-clause clause (subgoal-clause path-subgoal))))
	  (if result
	      (begin
		(if dewey-numbers
		    (begin
		      (display "instance ")
		      (display-clause clause)
		      (display " full subsumed by path ")
		      (display-clause (subgoal-clause path-subgoal))
		      (newline)))
		(set! path-subsumptions (+ path-subsumptions 1))
		result)
	      (clause-full-subsumed-by-path-clause linked-subgoal (clause-path (subgoal-clause path-subgoal)))))
	#f)))

(define (clause-full-subsumed-by-clause clause path-clause)
  (let ((subgoals (unsimplifiable-subgoals (clause-subgoals clause)))
	(p-subgoals (unsimplifiable-subgoals (clause-subgoals path-clause)))
	result)
    (if (pair? p-subgoals)
	(begin
	  (set! instantiatable-vars (clause-variables path-clause))
	  (set! result (match-subgoal-lists subgoals p-subgoals))
	  (set! instantiatable-vars '())
	  result)
	#f)))

(define (match-subgoal-lists subgoals p-subgoals)
  (if (> debug-level 5)
      (begin
	(display "full subsumption test with ")
	(display-clause (subgoal-clause (car p-subgoals)))
	(display " ")))
  (if (and (not preprocessing)
	   (path-subgoal-clause-tested (car p-subgoals)))
      #f
      (begin
	(if preprocessing
	    (set! pre-subsumption-tests (+ pre-subsumption-tests 1))
	    (set! path-subsumption-tests (+ path-subsumption-tests 1)))
	(if (> (length subgoals) (length p-subgoals))
	    (if (predicates-match-individually subgoals p-subgoals)
		(if (subgoals-match-individually subgoals p-subgoals)
		    (begin
		      (set! var-counter 1)
		      (if (> debug-level 5)
			  (begin
			    (display "testing against subgoals ")
			    (display-subgoal-list p-subgoals)
			    (newline)))
		      (if (permutation-subsumed subgoals p-subgoals)
			  (begin
			    ;;(print "successful subsumption test!")
			    (subgoal-clause (car p-subgoals)))
			  (begin
			    (if (> debug-level 5) (print "fail: full test"))
			    (set! full-complete-fails (+ 1 full-complete-fails))
			    #f)))
		    (begin 
		      (if (> debug-level 5) (print "fail: single match"))
		      (set! full-single-fails (+ 1 full-single-fails))
		      #f))
		(begin 
		  (if (> debug-level 5) (print "fail: signature match"))
		      (set! full-signature-fails (+ 1 full-signature-fails))
		  #f))
	    (begin 
	      (if (> debug-level 5) (print "fail: length"))
	      (set! full-length-fails (+ 1 full-length-fails))
	      #f)))))

(define (subgoals-match-individually subgoals p-subgoals)
  (if (pair? p-subgoals)
      (if (subgoal-matches-individually subgoals (car p-subgoals))
	  (subgoals-match-individually subgoals (cdr p-subgoals))
	  #f)
      #t))

; (define (subgoals-match-individually subgoals p-subgoals)
;   (if (pair? p-subgoals)
;       (if (subgoal-matches-individually subgoals (car p-subgoals))
; 	  (subgoals-match-individually subgoals (cdr p-subgoals))
; 	  (if (and (eq-subgoal? (car p-subgoals)) (not (subgoal-ordered-eq (car p-subgoals))))
; 	      (let ((result #f))
; 		(set-subgoal-terms (car p-subgoals) (list (cadr (subgoal-terms (car p-subgoals)))
; 							  (car (subgoal-terms (car p-subgoals)))))
; 		(set! result (subgoal-matches-individually subgoals (car p-subgoals)))
; 		(set-subgoal-terms (car p-subgoals) (list (cadr (subgoal-terms (car p-subgoals)))
; 							  (car (subgoal-terms (car p-subgoals)))))
; 		(if result
; 		    (begin
; 		      (print "successful individual full match by switched equation!")
; 		      (subgoals-match-individually subgoals (cdr p-subgoals)))
; 		    #f))
; 	      #f))
;       #t))

(define (subgoal-matches-individually subgoals p-subgoal)
  (let ((valid-subgoals (do ((sg-pointer subgoals (cdr sg-pointer)))
			    ((or (null? sg-pointer) (sign-predsym>= (car sg-pointer) p-subgoal))
			     (if (and (pair? sg-pointer) (sign-predsym= (car sg-pointer) p-subgoal))
				 sg-pointer
				 '())))))
    (if (pair? valid-subgoals)
	(if  (match-lists-stop (subgoal-terms p-subgoal) (subgoal-terms (car valid-subgoals)))
	    (begin
	      (unbind-vars)
	      (car valid-subgoals))
	    (subgoal-matches-individually (cdr valid-subgoals) p-subgoal))
	#f)))

(define (subgoals-match subgoal path-subgoal)
  (set! instantiatable-vars (clause-variables (subgoal-clause path-subgoal)))
  (if (and (eq? (subgoal-sign subgoal) (subgoal-sign path-subgoal))
	   (eq? (subgoal-pred subgoal) (subgoal-pred path-subgoal))
	   (match-lists-stop (subgoal-terms path-subgoal) (subgoal-terms subgoal)))
      (begin
	(unbind-vars)
	(set! instantiatable-vars '())
	#t)
      (begin
	(set! instantiatable-vars '())
	#f)))

(define (permutation-subsumed subgoals p-subgoals)
  (if (pair? p-subgoals)
      (do ((success #f) (fail #f) (possible-matches subgoals) (rest-subgoals '()) (v #f))
	  ((or success fail) success)
	(if (> debug-level 5)
	    (begin
	      (display "...searching global match for subgoal ")
	      (display-subgoal (car p-subgoals))))
	(set! v (get-matching-subgoal possible-matches (car p-subgoals)))
	(if v
	    (begin
	      (if (> debug-level 5)
		(begin
		  (display "...found global match ")
		  (display-subgoal v)
		  (newline)))
	      (set! rest-subgoals (remq v subgoals))
	      (if (permutation-subsumed rest-subgoals (cdr p-subgoals))
		  (set! success #t)
		  (set! possible-matches (remq v possible-matches)))
	      (unbind-vars))
	    (begin
	      (if (> debug-level 5)
		(begin
		  (display "...could not find global match for path subgoal ")
		  (display-subgoal (car p-subgoals))
		  (newline)))
	      (set! fail #t))))
      #t))

(define (get-matching-subgoal possible-matches p-subgoal)
  (if (and (pair? possible-matches) (not (sign-predsym> (car possible-matches) p-subgoal)))
      (begin
	(if (> debug-level 5)
	    (begin
	      (display "...testing possible match ")
	      (display-subgoal (car possible-matches))))
	(if (and (eq? (subgoal-sign (car possible-matches)) (subgoal-sign p-subgoal))
		 (eq? (subgoal-pred (car possible-matches)) (subgoal-pred p-subgoal))
		 (match-lists-stop (subgoal-terms p-subgoal) (subgoal-terms (car possible-matches))))
	    (car possible-matches)
	    (if (sign-predsym> (car possible-matches) p-subgoal)
		#f
		(get-matching-subgoal (cdr possible-matches) p-subgoal))))
      #f))

(define (backsubsume-clauses-with-new-clause clause clauses)
  (if (pair? clauses)
      (if (clause-full-subsumed-by-clauselist (car clauses) (list clause))
	  (begin
	    (if dewey-numbers
		(begin 
		  (display "deleted back-subsumed input ")
		  (display-clause clause)
		  (newline)))
	    (delete-subgoals-from-path-index (clause-subgoals (car clauses)))
	    (backsubsume-clauses-with-new-clause clause (cdr clauses)))
	  (cons (car clauses) (backsubsume-clauses-with-new-clause clause (cdr clauses))))
      '()))


(define (clause-path-subsumed unsimplifieds)
  (if (pair? unsimplifieds)
      (let ((result (test-potential-subsuming-path-clauses unsimplifieds (length unsimplifieds) unsimplifieds)))
	(unset-tested-path-clauses)
	(if result
	    (begin
	      (if dewey-numbers
		  (begin
		    (display "instance ") 
		    (display-clause (subgoal-clause (car unsimplifieds)))
		    (display " subsumed by path ") 
		    (display-clause result)
		    (newline)))
	      (set! path-subsumptions (+ path-subsumptions 1))))
	result)
      #f))

(define (test-potential-subsuming-path-clauses subgoals clause-length unsimplifieds)
  (if (pair? subgoals)
      (let ((result (subgoal-subsumed-by-path-index (car subgoals))))
; 	(display "index match for subgoal ")
; 	(display-subgoal (car subgoals))
; 	(display " produced ")
; 	(if (null? result)
; 	    (print "empty list!")
; 	    (begin
; 	      (display-subgoal-list result)
; 	      (newline)))
	(set! result (test-subsuming-path-clauses unsimplifieds result))
	(if result
	    result
	    (test-potential-subsuming-path-clauses (cdr subgoals) clause-length unsimplifieds)))
      #f))

(define (test-subsuming-path-clauses subgoals subsuming-path-subgoals)
  (if (pair? subsuming-path-subgoals)
      (let ((p-subgoals (unsimplifiable-subgoals (clause-subgoals (subgoal-clause (car subsuming-path-subgoals)))))
	    result)
	(if (not (subgoal-unlinkable (car subsuming-path-subgoals)))
	    (begin
	      (set! instantiatable-vars (clause-variables (subgoal-clause (car subsuming-path-subgoals))))
	      ;;(set! instantiatable-vars (variables-in-subgoals (clause-subgoals (subgoal-clause (car subsuming-path-subgoals))) '()))
	      (set! result (match-subgoal-lists subgoals p-subgoals))
	      (set! instantiatable-vars '())
	      (set-path-subgoal-clause-tested (car subsuming-path-subgoals))
	      (if result
		  result
		  (test-subsuming-path-clauses subgoals (cdr subsuming-path-subgoals))))
	    (test-subsuming-path-clauses subgoals (cdr subsuming-path-subgoals))))
	#f))
