/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
/**
 *  File Schedule.hpp for running scheduled tasks.
 */

#ifndef __Schedule__
#define __Schedule__

#include "List.hpp"
#include "GlobalClock.hpp"

class Property;
class Problem;
class Options;


class Schedule 
{
 public:
  typedef List<Options*,CID_OPTION_LIST> List;

  Schedule (const Property&, const Options& cmdLineOptions);
  ~Schedule ();
  void run (Problem&, BK::GlobalClock::Timer& timer);

 private:

  // structure
  List* _schedule;
  const Options& _commandLineOptions;

  // schedules for CASC
  void casc18(const Property& p, int timeLimit);
  void casc19(const Property& p, int timeLimit);
}; // class Schedule


#endif // __Schedule__
