/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
#ifndef INC_TPTPParser_hpp_
#define INC_TPTPParser_hpp_

#include "antlr/config.hpp"
/* $ANTLR 2.7.1: "TPTP.g" -> "TPTPParser.hpp"$ */
#include "antlr/TokenStream.hpp"
#include "antlr/TokenBuffer.hpp"
#include "TPTPLexerTokenTypes.hpp"
#include "antlr/LLkParser.hpp"

#line 18 "TPTP.g"

#include <iostream>
#include "Unit.hpp"

#line 17 "TPTPParser.hpp"
class TPTPParser : public ANTLR_USE_NAMESPACE(antlr)LLkParser, public TPTPLexerTokenTypes
 {
#line 142 "TPTP.g"

#line 21 "TPTPParser.hpp"
protected:
	TPTPParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k);
public:
	TPTPParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf);
protected:
	TPTPParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k);
public:
	TPTPParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer);
	TPTPParser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state);
	public: void units(
		UnitList& us
	);
	public: void include(
		UnitList& us
	);
	public: void unit(
		Unit& unit
	);
	public: void kw_include();
	public: void kw_formula();
	public: InputType  type();
	public: void formula(
		Formula& f
	);
	public: void kw_clause();
	public: void clause(
		Clause& c
	);
	public: void xorformula(
		Formula& f
	);
	public: void literals(
		LiteralList& ls
	);
	public: void impformula(
		Formula& f
	);
	public: void literal(
		Literal& l
	);
	public: void orformula(
		Formula& f
	);
	public: bool  sign();
	public: void atom(
		Atom& a
	);
	public: void andformula(
		Formula& f
	);
	public: void terms(
		TermList& ts
	);
	public: void simple_formula(
		Formula& f
	);
	public: void term(
		Term& t
	);
	public: void varlist(
		VarList& vs
	);
	public: void vars(
		VarList& vs
	);
private:
	static const char* _tokenNames[];
	
};

#endif /*INC_TPTPParser_hpp_*/
