/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File:         BSMachine.cpp
// Description:  Core of backward subsumption.
// Created:      Feb 26, 2000, 20:20
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//============================================================================
#include "BSMachine.h"
//============================================================================
#undef DEBUG_NAMESPACE 
#ifdef DEBUG_BS_MACHINE
 #define DEBUG_NAMESPACE "BSMachine"
#endif
#include "debugMacros.h"
//============================================================================

namespace VK
{
  using namespace BK;
  using namespace Gematogen;
bool BSMachine::subsumeNextSetMode(ulong& subsumedClNum)
{
 CALL("subsumeNextSetMode(ulong& subsumedClNum)");
 while (_clauseEqualizer.next())
  {
   ulong i;	  
   for (i = 0; i < _nextLit; i++) _litEqualizer[i].load(); 
   for (i = 0; i < _nextSymLit; i++) _symLitEqualizer[i].load();
   if (equalizeLiterals())
    {
     if (_substJoin.joinInSetMode()) { subsumedClNum = _clauseEqualizer.currClauseNum(); return true; };
    };
  };
 return false;         
}; // bool BSMachine::subsumeNextSetMode(ulong& subsumedClNum)

bool BSMachine::subsumeNextMultisetMode(ulong& subsumedClNum)
{
 CALL("subsumeNextMultisetMode(ulong& subsumedClNum)");
 while (_clauseEqualizer.next())
  {
   ulong i;	  
   for (i = 0; i < _nextLit; i++) _litEqualizer[i].load(); 
   for (i = 0; i < _nextSymLit; i++) _symLitEqualizer[i].load();
   if (equalizeLiterals())
    {
     if (_substJoin.joinInMultisetMode()) { subsumedClNum = _clauseEqualizer.currClauseNum(); return true; };
    };
  };
 return false;         
}; // bool BSMachine::subsumeNextMultisetMode(ulong& subsumedClNum)



}; // namespace VK

//============================================================================
