/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
// File:         BuiltInTheory.cpp
// Description:  Built-in theory abstraction.  
// Created:      Jul 06, 2002, Alexandre Riazanov, riazanov@cs.man.ac.uk
//==================================================================
#include "RuntimeError.hpp"
#include "BuiltInTheory.hpp"
#include "VampireKernelConst.hpp"
//===================================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_BUILT_IN_THEORY
 #define DEBUG_NAMESPACE "BuiltInTheory"
#endif
#include "debugMacros.hpp"
//===================================================================

using namespace VK;
using namespace BK;

BuiltInTheory::~BuiltInTheory()
{
};


bool BuiltInTheory::interpret(ulong inputSymbolId,const char* nativeSymbol)
{
  CALL("interpret(ulong inputSymbolId,const char* nativeSymbol)");
  if (VampireKernelConst::isEquality(inputSymbolId))
    {
      return
        interpretAs(VampireKernelConst::UnordEqNum,nativeSymbol) &&
        interpretAs(VampireKernelConst::OrdEqNum,nativeSymbol);
    }
  else
    return interpretAs(inputSymbolId,nativeSymbol);
}; // bool BuiltInTheory::interpret(ulong inputSymbolId,const char* nativeSymbol)


//==================================================================
