/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
// File:         BuiltInTheory.hpp
// Description:  Built-in theory abstraction.  
// Created:      Jul 06, 2002, Alexandre Riazanov, riazanov@cs.man.ac.uk
//==================================================================
#ifndef BUILT_IN_THEORY_H
#define BUILT_IN_THEORY_H
//==================================================================
#include <cstddef>
#include "jargon.hpp"
#include "VampireKernelDebugFlags.hpp"
//===================================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_BUILT_IN_THEORY
 #define DEBUG_NAMESPACE "BuiltInTheory"
#endif
#include "debugMacros.hpp"
//===================================================================

namespace VK
{
  class Clause;
  class TmpLiteral;
  class BuiltInTheory
    {
    public:
      BuiltInTheory(const char* name) : _name(name)
	{
	};
      const char* name() { return _name; };
      virtual ~BuiltInTheory();
      bool interpret(ulong inputSymbolId,
		     const char* nativeSymbol);
      virtual Clause* simplify(TmpLiteral* lit,TmpLiteral* newLit) = 0;
    protected:
      BuiltInTheory() : _name(0) {};
    private:
      virtual bool interpretAs(ulong inputSymbolId,
			       const char* nativeSymbol) = 0;
    private:
      const char* _name;
    }; // class BuiltInTheory

}; // namespace VK


//=================================================================
#endif
