/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
// File:         ClauseQueue.hpp
// Description:  Queues of clauses. 
// Created:      Apr 13, 2001, 16:00
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//============================================================================
#ifndef CLAUSE_QUEUE_H
//=============================================================================
#define CLAUSE_QUEUE_H
#include <iostream> 
#include "jargon.hpp"
#include "FIFO.hpp"
#include "GlobAlloc.hpp"
#include "Clause.hpp"
//======================================================================

namespace VK
{
typedef BK::FIFO<BK::GlobAlloc,Clause*,Clause> ClauseQueue;
typedef BK::FIFO<BK::GlobAlloc,const Clause*,Clause> ConstClauseQueue;
}; // namespace VK

namespace std
{
  inline
  ostream& operator<<(ostream& str,const VK::ClauseQueue& q)
  {
    for (const VK::ClauseQueue::Entry* e = q.begin();
	 e;
	 e = e->next())
      str << e->value() << "\n";
    return  str;
  };
  inline
  ostream& operator<<(ostream& str,const VK::ConstClauseQueue& q)
  {
    for (const VK::ConstClauseQueue::Entry* e = q.begin();
	 e;
	 e = e->next())
      str << e->value() << "\n";
    return  str;
  };

};

//======================================================================
#endif
