/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
// File:         FTUnification.hpp
// Description:  Unification for flatterms.
// Created:      Jun 6, 2000, 15:00
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//====================================================
#ifndef FT_UNIFICATION_H
//====================================================
#define FT_UNIFICATION_H
#ifndef NO_DEBUG_VIS
 #include <iostream>
#endif
#include "jargon.hpp"
#include "Stack.hpp"
#include "VampireKernelDebugFlags.hpp"
#include "VampireKernelConst.hpp"
#include "Term.hpp" 
#include "Flatterm.hpp" 
//================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_FT_UNIFICATION
 #define DEBUG_NAMESPACE "FTUnification"
#endif 
#include "debugMacros.hpp"
//================================================= 

namespace VK
{
class FTUnification
{
 public:
  FTUnification() 
   : _bound("_bound"),
     _borderVar("_borderVar"),
     _borderTerm("_borderTerm")
  { 
    CALL("constructor FTUnification()");
   for (ulong v = 0; v < 2*VampireKernelConst::MaxNumOfVariables; v++) _subst[v] = 0;
  };
  
  /********
  void init() 
  {
    CALL("init()");
    _bound.init();
    _borderVar.init();
    _borderTerm.init();
    for (ulong v = 0; v < 2*VampireKernelConst::MaxNumOfVariables; v++) 
      _subst[v] = 0;
  };
  ***********/

  ~FTUnification() 
  {
    CALL("destructor ~FTUnification()");
  };

  bool unify(const Flatterm* t1,const Flatterm* t2); 
  
  const Flatterm* subst(ulong var) const { return _subst[var]; };

  #ifndef NO_DEBUG
   bool equalWithSubst(const Flatterm* t1,const Flatterm* t2);
  #endif

 private: 
  void reset();
  bool occurs(ulong var,const Flatterm* term);
  void bind(ulong var,const Flatterm* term);
 private:
  const Flatterm* _subst[2*VampireKernelConst::MaxNumOfVariables];
  BK::Stack<ulong,2*VampireKernelConst::MaxNumOfVariables> _bound;
  BK::Stack<ulong,VampireKernelConst::MaxTermSize> _borderVar;
  BK::Stack<const Flatterm*,VampireKernelConst::MaxTermSize> _borderTerm;
}; // class FTUnification

}; // namespace VK



//================================================
#undef DEBUG_NAMESPACE
//================================================= 
#endif
