/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
// File:         LiteralList.cpp
// Description:  Representation of lists of stored marked literals.
// Created:      Dec 09, 2000, 16:30
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//====================================================  
#include "LiteralList.hpp"
//==================================================== 
using namespace BK;
using namespace VK;

#ifdef DEBUG_ALLOC_OBJ_TYPE
 ClassDesc LiteralList::_classDesc("LiteralList",sizeof(LiteralList),sizeof(LiteralList));
 ClassDesc LiteralList::Element::_classDesc("LiteralList::Element",sizeof(LiteralList::Element),sizeof(LiteralList::Element));
#endif

ostream& LiteralList::output(ostream& str) const
{
 CALL("output(ostream& str) const");
 ConstIterator iter(this);
 ulong sel = numOfSelectedLits();
 for (ulong i = 0; i < sel; i++)
  {
   ASSERT(iter.notEnd());
   str << iter.currentLiteral();
   iter.next();       
   if (i + 1 < sel) str <<  " \\/ ";
  };  
  
 if (iter.notEnd()) str << " | ";
 while (iter.notEnd()) 
  { 
   str << iter.currentLiteral();
   iter.next();          
   if (iter.notEnd()) str << " \\/ ";
  };
 return str;
}; // ostream& LiteralList::output(ostream& str) const



//====================================================  

