/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File:         OldBSIndex.cpp
// Description:  Simple index for backward subsumption based on discrimination trees.
// Created:      Jan 15, 2001, 14:30
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//============================================================================
#include "OldBSIndex.h"
//============================================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_OLD_BS_INDEX
 #define DEBUG_NAMESPACE "OldBSIndex"
#endif
#include "debugMacros.h"
//============================================================================
 
namespace VK
{
  using namespace BK;
  using namespace Gematogen;
#ifdef DEBUG_ALLOC_OBJ_TYPE
 #include "ClassDesc.h"
 ClassDesc OldBSIndex::DiscTree::Node::_nonleafNodeClassDesc("OldBSIndex::DiscTree::Node");
 ClassDesc OldBSIndex::DiscTree::Node::_leafClassDesc("OldBSIndex::DiscTree::Node");
 ClassDesc OldBSIndex::CLSkipList::_classDesc("OldBSIndex::CLSkipList");
 ClassDesc OldBSIndex::CLSkipList::Node::_classDesc("OldBSIndex::CLSkipList::Node");
 ClassDesc OldBSIndex::CSkipList::_classDesc("OldBSIndex::CSkipList");
 ClassDesc OldBSIndex::CSkipList::Node::_classDesc("OldBSIndex::CSkipList::Node");
#endif 

void OldBSIndex::destroy()
{
 CALL("destroy()");
 for (ulong i = 0; i < VampireKernelConst::MaxNumOfDifferentHeaders; i++) _propLitInd[i].destroy();
 
}; // void OldBSIndex::destroy()

}; // namespace VK



//======================================================================
#undef DEBUG_NAMESPACE
//============================================================================
