/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
// File:         OldBSMachine.hpp
// Description:  Core of backward subsumption based on discrimination trees. 
// Created:      Feb 26, 2000, 20:20
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//============================================================================
#ifndef OLD_BS_MACHINE_H  
//=============================================================================
#define OLD_BS_MACHINE_H 
#ifndef NO_DEBUG_VIS
 #include <iostream>
#endif
#include "jargon.hpp"
#include "VampireKernelDebugFlags.hpp"
#include "VampireKernelConst.hpp"
#include "Stack.hpp"
#include "OldBSIndex.hpp"
#include "Term.hpp"
#include "Clause.hpp"
//============================================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_OLD_BS_MACHINE
 #define DEBUG_NAMESPACE "OldBSMachine"
#endif
#include "debugMacros.hpp"
//============================================================================
namespace VK
{
  using namespace BK;
  using namespace Gem;
class OldBSMachine
{
 public: 
  typedef OldBSIndex::CSkipList CSkipList;
 public:
  OldBSMachine() {};
  ~OldBSMachine() { CALL("destructor ~OldBSMachine()"); };
  bool subsumeNextSetMode(ulong& subsumedClNum);
  bool subsumeNextMultisetMode(ulong& subsumedClNum);
  void resetQuery(const Clause* cl) 
  { 
   _clause = cl;
  };
  bool endOfQuery() 
  {
   return false; // dummy 
  }; 
  bool queryPropLit(const CSkipList* occList) 
  {  
   return false; // dummy 
  }; 
  void queryNextLit() 
  { 
  }; 
  bool queryEndOfLit() 
  {      
    return false; // dummy 
  };

 private:
  const Clause* _clause;
}; // class OldBSMachine 

}; // namespace VK


//======================================================================
#undef DEBUG_NAMESPACE
//======================================================================
#endif
