/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File:         OldBackwardSubsumption.cpp
// Description:  Implements back subsumption using discrimination trees.
// Created:      Jan 14, 2001, 18:00
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//============================================================================
#include "OldBackwardSubsumption.h"
//============================================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_OLD_BACKWARD_SUBSUMPTION
 #define DEBUG_NAMESPACE "OldBackwardSubsumption"
#endif
#include "debugMacros.h"
//============================================================================

namespace VK
{
  using namespace BK;
  using namespace Gematogen;
void OldBackwardSubsumption::integrate(const Clause* cl)
{
 CALL("integrate(const Clause* cl)");
 _integrator.clause(cl->Number());
 ulong ln = 0;
 for (LiteralList::Iterator iter(cl->LitList()); iter.notEnd(); iter.next())
  {
   const TERM* lit = iter.currentLiteral();
   if (lit->arity()) { _integrator.literal(lit,ln); }
   else _integrator.propLit(lit);
   ln++;
  };
}; // void OldBackwardSubsumption::integrate(const Clause* cl) 

}; // namespace VK


//============================================================================
