/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

#ifndef PR_PRIVATE_DECLARATIONS_H
//=======================================================
#define PR_PRIVATE_DECLARATIONS_H

#include <stdio.h>

#ifndef __cplusplus
 #define __cplusplus
#endif

#define YY_NEVER_INTERACTIVE 1

#include "pr_abstract_syntax.h"
//=======================================================

union yystypeUnion
 { 
  SYMBOL_COORDINATES coord;
  PR_SYMBOL_OCC* token;
  PR_TERM* term;
  PR_TERM_LIST* term_list;
  PR_LITERAL* literal;
  PR_LITERAL_LIST* literal_list;
 }; 
 
#define YYSTYPE union yystypeUnion 

extern FILE* yyin;
int yylex();
void yyerror(char *str) {};
int yyparse();
void resetScanner();
int countTabs(char *str);
char* registerSym(const char* str);

extern int charNum;
extern int lineNum;
extern int numOfTabs;

extern PR_FILE_PARS_RESULT* FileParsResult;
//=======================================================
#endif
