/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
// File:         StandardLiteralOrdering.hpp
// Description:  Extension of the simplification ordering on terms
//               to literals.  
// Created:      Nov 07, 2002, Alexandre Riazanov, riazanov@cs.man.ac.uk
//==================================================================
#ifndef STANDARD_LITERAL_ORDERING_H
#define STANDARD_LITERAL_ORDERING_H
//==================================================================
#include "jargon.hpp"
#include "VampireKernelDebugFlags.hpp"
#include "Comparison.hpp"
#include "SimplificationOrdering.hpp"
#include "tmp_literal.hpp"
#include "Signature.hpp"
#include "LiteralOrdering.hpp"
//===================================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_STANDARD_LITERAL_ORDERING
 #define DEBUG_NAMESPACE "StandardLiteralOrdering"
#endif
#include "debugMacros.hpp"
//===================================================================

namespace VK
{
  class StandardLiteralOrdering : public LiteralOrdering
  {
  public:
    StandardLiteralOrdering();    
    ~StandardLiteralOrdering();
    void init();
    void destroy();
    void setMode(long m) 
    { 
      _mode = m; 
      _isStratified = (_mode != 0L) && (_mode != 3L);
    };
    BK::Comparison compare(TmpLiteral* lit1,
			   TmpLiteral* lit2) const;
    BK::Comparison compareLayers(const TmpLiteral* lit1,
				 const TmpLiteral* lit2) const;
  private:

    BK::Comparison compareEq(TmpLiteral* lit1,
			 TmpLiteral* lit2) const;
    BK::Comparison compareEqAtomsOO(TmpLiteral* lit1,
				TmpLiteral* lit2) const;
    BK::Comparison compareEqAtomsOU(TmpLiteral* lit1,
				TmpLiteral* lit2) const;
    BK::Comparison compareEqAtomsUU(TmpLiteral* lit1,
				TmpLiteral* lit2) const;
    BK::Comparison compareNeqWithEq(TmpLiteral* neq,
				    TmpLiteral* eq) const;
    void* operator new(size_t,StandardLiteralOrdering* ptr)
    {
      return ptr;
    };

    
  private:
    long _mode;
  }; // class StandardLiteralOrdering
}; // namespace VK


//=================================================================
#endif
