/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
// File:         UVariable.cpp
// Description:  New specialised representation of variables for unification.
//               See also UTerm.hpp 
// Created:      Mar 15, 2003, Alexandre Riazanov, riazanov@cs.man.ac.uk
// Status:       Sketch.
//============================================================================
#include "UVariable.hpp"
#include "UTerm.hpp"
using namespace VK;
//============================================================================

UVariable::Domain* UVariable::_currentDomain; // implicitely initialised to 0

//============================================================================
#ifdef DEBUG_U_VARIABLE
#  undef DEBUG_NAMESPACE
#  define DEBUG_NAMESPACE "UVariable"
#endif
#include "debugMacros.hpp"
//============================================================================

#ifndef NO_DEBUG_VIS

ostream& UVariable::output(ostream& str) const
{
  CALL("output(ostream& str) const");
  return str << "U" << absoluteNumber();
}; // ostream& UVariable::output(ostream& str) const

#endif

 
#ifndef NO_DEBUG
bool UVariable::isCycleFree()
{
  CALL("isCycleFree()");
  return 
    isFree() || 
    (!content()->containsVar(this));
};
#endif



//============================================================================
