/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File:         VampireKernelDebugFlags.h
// Description:  Debugging flags for VampireKernel
// Created:      Feb 12, 2000, 16:10
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//=================================================================== 
#include "BlodKorvDebugFlags.h"
//=================================================================== 

#ifdef NO_DEBUG
 #undef NO_DEBUG_VIS
 #define NO_DEBUG_VIS
#endif 

//#define DEBUG_AUTO_FUNCTOR_PRECEDENCE
#define DEBUG_BACK_DEMODULATION
//#define DEBUG_BACK_PARA_CANDIDATES
//#define DEBUG_BACKWARD_SUBSUMPTION
//#define DEBUG_BACKWARD_SUPERPOSITION
//#define DEBUG_BINARY_RESOLUTION
//#define DEBUG_BS_INDEX
//#define DEBUG_BS_MACHINE
//#define DEBUG_CLAUSE
#define DEBUG_CLAUSE_ASSEMBLER
//#define DEBUG_CLAUSE_BACKGROUND
//#define DEBUG_CLAUSE_NUM_INDEX
//#define DEBUG_CLAUSE_SET
//#define DEBUG_COMPONENT_NAME
//#define DEBUG_DEFINED_HEADER_TABLE
//#define DEBUG_DIV_INTO_COMP
//#define DEBUG_DTREE
//#define DEBUG_EQ_FACTORING
//#define DEBUG_FLATTERM
//#define DEBUG_FORWARD_SUBSUMPTION
//#define DEBUG_FORWARD_SUBSUMPTION_FRONT_END
//#define DEBUG_FORWARD_SUPERPOSITION
//#define DEBUG_FORWARD_DEMODULATION
#define DEBUG_FORWARD_MATCHING_SUBSTITUTION_CACHE
//#define DEBUG_FS_CODE
//#define DEBUG_FS_COMMAND
//#define DEBUG_FT_UNIFICATION
//#define DEBUG_INFERENCE_DISPATCHER
//#define DEBUG_INFERENCE_TREE
#define DEBUG_INPUT
#define DEBUG_INSTANCE_RETRIEVAL_FOR_DEMODULATION
//#define DEBUG_IU_COMMAND
//#define DEBUG_KB_COMMAND
//#define DEBUG_KB_CONSTRAINT
//#define DEBUG_KEPT
//#define DEBUG_LARGE_WEIGHT_POLYNOMIAL
//#define DEBUG_LITERAL_LIST
//#define DEBUG_LITERAL_SELECTION
//#define DEBUG_LITERAL_SHARING
//#define DEBUG_LOGGING
//#define DEBUG_MASTER
//#define DEBUG_NEW_CLAUSE
#define DEBUG_NONRECURSIVE_KB_ORDERING
#define DEBUG_NONUNIFORM_ARGUMENT_SENSITIVE_TERM_WEIGHTING
#define DEBUG_NONUNIFORM_CONSTANT_TERM_WEIGHTING
//#define DEBUG_OPEN_NEW_CLAUSE
//#define DEBUG_OLD_BACKWARD_SUBSUMPTION
//#define DEBUG_OLD_BS_INDEX
//#define DEBUG_OLD_BS_MACHINE
//#define DEBUG_OLD_FS_CODE
//#define DEBUG_OR_INDEX
//#define DEBUG_OR_PREMISE
//#define DEBUG_PAGED_PASSIVE_CLAUSE_STORAGE
#define DEBUG_PARSER
//#define DEBUG_PREFIX
//#define DEBUG_PREMISE_FACTORING
//#define DEBUG_PROBLEM_PROFILE
//#define DEBUG_SHARED_KB_CONSTR
//#define DEBUG_SHARING
//#define DEBUG_SIGNATURE 
//#define DEBUG_SIMPLE_SUBSTITUTION
//#define DEBUG_SIMPLIFICATION_ORDERING
//#define DEBUG_SPLITTING
//#define DEBUG_STANDALONE
//#define DEBUG_STANDARD_KB_ORDERING
//#define DEBUG_SUBSUMPTION_CHECK
//#define DEBUG_SYMBOL_INFO
//#define DEBUG_TABULATION
//#define DEBUG_TERM
//#define DEBUG_TMP_LIT_LIST
//#define DEBUG_UNIFICATION 
//#define DEBUG_UNIFORM_TERM_WEIGHTING
//#define DEBUG_UNIT_CONFLICT
//#define DEBUG_VAMPIRE_KERNEL
//#define DEBUG_VARIABLES
//#define DEBUG_WEIGHT_FORMULA
//#define DEBUG_WEIGHT_POLYNOMIAL

#ifdef NO_DEBUG
 #undef DEBUG_AUTO_FUNCTOR_PRECEDENCE
 #undef DEBUG_BACK_DEMODULATION
 #undef DEBUG_BACK_PARA_CANDIDATES
 #undef DEBUG_BACKWARD_SUBSUMPTION
 #undef DEBUG_BACKWARD_SUPERPOSITION
 #undef DEBUG_BINARY_RESOLUTION
 #undef DEBUG_BS_INDEX
 #undef DEBUG_BS_MACHINE
 #undef DEBUG_CLAUSE
 #undef DEBUG_CLAUSE_ASSEMBLER
 #undef DEBUG_CLAUSE_BACKGROUND
 #undef DEBUG_CLAUSE_NUM_INDEX
 #undef DEBUG_CLAUSE_SET 
 #undef DEBUG_COMPONENT_NAME
 #undef DEBUG_DEFINED_HEADER_TABLE
 #undef DEBUG_DIV_INTO_COMP
 #undef DEBUG_DTREE
 #undef DEBUG_EQ_FACTORING
 #undef DEBUG_FLATTERM
 #undef DEBUG_FORWARD_SUBSUMPTION
 #undef DEBUG_FORWARD_SUBSUMPTION_FRONT_END
 #undef DEBUG_FORWARD_SUPERPOSITION
 #undef DEBUG_FORWARD_DEMODULATION
 #undef DEBUG_FORWARD_MATCHING_SUBSTITUTION_CACHE
 #undef DEBUG_FS_CODE
 #undef DEBUG_FS_COMMAND
 #undef DEBUG_FT_UNIFICATION
 #undef DEBUG_INFERENCE_DISPATCHER
 #undef DEBUG_INFERENCE_TREE
 #undef DEBUG_INPUT
 #undef DEBUG_INSTANCE_RETRIEVAL_FOR_DEMODULATION
 #undef DEBUG_IU_COMMAND
 #undef DEBUG_KB_COMMAND
 #undef DEBUG_KB_CONSTRAINT
 #undef DEBUG_KEPT
 #undef DEBUG_LARGE_WEIGHT_POLYNOMIAL
 #undef DEBUG_LITERAL_LIST
 #undef DEBUG_LITERAL_SELECTION
 #undef DEBUG_LITERAL_SHARING
 #undef DEBUG_LOGGING
 #undef DEBUG_MASTER
 #undef DEBUG_NEW_CLAUSE
 #undef DEBUG_NONRECURSIVE_KB_ORDERING
 #undef DEBUG_NONUNIFORM_ARGUMENT_SENSITIVE_TERM_WEIGHTING
 #undef DEBUG_NONUNIFORM_CONSTANT_TERM_WEIGHTING
 #undef DEBUG_OPEN_NEW_CLAUSE
 #undef DEBUG_OR_INDEX
 #undef DEBUG_OR_PREMISE
 #undef DEBUG_OLD_BACKWARD_SUBSUMPTION
 #undef DEBUG_OLD_BS_INDEX
 #undef DEBUG_OLD_BS_MACHINE
 #undef DEBUG_OLD_FS_CODE
 #undef DEBUG_PAGED_PASSIVE_CLAUSE_STORAGE
 #undef DEBUG_PARSER
 #undef DEBUG_PREFIX 
 #undef DEBUG_PREMISE_FACTORING
 #undef DEBUG_PROBLEM_PROFILE
 #undef DEBUG_SHARED_KB_CONSTR
 #undef DEBUG_SHARING
 #undef DEBUG_SIGNATURE 
 #undef DEBUG_SIMPLE_SUBSTITUTION
 #undef DEBUG_SIMPLIFICATION_ORDERING
 #undef DEBUG_SPLITTING
 #undef DEBUG_STANDALONE
 #undef DEBUG_STANDARD_KB_ORDERING
 #undef DEBUG_SUBSUMPTION_CHECK
 #undef DEBUG_SYMBOL_INFO
 #undef DEBUG_TABULATION
 #undef DEBUG_TERM
 #undef DEBUG_TMP_LIT_LIST
 #undef DEBUG_UNIFICATION
 #undef DEBUG_UNIFORM_TERM_WEIGHTING
 #undef DEBUG_UNIT_CONFLICT
 #undef DEBUG_VAMPIRE_KERNEL
 #undef DEBUG_VARIABLES 
 #undef DEBUG_WEIGHT_FORMULA
 #undef DEBUG_WEIGHT_POLYNOMIAL
#else
 #ifdef DEBUG_ALL
  #define DEBUG_AUTO_FUNCTOR_PRECEDENCE
  #define DEBUG_BACK_DEMODULATION
  #define DEBUG_BACK_PARA_CANDIDATES
  #define DEBUG_BACKWARD_SUBSUMPTION
  #define DEBUG_BACKWARD_SUPERPOSITION
  #define DEBUG_BINARY_RESOLUTION
  #define DEBUG_BS_INDEX
  #define DEBUG_BS_MACHINE
  #define DEBUG_CLAUSE
  #define DEBUG_CLAUSE_ASSEMBLER
  #define DEBUG_CLAUSE_BACKGROUND
  #define DEBUG_CLAUSE_NUM_INDEX
  #define DEBUG_CLAUSE_SET
  #define DEBUG_COMPONENT_NAME
  #define DEBUG_DEFINED_HEADER_TABLE
  #define DEBUG_DIV_INTO_COMP
  #define DEBUG_DTREE
  #define DEBUG_EQ_FACTORING
  #define DEBUG_FLATTERM
  #define DEBUG_FORWARD_SUBSUMPTION
  #define DEBUG_FORWARD_SUBSUMPTION_FRONT_END 
  #define DEBUG_FORWARD_SUPERPOSITION
  #define DEBUG_FORWARD_DEMODULATION
  #define DEBUG_FORWARD_MATCHING_SUBSTITUTION_CACHE
  #define DEBUG_FS_CODE
  #define DEBUG_FS_COMMAND
  #define DEBUG_FT_UNIFICATION
  #define DEBUG_INFERENCE_DISPATCHER
  #define DEBUG_INFERENCE_TREE
  #define DEBUG_INPUT
  #define DEBUG_INSTANCE_RETRIEVAL_FOR_DEMODULATION
  #define DEBUG_IU_COMMAND
  #define DEBUG_KB_COMMAND
  #define DEBUG_KB_CONSTRAINT
  #define DEBUG_KEPT
  #define DEBUG_LARGE_WEIGHT_POLYNOMIAL
  #define DEBUG_LITERAL_LIST
  #define DEBUG_LITERAL_SELECTION
  #define DEBUG_LITERAL_SHARING
  #define DEBUG_LOGGING
  #define DEBUG_MASTER
  #define DEBUG_NEW_CLAUSE
  #define DEBUG_NONRECURSIVE_KB_ORDERING
  #define DEBUG_NONUNIFORM_ARGUMENT_SENSITIVE_TERM_WEIGHTING
  #define DEBUG_NONUNIFORM_CONSTANT_TERM_WEIGHTING
  #define DEBUG_OPEN_NEW_CLAUSE
  #define DEBUG_OR_INDEX
  #define DEBUG_OR_PREMISE
  #define DEBUG_OLD_BACKWARD_SUBSUMPTION
  #define DEBUG_OLD_BS_INDEX
  #define DEBUG_OLD_BS_MACHINE
  #define DEBUG_OLD_FS_CODE
  #define DEBUG_PAGED_PASSIVE_CLAUSE_STORAGE
  #define DEBUG_PARSER
  #define DEBUG_PREFIX
  #define DEBUG_PREMISE_FACTORING
  #define DEBUG_PROBLEM_PROFILE
  #define DEBUG_SHARED_KB_CONSTR
  #define DEBUG_SHARING
  #define DEBUG_SIGNATURE
  #define DEBUG_SIMPLE_SUBSTITUTION
  #define DEBUG_SIMPLIFICATION_ORDERING
  #define DEBUG_SPLITTING
  #define DEBUG_STANDALONE
  #define DEBUG_STANDARD_KB_ORDERING
  #define DEBUG_SUBSUMPTION_CHECK
  #define DEBUG_SYMBOL_INFO
  #define DEBUG_TABULATION
  #define DEBUG_TERM
  #define DEBUG_TMP_LIT_LIST
  #define DEBUG_UNIFICATION  
  #define DEBUG_UNIFORM_TERM_WEIGHTING
  #define DEBUG_UNIT_CONFLICT
  #define DEBUG_VAMPIRE_KERNEL
  #define DEBUG_VARIABLES
  #define DEBUG_WEIGHT_FORMULA
  #define DEBUG_WEIGHT_POLYNOMIAL
 #endif
#endif


//==========================================================================

