/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File:         VampireKernelInterceptMacros.cpp
// Description:  Some objects used in VampireKernelInterceptMacros.h .
// Created:      Dec 05, 2000, 14:00
// Author:       Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//====================================================  

#ifdef INTERCEPT_FORWARD_MATCHING_INDEXING
#include "Logging.h"
Logging FMILog(Logging::ForwardMatching);
const Flatterm* interceptedForwardMatchingQuery = (const Flatterm*)0;
long maxSizeOfFMILogFile = LONG_MAX; 
#endif

#ifdef INTERCEPT_BACKWARD_SUBSUMPTION_INDEXING
#include "Logging.h"
Logging BSILog(Logging::BackwardSubsumption);
const Clause* interceptedBackwardSubsumptionQuery = (const Clause*)0;
ulong interceptedBackwardSubsumptionResultTotal = 0UL;
long maxSizeOfBSILogFile = LONG_MAX;
ulong interceptedBackwardSubsumptionNextSymbolToDeclare = 0UL;
#endif

#ifdef INTERCEPT_BACKWARD_MATCHING_INDEXING
#include "Logging.h"
Logging BMILog(Logging::BackwardMatching);
const TERM* interceptedBackwardMatchingQuery = (const TERM*)0;
ulong interceptedBackwardMatchingResultTotal = 0UL;
long maxSizeOfBMILogFile = LONG_MAX;
#endif

//=====================================================
