/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/


#include "iu_command.h"
//===========================================================
using namespace VK;

#ifndef NO_DEBUG_VIS
ostream& operator<<(ostream& str,IU_COMMAND::TAG tag)
{
  switch (tag)
    {
    case IU_COMMAND::START: return str << "START";
    case IU_COMMAND::VAR: return str << "VAR"; 
    case IU_COMMAND::VAR_FIRST_OCC: return str << "VAR_FIRST_OCC"; 
    case IU_COMMAND::FUNC: return str << "FUNC"; 
    case IU_COMMAND::FUNC_PLAIN: return str << "FUNC_PLAIN"; 
    case IU_COMMAND::FUNC_GROUND: return str << "FUNC_GROUND"; 
    case IU_COMMAND::CONST: return str << "CONST";
    case IU_COMMAND::END: return str << "END"; 
    default: return str << "UNKNOWN IU_COMMAND"; 
    };
};

ostream& IU_COMMAND::output(ostream& str,const IU_COMMAND* start) const
{
  str << '[' << this - start << "] " << Tag();
  if (Tag() == END) return str;
  str << ' ';
  Symbol().output(str); 

  if ((Tag() == FUNC) || (Tag() == FUNC_GROUND) || (Tag() == FUNC_PLAIN))
    {
      str << " next = [" << NextCommand() - start << "] ";
      PREFIX::outputTerm(str,Term());
    };
  if (Tag() == START) 
    {
      str << " variables = [" << (AllVars() ? (AllVars() - start) : 0) << "] ";
      PREFIX::outputTerm(str,Term());
    }; 
  if (Tag() == VAR_FIRST_OCC) 
    str << " next variable = [" << (NextVar() ? (NextVar() - start) : 0) << ']';
  return str;
}; // ostream& IU_COMMAND::output(ostream& str,const IU_COMMAND* start) const

ostream& IU_COMMAND::outputCode(ostream& str) const
{
  const IU_COMMAND* com;
  for (com = this; com->Tag() != END; com++)
    com->output(str,this) << '\n';
  return com->output(str,this) << '\n';
}; // ostream& IU_COMMAND::outputCode(ostream& str) const 
#endif

//===========================================================
