/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

#ifndef IU_COMMAND_H
//===========================================================
#define IU_COMMAND_H
#ifndef NO_DEBUG_VIS
 #include <iostream.h>
#endif
#include "jargon.h"
#include "VampireKernelDebugFlags.h"
#include "prefix.h"
//#include "variables.h"
//================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_IU_COMMAND
 #define DEBUG_NAMESPACE "IU_COMMAND"
#endif
#include "debugMacros.h"
//=================================================
namespace VK
{
class IU_COMMAND
 {
  public: 
   enum TAG
    {
     START,
     VAR,
     VAR_FIRST_OCC,
     FUNC,
     FUNC_PLAIN,
     FUNC_GROUND,
     CONST,
     END
    };
  private: // structure of a command
   TAG tag;
   PREF_SYM sym;
   PREFIX_SYM* term;
   IU_COMMAND* nextCommand;
  public:
   IU_COMMAND() {};
   ~IU_COMMAND() {};
   TAG& Tag() { return tag; };
   const TAG& Tag() const { return tag; };
   const PREF_SYM& Symbol() const { return sym; };
   PREF_SYM& Symbol() { return sym; };
   PREFIX_SYM*& Term() { return term; };
   const PREFIX_SYM* const & Term() const { return term; };
   IU_COMMAND*& NextCommand() { return nextCommand; };
   const IU_COMMAND* const & NextCommand() const { return nextCommand; };
   IU_COMMAND*& AllVars() 
    {
     CALL("AllVars()");
     ASSERT(Tag() == START);
     return nextCommand; 
    };
   const IU_COMMAND* const & AllVars() const 
    {
     CALL("AllVars()");
     ASSERT(Tag() == START);
     return nextCommand; 
    };
   IU_COMMAND*& NextVar() 
    {
     CALL("NextVar()");
     ASSERT(Tag() == VAR_FIRST_OCC);
     return nextCommand; 
    };
   const IU_COMMAND* const & NextVar() const
    {
     CALL("NextVar()");
     ASSERT(Tag() == VAR_FIRST_OCC);
     return nextCommand; 
    }; 
   void Inversepolarity() // applicable to a START command only
    {
     CALL("Inversepolarity()");
     ASSERT(Tag() == START);
     sym.Inversepolarity();
    };
  public: // for debugging 
   #ifndef NO_DEBUG_VIS
    ostream& output(ostream& str,const IU_COMMAND* start) const;
    ostream& outputCode(ostream& str) const; 
   #endif
 }; // class IU_COMMAND

}; // namespace VK

//================================================
#undef DEBUG_NAMESPACE
//===========================================================
#endif
