/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

#ifndef OR_MACHINE_H 
//==========================================================================
#define OR_MACHINE_H
#include "jargon.h"
#include "iu_command.h"
#include "prefix.h"
#include "variables.h"
#include "or_index.h"
#include "iu_machine.h"
//==========================================================================

namespace VK
{

class OR_MACH : public IU_MACH
 {
  public:
   OR_MACH(OR_INDEX* resIndex) : _ordResIndex(resIndex) {};
   ~OR_MACH() {};
   void init(OR_INDEX* resIndex) { IU_MACH::init(); _ordResIndex = resIndex; };
   void assignResIndex(OR_INDEX* resIndex) { _ordResIndex = resIndex; };
   bool FindFirstLeaf()
    {
     return IU_MACH::FindFirstLeaf(*(_ordResIndex->Tree(Code()->Symbol().Func())));
    };
   void Destroy() 
   {
    IU_MACH::Destroy();
   };
   #ifndef NO_DEBUG
    bool clean() const 
    {
     return IU_MACH::clean();
    };
   #endif    
  private:
   OR_INDEX* _ordResIndex;
 }; // class OR_MACH : public IU_MACH

}; // namespace VK

//==========================================================================
#endif

