/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

#ifndef PARA_MACHINE_H
//=================================================================
#define PARA_MACHINE_H
#ifndef NO_DEBUG_VIS
 #include <iostream.h>
#endif
#include "jargon.h"
#include "VampireKernelDebugFlags.h"
#include "iu_command.h"
#include "iu_machine.h"
//================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_FORWARD_SUPERPOSITION
 #define DEBUG_NAMESPACE "PARA_MACH"
#endif
#include "debugMacros.h"
//=================================================
namespace VK
{
class PREFIX_SYM;
class BackParaCandidates;
class PARA_MACH : private IU_MACH
 {
  public: 
   PARA_MACH() {};
   ~PARA_MACH() { CALL("destructor ~PARA_MACH()"); };
   void SetIndex(ulong ind) { IU_MACH::SetIndex(ind); };
   ulong GetIndex() const { return IU_MACH::GetIndex(); };
   void CompileComplexTerm(PREFIX_SYM* t)
    {
     CALL("CompileComplexTerm(PREFIX_SYM* t)");      
     IU_MACH::CompileLiteral(t);
    };
   void CompilePseudoLiteral(TERM header,PREFIX_SYM* t)
    {
     IU_MACH::CompilePseudoLiteral(header,t);
    }; 
   bool FindFirstLeaf(OR_INDEX_TREE_NODE* tree) 
    {
     return IU_MACH::FindFirstLeaf(tree); 
    }; 
   bool FindNextLeaf() { return IU_MACH::FindNextLeaf(); };
   void ResetCandidatesFromLeaf() { IU_MACH::ResetCandidatesFromLeaf(); };
   RES_PAIR_LIST* NextCandidateFromTheLeaf() { return IU_MACH::NextCandidate(); };
   

   BackParaCandidates* BPCandidatesFromLeaf() 
   {
    return IU_MACH::CurrentLeaf()->BPCandidates();
   };   

   bool VariablesFromIndexAffected() { return IU_MACH::VariablesFromIndexAffected(); };
  public: // for debugging
   #ifndef NO_DEBUG_VIS
    ostream& output(ostream& str) const
    {  
     return IU_MACH::outputCode(str);
    };
   #endif
 }; // class PARA_MACH : private IU_MACH
}; // namespace VK
//================================================
#undef DEBUG_NAMESPACE 
//=================================================================
#endif




























