/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
#include "weight_formula.hpp"

//=================================================
#undef DEBUG_NAMESPACE  
#ifdef DEBUG_WEIGHT_FORMULA
 #define DEBUG_NAMESPACE "LARGE_WEIGHT_FORMULA"
#endif
#include "debugMacros.hpp"
//=================================================


using namespace VK;




LARGE_WEIGHT_FORMULA::LARGE_WEIGHT_FORMULA() 
 : var_counter(), 
   const_part(0L) 
{
  CALL("constructor LARGE_WEIGHT_FORMULA()");
};


#ifndef NO_DEBUG_VIS
ostream& LARGE_WEIGHT_FORMULA::output(ostream& str)
{
  var_counter.ResetIteration();
  str << const_part;
  for (const Unifier::Variable* var = var_counter.NextRegistered();var;var = var_counter.NextRegistered())
    {
      long score = var_counter.Score(var);
      if (score < 0) { str << " - " << score*(-1); }
      else str << " + " << score;
      var->output(str);
    };
  return str; 
}; // ostream& LARGE_WEIGHT_FORMULA::output(ostream& str)

ostream& LARGE_WEIGHT_FORMULA::outputWithSubst(ostream& str)
{
  output(str) << "  WHERE\n";
  return Unifier::current()->output(str,Prefix::outputWordWithSubst);
}; // ostream& LARGE_WEIGHT_FORMULA::outputWithSubst(ostream& str)

#endif 


//=================================================
#undef DEBUG_NAMESPACE  
#ifdef DEBUG_WEIGHT_FORMULA
 #define DEBUG_NAMESPACE "ORD_FORMULA"
#endif
#include "debugMacros.hpp"
//=================================================

#ifndef NO_DEBUG_VIS
ostream& ORD_FORMULA::output(ostream& str)
{
  Prefix::outputWordWithSubst(str,term1) << " > ";
  Prefix::outputWordWithSubst(str,term2) << '\n';
  str << "DIFF.FORMULA:   ";
  difference.output(str) << '\n';
  str << "COMPUTED DIFF.: "; 
  return subst_diff.output(str) << '\n';
}; // ostream& ORD_FORMULA::output(ostream& str) 
  
ostream& ORD_FORMULA::outputWithSubst(ostream& str)
{
  Prefix::outputWordWithSubst(str,term1) << " > ";
  Prefix::outputWordWithSubst(str,term2) << '\n';
  str << "DIFF.FORMULA:   ";
  difference.outputWithSubst(str) << '\n';
  str << "COMPUTED DIFF.: "; 
  return subst_diff.output(str) << '\n';
}; // ostream& ORD_FORMULA::outputWithSubst(ostream& str)

#endif



//=================================================
#undef DEBUG_NAMESPACE  
#ifdef DEBUG_WEIGHT_FORMULA
 #define DEBUG_NAMESPACE "WEIGHT_FORMULA"
#endif
#include "debugMacros.hpp"
//=================================================

#ifndef NO_DEBUG_VIS
ostream& WEIGHT_FORMULA::output(ostream& str) 
{
  var_counter.ResetIteration();
  str << const_part;
  for (const Unifier::Variable* var = var_counter.NextRegistered();var;var = var_counter.NextRegistered())
    { 
      str << " + " << var_counter.Score(var);
      var->output(str);
    };  
  return str;
}; // ostream& WEIGHT_FORMULA::output(ostream& str)     
#endif



//=================================================
