/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002, 2003

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/
//
//  file Var.hpp
//  
//  05/09/2002, Bolzano
//


#ifndef __Var__
#  define __Var__

#include "Lst.hpp"


// variables
typedef int Var;
#define firstVar 0


class Substitution;


class VarList :
  public Lst<Var>
{
 public:
  // functions inherited from Lst
  const VarList& tail () const
    { return static_cast<const VarList&>(Lst<Var>::tail()); }
  VarList (Var head, const VarList& tail);
  VarList (const VarList& lst);
  explicit VarList (Var v); // one-element list
  VarList ();

  // miscellaneous
  void rectify (VarList, Substitution&, Var& last);
  Var max () const; // maximal variable in a non-empty list
};


class VarListList :
  public Lst<VarList>
{
 public:
  // functions inherited from Lst
  const VarListList& tail () const
    { return static_cast<const VarListList&>(Lst<VarList>::tail()); }
  VarListList (VarList head, const VarListList& tail);
  VarListList (const VarListList& lst);
  explicit VarListList (const VarList& t); // one-element list
  VarListList ();
};


// **************** class VarList, definitions ***********************

inline
VarList::VarList () 
{
}


inline
VarList::VarList (const VarList& lst) 
  :
  Lst<Var> (lst) 
{
}


inline
VarList::VarList (Var v) 
  :
  Lst<Var> (v) 
{
}


inline
VarList::VarList (Var head, const VarList& tail) 
  :
  Lst<Var> (head,tail) 
{
}


// **************** class VarListList, definitions ***********************


inline
VarListList::VarListList () 
{
}


inline
VarListList::VarListList (const VarListList& lst) 
  :
  Lst<VarList> (lst) 
{
}


inline
VarListList::VarListList (VarList head, const VarListList& tail) 
  :
  Lst<VarList> (head,tail) 
{
}


#endif // __Var__
