/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
//  File assert.cpp
//


#include "assert.h"


MyException::MyException (const char* file, int line) 
  :  
  _file (file),                       
  _line (line)                        
{ 
  //  cry (cout); 
}  // MyException::MyException

MyException::MyException (const char* msg) 
  :  
  _file (msg),
  _line (-1)                        
{
  //  cry (cout);
} // MyException::MyException                      


void MyException::cry (ostream& str)
{
  if ( _line != -1 ) {
    str << "Error in file: "
	<< _file
	<< ", line: " << _line
	<< '\n' << flush;
  }
  else {
    str << _file << '\n';
  }
} // MyException::cry


MemoryException::MemoryException (const char* file, int line) :  
  _file (file),                       
  _line (line)                        
{
} // MemoryException::MemoryException

void MemoryException::cry (ostream& str)
{
  str << "Memory could not be allocated: "
      << _file
      << ", line: " << _line
      << '\n';
}  // MemoryException::cry

