/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
//  File assert.h
//  991120 Manchester, made from debug.h in kk
//


#ifndef __assert__
#  define __assert__


#include <iostream.h>
#include <stdlib.h>


// ***************** MyException ********************


class MyException {
 public:                                
  MyException (const char* file, int line);
  MyException (const char* msg);
  virtual void cry (ostream& str);

 private:                               
  const char* _file;
  int _line;
}; // MyException


// ***************** MemoryException ********************


class MemoryException {
 public:                                
  MemoryException (const char* file, int line);
  void cry (ostream& str);

 private:                               
  const char* _file;
  int _line;
}; // MemoryException


// ***************** ASSERT and IF ********************


#define EXCEPTION(Class)                  \
  class Class :                           \
    public MyException                    \
  {                                       \
   public:                                \
    Class (const char* file, int line)    \
      : MyException (file, line) {}       \
  }

#define ASSERT(Switch,Cond)                   \
    if ( (Switch) && ! (Cond) ) {             \
      throw MyException (__FILE__,__LINE__);  \
    }                                         


#define NO_MEMORY                                 \
      throw MemoryException (__FILE__,__LINE__);  

#define IF( Switch, Statement )               \
    if ( (Switch) ) {                         \
      Statement;                              \
    }                                         \
    else {}


#endif // __assert__


