/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//  Class BitTable
//
//  Implementation of bit tables
//
//  990227 Uppsala
//


#include <ostream.h>


#include "bittable.h"


BitTable::BitTable ( int xs, int ys ) :
  _xsize (xs),
  _ysize (ys)
{
  ASSERT ( debug_bit_table, xs > 0 && ys > 0 );

  int tableSize = xs * ys / wordSize + 1;
  _table = new unsigned int [ tableSize ];

  // initialize all words by 0
  for ( int k = 0L; k < tableSize; k++)
    _table [k] = 0UL;
}  // BitTable::BitTable


BitTable::~BitTable()
{
  delete [] _table;
}


// A debug function, shows all (x,y) such that table[x,y] is true
void BitTable::showAll ( ostream& str ) const
{
  str << "True values in the table are:\n";

  for ( int x = 0; x < _xsize; ++x ) {
    
    str << x << ':';
    
    for ( int y = x - 1; y >= 0; --y ) {
      if ( get (x, y) ) 
        str << ' ' << y;
      else 
        {}
    }
    
    str << '\n';
  }

  str << "\nEnd of table\n";
}  // BitTable::showAll
