// a dynamic string

#ifndef DYNSTRING_H
#define DYNSTRING_H

#include <stdio.h>

typedef struct {
    int length;
    int allocated;
    char *c_str;
} dynstring;

void dynstring_initialise(dynstring *d, const char *initial);
void dynstring_free(dynstring *d);
void dynstring_strcat(dynstring *d, const dynstring *s);
void dynstring_strcatc(dynstring *d, const char *s);
void dynstring_sprintf(dynstring *d, const char *fmt, ...);
void dynstring_strcpy(dynstring *d, const dynstring *s);
void dynstring_strcpyc(dynstring *d, const char *s);
void dynstring_clear(dynstring *d);
char *dynstring_fgets(dynstring *d, FILE *f);
void dynstring_append_char(dynstring *d, char ch);
void dynstring_ensure_space(dynstring *d, int index);

#endif
