
#include "FINDER.h"

/*
*	Local external variables for communication
*/

static boolean clause_is_valid;
static clause this_clause;




int tisgood( clause c )
{
  this_clause = c;
  ttr_par.vlength = tset_cc();
  ttr_par.done = false;
  ttr_par.report_breaks = false;
  ttr_par.verb = 1;
  ttr_par.random = false;
  clause_is_valid = true;
  transref( &ttr_par );
  untset_cc();

  if (bug_out) return false;

  return clause_is_valid;
}



int tset_cc()
{
  wff_stack wf;
  int tsmax = 0;

  for ( wf = this_clause->varlist; wf; wf = wf->nxt )
    wf->w->wcc = tsmax++;
  for ( wf = this_clause->testlist; wf; wf = wf->nxt )
    wf->w->wcc = tsmax++;
  return tsmax;
}


void untset_cc()
{
  wff_stack wf;

  for ( wf = this_clause->varlist; wf; wf = wf->nxt )
    wf->w->wcc = -1;
  for ( wf = this_clause->testlist; wf; wf = wf->nxt )
    wf->w->wcc = -1;
}


int model_t( int info[], TRS *T )
{
  wff_stack wf;
  wff badwf = 0;
  int i;
  int args[ARGMAX];

  if ( clause_is_valid ) {
    for ( wf = this_clause->varlist; wf; wf = wf->nxt )
      wf->w->val = info[wf->w->wcc];

    for ( wf = this_clause->testlist; wf; wf = wf->nxt ) {
      for (i=0; i<wf->w->sym->adicity; i++)
	args[i] = *(wf->w->sbval[i]);
      wf->w->val = *(wf->w->matrix + getoffset(wf->w->sym,args));
      if ( wf->w->val != info[wf->w->wcc] ) {
	badwf = wf->w;
	wf->w->val = info[wf->w->wcc];
      }
    }

    if ( badwf ) {
      Ref( badwf->wcc, T );
      for (i=0; i<badwf->sym->adicity; i++)
	if ( badwf->sb[i]->wcc >= 0 )
	  Ref( badwf->sb[i]->wcc, T );
    }
    else clause_is_valid = false;
  }
  return false;		/* Sends 0-refutation if search is done */
}



int single_t( set info[], TRS *T )
{
  wff_stack wf;

  for ( wf = this_clause->prem; wf; wf = wf->nxt )
    outofset(0,info[wf->w->wcc]);
  for ( wf = this_clause->conc; wf; wf = wf->nxt ) {
    if (isinset(0,info[wf->w->wcc])) singleton(0,info[wf->w->wcc]);
    else emptyset(info[wf->w->wcc]);
  }
  for ( wf = this_clause->varlist; wf; wf = wf->nxt )
    intersect(info[wf->w->wcc],wf->w->sym->val_type->sizmask);
  for ( wf = this_clause->testlist; wf; wf = wf->nxt ) {
    intersect(info[wf->w->wcc],wf->w->sym->val_type->sizmask);
    if ( !wf->w->sym->adicity ) {
      if (isinset(*(wf->w->matrix),info[wf->w->wcc]))
	singleton(*(wf->w->matrix),info[wf->w->wcc]);
      else emptyset(info[wf->w->wcc]);
    }
  }

  return TRUE;
}


 
int tuple_t( int info[], TRS *T )
{
  wff_stack wf;
  wff w;
  int i, j, k;
  int cells[PRE_MAX], vals[PRE_MAX];
  boolean valency[PRE_MAX];
  int subvalues[ARGMAX];

  for ( wf = this_clause->testlist; wf; wf = wf->nxt ) {
    w = wf->w;
    for ( i = 0; i < w->sym->adicity; i++ )
      subvalues[i] = 0;
    do {
      k = *(w->matrix + getoffset(w->sym,subvalues));
      cells[0] = w->wcc;  vals[0] = k; valency[0] = true;
      j = 1;
      for (i=0; i<w->sym->adicity; i++)
	if (w->sb[i]->sym->category != Const) {
	  cells[j] = w->sb[i]->wcc;
	  vals[j] = subvalues[i];
	  valency[j++] = false;
	}
      cells[j] = -1;
      new_small_ref( cells, vals, valency, 0, T );
    }
    while (next_instance(w,subvalues));
  }

  return TRUE;
}



void dump_wcc()
{
  wff_stack wf;
  int i;

  for ( wf = this_clause->varlist; wf; wf = wf->nxt )
    printf("%-6d %s\n", wf->w->wcc, wf->w->sym->fname);
  for ( wf = this_clause->testlist; wf; wf = wf->nxt ) {
    printf("%-6d %s", wf->w->wcc, wf->w->sym->fname);
    for (i=0; i<wf->w->sym->adicity; i++)
      printf(" %d", wf->w->sb[i]->wcc);
    printf("\n");
  }
}


boolean next_instance(wff w, int subvalues[])
{
  int i;

  for (i=0; i<w->sym->adicity; i++)
    if (w->sb[i]->sym->category != Const) {
      if (subvalues[i] == w->sb[i]->sym->val_type->siz-1)
	subvalues[i] = 0;
      else {
	subvalues[i]++;
	return true;
      }
    }
  return false;
}
