#include "Fvntr.h"


static logical fullword;


void init_sets()
{
  int i;

  for (i=0; i<WSZ; i++)
    fullword |= ((logical)1 << i);
}



void fullset(set s)
{
  int i;

  for (i=0; i<SSZ; i++)
    s[i] = fullword;
}



void emptyset(set s)
{
  int i;

  for (i=0; i<SSZ; i++)
    s[i] = 0;
}



boolean isemptyset(set s)
{
  int i;

  for (i=0; i<SSZ; i++)
    if (s[i]) return false;
  return true;
}


void singleton(int x, set s)
{
  emptyset(s);
  intoset(x,s);
}


boolean issingle(set s)
{
  int i,j;

  for (i=0; i<SSZ; i++)
    if (s[i]) {
      for (j=i+1; j<SSZ; j++)
	if (s[j]) return false;
      if (s[i] & (s[i]-1)) return false;
      return true;
    }
  return false;
}


void assignset(set dest, set source)
{
  int i;

  for (i=0; i<SSZ; i++)
    dest[i] = source[i];
}



void intoset(int x, set s)
{
  s[x/WSZ] |= ((logical)1 << (x%WSZ));
}



void outofset(int x, set s)
{
  s[x/WSZ] &= ~((logical)1 << (x%WSZ));
}



boolean isinset(int x, set s)
{
  if (s[x/WSZ] & ((logical)1 << (x%WSZ)))
    return true;
  return false;
}



void intersect(set dest, set mask)
{
  int i;

  for (i=0; i<SSZ; i++)
    dest[i] &= mask[i];
}
