/**********************************************************************
* Filename : ClasHeuristics
*
* Kurzbeschreibung : Heuristiken zur Classifikation
*
* Autoren : Andreas Jaeger
*
* 10.03.98: Erstellung
*
*
*
**********************************************************************/
#ifndef CLASHEURISTICS
#define CLASHEURISTICS

#include "RUndEVerwaltung.h"
#include "TermOperationen.h"

/* Classifikationsroutinen haben alle folgende Aufrufsyntax:
   wtPtr: WeightEntryT
   lhs: TermT
   rhs: TermT
   actualParent: RegelOderGleichungsT
   otherParent: RegelOderGleichungsT
   actualPosition: UTermT : Position in actualParent?
Wo?-> CG/CP
   type ist ClassifyProcT
(WeightEntryT *wtPtr, TermT lhs, TermT rhs, RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent, UTermT actualPosition);
*/

WeightT CH_AddWeight (TermT lhs, TermT rhs,
		      RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent,
		      UTermT actualPosition, BOOLEAN isCP);

WeightT CH_OrdWeight (TermT lhs, TermT rhs,
		      RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent,
		      UTermT actualPosition, BOOLEAN isCP);


WeightT CH_GtWeight (TermT lhs, TermT rhs,
		     RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent,
		     UTermT actualPosition, BOOLEAN isCP);

WeightT CH_MixWeight (TermT lhs, TermT rhs,
		      RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent,
		      UTermT actualPosition, BOOLEAN isCP);

WeightT CH_MixWeight2 (TermT lhs, TermT rhs,
		       RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent,
		       UTermT actualPosition, BOOLEAN isCP);

WeightT CH_MaxWeight (TermT lhs, TermT rhs,
		      RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent,
		      UTermT actualPosition, BOOLEAN isCP);

WeightT  CH_Unifikationsmass (TermT lhs, TermT rhs,
			      RegelOderGleichungsT actualParent, RegelOderGleichungsT otherParent,
			      UTermT actualPosition, BOOLEAN isCP);

WeightT CH_Fifo (TermT lhs, TermT rhs,
                 RegelOderGleichungsT actualParent,
                 RegelOderGleichungsT otherParent,
                 UTermT actualPosition,
                 BOOLEAN isCP);

WeightT CH_Golem (TermT lhs, TermT rhs,
                  RegelOderGleichungsT actualParent,
                  RegelOderGleichungsT otherParent,
                  UTermT actualPosition,
                  BOOLEAN isCP);

WeightT CH_PolyWeight (TermT lhs, TermT rhs, RegelOderGleichungsT actualParent,
          RegelOderGleichungsT otherParent, UTermT actualPosition, BOOLEAN isCP);

#endif
