/*=================================================================================================================
  =                                                                                                               =
  =  Interreduktion.h                                                                                             =
  =                                                                                                               =
  =  Interreduktion der Regel- und Gleichungsmenge                                                                =
  =  Subsumption                                                                                                  =
  =                                                                                                               =
  =  24.06.94  Arnim.                                                                                             =
  =  14.07.94  Arnim. Subsumption, dh. Durchlauf + Abspeichern aller Subgleichungen.                              =
  =  15.07.94  Arnim. Subgleichungsmenge implementiert.                                                           =
  =================================================================================================================*/
#ifndef INTERREDUKTION_H
#define INTERREDUKTION_H

#include "RUndEVerwaltung.h"
#include "TermOperationen.h"
#include "InfoStrings.h"

/* -------------------------------------------------------------------------------*/
/* --------------- Parametereinstellung ------------------------------------------*/
/* -------------------------------------------------------------------------------*/

void IR_SetzeRechtsBehandlung(BOOLEAN nachP);

/* -------------------------------------------------------------------------------*/
/* --------------- eigentliche Interreduktion ------------------------------------*/
/* -------------------------------------------------------------------------------*/

void IR_InterreduktionLinks(RegelOderGleichungsT zuletztEingefuegtesObjekt);

void IR_InterreduktionRechts(RegelOderGleichungsT zuletztEingefuegtesObjekt);

 /* -------------------------------------------------------------------------------*/
/* --------------- Weiterbehandlung der entfernten Objekte -----------------------*/
/* -------------------------------------------------------------------------------*/

void IR_PufferAuslesen(void);
/* Auslesen des waehrend der Interreduktion gefuellten Regel- und Gleichungs-Puffers.
   Behandeln der darin befindlichen Objekte gemaess Modus.
   Meldungen: *Im entsprechenden Ausgabelevel -> 'Interreduktion Ende',
              *Beim Loeschen der entsprechenden Objekte automatisch durch die Loeschroutine,
              *Beim Einfuegen als KP von dieser Routine.
*/

/* -------------------------------------------------------------------------------*/
/* --------------- Test auf Killer-Eigenschaft -----------------------------------*/
/* -------------------------------------------------------------------------------*/

/* Die beiden folgenden Prozeduren ueberpruefen, ob das gegebene Termpaar als 
   Regel (IR_TPRReduziertRE), dh. von links nach rechts, bzw. als Gleichung
   (IR_TPGReduziertRE) gesehen, die linke Seite einer Regel oder Gleichung
   aus RE reduziert. */

BOOLEAN IR_TPRReduziertRE(TermT Links, TermT Rechts);

BOOLEAN IR_TPEReduziertRE(TermT Links, TermT Rechts);

#endif

