/* *************************************************************************
 *
 * KDHeapElements.h
 *
 * Typdefinition des ElementT fuer den KDHeap
 *
 * Bernd Loechner, 29.12.2001
 *
 * ************************************************************************* */

#ifndef KDHEAPELEMENTS_H
#define KDHEAPELEMENTS_H

#include "TermpairRepresentation.h"
#include "KPVerwaltung.h"

#include "RUndEVerwaltung.h"

typedef struct{
  WeightT              w1;
  WeightT              w2;
  RegelOderGleichungsT aP;
  RegelOderGleichungsT oP;
  TermpairT            tp;
} ElementT;

#define EL_GREATER(d,x,y)			\
((d == 0) ?					\
   ((x.w1 > y.w1) ||				\
    ((x.w1 == y.w1) && (x.w2 > y.w2))) :	\
   (x.w2 > y.w2))                               \


#define PRINT_ELEMENT(x)			\
  printf("(%ld, %ld)", x.w1, x.w2);		\


#endif
