/* -------------------------------------------------------------------------------------------------------------*/
/* -                                                                                                            */
/* - TermpairRepresentation.h                                                                                   */
/* - ************************                                                                                   */
/* -                                                                                                            */
/* - Schnittstelle fuer das Set of unselected equations.                                                        */
/* -                                                                                                            */
/* - 14.03.96 Arnim. Angelegt.                                                                                  */
/* -                                                                                                            */
/* -                                                                                                            */
/* -------------------------------------------------------------------------------------------------------------*/


#ifndef TERMPAIRREPRESENTATION_H
#define TERMPAIRREPRESENTATION_H

#include "InfoStrings.h"
#include "TermOperationen.h"
#include "RUndEVerwaltung.h"


/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Initialize-------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void TPR_ParamInfo(ParamInfoArtT what, InfoStringT DEF, InfoStringT USR);

BOOLEAN TPR_InitAposteriori (InfoStringT DEF, InfoStringT USR);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- New Flats generated ---------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void TPR_NewFlatsGenerated(void);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- FLATTERMS to TERMPAIR -------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

TermpairT TPR_Flat2TP (TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, UTermT, PCL_ObjektNummerT, BOOLEAN isCPWithFather, TermT lhsReplica);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- TERMPAIR to PARALLEL --------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void TPR_TP2ParIntermed (TermpairT, TermT *, TermT *, RegelOderGleichungsT, RegelOderGleichungsT, PCL_ObjektNummerT *);
void TPR_TP2ParFinal (TermpairT, TermT *, TermT *, RegelOderGleichungsT, RegelOderGleichungsT, PCL_ObjektNummerT *);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- PARALLEL to FLATTERMS -------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void TPR_Par2Flat (TermpairT, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT);
/* Destroys the termpair-representation irrecoverable */

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- PARALLEL to TERMPAIR --------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

TermpairT TPR_Par2TP (TermpairT, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT, BOOLEAN, PCL_ObjektNummerT);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- DESTROY ---------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void TPR_DestroyTP (TermpairT, RegelOderGleichungsT, RegelOderGleichungsT);
void TPR_DestroyPar (TermpairT, TermT, TermT, RegelOderGleichungsT, RegelOderGleichungsT);

/* -------------------------------------------------------------------------------------------------------------*/
/* ------- Output ----------------------------------------------------------------------------------------------*/
/* -------------------------------------------------------------------------------------------------------------*/

void TPR_PrintTermpair (TermpairT, RegelOderGleichungsT, RegelOderGleichungsT, const char *);

#endif /* TERMPAIRREPRESENTATION_H */
