/***********************************************************************************************************************
 * Schnittstelle fuer die Prozeduren zur Zeitmessung
 ***********************************************************************************************************************
 * Autor:     Juergen Sellentin. Implementiert am 13.02.94
 * Angepasst: Arnim am 04.03.94.  Makros und Funtionen eingesetzt.
 *            Arnim am 04.04.94.  Stack zur Verwaltung von geschachtelten Aufrufen eingebaut.
 *            Arnim bis 24.05.95. Komplett neues Konzept, gettimeofday und Zaehler eingebaut.  
 ***********************************************************************************************************************/


#ifndef ZEITMESSUNG_H
#define ZEITMESSUNG_H

#include "general.h"
#include "InfoStrings.h"
#include "Parameter.h"
#include <sys/time.h>

void ZM_StartGesamtZeit(void);
void ZM_StoppGesamtZeit(void);

typedef struct {
  unsigned long int Sekunden,
                    Zehntelsekunden;
} DauerT;

DauerT ZM_Laufzeit(void); /* Summe aus System- und User-Zeit */

#endif
