/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
// File int.h
//
// Implements several functions on integers
//
//  990806 Uppsala
//  990928 Uppsala, min added
//  19/02/2000 Manchester, slightly reimplemented
//  09/06/2000 Manchester, toString added and int.cpp created
//


#ifndef __int__
#define __int__


#include <limits.h>
#include "list.h"


enum Compare 
{
  LESS = -1,
  EQUAL = 0,
  GREATER = 1
};


class Int 
{
 public:

  static int max ( int i1, int i2 );
  static int min ( int i1, int i2 );
  static Compare compare ( int i1, int i2 );
  static const int max ();
  static const int min ();
  static void toString ( int i, char* str );

  typedef List<int,CID_INTLIST> List;
};


inline 
int Int::max ( int i1, int i2 ) 
{
  return  i1 > i2 ? i1 : i2 ;
}


inline 
int Int::min ( int i1, int i2 ) 
{
  return  i1 < i2 ? i1 : i2 ;
}


inline 
Compare Int::compare ( int i1, int i2 ) 
{
  if ( i1 > i2 )
    return GREATER;

  if ( i1 == i2 )
    return EQUAL;

  return LESS;
} // Int::compare


inline
const int Int::max ()
{
  return INT_MAX;
}


inline
const int Int::min ()
{
  return INT_MIN;
}


#endif  // __int__

