/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
//  File int_name_table.h
//
//  Defines the class IntNameTable for a table of names, 
//    where insert returns an integer rather than char*
//
//  made from NameTable, 13/05/2000, flight Manchester-Atlanta
//


#ifndef __int_name_table__
#define __int_name_table__


#include <ostream.h>


#include "list.h"
#include "pair.h"


typedef Pair <int,char*,CID_ENTRY> Entry;
typedef List <Entry*,CID_ENTRY_LIST> EntryList;


// ****************** class IntNameTable **********************

class IntNameTable 
{
 public:
  
  IntNameTable ();
  ~IntNameTable ();
  int insert ( const char* str );
  inline const char* & operator[] ( int num ) const;
  int numberOfSymbols ();

  friend ostream& operator << (ostream &stream,IntNameTable& table);
  static IntNameTable* vars;

 private:

  static const int _noOfBuckets;
  EntryList ** _buckets;
  int _nextNumber;

  // hashing
  static int hash ( const char* );  // hashing function
}; // class NameTable


ostream& operator << (ostream &stream,IntNameTable& table);



#endif


