#include "../ladr/header.h"

#include "../ladr/ioutil.h"
#include "../ladr/fastparse.h"

#define PROGRAM_NAME    "unfast"
#define PROGRAM_VERSION "2003-C"
#define PROGRAM_DATE    "Nov 2003"

static char Help_string[] =
"\nThis program takes a stream of fastparse terms and writes them\n"
"as ordinary terms.  The following symbols/arities are recognized.\n"
"=/2, m/2, j/2, c/1, f/2.  Variables are r--z.  Other symbols\n"
"are constants.  Input should be one term per line, terminated\n"
"with a period, without spaces.  Lines starting with % are echoed.\n\n";

static BOOL member_args(int argc, char **argv, char *str)
{
  int i;
  for (i = 1; i < argc; i++)
    if (str_ident(argv[i], str))
      return TRUE;
  return FALSE;
}  /* member_args */

/*************
 *
 *   main()
 *
 *************/

int main(int argc, char **argv)
{
  Clause c;

  if (member_args(argc, argv, "help") ||
      member_args(argc, argv, "-help")) {
    printf("\n%s, version %s, %s\n",PROGRAM_NAME,PROGRAM_VERSION,PROGRAM_DATE);
    printf("%s", Help_string);
    exit(1);
  }

  declare_standard_parse_types();

  fast_set_defaults();

  c = fast_read_clause(stdin, stderr);
  while (c != NULL) {
    fwrite_clause(stdout, c, FALSE, FALSE);
    fflush(stdout);
    zap_clause(c);
    c = fast_read_clause(stdin, stderr);
  }
  exit(0);
}  /* main */
