#ifndef TP_MEMORY_H
#define TP_MEMORY_H

#include "fatal.h"

/* INTRODUCTION
If you need a small chunks of memory to build data structures, this is
where to come.  We my_malloc() big blocks of memory, then break it up and
give it out as needed.
<P>
Unlike malloc(), the memory obtained by tp_alloc() cannot be
freed at this level of abstraction or to the operating system.
Instead, it is assumed that the caller is some
kind of get_node() routine, which, along with the corresponding
free_node() routine, manages a list of available nodes.
*/

/* Public definitions */

#define DEFAULT_MAX_MEGS     96  /* Change with set_max_megs(). */
#define DEFAULT_MALLOC_MEGS   1  /* Change with set_malloc_megs(). */

/* End of public definitions */

/* Public function prototypes from memory.c */

void *tp_alloc(size_t n);

void *tp_calloc(size_t n);

int megs_malloced(void);

void set_max_megs(int megs);

void set_malloc_megs(int megs);

#endif  /* conditional compilation of whole file */
