#ifndef TP_FPA2_H
#define TP_FPA2_H

#ifndef FSOLO
     /* ordinary mode */
#    define FTYPE struct term *
#    define FDEFAULT NULL
#    define FLT(x,y) ((x)->fpa_id <  (y)->fpa_id)
#    define FGT(x,y) ((x)->fpa_id >  (y)->fpa_id)
#    define FLE(x,y) ((x)->fpa_id <= (y)->fpa_id)
#    define FGE(x,y) ((x)->fpa_id >= (y)->fpa_id)
#    define FEQ(x,y) ((x) == (y))
#    define FNE(x,y) ((x) != (y))
#    define FTERM(p) ((p).f == NULL ? NULL : (p).f->d[(p).i])
#    define FMAX 400  /* maximum number of items per chunk */
#else  /* FSOLO */
     /* stand-alone for testing */
#    define FTYPE int
#    define FDEFAULT 0
#    define FLT(x,y) ((x) <  (y))
#    define FGT(x,y) ((x) >  (y))
#    define FLE(x,y) ((x) <= (y))
#    define FGE(x,y) ((x) >= (y))
#    define FEQ(x,y) ((x) == (y))
#    define FNE(x,y) ((x) != (y))
     typedef enum { FALSE=0, TRUE=1 } BOOLEAN;
#    define FMAX 100  /* maximum number of items per chunk */
#endif  /* FSOLO */

struct fnode {    /* a chunk of an FPA list */
  FTYPE d[FMAX];
  int n;
  struct fnode *next;
};

typedef struct fnode *Fnode;

/* to maintain a position (needed for FPA indexing) */

struct fposition {
  Fnode f;
  int i;
};

/* function prototypes */

#ifndef FSOLO
    Fnode flist_insert(Fnode f, FTYPE x);
    Fnode flist_delete(Fnode f, FTYPE x);
    struct fposition first_fpos(Fnode f);
    struct fposition next_fpos(struct fposition p);
    void fprint_flist_mem(FILE *fp, BOOLEAN heading);
    void p_flist_mem();
#else
    /* stand-alone debug mode */
    void *tp_alloc(size_t size);
    void random_permutation(int *a, int size);
#endif

#endif  /* conditional compilation of whole file */
