#ifndef TP_HASH_H
#define TP_HASH_H

#include "memory.h"

typedef struct hashtab * Hashtab;
typedef struct hashnode * Hashnode;

/* INTRODUCTION
This is a general-purpose hash package.  There is nothing fancy about it.
<P>
One can insert and delete pairs (integer ID, void *pointer), and retrieve the
pointer associated with a given ID.
*/

/* Public definitions */

/* End of public definitions */

/* Public function prototypes from hash.c */

void fprint_hash_mem(FILE *fp, BOOL heading);

void p_hash_mem();

Hashtab hash_init(int size);

void hash_insert(int id, void *v, Hashtab h);

void * hash_lookup(int id, Hashtab h);

void hash_delete(int id, Hashtab h);

void hash_destroy(Hashtab h);

#endif  /* conditional compilation of whole file */
