#ifndef TP_INTERP_H
#define TP_INTERP_H

#include "parse.h"
#include "clause.h"
#include "formula.h"

/* INTRODUCTION
*/

/* Public definitions */

typedef struct interp *Interp;

/* End of public definitions */

/* Public function prototypes from interp.c */

void fprint_interp_mem(FILE *fp, BOOL heading);

void p_interp_mem();

Interp compile_interp(Term t);

void transpose_binary(Term t);

void zap_interp(Interp p);

void fprint_interp_tex(FILE *fp, Interp p);

void fprint_interp(FILE *fp, Interp p);

void fprint_interp_2(FILE *fp, Interp p);

void p_interp(Interp p);

void fprint_interp_tabular(FILE *fp, Interp p);

BOOL eval_clause(Clause c, Interp p);

int eval_clause_false_instances(Clause c, Interp p);

BOOL eval_formula(Formula f, Interp p);

Interp copy_interp(Interp p);

Interp permute_interp(Interp source, int *p);

BOOL ident_interp_perm(Interp a, Interp b, int *p);

Interp canon_interp(Interp a);

BOOL isomorphic_interps(Interp a, Interp b, BOOL canon);

int interp_size(Interp a);

int *interp_table(Interp p, char *sym, int arity);

long unsigned iso_checks(void);

long unsigned iso_perms(void);

#endif  /* conditional compilation of whole file */
