#ifndef TP_JUST_H
#define TP_JUST_H

#include "header.h"
#include "clauseid.h"

/* INTRODUCTION
*/

/* Public definitions */

typedef struct just * Just;

typedef enum {
  INPUT,             /*          Primary */
  BACK_DEMOD_JUST,   /* int      Primary  */
  FLIP_JUST,         /* int      Secondary */
  XX_JUST,           /* int      Secondary */
  MERGE_JUST,        /* int      Secondary */
 
  BINARY_RES_JUST,   /* Ilist    Primary */
  HYPER_RES_JUST,    /* Ilist    Primary */
  UR_RES_JUST,       /* Ilist    Primary */
  CD_JUST,           /* Ilist    Primary */
  FACTOR_JUST,       /* Ilist    Primary */
  DEMOD_JUST,        /* Ilist    Secondary */
  UNIT_DEL_JUST,     /* Ilist    Secondary */

  PARA_JUST,         /* Parajust Primary */
  PARA_FX_JUST,      /* Parajust Primary */
  PARA_IX_JUST,      /* Parajust Primary */
  PARA_FX_IX_JUST    /* Parajust Primary */

} Just_type;

/* End of public definitions */

/* Public function prototypes from just.c */

void fprint_just_mem(FILE *fp, int heading);

void p_just_mem();

void fprint_just(FILE *fp, Just just);

void zap_just(Just just);

Plist get_clause_ancestors(Clause c);

int proof_length(Plist proof);

Just cd_just(Clause major, Clause minor);

Just unit_del_just(Clause deleter, int literal_num);

Just back_demod_just(Clause c);

Just flip_just(int n);

Just xx_just(int n);

Just merge_just(int n);

Just binary_res_just(Clause c1, int n1, Clause c2, int n2);

Just para_just(Just_type rule,
		Clause from, Ilist from_vec,
		Clause into, Ilist into_vec);

Just demod_just(Ilist g);

Just resolve_just(Ilist g, Just_type type);

Just factor_just(Clause c, int lit1, int lit2);

Just append_just(Just j1, Just j2);

#endif  /* conditional compilation of whole file */
