#ifndef TP_OPTIONS_H
#define TP_OPTIONS_H

#include "fatal.h"
#include "string.h"

/* INTRODUCTION
There are two kinds of options: Flags and Parms.  Flags are
Boolean valued, and Parms are integer valued.
<P>
To introduce a new flag or parm, 
*/

/* Public definitions */

#define MAX_FLAGS                100
#define MAX_PARMS                100

/* End of public definitions */

/* Public function prototypes from options.c */

void init_options(void);

int next_available_flag_id(void);

int next_available_parm_id(void);

void init_flag(int flag_id,
	       char *flag_name,
	       BOOL default_value);

void init_parm(int parm_id,
	       char *parm_name,
	       int default_value,
	       int min_value,
	       int max_value);

void fprint_options(FILE *fp);

void p_options(void);

int flag(int flag_id);

int parm(int parm_id);

void set_flag(int id);

void clear_flag(int id);

void assign_parm(int id, int val);

int str_to_flag_id(char *flag_name);

int str_to_parm_id(char *parm_name);

char *flag_id_to_str(int id);

char *parm_id_to_str(int id);

#endif  /* conditional compilation of whole file */
