#ifndef TP_ORDER_H
#define TP_ORDER_H

#include "header.h"

/* INTRODUCTION
This package is mostly about ordering terms.  It also has
a generic sorting routine merge_sort() that can be used
to sort any kind of data.
*/

/* Public definitions */

/* basic order relations */

typedef enum { NOT_COMPARABLE,
	       SAME_AS,
	       LESS_THAN,
	       GREATER_THAN,
	       NOT_LESS_THAN,
	       NOT_GREATER_THAN
             } Ordertype;

/* End of public definitions */

/* Public function prototypes from order.c */

void merge_sort_recurse(void *a[],    /* array to sort */
			void *w[],    /* work array */
			int start,    /* index of first element */
			int end,      /* index of last element */
			Ordertype (*comp_proc) (void *, void *));

void merge_sort(void *a[],   /* array to sort */
		int n,       /* size of array */
		Ordertype (*comp_proc) (void *, void *));

#endif  /* conditional compilation of whole file */
