#ifndef TP_PARSE_H
#define TP_PARSE_H

#include "listterm.h"

/* INTRODUCTION
This package has routines for reading and writing terms in
human-readable form.  Binary function symbols can be declared
to be infix with a precedence and left or right association,
so that many parentheses can be omitted.  Unary symbols
can be declared to be prefix or postfix.
In addition, prolog-style list-notation and quantified formulas are
supported.
<P>
The symbol declarations and parse rules are similar to the method
used by many Prolog systems (although we use mnemonic names 
instead of xfy, yfx, yf, etc.).  The symbol declarations
are made with set_parse_type().
<P>
This package is based on code taked form Otter and EQP, but there
are some important differences.  Detailed documentation should
be available elsewhere.
<P>
The intension is to use this package for reading
and writing all types of data (terms, clauses, formulas, control
information, etc.), with outside routines to translate to/from
the appropriate internal data structure when necessary.
*/

/* Public definitions */

/* End of public definitions */

/* Public function prototypes from parse.c */

void fprint_parse_mem(FILE *fp, BOOL heading);

void p_parse_mem();

void translate_neg_equalities(BOOL flag);

Term sread_term(String_buf sb, FILE *fout);

Term read_term(FILE *fin, FILE *fout);

void fwrite_term(FILE *fp, Term t);

void fwrite_term_nl(FILE *fp, Term t);

void declare_standard_parse_types(void);

#endif  /* conditional compilation of whole file */
