#ifndef TP_RANDOM_H
#define TP_RANDOM_H

#include "listterm.h"
#include "clause.h"

/* INTRODUCTION
These are some routines I used for testing and debugging some
of the low-level code.  The main reason I wrote these is so that
I could write and test the early code without having to input terms.
Maybe I'll see how far I can go before I have to write a term parser.
<P>
And, who knows, maybe the next big breakthrough in automated theorem
proving will depend on randonly generated terms!
*/

/* Public definitions */

/* End of public definitions */

/* Public function prototypes from random.c */

Term random_term(int v, int a0, int a1, int a2, int a3,
		 int max_depth);

Term random_nonvariable_term(int v, int a0, int a1, int a2, int a3,
			     int max_depth);

Term random_complex_term(int v, int a0, int a1, int a2, int a3,
			     int max_depth);

Ilist random_path(int length_max, int value_max);

void random_permutation(int *a, int size);

Clause random_clause(int v, int a0, int a1, int a2, int a3,
		     int max_depth, int max_lits);

Term random_op_term(int depth);

#endif  /* conditional compilation of whole file */
