#ifndef TP_MSTATE_H
#define TP_MSTATE_H

/* Public definitions */

typedef struct jnode * Jnode;
typedef struct mstate * Mstate;

struct mstate {
  Estack stack;
  Jnode first_job;
  Jnode last_job;
  BOOL ok;
  Mstate next;  /* for avail list only */
};

struct jnode {
  int type;
  int id;
  Term alpha;
  Term beta;
  int pos;
  Jnode prev;
  Jnode next;
};

/* End of public definitions */

/* Public function prototypes from mstate.c */

Mstate get_mstate(void);

void free_mstate(Mstate p);

Jnode get_jnode(void);

void free_jnode(Jnode p);

void fprint_mstate_mem(FILE *fp, BOOL heading);

void p_mstate_mem(void);

void job_append(Mstate s, int type, int id, Term atom, Term beta, int pos);

void job_prepend(Mstate s, int type, int id, Term atom, Term beta, int pos);

void job_pop(Mstate s);

void zap_jobs(Mstate s);

#endif  /* conditional compilation of whole file */
