/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

// *************************************************************
//
//  Class Pair<C,D> for implementing pairs
//
//  14/04/2000 Breckenridge
//  02/06/2000 Manchester, == added
//
// *************************************************************

#ifndef __pair__
#  define __pair__


#include "assert.h"
#include "memory.h"


// *******************Class Pair*******************************


template <class C, class D, ClassID cid>
class Pair
#   if debug_memory
    : public Memory <cid>
#   endif
{
 public:

  // constructors
  inline
  Pair ( C left, D right )
    :
    _left ( left ),
    _right ( right ) {}

  inline
  Pair () {}

  // structure quering
  inline C left () const { return _left; }
  inline D right () const { return _right; }

  // change left/right elements
  inline void left ( C lft ) { _left = lft; }
  inline void right ( D rht ) { _right = rht; }

  // equality
  inline 
  bool operator == ( Pair& rhs ) const 
    { return left() == rhs.left() &&
             right() == rhs.right(); }

 protected:  // structure
  C _left;
  D _right;
};  // class Pair


// ******************* Class Pair, definitions ****************************


#endif


