/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
//  file prepro.h
//  defines preprocessor
//
//  09/06/2000 Manchester
//  31/03/2001 Manchester, changed by introducing functions corresponding 
//              to series of experiments, eg casc17
//  08/04/2001 Manchester, general () now has an argument (ostream)
//  09/05/2001 Manchester, several functions zipped out
//  10/05/2001 Manchester, simplifyA
//  15/05/2001 Manchester, simplifyB
//  22/05/2001 Manchester, simplifyC
//  23/05/2001 Manchester, simplifyBasic/1
//  29/05/2001 Manchester, simplifyD
//  30/05/2001 Manchester, simplifyBasic/0, simplifyE/0
//  31/05/2001 Manchester, normalize/0, simplifyF
//


#ifndef __prepro__
#define __prepro__


class ostream;
class Problem;
class Options;


class Prepro {
 public:
  // Prepro ( Problem&, int timeLimit, int memory );
  Prepro ( Problem& );
/*
  char* classify ();  // returns classification of the problem (eq UEQ)
*/
  int simplifyBasic ();  // simplifications that should always be done
/*
  int simplifyA (ostream& tab);  // Basic + dummy function definitions
  int simplifyB (ostream& tab);  // A + removal of cancellation axioms
  int simplifyC (ostream& tab);  // removal of linear function definitions
  int simplifyD (ostream& tab);  // elimination of resolvable
  int simplifyE (ostream& tab);  // removal of all function definitions
  int simplifyF (ostream& tab);  // negative equality split
  void normalize ();  // normalize the problem
  Problem& problem () { return _problem; }

 private:
  void writeVampireCall ( const char* vampire, const char* problemFile, Options&, 
                          int timeLimit, int memLimit, ostream& );
*/
  Problem& _problem;
/*
  int _timeLimit;
  int _memoryLimit;
//  ostream& _out;
//  ostream& _tab;
//  ostream& _script;
*/
};

ostream& operator << ( ostream&, Prepro& );

#endif
