/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
//  file renaming.cpp
//  implements Renaming
//  currently not a very fast implementation
//

#include "renaming.h"

// 27/06/2002 Manchester
Renaming::Renaming ()
  : _bindings (List::empty())
{
} // Renaming::Renaming


// 27/06/2002 Manchester
Renaming::~Renaming ()
{
  List::Iterator bs (_bindings);
  while (bs.more()) {
    delete bs.next ();
  }
  _bindings->destroy ();
} // Renaming::~Renaming


// 27/06/2002 Manchester
void Renaming::push ( Var v, Var t)
{
  List::push ( new Binding(v,t), _bindings );
} // Renaming::push


// 27/06/2002 Manchester
Var Renaming::get (Var v) const
{
  List::Iterator bs (_bindings);
  while (bs.more()) {
    Binding* b = bs.next ();
    if (b->left() == v) {
      return b->right();
    }
  }
  // not found
  return -1;
} // Renaming::get


// 27/06/2002 Manchester
void Renaming::pop ()
{
  ASSERT( debug_renaming, ! _bindings->isEmpty() );

  delete List::pop (_bindings);
} // Renaming::pop


