/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
//  file renaming.h 
//  defines class Renaming
//  currently not a very fast implementation
//

#ifndef __renaming__
#define __renaming__


#include "typedefs.h"
#include "memory.h"
#include "tracer.h"
#include "term.h"
#include "pair.h"


class Renaming
{
 public:
  Renaming ();
  ~Renaming ();
  void push ( Var v1, Var v2);
  Var get (Var v1) const; // -1 if not found
  void pop ();

 private:
  typedef Pair<Var, Var, CID_REN_BINDING> Binding;
  typedef List<Binding*, CID_REN_BINDING_LIST> List;

  List* _bindings;
}; // class Renaming


#endif // __renaming__
