(* $Id: admissible.mli,v 1.4 2004/06/13 18:22:21 alexf Exp $ *)

(*
This file is part of the first order theorem prover Darwin
Copyright (C) 2004  The University of Iowa
                    Universitaet Koblenz-Landau 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)


(** makes a context unifier admissible *)

(** {6 Types} *)

type subst = Subst.subst
type raw_context_unifier = Context_unifier.raw_context_unifier

(** {6 Functions} *)

(** [make_admissible raw_context_unifier subst remainder_flags]
  makes the context unifier [subst] of [raw_context_unifier] admissible.
  The remainder states of the literals are precomputed in [remainder_flags]
  (see {!Context_unifier.compute_remainder_states}).

  As many remainder literals as possible are made parameter-free
  while not introducing new remainder literals *)
val make_admissible: raw_context_unifier -> subst -> bool array -> subst
