(* $Id: selection_types.mli,v 1.7 2004/06/13 18:22:22 alexf Exp $ *)

(*
This file is part of the first order theorem prover Darwin
Copyright (C) 2004  The University of Iowa
                    Universitaet Koblenz-Landau 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)


type literal = Term.literal
type state = State.state
type explanation = State.explanation
type raw_context_unifier = Context_unifier.raw_context_unifier

type selected_assert = {
  sa_literal: literal;
  sa_mandatory_at: state option;
  sa_explanation: explanation;
  sa_generation: int;

  sa_raw_context_unifier: raw_context_unifier option;
  (* None for a unit clause *)
}

type selected_split = {
  ss_literal: literal;
  ss_explanation: explanation;

  ss_valid: state ref;
  (* the split is valid as long as the state is valid.
     I.e. after the left split is closed and a right split is done
     the invalidated left split state has to be replaced
     by the valid right split state *)

  ss_generation: int;
  ss_raw_context_unifier: raw_context_unifier;
}
