(* $Id: statistic.mli,v 1.5 2004/06/13 18:22:22 alexf Exp $ *)

(*
This file is part of the first order theorem prover Darwin
Copyright (C) 2004  The University of Iowa
                    Universitaet Koblenz-Landau 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)


(** derivation statistic *)

(** {2 Counters } *)

val inc_close: unit -> unit
val get_close: unit -> int
(** applications of [Close] *)

val inc_assert: unit -> unit
val get_assert: unit -> int
(** applications of [Assert] *)

val inc_split: unit -> unit
val get_split: unit -> int
(** applications of [Split] *)

val inc_resolve: unit -> unit
val get_resolve: unit -> int
(** applications of [Resolve] *)

val inc_subsume: unit -> unit
val get_subsume: unit -> int
(** applications of [Subsume] *)

val inc_compact: unit -> unit
val get_compact: unit -> int
(** applications of [Compact] *)

val inc_filtered_by_productivity: unit -> unit
val get_filtered_by_productivity: unit -> int
(** ignored unproductive remainders *)

val inc_computed_assert_candidates: unit -> unit
val get_computed_assert_candidates: unit -> int
(** computed assert candidates,
  i.e. "assert context unifiers" not exceeding the depth bound *)

val inc_computed_split_candidates: unit -> unit
val get_computed_split_candidates: unit -> int
(** computed split candidates (remainders),
  i.e. context unifiers not exceeding the depth bound *)

val set_max_context_size: int -> unit
val get_max_context_size: unit -> int
(** the maximum number of literals in the context at one point of time *)

val inc_debug: unit -> unit
val get_debug: unit -> int
(** for debuging purposes *)




(** {2 Representation} *)

val to_string: unit -> string




(** {2 Restart} *)

val restart: unit -> unit
