/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
//  File string.cpp - implements strings that are deallocated automatically after use
//  08/04/2001, Manchester, operator << 
//


#include <string.h>
#include <iostream.h>


#include "string.h"


String::String ()
  :
  _str ( new char [1] )
{
  *_str = 0;
} // String::String


String::String ( const char* string )
  :
  _str ( new char [ strlen(string) + 1 ] )
{
  strcpy ( _str, string );
} // String::String


// 04/06/2001
// makes a string obtained by concatenating prefix with postfix
String::String ( const String* prefix, const char* postfix )
{
  int prefixLength = prefix->length ();
  _str = new char [ prefixLength + strlen(postfix) + 1 ];
  strcpy ( _str, prefix->string() );
  strcpy ( _str + prefixLength, postfix );
}


String::~String ()
{
  delete [] _str;
} // String::~String


void String::operator += ( const char* string )
{
  int length = strlen ( _str );

  char* result = new char [ length + strlen(string) + 1];
  strcpy ( result, _str );
  strcpy ( result + length, string );

  delete [] _str;

  _str = result;
} // String::operator +=


ostream& operator << ( ostream& str , const String* string )
{
  str << string->_str;

  return str;
} // operator << ( ostream& str, const String& string )


ostream& operator << ( ostream& str, const String& string )
{
  str << string._str;

  return str;
} // operator << ( ostream& str, const String& string )


int String::length () const
{
  return strlen(_str);
} // String::string


