/*
COPYRIGHT UNIVERSITY OF MANCHESTER, 2002

Contributors:
  Alexandre Riazanov
  Andrei Voronkov

LICENCE TERMS

Please note the following:

(1) this code was intended for CASC only, can only be used for
CASC-related experiments and cannot be used otherwise;

(2) Vampire is free for non-commercial use and a standard non-commercial
licence can be found on the Vampire Web page that is currently:

  http://www.cs.man.ac.uk/~riazanoa/Vampire/index.html

BY USING THIS CODE YOU AGREE TO THE TERMS IN THIS LICENCE.
 
(3) To get a licence for commercial use, please consult the Vampire Web
page.

(4) Disclaimer.

THIS MATERIAL IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. THE ENTIRE RISK AS TO THE QUALITY AND
PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE PROGRAM PROVE
DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR
CORRECTION.

*/

//
//  File string.h - implements strings that are deallocated automatically after use
//
//  22/06/2000, Manchester
//  08/04/2001, Manchester, operator << 
//  09/04/2001, Manchester, operators +=, length(), string()
//


#ifndef __string__
#define __string__


class ostream;


// *************** class String, definition ***********************


class String {
 public:
  
  String ();
  ~String ();
  explicit String ( const char* str );
  String ( const String* prefix, const char* postfix );
  void operator += ( const char* str ); // appends str to the end
  void operator += ( const String* str ); // appends str to the end
  void operator += ( int ); // converts integer to string and appends it to the end
  int length () const;
  const char* string () const;

 private:

  char* _str;

 friend ostream& operator << ( ostream&, const String* str );
 friend ostream& operator << ( ostream&, const String& str );
}; // class String


ostream& operator << ( ostream&, const String* str );
ostream& operator << ( ostream&, const String& str );


// *************** class String, implementation *******************


inline
const char* String::string () const
{
  return _str;
} // String::string


#endif
