//
// File:         Receiver.hpp
// Description:  An abstraction for objects that 
//               can receive data of a certain type.
// Created:      Dec 30, 2003, Alexandre Riazanov
// mail:         riazanov@cs.man.ac.uk
//==========================================================================
#ifndef RECEIVER_H
#define RECEIVER_H
//==========================================================================
#include "jargon.hpp"
#include "BlodKorvDebugFlags.hpp"
//==========================================================================
#undef DEBUG_NAMESPACE
#ifdef DEBUG_RECEIVER
#  define DEBUG_NAMESPACE "Receiver<class C>"
#endif
#include "debugMacros.hpp"
//==========================================================================

namespace BK 
{

template <class C>
class Receiver 
{
public:
  virtual ~Receiver() {};
  virtual void receive(const C&) = 0;
}; // class Receiver<class C>

}; // namespace BK

//==========================================================================
#endif
