
/*
 * File EqualityProxy.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __EqualityProxy__
#define __EqualityProxy__

class Problem;
class Signature;
class PredicateSymbol;
class LiteralList;
class Literal;



class EqualityProxy {
public:
  EqualityProxy (Signature& signature);
  void apply (Problem& problem);
private:
  void apply (LiteralList& literals);
  void apply (Literal& literal);

  
  PredicateSymbol* _proxy;
  
  PredicateSymbol& _equality;
}; 

#endif
