
/*
 * File FormulaVarIterator.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __FormulaVarIterator__
#define __FormulaVarIterator__

class Term;
class Formula;
class FormulaList;

#include "Var.hpp"
#include "VarCounter.hpp"


class FormulaVarIterator
{
public:
  FormulaVarIterator (const Formula&);
  FormulaVarIterator (const FormulaList&);
  ~FormulaVarIterator ();

  bool hasNext ();
  Var next ();
private:
  class Element;
  Term* _current;
  Element* _reserve;
  
  VarCounter _bound;
  void popReserve ();
}; 


#endif 


