
/*
 * File Int.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __INT__
#define __INT__


#include <climits>
#include <string>

using namespace std;

#ifdef _MSC_VER 
#  undef max
#  undef min
#endif



class Int 
{
 public:

  static int max ( int i1, int i2 );
  static int min ( int i1, int i2 );
  static const int greatestNumber ();
  static const int leastNumber ();
  static string toString (int i);
  static string toString (long l);
  static string toString (unsigned long l);
  static string toString (float f);
  static string toString (double d);
  static int compare (int i1, int i2);
  static int compare (float i1, float i2);
  static int compare (double i1, double i2);
};



inline 
int Int::max ( int i1, int i2 ) 
{
  return  i1 > i2 ? i1 : i2 ;
}



inline 
int Int::min ( int i1, int i2 ) 
{
  return  i1 < i2 ? i1 : i2 ;
}


inline
const int Int::greatestNumber ()
{
  return INT_MAX;
}



inline
const int Int::leastNumber ()
{
  return INT_MIN;
}


inline
int Int::compare (int i1, int i2)
{
  return i1 < i2 ? -1 :
         i1 == i2 ? 0 :
         1;
}


inline
int Int::compare (double i1, double i2)
{
  return i1 < i2 ? -1 :
         i1 == i2 ? 0 :
         1;
}

#endif  

