
/*
 * File IntNameTable.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __IntNameTable__
#define __IntNameTable__

#include <iostream>
#include <string>

#include "List.hpp"
#include "Pair.hpp"


typedef Pair <int,string> Entry;
typedef List <Entry*> EntryList;




class IntNameTable 
{
 public:
  
  IntNameTable ();
  ~IntNameTable ();
  int insert (const string& str);
  string operator[] ( int num ) const;
  int numberOfSymbols ();

  
  static IntNameTable vars;

 private:

  static const int _noOfBuckets;
  EntryList ** _buckets;
  int _nextNumber;

  
  static int hash (string);  
}; 



#endif
