/* $ANTLR 2.7.3 (20040506-1): "KIF.g" -> "KIFParser.cpp"$ */
#line 36 "KIF.g"

    // gets inserted before the antlr generated includes in the cpp file

#line 7 "KIFParser.cpp"
#include "KIFParser.hpp"
#include <antlr/NoViableAltException.hpp>
#include <antlr/SemanticException.hpp>
#include <antlr/ASTFactory.hpp>
#line 40 "KIF.g"

    // gets inserted after the antlr generated includes in the cpp file

#line 16 "KIFParser.cpp"
#line 175 "KIF.g"

// head of parser file
#include "Tracer.hpp"
#include "IntNameTable.hpp"
#include "Signature.hpp"
#include "Problem.hpp"
#include "VampireException.hpp"
#include "Formula.hpp"

#line 27 "KIFParser.cpp"
KIFParser::KIFParser(antlr::TokenBuffer& tokenBuf, int k)
: antlr::LLkParser(tokenBuf,k)
{
}

KIFParser::KIFParser(antlr::TokenBuffer& tokenBuf)
: antlr::LLkParser(tokenBuf,2)
{
}

KIFParser::KIFParser(antlr::TokenStream& lexer, int k)
: antlr::LLkParser(lexer,k)
{
}

KIFParser::KIFParser(antlr::TokenStream& lexer)
: antlr::LLkParser(lexer,2)
{
}

KIFParser::KIFParser(const antlr::ParserSharedInputState& state)
: antlr::LLkParser(state,2)
{
}

void KIFParser::start(
	FormulaList& formulas
) {
#line 199 "KIF.g"
	
		  TRACER ("KIFParser::start");
		  Formula f;
		  FormulaList fs;
		
#line 62 "KIFParser.cpp"
	
	sentence(f);
	{
	switch ( LA(1)) {
	case WORD:
	case LPAR:
	{
		start(fs);
		break;
	}
	case antlr::Token::EOF_TYPE:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 211 "KIF.g"
	
		  formulas = FormulaList (f, fs);
		
#line 87 "KIFParser.cpp"
}

void KIFParser::sentence(
	Formula& f
) {
	antlr::RefToken  c = antlr::nullToken;
#line 401 "KIF.g"
	
		  TRACER ("KIFParser::sentence");
		  Atom a;
		
#line 99 "KIFParser.cpp"
	
	if ((LA(1) == WORD)) {
		c = LT(1);
		match(WORD);
#line 408 "KIF.g"
		
		f = Formula (Atom ( Signature::sig.createPred (c->getText(), 0)));
			
#line 108 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && (LA(2) == LITERAL_equal)) {
		equation(a);
#line 413 "KIF.g"
		
		f = Formula (a);
			
#line 116 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && ((LA(2) >= LESS && LA(2) <= GEQ))) {
		inequality(a);
#line 418 "KIF.g"
		
		f = Formula (a);
			
#line 124 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && (LA(2) == WORD)) {
		relsent(a);
#line 423 "KIF.g"
		
		f = Formula (a);
			
#line 132 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && (LA(2) == LITERAL_not)) {
		match(LPAR);
		kw_not();
		sentence(f);
		match(RPAR);
#line 431 "KIF.g"
		
			  f = Formula (NOT, f);
			
#line 143 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && (LA(2) == LITERAL_and || LA(2) == LITERAL_or)) {
#line 435 "KIF.g"
		
			  FormulaList fs;
			  Connective c;
			
#line 151 "KIFParser.cpp"
		match(LPAR);
		c=junction();
		sentence_plus(fs);
		match(RPAR);
#line 443 "KIF.g"
		
			  f = Formula (c, fs);
			
#line 160 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && (LA(2) == IMPLY || LA(2) == EQUIVALENCE)) {
#line 447 "KIF.g"
		
			  Formula g;
			  Connective c;
			
#line 168 "KIFParser.cpp"
		match(LPAR);
		c=binary_connective();
		sentence(f);
		sentence(g);
		match(RPAR);
#line 456 "KIF.g"
		
			  f = Formula (c, f, g);
			
#line 178 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && (LA(2) == LITERAL_forall || LA(2) == LITERAL_exists)) {
#line 461 "KIF.g"
		
			  VarList vs;
			  Connective q;
			
#line 186 "KIFParser.cpp"
		match(LPAR);
		q=quantifier();
		match(LPAR);
		variable_plus(vs);
		match(RPAR);
		sentence(f);
		match(RPAR);
#line 472 "KIF.g"
		
			  f = Formula (q, vs, f);
			
#line 198 "KIFParser.cpp"
	}
	else {
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	
}

void KIFParser::term(
	Term& t
) {
	antlr::RefToken  c = antlr::nullToken;
	antlr::RefToken  s = antlr::nullToken;
	antlr::RefToken  n = antlr::nullToken;
#line 216 "KIF.g"
	
		  TRACER ("KIFParser::term");
		  Var v;
		
#line 217 "KIFParser.cpp"
	
	switch ( LA(1)) {
	case VARIABLE:
	{
		v=variable();
#line 223 "KIF.g"
		
			  t = Term(v);
			
#line 227 "KIFParser.cpp"
		break;
	}
	case WORD:
	{
		c = LT(1);
		match(WORD);
#line 228 "KIF.g"
		
			  t = Term (Signature::sig.createFun(c->getText(), 0));
			
#line 238 "KIFParser.cpp"
		break;
	}
	case STRING:
	{
		s = LT(1);
		match(STRING);
#line 233 "KIF.g"
		
			  t = Term ( Signature::sig.createFun(s->getText(), 0));
		
#line 249 "KIFParser.cpp"
		break;
	}
	case LPAR:
	{
		funterm(t);
		break;
	}
	case NUMBER:
	{
		n = LT(1);
		match(NUMBER);
#line 240 "KIF.g"
		
			  char* endptr = 0;
			  const char* string = n->getText().c_str();
			  double d = strtod (string, &endptr);
		
			  if (*endptr) { // error returned by strtol
			    USER_ERROR("Incorrect floating point number");
			  }
			  t = Term (d);
			
#line 272 "KIFParser.cpp"
		break;
	}
	case QUOTE:
	{
		quoted_term(t);
		break;
	}
	case IMPLY:
	{
		match(IMPLY);
#line 255 "KIF.g"
		
			  t = Term (Signature::sig.createFun ("=>", 0));
			
#line 287 "KIFParser.cpp"
		break;
	}
	case EQUIVALENCE:
	{
		match(EQUIVALENCE);
#line 260 "KIF.g"
		
			  t = Term (Signature::sig.createFun ("<=>", 0));
			
#line 297 "KIFParser.cpp"
		break;
	}
	case LITERAL_and:
	{
		kw_and();
#line 265 "KIF.g"
		
			  t = Term (Signature::sig.createFun ("and", 0));
			
#line 307 "KIFParser.cpp"
		break;
	}
	case LITERAL_or:
	{
		kw_or();
#line 270 "KIF.g"
		
			  t = Term (Signature::sig.createFun ("or", 0));
			
#line 317 "KIFParser.cpp"
		break;
	}
	case LITERAL_not:
	{
		kw_not();
#line 275 "KIF.g"
		
			  t = Term (Signature::sig.createFun ("not", 0));
			
#line 327 "KIFParser.cpp"
		break;
	}
	case LITERAL_forall:
	{
		kw_forall();
#line 280 "KIF.g"
		
			  t = Term (Signature::sig.createFun ("forall", 0));
			
#line 337 "KIFParser.cpp"
		break;
	}
	case LITERAL_exists:
	{
		kw_exists();
#line 285 "KIF.g"
		
			  t = Term (Signature::sig.createFun ("exists", 0));
			
#line 347 "KIFParser.cpp"
		break;
	}
	case LITERAL_equal:
	{
		kw_equal();
#line 290 "KIF.g"
		
			  t = Term (Signature::sig.createFun ("equal", 0));
			
#line 357 "KIFParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
}

Var  KIFParser::variable() {
#line 764 "KIF.g"
	Var v;
#line 370 "KIFParser.cpp"
	antlr::RefToken  w = antlr::nullToken;
#line 764 "KIF.g"
	
		  TRACER ("KIFParser::variable");
		
#line 376 "KIFParser.cpp"
	
	w = LT(1);
	match(VARIABLE);
#line 771 "KIF.g"
	
	v = Var(IntNameTable::vars.insert(w->getText()));
	
#line 384 "KIFParser.cpp"
	return v;
}

void KIFParser::funterm(
	Term& t
) {
	antlr::RefToken  w = antlr::nullToken;
#line 296 "KIF.g"
	
		  TRACER ("KIFParser::funterm");
		  TermList ts;
		
#line 397 "KIFParser.cpp"
	
	match(LPAR);
	w = LT(1);
	match(WORD);
	term_plus(ts);
#line 305 "KIF.g"
	
		  t = Term ( Signature::sig.createFun (w->getText(), ts.length()),
	ts );
		
#line 408 "KIFParser.cpp"
	match(RPAR);
}

void KIFParser::quoted_term(
	Term& t
) {
#line 388 "KIF.g"
	
		  TRACER ("KIFParser::quoted_term");
		
#line 419 "KIFParser.cpp"
	
	match(QUOTE);
	term_sentence(t);
#line 395 "KIF.g"
	
		  t = Term (Signature::sig.createFun("$`",1), TermList(t));
		
#line 427 "KIFParser.cpp"
}

void KIFParser::kw_and() {
	
	match(LITERAL_and);
}

void KIFParser::kw_or() {
	
	match(LITERAL_or);
}

void KIFParser::kw_not() {
	
	match(LITERAL_not);
}

void KIFParser::kw_forall() {
	
	match(LITERAL_forall);
}

void KIFParser::kw_exists() {
	
	match(LITERAL_exists);
}

void KIFParser::kw_equal() {
	
	match(LITERAL_equal);
}

void KIFParser::term_plus(
	TermList& ts
) {
#line 730 "KIF.g"
	
		  TRACER ("KIFParser::term_plus");
	TermList rest;
	Term t;
	
#line 469 "KIFParser.cpp"
	
	term(t);
	{
	switch ( LA(1)) {
	case WORD:
	case STRING:
	case VARIABLE:
	case NUMBER:
	case QUOTE:
	case LPAR:
	case IMPLY:
	case EQUIVALENCE:
	case LITERAL_equal:
	case LITERAL_not:
	case LITERAL_and:
	case LITERAL_or:
	case LITERAL_forall:
	case LITERAL_exists:
	{
		term_plus(rest);
		break;
	}
	case RPAR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 742 "KIF.g"
	
		  ts = TermList (t, rest);
		
#line 506 "KIFParser.cpp"
}

Connective  KIFParser::binary_connective() {
#line 313 "KIF.g"
	Connective c;
#line 512 "KIFParser.cpp"
	
	switch ( LA(1)) {
	case IMPLY:
	{
		match(IMPLY);
#line 317 "KIF.g"
		
			  c = IMP;
			
#line 522 "KIFParser.cpp"
		break;
	}
	case EQUIVALENCE:
	{
		match(EQUIVALENCE);
#line 322 "KIF.g"
		
			  c = IFF;
			
#line 532 "KIFParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	return c;
}

FunctionSymbol*  KIFParser::binary_connective_fun() {
#line 328 "KIF.g"
	FunctionSymbol* f;
#line 546 "KIFParser.cpp"
	
	switch ( LA(1)) {
	case IMPLY:
	{
		match(IMPLY);
#line 332 "KIF.g"
		
			  f = &(Signature::sig.createFun ("=>", 2));
			
#line 556 "KIFParser.cpp"
		break;
	}
	case EQUIVALENCE:
	{
		match(EQUIVALENCE);
#line 337 "KIF.g"
		
			  f = &(Signature::sig.createFun ("<=>", 2));
			
#line 566 "KIFParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	return f;
}

Connective  KIFParser::junction() {
#line 343 "KIF.g"
	Connective c;
#line 580 "KIFParser.cpp"
	
	switch ( LA(1)) {
	case LITERAL_and:
	{
		kw_and();
#line 347 "KIF.g"
		
			  c = AND;
			
#line 590 "KIFParser.cpp"
		break;
	}
	case LITERAL_or:
	{
		kw_or();
#line 352 "KIF.g"
		
			  c = OR;
			
#line 600 "KIFParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	return c;
}

Connective  KIFParser::quantifier() {
#line 358 "KIF.g"
	Connective c;
#line 614 "KIFParser.cpp"
	
	switch ( LA(1)) {
	case LITERAL_forall:
	{
		kw_forall();
#line 362 "KIF.g"
		
			  c = FORALL;
			
#line 624 "KIFParser.cpp"
		break;
	}
	case LITERAL_exists:
	{
		kw_exists();
#line 367 "KIF.g"
		
			  c = EXISTS;
			
#line 634 "KIFParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	return c;
}

FunctionSymbol*  KIFParser::quantifier_fun() {
#line 373 "KIF.g"
	FunctionSymbol* f;
#line 648 "KIFParser.cpp"
	
	switch ( LA(1)) {
	case LITERAL_forall:
	{
		kw_forall();
#line 377 "KIF.g"
		
			  f = &(Signature::sig.createFun ("forall",2));
			
#line 658 "KIFParser.cpp"
		break;
	}
	case LITERAL_exists:
	{
		kw_exists();
#line 382 "KIF.g"
		
			  f = &(Signature::sig.createFun ("exists",2));
			
#line 668 "KIFParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	return f;
}

void KIFParser::term_sentence(
	Term& t
) {
#line 478 "KIF.g"
	
		  TRACER ("KIFParser::term_sentence");
		
#line 686 "KIFParser.cpp"
	
	if ((LA(1) == LPAR) && (LA(2) == LITERAL_equal)) {
		term_equation(t);
	}
	else if ((LA(1) == LPAR) && ((LA(2) >= LESS && LA(2) <= GEQ))) {
		term_inequality(t);
	}
	else if ((LA(1) == LPAR) && (LA(2) == LITERAL_not)) {
		match(LPAR);
		kw_not();
		term_sentence(t);
		match(RPAR);
#line 491 "KIF.g"
		
			  t = Term (Signature::sig.createFun("not",1), TermList(t));
			
#line 703 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && (LA(2) == LITERAL_and || LA(2) == LITERAL_or)) {
#line 495 "KIF.g"
		
			  TermList ts;
			  Connective c;
			
#line 711 "KIFParser.cpp"
		match(LPAR);
		c=junction();
		term_sentence_plus(ts);
		match(RPAR);
#line 503 "KIF.g"
		
			  t = Term (Signature::sig.createFun(c == AND? "and" : "or", ts.length()), ts);
			
#line 720 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && (LA(2) == IMPLY || LA(2) == EQUIVALENCE)) {
#line 507 "KIF.g"
		
			  Term s;
			  FunctionSymbol* f;
			
#line 728 "KIFParser.cpp"
		match(LPAR);
		f=binary_connective_fun();
		term_sentence(s);
		term_sentence(t);
		match(RPAR);
#line 516 "KIF.g"
		
			  t = Term (*f, 
				    TermList(s, 
					     TermList(t)));
			
#line 740 "KIFParser.cpp"
	}
	else if ((LA(1) == LPAR) && (LA(2) == LITERAL_forall || LA(2) == LITERAL_exists)) {
#line 522 "KIF.g"
		
			  VarList vs;
			  FunctionSymbol* q;
			
#line 748 "KIFParser.cpp"
		match(LPAR);
		q=quantifier_fun();
		match(LPAR);
		variable_plus(vs);
		match(RPAR);
		term_sentence(t);
		match(RPAR);
#line 533 "KIF.g"
		
			  FunctionSymbol* v = &(Signature::sig.createFun ("$qvars",vs.length()));
			  t = Term (*q, TermList(Term(*v,TermList(vs)),
						 TermList(t)));
			
#line 762 "KIFParser.cpp"
	}
	else if ((_tokenSet_0.member(LA(1))) && (_tokenSet_1.member(LA(2)))) {
		term(t);
	}
	else {
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	
}

void KIFParser::equation(
	Atom& a
) {
#line 543 "KIF.g"
	
		  TRACER ("KIFParser::equation");
		  Term t1;
		  Term t2;
		
#line 782 "KIFParser.cpp"
	
	match(LPAR);
	kw_equal();
	term(t1);
	term(t2);
#line 554 "KIF.g"
	
		  a = Atom (t1, t2);
		
#line 792 "KIFParser.cpp"
	match(RPAR);
}

void KIFParser::inequality(
	Atom& a
) {
#line 637 "KIF.g"
	
		  TRACER ("KIFParser::inequality");
		  PredicateSymbol* p;
		  Term t1;
		  Term t2;
		
#line 806 "KIFParser.cpp"
	
	match(LPAR);
	p=binary_comparison();
	term(t1);
	term(t2);
	match(RPAR);
#line 650 "KIF.g"
	
		  a = Atom(*p, TermList (t1, 
			       TermList (t2)));
		
#line 818 "KIFParser.cpp"
}

void KIFParser::relsent(
	Atom& a
) {
	antlr::RefToken  w = antlr::nullToken;
#line 677 "KIF.g"
	
		  TRACER ("KIFParser::relsent");
		  TermList ts;
		
#line 830 "KIFParser.cpp"
	
	match(LPAR);
	w = LT(1);
	match(WORD);
	term_plus(ts);
#line 686 "KIF.g"
	
		  a = Atom(Signature::sig.createPred (w->getText(), ts.length()),
	ts );
		
#line 841 "KIFParser.cpp"
	match(RPAR);
}

void KIFParser::sentence_plus(
	FormulaList& fs
) {
#line 694 "KIF.g"
	
		  TRACER ("KIFParser::sentence_plus");
	FormulaList rest;
	Formula f;
	
#line 854 "KIFParser.cpp"
	
	sentence(f);
	{
	switch ( LA(1)) {
	case WORD:
	case LPAR:
	{
		sentence_plus(rest);
		break;
	}
	case RPAR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 706 "KIF.g"
	
		  fs = FormulaList (f, rest);
		
#line 879 "KIFParser.cpp"
}

void KIFParser::variable_plus(
	VarList& ws
) {
#line 747 "KIF.g"
	
		  TRACER ("KIFParser::variable_plus");
	VarList vs;
	Var vv;
	
#line 891 "KIFParser.cpp"
	
	vv=variable();
	{
	switch ( LA(1)) {
	case VARIABLE:
	{
		variable_plus(vs);
		break;
	}
	case RPAR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 759 "KIF.g"
	
		  ws = VarList (vv, vs);
		
#line 915 "KIFParser.cpp"
}

void KIFParser::term_equation(
	Term& t
) {
#line 561 "KIF.g"
	
		  TRACER ("KIFParser::term_equation");
		  Term t1;
		  Term t2;
		
#line 927 "KIFParser.cpp"
	
	match(LPAR);
	kw_equal();
	term(t1);
	term(t2);
#line 572 "KIF.g"
	
		  t = Term (Signature::sig.createFun ("equal", 2),
			    TermList (t1, 
				      TermList(t2)));
		
#line 939 "KIFParser.cpp"
	match(RPAR);
}

void KIFParser::term_inequality(
	Term& t
) {
#line 657 "KIF.g"
	
		  TRACER ("KIFParser::term_inequality");
		  FunctionSymbol* f;
		  Term t1;
		  Term t2;
		
#line 953 "KIFParser.cpp"
	
	match(LPAR);
	f=binary_comparison_fun();
	term(t1);
	term(t2);
	match(RPAR);
#line 670 "KIF.g"
	
		  t = Term(*f, TermList (t1, 
			       TermList (t2)));
		
#line 965 "KIFParser.cpp"
}

void KIFParser::term_sentence_plus(
	TermList& ts
) {
#line 712 "KIF.g"
	
		  TRACER ("KIFParser::term_sentence_plus");
	TermList rest;
	Term t;
	
#line 977 "KIFParser.cpp"
	
	term_sentence(t);
	{
	switch ( LA(1)) {
	case WORD:
	case STRING:
	case VARIABLE:
	case NUMBER:
	case QUOTE:
	case LPAR:
	case IMPLY:
	case EQUIVALENCE:
	case LITERAL_equal:
	case LITERAL_not:
	case LITERAL_and:
	case LITERAL_or:
	case LITERAL_forall:
	case LITERAL_exists:
	{
		term_sentence_plus(rest);
		break;
	}
	case RPAR:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
#line 724 "KIF.g"
	
		  ts = TermList (t, rest);
		
#line 1014 "KIFParser.cpp"
}

PredicateSymbol*  KIFParser::binary_comparison() {
#line 581 "KIF.g"
	PredicateSymbol* p;
#line 1020 "KIFParser.cpp"
#line 581 "KIF.g"
	
		  TRACER ("KIFParser::binary_comparison");
		
#line 1025 "KIFParser.cpp"
	
	switch ( LA(1)) {
	case MORE:
	{
		match(MORE);
#line 588 "KIF.g"
		
			  p = &(Signature::sig.createPred (">", 2));
			
#line 1035 "KIFParser.cpp"
		break;
	}
	case LESS:
	{
		match(LESS);
#line 593 "KIF.g"
		
			  p = &(Signature::sig.createPred ("<", 2));
			
#line 1045 "KIFParser.cpp"
		break;
	}
	case GEQ:
	{
		match(GEQ);
#line 598 "KIF.g"
		
			  p = &(Signature::sig.createPred (">=", 2));
			
#line 1055 "KIFParser.cpp"
		break;
	}
	case LESSEQ:
	{
		match(LESSEQ);
#line 603 "KIF.g"
		
			  p = &(Signature::sig.createPred ("<=", 2));
			
#line 1065 "KIFParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	return p;
}

FunctionSymbol*  KIFParser::binary_comparison_fun() {
#line 609 "KIF.g"
	FunctionSymbol* f;
#line 1079 "KIFParser.cpp"
#line 609 "KIF.g"
	
		  TRACER ("KIFParser::binary_comparison_fun");
		
#line 1084 "KIFParser.cpp"
	
	switch ( LA(1)) {
	case MORE:
	{
		match(MORE);
#line 616 "KIF.g"
		
			  f = &(Signature::sig.createFun (">", 2));
			
#line 1094 "KIFParser.cpp"
		break;
	}
	case LESS:
	{
		match(LESS);
#line 621 "KIF.g"
		
			  f = &(Signature::sig.createFun ("<", 2));
			
#line 1104 "KIFParser.cpp"
		break;
	}
	case GEQ:
	{
		match(GEQ);
#line 626 "KIF.g"
		
			  f = &(Signature::sig.createFun (">=", 2));
			
#line 1114 "KIFParser.cpp"
		break;
	}
	case LESSEQ:
	{
		match(LESSEQ);
#line 631 "KIF.g"
		
			  f = &(Signature::sig.createFun ("<=", 2));
			
#line 1124 "KIFParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	return f;
}

void KIFParser::initializeASTFactory( antlr::ASTFactory& )
{
}
const char* KIFParser::tokenNames[] = {
	"<0>",
	"EOF",
	"<2>",
	"NULL_TREE_LOOKAHEAD",
	"UPPER",
	"LOWER",
	"DIGIT",
	"SPECIAL",
	"WHITE",
	"INITIALCHAR",
	"WORDCHAR",
	"CHARACTER",
	"TICK",
	"WORD",
	"STRING",
	"VARIABLE",
	"FIGURE",
	"NUMBER",
	"EXPONENT",
	"QUOTE",
	"SKIP_RULE",
	"COMMENT_LINE",
	"LPAR",
	"RPAR",
	"LESS",
	"MORE",
	"LESSEQ",
	"GEQ",
	"IMPLY",
	"EQUIVALENCE",
	"\"equal\"",
	"\"not\"",
	"\"and\"",
	"\"or\"",
	"\"forall\"",
	"\"exists\"",
	0
};

const unsigned long KIFParser::_tokenSet_0_data_[] = { 4031438848UL, 15UL, 0UL, 0UL };
// WORD STRING VARIABLE NUMBER QUOTE LPAR IMPLY EQUIVALENCE "equal" "not" 
// "and" "or" "forall" "exists" 
const antlr::BitSet KIFParser::_tokenSet_0(_tokenSet_0_data_,4);
const unsigned long KIFParser::_tokenSet_1_data_[] = { 4039827456UL, 15UL, 0UL, 0UL };
// WORD STRING VARIABLE NUMBER QUOTE LPAR RPAR IMPLY EQUIVALENCE "equal" 
// "not" "and" "or" "forall" "exists" 
const antlr::BitSet KIFParser::_tokenSet_1(_tokenSet_1_data_,4);


