#ifndef INC_KIFParser_hpp_
#define INC_KIFParser_hpp_

#line 19 "KIF.g"

    // gets inserted before antlr generated includes in the header file
  class FormulaList;
  class Term;
  class Atom;
  class Formula;
  class TermList;
  class FunctionSymbol;
  class PredicateSymbol;

#line 16 "KIFParser.hpp"
#include <antlr/config.hpp>
/* $ANTLR 2.7.3 (20040506-1): "KIF.g" -> "KIFParser.hpp"$ */
#include <antlr/TokenStream.hpp>
#include <antlr/TokenBuffer.hpp>
#include "KIFLexerTokenTypes.hpp"
#include <antlr/LLkParser.hpp>

#line 29 "KIF.g"

    // gets inserted after antlr generated includes in the header file
     // outside any generated namespace specifications
#include "Var.hpp"
#include "Connective.hpp"

#line 31 "KIFParser.hpp"
#line 44 "KIF.g"

    // gets inserted after generated namespace specifications in the header
    // file. But outside the generated class.

#line 37 "KIFParser.hpp"
class CUSTOM_API KIFParser : public antlr::LLkParser, public KIFLexerTokenTypes
{
#line 194 "KIF.g"

#line 41 "KIFParser.hpp"
public:
	void initializeASTFactory( antlr::ASTFactory& factory );
protected:
	KIFParser(antlr::TokenBuffer& tokenBuf, int k);
public:
	KIFParser(antlr::TokenBuffer& tokenBuf);
protected:
	KIFParser(antlr::TokenStream& lexer, int k);
public:
	KIFParser(antlr::TokenStream& lexer);
	KIFParser(const antlr::ParserSharedInputState& state);
	int getNumTokens() const
	{
		return KIFParser::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return KIFParser::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return KIFParser::tokenNames;
	}
	public: void start(
		FormulaList& formulas
	);
	public: void sentence(
		Formula& f
	);
	public: void term(
		Term& t
	);
	public: Var  variable();
	public: void funterm(
		Term& t
	);
	public: void quoted_term(
		Term& t
	);
	public: void kw_and();
	public: void kw_or();
	public: void kw_not();
	public: void kw_forall();
	public: void kw_exists();
	public: void kw_equal();
	public: void term_plus(
		TermList& ts
	);
	public: Connective  binary_connective();
	public: FunctionSymbol*  binary_connective_fun();
	public: Connective  junction();
	public: Connective  quantifier();
	public: FunctionSymbol*  quantifier_fun();
	public: void term_sentence(
		Term& t
	);
	public: void equation(
		Atom& a
	);
	public: void inequality(
		Atom& a
	);
	public: void relsent(
		Atom& a
	);
	public: void sentence_plus(
		FormulaList& fs
	);
	public: void variable_plus(
		VarList& ws
	);
	public: void term_equation(
		Term& t
	);
	public: void term_inequality(
		Term& t
	);
	public: void term_sentence_plus(
		TermList& ts
	);
	public: PredicateSymbol*  binary_comparison();
	public: FunctionSymbol*  binary_comparison_fun();
public:
	antlr::RefAST getAST()
	{
		return returnAST;
	}
	
protected:
	antlr::RefAST returnAST;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 36;
#else
	enum {
		NUM_TOKENS = 36
	};
#endif
	
	static const unsigned long _tokenSet_0_data_[];
	static const antlr::BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const antlr::BitSet _tokenSet_1;
};

#endif /*INC_KIFParser_hpp_*/
