
/*
 * File LaTeX.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __LaTeX__
#define __LaTeX__

class Term;
class Symbol;
class TermList;
class Atom;
class Literal;
class Clause;
class Formula;
class Refutation;
class Unit;
class Options;

#include "Var.hpp"
#include "Connective.hpp"
#include <string>
#include <fstream>


class LaTeX
{
public:
  static void output (const Refutation&,const Options& options);
private:
  static string toLaTeX (const Refutation&);
  static string toLaTeX (Var);
  static string toLaTeX (const Term&);
  static string toLaTeX (const Symbol&);
  static string toLaTeX (const TermList&);
  static string toLaTeX (const Atom&);
  static string toLaTeX (const Literal&);
  static string toLaTeX (const Clause&);
  static string toLaTeX (const Formula&);
  static string toLaTeX (const Formula&, Connective c);
  static string toLaTeX (const Unit&);
  static string toLaTeXAsInference (const Unit&);
}; 


#endif 

