
/*
 * File Lists.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Lists__
#define __Lists__

#include <string>
#include "Lst.hpp"

class IntList 
  : public Lst<int>
{
 public:
  
  IntList ();
  IntList (const IntList&);
  explicit IntList (int); 
  IntList (int head, const IntList& tail);

  
  const IntList& tail () const
    { return static_cast<const IntList&>(Lst<int>::tail()); }

  string toString () const;
}; 




inline
IntList::IntList () 
  : 
  Lst<int> ()
{
} 



inline
IntList::IntList (const IntList& ts)
  :
  Lst<int> (ts)
{
} 



inline
IntList::IntList (int hd, const IntList& tl)
  :
  Lst<int> (hd,tl)
{
} 



inline
IntList::IntList (int hd)
  :
  Lst<int> (hd)
{
} 


#endif 

