
/*
 * File Matching.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Matching__
#define __Matching__

#include "VarCounter.hpp"

class Substitution;
class Formula;
class FormulaList;
class Atom;
class Term;
class TermList;



class Matching
{
public:
  static bool match (const Formula&, const Formula&, Substitution& sbst);
private:
  
  Matching (Substitution& sbst) : _sbst(sbst) {}
  bool match (const Formula&, const Formula&);
  bool match (const FormulaList&,const FormulaList&);
  bool match (const Atom&, const Atom&);
  bool match (const Term&, const Term&);
  bool match (const TermList&, const TermList&);
  bool hasBoundVariables (const Term& t) const;
  
  VarCounter _bound1;
  
  VarCounter _bound2;
  
  Substitution& _sbst;
};


#endif 
