
/*
 * File Pretty.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Pretty__
#define __Pretty__



class Formula;
class FormulaList;
class Atom;
class Atom;

#include "Connective.hpp"
#include <string>



class Pretty
{
public:
  static string toString(const Formula&);
private:
  static string indent (int n);
  static string toString (const Formula&, int indent);
  static string toStringInScopeOf (const Formula&, Connective c, int indent);
  static bool isOneLine (const Formula&);
  static void stripUnaryConnectives(Formula&);
  static bool isLiteral (const Formula&);
  static bool isBuiltUsingUnaryConnectives (const Formula&);
  static int quantifierPrintLength (Connective Q,const VarList& vs);
}; 


#endif 
