
/*
 * File Random.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */



#ifndef __RANDOM__
#  define __RANDOM__


#include <cstdlib>
#include <ctime>





class Random 
{
  
  
  static int _seed;             
  static int _remainingBits;    
  static const int _bitsPerInt; 
  static int _bits;             

  static int bitsPerInt ();     

 public:

  
  static int getMax ();
  
  static int getInteger ();
  
  static int getInteger (int modulus);
  
  static int getBit ();
  
  static void setSeed (int s);
  
  static int getSeed ();
  
  static void resetSeed ();
}; 





inline
void Random::setSeed ( int s )
{
  _seed = s;
  srand ( s );
}



inline
int Random::getSeed ()
{
  return _seed;
}


inline
int Random::getMax ()
{
  return RAND_MAX;
}



inline
int Random::getInteger ()
{
  return rand ();
}



inline
int Random::getInteger (int modulus)
{
  return getInteger () % modulus;
}


inline
void Random::resetSeed ()
{
  setSeed (time(0));
}



inline
int Random::getBit ()
{
  if ( _remainingBits == 0 ) {
    _remainingBits = _bitsPerInt;
    _bits = getInteger();
  }

  int result = _bits % 2;
  _bits /= 2;
  _remainingBits --;

  return result;
} 


#endif


