
/*
 * File Renaming.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Renaming__
#define __Renaming__

class Term;
class TermList;
class Atom;
class Literal;
class LiteralList;
class Clause;

class Renaming
{
public:
  static bool isVariant (const Clause&, const Clause&);
private:
  Renaming ();
  ~Renaming ();
  bool match (const Term&, const Term&);
  bool match (const TermList&, const TermList&);
  bool match (const Atom&, const Atom&);
  bool match (const Literal&, const Literal&);
  bool match (const LiteralList&, const LiteralList&);
  bool addBinding (int v1,int v2);
  static void expandToFit (int v,int*& varArray,int& arrayLength);

  
  int* _direct;
  
  int* _inverse;
  
  int _nextDirect;
  
  int _nextInverse;
}; 


#endif 
