
/*
 * File Sequent.cpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#include "Sequent.hpp"


Sequent::Sequent ()
{
} 


Sequent::Sequent (const SignedFormulaList& formulas, 
		  const LiteralList& literals)
  : _formulas(formulas),
    _literals(literals)
{
}


Sequent* Sequent::popFormula (SignedFormula& sf)
{
  sf = _formulas.head();
  return new Sequent(_formulas.tail(),_literals);
} 


Sequent::Sequent (const Sequent* s, bool sign, const Atom& a)
  : _formulas(s->_formulas),
    _literals(Literal(sign,a),s->_literals)
{
} 



Sequent::Sequent (const Sequent* s, bool sign, const Formula& f)
  : _formulas(SignedFormula(sign,f),s->_formulas),
    _literals(s->_literals)
{
} 



Sequent::Sequent (const Sequent* s, bool sign, const FormulaList& fs)
  : _formulas(s->_formulas),
    _literals(s->_literals)
{
  Iterator<Formula> Fs(fs);
  while (Fs.hasNext()) {
    _formulas.push(SignedFormula(sign,Fs.next()));
  }
} 
