
/*
 * File Sequent.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __Sequent__
#define __Sequent__


#include "Literal.hpp"
#include "SignedFormula.hpp"



class Sequent 
{
public:
  Sequent ();
  Sequent (const Sequent* s, bool sign, const Formula& f);
  Sequent (const Sequent* s, bool sign, const FormulaList& fs);
  Sequent (const Sequent* s, bool sign, const Atom& a);
  Sequent* popFormula (SignedFormula& sf);
private:
  Sequent (const SignedFormulaList& formulas, const LiteralList& literals);
  SignedFormulaList _formulas;
  LiteralList _literals;
}; 


#endif
