
/*
 * File TPTP.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __TPTP__
#define __TPTP__

class Symbol;
class Atom;
class Literal;
class Clause;
class Formula;
class Unit;
class Refutation;
class Problem;

#include "Var.hpp"
#include "Connective.hpp"
#include <string>


class TPTP
{
public:
  static string toString (const Problem&);
  static string toString (const Refutation&);
private:
  static string toString (const Symbol&);
  static string toString (const Atom&);
  static string toString (const Literal&);
  static string toString (const Clause&);
  static string toString (const Formula&);
  static string toString (const Formula&, Connective);
  static string toString (const Unit&);
  static string toStringAsInference (const Unit&);
}; 


#endif 

