
/*
 * File Var.cpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */



#include <cstdio>
#include "Var.hpp"
#include "XML.hpp"
#include "Int.hpp"


bool VarList::equals (const VarList& vs) const
{
   if (isEmpty()) {
    return vs.isEmpty();
  }
  return vs.isNonEmpty() &&
         head() == vs.head() &&
         tail().equals(vs.tail());
} 



XML::Element* Var::toXML () const
{
  XML::EmptyElement* v = new XML::EmptyElement("variable");
  v->addAttribute(new XML::IntegerAttribute("number",_var));
  return v;
} 



string Var::toString () const
{
  static char tmp [20] = {'X'};
  sprintf(tmp+1,"%d",_var);

  return string(tmp);
} 



string VarList::toString () const
{
  if (isEmpty()) {
    return "";
  }
  string result = head().toString();
  Iterator<Var> vs(tail());
  while (vs.hasNext()) {
    result += (string)"," + vs.next().toString();
  }

  return result;
} 

