
/*
 * File VarCounter.hpp.
 * Copyright (c) 2004 Andrei Voronkov and Alexandre Riazanov.
 *
 * You are not allowed to use or modify this software or
 * any part thereof.
 * The only reason this file appears on the Web is that
 * it is required by the CASC rules.
 * All questions related to licensing and distribution of
 * Vampire should be addressed to Andrei Voronkov.
 */


#ifndef __VarCounter__
#define __VarCounter__

namespace XML {
  class Element;
};

#include "Var.hpp"


class VarCounter
{
public:
  VarCounter ();
  ~VarCounter ();

  void incCount (Var v);
  void decCount (Var v);
  void setCount (Var v, int count);
  int getCount (Var v) const;
  XML::Element* toXML () const;
private:
  
  int _top;
  
  int* _counts;
  void expandToFit (int v);
}; 


#endif 


