/* $ANTLR 2.7.3 (20040506-1): "XML.g" -> "XMLParser.cpp"$ */
#line 28 "XML.g"

    // gets inserted before the antlr generated includes in the cpp file

#line 7 "XMLParser.cpp"
#include "XMLParser.hpp"
#include <antlr/NoViableAltException.hpp>
#include <antlr/SemanticException.hpp>
#include <antlr/ASTFactory.hpp>
#line 32 "XML.g"

    // gets inserted after the antlr generated includes in the cpp file

#line 16 "XMLParser.cpp"
#line 123 "XML.g"

// head of parser file
#include "KIFParser.hpp"

#include "antlr/TokenStreamSelector.hpp"
extern antlr::TokenStreamSelector* selector;


#line 26 "XMLParser.cpp"
XMLParser::XMLParser(antlr::TokenBuffer& tokenBuf, int k)
: antlr::LLkParser(tokenBuf,k)
{
}

XMLParser::XMLParser(antlr::TokenBuffer& tokenBuf)
: antlr::LLkParser(tokenBuf,2)
{
}

XMLParser::XMLParser(antlr::TokenStream& lexer, int k)
: antlr::LLkParser(lexer,k)
{
}

XMLParser::XMLParser(antlr::TokenStream& lexer)
: antlr::LLkParser(lexer,2)
{
}

XMLParser::XMLParser(const antlr::ParserSharedInputState& state)
: antlr::LLkParser(state,2)
{
}

Query*  XMLParser::start() {
#line 158 "XML.g"
	Query* q;
#line 55 "XMLParser.cpp"
	
	if ((LA(1) == START_TAG) && (LA(2) == LITERAL_query)) {
		q=query();
	}
	else if ((LA(1) == START_TAG) && (LA(2) == LITERAL_assertion)) {
		q=assertion();
	}
	else if ((LA(1) == antlr::Token::EOF_TYPE || LA(1) == START_TAG) && (LA(2) == antlr::Token::EOF_TYPE || LA(2) == LITERAL_bye)) {
		terminate();
#line 166 "XML.g"
		
			  q = new Query ();
			
#line 69 "XMLParser.cpp"
	}
	else {
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	
	return q;
}

Query*  XMLParser::query() {
#line 181 "XML.g"
	Query* query;
#line 81 "XMLParser.cpp"
#line 181 "XML.g"
	
		  Query::Attribute* attrs;
		  Formula formula;
		
#line 87 "XMLParser.cpp"
	
	match(START_TAG);
	kw_query();
	attrs=attributes();
	match(END_OF_TAG);
#line 191 "XML.g"
	//  !!! KIF parser invocation !!!
	// switch lexers
	selector->push("KIFLexer");
	// create a parser to handle the KIF structures
	KIFParser kifParser (getInputState());
	kifParser.sentence(formula); // go parse KIF
	// switch lexers back
	selector->pop();
	query = new Query (Query::GOAL, formula, attrs);
	
#line 104 "XMLParser.cpp"
	match(START_OF_END_TAG);
	kw_query();
	match(END_OF_TAG);
	return query;
}

Query*  XMLParser::assertion() {
#line 204 "XML.g"
	Query* query;
#line 114 "XMLParser.cpp"
#line 204 "XML.g"
	
		  Query::Attribute* attrs;
		  Formula formula;
		
#line 120 "XMLParser.cpp"
	
	match(START_TAG);
	kw_assertion();
	attrs=attributes();
	match(END_OF_TAG);
#line 214 "XML.g"
	//  !!! KIF parser invocation !!!
	// switch lexers
	selector->push("KIFLexer");
	// create a parser to handle the KIF structures
	KIFParser kifParser (getInputState());
	kifParser.sentence(formula); // go parse KIF
	// switch lexers back
	selector->pop();
	query = new Query (Query::ASSERTION, formula, attrs);
	
#line 137 "XMLParser.cpp"
	match(START_OF_END_TAG);
	kw_assertion();
	match(END_OF_TAG);
	return query;
}

void XMLParser::terminate() {
	
	switch ( LA(1)) {
	case START_TAG:
	{
		match(START_TAG);
		kw_bye();
		match(END_OF_EMPTY_TAG);
		break;
	}
	case antlr::Token::EOF_TYPE:
	{
		match(antlr::Token::EOF_TYPE);
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
}

void XMLParser::kw_bye() {
	
	match(LITERAL_bye);
}

void XMLParser::kw_query() {
	
	match(LITERAL_query);
}

Query::Attribute*  XMLParser::attributes() {
#line 229 "XML.g"
	Query::Attribute* attrs;
#line 179 "XMLParser.cpp"
#line 229 "XML.g"
	
		  Query::Attribute* rest = 0;
		
#line 184 "XMLParser.cpp"
	
	switch ( LA(1)) {
	case NAME:
	{
		attrs=attribute();
		rest=attributes();
#line 237 "XML.g"
		
			  attrs->next (rest);
			
#line 195 "XMLParser.cpp"
		break;
	}
	case END_OF_TAG:
	{
#line 241 "XML.g"
		
			  attrs = 0;
			
#line 204 "XMLParser.cpp"
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	return attrs;
}

void XMLParser::kw_assertion() {
	
	match(LITERAL_assertion);
}

Query::Attribute*  XMLParser::attribute() {
#line 247 "XML.g"
	Query::Attribute* attr;
#line 223 "XMLParser.cpp"
	antlr::RefToken  n = antlr::nullToken;
	antlr::RefToken  st = antlr::nullToken;
	
	n = LT(1);
	match(NAME);
	match(EQ);
	st = LT(1);
	match(STRING);
#line 253 "XML.g"
	
		  attr = new Query::Attribute ( n->getText(), st->getText());
		
#line 236 "XMLParser.cpp"
	return attr;
}

void XMLParser::recover() {
	
	{
	switch ( LA(1)) {
	case START_OF_END_TAG:
	{
		match(START_OF_END_TAG);
		break;
	}
	case LITERAL_query:
	case LITERAL_assertion:
	{
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
	{
	switch ( LA(1)) {
	case LITERAL_assertion:
	{
		kw_assertion();
		break;
	}
	case LITERAL_query:
	{
		kw_query();
		break;
	}
	default:
	{
		throw antlr::NoViableAltException(LT(1), getFilename());
	}
	}
	}
	match(END_OF_TAG);
}

void XMLParser::initializeASTFactory( antlr::ASTFactory& )
{
}
const char* XMLParser::tokenNames[] = {
	"<0>",
	"EOF",
	"<2>",
	"NULL_TREE_LOOKAHEAD",
	"UPPER",
	"LOWER",
	"DIGIT",
	"SPECIAL",
	"WHITE",
	"INITIALCHAR",
	"WORDCHAR",
	"CHARACTER",
	"TICK",
	"WORD",
	"STRING",
	"VARIABLE",
	"FIGURE",
	"NUMBER",
	"EXPONENT",
	"QUOTE",
	"SKIP_RULE",
	"COMMENT_LINE",
	"LPAR",
	"RPAR",
	"LESS",
	"MORE",
	"LESSEQ",
	"GEQ",
	"IMPLY",
	"EQUIVALENCE",
	"\"equal\"",
	"\"not\"",
	"\"and\"",
	"\"or\"",
	"\"forall\"",
	"\"exists\"",
	"LETTER",
	"NAME",
	"<",
	"</",
	">",
	"/>",
	"=",
	"COMMENT",
	"\"query\"",
	"\"assertion\"",
	"\"bye\"",
	0
};



