#include "resbase.h"

SCM shiftleft(x,y)
SCM x,y;
{
  return MAKINUM(INUM(x)<<INUM(y));
}

SCM shiftright(x,y)
SCM x,y;
{
  return MAKINUM(INUM(x)>>INUM(y));
}

SCM clinfo_clnumber_sublist(inf)
SCM inf;
{
  return CDR(CDR(CDR(CDR(inf))));
}

SCM clinfo_history_sublist(inf)
SCM inf;
{
  return CDR(CDR(CDR(CDR(CDR(inf)))));
}

SCM clinfo_distance(inf)
SCM inf;
{
  return CAR(CDR(CDR(CDR(CDR(CDR(CDR(inf)))))));
}

SCM clinfo_clnr(inf)
SCM inf;
{
  return CAR(CDR(CDR(CDR(CDR(inf)))));
}

SCM get_litinfo_ordernr(inf)
SCM inf;
{
  return MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&inf)>>16);
}

SCM put_litinfo_ordernr(nr,inf)
SCM nr,inf;
{
  return MAKINUM(INUM(nr)<<16)|MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&inf)^INUM(inf));
}

SCM get_litinfo_classnr(inf)
SCM inf;
{
  return MAKINUM(INUM(GLOBAL(litinf_classnr_mask_global)&inf)>>24);
}

SCM put_litinfo_classnr(nr,inf)
SCM nr,inf;
{
  return MAKINUM(INUM(nr)<<24)|MAKINUM(INUM(GLOBAL(litinf_classnr_mask_global)&inf)^INUM(inf));
}

SCM composite_pred_(x)
SCM x;
{
  return NOT(SBOOL(NUMBER_P(x)));
}

SCM non_composite_pred_(x)
SCM x;
{
  return SBOOL(NUMBER_P(x));
}

SCM var_pred_(x)
SCM x;
{
  if(NUMBER_P(x))
    return SBOOL(x<=MAKINUM(65535));
  else
    return BOOL_F;
}

SCM non_composite_colon__var_pred_(x)
SCM x;
{
  return SBOOL(MAKINUM(65535)>x);
}

SCM const_pred_(x)
SCM x;
{
  if(NUMBER_P(x))
    return SBOOL(x>MAKINUM(65535));
  else
    return BOOL_F;
}

SCM single_occ_lit_var_pred_(x)
SCM x;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(32768)&x)));
}

SCM repeated_occ_lit_var_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(32768)&x));
}

SCM later_occurrences_var_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(8192)&x));
}

SCM term_may_cont_vars_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(65536)&CAR(x)));
}

SCM fun_may_cont_vars_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(65536)&x));
}

SCM fun_may_cont_repeatedvars_pred_(x)
SCM x;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(131072)&x)));
}

SCM pure_fun(x)
SCM x;
{
  return MAKINUM(534773760)&x;
}

SCM pure_unsigned_fun(x)
SCM x;
{
  return MAKINUM(266338304)&x;
}

SCM fun_depth_strength(fun)
SCM fun;
{
  return MAKINUM(65535)&fun;
}

SCM fun_depth(fun)
SCM fun;
{
  return MAKINUM(63488)&fun;
}

SCM fun_depth_size(fun)
SCM fun;
{
  return (MAKINUM(63488)|MAKINUM(2016))&fun;
}

SCM fun_real_depth(fun)
SCM fun;
{
  return MAKINUM(INUM(MAKINUM(63488)&fun)>>11);
}

SCM neg_fun_pred_(x)
SCM x;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(268435456)&x)));
}

SCM pos_fun_pred_(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(268435456)&x));
}

SCM complementary_fun_pred_(x)
SCM x;
{
  return MAKINUM(0-INUM(MAKINUM(534773760)&x));
}

SCM fun_can_subsume_pred_(sf,gf)
SCM sf,gf;
{
  if((MAKINUM(534773760)&sf)==(MAKINUM(534773760)&gf)) {
    if((MAKINUM(131071)&sf)>=(MAKINUM(131071)&gf)) {
      if((MAKINUM(65535)&sf)>=(MAKINUM(65535)&gf)) {
        if((MAKINUM(2047)&sf)>=(MAKINUM(2047)&gf))
          return SBOOL((MAKINUM(31)&sf)>=(MAKINUM(31)&gf));
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM ground_lit_equal_pred_(xlit,ylit)
SCM xlit,ylit;
{
  return composite_equal_pred_(xlit,ylit);
}

SCM term_equal_pred_(xterm,yterm)
SCM xterm,yterm;
{
  SCM xel,yel;

  if(xterm==yterm)
    return BOOL_T;
  else
  if(NUMBER_P(xterm)||(NUMBER_P(yterm)||!(CAR(xterm)==CAR(yterm))))
    return BOOL_F;
  else {
    xterm=CDR(xterm);
    yterm=CDR(yterm);
    for(;!(NULL_P(xterm));) {
      xel=CAR(xterm);
      yel=CAR(yterm);
      if((xel==yel)||(!(NUMBER_P(xel))&&(!(NUMBER_P(yel))&&NFALSEP(composite_equal_pred_(xel,yel))))) {
        xterm=CDR(xterm);
        yterm=CDR(yterm);
      }
      else {
        xterm=EOL;
        yterm=BOOL_T;
      }
    }
    return SBOOL(NULL_P(yterm));
  }
}

SCM composite_equal_pred_(xcomp,ycomp)
SCM xcomp,ycomp;
{
  SCM xel,yel;

  if(CAR(xcomp)==CAR(ycomp)) {
    xcomp=CDR(xcomp);
    ycomp=CDR(ycomp);
    for(;!(NULL_P(xcomp));) {
      xel=CAR(xcomp);
      yel=CAR(ycomp);
      if((xel==yel)||(!(NUMBER_P(xel))&&(!(NUMBER_P(yel))&&NFALSEP(composite_equal_pred_(xel,yel))))) {
        xcomp=CDR(xcomp);
        ycomp=CDR(ycomp);
      }
      else {
        xcomp=EOL;
        ycomp=BOOL_T;
      }
    }
    return SBOOL(NULL_P(ycomp));
  }
  else
    return BOOL_F;
}

SCM term_equal_strong_pred_(xterm,yterm)
SCM xterm,yterm;
{
  if(NUMBER_P(xterm)) {
    if(NUMBER_P(yterm)) {
      if(MAKINUM(65535)>xterm)
        return SBOOL((MAKINUM(8191)&xterm)==(MAKINUM(8191)&yterm));
      else
        return SBOOL(xterm==yterm);
    }
    else
      return BOOL_F;
  }
  else
  if(!(NUMBER_P(yterm)))
    return composite_equal_strong_pred_(xterm,yterm);
  else
    return BOOL_F;
}

SCM composite_equal_strong_pred_(xcomp,ycomp)
SCM xcomp,ycomp;
{
  SCM xel,yel;

  if((MAKINUM(534904831)&CAR(xcomp))==(MAKINUM(534904831)&CAR(ycomp))) {
    xcomp=CDR(xcomp);
    ycomp=CDR(ycomp);
    for(;!(NULL_P(xcomp));) {
      xel=CAR(xcomp);
      yel=CAR(ycomp);
      if(NUMBER_P(xel)) {
        if(NUMBER_P(yel)) {
          if(MAKINUM(65535)>xel) {
            if((MAKINUM(8191)&xel)==(MAKINUM(8191)&yel)) {
              xcomp=CDR(xcomp);
              ycomp=CDR(ycomp);
            }
            else {
              xcomp=EOL;
              ycomp=BOOL_T;
            }
          }
          else
          if(xel==yel) {
            xcomp=CDR(xcomp);
            ycomp=CDR(ycomp);
          }
          else {
            xcomp=EOL;
            ycomp=BOOL_T;
          }
        }
        else {
          xcomp=EOL;
          ycomp=BOOL_T;
        }
      }
      else
      if(!(NUMBER_P(yel))&&NFALSEP(composite_equal_strong_pred_(xel,yel))) {
        xcomp=CDR(xcomp);
        ycomp=CDR(ycomp);
      }
      else {
        xcomp=EOL;
        ycomp=BOOL_T;
      }
    }
    return SBOOL(NULL_P(ycomp));
  }
  else
    return BOOL_F;
}

SCM term_list_equal_pred_(xlst,ylst)
SCM xlst,ylst;
{
  for(;!(NULL_P(xlst));)
    if(NFALSEP(term_equal_pred_(CAR(xlst),CAR(ylst)))) {
      xlst=CDR(xlst);
      ylst=CDR(ylst);
    }
    else {
      xlst=EOL;
      ylst=BOOL_T;
    }
  return SBOOL(NULL_P(ylst));
}

SCM swapped_term_list_equal_pred_(xlst,ylst)
SCM xlst,ylst;
{
  if(NFALSEP(term_equal_pred_(CAR(xlst),CAR(CDR(ylst))))) {
    if(NFALSEP(term_equal_pred_(CAR(CDR(xlst)),CAR(ylst))))
      return term_list_equal_pred_(CDR(CDR(xlst)),CDR(CDR(ylst)));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM term_list_equal_strong_pred_(xlst,ylst)
SCM xlst,ylst;
{
  for(;!(NULL_P(xlst));)
    if(NFALSEP(term_equal_strong_pred_(CAR(xlst),CAR(ylst)))) {
      xlst=CDR(xlst);
      ylst=CDR(ylst);
    }
    else {
      xlst=EOL;
      ylst=BOOL_T;
    }
  return SBOOL(NULL_P(ylst));
}

SCM swapped_term_list_equal_strong_pred_(xlst,ylst)
SCM xlst,ylst;
{
  if(NFALSEP(term_equal_strong_pred_(CAR(xlst),CAR(CDR(ylst))))) {
    if(NFALSEP(term_equal_strong_pred_(CAR(CDR(xlst)),CAR(ylst))))
      return term_list_equal_strong_pred_(CDR(CDR(xlst)),CDR(CDR(ylst)));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM clause_can_subsume_pred_(sclstrength,sclpreds,gclinfo)
SCM sclstrength,sclpreds,gclinfo;
{
  SCM gclstrength,gclpreds;

  gclstrength=CAR(gclinfo);
  if(((MAKINUM(8388607)&sclstrength)>=(MAKINUM(8388607)&gclstrength))&&(((MAKINUM(131071)&sclstrength)>=(MAKINUM(131071)&gclstrength))&&(((MAKINUM(65535)&sclstrength)>=(MAKINUM(65535)&gclstrength))&&(((MAKINUM(2047)&sclstrength)>=(MAKINUM(2047)&gclstrength))&&((MAKINUM(31)&sclstrength)>=(MAKINUM(31)&gclstrength)))))) {
    gclpreds=CAR(CDR(gclinfo));
    return SBOOL(gclpreds==(gclpreds&sclpreds));
  }
  else
    return BOOL_F;
}

SCM pure_clause_may_cont_vars_pred_(cl)
SCM cl;
{
  SCM res;

  res=BOOL_F;
  for(;!(NULL_P(cl)||NFALSEP(res));)
    if(ZERO_P(MAKINUM(65536)&CAR(CAR(cl)))) {
      res=BOOL_T;
    }
    else {
      cl=CDR(cl);
    }
  return res;
}

SCM var_nr(var)
SCM var;
{
  return MAKINUM(8191)&var;
}

SCM y_var_pred_(var)
SCM var;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(256)&var)));
}

SCM x_var_pred_(var)
SCM var;
{
  return SBOOL(ZERO_P(MAKINUM(256)&var));
}

SCM unassigned_val_pred_(x)
SCM x;
{
  return SBOOL(x==MAKINUM(99999999));
}

SCM touched_var_pred_(var)
SCM var;
{
  return STBL_VECTOR_REF(_star_var_touched_table_star__velts0,var);
}

SCM set_var_touched_excl_(var,val)
SCM var,val;
{
  STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,val);
  return UNSPECIFIED;
}

SCM var_ref(var)
SCM var;
{
  return STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
}

SCM set_var_ref_excl_(var,val)
SCM var,val;
{
  STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,val);
  return UNSPECIFIED;
}

SCM var_val(var)
SCM var;
{
  SCM var1,var2;

  for(var1=var,var2=STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&var);
      NUMBER_P(var2)&&(var2<=MAKINUM(65535));
      var1=var2,var2=STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&var2)) ;
  if(var2==MAKINUM(99999999))
    return var1;
  else
    return var2;
}

SCM dereference_var(var)
SCM var;
{
  SCM ref;

  ref=STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
  if(ref==MAKINUM(99999999))
    return var;
  else
  if(NFALSEP(STBL_VECTOR_REF(_star_var_touched_table_star__velts0,var))) {
    if(NUMBER_P(ref))
      return ref;
    else
      return dereference_copy_term(ref);
  }
  else {
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_T);
    ref=subst_deco_term(ref,BOOL_F);
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,ref);
    return ref;
  }
}

SCM dereference_copy_term(term)
SCM term;
{
  SCM fun;

  fun=CAR(term);
  if(ZERO_P(MAKINUM(65536)&fun))
    return cons(fun,map1(dereference_copy_aux,CDR(term)));
  else
    return term;
}

SCM dereference_copy_aux(term)
SCM term;
{
  SCM fun;

  if(NUMBER_P(term))
    return term;
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun))
      return cons(fun,map1(dereference_copy_aux,CDR(term)));
    else
      return term;
  }
}

SCM clear_x_vars_excl_(var)
SCM var;
{
  for(;!(ZERO_P(var));) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_x_vars_and_touched_excl_(var)
SCM var;
{
  for(;!(ZERO_P(var));) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_F);
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_y_vars_excl_(var)
SCM var;
{
  var=(MAKINUM(256)|var);
  for(;!(MAKINUM(256)==var);) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_y_vars_and_touched_excl_(var)
SCM var;
{
  var=(MAKINUM(256)|var);
  for(;!(MAKINUM(256)==var);) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_F);
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_z_vars_excl_(var)
SCM var;
{
  var=(MAKINUM(512)|var);
  for(;!(MAKINUM(512)==var);) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_z_vars_and_touched_excl_(var)
SCM var;
{
  var=(MAKINUM(512)|var);
  for(;!(MAKINUM(512)==var);) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,MAKINUM(99999999));
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_F);
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM set_x_vars_selfref_touched_excl_(var)
SCM var;
{
  for(;!(ZERO_P(var));) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,var);
    STBL_VECTOR_SET(_star_var_touched_table_star__velts0,var,BOOL_T);
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM clear_gcl_vars()
{
  return clear_x_vars_excl_(gcl_maxvar_global);
}

SCM restore_gcl_vars()
{
  SCM var,frame;

  for(var=MAKINUM(1),frame=CAR(GLOBAL(gcl_varsstack_global));
      !(NULL_P(frame));
      var=MAKINUM(1+INUM(var)),frame=CDR(frame)) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,CAR(frame));
  }
  GLOBAL(gcl_varsstack_global)=CDR(GLOBAL(gcl_varsstack_global));
  return UNSPECIFIED;
}

SCM save_gcl_vars()
{
  SCM res,var;

  res=EOL;
  for(var=gcl_maxvar_global;!(ZERO_P(var));var=MAKINUM(INUM(var)-1)) {
    res=cons(STBL_VECTOR_REF(_star_var_val_table_star__velts0,var),res);
  }
  GLOBAL(gcl_varsstack_global)=cons(res,GLOBAL(gcl_varsstack_global));
  return UNSPECIFIED;
}

SCM pop_gcl_vars_stack()
{
  GLOBAL(gcl_varsstack_global)=CDR(GLOBAL(gcl_varsstack_global));
  return UNSPECIFIED;
}

SCM copy_nonground_term(term)
SCM term;
{
  if(PAIR_P(term)) {
    if(ZERO_P(MAKINUM(65536)&CAR(term)))
      return cons(CAR(term),map1(copy_nonground_term,CDR(term)));
    else
      return term;
  }
  else
    return term;
}

SCM rename_x_to_y_term(term)
SCM term;
{
  SCM fun;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return MAKINUM(256)|term;
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun))
      return cons(fun,map1(rename_x_to_y_term,CDR(term)));
    else
      return term;
  }
}

SCM rename_y_to_x_term(term)
SCM term;
{
  SCM fun;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return MAKINUM(256^INUM(term));
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun))
      return cons(fun,map1(rename_y_to_x_term,CDR(term)));
    else
      return term;
  }
}

SCM rename_x_to_z_term(term)
SCM term;
{
  SCM fun;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return MAKINUM(512)|term;
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun))
      return cons(fun,map1(rename_x_to_z_term,CDR(term)));
    else
      return term;
  }
}

SCM rename_x_to_y_term_excl_(cterm)
SCM cterm;
{
  SCM part,el;

  if(ZERO_P(MAKINUM(65536)&CAR(cterm))) {
    for(part=CDR(cterm);!(NULL_P(part));part=CDR(part)) {
      el=CAR(part);
      if(!(NUMBER_P(el)))
        rename_x_to_y_term_excl_(el);
      else
      if(MAKINUM(65535)>el) {
        SET_CAR(part,MAKINUM(256)|el);
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM rename_y_to_x_term_excl_(cterm)
SCM cterm;
{
  SCM part,el;

  if(ZERO_P(MAKINUM(65536)&CAR(cterm))) {
    for(part=CDR(cterm);!(NULL_P(part));part=CDR(part)) {
      el=CAR(part);
      if(!(NUMBER_P(el)))
        rename_y_to_x_term_excl_(el);
      else
      if(MAKINUM(65535)>el) {
        SET_CAR(part,MAKINUM(256^INUM(el)));
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM subst_deco_term(term,litflag)
SCM term,litflag;
{
  SCM part,fun,res,resend,str,new;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return dereference_var(MAKINUM(8191)&term);
    else
    if(NFALSEP(GLOBAL(demodulate_constants_flag_global)))
      return demodulate_constant(term);
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(NFALSEP(GLOBAL(new_demodulators_flag_global))||ZERO_P(MAKINUM(65536)&fun)) {
      if(GLOBAL(case_fun_nr_global)==(MAKINUM(534773760)&fun))
        return subst_deco_case_term(term);
      else {
        res=cons(EOL,EOL);
        resend=res;
        str=MAKINUM(65536);
        for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
          new=subst_deco_term(CAR(part),BOOL_F);
          SET_CDR(resend,cons(new,EOL));
          if(resend==res) {
            if(NUMBER_P(new)) {
              if(MAKINUM(65535)>new) {
                str=GLOBAL(var_strength_global);
              }
              else {
                str=GLOBAL(const_strength_global);
              }
            }
            else {
              str=CAR(new);
            }
          }
          else
          if(NUMBER_P(new)) {
            if(MAKINUM(65535)>new) {
              str=sum_fun_strengths(GLOBAL(var_strength_global),str);
            }
            else {
              str=sum_fun_strengths(GLOBAL(const_strength_global),str);
            }
          }
          else {
            str=sum_fun_strengths(CAR(new),str);
          }
          resend=CDR(resend);
        }
        SET_CAR(res,create_new_fun_pos_object(fun,str));
        if(NFALSEP(GLOBAL(demodulate_flag_global))&&!(NFALSEP(litflag)))
          return demodulate_composite(res);
        else
        if(NFALSEP(litflag)&&NFALSEP(GLOBAL(demodulate_lit_flag_global)))
          return demodulate_lit(res);
        else
          return res;
      }
    }
    else
      return term;
  }
}

SCM deco_leading_fun(term)
SCM term;
{
  SCM str,new,fun,part;

  fun=CAR(term);
  new=EOL;
  str=MAKINUM(65536);
  for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
    new=CAR(part);
    if(part==CDR(term)) {
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=GLOBAL(var_strength_global);
        }
        else {
          str=GLOBAL(const_strength_global);
        }
      }
      else {
        str=CAR(new);
      }
    }
    else
    if(NUMBER_P(new)) {
      if(MAKINUM(65535)>new) {
        str=sum_fun_strengths(GLOBAL(var_strength_global),str);
      }
      else {
        str=sum_fun_strengths(GLOBAL(const_strength_global),str);
      }
    }
    else {
      str=sum_fun_strengths(CAR(new),str);
    }
  }
  return cons(create_new_fun_pos_object(fun,str),CDR(term));
}

SCM subst_deco_term_nodemodulate(term,litflag)
SCM term,litflag;
{
  SCM tmp1,tmp2,tmp3,tmp4,res;

  tmp1=GLOBAL(demodulate_flag_global);
  tmp2=GLOBAL(demodulate_lit_flag_global);
  tmp3=GLOBAL(demodulate_constants_flag_global);
  tmp4=GLOBAL(new_demodulators_flag_global);
  res=EOL;
  GLOBAL(demodulate_flag_global)=BOOL_F;
  GLOBAL(demodulate_lit_flag_global)=BOOL_F;
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  GLOBAL(new_demodulators_flag_global)=BOOL_F;
  res=subst_deco_term(term,litflag);
  GLOBAL(demodulate_flag_global)=tmp1;
  GLOBAL(demodulate_lit_flag_global)=tmp2;
  GLOBAL(demodulate_constants_flag_global)=tmp3;
  GLOBAL(new_demodulators_flag_global)=tmp4;
  return res;
}

SCM subst_deco_case_term(caseterm)
SCM caseterm;
{
  SCM tmp,successres,value,caselist;

  value=subst_deco_term(CAR(CDR(caseterm)),BOOL_F);
  successres=BOOL_F;
  tmp=EOL;
  for(caselist=CAR(CDR(CDR(caseterm)));!(!(!(NUMBER_P(caselist)))||NFALSEP(successres));caselist=CAR(CDR(CDR(CDR(caselist))))) {
    tmp=subst_deco_term(CAR(CDR(caselist)),BOOL_F);
    tmp=subsumed_term_ordinary_collectvars_pred_(value,tmp);
    if(NFALSEP(CAR(tmp))) {
      successres=subst_deco_term(CAR(CDR(CDR(caselist))),BOOL_F);
      clear_varlist(CDR(tmp));
    }
    else
      clear_varlist(CDR(tmp));
  }
  if(NFALSEP(successres))
    return successres;
  else
    return deco_leading_fun(cons(GLOBAL(case_fun_nr_global),cons(value,cons(subst_deco_term(CAR(CDR(CDR(caseterm))),BOOL_F),EOL))));
}

SCM clear_varlist(lst)
SCM lst;
{
  SCM lstpart;

  for(lstpart=lst;!(NULL_P(lstpart));lstpart=CDR(lstpart)) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&CAR(lstpart),MAKINUM(99999999));
  }
  return UNSPECIFIED;
}

SCM subst_deco_term_nodemodulate_spec(term)
SCM term;
{
  SCM part,fun,res,resend,str,new;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return dereference_var(MAKINUM(8191)&term);
    else
      return term;
  }
  else {
    fun=CAR(term);
    if(ZERO_P(MAKINUM(65536)&fun)) {
      res=cons(EOL,EOL);
      resend=res;
      str=MAKINUM(65536);
      for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
        new=subst_deco_term_nodemodulate_spec(CAR(part));
        SET_CDR(resend,cons(new,EOL));
        if(resend==res) {
          if(NUMBER_P(new)) {
            if(MAKINUM(65535)>new) {
              str=GLOBAL(var_strength_global);
            }
            else {
              str=GLOBAL(const_strength_global);
            }
          }
          else {
            str=CAR(new);
          }
        }
        else
        if(NUMBER_P(new)) {
          if(MAKINUM(65535)>new) {
            str=sum_fun_strengths(GLOBAL(var_strength_global),str);
          }
          else {
            str=sum_fun_strengths(GLOBAL(const_strength_global),str);
          }
        }
        else {
          str=sum_fun_strengths(CAR(new),str);
        }
        resend=CDR(resend);
      }
      SET_CAR(res,create_new_fun_pos_object(fun,str));
      return res;
    }
    else
      return term;
  }
}

SCM subst_deco_replace_term(term,path,replterm,litflag)
SCM term,path,replterm,litflag;
{
  SCM str,new,resend,res,nr,fun,part,nrpart;

  if(NULL_P(path))
    return subst_deco_term(replterm,litflag);
  else
  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return dereference_var(MAKINUM(8191)&term);
    else
    if(NFALSEP(GLOBAL(demodulate_constants_flag_global)))
      return demodulate_constant(term);
    else
      return term;
  }
  else {
    fun=CAR(term);
    nr=CAR(path);
    res=cons(EOL,EOL);
    resend=res;
    new=EOL;
    str=MAKINUM(65536);
    for(part=CDR(term),nrpart=MAKINUM(INUM(nr)-1);
        !(NULL_P(part));
        part=CDR(part),nrpart=MAKINUM(INUM(nrpart)-1)) {
      if(ZERO_P(nrpart)) {
        new=subst_deco_replace_term(CAR(part),CDR(path),replterm,BOOL_F);
      }
      else {
        new=subst_deco_term(CAR(part),BOOL_F);
      }
      SET_CDR(resend,cons(new,EOL));
      if(resend==res) {
        if(NUMBER_P(new)) {
          if(MAKINUM(65535)>new) {
            str=GLOBAL(var_strength_global);
          }
          else {
            str=GLOBAL(const_strength_global);
          }
        }
        else {
          str=CAR(new);
        }
      }
      else
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=sum_fun_strengths(GLOBAL(var_strength_global),str);
        }
        else {
          str=sum_fun_strengths(GLOBAL(const_strength_global),str);
        }
      }
      else {
        str=sum_fun_strengths(CAR(new),str);
      }
      resend=CDR(resend);
    }
    SET_CAR(res,create_new_fun_pos_object(fun,str));
    if(NFALSEP(GLOBAL(demodulate_flag_global))&&!(NFALSEP(litflag)))
      return demodulate_composite(res);
    else
    if(NFALSEP(litflag)&&NFALSEP(GLOBAL(demodulate_lit_flag_global)))
      return demodulate_lit(res);
    else
      return res;
  }
}

SCM subst_deco_replace_term_nodemodulate(term,path,replterm,litflag)
SCM term,path,replterm,litflag;
{
  SCM tmp1,tmp2,tmp3,tmp4,res;

  tmp1=GLOBAL(demodulate_flag_global);
  tmp2=GLOBAL(demodulate_lit_flag_global);
  tmp3=GLOBAL(demodulate_constants_flag_global);
  tmp4=GLOBAL(new_demodulators_flag_global);
  res=EOL;
  GLOBAL(demodulate_flag_global)=BOOL_F;
  GLOBAL(demodulate_lit_flag_global)=BOOL_F;
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  GLOBAL(new_demodulators_flag_global)=BOOL_F;
  res=subst_deco_replace_term(term,path,replterm,litflag);
  GLOBAL(demodulate_flag_global)=tmp1;
  GLOBAL(demodulate_lit_flag_global)=tmp2;
  GLOBAL(demodulate_constants_flag_global)=tmp3;
  GLOBAL(new_demodulators_flag_global)=tmp4;
  return res;
}

SCM replace_subterm(term,path,replterm)
SCM term,path,replterm;
{
  SCM str,new,resend,res,nr,fun,part,nrpart;

  if(NULL_P(path))
    return replterm;
  else
  if(NUMBER_P(term))
    return term;
  else {
    fun=CAR(term);
    nr=CAR(path);
    res=cons(EOL,EOL);
    resend=res;
    new=EOL;
    str=MAKINUM(65536);
    for(part=CDR(term),nrpart=MAKINUM(INUM(nr)-1);
        !(NULL_P(part));
        part=CDR(part),nrpart=MAKINUM(INUM(nrpart)-1)) {
      if(ZERO_P(nrpart)) {
        new=replace_subterm(CAR(part),CDR(path),replterm);
      }
      else {
        new=CAR(part);
      }
      SET_CDR(resend,cons(new,EOL));
      if(resend==res) {
        if(NUMBER_P(new)) {
          if(MAKINUM(65535)>new) {
            str=GLOBAL(var_strength_global);
          }
          else {
            str=GLOBAL(const_strength_global);
          }
        }
        else {
          str=CAR(new);
        }
      }
      else
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=sum_fun_strengths(GLOBAL(var_strength_global),str);
        }
        else {
          str=sum_fun_strengths(GLOBAL(const_strength_global),str);
        }
      }
      else {
        str=sum_fun_strengths(CAR(new),str);
      }
      resend=CDR(resend);
    }
    SET_CAR(res,create_new_fun_pos_object(fun,str));
    return res;
  }
}

SCM subterm_at_path(term,path)
SCM term,path;
{
  SCM nrpart,termpart,tmp_var1,tmp_var2;

tailrecursion:
  if(NULL_P(path))
    return term;
  else {
    for(termpart=term,nrpart=CAR(path);
        !(ZERO_P(nrpart));
        termpart=CDR(termpart),nrpart=MAKINUM(INUM(nrpart)-1)) ;
    tmp_var1=CAR(termpart);
    tmp_var2=CDR(path);
    term=tmp_var1;
    path=tmp_var2;
    goto tailrecursion;
  }
}

SCM subst_deco_weight_term(term,depth,scope)
SCM term,depth,scope;
{
  SCM str,weight__2,part,resend,res__1,weight,res,fun,failflag,newpair,new,weight__3;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      res=dereference_var(MAKINUM(8191)&term);
    else
      res=term;
    weight=compute_term_weight(res,depth,scope);
    if(INTEGER_P(weight))
      return cons(weight,res);
    else
      return BOOL_F;
  }
  else {
    fun=CAR(term);
    failflag=BOOL_F;
    if(ZERO_P(MAKINUM(65536)&fun)) {
      res__1=cons(EOL,EOL);
      resend=res__1;
      part=CDR(term);
      weight__2=MAKINUM(0);
      str=MAKINUM(65536);
      for(;!(NULL_P(part));) {
        newpair=subst_deco_weight_term(CAR(part));
        new=CDR(newpair);
        weight__3=CAR(newpair);
        if(INTEGER_P(weight__3)) {
          SET_CDR(resend,cons(new,EOL));
          if(resend==res__1) {
            if(NUMBER_P(new)) {
              if(MAKINUM(65535)>new) {
                str=GLOBAL(var_strength_global);
              }
              else {
                str=GLOBAL(const_strength_global);
              }
            }
            else {
              str=CAR(new);
            }
          }
          else
          if(NUMBER_P(new)) {
            if(MAKINUM(65535)>new) {
              str=sum_fun_strengths(GLOBAL(var_strength_global),str);
            }
            else {
              str=sum_fun_strengths(GLOBAL(const_strength_global),str);
            }
          }
          else {
            str=sum_fun_strengths(CAR(new),str);
          }
          resend=CDR(resend);
          part=CDR(part);
        }
        else {
          part=EOL;
          failflag=BOOL_T;
        }
      }
      if(NFALSEP(failflag))
        return BOOL_F;
      else {
        SET_CAR(res__1,create_new_fun_pos_object(fun,str));
        return cons(weight__2,res__1);
      }
    }
    else
      return UNSPECIFIED;
  }
}

SCM compute_term_weight(x,y,z)
SCM x,y,z;
{
  return MAKINUM(0);
}

SCM sum_fun_strengths(fnx,fny)
SCM fnx,fny;
{
  SCM newmaxplusnr,newmaxplusnr__1;

  return ((MAKINUM(65536)&fnx)&(MAKINUM(65536)&fny))|((((MAKINUM(63488)&fnx)>(MAKINUM(63488)&fny)) ? (MAKINUM(63488)&fnx) : (MAKINUM(63488)&fny))|((newmaxplusnr=MAKINUM(INUM(MAKINUM(2047)&fnx)+INUM(MAKINUM(2047)&fny)),((newmaxplusnr>MAKINUM(2016)) ? MAKINUM(2016) : newmaxplusnr))|(newmaxplusnr__1=MAKINUM(INUM(MAKINUM(31)&fnx)+INUM(MAKINUM(31)&fny)),((newmaxplusnr__1>MAKINUM(31)) ? MAKINUM(31) : newmaxplusnr__1))));
}

SCM create_new_fun_pos_object(oldfun,argsstrn)
SCM oldfun,argsstrn;
{
  SCM newmaxplusnr,newmaxplusnr__1;

  return (MAKINUM(534773760)&oldfun)|(((newmaxplusnr=MAKINUM(2048+INUM(MAKINUM(63488)&argsstrn)),((newmaxplusnr>MAKINUM(63488)) ? MAKINUM(63488) : newmaxplusnr))|(newmaxplusnr__1=MAKINUM(32+INUM(MAKINUM(2016)&argsstrn)),((newmaxplusnr__1>MAKINUM(2016)) ? MAKINUM(2016) : newmaxplusnr__1)))|((MAKINUM(65536)|MAKINUM(31))&argsstrn));
}

SCM collect_vars_composite_excl_(composite)
SCM composite;
{
  SCM el,vars,repeating,fun,comppart,elvars;

  fun=CAR(composite);
  repeating=EOL;
  vars=EOL;
  for(comppart=CDR(composite);!(NULL_P(comppart));comppart=CDR(comppart)) {
    el=CAR(comppart);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        el=(MAKINUM(8191)&el);
        if(!(NFALSEP(memq(el,repeating)))) {
          if(NFALSEP(memq(el,vars))) {
            repeating=cons(el,repeating);
          }
          else {
            vars=cons(el,vars);
          }
        }
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el))) {
      elvars=collect_vars_composite_excl_(el);
      vars=intersection_union(CAR(elvars),CDR(elvars),repeating,vars);
      repeating=GLOBAL(intersection_tmp_global);
    }
  }
  if(!(NULL_P(repeating))) {
    SET_CAR(composite,MAKINUM(131072)|fun);
  }
  return cons(repeating,vars);
}

SCM intersection_union(xrep,xvars,yrep,yvars)
SCM xrep,xvars,yrep,yvars;
{
  SCM tmprep;

  if(NULL_P(yvars)) {
    GLOBAL(intersection_tmp_global)=xrep;
    return xvars;
  }
  else {
    tmprep=union_nonkeyword(xrep,yrep);
    GLOBAL(intersection_tmp_global)=tmprep;
    return intersection_union_aux(xvars,yvars);
  }
}

SCM intersection_union_aux(xvars,yvars)
SCM xvars,yvars;
{
tailrecursion:
  if(NULL_P(xvars))
    return yvars;
  else
  if(NFALSEP(memq(CAR(xvars),yvars))) {
    if(!(NFALSEP(memq(CAR(xvars),GLOBAL(intersection_tmp_global))))) {
      GLOBAL(intersection_tmp_global)=cons(CAR(xvars),GLOBAL(intersection_tmp_global));
    }
    xvars=CDR(xvars);
    goto tailrecursion;
  }
  else
    return cons(CAR(xvars),intersection_union_aux(CDR(xvars),yvars));
}

SCM decorate_vars_lit_excl_(lit,rep_lit_vars,lit_vars,other_lit_vars,foll_lit_vars)
SCM lit,rep_lit_vars,lit_vars,other_lit_vars,foll_lit_vars;
{
  SCM varspart,el,renamed,new;

  if(!(NULL_P(lit_vars))) {
    for(varspart=reverse(lit_vars);!(NULL_P(varspart));varspart=CDR(varspart)) {
      el=CAR(varspart);
      renamed=assq(el,GLOBAL(new_var_names_global));
      new=EOL;
      if(NFALSEP(renamed)) {
        new=(MAKINUM(8191)&CDR(renamed));
      }
      else {
        clause_var_nr_global=MAKINUM(1+INUM(clause_var_nr_global));
        if(clause_var_nr_global>MAKINUM(255)) {
          GLOBAL(too_many_vars_flag_global)=BOOL_T;
        }
        new=clause_var_nr_global;
      }
      if(!(NFALSEP(memq(el,rep_lit_vars)))) {
        new=(MAKINUM(32768)|new);
      }
      if(!(NFALSEP(member_memq_pred_(el,other_lit_vars)))) {
        new=(MAKINUM(16384)|new);
      }
      if(!(NFALSEP(member_memq_pred_(el,foll_lit_vars)))) {
        new=(MAKINUM(8192)|new);
      }
      if(NFALSEP(renamed)) {
        SET_CDR(renamed,new);
      }
      else {
        GLOBAL(new_var_names_global)=cons(cons(el,new),GLOBAL(new_var_names_global));
      }
    }
    return decorate_vars_composite_excl_(lit,GLOBAL(new_var_names_global));
  }
  else
    return UNSPECIFIED;
}

SCM decorate_vars_composite_excl_(composite,alist)
SCM composite,alist;
{
  SCM comppart,el;

  for(comppart=CDR(composite);!(NULL_P(comppart));comppart=CDR(comppart)) {
    el=CAR(comppart);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        SET_CAR(comppart,CDR(assq(MAKINUM(8191)&el,alist)));
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el)))
      decorate_vars_composite_excl_(el,alist);
  }
  return UNSPECIFIED;
}

SCM resolve_unify_ordinary(xfun,yfun,xlit,ylit)
SCM xfun,yfun,xlit,ylit;
{
  SCM ypart,xpart,fail_flag,new_var1;

  if(ZERO_P(MAKINUM(65536)&xfun)) {
    if(ZERO_P(MAKINUM(65536)&yfun)) {
      fail_flag=BOOL_F;
      if(!(ZERO_P(MAKINUM(131072)&xfun)))
        repeatedvars_flag_global=NOT(SBOOL(ZERO_P(MAKINUM(131072)&yfun)));
      else
        repeatedvars_flag_global=BOOL_F;
      occurcheck_flag_global=BOOL_F;
      xvars_set_flag_global=BOOL_F;
      yvars_set_flag_global=BOOL_F;
      for(xpart=CDR(xlit),ypart=CDR(ylit);
          !(NFALSEP(fail_flag)||NULL_P(xpart));
          xpart=CDR(xpart),ypart=CDR(ypart))
        if(!(NFALSEP(resolve_unify_ordinary_aux(CAR(xpart),CAR(ypart))))) {
          fail_flag=BOOL_T;
        }
      return NOT(fail_flag);
    }
    else {
      yvars_set_flag_global=BOOL_F;
      if((MAKINUM(65535)&xfun)>(MAKINUM(65535)&yfun)) {
        xvars_set_flag_global=BOOL_F;
        return BOOL_F;
      }
      else {
        var_set_flag_global=BOOL_F;
        alt_var_set_flag_global=BOOL_F;
        if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(ylit),CDR(xlit)))) {
          xvars_set_flag_global=BOOL_T;
          return BOOL_T;
        }
        else {
          if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            xvars_set_flag_global=BOOL_F;
          }
          return BOOL_F;
        }
      }
    }
  }
  else
  if(ZERO_P(MAKINUM(65536)&yfun)) {
    xvars_set_flag_global=BOOL_F;
    if((MAKINUM(65535)&yfun)>(MAKINUM(65535)&xfun)) {
      yvars_set_flag_global=BOOL_F;
      return BOOL_F;
    }
    else {
      var_set_flag_global=BOOL_F;
      alt_var_set_flag_global=BOOL_F;
      if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(xlit),CDR(ylit)))) {
        yvars_set_flag_global=BOOL_T;
        return BOOL_T;
      }
      else {
        if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
          yvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_F;
        }
        return BOOL_F;
      }
    }
  }
  else {
    xvars_set_flag_global=BOOL_F;
    yvars_set_flag_global=BOOL_F;
    new_var1=SBOOL(CDR(xlit)==CDR(ylit));
    if(NFALSEP(new_var1))
      return new_var1;
    else
    if(NFALSEP(GLOBAL(compare_ground_litcdr_equal_flag_global))) {
      if((MAKINUM(65535)&xfun)==(MAKINUM(65535)&yfun))
        return term_list_equal_pred_(CDR(xlit),CDR(ylit));
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
}

SCM resolve_unify_cutoff(xfun,yfun,xlit,ylit)
SCM xfun,yfun,xlit,ylit;
{
  SCM fail_flag,xpart,ypart;

  if(ZERO_P(MAKINUM(65536)&xfun)) {
    fail_flag=BOOL_F;
    if(!(ZERO_P(MAKINUM(131072)&xfun)))
      repeatedvars_flag_global=NOT(SBOOL(ZERO_P(MAKINUM(131072)&yfun)));
    else
      repeatedvars_flag_global=BOOL_F;
    occurcheck_flag_global=BOOL_F;
    xvars_set_flag_global=BOOL_F;
    yvars_set_flag_global=BOOL_F;
    for(xpart=CDR(xlit),ypart=CDR(ylit);
        !(NFALSEP(fail_flag)||NULL_P(xpart));
        xpart=CDR(xpart),ypart=CDR(ypart))
      if(!(NFALSEP(resolve_unify_cutoff_aux(CAR(xpart),CAR(ypart))))) {
        fail_flag=BOOL_T;
      }
    return NOT(fail_flag);
  }
  else {
    xvars_set_flag_global=BOOL_F;
    if((MAKINUM(65535)&yfun)>(MAKINUM(65535)&xfun)) {
      yvars_set_flag_global=BOOL_F;
      return BOOL_F;
    }
    else {
      var_set_flag_global=BOOL_F;
      alt_var_set_flag_global=BOOL_F;
      if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(xlit),CDR(ylit)))) {
        yvars_set_flag_global=BOOL_T;
        return BOOL_T;
      }
      else {
        if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
          yvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_F;
        }
        return BOOL_F;
      }
    }
  }
}

SCM factor_unify_ordinary(xlit,ylit)
SCM xlit,ylit;
{
  SCM fail_flag,yfun,xfun,xpart,ypart;

  xfun=CAR(xlit);
  yfun=CAR(ylit);
  fail_flag=BOOL_F;
  if((MAKINUM(534773760)&xfun)==(MAKINUM(534773760)&yfun)) {
    if(ZERO_P(MAKINUM(65536)&xfun)) {
      if(ZERO_P(MAKINUM(65536)&yfun)) {
        for(xpart=CDR(xlit),ypart=CDR(ylit);
            !(NFALSEP(fail_flag)||NULL_P(xpart));
            xpart=CDR(xpart),ypart=CDR(ypart))
          if(!(NFALSEP(factor_unify_ordinary_aux(CAR(xpart),CAR(ypart))))) {
            fail_flag=BOOL_T;
          }
        return NOT(fail_flag);
      }
      else
      if((MAKINUM(65535)&xfun)<=(MAKINUM(65535)&yfun))
        return subsumed_term_list_ordinary_pred_(CDR(ylit),CDR(xlit));
      else
        return BOOL_F;
    }
    else
    if(ZERO_P(MAKINUM(65536)&yfun)) {
      if((MAKINUM(65535)&yfun)<=(MAKINUM(65535)&xfun))
        return subsumed_term_list_ordinary_pred_(CDR(xlit),CDR(ylit));
      else
        return BOOL_F;
    }
    else
    if(xfun==yfun)
      return term_list_equal_pred_(CDR(xlit),CDR(ylit));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM resolve_unify_ordinary_aux(xterm,yterm)
SCM xterm,yterm;
{
  SCM fail_flag,yfun,xfun,xpart,ypart;

  if(NUMBER_P(xterm)&&(xterm<=MAKINUM(65535))) {
    xterm=var_val(xterm);
  }
  if(NUMBER_P(yterm)&&(yterm<=MAKINUM(65535))) {
    yterm=var_val(yterm);
  }
  if(NUMBER_P(xterm)) {
    if(NUMBER_P(yterm)) {
      if(xterm==yterm)
        return BOOL_T;
      else
      if(MAKINUM(65535)>yterm) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        if(ZERO_P(MAKINUM(256)&yterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&((MAKINUM(65535)>xterm)&&ZERO_P(MAKINUM(32768)&yterm))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
      if(MAKINUM(65535)>xterm) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        if(ZERO_P(MAKINUM(256)&xterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
        return BOOL_F;
    }
    else
    if(MAKINUM(65535)>xterm) {
      if(NFALSEP(occurcheck_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(yterm))) {
        if(NFALSEP(occur_check_pred_(xterm,yterm)))
          return BOOL_F;
        else {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
          if(ZERO_P(MAKINUM(256)&xterm)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            yvars_set_flag_global=BOOL_T;
          }
          return BOOL_T;
        }
      }
      else {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        if(ZERO_P(MAKINUM(256)&xterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&(ZERO_P(MAKINUM(32768)&xterm)&&ZERO_P(MAKINUM(65536)&CAR(yterm)))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(yterm)) {
    if(MAKINUM(65535)>yterm) {
      if(NFALSEP(occurcheck_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(xterm))) {
        if(NFALSEP(occur_check_pred_(yterm,xterm)))
          return BOOL_F;
        else {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
          if(ZERO_P(MAKINUM(256)&yterm)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            yvars_set_flag_global=BOOL_T;
          }
          return BOOL_T;
        }
      }
      else {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        if(ZERO_P(MAKINUM(256)&yterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&(ZERO_P(MAKINUM(32768)&yterm)&&ZERO_P(MAKINUM(65536)&CAR(xterm)))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else {
    xfun=CAR(xterm);
    yfun=CAR(yterm);
    fail_flag=BOOL_F;
    if((MAKINUM(534773760)&xfun)==(MAKINUM(534773760)&yfun)) {
      if(ZERO_P(MAKINUM(65536)&xfun)||ZERO_P(MAKINUM(65536)&yfun)) {
        for(xpart=CDR(xterm),ypart=CDR(yterm);
            !(NFALSEP(fail_flag)||NULL_P(xpart));
            xpart=CDR(xpart),ypart=CDR(ypart))
          if(!(NFALSEP(resolve_unify_ordinary_aux(CAR(xpart),CAR(ypart))))) {
            fail_flag=BOOL_T;
          }
        return NOT(fail_flag);
      }
      else
        return term_list_equal_pred_(CDR(xterm),CDR(yterm));
    }
    else
      return BOOL_F;
  }
}

SCM resolve_unify_cutoff_aux(xterm,yterm)
SCM xterm,yterm;
{
  SCM fail_flag,yfun,xfun,xpart,ypart;

  if(NUMBER_P(xterm)&&(xterm<=MAKINUM(65535))) {
    xterm=var_val(xterm);
  }
  if((NUMBER_P(yterm)&&(yterm<=MAKINUM(65535)))&&!(ZERO_P(MAKINUM(16384)&yterm))) {
    yterm=var_val(yterm);
  }
  if(NUMBER_P(xterm)) {
    if(NUMBER_P(yterm)) {
      if(xterm==yterm)
        return BOOL_T;
      else
      if((MAKINUM(65535)>yterm)&&!(ZERO_P(MAKINUM(16384)&yterm))) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        if(ZERO_P(MAKINUM(256)&yterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&((MAKINUM(65535)>xterm)&&ZERO_P(MAKINUM(32768)&yterm))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
      if((MAKINUM(65535)>xterm)&&!(ZERO_P(MAKINUM(16384)&xterm))) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        if(ZERO_P(MAKINUM(256)&xterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
        return BOOL_F;
    }
    else
    if((MAKINUM(65535)>xterm)&&!(ZERO_P(MAKINUM(16384)&xterm))) {
      if(NFALSEP(occurcheck_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(yterm))) {
        if(NFALSEP(occur_check_pred_(xterm,yterm)))
          return BOOL_F;
        else {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
          if(ZERO_P(MAKINUM(256)&xterm)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            yvars_set_flag_global=BOOL_T;
          }
          return BOOL_T;
        }
      }
      else {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        if(ZERO_P(MAKINUM(256)&xterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&(ZERO_P(MAKINUM(32768)&xterm)&&ZERO_P(MAKINUM(65536)&CAR(yterm)))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(yterm)) {
    if((MAKINUM(65535)>yterm)&&!(ZERO_P(MAKINUM(16384)&yterm))) {
      if(NFALSEP(occurcheck_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(xterm))) {
        if(NFALSEP(occur_check_pred_(yterm,xterm)))
          return BOOL_F;
        else {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
          if(ZERO_P(MAKINUM(256)&yterm)) {
            xvars_set_flag_global=BOOL_T;
          }
          else {
            yvars_set_flag_global=BOOL_T;
          }
          return BOOL_T;
        }
      }
      else {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        if(ZERO_P(MAKINUM(256)&yterm)) {
          xvars_set_flag_global=BOOL_T;
        }
        else {
          yvars_set_flag_global=BOOL_T;
        }
        if(NFALSEP(repeatedvars_flag_global)&&(ZERO_P(MAKINUM(32768)&yterm)&&ZERO_P(MAKINUM(65536)&CAR(xterm)))) {
          occurcheck_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else {
    xfun=CAR(xterm);
    yfun=CAR(yterm);
    fail_flag=BOOL_F;
    if((MAKINUM(534773760)&xfun)==(MAKINUM(534773760)&yfun)) {
      if(ZERO_P(MAKINUM(65536)&xfun)||ZERO_P(MAKINUM(65536)&yfun)) {
        for(xpart=CDR(xterm),ypart=CDR(yterm);
            !(NFALSEP(fail_flag)||NULL_P(xpart));
            xpart=CDR(xpart),ypart=CDR(ypart))
          if(!(NFALSEP(resolve_unify_cutoff_aux(CAR(xpart),CAR(ypart))))) {
            fail_flag=BOOL_T;
          }
        return NOT(fail_flag);
      }
      else
        return term_list_equal_pred_(CDR(xterm),CDR(yterm));
    }
    else
      return BOOL_F;
  }
}

SCM factor_unify_ordinary_aux(xterm,yterm)
SCM xterm,yterm;
{
  SCM fail_flag,yfun,xfun,xpart,ypart;

  if(NUMBER_P(xterm)&&(xterm<=MAKINUM(65535))) {
    xterm=var_val(xterm);
  }
  if(NUMBER_P(yterm)&&(yterm<=MAKINUM(65535))) {
    yterm=var_val(yterm);
  }
  if(NUMBER_P(xterm)) {
    if(NUMBER_P(yterm)) {
      if(xterm==yterm)
        return BOOL_T;
      else
      if(MAKINUM(65535)>xterm) {
        if((MAKINUM(65535)>yterm)&&((MAKINUM(8191)&xterm)==(MAKINUM(8191)&yterm)))
          return BOOL_T;
        else {
          fac_vars_set_global=BOOL_T;
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
          return BOOL_T;
        }
      }
      else
      if(MAKINUM(65535)>yterm) {
        fac_vars_set_global=BOOL_T;
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        return BOOL_T;
      }
      else
        return BOOL_F;
    }
    else
    if(MAKINUM(65535)>xterm) {
      if(ZERO_P(MAKINUM(65536)&CAR(yterm))) {
        if(NFALSEP(factor_occur_check_pred_(MAKINUM(8191)&xterm,yterm)))
          return BOOL_F;
        else {
          fac_vars_set_global=BOOL_T;
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
          return BOOL_T;
        }
      }
      else {
        fac_vars_set_global=BOOL_T;
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&xterm,yterm);
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(yterm)) {
    if(MAKINUM(65535)>yterm) {
      if(ZERO_P(MAKINUM(65536)&CAR(xterm))) {
        if(NFALSEP(factor_occur_check_pred_(MAKINUM(8191)&yterm,xterm)))
          return BOOL_F;
        else {
          fac_vars_set_global=BOOL_T;
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
          return BOOL_T;
        }
      }
      else {
        fac_vars_set_global=BOOL_T;
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&yterm,xterm);
        return BOOL_T;
      }
    }
    else
      return BOOL_F;
  }
  else {
    xfun=CAR(xterm);
    yfun=CAR(yterm);
    fail_flag=BOOL_F;
    if((MAKINUM(534773760)&xfun)==(MAKINUM(534773760)&yfun)) {
      if(ZERO_P(MAKINUM(65536)&xfun)||ZERO_P(MAKINUM(65536)&yfun)) {
        for(xpart=CDR(xterm),ypart=CDR(yterm);
            !(NFALSEP(fail_flag)||NULL_P(xpart));
            xpart=CDR(xpart),ypart=CDR(ypart))
          if(!(NFALSEP(factor_unify_ordinary_aux(CAR(xpart),CAR(ypart))))) {
            fail_flag=BOOL_T;
          }
        return NOT(fail_flag);
      }
      else
        return term_list_equal_pred_(CDR(xterm),CDR(yterm));
    }
    else
      return BOOL_F;
  }
}

SCM occur_check_pred_(var,composite)
SCM var,composite;
{
  SCM el;

  composite=CDR(composite);
  for(;!(NULL_P(composite));) {
    el=CAR(composite);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        el=var_val(el);
        if((var==el)||(!(NUMBER_P(el))&&(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(occur_check_pred_(var,el))))) {
          composite=EOL;
          var=BOOL_T;
        }
        else {
          composite=CDR(composite);
        }
      }
      else {
        composite=CDR(composite);
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(occur_check_pred_(var,el))) {
      composite=EOL;
      var=BOOL_T;
    }
    else {
      composite=CDR(composite);
    }
  }
  return SBOOL(var==BOOL_T);
}

SCM factor_occur_check_pred_(var,composite)
SCM var,composite;
{
  SCM el;

  composite=CDR(composite);
  for(;!(NULL_P(composite));) {
    el=CAR(composite);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        el=var_val(el);
        if(((NUMBER_P(el)&&(el<=MAKINUM(65535)))&&(var==(MAKINUM(8191)&el)))||(!(NUMBER_P(el))&&(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(factor_occur_check_pred_(var,el))))) {
          composite=EOL;
          var=BOOL_T;
        }
        else {
          composite=CDR(composite);
        }
      }
      else {
        composite=CDR(composite);
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(factor_occur_check_pred_(var,el))) {
      composite=EOL;
      var=BOOL_T;
    }
    else {
      composite=CDR(composite);
    }
  }
  return SBOOL(var==BOOL_T);
}

SCM havealready_clause_pred_(clauseinf,cl)
SCM clauseinf,cl;
{
  SCM part,new_var1,strengthint,predsymbsint,len,strength,pure_strength,foundflag,tmp_subs_list,tmp,glen,new_var2,part1;

  strengthint=CAR(clauseinf);
  predsymbsint=CAR(CDR(clauseinf));
  len=MAKINUM(INUM(MAKINUM(8257536)&strengthint)>>17);
  strength=(MAKINUM(131071)&strengthint);
  pure_strength=(MAKINUM(65535)&strengthint);
  foundflag=BOOL_F;
  tmp_subs_list=CDR(GLOBAL(subsumption_list_global));
  tmp=BOOL_F;
  glen=MAKINUM(0);
  GLOBAL(havealready_timecounter_global)=MAKINUM(1+INUM(GLOBAL(havealready_timecounter_global)));
  if(!(NFALSEP(GLOBAL(classical_synth_stratflag_global)))) {
    cl=remove_ans_literals(cl);
  }
  GLOBAL(gcl_varsstack_global)=EOL;
  tmp=check_nonunit_discr_tree(GLOBAL(nonunit_discr_tree_global),cl);
  if(NFALSEP(tmp)&&(!(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))&&NFALSEP(GLOBAL(sat_strategy_flag_global)))||NFALSEP(strong_subsumed_purecl_pred_(cl,CDR(CAR(tmp)))))) {
    GLOBAL(forward_subsumed_double_nr_global)=MAKINUM(1+INUM(GLOBAL(forward_subsumed_double_nr_global)));
    foundflag=BOOL_T;
    GLOBAL(subsuming_clause_global)=CAR(tmp);
  }
  else {
    if(len<=MAKINUM(2))
      new_var1=NOT(SBOOL(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))&&NFALSEP(GLOBAL(sat_strategy_flag_global))));
    else
      new_var1=BOOL_F;
    if(NFALSEP(new_var1)) ;
    else {
      new_var2=SBOOL(len<=MAKINUM(1));
      if(NFALSEP(new_var2)) ;
      else {
        for(part=GLOBAL(nonunit_res_global);!(NULL_P(part)||NFALSEP(foundflag));part=CDR(part))
          for(part1=CAR(part);!(NULL_P(part1)||NFALSEP(foundflag));part1=CDR(part1))
            if(!(CAR(CAR(part1))==GLOBAL(havealready_timecounter_global))) {
              SET_CAR(CAR(part1),GLOBAL(havealready_timecounter_global));
              if(NFALSEP(GLOBAL(prohibit_subs_clnr_global))&&(CAR(CDR(CDR(CDR(CDR(CAR(CDR(CAR(part1))))))))==GLOBAL(prohibit_subs_clnr_global)))
                BOOL_F;
              else {
                foundflag=subsumed_clause_aux_pred_(cl,CDR(CAR(part1)),MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(CDR(CAR(part1)))))>>17),len,strength,predsymbsint,CDR(CDR(CDR(CDR(CAR(part1))))));
              }
            }
        if(NFALSEP(foundflag)) {
          GLOBAL(forward_subsumed_overdouble_nr_global)=MAKINUM(1+INUM(GLOBAL(forward_subsumed_overdouble_nr_global)));
        }
      }
    }
  }
  return foundflag;
}

SCM subsumed_clause_pred_(scl,gcl)
SCM scl,gcl;
{
  SCM gmaxvar,foundflag,glit,len,glen,part;

  len=MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(scl)))>>17);
  glen=MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(gcl)))>>17);
  if(glen==MAKINUM(1)) {
    glit=CAR(CDR(gcl));
    foundflag=BOOL_F;
    gmaxvar=give_cl_maxvar(CAR(gcl));
    for(part=CDR(scl);!(NULL_P(part)||NFALSEP(foundflag));part=CDR(part))
      if(NFALSEP(subsumed_literal_pred_(CAR(part),glit,gmaxvar))) {
        foundflag=BOOL_T;
      }
    return foundflag;
  }
  else
    return subsumed_clause_aux_pred_(CDR(scl),gcl,glen,len,MAKINUM(131071)&CAR(CAR(scl)),CAR(CDR(CAR(scl))),CDR(gcl));
}

SCM subsumed_literal_pred_(slit,glit,gmaxvar)
SCM slit,glit,gmaxvar;
{
  SCM foundflag,gfun,new_var1;

  gfun=CAR(glit);
  foundflag=BOOL_F;
  if(((MAKINUM(534773760)&CAR(slit))==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&CAR(slit))>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&CAR(slit))>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&CAR(slit))>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&CAR(slit))>=(MAKINUM(31)&gfun)))))) {
    if(ZERO_P(MAKINUM(65536)&gfun)) {
      var_set_flag_global=BOOL_F;
      alt_var_set_flag_global=BOOL_F;
      if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))) {
        foundflag=BOOL_T;
      }
      else
      if(NFALSEP(commutative_fun_pred_(MAKINUM(534773760)&gfun))) {
        clear_x_vars_excl_(gmaxvar);
        if(NFALSEP(swapped_subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))) {
          foundflag=BOOL_T;
        }
      }
      if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
        clear_x_vars_excl_(gmaxvar);
        var_set_flag_global=BOOL_F;
        alt_var_set_flag_global=BOOL_F;
      }
    }
    else {
      new_var1=term_list_equal_pred_(CDR(slit),CDR(glit));
      if(NFALSEP(new_var1)) ;
      else
      if(NFALSEP(commutative_fun_pred_(MAKINUM(534773760)&gfun)))
        swapped_term_list_equal_pred_(CDR(slit),CDR(glit));
      else
        BOOL_F;
    }
  }
  return foundflag;
}

SCM subsumed_clause_aux_pred_(cl,gfcl,glen,len,strength,predsymbsint,gcl_fastlits)
SCM cl,gfcl,glen,len,strength,predsymbsint,gcl_fastlits;
{
  SCM ginf,gstrength,gclpreds,tmpres,foundflag;

  ginf=CAR(gfcl);
  gstrength=(MAKINUM(131071)&CAR(ginf));
  gclpreds=CAR(CDR(ginf));
  tmpres=EOL;
  foundflag=BOOL_F;
  GLOBAL(subs_tried_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_tried_nr_global)));
  if(len==glen) {
    if(gstrength>strength) {
      GLOBAL(subs_length_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_length_fail_nr_global)));
      GLOBAL(stopsubsuming_flag_global)=BOOL_T;
    }
    else
    if(!(gclpreds==predsymbsint)) {
      GLOBAL(subs_gclpreds_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_gclpreds_fail_nr_global)));
    }
    else
    if(!(NFALSEP(bigger_strength_aux_pred_(strength,gstrength)))) {
      GLOBAL(subs_aux_strength_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_aux_strength_fail_nr_global)));
    }
    else
    if(NFALSEP(funlist_can_subsume_pred_(cl,gcl_fastlits,len,glen))) {
      if(ZERO_P(MAKINUM(65536)&gstrength)) {
        GLOBAL(subs_reg_subs_tried_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_reg_subs_tried_nr_global)));
        gcl_maxvar_global=give_cl_maxvar(ginf);
        if(NFALSEP(GLOBAL(sat_strategy_flag_global))&&NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))) {
          tmpres=strong_subsumed_purecl_pred_(cl,CDR(gfcl));
        }
        else {
          tmpres=subsumed_pure_clause_aux_pred_(cl,CDR(gfcl),BOOL_F,EOL,BOOL_F);
        }
        if(!(NFALSEP(tmpres))) {
          GLOBAL(subs_reg_subs_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_reg_subs_fail_nr_global)));
        }
        else {
          foundflag=BOOL_T;
          GLOBAL(subsuming_clause_global)=gfcl;
          GLOBAL(stopsubsuming_flag_global)=BOOL_T;
          clear_gcl_vars();
          GLOBAL(gcl_varsstack_global)=EOL;
        }
      }
      else {
        foundflag=BOOL_T;
        GLOBAL(subsuming_clause_global)=gfcl;
        GLOBAL(stopsubsuming_flag_global)=BOOL_T;
      }
    }
  }
  else
  if((MAKINUM(65535)&gstrength)>(MAKINUM(65535)&strength)) {
    GLOBAL(subs_strength_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_strength_fail_nr_global)));
    if(!(ZERO_P(MAKINUM(65536)&gstrength))) {
      GLOBAL(stopsubsuming_flag_global)=BOOL_T;
    }
  }
  else
  if(!(gclpreds==(gclpreds&predsymbsint))) {
    GLOBAL(subs_gclpreds_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_gclpreds_fail_nr_global)));
  }
  else
  if(!(NFALSEP(bigger_strength_aux_aux_pred_(strength,gstrength)))) {
    GLOBAL(subs_aux_strength_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_aux_strength_fail_nr_global)));
  }
  else
  if(!(NFALSEP(funlist_can_subsume_pred_(cl,gcl_fastlits,len,glen)))) {
    GLOBAL(subs_funlist_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_funlist_fail_nr_global)));
  }
  else
  if(ZERO_P(MAKINUM(65536)&gstrength)) {
    GLOBAL(subs_reg_subs_tried_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_reg_subs_tried_nr_global)));
    gcl_maxvar_global=give_cl_maxvar(ginf);
    if(NFALSEP(GLOBAL(sat_strategy_flag_global))&&NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))) {
      tmpres=strong_subsumed_purecl_pred_(cl,CDR(gfcl));
    }
    else {
      tmpres=subsumed_pure_clause_aux_pred_(cl,CDR(gfcl),BOOL_F,EOL,BOOL_F);
    }
    if(!(NFALSEP(tmpres))) {
      GLOBAL(subs_reg_subs_fail_nr_global)=MAKINUM(1+INUM(GLOBAL(subs_reg_subs_fail_nr_global)));
    }
    else {
      foundflag=BOOL_T;
      GLOBAL(subsuming_clause_global)=gfcl;
      GLOBAL(stopsubsuming_flag_global)=BOOL_T;
      clear_gcl_vars();
      GLOBAL(gcl_varsstack_global)=EOL;
    }
  }
  else {
    foundflag=BOOL_T;
    GLOBAL(subsuming_clause_global)=gfcl;
    GLOBAL(stopsubsuming_flag_global)=BOOL_T;
  }
  return foundflag;
}

SCM strong_subsumed_purecl_pred_(scl,gcl)
SCM scl,gcl;
{
  SCM fail_flag,gfun,glit,gpart;

  glit=CAR(gcl);
  gfun=CAR(glit);
  fail_flag=BOOL_F;
  for(gpart=gcl;!(NULL_P(gpart)||NFALSEP(fail_flag));gpart=CDR(gpart))
    if(!(NFALSEP(some_pred__inst1(glit,gfun,strong_subsumed_purecl_pred__fn2,scl)))) {
      fail_flag=BOOL_T;
    }
  return NOT(fail_flag);
}

SCM strong_subsumed_purecl_pred__fn2(glit,gfun,lit)
SCM glit,gfun,lit;
{
  return SBOOL((gfun==CAR(lit))&&NFALSEP(term_equal_strong_pred_(glit,CAR(lit))));
}

SCM back_subsume(clauseinf,cl)
SCM clauseinf,cl;
{
  SCM sclinf,scl__2,sfun,slit,scl,littail,purefn,last_part,tmp_part,slen,tmp_subs_list,foundflag,clmaxvar,pure_strength,strength,len,predsymbsint,strengthint,subs_part,part,part__1,new_var1;

  strengthint=CAR(clauseinf);
  predsymbsint=CAR(CDR(clauseinf));
  len=MAKINUM(INUM(MAKINUM(8257536)&strengthint)>>17);
  strength=(MAKINUM(131071)&strengthint);
  pure_strength=(MAKINUM(65535)&strengthint);
  clmaxvar=give_cl_maxvar(clauseinf);
  foundflag=BOOL_F;
  tmp_subs_list=CDR(GLOBAL(subsumption_list_global));
  slen=MAKINUM(0);
  tmp_part=EOL;
  last_part=EOL;
  if(!(NFALSEP(GLOBAL(classical_synth_stratflag_global)))) {
    cl=remove_ans_literals(cl);
  }
  gcl_maxvar_global=clmaxvar;
  GLOBAL(subsumed_clauses_global)=EOL;
  GLOBAL(gcl_varsstack_global)=EOL;
  for(;!(NULL_P(tmp_subs_list)||(CAR(CAR(tmp_subs_list))>=len));) {
    tmp_subs_list=CDR(tmp_subs_list);
  }
  for(subs_part=tmp_subs_list;!(NULL_P(subs_part));subs_part=CDR(subs_part)) {
    slen=CAR(CAR(subs_part));
    last_part=CAR(subs_part);
    tmp_part=CDR(last_part);
    var_set_flag_global=BOOL_F;
    alt_var_set_flag_global=BOOL_F;
    clear_x_vars_excl_(clmaxvar);
    GLOBAL(gcl_varsstack_global)=EOL;
    if(slen==MAKINUM(1)) {
      purefn=(MAKINUM(534773760)&CAR(CAR(cl)));
      littail=CDR(CAR(cl));
      for(part=tmp_part;!(NULL_P(part)||(pure_strength>(MAKINUM(65535)&CAR(CAR(CAR(part))))));part=CDR(part)) {
        scl=CAR(part);
        slit=CAR(CDR(scl));
        sfun=CAR(slit);
        if((purefn==(MAKINUM(534773760)&sfun))&&NFALSEP(bigger_strength_pred_(sfun,strengthint))) {
          if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(slit),littail))) {
            SET_CDR(last_part,CDR(part));
            GLOBAL(subsumed_clauses_global)=cons(scl,GLOBAL(subsumed_clauses_global));
            if(NFALSEP(commutative_fun_pred_(purefn))) {
              if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
                clear_x_vars_excl_(clmaxvar);
                var_set_flag_global=BOOL_F;
                alt_var_set_flag_global=BOOL_F;
              }
              if(NFALSEP(swapped_subsumed_term_list_ordinary_pred_(CDR(slit),littail))) {
                SET_CDR(last_part,CDR(part));
                GLOBAL(subsumed_clauses_global)=cons(scl,GLOBAL(subsumed_clauses_global));
              }
            }
          }
          if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
            clear_x_vars_excl_(clmaxvar);
            var_set_flag_global=BOOL_F;
            alt_var_set_flag_global=BOOL_F;
          }
        }
        if(CDR(last_part)==part) {
          last_part=part;
        }
      }
    }
    else
      for(part__1=tmp_part;!(NULL_P(part__1)||(pure_strength>(MAKINUM(65535)&CAR(CAR(CAR(part__1))))));part__1=CDR(part__1)) {
        scl__2=CAR(part__1);
        sclinf=CAR(scl__2);
        if(NFALSEP(((len==slen) ? bigger_strength_pred_(CAR(sclinf),strength) : bigger_strength_aux_pred_(CAR(sclinf),strength)))) {
          if(NFALSEP(((len==slen) ? SBOOL(predsymbsint==CAR(CDR(sclinf))) : SBOOL(predsymbsint==(CAR(CDR(sclinf))&predsymbsint))))) {
            if(NFALSEP(funlist_can_subsume_pred_(CDR(scl__2),cl,slen,len))) {
              if(ZERO_P(MAKINUM(65536)&strengthint)) {
                if(NFALSEP(subsumed_pure_clause_aux_pred_(CDR(scl__2),cl,BOOL_F,EOL,BOOL_F))) {
                  SET_CDR(last_part,CDR(part__1));
                  GLOBAL(subsumed_clauses_global)=cons(scl__2,GLOBAL(subsumed_clauses_global));
                  clear_gcl_vars();
                  GLOBAL(gcl_varsstack_global)=EOL;
                }
              }
              else {
                SET_CDR(last_part,CDR(part__1));
                GLOBAL(subsumed_clauses_global)=cons(scl__2,GLOBAL(subsumed_clauses_global));
              }
            }
          }
        }
        if(CDR(last_part)==part__1) {
          last_part=part__1;
        }
      }
  }
  new_var1=SBOOL(NULL_P(GLOBAL(subsumed_clauses_global)));
  if(NFALSEP(new_var1)) ;
  else
  if(GLOBAL(display_info_level_global)>=MAKINUM(63)) {
    newline(cur_output_port());
    display(const_1,cur_output_port());
    newline(cur_output_port());
    for_each1(back_subsume_fn5,GLOBAL(subsumed_clauses_global));
    newline(cur_output_port());
  }
  else
  if(NFALSEP(GLOBAL(display_info_char_flag_global)))
    display(const_2,cur_output_port());
  for_each1(back_subsume_fn6,GLOBAL(subsumed_clauses_global));
  GLOBAL(subsumed_clauses_global)=EOL;
  return UNSPECIFIED;
}

SCM back_subsume_fn6(x)
SCM x;
{
  GLOBAL(back_subsumed_nr_global)=MAKINUM(1+INUM(GLOBAL(back_subsumed_nr_global)));
  SET_CAR(CAR(x),MAKINUM(65535^INUM(MAKINUM(65535)|CAR(CAR(x)))));
  return UNSPECIFIED;
}

SCM back_subsume_fn5(x)
SCM x;
{
  print_full_clause(x);
  return newline(cur_output_port());
}

SCM bigger_strength_pred_(sclstrength,gclstrength)
SCM sclstrength,gclstrength;
{
  if((MAKINUM(131071)&sclstrength)>=(MAKINUM(131071)&gclstrength)) {
    if((MAKINUM(65535)&sclstrength)>=(MAKINUM(65535)&gclstrength)) {
      if((MAKINUM(2047)&sclstrength)>=(MAKINUM(2047)&gclstrength))
        return SBOOL((MAKINUM(31)&sclstrength)>=(MAKINUM(31)&gclstrength));
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM bigger_strength_aux_pred_(sclstrength,gclstrength)
SCM sclstrength,gclstrength;
{
  if((MAKINUM(65535)&sclstrength)>=(MAKINUM(65535)&gclstrength)) {
    if((MAKINUM(2047)&sclstrength)>=(MAKINUM(2047)&gclstrength))
      return SBOOL((MAKINUM(31)&sclstrength)>=(MAKINUM(31)&gclstrength));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM bigger_strength_aux_aux_pred_(sclstrength,gclstrength)
SCM sclstrength,gclstrength;
{
  if((MAKINUM(2047)&sclstrength)>=(MAKINUM(2047)&gclstrength))
    return SBOOL((MAKINUM(31)&sclstrength)>=(MAKINUM(31)&gclstrength));
  else
    return BOOL_F;
}

SCM funlist_can_subsume_pred_(scl,gcl,slen,glen)
SCM scl,gcl,slen,glen;
{
  SCM gfun1,glit1,slit1,sfun1;

  if(NFALSEP(GLOBAL(classical_synth_stratflag_global))) {
    glit1=CAR(gcl);
    gfun1=CAR(glit1);
    if(NFALSEP(answer_pred_pred_(gfun1))) {
      slit1=CAR(scl);
      sfun1=CAR(slit1);
      if(NFALSEP(answer_pred_pred_(sfun1))) {
        if(ZERO_P(MAKINUM(65536)&gfun1)) {
          if(((MAKINUM(534773760)&sfun1)==(MAKINUM(534773760)&gfun1))&&(((MAKINUM(131071)&sfun1)>=(MAKINUM(131071)&gfun1))&&(((MAKINUM(65535)&sfun1)>=(MAKINUM(65535)&gfun1))&&(((MAKINUM(2047)&sfun1)>=(MAKINUM(2047)&gfun1))&&((MAKINUM(31)&sfun1)>=(MAKINUM(31)&gfun1))))))
            return funlist_can_subsume_aux_pred_(CDR(scl),CDR(gcl));
          else
            return BOOL_F;
        }
        else
        if(NFALSEP(composite_equal_pred_(glit1,slit1)))
          return funlist_can_subsume_aux_pred_(CDR(scl),CDR(gcl));
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
    else
    if(NFALSEP(answer_pred_pred_(CAR(CAR(scl))))) {
      if(slen==glen)
        return BOOL_F;
      else
        return funlist_can_subsume_aux_pred_(CDR(scl),gcl);
    }
    else
      return funlist_can_subsume_aux_pred_(scl,gcl);
  }
  else
    return funlist_can_subsume_aux_pred_(scl,gcl);
}

SCM funlist_can_subsume_aux_pred_(scl,gcl)
SCM scl,gcl;
{
  SCM success_flag,gfun,glit,spart,slit,sfun;

  spart=scl;
  for(;!(NULL_P(spart)||NULL_P(gcl));) {
    glit=CAR(gcl);
    gfun=CAR(glit);
    success_flag=BOOL_F;
    spart=scl;
    for(;!(NULL_P(spart)||NFALSEP(success_flag));) {
      slit=CAR(spart);
      sfun=CAR(slit);
      if(NFALSEP(_grtr__fun_ordering_aux_pred_(gfun,sfun))) {
        spart=EOL;
      }
      else
      if(ZERO_P(MAKINUM(65536)&gfun)) {
        if(((MAKINUM(534773760)&sfun)==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&sfun)>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&sfun)>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&sfun)>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&sfun)>=(MAKINUM(31)&gfun)))))) {
          gcl=CDR(gcl);
          success_flag=BOOL_T;
        }
        else {
          spart=CDR(spart);
        }
      }
      else
      if(NFALSEP(composite_equal_pred_(slit,glit))) {
        gcl=CDR(gcl);
        success_flag=BOOL_T;
      }
      else {
        spart=CDR(spart);
      }
    }
  }
  return SBOOL(NULL_P(gcl));
}

SCM _grtr__fun_ordering_pred_(xfun,yfun)
SCM xfun,yfun;
{
  if(NFALSEP(answer_pred_pred_(xfun))) {
    if(NFALSEP(answer_pred_pred_(yfun))) {
      if((MAKINUM(131071)&xfun)>=(MAKINUM(131071)&yfun))
        return BOOL_T;
      else
        return BOOL_F;
    }
    else
      return BOOL_T;
  }
  else
  if(NFALSEP(answer_pred_pred_(yfun)))
    return BOOL_F;
  else
  if(((MAKINUM(131071)&xfun)>(MAKINUM(131071)&yfun))||(((MAKINUM(131071)&xfun)==(MAKINUM(131071)&yfun))&&((MAKINUM(534773760)&xfun)>(MAKINUM(534773760)&yfun))))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM _grtr__fun_ordering_aux_pred_(xfun,yfun)
SCM xfun,yfun;
{
  if(((MAKINUM(131071)&xfun)>(MAKINUM(131071)&yfun))||(((MAKINUM(131071)&xfun)==(MAKINUM(131071)&yfun))&&((MAKINUM(534773760)&xfun)>(MAKINUM(534773760)&yfun))))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM subsumed_pure_clause_ans_pred_(scl,gcl)
SCM scl,gcl;
{
  SCM glit1,slit1;

  glit1=CAR(gcl);
  if(NFALSEP(answer_pred_pred_(CAR(glit1)))) {
    slit1=CAR(scl);
    if(!(ZERO_P(MAKINUM(65536)&CAR(glit1))))
      return subsumed_pure_clause_aux_pred_(CDR(scl),CDR(gcl),BOOL_F,EOL,BOOL_F);
    else {
      var_set_flag_global=BOOL_F;
      if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(slit1),CDR(glit1)))) {
        if(NFALSEP(subsumed_pure_clause_aux_pred_(CDR(scl),CDR(gcl),BOOL_T,EOL,BOOL_F))) {
          clear_gcl_vars();
          return BOOL_T;
        }
        else {
          clear_gcl_vars();
          return BOOL_F;
        }
      }
      else {
        if(NFALSEP(var_set_flag_global))
          clear_gcl_vars();
        return BOOL_F;
      }
    }
  }
  else
  if(NFALSEP(answer_pred_pred_(CAR(CAR(scl)))))
    return subsumed_pure_clause_aux_pred_(CDR(scl),gcl,BOOL_F,EOL,BOOL_F);
  else
    return subsumed_pure_clause_aux_pred_(scl,gcl,BOOL_F,EOL,BOOL_F);
}

SCM subsumed_pure_clause_aux_pred_(scl,gcl,var_set_before,done_scl_parts,swapped_flag)
SCM scl,gcl,var_set_before,done_scl_parts,swapped_flag;
{
  SCM tmp_var_set_flag__4,grest__3,grest__1,slit,success_flag,gfun,glit,spart,grest,grest__2,tmp_var_set_flag,grest__5;

  glit=CAR(gcl);
  gfun=CAR(glit);
  success_flag=BOOL_F;
  if(NFALSEP(GLOBAL(sat_strategy_flag_global))&&NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global)))
    return strong_subsumed_purecl_pred_(scl,gcl);
  else {
    for(spart=scl;!(NULL_P(spart)||NFALSEP(success_flag));spart=(NULL_P(spart) ? EOL : CDR(spart)))
      if(NULL_P(done_scl_parts)||!(NFALSEP(memq(spart,done_scl_parts)))) {
        slit=CAR(spart);
        if(((MAKINUM(534773760)&CAR(slit))==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&CAR(slit))>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&CAR(slit))>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&CAR(slit))>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&CAR(slit))>=(MAKINUM(31)&gfun)))))) {
          if(ZERO_P(MAKINUM(65536)&gfun)) {
            if(NFALSEP(var_set_before))
              save_gcl_vars();
            var_set_flag_global=BOOL_F;
            alt_var_set_flag_global=BOOL_F;
            swapped_flag=BOOL_F;
            if(NFALSEP(subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))||(NFALSEP(commutative_fun_pred_(gfun))&&(NFALSEP((((NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) ? ((NFALSEP(var_set_before) ? restore_gcl_vars() : clear_gcl_vars()),var_set_flag_global=BOOL_F,UNSPECIFIED,alt_var_set_flag_global=BOOL_F,UNSPECIFIED) : UNSPECIFIED),BOOL_T))&&(NFALSEP(swapped_subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))&&NFALSEP((swapped_flag=BOOL_T,UNSPECIFIED,BOOL_T)))))) {
              if(NFALSEP(var_set_flag_global)) {
                grest=CDR(gcl);
                if(NULL_P(grest)) {
                  success_flag=BOOL_T;
                }
                else
                if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest,BOOL_T,cons(spart,done_scl_parts),swapped_flag))) {
                  success_flag=BOOL_T;
                }
                else
                if(NFALSEP(var_set_before))
                  restore_gcl_vars();
                else
                  clear_gcl_vars();
                if(!(NFALSEP(success_flag))&&(NFALSEP(commutative_fun_pred_(gfun))&&(!(NFALSEP(swapped_flag))&&NFALSEP(swapped_subsumed_term_list_ordinary_pred_(CDR(slit),CDR(glit)))))) {
                  if(NFALSEP(var_set_flag_global)) {
                    grest__1=CDR(gcl);
                    if(NULL_P(grest__1)) {
                      success_flag=BOOL_T;
                    }
                    else
                    if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest__1,BOOL_T,cons(spart,done_scl_parts),swapped_flag))) {
                      success_flag=BOOL_T;
                    }
                    else
                    if(NFALSEP(var_set_before))
                      restore_gcl_vars();
                    else
                      clear_gcl_vars();
                  }
                  else {
                    grest__2=CDR(gcl);
                    tmp_var_set_flag=alt_var_set_flag_global;
                    if(NULL_P(grest__2)) {
                      success_flag=BOOL_T;
                    }
                    else
                    if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest__2,BOOL_T,cons(spart,done_scl_parts),swapped_flag))) {
                      success_flag=BOOL_T;
                    }
                    else {
                      if(NFALSEP(tmp_var_set_flag)) {
                        if(NFALSEP(var_set_before))
                          restore_gcl_vars();
                        else
                          clear_gcl_vars();
                      }
                      else
                      if(NFALSEP(var_set_before))
                        pop_gcl_vars_stack();
                      spart=EOL;
                    }
                  }
                }
              }
              else {
                grest__3=CDR(gcl);
                tmp_var_set_flag__4=alt_var_set_flag_global;
                if(NULL_P(grest__3)) {
                  success_flag=BOOL_T;
                }
                else
                if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest__3,BOOL_T,cons(spart,done_scl_parts),swapped_flag))) {
                  success_flag=BOOL_T;
                }
                else {
                  if(NFALSEP(tmp_var_set_flag__4)) {
                    if(NFALSEP(var_set_before))
                      restore_gcl_vars();
                    else
                      clear_gcl_vars();
                  }
                  else
                  if(NFALSEP(var_set_before))
                    pop_gcl_vars_stack();
                  spart=EOL;
                }
              }
            }
            else
            if(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global)) {
              if(NFALSEP(var_set_before))
                restore_gcl_vars();
              else
                clear_gcl_vars();
            }
            else
            if(NFALSEP(var_set_before))
              pop_gcl_vars_stack();
          }
          else
          if(NFALSEP(composite_equal_pred_(glit,slit))) {
            grest__5=CDR(gcl);
            if(NULL_P(grest__5)) {
              success_flag=BOOL_T;
            }
            else
            if(NFALSEP(subsumed_pure_clause_aux_pred_(scl,grest__5,var_set_before,cons(spart,done_scl_parts),swapped_flag))) {
              success_flag=BOOL_T;
            }
            else {
              spart=EOL;
            }
          }
        }
      }
    return success_flag;
  }
}

SCM same_or_nonground_fun_pred_(xfun,yfun)
SCM xfun,yfun;
{
  SCM new_var1;

  new_var1=SBOOL(ZERO_P(MAKINUM(65536)&yfun));
  if(NFALSEP(new_var1))
    return new_var1;
  else
    return SBOOL(xfun==yfun);
}

SCM subsumed_term_ordinary_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM sfun,gfun,gval,spart,gpart;

  if(NUMBER_P(gterm)) {
    if(MAKINUM(65535)>gterm) {
      gval=STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&gterm);
      if(gval==MAKINUM(99999999)) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&gterm,sterm);
        if(ZERO_P(MAKINUM(8192)&gterm)) {
          var_set_flag_global=BOOL_T;
        }
        else {
          alt_var_set_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
      if(NUMBER_P(sterm)) {
        if(MAKINUM(65535)>sterm) {
          if(NUMBER_P(gval)&&(gval<=MAKINUM(65535)))
            return SBOOL((MAKINUM(8191)&sterm)==(MAKINUM(8191)&gval));
          else
            return BOOL_F;
        }
        else
          return SBOOL(sterm==gval);
      }
      else
      if(NUMBER_P(gval))
        return BOOL_F;
      else
      if(sterm==gval)
        return BOOL_T;
      else
      if(NFALSEP(composite_equal_strong_pred_(sterm,gval)))
        return BOOL_T;
      else
        return BOOL_F;
    }
    else
      return SBOOL(sterm==gterm);
  }
  else
  if(NUMBER_P(sterm))
    return BOOL_F;
  else {
    gfun=CAR(gterm);
    sfun=CAR(sterm);
    if(((MAKINUM(534773760)&sfun)==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&sfun)>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&sfun)>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&sfun)>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&sfun)>=(MAKINUM(31)&gfun)))))) {
      if(ZERO_P(MAKINUM(65536)&gfun)) {
        for(spart=CDR(sterm),gpart=CDR(gterm);
            !(NULL_P(spart)||!(NFALSEP(subsumed_term_ordinary_pred_(CAR(spart),CAR(gpart)))));
            spart=CDR(spart),gpart=CDR(gpart)) ;
        return SBOOL(NULL_P(spart));
      }
      else
        return term_list_equal_pred_(CDR(gterm),CDR(sterm));
    }
    else
      return BOOL_F;
  }
}

SCM subsumed_term_ordinary_collectvars_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM res;

  GLOBAL(collected_vars_global)=EOL;
  res=subsumed_term_ordinary_collectvars_aux_pred_(sterm,gterm);
  return cons(res,GLOBAL(collected_vars_global));
}

SCM subsumed_term_ordinary_collectvars_aux_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM sfun,gfun,gval,spart,gpart;

  if(NUMBER_P(gterm)) {
    if(MAKINUM(65535)>gterm) {
      gval=STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&gterm);
      if(gval==MAKINUM(99999999)) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&gterm,sterm);
        GLOBAL(collected_vars_global)=cons(gterm,GLOBAL(collected_vars_global));
        if(ZERO_P(MAKINUM(8192)&gterm)) {
          var_set_flag_global=BOOL_T;
        }
        else {
          alt_var_set_flag_global=BOOL_T;
        }
        return BOOL_T;
      }
      else
      if(NUMBER_P(sterm)) {
        if(MAKINUM(65535)>sterm) {
          if(NUMBER_P(gval)&&(gval<=MAKINUM(65535)))
            return SBOOL((MAKINUM(8191)&sterm)==(MAKINUM(8191)&gval));
          else
            return BOOL_F;
        }
        else
          return SBOOL(sterm==gval);
      }
      else
      if(NUMBER_P(gval))
        return BOOL_F;
      else
      if(sterm==gval)
        return BOOL_T;
      else
      if(NFALSEP(composite_equal_strong_pred_(sterm,gval)))
        return BOOL_T;
      else
        return BOOL_F;
    }
    else
      return SBOOL(sterm==gterm);
  }
  else
  if(NUMBER_P(sterm))
    return BOOL_F;
  else {
    gfun=CAR(gterm);
    sfun=CAR(sterm);
    if(((MAKINUM(534773760)&sfun)==(MAKINUM(534773760)&gfun))&&(((MAKINUM(131071)&sfun)>=(MAKINUM(131071)&gfun))&&(((MAKINUM(65535)&sfun)>=(MAKINUM(65535)&gfun))&&(((MAKINUM(2047)&sfun)>=(MAKINUM(2047)&gfun))&&((MAKINUM(31)&sfun)>=(MAKINUM(31)&gfun)))))) {
      if(ZERO_P(MAKINUM(65536)&gfun)) {
        for(spart=CDR(sterm),gpart=CDR(gterm);
            !(NULL_P(spart)||!(NFALSEP(subsumed_term_ordinary_collectvars_aux_pred_(CAR(spart),CAR(gpart)))));
            spart=CDR(spart),gpart=CDR(gpart)) ;
        return SBOOL(NULL_P(spart));
      }
      else
        return term_list_equal_pred_(CDR(gterm),CDR(sterm));
    }
    else
      return BOOL_F;
  }
}

SCM subsumed_term_list_ordinary_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM spart,gpart;

  for(spart=sterm,gpart=gterm;
      !(NULL_P(spart)||!(NFALSEP(subsumed_term_ordinary_pred_(CAR(spart),CAR(gpart)))));
      spart=CDR(spart),gpart=CDR(gpart)) ;
  return SBOOL(NULL_P(spart));
}

SCM swapped_subsumed_term_list_ordinary_pred_(sterm,gterm)
SCM sterm,gterm;
{
  SCM spart,gpart;

  if(NFALSEP(subsumed_term_ordinary_pred_(CAR(sterm),CAR(CDR(gterm))))) {
    if(NFALSEP(subsumed_term_ordinary_pred_(CAR(CDR(sterm)),CAR(gterm)))) {
      for(spart=CDR(CDR(sterm)),gpart=CDR(CDR(gterm));
          !(NULL_P(spart)||!(NFALSEP(subsumed_term_ordinary_pred_(CAR(spart),CAR(gpart)))));
          spart=CDR(spart),gpart=CDR(gpart)) ;
      return SBOOL(NULL_P(spart));
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM not_zero_pred_(x)
SCM x;
{
  return NOT(SBOOL(ZERO_P(x)));
}

SCM mymax(x,y)
SCM x,y;
{
  if(x>y)
    return x;
  else
    return y;
}

SCM maxplus(max__1,x,y)
SCM max__1,x,y;
{
  SCM newmaxplusnr;

  newmaxplusnr=MAKINUM(INUM(x)+INUM(y));
  if(newmaxplusnr>max__1)
    return max__1;
  else
    return newmaxplusnr;
}

SCM rassq(key,lst)
SCM key,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return BOOL_F;
  else
  if(key==CDR(CAR(lst)))
    return CAR(lst);
  else {
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM adjoin(x,lst)
SCM x,lst;
{
  if(NFALSEP(memq(x,lst)))
    return lst;
  else
    return cons(x,lst);
}

SCM union_nonkeyword(xset,yset)
SCM xset,yset;
{
tailrecursion:
  if(NULL_P(xset))
    return yset;
  else
  if(NFALSEP(memq(CAR(xset),yset))) {
    xset=CDR(xset);
    goto tailrecursion;
  }
  else
    return cons(CAR(xset),union_nonkeyword(CDR(xset),yset));
}

SCM list_union(lst)
SCM lst;
{
  if(NULL_P(lst))
    return EOL;
  else
  if(NULL_P(CDR(lst)))
    return CAR(lst);
  else
    return union_nonkeyword(CAR(lst),list_union(CDR(lst)));
}

SCM member_memq_pred_(x,lst)
SCM x,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return BOOL_F;
  else
  if(NFALSEP(memq(x,CAR(lst))))
    return BOOL_T;
  else {
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM assoc_memq(x,lst)
SCM x,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return BOOL_F;
  else
  if(NFALSEP(memq(x,CAR(CAR(lst)))))
    return CAR(lst);
  else {
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM nth_cdr(n,lst)
SCM n,lst;
{
  SCM tmp_var1,tmp_var2;

tailrecursion:
  if(ZERO_P(n))
    return lst;
  else {
    tmp_var1=MAKINUM(INUM(n)-1);
    tmp_var2=CDR(lst);
    n=tmp_var1;
    lst=tmp_var2;
    goto tailrecursion;
  }
}

SCM pos_in_list(x,lst)
SCM x,lst;
{
  return pos_in_list_aux(x,lst,MAKINUM(1));
}

SCM pos_in_list_aux(x,lst,nr)
SCM x,lst,nr;
{
  SCM tmp_var1,tmp_var2;

tailrecursion:
  if(PAIR_P(lst)) {
    if(CAR(lst)==x)
      return nr;
    else {
      tmp_var1=CDR(lst);
      tmp_var2=MAKINUM(1+INUM(nr));
      lst=tmp_var1;
      nr=tmp_var2;
      goto tailrecursion;
    }
  }
  else
    return MAKINUM(-1);
}

SCM split_list(l,n)
SCM l,n;
{
  SCM resend,res,lpart;

  res=cons(EOL,EOL);
  resend=res;
  for(lpart=l;!(ZERO_P(n));lpart=CDR(lpart)) {
    SET_CDR(resend,cons(CAR(lpart),CDR(resend)));
    resend=CDR(resend);
    n=MAKINUM(INUM(n)-1);
  }
  return cons(CDR(res),lpart);
}

SCM split_if_exporthof(fn,lst)
SCM fn,lst;
{
  SCM nolst,yeslst,lstpart;

  yeslst=EOL;
  nolst=EOL;
  for(lstpart=lst;!(NULL_P(lstpart));lstpart=CDR(lstpart))
    if(NFALSEP(apply(fn,CAR(lstpart),listofnull))) {
      yeslst=cons(CAR(lstpart),yeslst);
    }
    else {
      nolst=cons(CAR(lstpart),nolst);
    }
  return cons(reverse(yeslst),reverse(nolst));
}

SCM split_if(fn,lst)
SCM (*fn) ();
SCM lst;
{
  SCM nolst,yeslst,lstpart;

  yeslst=EOL;
  nolst=EOL;
  for(lstpart=lst;!(NULL_P(lstpart));lstpart=CDR(lstpart))
    if(NFALSEP((*fn)(CAR(lstpart)))) {
      yeslst=cons(CAR(lstpart),yeslst);
    }
    else {
      nolst=cons(CAR(lstpart),nolst);
    }
  return cons(reverse(yeslst),reverse(nolst));
}

SCM my_last_pair(x)
SCM x;
{
  if(PAIR_P(x))
    return my_last_pair_aux(x);
  else
    return x;
}

SCM my_last_pair_aux(x)
SCM x;
{
tailrecursion:
  if(PAIR_P(CDR(x))) {
    x=CDR(x);
    goto tailrecursion;
  }
  else
    return x;
}

SCM my_append_excl_(x,y)
SCM x,y;
{
  SCM z;

  z=my_last_pair(x);
  if(PAIR_P(z)) {
    SET_CDR(z,y);
    return x;
  }
  else
    return y;
}

SCM but_last(lst)
SCM lst;
{
  if(!(PAIR_P(lst)))
    return EOL;
  else
  if(!(PAIR_P(CDR(lst))))
    return EOL;
  else
    return cons(CAR(lst),but_last(CDR(lst)));
}

SCM map_excl__exporthof(fn,lst)
SCM fn,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return lst;
  else {
    SET_CAR(lst,apply(fn,CAR(lst),listofnull));
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM map_excl_(fn,lst)
SCM (*fn) ();
SCM lst;
{
tailrecursion:
  if(NULL_P(lst))
    return lst;
  else {
    SET_CAR(lst,(*fn)(CAR(lst)));
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM some_pred__exporthof(fn,lst)
SCM fn,lst;
{
  SCM new_var1;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var1=apply(fn,CAR(lst),listofnull);
    if(NFALSEP(new_var1))
      return new_var1;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM some_pred_(fn,lst)
SCM (*fn) ();
SCM lst;
{
  SCM new_var1;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var1=(*fn)(CAR(lst));
    if(NFALSEP(new_var1))
      return new_var1;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM some_pred__inst4(npar__36,npar__37,npar__38,fn,lst)
SCM *npar__38;
SCM (*fn) ();
SCM npar__36,npar__37,lst;
{
  SCM new_var1;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var1=(*fn)(npar__36,npar__37,npar__38,CAR(lst));
    if(NFALSEP(new_var1))
      return new_var1;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM some_pred__inst3(npar__31,fn,lst)
SCM *npar__31;
SCM (*fn) ();
SCM lst;
{
  SCM new_var1;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var1=(*fn)(npar__31,CAR(lst));
    if(NFALSEP(new_var1))
      return new_var1;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM some_pred__inst2(npar__5,fn,lst)
SCM (*fn) ();
SCM npar__5,lst;
{
  SCM new_var1;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var1=(*fn)(npar__5,CAR(lst));
    if(NFALSEP(new_var1))
      return new_var1;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM some_pred__inst1(npar__1,npar__2,fn,lst)
SCM (*fn) ();
SCM npar__1,npar__2,lst;
{
  SCM new_var1;

tailrecursion:
  if(PAIR_P(lst)) {
    new_var1=(*fn)(npar__1,npar__2,CAR(lst));
    if(NFALSEP(new_var1))
      return new_var1;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM every_pred__exporthof(fn,lst)
SCM fn,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP(apply(fn,CAR(lst),listofnull))) {
      lst=CDR(lst);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM every_pred_(fn,lst)
SCM (*fn) ();
SCM lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(CAR(lst)))) {
      lst=CDR(lst);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM every_pred__inst4(npar__42,npar__43,fn,lst)
SCM (*fn) ();
SCM npar__42,npar__43,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(npar__42,npar__43,CAR(lst)))) {
      lst=CDR(lst);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM every_pred__inst3(npar__39,npar__40,npar__41,fn,lst)
SCM *npar__41;
SCM (*fn) ();
SCM npar__39,npar__40,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(npar__39,npar__40,npar__41,CAR(lst)))) {
      lst=CDR(lst);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM every_pred__inst2(npar__32,npar__33,fn,lst)
SCM *npar__33;
SCM (*fn) ();
SCM npar__32,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(npar__32,npar__33,CAR(lst)))) {
      lst=CDR(lst);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM every_pred__inst1(npar__3,fn,lst)
SCM (*fn) ();
SCM npar__3,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(npar__3,CAR(lst)))) {
      lst=CDR(lst);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM member_if_exporthof(fn,lst)
SCM fn,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP(apply(fn,CAR(lst),listofnull)))
      return lst;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM member_if(fn,lst)
SCM (*fn) ();
SCM lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(CAR(lst))))
      return lst;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM member_if_inst1(npar__4,fn,lst)
SCM (*fn) ();
SCM npar__4,lst;
{
tailrecursion:
  if(PAIR_P(lst)) {
    if(NFALSEP((*fn)(npar__4,CAR(lst))))
      return lst;
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return BOOL_F;
}

SCM remove_if_exporthof(fn,lst)
SCM fn,lst;
{
tailrecursion:
  if(!(PAIR_P(lst)))
    return lst;
  else
  if(NFALSEP(apply(fn,CAR(lst),listofnull))) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_if_exporthof(fn,CDR(lst)));
}

SCM remove_if(fn,lst)
SCM (*fn) ();
SCM lst;
{
tailrecursion:
  if(!(PAIR_P(lst)))
    return lst;
  else
  if(NFALSEP((*fn)(CAR(lst)))) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_if(fn,CDR(lst)));
}

SCM remove_if_inst1(npar__7,fn,lst)
SCM (*fn) ();
SCM npar__7,lst;
{
tailrecursion:
  if(!(PAIR_P(lst)))
    return lst;
  else
  if(NFALSEP((*fn)(npar__7,CAR(lst)))) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_if_inst1(npar__7,fn,CDR(lst)));
}

SCM filter_map_exporthof(f,lst)
SCM f,lst;
{
  SCM res;

tailrecursion:
  if(PAIR_P(lst)) {
    res=apply(f,CAR(lst),listofnull);
    if(NFALSEP(res))
      return cons(res,filter_map_exporthof(f,CDR(lst)));
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return EOL;
}

SCM filter_map(f,lst)
SCM (*f) ();
SCM lst;
{
  SCM res;

tailrecursion:
  if(PAIR_P(lst)) {
    res=(*f)(CAR(lst));
    if(NFALSEP(res))
      return cons(res,filter_map(f,CDR(lst)));
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return EOL;
}

SCM filter_map_inst2(npar__48,npar__49,f,lst)
SCM *npar__49;
SCM (*f) ();
SCM npar__48,lst;
{
  SCM res;

tailrecursion:
  if(PAIR_P(lst)) {
    res=(*f)(npar__48,npar__49,CAR(lst));
    if(NFALSEP(res))
      return cons(res,filter_map_inst2(npar__48,npar__49,f,CDR(lst)));
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return EOL;
}

SCM filter_map_inst1(npar__46,npar__47,f,lst)
SCM (*f) ();
SCM npar__46,npar__47,lst;
{
  SCM res;

tailrecursion:
  if(PAIR_P(lst)) {
    res=(*f)(npar__46,npar__47,CAR(lst));
    if(NFALSEP(res))
      return cons(res,filter_map_inst1(npar__46,npar__47,f,CDR(lst)));
    else {
      lst=CDR(lst);
      goto tailrecursion;
    }
  }
  else
    return EOL;
}

SCM copy_list(lst)
SCM lst;
{
  if(NULL_P(lst))
    return lst;
  else
    return cons(CAR(lst),copy_list(CDR(lst)));
}

SCM sum_list(lst)
SCM lst;
{
  if(PAIR_P(lst))
    return MAKINUM(INUM(CAR(lst))+INUM(sum_list(CDR(lst))));
  else
    return MAKINUM(0);
}

SCM remove_one_equal(what,lst)
SCM what,lst;
{
  if(NULL_P(lst))
    return lst;
  else
  if(NFALSEP(equal(what,CAR(lst))))
    return CDR(lst);
  else
    return cons(CAR(lst),remove_one_equal(what,CDR(lst)));
}

SCM remove_eq(el,lst)
SCM el,lst;
{
tailrecursion:
  if(NULL_P(lst))
    return lst;
  else
  if(CAR(lst)==el) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_eq(el,CDR(lst)));
}

SCM remove_at_place(place,lst)
SCM place,lst;
{
  if(NULL_P(lst))
    return lst;
  else
  if(place==lst)
    return CDR(lst);
  else
    return cons(CAR(lst),remove_at_place(place,CDR(lst)));
}

SCM replace_one_eq(what,with,lst)
SCM what,with,lst;
{
  if(NULL_P(lst))
    return EOL;
  else
  if(what==CAR(lst))
    return cons(with,CDR(lst));
  else
    return cons(CAR(lst),replace_one_eq(what,with,CDR(lst)));
}

SCM replace_nth(where,nr,with)
SCM where,nr,with;
{
  if(MAKINUM(1)==nr)
    return cons(with,CDR(where));
  else
    return cons(CAR(where),replace_nth(CDR(where),MAKINUM(INUM(nr)-1),with));
}

SCM remove_at_place_excl_(place,lst)
SCM place,lst;
{
  SCM lstpart;

  if(NULL_P(lst))
    return EOL;
  else
  if(NULL_P(CDR(lst)))
    return EOL;
  else {
    for(lstpart=lst;!(PAIR_P(CDR(lstpart))&&(place==CDR(lstpart)));lstpart=CDR(lstpart)) ;
    SET_CDR(lstpart,CDR(CDR(lstpart)));
    return UNSPECIFIED;
  }
}

SCM make_inside_subset(lst,where)
SCM lst,where;
{
  GLOBAL(make_inside_subset_tmp_global)=EOL;
  GLOBAL(make_inside_subset_tmp_lst_global)=lst;
  make_inside_subset_aux_excl_(where);
  return GLOBAL(make_inside_subset_tmp_global);
}

SCM make_inside_subset_aux_excl_(where)
SCM where;
{
  SCM lstpart;

  if(!(NULL_P(GLOBAL(make_inside_subset_tmp_lst_global)))) {
    if(PAIR_P(where))
      return for_each1(make_inside_subset_aux_excl_,where);
    else {
      for(lstpart=GLOBAL(make_inside_subset_tmp_lst_global);!(NULL_P(lstpart));lstpart=CDR(lstpart))
        if(CAR(lstpart)==where) {
          GLOBAL(make_inside_subset_tmp_global)=cons(CAR(lstpart),GLOBAL(make_inside_subset_tmp_global));
          GLOBAL(make_inside_subset_tmp_lst_global)=remove_at_place(lstpart,GLOBAL(make_inside_subset_tmp_lst_global));
        }
      return UNSPECIFIED;
    }
  }
  else
    return UNSPECIFIED;
}

SCM make_input_clause(cl,sosflag)
SCM cl,sosflag;
{
  SCM fun,lit,clinfo,minw,weight,predsymbsint,len,strengthint,litinfolst,tmp,clpart,clpart__1;

  cl=remove_duplicates(cl);
  litinfolst=make_input_litinfolst(cl);
  tmp=EOL;
  set_x_vars_selfref_touched_excl_(MAKINUM(255));
  cl=map1(make_input_clause_fn16,cl);
  GLOBAL(used_demodulators_global)=EOL;
  tmp=sort_clause(make_input_clause_aux774(cl,litinfolst),BOOL_T);
  cl=map1(make_input_clause_fn17,tmp);
  litinfolst=map1(make_input_clause_fn18,tmp);
  clause_var_nr_global=MAKINUM(0);
  if(NFALSEP(pure_clause_may_cont_vars_pred_(cl))) {
    cl=copy_list(cl);
    make_varinfo_lst_excl_(cl,cons(EOL,EOL));
    GLOBAL(new_var_names_global)=EOL;
    make_fulldeco_clause_excl_(cl);
  }
  strengthint=MAKINUM(0);
  len=MAKINUM(0);
  predsymbsint=MAKINUM(0);
  weight=MAKINUM(0);
  minw=MAKINUM(0);
  clinfo=EOL;
  for(clpart=cl;!(NULL_P(clpart));clpart=CDR(clpart)) {
    lit=CAR(clpart);
    fun=CAR(lit);
    if(NFALSEP(countable_pred_pred_(fun))) {
      if(ZERO_P(strengthint)) {
        strengthint=(MAKINUM(131071)&fun);
      }
      else {
        strengthint=sum_fun_strengths(fun,strengthint);
      }
      if(!(ZERO_P(predsymb_bit(fun)&predsymbsint))) {
        predsymbsint=(MAKINUM(134217728)|predsymbsint);
      }
      predsymbsint=(predsymb_bit(fun)|predsymbsint);
      len=MAKINUM(1+INUM(len));
      weight=MAKINUM(INUM(weight)+INUM(lit_weight(lit)));
    }
  }
  if(len>MAKINUM(63)) {
    len=MAKINUM(63);
  }
  if(clause_var_nr_global>MAKINUM(63)) {
    clause_var_nr_global=MAKINUM(63);
  }
  strengthint=((MAKINUM(INUM(len)<<17)|MAKINUM(INUM(clause_var_nr_global)<<23))|strengthint);
  GLOBAL(kept_cl_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_cl_nr_global)));
  if(NFALSEP(GLOBAL(order_strategy_flag_global))||(NFALSEP(GLOBAL(name_order_strategy_flag_global))||(NFALSEP(GLOBAL(exp_order_strategy_flag_global))||(NFALSEP(GLOBAL(epr_order_strategy_flag_global))||(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))||(NFALSEP(GLOBAL(negweight_order_strategy_flag_global))||NFALSEP(GLOBAL(ordered_paramodulation_flag_global))))))))) {
    litinfolst=map1(make_input_clause_fn19,order_prohibit_litinfos(map1(make_input_clause_fn20,litinfolst),cl));
  }
  if(NFALSEP(GLOBAL(split_strategy_flag_global))&&!(NULL_P(CDR(cl)))) {
    weight=strengthint;
    tmp=map1(make_input_clause_fn21,cl);
    if(NFALSEP(every_pred__inst1(tmp,make_input_clause_fn22,tmp))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
        newline(cur_output_port());
        display(const_3,cur_output_port());
        print_pure_clause(cl);
        newline(cur_output_port());
      }
      for(clpart__1=cl;!(NULL_P(clpart__1));clpart__1=CDR(clpart__1))
        if(ZERO_P(minw)) {
          minw=(MAKINUM(131071)&CAR(CAR(clpart__1)));
        }
        else
        if((MAKINUM(131071)&CAR(CAR(clpart__1)))>minw) {
          minw=(MAKINUM(131071)&CAR(CAR(clpart__1)));
        }
      weight=minw;
    }
  }
  clinfo=cons(strengthint,cons(predsymbsint,cons(litinfolst,cons(weight,cons(GLOBAL(kept_cl_nr_global),cons(cons(input_symb,cons(GLOBAL(kept_cl_nr_global),EOL)),cons(sosflag,EOL)))))));
  tmp=cons(clinfo,cl);
  if(NFALSEP(GLOBAL(dynamic_demodulation_flag_global)))
    attempt_to_make_a_demodulator(tmp);
  return tmp;
}

SCM make_input_clause_aux774(cl,litinfolst)
SCM cl,litinfolst;
{
  SCM new_var4,new_var5,new_var1,new_var2,new_var3;

  for(new_var4=litinfolst,new_var5=cl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=cons(CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM make_input_clause_fn22(tmp,el)
SCM tmp,el;
{
  return SBOOL(!(NULL_P(el))&&NFALSEP(every_pred__inst1(el,make_input_clause_fn23,tmp)));
}

SCM make_input_clause_fn23(el,el2)
SCM el,el2;
{
  return SBOOL((el2==el)||NFALSEP(every_pred__inst1(el2,make_input_clause_fn24,el)));
}

SCM make_input_clause_fn24(el2,v)
SCM el2,v;
{
  return SBOOL(!(NFALSEP(assq(CAR(v),el2))));
}

SCM make_input_clause_fn21(x)
SCM x;
{
  return make_var_depth_info(x);
}

SCM make_input_clause_fn20(x)
SCM x;
{
  return cons(EOL,cons(EOL,x));
}

SCM make_input_clause_fn19(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM make_input_clause_fn18(x)
SCM x;
{
  return CAR(x);
}

SCM make_input_clause_fn17(x)
SCM x;
{
  return CDR(x);
}

SCM make_input_clause_fn16(x)
SCM x;
{
  return subst_deco_term(x,BOOL_T);
}

SCM remove_duplicates(lst)
SCM lst;
{
tailrecursion:
  if(NULL_P(lst))
    return EOL;
  else
  if(NFALSEP(member(CAR(lst),CDR(lst)))) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),remove_duplicates(CDR(lst)));
}

SCM make_input_litinfolst(cl)
SCM cl;
{
  SCM res,nr,clpart;

  if(!(NFALSEP(GLOBAL(hyper_strategy_flag_global))))
    return make_input_litinfolist_aux(cl);
  else
  if(NFALSEP(positive_cl_pred_(cl)))
    return make_input_litinfolist_aux(cl);
  else {
    nr=MAKINUM(1);
    res=EOL;
    for(clpart=cl;!(NULL_P(clpart));clpart=CDR(clpart))
      if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))) {
        res=cons(cons(MAKINUM(INUM(nr)<<16)|MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&MAKINUM(8))^8),EOL),res);
        nr=MAKINUM(1+INUM(nr));
      }
      else {
        res=cons(make_pos_lit_litinfo(CAR(clpart)),res);
      }
    return reverse(res);
  }
}

SCM make_input_litinfolist_aux(cl)
SCM cl;
{
  return map1(make_pos_lit_litinfo,cl);
}

SCM make_pos_lit_litinfo(x)
SCM x;
{
  if(NFALSEP(answer_lit_pred_(x)))
    return cons(GLOBAL(answer_litinf_global),EOL);
  else
  if((GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(x)))&&NFALSEP(equal(CAR(CDR(x)),CAR(CDR(CDR(x))))))
    return cons(MAKINUM(8)|(MAKINUM(16)|MAKINUM(32)),EOL);
  else
  if(!(NUMBER_P(CAR(CDR(x))))&&((GLOBAL(eq_fun_nr_global)==(MAKINUM(534773760)&CAR(CAR(CDR(x)))))&&NFALSEP(equal(CAR(CDR(CAR(CDR(x)))),CAR(CDR(CDR(CAR(CDR(x)))))))))
    return cons(MAKINUM(8)|(MAKINUM(16)|MAKINUM(32)),EOL);
  else
    return cons(MAKINUM(0),EOL);
}

SCM make_varinfo_lst_excl_(cl,prevars)
SCM cl,prevars;
{
  SCM lit,fun,lcvars,follvars;

  if(NULL_P(cl))
    return EOL;
  else {
    lit=CAR(cl);
    fun=CAR(lit);
    if(ZERO_P(MAKINUM(65536)&fun))
      lcvars=collect_vars_composite_excl_(lit);
    else
      lcvars=cons(EOL,EOL);
    follvars=EOL;
    follvars=make_varinfo_lst_excl_(CDR(cl),cons(CDR(lcvars),prevars));
    if(ZERO_P(MAKINUM(65536)&fun)) {
      SET_CAR(cl,cons(lit,cons(CAR(lcvars),cons(CDR(lcvars),cons(append2(prevars,follvars),cons(follvars,EOL))))));
    }
    else {
      SET_CAR(cl,cons(lit,EOL));
    }
    return cons(CDR(lcvars),follvars);
  }
}

SCM make_fulldeco_clause_excl_(reslst)
SCM reslst;
{
  SCM el;

tailrecursion:
  if(!(NULL_P(reslst))) {
    el=CAR(reslst);
    if(ZERO_P(MAKINUM(65536)&CAR(CAR(el))))
      decorate_vars_lit_excl_(CAR(el),CAR(CDR(el)),CAR(CDR(CDR(el))),CAR(CDR(CDR(CDR(el)))),CAR(CDR(CDR(CDR(CDR(el))))));
    SET_CAR(reslst,CAR(el));
    reslst=CDR(reslst);
    goto tailrecursion;
  }
  else
    return UNSPECIFIED;
}

SCM pos_eq_pred_pred_(fn)
SCM fn;
{
  return SBOOL(GLOBAL(eq_pred_nr_global)==fn);
}

SCM pos_eq_fun_pred_(fn)
SCM fn;
{
  return SBOOL(GLOBAL(eq_fun_nr_global)==fn);
}

SCM fill_predsymb_bit_vector_excl_()
{
  SCM intlabel,ifs,cf,ef,e,a,part,n;

  a=assq(GLOBAL(ans_symbol_global),GLOBAL(pred_num_table_global));
  e=assq(GLOBAL(eq_symbol_global),GLOBAL(pred_num_table_global));
  ef=assq(GLOBAL(eq_fun_symbol_global),GLOBAL(fun_num_table_global));
  cf=assq(GLOBAL(case_fun_symbol_global),GLOBAL(fun_num_table_global));
  ifs=assq(GLOBAL(if_fun_symbol_global),GLOBAL(fun_num_table_global));
  if(NFALSEP(GLOBAL(int_logic_flag_global)))
    intlabel=assq(GLOBAL(int_outmost_symb_labelfun_global),GLOBAL(pred_num_table_global));
  else
    intlabel=BOOL_F;
  GLOBAL(ans_pred_nr_global)=MAKINUM(0);
  GLOBAL(eq_pred_nr_global)=MAKINUM(0);
  GLOBAL(eq_fun_nr_global)=MAKINUM(0);
  GLOBAL(case_fun_nr_global)=MAKINUM(0);
  GLOBAL(if_fun_nr_global)=MAKINUM(0);
  GLOBAL(int_outmost_label_fun_nr_global)=MAKINUM(0);
  if(NFALSEP(e)) {
    GLOBAL(pred_num_table_global)=cons(e,remove_eq(e,GLOBAL(pred_num_table_global)));
    GLOBAL(eq_pred_nr_global)=CDR(e);
  }
  if(NFALSEP(a)) {
    GLOBAL(pred_num_table_global)=cons(a,remove_eq(a,GLOBAL(pred_num_table_global)));
    GLOBAL(ans_pred_nr_global)=CDR(a);
  }
  if(NFALSEP(ef)) {
    GLOBAL(eq_fun_nr_global)=CDR(ef);
  }
  if(NFALSEP(cf)) {
    GLOBAL(case_fun_nr_global)=CDR(cf);
  }
  if(NFALSEP(ifs)) {
    GLOBAL(if_fun_nr_global)=CDR(ifs);
  }
  if(NFALSEP(intlabel)) {
    GLOBAL(int_outmost_label_fun_nr_global)=CDR(intlabel);
  }
  for(part=GLOBAL(pred_num_table_global),n=MAKINUM(1);
      !(NULL_P(part));
      part=CDR(part),n=((n<MAKINUM(4096)) ? MAKINUM(INUM(n)<<1) : MAKINUM(67108864))) {
    VECTOR_SET(GLOBAL(predsymb_bit_vector_global),MAKINUM(INUM(CDR(CAR(part)))>>21),n);
    VECTOR_SET(GLOBAL(predsymb_bit_vector_global),MAKINUM(INUM(MAKINUM(268435456)|CDR(CAR(part)))>>21),((n==MAKINUM(67108864)) ? MAKINUM(67108864) : MAKINUM(INUM(n)<<13)));
  }
  return UNSPECIFIED;
}

SCM turn_on_demodulation()
{
  GLOBAL(demodulate_flag_global)=BOOL_T;
  GLOBAL(dynamic_demodulation_flag_global)=BOOL_T;
  GLOBAL(new_demodulators_flag_global)=BOOL_T;
  GLOBAL(demodulate_constants_flag_global)=BOOL_T;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM turn_off_demodulation()
{
  GLOBAL(demodulate_flag_global)=BOOL_F;
  GLOBAL(dynamic_demodulation_flag_global)=BOOL_F;
  GLOBAL(new_demodulators_flag_global)=BOOL_F;
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_binres_strat()
{
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  GLOBAL(complete_unsat_strategy_global)=BOOL_F;
  GLOBAL(complete_sat_strategy_global)=BOOL_F;
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(double_strategy_flag_global)=BOOL_F;
  GLOBAL(bliksem_strategy_flag_global)=BOOL_F;
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(epr_order_strategy_flag_global)=BOOL_F;
  GLOBAL(exp_order_strategy_flag_global)=BOOL_F;
  GLOBAL(firstlitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_T;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_F;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_hyper_strat_new()
{
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  GLOBAL(complete_unsat_strategy_global)=BOOL_F;
  GLOBAL(complete_sat_strategy_global)=BOOL_F;
  init_posweight_ordered_binres_strat();
  turn_on_demodulation();
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_T;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_hyper_strat()
{
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  GLOBAL(complete_unsat_strategy_global)=BOOL_F;
  GLOBAL(complete_sat_strategy_global)=BOOL_F;
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(double_strategy_flag_global)=BOOL_F;
  GLOBAL(bliksem_strategy_flag_global)=BOOL_F;
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(epr_order_strategy_flag_global)=BOOL_F;
  GLOBAL(exp_order_strategy_flag_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(hyper_strategy_flag_global)=BOOL_T;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_T;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  turn_on_demodulation();
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_T;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_F;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_synth_strat()
{
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  GLOBAL(classical_synth_stratflag_global)=BOOL_T;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_T;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_binary_hyper_sos_strat()
{
  init_binres_strat();
  GLOBAL(binary_hyper_sos_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_unit_strat()
{
  init_binres_strat();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_double_strat()
{
  init_binres_strat();
  GLOBAL(double_strategy_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_binres_bliksem_strat()
{
  init_posweight_ordered_binres_strat();
  GLOBAL(bliksem_strategy_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_posweight_ordered_unit_strat()
{
  init_unit_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_negweight_ordered_unit_strat()
{
  init_unit_strat();
  GLOBAL(negweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_ordered_binres_strat()
{
  init_binres_strat();
  GLOBAL(order_strategy_flag_global)=BOOL_T;
  GLOBAL(negweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_ordered_binres_fulleq_strat()
{
  init_binres_strat();
  GLOBAL(order_strategy_flag_global)=BOOL_T;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_T;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_ordered_binres_sos_strat()
{
  init_binres_strat();
  GLOBAL(order_sos_strategy_flag_global)=BOOL_T;
  GLOBAL(order_strategy_flag_global)=BOOL_T;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_name_ordered_binres_strat()
{
  init_binres_strat();
  GLOBAL(order_strategy_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_name_ordered_binres_sos_strat()
{
  init_binres_strat();
  GLOBAL(order_sos_strategy_flag_global)=BOOL_T;
  GLOBAL(order_strategy_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_weight_ordered_binres_sos_strat()
{
  init_binres_strat();
  GLOBAL(order_sos_strategy_flag_global)=BOOL_T;
  GLOBAL(firstlitpref_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_weight_ordered_binres_strat()
{
  init_binres_strat();
  GLOBAL(order_sos_strategy_flag_global)=BOOL_F;
  GLOBAL(firstlitpref_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_posweight_ordered_binres_sos_strat()
{
  init_binres_strat();
  GLOBAL(order_sos_strategy_flag_global)=BOOL_T;
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_negweight_ordered_binres_sos_strat()
{
  init_binres_strat();
  GLOBAL(order_sos_strategy_flag_global)=BOOL_T;
  GLOBAL(negweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_posweight_ordered_binres_strat()
{
  init_binres_strat();
  clear_eq_order_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  turn_on_demodulation();
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_negweight_ordered_binres_strat()
{
  init_binres_strat();
  GLOBAL(negweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_hyper_wos_strat()
{
  init_hyper_strat();
  GLOBAL(hyper_wos_strategy_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_ordered_hyper_strat()
{
  init_hyper_strat();
  GLOBAL(order_strategy_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_typet_strat()
{
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_F;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_F;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(hyper_strategy_flag_global)=BOOL_T;
  GLOBAL(type_theory_stratflag_global)=BOOL_T;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_T;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_binary_unit_depth_backdemod()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(sos_preference_ratio_global)=MAKINUM(0);
  return UNSPECIFIED;
}

SCM init_binary_unit_depth_backdemod_alt()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(sos_preference_ratio_global)=MAKINUM(2);
  return UNSPECIFIED;
}

SCM init_binary_unit_depth_root_backdemod_alt()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(root_para_strat_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_T;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(sos_preference_ratio_global)=MAKINUM(6);
  return UNSPECIFIED;
}

SCM init_binary_unit_depth()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(sos_preference_ratio_global)=MAKINUM(0);
  return UNSPECIFIED;
}

SCM init_binary_unit_depth_sospref()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(sos_preference_ratio_global)=MAKINUM(0);
  return UNSPECIFIED;
}

SCM init_binary_unit_depth_sospref_alt()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(sos_preference_ratio_global)=MAKINUM(2);
  return UNSPECIFIED;
}

SCM init_binary_unit_lex()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_T;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_binary_unit_lex_backdemod()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_T;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_binary_unit_firstpref()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_binary_unit_firstpref_backdemod()
{
  init_binres_strat();
  turn_on_demodulation();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_ordered_hyper_uniteq_strat()
{
  init_ordered_hyper_strat();
  GLOBAL(para_unit_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_unit_uniteq_strat()
{
  init_unit_strat();
  GLOBAL(unit_strategy_flag_global)=BOOL_T;
  GLOBAL(para_unit_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_name_ordered_binres_uniteq_strat()
{
  init_name_ordered_binres_strat();
  GLOBAL(para_unit_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_ordered_binres_uniteq_strat()
{
  init_ordered_binres_strat();
  GLOBAL(para_unit_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_binres_uniteq_strat()
{
  init_binres_strat();
  GLOBAL(para_unit_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_exp_order_strat()
{
  init_binres_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_T;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_T;
  GLOBAL(epr_order_strategy_flag_global)=BOOL_F;
  GLOBAL(exp_order_strategy_flag_global)=BOOL_T;
  GLOBAL(complete_unsat_strategy_global)=BOOL_F;
  GLOBAL(complete_sat_strategy_global)=BOOL_F;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_F;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_epr_order_strat()
{
  init_binres_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_T;
  turn_off_demodulation();
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_T;
  GLOBAL(epr_order_strategy_flag_global)=BOOL_T;
  GLOBAL(complete_unsat_strategy_global)=BOOL_T;
  GLOBAL(complete_sat_strategy_global)=BOOL_F;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_T;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_posweight_ordered_binres_kb_big_strat()
{
  init_binres_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_T;
  turn_on_demodulation();
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_T;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_posweight_ordered_binres_kb_small_strat()
{
  init_binres_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_T;
  turn_on_demodulation();
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_F;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_posweight_ordered_binres_kb_small_fulleq_strat()
{
  init_binres_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_T;
  turn_on_demodulation();
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_F;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_T;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_posweight_ordered_binres_lex_big_strat()
{
  init_binres_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_T;
  turn_on_demodulation();
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_T;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_T;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_posweight_ordered_binres_lex_small_strat()
{
  init_binres_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_T;
  turn_on_demodulation();
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_T;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_F;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_T;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_posweight_ordered_firstpref_strat()
{
  init_binres_strat();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_T;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_T;
  turn_on_demodulation();
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_T;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_T;
  make_symbs_lex_order_vector();
  return make_symbs_kb_order_vector();
}

SCM init_sat_hyper_strat()
{
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_F;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  init_hyper_strat();
  turn_off_demodulation();
  GLOBAL(complete_unsat_strategy_global)=BOOL_T;
  GLOBAL(complete_sat_strategy_global)=BOOL_T;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_sat_posweight_ordered_binres_strat()
{
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_F;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  init_posweight_ordered_binres_kb_big_strat();
  turn_off_demodulation();
  GLOBAL(complete_unsat_strategy_global)=BOOL_T;
  GLOBAL(complete_sat_strategy_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_sat_ordered_binres_strat()
{
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_F;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  init_ordered_binres_strat();
  turn_off_demodulation();
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(complete_unsat_strategy_global)=BOOL_T;
  GLOBAL(complete_sat_strategy_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_sat_weight_ordered_binres_strat()
{
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_F;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  init_weight_ordered_binres_strat();
  turn_off_demodulation();
  GLOBAL(remove_all_tautologies_stratflag_global)=BOOL_F;
  GLOBAL(back_subsume_stratflag_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_prop_unsat_nofun_strat()
{
  GLOBAL(complete_unsat_strategy_global)=BOOL_T;
  GLOBAL(complete_sat_strategy_global)=BOOL_T;
  GLOBAL(prop_unsat_strat_global)=BOOL_T;
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_T;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_simple_model_strat()
{
  init_prop_sat_aux();
  GLOBAL(complete_unsat_strategy_global)=BOOL_F;
  GLOBAL(complete_sat_strategy_global)=BOOL_T;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_T;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_mace_model_strat()
{
  init_prop_sat_aux();
  GLOBAL(complete_unsat_strategy_global)=BOOL_F;
  GLOBAL(complete_sat_strategy_global)=BOOL_T;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_F;
  GLOBAL(mace_model_strat_global)=BOOL_T;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_sem_model_strat()
{
  init_prop_sat_aux();
  GLOBAL(complete_unsat_strategy_global)=BOOL_F;
  GLOBAL(complete_sat_strategy_global)=BOOL_T;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_F;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM init_mace_nofuns_model_strat()
{
  init_prop_sat_aux();
  GLOBAL(complete_unsat_strategy_global)=BOOL_T;
  GLOBAL(complete_sat_strategy_global)=BOOL_T;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_T;
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_F;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_random_model_strat()
{
  init_prop_sat_aux();
  GLOBAL(complete_unsat_strategy_global)=BOOL_F;
  GLOBAL(complete_sat_strategy_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(random_model_strat_global)=BOOL_T;
  GLOBAL(simple_model_strat_global)=BOOL_F;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_prop_sat_aux()
{
  turn_off_demodulation();
  GLOBAL(back_subsume_stratflag_global)=BOOL_F;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_F;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM clear_eq_order_strat()
{
  GLOBAL(order_equality_kb_strat_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM init_one_pass_strategical_flags()
{
  GLOBAL(sos_preference_ratio_global)=GLOBAL(global_sos_preference_ratio_global);
  GLOBAL(split_strategy_flag_global)=BOOL_F;
  GLOBAL(sos_strategy_flag_global)=BOOL_T;
  GLOBAL(binary_hyper_sos_strategy_global)=BOOL_F;
  GLOBAL(hyper_wos_strategy_flag_global)=BOOL_F;
  GLOBAL(remove_all_tautologies_stratflag_global)=BOOL_T;
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_F;
  GLOBAL(unit_clash_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_F;
  GLOBAL(back_subsume_stratflag_global)=BOOL_T;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_T;
  GLOBAL(bliksem_strategy_flag_global)=BOOL_F;
  GLOBAL(prop_unsat_strat_global)=BOOL_F;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(paramodulation_strategy_flag_global)=BOOL_T;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(double_strategy_flag_global)=BOOL_F;
  GLOBAL(hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(bliksem_strategy_flag_global)=BOOL_F;
  GLOBAL(order_strategy_flag_global)=BOOL_F;
  GLOBAL(order_strategy_sos_flag_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(epr_order_strategy_flag_global)=BOOL_F;
  GLOBAL(firstlitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(poslitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(negweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(neg_hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(int_logic_flag_global)=BOOL_F;
  GLOBAL(int_use_binres_flag_global)=BOOL_F;
  GLOBAL(classical_synth_stratflag_global)=BOOL_F;
  GLOBAL(int_use_hyperres_flag_global)=BOOL_F;
  GLOBAL(discr_tree_subsume_stratflag_global)=BOOL_T;
  GLOBAL(discr_depth_first_global)=BOOL_T;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(unit_equality_strat_global)=BOOL_F;
  GLOBAL(root_para_strat_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(user_criterias_pre_flag_global)=BOOL_F;
  GLOBAL(clause_keepdepth_limit_global)=MAKINUM(0);
  GLOBAL(clause_keeplength_limit_global)=MAKINUM(0);
  GLOBAL(clause_uselength_limit_global)=MAKINUM(0);
  GLOBAL(clause_finalkeepsize_limit_global)=MAKINUM(0);
  GLOBAL(clause_midsearch_keepsize_limit_global)=MAKINUM(0);
  GLOBAL(clause_usenr_limits_global)=EOL;
  GLOBAL(special_insertion_place_global)=EOL;
  GLOBAL(clause_usedepth_limits_global)=EOL;
  GLOBAL(clause_usestruct_limits_global)=EOL;
  return UNSPECIFIED;
}

SCM empty_cl_pred_(cl)
SCM cl;
{
  SCM resflag,new_var1,clpart;

  if(NFALSEP(GLOBAL(int_logic_flag_global))) {
    new_var1=SBOOL(NULL_P(cl));
    if(NFALSEP(new_var1))
      return new_var1;
    else
    if(NULL_P(CDR(cl)))
      return SBOOL(GLOBAL(int_outmost_label_fun_nr_global)==(MAKINUM(534773760)&CAR(CAR(cl))));
    else
      return BOOL_F;
  }
  else {
    resflag=BOOL_T;
    for(clpart=cl;!(NULL_P(clpart)||!(NFALSEP(resflag)));clpart=CDR(clpart))
      if(!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))))) {
        resflag=BOOL_F;
      }
    return resflag;
  }
}

SCM unit_cl_pred_(cl)
SCM cl;
{
  return SBOOL(NULL_P(CDR(cl)));
}

SCM double_cl_pred_(cl)
SCM cl;
{
  SCM new_var1;

  new_var1=SBOOL(NULL_P(CDR(cl)));
  if(NFALSEP(new_var1))
    return new_var1;
  else
    return SBOOL(NULL_P(CDR(CDR(cl))));
}

SCM first_nonans_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NULL_P(clpart)||!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart))))));clpart=CDR(clpart)) ;
  if(NULL_P(clpart))
    return BOOL_F;
  else
    return CAR(clpart);
}

SCM member_nonans_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NULL_P(clpart)||!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart))))));clpart=CDR(clpart)) ;
  if(NULL_P(clpart))
    return BOOL_F;
  else
    return clpart;
}

SCM member_ans_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NULL_P(clpart)||NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))));clpart=CDR(clpart)) ;
  if(NULL_P(clpart))
    return BOOL_F;
  else
    return clpart;
}

SCM remove_ans_literals(cl)
SCM cl;
{
  SCM resend,res,clpart;

  res=cons(EOL,EOL);
  resend=res;
  for(clpart=cl;!(NULL_P(clpart));clpart=CDR(clpart))
    if(!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))))) {
      SET_CDR(resend,cons(CAR(clpart),EOL));
      resend=CDR(resend);
    }
  return CDR(res);
}

SCM ground_fullcl_pred_(fullcl)
SCM fullcl;
{
  return NOT(SBOOL(ZERO_P(CAR(CAR(fullcl))&GLOBAL(cl_ground_flag_global))));
}

SCM positive_cl_pred_(cl)
SCM cl;
{
  SCM resflag,clpart;

  resflag=BOOL_T;
  for(clpart=cl;!(NULL_P(clpart)||!(NFALSEP(resflag)));clpart=CDR(clpart))
    if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))) {
      resflag=BOOL_F;
    }
  return resflag;
}

SCM negative_cl_pred_(cl)
SCM cl;
{
  SCM resflag,clpart;

  resflag=BOOL_T;
  for(clpart=cl;!(NULL_P(clpart)||!(NFALSEP(resflag)));clpart=CDR(clpart))
    if(!(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)))))) {
      resflag=BOOL_F;
    }
  return resflag;
}

SCM mixed_cl_pred_(cl)
SCM cl;
{
  SCM posflag,negflag,clpart;

  negflag=BOOL_F;
  posflag=BOOL_F;
  for(clpart=cl;!(NULL_P(clpart)||(NFALSEP(negflag)&&NFALSEP(posflag)));clpart=CDR(clpart))
    if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))) {
      negflag=BOOL_T;
    }
    else {
      posflag=BOOL_T;
    }
  if(NFALSEP(negflag))
    return posflag;
  else
    return BOOL_F;
}

SCM has_single_hyper_premiss_pred_(cl)
SCM cl;
{
  SCM count,clpart;

  count=MAKINUM(0);
  for(clpart=cl;!(NULL_P(clpart)||(count==MAKINUM(2)));clpart=CDR(clpart))
    if(NFALSEP((NFALSEP(GLOBAL(neg_hyper_strategy_flag_global)) ? SBOOL(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)))&&!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))))) : SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)))))))) {
      if(count==MAKINUM(0)) {
        count=MAKINUM(1);
      }
      else {
        count=MAKINUM(2);
      }
    }
  return NOT(SBOOL(count==MAKINUM(2)));
}

SCM first_hyper_premiss_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NFALSEP((NFALSEP(GLOBAL(neg_hyper_strategy_flag_global)) ? SBOOL(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)))&&!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart)))))) : SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))))));clpart=CDR(clpart)) ;
  return CAR(clpart);
}

SCM first_neg_lit(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart)));clpart=CDR(clpart)) ;
  return CAR(clpart);
}

SCM contains_eqlit_cl_pred_(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NULL_P(clpart)||(GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(CAR(clpart)))));clpart=CDR(clpart)) ;
  return NOT(SBOOL(NULL_P(clpart)));
}

SCM contains_eqorneg_cl_pred_(cl)
SCM cl;
{
  SCM clpart;

  for(clpart=cl;!(NULL_P(clpart)||(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(clpart))))||(GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(CAR(clpart))))));clpart=CDR(clpart)) ;
  return NOT(SBOOL(NULL_P(clpart)));
}

SCM commutative_fun_pred_(fun)
SCM fun;
{
  return BOOL_F;
}

SCM reflexive_fun_pred_(fun)
SCM fun;
{
  return BOOL_F;
}

SCM removable_tautology_pr_pred_(litinfcl_pr)
SCM litinfcl_pr;
{
  if(NFALSEP(GLOBAL(remove_all_tautologies_stratflag_global))&&NFALSEP(tautology_pure_cl_pred_(CDR(litinfcl_pr)))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(80)) {
      newline(cur_output_port());
      display(const_4,cur_output_port());
    }
    else
    if(NFALSEP(GLOBAL(display_info_char_flag_global)))
      display(const_5,cur_output_port());
    return BOOL_T;
  }
  else
    return BOOL_F;
}

SCM clause_pass_user_limits_post_pred_(purecl)
SCM purecl;
{
  SCM new_var1;

  if(ZERO_P(GLOBAL(clause_keepsize_limit_global))||NFALSEP(pass_keepsize_limit_pred_(purecl))) {
    if(ZERO_P(GLOBAL(clause_keepdepth_limit_global))||NFALSEP(pass_keepdepth_limit_pred_(purecl))) {
      new_var1=SBOOL(ZERO_P(GLOBAL(clause_keeplength_limit_global)));
      if(NFALSEP(new_var1))
        return new_var1;
      else
        return pass_keeplength_limit_pred_(purecl);
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM pass_keepdepth_limit_pred_(purecl)
SCM purecl;
{
  return every_pred_(pass_keepdepth_limit_pred__fn26,purecl);
}

SCM pass_keepdepth_limit_pred__fn26(lit)
SCM lit;
{
  return SBOOL((INUM(MAKINUM(63488)&CAR(lit))>>11)<=INUM(GLOBAL(clause_keepdepth_limit_global)));
}

SCM pass_keepsize_limit_pred_(purecl)
SCM purecl;
{
  SCM tmp,sum_nonkeyword,part;

  sum_nonkeyword=MAKINUM(0);
  tmp=MAKINUM(0);
  for(part=purecl;!(NULL_P(part)||(sum_nonkeyword>GLOBAL(clause_keepsize_limit_global)));part=CDR(part)) {
    tmp=MAKINUM(INUM(MAKINUM(2016)&CAR(CAR(part)))>>5);
    if(tmp>=MAKINUM(63)) {
      tmp=compute_real_termsize(CAR(part));
    }
    sum_nonkeyword=MAKINUM(INUM(sum_nonkeyword)+INUM(tmp));
  }
  return SBOOL(sum_nonkeyword<=GLOBAL(clause_keepsize_limit_global));
}

SCM compute_real_termsize(term)
SCM term;
{
  SCM tmp,sum_nonkeyword,part;

  sum_nonkeyword=MAKINUM(0);
  tmp=MAKINUM(0);
  if(NUMBER_P(term))
    return MAKINUM(1);
  else {
    tmp=MAKINUM(INUM(MAKINUM(2016)&CAR(term))>>5);
    if(tmp<MAKINUM(63))
      return tmp;
    else {
      for(part=term;!(NULL_P(part));part=CDR(part)) {
        sum_nonkeyword=MAKINUM(INUM(sum_nonkeyword)+INUM(compute_real_termsize(CAR(part))));
      }
      return MAKINUM(1+INUM(sum_nonkeyword));
    }
  }
}

SCM compute_real_clausesize(purecl)
SCM purecl;
{
  SCM res,part;

  res=MAKINUM(0);
  for(part=purecl;!(NULL_P(part));part=CDR(part)) {
    res=MAKINUM(INUM(res)+INUM(compute_real_termsize(CAR(part))));
  }
  return res;
}

SCM pass_keeplength_limit_pred_(purecl)
SCM purecl;
{
  return SBOOL(length(purecl)<=GLOBAL(clause_keeplength_limit_global));
}

SCM clause_pass_user_crit_post_pred_(inflist,purecl,hist)
SCM inflist,purecl,hist;
{
  SCM new_var1;

  if(NULL_P(GLOBAL(clause_usenr_limits_global))||NFALSEP(hist_pass_usenr_limits_pred_(hist))) {
    if(NULL_P(GLOBAL(clause_usedepth_limits_global))||NFALSEP(hist_pass_usedepth_limits_pred_(hist))) {
      new_var1=SBOOL(NULL_P(GLOBAL(clause_usestruct_limits_global)));
      if(NFALSEP(new_var1))
        return new_var1;
      else
        return hist_pass_usestruct_limits_pred_(hist);
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM hist_pass_usenr_limits_pred_(hist)
SCM hist;
{
  SCM countlst;

  countlst=map1(hist_pass_usenr_limits_pred__fn28,GLOBAL(clause_usenr_limits_global));
  return hist_count_check(countlst,hist);
}

SCM hist_pass_usenr_limits_pred__fn28(x)
SCM x;
{
  return cons(CAR(x),cons(MAKINUM(0),cons(CAR(CDR(x)),EOL)));
}

SCM hist_count_check(countlst,hist)
SCM countlst,hist;
{
  SCM constr;

tailrecursion:
  if(PAIR_P(hist)) {
    constr=CAR(hist);
    if(constr==hyper_symb) {
      if(NFALSEP(hist_count_check(countlst,CAR(CDR(CDR(hist))))))
        return every_pred__inst1(countlst,hist_count_check_fn30,CDR(CDR(CDR(hist))));
      else
        return BOOL_F;
    }
    else
    if(constr==literal_symb) {
      hist=CAR(CDR(hist));
      goto tailrecursion;
    }
    else
    if(constr==input_symb) {
      constr=assoc_memq(CAR(CDR(hist)),countlst);
      if(NFALSEP(constr)) {
        if(CAR(CDR(constr))==CAR(CDR(CDR(constr))))
          return BOOL_F;
        else {
          SET_CAR(CDR(constr),MAKINUM(1+INUM(CAR(CDR(constr)))));
          return BOOL_T;
        }
      }
      else
        return BOOL_T;
    }
    else
      return BOOL_T;
  }
  else
    return BOOL_T;
}

SCM hist_count_check_fn30(countlst,x)
SCM countlst,x;
{
  return hist_count_check(countlst,x);
}

SCM hist_pass_usedepth_limits_pred_(hist)
SCM hist;
{
  SCM constr,given,limit1,limit2;

  constr=CAR(hist);
  given=EOL;
  limit1=EOL;
  limit2=EOL;
  if(constr==para_symb) {
    limit1=CAR(CDR(CDR(hist)));
    limit2=CAR(CDR(CDR(CDR(hist))));
    if((input_symb==CAR(limit1))&&(NFALSEP((given=assq(CAR(CDR(limit1)),GLOBAL(clause_usedepth_limits_global)),UNSPECIFIED,given))&&NFALSEP(apply(GLOBAL(greater_clause_occ_depth_pred_),CAR(CDR(limit1)),cons(CDR(given),cons(limit2,listofnull))))))
      return BOOL_F;
    else
    if((input_symb==CAR(limit2))&&(NFALSEP((given=assq(CAR(CDR(limit2)),GLOBAL(clause_usedepth_limits_global)),UNSPECIFIED,given))&&NFALSEP(apply(GLOBAL(greater_clause_occ_depth_pred_),CAR(CDR(limit1)),cons(CDR(given),cons(limit1,listofnull))))))
      return BOOL_F;
    else
      return BOOL_T;
  }
  else
  if(constr==hyper_symb) {
    given=assq(CAR(CDR(CDR(hist))),GLOBAL(clause_usedepth_limits_global));
    if(!(NFALSEP(given)))
      return BOOL_T;
    else
      return NOT(apply(GLOBAL(greater_clause_occ_depth_pred_),CAR(CDR(CDR(hist))),cons(CDR(given),listofnull)));
  }
  else
    return UNSPECIFIED;
}

SCM hist_pass_usestruct_limits_pred_(hist)
SCM hist;
{
  SCM tmp,one_found,res,constr,place;

  constr=CAR(hist);
  res=BOOL_F;
  one_found=BOOL_F;
  tmp=EOL;
  if(constr==hyper_symb) {
    tmp=CAR(CDR(CAR(CDR(CDR(hist)))));
    for(place=member_if_inst1(tmp,hist_pass_usestruct_limits_pred__fn34,GLOBAL(clause_usestruct_limits_global));!(NULL_P(place)||(!(NFALSEP(place))||NFALSEP(res)));place=member_if_inst1(tmp,hist_pass_usestruct_limits_pred__fn33,CDR(place))) {
      one_found=BOOL_T;
      if(NFALSEP(hist_pass_usestruct_limits_hyper_pred_(hist,CAR(place)))) {
        res=BOOL_T;
      }
    }
    if(NFALSEP(res))
      return BOOL_T;
    else
      return NOT(one_found);
  }
  else
    return BOOL_T;
}

SCM hist_pass_usestruct_limits_pred__fn34(tmp,x)
SCM tmp,x;
{
  return SBOOL(CAR(x)==tmp);
}

SCM hist_pass_usestruct_limits_pred__fn33(tmp,x)
SCM tmp,x;
{
  return SBOOL(CAR(x)==tmp);
}

SCM hist_pass_usestruct_limits_hyper_pred_(hist,limitcase)
SCM hist,limitcase;
{
  SCM tmp,res,nr,els;

  nr=CAR(CDR(CAR(CDR(CDR(hist)))));
  res=BOOL_T;
  tmp=EOL;
  for(els=CDR(CDR(CDR(hist)));!(NULL_P(els)||!(NFALSEP(res)));els=CDR(els))
    if(PAIR_P(CAR(els))&&NFALSEP((tmp=get_hyper_hist_el_limitnr(CAR(els)),UNSPECIFIED,SBOOL(!(NFALSEP(some_pred__inst2(tmp,hist_pass_usestruct_limits_hyper_pred__fn36,CDR(limitcase)))))))) {
      res=BOOL_F;
    }
  return res;
}

SCM hist_pass_usestruct_limits_hyper_pred__fn36(tmp,x)
SCM tmp,x;
{
  return SBOOL((x==tmp)||(PAIR_P(x)&&(CAR(x)==tmp)));
}

SCM get_hyper_hist_el_limitnr(hist)
SCM hist;
{
tailrecursion:
  if(literal_symb==CAR(hist)) {
    hist=CAR(CDR(hist));
    goto tailrecursion;
  }
  else
  if(input_symb==CAR(hist))
    return CAR(CDR(hist));
  else
  if((hyper_symb==CAR(hist))||(fact_symb==CAR(hist))) {
    hist=CAR(CDR(CDR(hist)));
    goto tailrecursion;
  }
  else
    return MAKINUM(0);
}

SCM init_globals()
{
  init_one_pass_globals();
  GLOBAL(unit_equality_strat_global)=BOOL_F;
  GLOBAL(root_para_strat_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(use_real_time_global)=BOOL_F;
  GLOBAL(run_forever_flag_global)=BOOL_F;
  if(NFALSEP(GLOBAL(full_proof_strategy_flag_global))) {
    GLOBAL(keep_all_old_clauses_flag_global)=BOOL_T;
  }
  else {
    GLOBAL(keep_all_old_clauses_flag_global)=BOOL_F;
  }
  GLOBAL(all_back_subsumed_clauses_global)=EOL;
  GLOBAL(default_time_limit_global)=MAKINUM(300);
  if(!(NFALSEP(GLOBAL(args_timelimit_global)))) {
    GLOBAL(timelimit_global)=BOOL_F;
  }
  else {
    GLOBAL(timelimit_global)=GLOBAL(args_timelimit_global);
  }
  GLOBAL(foundflag_global)=BOOL_F;
  GLOBAL(sat_found_flag_global)=BOOL_F;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(checkpoint_keptnrs_global)=EOL;
  GLOBAL(sos_strategy_flag_global)=BOOL_T;
  GLOBAL(bliksem_strategy_flag_global)=BOOL_F;
  GLOBAL(ans_prohibited_funnrs_global)=EOL;
  GLOBAL(ans_prohibited_constnrs_global)=EOL;
  GLOBAL(ans_prohibited_prednrs_global)=EOL;
  GLOBAL(discr_tree_list_global)=EOL;
  GLOBAL(unit_alist_list_global)=EOL;
  GLOBAL(sos_clauses_list_list_global)=EOL;
  GLOBAL(usable_clauses_list_list_global)=EOL;
  GLOBAL(lex_symbol_orderlst_global)=EOL;
  GLOBAL(unit_alist_global)=EOL;
  GLOBAL(clause_finalkeepsize_limit_global)=MAKINUM(0);
  GLOBAL(clause_keepdepth_limit_global)=MAKINUM(0);
  GLOBAL(clause_keeplength_limit_global)=MAKINUM(0);
  GLOBAL(clause_uselength_limit_global)=MAKINUM(0);
  GLOBAL(prolog_style_variables_global)=BOOL_T;
  GLOBAL(const_num_table_global)=EOL;
  GLOBAL(const_num_global)=MAKINUM(0);
  GLOBAL(min_const_num_sub1_global)=MAKINUM(100000);
  GLOBAL(fun_num_table_global)=EOL;
  GLOBAL(fun_num_global)=MAKINUM(0);
  GLOBAL(min_fun_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_funs_global)=MAKINUM(255);
  GLOBAL(pred_num_table_global)=EOL;
  GLOBAL(pred_num_global)=MAKINUM(0);
  GLOBAL(min_pred_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_preds_global)=MAKINUM(127);
  GLOBAL(var_num_table_global)=EOL;
  GLOBAL(var_num_global)=MAKINUM(0);
  GLOBAL(min_var_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_vars_in_clause_global)=MAKINUM(255);
  return UNSPECIFIED;
}

SCM init_one_pass_globals()
{
  GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_F;
  GLOBAL(clause_usenr_limits_global)=EOL;
  GLOBAL(clause_usedepth_limits_global)=EOL;
  GLOBAL(clause_usestruct_limits_global)=EOL;
  GLOBAL(one_pass_kept_clauses_firstnr_global)=MAKINUM(1+INUM(GLOBAL(kept_clauses_nr_global)));
  GLOBAL(foundflag_global)=BOOL_F;
  GLOBAL(sat_found_flag_global)=BOOL_F;
  GLOBAL(answer_cl_global)=EOL;
  GLOBAL(answer_history_global)=EOL;
  GLOBAL(too_many_vars_flag_global)=BOOL_F;
  GLOBAL(lex_symbol_orderlst_global)=EOL;
  GLOBAL(sos_clauses_list_global)=EOL;
  GLOBAL(sos_clauses_list_end_global)=EOL;
  GLOBAL(ans_input_sos_global)=EOL;
  GLOBAL(usable_clauses_list_global)=EOL;
  GLOBAL(usable_clauses_list_end_global)=EOL;
  GLOBAL(subsumption_list_global)=cons(cons(MAKINUM(0),EOL),EOL);
  GLOBAL(unit_alist_global)=EOL;
  GLOBAL(discr_tree_global)=cons(EOL,EOL);
  GLOBAL(nonunit_discr_tree_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_terms_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_atoms_global)=cons(EOL,EOL);
  GLOBAL(sos_clauses_list_list_global)=EOL;
  GLOBAL(usable_clauses_list_list_global)=EOL;
  return UNSPECIFIED;
}

SCM init_one_pass_globals_combinedstrategy()
{
  GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_F;
  GLOBAL(clause_usenr_limits_global)=EOL;
  GLOBAL(clause_usedepth_limits_global)=EOL;
  GLOBAL(clause_usestruct_limits_global)=EOL;
  GLOBAL(one_pass_kept_clauses_firstnr_global)=MAKINUM(1+INUM(GLOBAL(kept_clauses_nr_global)));
  GLOBAL(foundflag_global)=BOOL_F;
  GLOBAL(sat_found_flag_global)=BOOL_F;
  GLOBAL(answer_cl_global)=EOL;
  GLOBAL(answer_history_global)=EOL;
  GLOBAL(too_many_vars_flag_global)=BOOL_F;
  GLOBAL(lex_symbol_orderlst_global)=EOL;
  GLOBAL(sos_clauses_list_global)=EOL;
  GLOBAL(sos_clauses_list_end_global)=EOL;
  GLOBAL(ans_input_sos_global)=EOL;
  GLOBAL(usable_clauses_list_global)=EOL;
  GLOBAL(usable_clauses_list_end_global)=EOL;
  GLOBAL(subsumption_list_global)=cons(cons(MAKINUM(0),EOL),EOL);
  GLOBAL(discr_tree_global)=cons(EOL,EOL);
  return UNSPECIFIED;
}

SCM init_stats()
{
  GLOBAL(given_clause_nr_global)=MAKINUM(0);
  GLOBAL(derived_clauses_nr_global)=MAKINUM(0);
  GLOBAL(kept_clauses_nr_global)=MAKINUM(0);
  GLOBAL(kept_size_sum_nr_global)=MAKINUM(0);
  GLOBAL(last_usable_cl_nr_global)=MAKINUM(0);
  GLOBAL(kept_mid_nucleus_nr_global)=MAKINUM(0);
  GLOBAL(kept_new_demodulators_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_unit_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_nonunit_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_double_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_overdouble_nr_global)=MAKINUM(0);
  GLOBAL(back_subsumed_nr_global)=MAKINUM(0);
  GLOBAL(havealready_timecounter_global)=MAKINUM(0);
  GLOBAL(simple_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(full_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(double_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(proof_start_real_time_global)=apply(GLOBAL(get_internal_real_time),EOL,EOL);
  GLOBAL(proof_start_run_time_global)=my_time();
  GLOBAL(subs_tried_nr_global)=MAKINUM(0);
  GLOBAL(subs_length_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_strength_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_aux_strength_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_gclpreds_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_funlist_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_reg_subs_tried_nr_global)=MAKINUM(0);
  GLOBAL(subs_reg_subs_fail_nr_global)=MAKINUM(0);
  return UNSPECIFIED;
}

SCM show_stats()
{
  show_main_stats();
  return show_subsumption_stats();
}

SCM show_main_stats()
{
  newline(cur_output_port());
  display(const_6,cur_output_port());
  newline(cur_output_port());
  newline(cur_output_port());
  display(const_7,cur_output_port());
  display(GLOBAL(given_clause_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_8,cur_output_port());
  display(GLOBAL(derived_clauses_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_9,cur_output_port());
  display(GLOBAL(kept_clauses_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_10,cur_output_port());
  display(GLOBAL(kept_size_sum_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_11,cur_output_port());
  display(GLOBAL(kept_mid_nucleus_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_12,cur_output_port());
  display(GLOBAL(kept_new_demodulators_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_13,cur_output_port());
  display(GLOBAL(forward_subsumed_unit_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_14,cur_output_port());
  display(GLOBAL(forward_subsumed_double_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_15,cur_output_port());
  display(GLOBAL(forward_subsumed_overdouble_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_16,cur_output_port());
  display(GLOBAL(back_subsumed_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_17,cur_output_port());
  display(GLOBAL(simple_unit_cutoff_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_18,cur_output_port());
  display(GLOBAL(full_unit_cutoff_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_19,cur_output_port());
  display(GLOBAL(double_unit_cutoff_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_20,cur_output_port());
  display_time_seconds(MAKINUM(INUM(apply(GLOBAL(get_internal_real_time),EOL,EOL))-INUM(GLOBAL(proof_start_real_time_global))));
  newline(cur_output_port());
  display(const_21,cur_output_port());
  display_time_seconds(MAKINUM(INUM(my_time())-INUM(GLOBAL(proof_start_run_time_global))));
  return newline(cur_output_port());
}

SCM show_subsumption_stats()
{
  display(const_22,cur_output_port());
  newline(cur_output_port());
  display(const_23,cur_output_port());
  display(GLOBAL(subs_tried_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_24,cur_output_port());
  display(GLOBAL(subs_length_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_25,cur_output_port());
  display(GLOBAL(subs_strength_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_26,cur_output_port());
  display(GLOBAL(subs_gclpreds_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_27,cur_output_port());
  display(GLOBAL(subs_aux_strength_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_28,cur_output_port());
  display(GLOBAL(subs_funlist_fail_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_29,cur_output_port());
  display(GLOBAL(subs_reg_subs_tried_nr_global),cur_output_port());
  newline(cur_output_port());
  display(const_30,cur_output_port());
  display(GLOBAL(subs_reg_subs_fail_nr_global),cur_output_port());
  return newline(cur_output_port());
}

SCM display_time_seconds(units)
SCM units;
{
  SCM full,rest;

  full=MAKINUM(INUM(units)/INUM(GLOBAL(internal_time_units_per_second)));
  rest=MAKINUM(INUM(units)%INUM(GLOBAL(internal_time_units_per_second)));
  display(full,cur_output_port());
  display(MAKICHR('.'),cur_output_port());
  return display(rest,cur_output_port());
}

SCM mkstring_time_seconds(units)
SCM units;
{
  SCM full,rest;

  full=MAKINUM(INUM(units)/INUM(GLOBAL(internal_time_units_per_second)));
  rest=MAKINUM(INUM(units)%INUM(GLOBAL(internal_time_units_per_second)));
  return st_append(cons(number2string(full,MAKINUM(10)),cons(st_append(cons(const_31,cons(number2string(rest,MAKINUM(10)),EOL))),EOL)));
}

SCM gandalf_remove_tempfiles()
{
  if(NFALSEP(GLOBAL(prop_conversion_file_name_global))&&(!(NULL_P(GLOBAL(prop_conversion_file_name_global)))&&!(NFALSEP(equal(GLOBAL(prop_conversion_file_name_global),const_32))))) {
    lsystem(st_append(cons(const_33,cons(GLOBAL(prop_conversion_file_name_global),EOL))));
    lsystem(st_append(cons(const_34,cons(GLOBAL(prop_conversion_temp_file_name_global),EOL))));
    lsystem(st_append(cons(const_35,cons(GLOBAL(prop_conversion_header_file_name_global),EOL))));
    return lsystem(st_append(cons(const_36,cons(GLOBAL(prop_conversion_result_file_name_global),EOL))));
  }
  else
    return UNSPECIFIED;
}

SCM gandalf_set_pid(i)
SCM i;
{
  GLOBAL(gandalf_pid_global)=i;
  return UNSPECIFIED;
}

SCM fsat(filename)
SCM filename;
{
  GLOBAL(sat_strategy_flag_global)=BOOL_T;
  return fprove(filename);
}

SCM fprove(filename)
SCM filename;
{
  SCM tmpname,rawlst,clauselst,readylst,res;

  GLOBAL(run_id_global)=st_append(cons(number2string(GLOBAL(gandalf_pid_global),MAKINUM(10)),cons(st_append(cons(string_lastn(number2string(apply(GLOBAL(current_time),EOL,EOL),MAKINUM(10)),MAKINUM(5)),cons(string_firstn(path_string_endpart(filename),MAKINUM(10)),EOL))),EOL)));
  GLOBAL(gandalf_program_arguments_global)=apply(GLOBAL(program_arguments),EOL,EOL);
  if(NFALSEP(st_equal(const_37,path_string_endpart(CAR(GLOBAL(gandalf_program_arguments_global)))))||NFALSEP(st_equal(const_38,path_string_endpart(CAR(GLOBAL(gandalf_program_arguments_global)))))) {
    GLOBAL(intepreter_mode_global)=BOOL_T;
  }
  else {
    GLOBAL(intepreter_mode_global)=BOOL_F;
  }
  init_globals();
  GLOBAL(sos_exhausted_flag_global)=BOOL_F;
  GLOBAL(auto_mode_flag_global)=BOOL_T;
  if(NFALSEP(GLOBAL(sat_strategy_flag_global))) {
    GLOBAL(display_info_level_global)=MAKINUM(30);
  }
  else {
    GLOBAL(display_info_level_global)=MAKINUM(30);
  }
  preprocess_otter_file(filename);
  tmpname=GLOBAL(otter_tmpfile_global);
  rawlst=read_processed_otter_file(tmpname);
  clauselst=read_otter_list_clauses(rawlst);
  readylst=EOL;
  res=BOOL_F;
  GLOBAL(ans_prohibited_constsymbs_global)=EOL;
  GLOBAL(ans_prohibited_predsymbs_global)=EOL;
  GLOBAL(ans_prohibited_funsymbs_global)=EOL;
  readylst=sort_out_otter_list_clauses(clauselst);
  readylst=curry_input_readylst(readylst);
  res=prove(readylst,MAKINUM(99999999),MAKINUM(50));
  if(NFALSEP(res)) {
    if(0) {
      newline(cur_output_port());
      if(!(NULL_P(GLOBAL(answer_cl_global)))) {
        display(const_39,cur_output_port());
        print_pure_clause(GLOBAL(answer_cl_global));
        newline(cur_output_port());
      }
      if(!(NFALSEP(GLOBAL(prop_unsat_strat_global))))
        show_history(GLOBAL(answer_history_global));
    }
    newline(cur_output_port());
    display(const_40,cur_output_port());
    newline(cur_output_port());
    BOOL_T;
  }
  else
  if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
    if(NFALSEP(GLOBAL(sat_strategy_flag_global))&&(NFALSEP(GLOBAL(sos_exhausted_flag_global))&&NFALSEP(GLOBAL(complete_unsat_strategy_global)))) {
      newline(cur_output_port());
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global)))) {
        display(const_41,cur_output_port());
        newline(cur_output_port());
        GLOBAL(sat_found_flag_global)=BOOL_T;
      }
      BOOL_F;
    }
    else
    if(GLOBAL(answer_history_global)==not_enough_time_symb) {
      newline(cur_output_port());
      display(const_42,cur_output_port());
      newline(cur_output_port());
      BOOL_F;
    }
    else {
      newline(cur_output_port());
      display(const_43,cur_output_port());
      newline(cur_output_port());
      if(NFALSEP(GLOBAL(sat_strategy_flag_global))&&(NFALSEP(GLOBAL(sos_exhausted_flag_global))&&NFALSEP(GLOBAL(complete_unsat_strategy_global)))) {
        if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global))))
          display(const_44,cur_output_port());
        newline(cur_output_port());
      }
      BOOL_F;
    }
  }
  else
    BOOL_F;
  if(GLOBAL(display_info_level_global)>=MAKINUM(35))
    show_stats();
  if(NFALSEP(res))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM sprove(filename)
SCM filename;
{
  GLOBAL(sat_strategy_flag_global)=BOOL_T;
  return fprove(filename);
}

SCM path_string_endpart(str)
SCM str;
{
  SCM resstr,origstr,i;

  origstr=str;
  resstr=const_45;
  for(i=MAKINUM(INUM(ST_LENGTH(str))-1);!((i<MAKINUM(0))||(MAKICHR('/')==ST_REF(str,i)));i=MAKINUM(INUM(i)-1)) {
    resstr=st_append(cons(string(cons(ST_REF(str,i),EOL)),cons(resstr,EOL)));
  }
  return resstr;
}

SCM path_string_startpart(str)
SCM str;
{
  SCM endpart;

  endpart=path_string_endpart(str);
  return substring(str,MAKINUM(0),MAKINUM(INUM(ST_LENGTH(str))-INUM(ST_LENGTH(endpart))));
}

SCM string_firstn(str,n)
SCM str,n;
{
  SCM l;

  l=ST_LENGTH(str);
  if(n>l)
    return str;
  else
    return substring(str,MAKINUM(0),n);
}

SCM string_lastn(str,n)
SCM str,n;
{
  SCM l;

  l=ST_LENGTH(str);
  if(n>l)
    return str;
  else
    return substring(str,MAKINUM(INUM(l)-INUM(n)),l);
}

SCM use_input_settings(raw_input)
SCM raw_input;
{
  SCM setlist,clearlist,assignlist;

  setlist=assq(set_symb,raw_input);
  clearlist=assq(clear_symb,raw_input);
  assignlist=assq(assign_symb,raw_input);
  if(!(NFALSEP(setlist))) {
    setlist=EOL;
  }
  if(!(NFALSEP(clearlist))) {
    clearlist=EOL;
  }
  if(!(NFALSEP(assignlist))) {
    assignlist=EOL;
  }
  for_each1(use_input_settings_fn40,setlist);
  for_each1(use_input_settings_fn41,clearlist);
  return for_each1(use_input_settings_fn42,assignlist);
}

SCM use_input_settings_fn42(el)
SCM el;
{
  SCM new_var1,new_var2;

  new_var1=NOT(SBOOL(PAIR_P(el)));
  if(NFALSEP(new_var1))
    return new_var1;
  else {
    new_var2=NOT(SBOOL(PAIR_P(CDR(el))));
    if(NFALSEP(new_var2))
      return new_var2;
    else
    if(preference_ratio_symb==CAR(el)) {
      GLOBAL(global_sos_preference_ratio_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(checkpoints_symb==CAR(el)) {
      GLOBAL(given_checkpoint_keptnrs_global)=CDR(CAR(CDR(el)));
      return UNSPECIFIED;
    }
    else
    if(max_kept_symb==CAR(el)) {
      GLOBAL(max_kept_clauses_nr_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(max_size_sum_symb==CAR(el)) {
      GLOBAL(max_size_sum_nr_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(max_seconds_symb==CAR(el)) {
      if(!(NFALSEP(GLOBAL(timelimit_global)))) {
        GLOBAL(timelimit_global)=number2string(CAR(CDR(el)),MAKINUM(10));
        return UNSPECIFIED;
      }
      else
        return UNSPECIFIED;
    }
    else
    if(print_level_symb==CAR(el)) {
      GLOBAL(display_info_level_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(max_literals_symb==CAR(el)) {
      GLOBAL(clause_keeplength_limit_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(max_weight_symb==CAR(el)) {
      GLOBAL(clause_keepsize_limit_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
    if(max_depth_symb==CAR(el)) {
      GLOBAL(clause_keepdepth_limit_global)=CAR(CDR(el));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
}

SCM use_input_settings_fn41(el)
SCM el;
{
  if(el==prolog_style_variables_symb) {
    GLOBAL(prolog_style_variables_global)=BOOL_F;
    return UNSPECIFIED;
  }
  else
  if(el==split_symb) {
    GLOBAL(splitting_allowed_flag_global)=BOOL_F;
    return UNSPECIFIED;
  }
  else
  if(el==paramodulate_symb) {
    GLOBAL(paramodulation_allowed_flag_global)=BOOL_F;
    return UNSPECIFIED;
  }
  else
  if(el==demodulate_symb)
    return turn_off_demodulation();
  else
    return UNSPECIFIED;
}

SCM use_input_settings_fn40(el)
SCM el;
{
  if(el==binary_exporder_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_exp_order_strat();
  }
  else
  if(el==binary_eprorder_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_epr_order_strat();
  }
  else
  if(el==binary_posweight_kb_big_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_binres_kb_big_strat();
  }
  else
  if(el==binary_posweight_kb_small_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_binres_kb_small_strat();
  }
  else
  if(el==binary_posweight_lex_big_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_binres_lex_big_strat();
  }
  else
  if(el==binary_posweight_lex_small_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_binres_kb_big_strat();
  }
  else
  if(el==binary_posweight_firstpred_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_firstpref_strat();
  }
  else
  if(el==hyper_order_uniteq_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_ordered_hyper_uniteq_strat();
  }
  else
  if(el==binary_unit_uniteq_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_unit_uniteq_strat();
  }
  else
  if(el==binary_nameorder_uniteq_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_name_ordered_binres_uniteq_strat();
  }
  else
  if(el==binary_order_uniteq_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_ordered_binres_uniteq_strat();
  }
  else
  if(el==binary_order_sos_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_ordered_binres_sos_strat();
  }
  else
  if(el==binary_nameorder_sos_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_name_ordered_binres_sos_strat();
  }
  else
  if(el==binary_uniteq_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_binres_uniteq_strat();
  }
  else
  if(el==binary_posweightorder_sos_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_binres_sos_strat();
  }
  else
  if(el==binary_negweightorder_sos_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_negweight_ordered_binres_sos_strat();
  }
  else
  if(el==binary_order_fulleq_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_ordered_binres_fulleq_strat();
  }
  else
  if(el==auto_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==hyper_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_hyper_strat();
  }
  else
  if(el==hyper_order_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_ordered_hyper_strat();
  }
  else
  if(el==binary_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_binres_strat();
  }
  else
  if(el==binary_order_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_ordered_binres_strat();
  }
  else
  if(el==binary_nameorder_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_name_ordered_binres_strat();
  }
  else
  if(el==binary_weightorder_sos_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_weight_ordered_binres_sos_strat();
  }
  else
  if(el==binary_weightorder_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_weight_ordered_binres_strat();
  }
  else
  if(el==binary_posweightorder_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_binres_strat();
  }
  else
  if(el==binary_negweightorder_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_negweight_ordered_binres_strat();
  }
  else
  if(el==binary_hypersos_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_binary_hyper_sos_strat();
  }
  else
  if(el==binary_unit_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_unit_strat();
  }
  else
  if(el==binary_double_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_double_strat();
  }
  else
  if(el==binary_posweightunit_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_posweight_ordered_unit_strat();
  }
  else
  if(el==binary_negweightunit_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_negweight_ordered_unit_strat();
  }
  else
  if(el==binary_synth_res_symb) {
    GLOBAL(auto_mode_flag_global)=BOOL_F;
    return init_synth_strat();
  }
  else
  if(el==eq_order_lex_symb) {
    clear_eq_order_strat();
    GLOBAL(order_equality_lex_strat_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==eq_order_kb_symb) {
    clear_eq_order_strat();
    GLOBAL(order_equality_kb_strat_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==eq_order_firstpref_symb) {
    clear_eq_order_strat();
    GLOBAL(order_equality_firstpref_strat_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==eq_order_depth_symb) {
    clear_eq_order_strat();
    GLOBAL(order_equality_lex_strat_global)=BOOL_F;
    return UNSPECIFIED;
  }
  else
  if(el==check_hypercontra_symb) {
    GLOBAL(hyper_contradiction_strategy_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==demodulate_symb)
    return turn_on_demodulation();
  else
  if(el==back_demodulate_symb) {
    turn_on_demodulation();
    GLOBAL(back_demodulate_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==split_symb) {
    GLOBAL(split_strategy_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==wall_time_symb) {
    GLOBAL(use_real_time_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==run_forever_symb) {
    GLOBAL(run_forever_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(print_tracechar_symb==el) {
    GLOBAL(display_info_char_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(print_debug_symb==el) {
    GLOBAL(display_debug_info_flag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
  if(el==otter_style_variables_symb) {
    GLOBAL(prolog_style_variables_global)=BOOL_F;
    return UNSPECIFIED;
  }
  else
  if(el==prolog_style_variables_symb) {
    GLOBAL(prolog_style_variables_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM sort_out_otter_list_clauses(otterlst)
SCM otterlst;
{
  SCM res,usableformulalist,eol_reached,curlist,cl,assignlist,clearlist,setlist,commandlist,demodlist,axiomslist,sosusablelist,sosformulalist,usablelist,soslist,part;

  soslist=EOL;
  usablelist=EOL;
  sosformulalist=EOL;
  sosusablelist=EOL;
  axiomslist=EOL;
  demodlist=EOL;
  commandlist=EOL;
  setlist=EOL;
  clearlist=EOL;
  assignlist=EOL;
  cl=EOL;
  curlist=EOL;
  eol_reached=BOOL_T;
  usableformulalist=EOL;
  res=EOL;
  for(part=otterlst;!(NULL_P(part));part=CDR(part)) {
    cl=CAR(part);
    if(!(PAIR_P(cl)))
      report_error(const_46,cons(cl,EOL));
    else
    if(CAR(cl)==end_of_list_symb) {
      eol_reached=BOOL_T;
      curlist=BOOL_F;
    }
    else
    if(PAIR_P(CAR(cl))&&((assign_symb==CAR(CAR(cl)))&&(prohibit_ans_pred_symb==CAR(CDR(CAR(cl)))))) {
      GLOBAL(ans_prohibited_predsymbs_global)=CAR(CDR(CDR(CAR(cl))));
    }
    else
    if(PAIR_P(CAR(cl))&&((assign_symb==CAR(CAR(cl)))&&(prohibit_ans_fun_symb==CAR(CDR(CAR(cl)))))) {
      GLOBAL(ans_prohibited_funsymbs_global)=CAR(CDR(CDR(CAR(cl))));
    }
    else
    if(PAIR_P(CAR(cl))&&((assign_symb==CAR(CAR(cl)))&&(prohibit_ans_const_symb==CAR(CDR(CAR(cl)))))) {
      GLOBAL(ans_prohibited_constsymbs_global)=CAR(CDR(CDR(CAR(cl))));
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&(PAIR_P(CAR(cl))&&((list_symb==CAR(CAR(cl)))&&(sos_symb==CAR(CDR(CAR(cl)))))))) {
      eol_reached=BOOL_F;
      curlist=sos_symb;
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&(PAIR_P(CAR(cl))&&((list_symb==CAR(CAR(cl)))&&(usable_symb==CAR(CDR(CAR(cl)))))))) {
      eol_reached=BOOL_F;
      curlist=usable_symb;
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&(PAIR_P(CAR(cl))&&((formula_list_symb==CAR(CAR(cl)))&&(sos_symb==CAR(CDR(CAR(cl)))))))) {
      eol_reached=BOOL_F;
      curlist=sosformula_symb;
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&(PAIR_P(CAR(cl))&&((formula_list_symb==CAR(CAR(cl)))&&(usable_symb==CAR(CDR(CAR(cl)))))))) {
      eol_reached=BOOL_F;
      curlist=usableformula_symb;
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&(PAIR_P(CAR(cl))&&((list_symb==CAR(CAR(cl)))&&(axioms_symb==CAR(CDR(CAR(cl)))))))) {
      eol_reached=BOOL_F;
      curlist=axioms_symb;
    }
    else
    if(NULL_P(CDR(cl))&&(NFALSEP(eol_reached)&&(PAIR_P(CAR(cl))&&((list_symb==CAR(CAR(cl)))&&(demodulators_symb==CAR(CDR(CAR(cl)))))))) {
      eol_reached=BOOL_F;
      curlist=demodulators_symb;
    }
    else
    if(curlist==sos_symb) {
      soslist=cons(cl,soslist);
    }
    else
    if(curlist==usable_symb) {
      usablelist=cons(cl,usablelist);
    }
    else
    if(curlist==sosformula_symb) {
      sosformulalist=cons(cl,sosformulalist);
    }
    else
    if(curlist==usableformula_symb) {
      usableformulalist=cons(cl,usableformulalist);
    }
    else
    if(curlist==axioms_symb) {
      axiomslist=cons(cl,axiomslist);
    }
    else
    if(curlist==demodulators_symb) {
      demodlist=cons(cl,demodlist);
    }
    else
    if(!(PAIR_P(CAR(cl))))
      report_error(const_47,cons(cl,EOL));
    else
    if(set_symb==CAR(CAR(cl))) {
      if(!(PAIR_P(CDR(CAR(cl)))))
        report_error(const_48,cons(cl,EOL));
      setlist=cons(CAR(CDR(CAR(cl))),setlist);
    }
    else
    if(clear_symb==CAR(CAR(cl))) {
      if(!(PAIR_P(CDR(CAR(cl)))))
        report_error(const_49,cons(cl,EOL));
      clearlist=cons(CAR(CDR(CAR(cl))),clearlist);
    }
    else
    if(assign_symb==CAR(CAR(cl))) {
      if(!(PAIR_P(CDR(CAR(cl))))||!(PAIR_P(CDR(CDR(CAR(cl))))))
        report_error(const_50,cons(cl,EOL));
      assignlist=cons(CDR(CAR(cl)),assignlist);
    }
    else {
      commandlist=cons(cl,commandlist);
    }
  }
  if(!(NULL_P(soslist))) {
    res=cons(cons(sos_symb,reverse(prop_conv(soslist))),res);
  }
  if(!(NULL_P(usablelist))) {
    res=cons(cons(usable_symb,reverse(prop_conv(usablelist))),res);
  }
  if(!(NULL_P(sosformulalist))) {
    res=cons(cons(sosformula_symb,reverse(prop_conv(sosformulalist))),res);
  }
  if(!(NULL_P(usableformulalist))) {
    res=cons(cons(usableformula_symb,reverse(prop_conv(usableformulalist))),res);
  }
  if(!(NULL_P(axiomslist))) {
    res=cons(cons(axioms_symb,reverse(axiomslist)),res);
  }
  if(!(NULL_P(demodlist))) {
    res=cons(cons(demodulators_symb,reverse(demodlist)),res);
  }
  if(!(NULL_P(setlist))) {
    res=cons(cons(set_symb,setlist),res);
  }
  if(!(NULL_P(clearlist))) {
    res=cons(cons(clear_symb,clearlist),res);
  }
  if(!(NULL_P(assignlist))) {
    res=cons(cons(assign_symb,assignlist),res);
  }
  if(!(NULL_P(commandlist))) {
    res=cons(cons(command_symb,commandlist),res);
  }
  return res;
}

SCM prop_conv(lst)
SCM lst;
{
  return map1(prop_conv_fn45,lst);
}

SCM prop_conv_fn45(cl)
SCM cl;
{
  return map1(prop_conv_fn46,cl);
}

SCM prop_conv_fn46(lit)
SCM lit;
{
  if(PAIR_P(lit))
    return lit;
  else
    return cons(lit,cons(MAKINUM(0),EOL));
}

SCM read_otter_list_clauses(otterlst)
SCM otterlst;
{
  SCM part,clause_rest,res;

  part=otterlst;
  clause_rest=EOL;
  res=EOL;
  GLOBAL(parse_formula_context_global)=BOOL_F;
  for(;!(NULL_P(part));) {
    clause_rest=parse_otter_clause(part);
    res=cons(CAR(clause_rest),res);
    part=CDR(clause_rest);
  }
  return reverse(res);
}

SCM parse_otter_clause(lst)
SCM lst;
{
  SCM new_var1,part,res,endflag,tmp1,tmp;

  part=lst;
  res=EOL;
  endflag=BOOL_F;
  tmp1=EOL;
  for(;!(NFALSEP(endflag));) {
    if(PAIR_P(part)&&(CAR(part)==formula_list_symb)) {
      GLOBAL(parse_formula_context_global)=BOOL_T;
    }
    if(PAIR_P(part)&&(CAR(part)==end_of_list_symb)) {
      GLOBAL(parse_formula_context_global)=BOOL_F;
    }
    if(PAIR_P(part)&&(PAIR_P(CDR(part))&&(PAIR_P(CDR(CDR(part)))&&((_equal__symb==CAR(CDR(part)))||(_excl__equal__symb==CAR(CDR(part))))))) {
      if(_excl__equal__symb==CAR(CDR(part))) {
        tmp1=string2symbol(st_append(cons(const_51,cons(symbol2string(GLOBAL(eq_symbol_global)),EOL))));
      }
      else {
        tmp1=GLOBAL(eq_symbol_global);
      }
      part=append2(cons(tmp1,cons(cons(CAR(part),cons(_excl__symb,cons(CAR(CDR(CDR(part))),EOL))),EOL)),CDR(CDR(CDR(part))));
    }
    if(NFALSEP(GLOBAL(parse_formula_context_global))) {
      if(GLOBAL(otter_dot_repl_global)==CAR(part)) {
        endflag=BOOL_T;
      }
      else {
        res=cons(CAR(part),res);
      }
    }
    else
    if(GLOBAL(otter_dot_repl_global)==CAR(part)) {
      endflag=BOOL_T;
    }
    else {
      new_var1=SBOOL(GLOBAL(otter_or_symbol_global)==CAR(part));
      if(NFALSEP(new_var1)) ;
      else
      if(SYMBOL_P(CAR(part))||NUMBER_P(CAR(part))) {
        if(NULL_P(CDR(part)))
          report_error(const_52,EOL);
        else
        if(GLOBAL(otter_dot_repl_global)==CAR(CDR(part))) {
          res=cons(CAR(part),res);
        }
        else
        if(GLOBAL(otter_or_symbol_global)==CAR(CDR(part))) {
          if(NULL_P(CDR(CDR(part))))
            report_error(const_53,EOL);
          else {
            res=cons(CAR(part),res);
          }
        }
        else
        if(!(PAIR_P(CAR(CDR(part)))))
          report_error(const_54,EOL);
        else {
          tmp=parse_otter_explist(CAR(CDR(part)));
          res=cons(cons(CAR(part),tmp),res);
          part=CDR(part);
        }
      }
      else
      if(PAIR_P(CAR(part)))
        report_error(const_55,EOL);
    }
    if(!(NULL_P(part))) {
      part=CDR(part);
    }
  }
  if(NFALSEP(GLOBAL(parse_formula_context_global)))
    return cons(cons(make_prefix_formula(reverse(res)),EOL),part);
  else
    return cons(reverse(res),part);
}

SCM make_prefix_formula(form)
SCM form;
{
  return form;
}

SCM make_prefix_formula_term_aux(term,termflag)
SCM term,termflag;
{
  SCM tmp_var1,tmp_var2;

tailrecursion:
  if(!(PAIR_P(term)))
    return term;
  else
  if(NFALSEP(listp(term))) {
    if(NFALSEP(memq(GLOBAL(otter_comma_repl_global),term))) {
      term=remove_eq(GLOBAL(otter_comma_repl_global),term);
    }
    if(!(NFALSEP(termflag))&&((CAR(term)==GLOBAL(exists_symbol_global))||(CAR(term)==GLOBAL(all_symbol_global)))) {
      if(NULL_P(CDR(term))||NULL_P(CDR(CDR(term))))
        return formula_syntax_error(const_56,term);
      else
      if(PAIR_P(CAR(CDR(term))))
        return formula_syntax_error(const_57,term);
      else
      if(SYMBOL_P(CAR(CDR(CDR(term))))&&NULL_P(CDR(CDR(CDR(term)))))
        return CAR(CDR(CDR(term)));
      else
      if(SYMBOL_P(CAR(CDR(CDR(term))))&&(PAIR_P(CAR(CDR(CDR(CDR(term)))))&&NULL_P(CDR(CDR(CDR(CDR(term)))))))
        return cons(CAR(term),cons(CAR(CDR(term)),cons(make_prefix_formula_term_aux(cons(CAR(CDR(CDR(term))),CAR(CDR(CDR(CDR(term))))),BOOL_T),EOL)));
      else
      if((CAR(CDR(CDR(term)))==GLOBAL(exists_symbol_global))||(CAR(CDR(CDR(term)))==GLOBAL(all_symbol_global)))
        return cons(CAR(term),cons(CAR(CDR(term)),cons(make_prefix_formula_term_aux(CDR(CDR(term)),BOOL_F),EOL)));
      else
      if(!(NULL_P(CDR(CDR(CDR(term))))))
        return formula_syntax_error(const_58,term);
      else
        return cons(CAR(term),cons(CAR(CDR(term)),cons(make_prefix_formula_term_aux(CAR(CDR(CDR(term))),BOOL_F),EOL)));
    }
    else
    if(!(NFALSEP(termflag))&&(CAR(term)==GLOBAL(not_symbol_global))) {
      if(NULL_P(CDR(term)))
        return formula_syntax_error(const_59,term);
      else
      if(SYMBOL_P(CAR(CDR(term)))&&NULL_P(CDR(CDR(term))))
        return make_neg_symbol(CAR(CDR(term)));
      else
      if(!(PAIR_P(CAR(CDR(term))))&&NULL_P(CDR(CDR(term))))
        return formula_syntax_error(const_60,term);
      else
      if(SYMBOL_P(CAR(CDR(term)))&&(PAIR_P(CAR(CDR(CDR(term))))&&NULL_P(CDR(CDR(CDR(term)))))) {
        tmp_var1=cons(make_neg_symbol(CAR(CDR(term))),CAR(CDR(CDR(term))));
        tmp_var2=BOOL_T;
        term=tmp_var1;
        termflag=tmp_var2;
        goto tailrecursion;
      }
      else
        return cons(CAR(term),cons(make_prefix_formula_term_aux(CDR(term),BOOL_F),EOL));
    }
    else
    if(!(NFALSEP(termflag))&&(PAIR_P(CDR(term))&&(((CAR(CDR(term))==GLOBAL(and_symbol_global))||((CAR(CDR(term))==GLOBAL(or_symbol_global))||((CAR(CDR(term))==GLOBAL(imp_symbol_global))||(CAR(CDR(term))==GLOBAL(equivalent_symbol_global)))))&&NULL_P(CDR(CDR(term))))))
      return formula_syntax_error(const_61,term);
    else
    if(!(NFALSEP(termflag))&&(((CAR(term)==GLOBAL(and_symbol_global))||((CAR(term)==GLOBAL(or_symbol_global))||((CAR(term)==GLOBAL(imp_symbol_global))||(CAR(term)==GLOBAL(equivalent_symbol_global)))))&&(NULL_P(CDR(term))||NULL_P(CDR(CDR(term))))))
      return formula_syntax_error(const_62,term);
    else
    if(!(NFALSEP(termflag))&&(PAIR_P(CDR(term))&&(PAIR_P(CDR(CDR(term)))&&((CAR(CDR(term))==GLOBAL(and_symbol_global))||((CAR(CDR(term))==GLOBAL(or_symbol_global))||((CAR(CDR(term))==GLOBAL(imp_symbol_global))||(CAR(CDR(term))==GLOBAL(equivalent_symbol_global))))))))
      return cons(CAR(CDR(term)),cons(make_prefix_formula_term_aux(CAR(term),BOOL_F),cons(make_prefix_formula_term_aux(CDR(CDR(term)),BOOL_F),EOL)));
    else
    if(!(NFALSEP(termflag))&&(!(PAIR_P(CAR(term)))&&(!((CAR(term)==GLOBAL(and_symbol_global))||((CAR(term)==GLOBAL(or_symbol_global))||((CAR(term)==GLOBAL(imp_symbol_global))||(CAR(term)==GLOBAL(equivalent_symbol_global)))))&&(PAIR_P(CDR(term))&&(PAIR_P(CDR(CDR(term)))&&(PAIR_P(CDR(CDR(CDR(term))))&&(PAIR_P(CAR(CDR(term)))&&((CAR(CDR(CDR(term)))==GLOBAL(and_symbol_global))||((CAR(CDR(CDR(term)))==GLOBAL(or_symbol_global))||((CAR(CDR(CDR(term)))==GLOBAL(imp_symbol_global))||(CAR(CDR(CDR(term)))==GLOBAL(equivalent_symbol_global))))))))))))
      return cons(CAR(CDR(CDR(term))),cons(cons(CAR(term),make_prefix_formula_term_aux(CAR(CDR(term)),BOOL_T)),cons(make_prefix_formula_term_aux(CDR(CDR(CDR(term))),BOOL_F),EOL)));
    else
    if(!(PAIR_P(CAR(term)))&&(!(NULL_P(CDR(term)))&&PAIR_P(CAR(CDR(term)))))
      return cons(cons(CAR(term),make_prefix_formula_term_aux(CAR(CDR(term)),BOOL_T)),make_prefix_formula_term_aux(CDR(CDR(term)),termflag));
    else
      return cons(make_prefix_formula_term_aux(CAR(term),termflag),make_prefix_formula_term_aux(CDR(term),termflag));
  }
  else
    return formula_syntax_error(const_63,term);
}

SCM formula_syntax_error(msg,term)
SCM msg,term;
{
  newline(cur_output_port());
  display(const_64,cur_output_port());
  display(msg,cur_output_port());
  display(const_65,cur_output_port());
  newline(cur_output_port());
  apply(GLOBAL(pretty_print),term,listofnull);
  newline(cur_output_port());
  return abrt();
}

SCM print_raw_formula(term)
SCM term;
{
  return print_list_as_term(remove_formula_dots(term));
}

SCM remove_formula_dots(term)
SCM term;
{
tailrecursion:
  if(PAIR_P(term)) {
    if(CAR(term)==GLOBAL(otter_comma_repl_global)) {
      term=CDR(term);
      goto tailrecursion;
    }
    else
      return cons(remove_formula_dots(CAR(term)),remove_formula_dots(CDR(term)));
  }
  else
    return term;
}

SCM move_not_and_equiv(term,mcon)
SCM term,mcon;
{
  SCM arg;

tailrecursion:
  arg=EOL;
  if(!(PAIR_P(term)))
    return term;
  else
  if(GLOBAL(not_symbol_global)==CAR(term)) {
    arg=CAR(CDR(term));
    if(!(PAIR_P(arg)))
      return make_neg_symbol(arg);
    else
    if(PAIR_P(CAR(arg))) {
      term=cons(GLOBAL(not_symbol_global),cons(CAR(arg),cons(mcon,EOL)));
      goto tailrecursion;
    }
    else
    if(GLOBAL(not_symbol_global)==CAR(arg)) {
      term=arg;
      goto tailrecursion;
    }
    else
    if(GLOBAL(or_symbol_global)==CAR(arg))
      return cons(GLOBAL(and_symbol_global),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(arg)),EOL)),mcon),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(CDR(arg))),EOL)),mcon),EOL)));
    else
    if(GLOBAL(and_symbol_global)==CAR(arg))
      return cons(GLOBAL(or_symbol_global),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(arg)),EOL)),mcon),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(CDR(arg))),EOL)),mcon),EOL)));
    else
    if(GLOBAL(imp_symbol_global)==CAR(arg))
      return cons(GLOBAL(and_symbol_global),cons(move_not_and_equiv(CAR(CDR(term)),mcon),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(CDR(term))),EOL)),mcon),EOL)));
    else
    if(GLOBAL(equivalent_symbol_global)==CAR(arg)) {
      if(mcon==GLOBAL(or_symbol_global))
        return cons(GLOBAL(or_symbol_global),cons(cons(GLOBAL(and_symbol_global),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(arg)),cons(mcon,EOL)))),cons(move_not_and_equiv(CAR(CDR(CDR(arg))),mcon),EOL))),cons(cons(GLOBAL(and_symbol_global),cons(move_not_and_equiv(CAR(CDR(arg)),mcon),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(CDR(arg))),EOL)),mcon),EOL))),EOL)));
      else
        return cons(GLOBAL(and_symbol_global),cons(cons(GLOBAL(or_symbol_global),cons(move_not_and_equiv(CAR(CDR(arg)),mcon),cons(move_not_and_equiv(CAR(CDR(CDR(arg))),mcon),cons(cons(GLOBAL(or_symbol_global),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(arg)),EOL)),mcon),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(CDR(arg))),EOL)),mcon),EOL))),EOL)))),EOL));
    }
    else
    if(GLOBAL(all_symbol_global)==CAR(arg))
      return cons(GLOBAL(exists_symbol_global),cons(CAR(CDR(arg)),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(CDR(arg))),EOL)),mcon),EOL)));
    else
    if(GLOBAL(exists_symbol_global)==CAR(arg))
      return cons(GLOBAL(all_symbol_global),cons(CAR(CDR(arg)),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(CDR(arg))),EOL)),mcon),EOL)));
    else
      return cons(make_neg_symbol(CAR(arg)),CDR(arg));
  }
  else
  if(GLOBAL(imp_symbol_global)==CAR(term))
    return cons(GLOBAL(or_symbol_global),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(term)),EOL)),mcon),cons(move_not_and_equiv(CAR(CDR(CDR(term))),mcon),EOL)));
  else
  if(GLOBAL(equivalent_symbol_global)==CAR(term)) {
    if(mcon==GLOBAL(or_symbol_global))
      return cons(GLOBAL(or_symbol_global),cons(cons(GLOBAL(and_symbol_global),cons(move_not_and_equiv(CAR(CDR(term)),mcon),cons(move_not_and_equiv(CAR(CDR(CDR(term))),mcon),EOL))),cons(cons(GLOBAL(and_symbol_global),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(term)),EOL)),mcon),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(CDR(term))),EOL)),mcon),EOL))),EOL)));
    else
      return cons(GLOBAL(and_symbol_global),cons(cons(GLOBAL(or_symbol_global),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(term)),EOL)),mcon),cons(move_not_and_equiv(CAR(CDR(CDR(term))),mcon),EOL))),cons(cons(GLOBAL(or_symbol_global),cons(move_not_and_equiv(CAR(CDR(term)),mcon),cons(move_not_and_equiv(cons(GLOBAL(not_symbol_global),cons(CAR(CDR(CDR(term))),EOL)),mcon),EOL))),EOL)));
  }
  else
    return map1_inst1(mcon,move_not_and_equiv_fn48,term);
}

SCM move_not_and_equiv_fn48(mcon,x)
SCM mcon,x;
{
  return move_not_and_equiv(x,mcon);
}

SCM flatten_prefix_formula(term)
SCM term;
{
tailrecursion:
  if(!(PAIR_P(term)))
    return term;
  else
  if(!(PAIR_P(CDR(term)))) {
    term=CAR(term);
    goto tailrecursion;
  }
  else
  if((CAR(term)==GLOBAL(and_symbol_global))||((CAR(term)==GLOBAL(or_symbol_global))||(CAR(term)==GLOBAL(imp_symbol_global)))) {
    if(PAIR_P(CAR(CDR(term)))&&((CAR(CAR(CDR(term)))==CAR(term))&&(PAIR_P(CAR(CDR(CDR(term))))&&(CAR(CAR(CDR(CDR(term))))==CAR(term)))))
      return cons(CAR(term),append2(CDR(flatten_prefix_formula(CAR(CDR(term)))),append2(EOL,CDR(apply(GLOBAL(flatter_prefix_formula),CAR(CDR(CDR(term))),listofnull)))));
    else
    if(PAIR_P(CAR(CDR(term)))&&(CAR(CAR(CDR(term)))==CAR(term)))
      return cons(CAR(term),append2(CDR(flatten_prefix_formula(CAR(CDR(term)))),map1(flatten_prefix_formula,CDR(CDR(term)))));
    else
    if(PAIR_P(CAR(CDR(CDR(term))))&&(CAR(CAR(CDR(CDR(term))))==CAR(term)))
      return cons(CAR(term),cons(flatten_prefix_formula(CAR(CDR(term))),append2(CDR(flatten_prefix_formula(CAR(CDR(CDR(term))))),map1(flatten_prefix_formula,CDR(CDR(CDR(term)))))));
    else
      return map1(flatten_prefix_formula_fn51,term);
  }
  else
    return map1(flatten_prefix_formula_fn52,term);
}

SCM flatten_prefix_formula_fn52(x)
SCM x;
{
  return flatten_prefix_formula(x);
}

SCM flatten_prefix_formula_fn51(x)
SCM x;
{
  return flatten_prefix_formula(x);
}

SCM skolemize_formula(term)
SCM term;
{
  GLOBAL(last_skolemfn_nr_global)=MAKINUM(0);
  GLOBAL(last_free_var_nr_global)=MAKINUM(0);
  return skolemize_formula_aux(term,EOL,EOL);
}

SCM skolemize_formula_aux(term,free_vars,varbindings)
SCM term,free_vars,varbindings;
{
  SCM tmp1,tmp2,var,typename,tmp_var3,tmp_var1,tmp_var2;

tailrecursion:
  tmp1=EOL;
  tmp2=EOL;
  var=EOL;
  typename=EOL;
  if(SYMBOL_P(term)) {
    tmp1=assq(term,varbindings);
    if(NFALSEP(tmp1))
      return CDR(tmp1);
    else
      return term;
  }
  else
  if(!(PAIR_P(term)))
    return term;
  else
  if(GLOBAL(all_symbol_global)==CAR(term)) {
    if(SYMBOL_P(CAR(CDR(term)))) {
      tmp1=make_freevar_formula();
      varbindings=remove_if_inst1(term,skolemize_formula_aux_fn58,varbindings);
      tmp_var1=CAR(CDR(CDR(term)));
      tmp_var2=cons(tmp1,free_vars);
      tmp_var3=cons(cons(CAR(CDR(term)),tmp1),varbindings);
      term=tmp_var1;
      free_vars=tmp_var2;
      varbindings=tmp_var3;
      goto tailrecursion;
    }
    else
    if(PAIR_P(CAR(CDR(term)))) {
      var=CAR(CDR(CAR(CDR(term))));
      apply(GLOBAL(set),typename,cons(CAR(CDR(CDR(CAR(CDR(term))))),listofnull));
      tmp2=assq(typename,GLOBAL(type_alist_global));
      varbindings=remove_if_inst1(var,skolemize_formula_aux_fn59,varbindings);
      if(!(NFALSEP(GLOBAL(unfold_finite_types_flag_global)))||!(NFALSEP(finite_type_symbol_formula(typename)))) {
        tmp1=make_freevar_formula();
        tmp_var1=cons(GLOBAL(or_symbol_global),cons(cons(GLOBAL(not_symbol_global),cons(make_type_literal(tmp1,typename),EOL)),cons(CAR(CDR(CDR(term))),EOL)));
        tmp_var2=cons(tmp1,free_vars);
        tmp_var3=cons(cons(var,tmp1),varbindings);
        term=tmp_var1;
        free_vars=tmp_var2;
        varbindings=tmp_var3;
        goto tailrecursion;
      }
      else {
        term=make_finite_subs_formula(term,var,typename);
        goto tailrecursion;
      }
    }
    else
      return UNSPECIFIED;
  }
  else
  if(GLOBAL(exists_symbol_global)==CAR(term)) {
    if(SYMBOL_P(CAR(CDR(term)))) {
      tmp1=make_skolem_term_formula(CAR(CDR(term)),free_vars);
      varbindings=remove_if_inst1(term,skolemize_formula_aux_fn60,varbindings);
      tmp_var1=CAR(CDR(CDR(term)));
      tmp_var2=cons(cons(CAR(CDR(term)),tmp1),varbindings);
      term=tmp_var1;
      varbindings=tmp_var2;
      goto tailrecursion;
    }
    else
    if(PAIR_P(CAR(CDR(term)))) {
      var=CAR(CDR(CAR(CDR(term))));
      apply(GLOBAL(set),typename,cons(CAR(CDR(CDR(CAR(CDR(term))))),listofnull));
      tmp2=assq(typename,GLOBAL(type_alist_global));
      varbindings=remove_if_inst1(var,skolemize_formula_aux_fn61,varbindings);
      if(!(NFALSEP(GLOBAL(unfold_finite_types_flag_global)))||!(NFALSEP(finite_type_symbol_formula(typename)))) {
        tmp1=make_skolem_term_formula(var,free_vars);
        tmp_var1=cons(GLOBAL(and_symbol_global),cons(make_type_literal(tmp1,typename),cons(CAR(CDR(CDR(term))),EOL)));
        tmp_var2=cons(cons(var,tmp1),varbindings);
        term=tmp_var1;
        varbindings=tmp_var2;
        goto tailrecursion;
      }
      else {
        term=make_finite_subs_formula(term,var,typename);
        goto tailrecursion;
      }
    }
    else
      return UNSPECIFIED;
  }
  else
    return map1_inst2(varbindings,free_vars,skolemize_formula_aux_fn62,term);
}

SCM skolemize_formula_aux_fn62(varbindings,free_vars,x)
SCM varbindings,free_vars,x;
{
  return skolemize_formula_aux(x,free_vars,varbindings);
}

SCM skolemize_formula_aux_fn61(var,x)
SCM var,x;
{
  return SBOOL(CAR(x)==var);
}

SCM skolemize_formula_aux_fn60(term,x)
SCM term,x;
{
  return SBOOL(CAR(x)==CAR(CDR(term)));
}

SCM skolemize_formula_aux_fn59(var,x)
SCM var,x;
{
  return SBOOL(CAR(x)==var);
}

SCM skolemize_formula_aux_fn58(term,x)
SCM term,x;
{
  return SBOOL(CAR(x)==CAR(CDR(term)));
}

SCM make_skolem_term_formula(varsymb,free_vars)
SCM varsymb,free_vars;
{
  SCM tmp;

  tmp=EOL;
  GLOBAL(last_skolemfn_nr_global)=MAKINUM(1+INUM(GLOBAL(last_skolemfn_nr_global)));
  tmp=string2symbol(st_append(cons(GLOBAL(skolemfn_base_string_global),cons(number2string(GLOBAL(last_skolemfn_nr_global),MAKINUM(10)),EOL))));
  return cons(tmp,free_vars);
}

SCM make_finite_subs_formula(term,var,typename)
SCM term,var,typename;
{
  SCM typecases,form_list,connective;

  typecases=EOL;
  form_list=EOL;
  connective=EOL;
  typecases=assq(typename,GLOBAL(type_alist_global));
  typecases=CDR(typecases);
  form_list=map1_inst2(var,term,make_finite_subs_formula_fn64,typecases);
  if(CAR(term)==GLOBAL(exists_symbol_global)) {
    connective=GLOBAL(or_symbol_global);
  }
  else {
    connective=GLOBAL(and_symbol_global);
  }
  return split_list_by_connective_formula(connective,form_list);
}

SCM make_finite_subs_formula_fn64(var,term,x)
SCM var,term,x;
{
  return subs_into_formula(CAR(CDR(CDR(term))),var,x);
}

SCM split_list_by_connective_formula(conn,lst)
SCM conn,lst;
{
  if(NULL_P(lst))
    return lst;
  else
  if(NULL_P(CDR(lst)))
    return CAR(lst);
  else
  if(NULL_P(CDR(CDR(lst))))
    return cons(conn,lst);
  else
    return cons(conn,cons(CAR(lst),cons(split_list_by_connective_formula(conn,CDR(lst)),EOL)));
}

SCM subs_into_formula(term,var,value)
SCM term,var,value;
{
  if(term==var)
    return value;
  else
  if(!(PAIR_P(term)))
    return term;
  else
  if(((CAR(term)==GLOBAL(all_symbol_global))||(CAR(term)==GLOBAL(exists_symbol_global)))&&((SYMBOL_P(CAR(CDR(term)))&&(CAR(CDR(term))==var))||(PAIR_P(CAR(CDR(term)))&&(CAR(CDR(CAR(CDR(term))))==var))))
    return term;
  else
    return map1_inst2(value,var,subs_into_formula_fn66,term);
}

SCM subs_into_formula_fn66(value,var,x)
SCM value,var,x;
{
  return subs_into_formula(x,var,value);
}

SCM make_freevar_formula()
{
  GLOBAL(last_free_var_nr_global)=MAKINUM(1+INUM(GLOBAL(last_free_var_nr_global)));
  return string2symbol(st_append(cons(GLOBAL(free_var_base_string_global),cons(number2string(GLOBAL(last_free_var_nr_global),MAKINUM(10)),EOL))));
}

SCM make_type_literal(var,name)
SCM var,name;
{
  return cons(GLOBAL(type_pred_name_global),cons(var,cons(name,EOL)));
}

SCM finite_type_symbol_formula(x)
SCM x;
{
  return BOOL_F;
}

SCM make_neg_symbol(pred)
SCM pred;
{
  SCM predstr,polarity;

  predstr=symbol2string(pred);
  if(MAKICHR('-')==ST_REF(predstr,MAKINUM(0)))
    polarity=BOOL_F;
  else
    polarity=BOOL_T;
  if(!(NFALSEP(polarity)))
    return string2symbol(substring(predstr,MAKINUM(1),ST_LENGTH(predstr)));
  else
    return string2symbol(st_append(cons(const_66,cons(predstr,EOL))));
}

SCM clausify_formula_aux(term)
SCM term;
{
  return term;
}

SCM ftest()
{
  return fprove(const_67);
}

SCM prepare_read_eqsymb(eqlit,posflag)
SCM eqlit,posflag;
{
  SCM eqsymb,neweqsymb,tmp;

  if(NFALSEP(posflag))
    eqsymb=_equal__symb;
  else
    eqsymb=_excl__equal__symb;
  if(NFALSEP(posflag))
    neweqsymb=GLOBAL(eq_symbol_global);
  else
    neweqsymb=string2symbol(st_append(cons(const_68,cons(symbol2string(GLOBAL(eq_symbol_global)),EOL))));
  tmp=replace_one_eq(eqsymb,_excl__symb,eqlit);
  return cons(neweqsymb,cons(tmp,EOL));
}

SCM prepare_read_eqlit(eqlit,posflag)
SCM eqlit,posflag;
{
  SCM eqsymb,neweqsymb,tmp;

  if(NFALSEP(posflag))
    eqsymb=_equal__symb;
  else
    eqsymb=_excl__equal__symb;
  if(NFALSEP(posflag))
    neweqsymb=GLOBAL(eq_symbol_global);
  else
    neweqsymb=string2symbol(st_append(cons(const_69,cons(symbol2string(GLOBAL(eq_symbol_global)),EOL))));
  tmp=replace_one_eq(eqsymb,_excl__symb,eqlit);
  return cons(neweqsymb,cons(tmp,EOL));
}

SCM parse_otter_explist(exp_nonkeyword)
SCM exp_nonkeyword;
{
  SCM new_var1,part,res,tmp;

  part=exp_nonkeyword;
  res=EOL;
  for(;!(NULL_P(part));) {
    new_var1=SBOOL(GLOBAL(otter_comma_repl_global)==CAR(part));
    if(NFALSEP(new_var1)) ;
    else
    if(SYMBOL_P(CAR(part))||NUMBER_P(CAR(part))) {
      if(NULL_P(CDR(part))) {
        res=cons(CAR(part),res);
      }
      else
      if(GLOBAL(otter_comma_repl_global)==CAR(CDR(part))) {
        if(NULL_P(CDR(CDR(part))))
          report_error(const_70,EOL);
        else {
          res=cons(CAR(part),res);
        }
      }
      else
      if(!(PAIR_P(CAR(CDR(part)))))
        report_error(const_71,EOL);
      else {
        tmp=parse_otter_explist(CAR(CDR(part)));
        res=cons(cons(CAR(part),tmp),res);
        part=CDR(part);
      }
    }
    else
    if(PAIR_P(CAR(part))) {
      res=cons(parse_otter_explist(CAR(part)),res);
    }
    if(!(NULL_P(part))) {
      part=CDR(part);
    }
  }
  return reverse(res);
}

SCM string_port_handler(port)
SCM port;
{
  return port;
}

SCM preprocess_otter_file(filename)
SCM filename;
{
  SCM iport,ostring;

  iport=open_file(filename,const_72);
  if(NFALSEP(iport)) {
    ostring=EOL;
    GLOBAL(otter_inport_global)=iport;
    ostring=apply(GLOBAL(call_with_output_string),GLOBAL(preprocess_otter_file_aux_clproc0),listofnull);
    GLOBAL(otter_tmpfile_global)=ostring;
    return UNSPECIFIED;
  }
  else {
    report_error(const_73,cons(filename,EOL));
    return BOOL_F;
  }
}

SCM preprocess_otter_file_aux(oport)
SCM oport;
{
  SCM iport,char_nonkeyword;

  if(NFALSEP(oport)) {
    iport=GLOBAL(otter_inport_global);
    for(char_nonkeyword=scm_read_char(iport);!(NFALSEP(eof_objectp(char_nonkeyword)));char_nonkeyword=scm_read_char(iport))
      if(char_nonkeyword==MAKICHR(',')) {
        write_char(MAKICHR(' '),oport);
        lwrite(GLOBAL(otter_comma_repl_global),oport);
        write_char(MAKICHR(' '),oport);
      }
      else
      if(char_nonkeyword==MAKICHR('%'))
        write_char(MAKICHR(';'),oport);
      else
      if(char_nonkeyword==MAKICHR('.')) {
        write_char(MAKICHR(' '),oport);
        lwrite(GLOBAL(otter_dot_repl_global),oport);
        write_char(MAKICHR(' '),oport);
      }
      else
      if(char_nonkeyword==MAKICHR('|')) {
        write_char(MAKICHR(' '),oport);
        write_char(MAKICHR('|'),oport);
        write_char(MAKICHR(' '),oport);
      }
      else
      if(char_nonkeyword==GLOBAL(otter_uppercase_prefix_global)) {
        write_char(GLOBAL(otter_uppercase_prefix_global),oport);
        write_char(GLOBAL(otter_uppercase_prefix_global),oport);
      }
      else
      if(char_nonkeyword==MAKICHR('$')) {
        write_char(MAKICHR('$'),oport);
        write_char(MAKICHR('$'),oport);
      }
      else
      if(NFALSEP(CHAR_ALPHAP(char_nonkeyword))&&NFALSEP(CHAR_UPPERP(char_nonkeyword))) {
        write_char(GLOBAL(otter_uppercase_prefix_global),oport);
        write_char(char_nonkeyword,oport);
      }
      else
        write_char(char_nonkeyword,oport);
    return oport;
  }
  else {
    report_error(const_74,EOL);
    return BOOL_F;
  }
}

SCM read_processed_otter_file(filename)
SCM filename;
{
  SCM lst_end,lst,iport,obj;

  iport=apply(GLOBAL(call_with_input_string),filename,cons(GLOBAL(string_port_handler_clproc0),listofnull));
  lst=EOL;
  lst_end=EOL;
  lst=cons(EOL,EOL);
  lst_end=lst;
  for(obj=lread(iport);!(NFALSEP(eof_objectp(obj)));obj=lread(iport)) {
    SET_CDR(lst_end,cons(obj,EOL));
    lst_end=CDR(lst_end);
  }
  close_port(iport);
  lst=CDR(lst);
  return lst;
}

SCM numerify_clause_list(clauses)
SCM clauses;
{
  init_numerify_clause_list();
  return map1(numerify_clause,clauses);
}

SCM init_numerify_clause_list()
{
  GLOBAL(const_num_table_global)=EOL;
  GLOBAL(fun_num_table_global)=EOL;
  GLOBAL(fun_num_arity_table_global)=EOL;
  GLOBAL(pred_num_table_global)=EOL;
  GLOBAL(const_num_global)=MAKINUM(65536-1);
  GLOBAL(curry_const_num_global)=MAKINUM(200000-1);
  GLOBAL(fun_num_global)=GLOBAL(min_fun_num_sub1_global);
  GLOBAL(pred_num_global)=GLOBAL(min_pred_num_sub1_global);
  GLOBAL(ans_prohibited_funnrs_global)=EOL;
  GLOBAL(ans_prohibited_prednrs_global)=EOL;
  GLOBAL(ans_prohibited_constnrs_global)=EOL;
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    numerify_literal(GLOBAL(typet_speclit_global));
  if(NFALSEP(GLOBAL(classical_synth_stratflag_global))) {
    numerify_literal(GLOBAL(classicsynth_speclit_global));
    GLOBAL(ans_prohibited_prednrs_global)=map1(init_numerify_clause_list_fn69,GLOBAL(ans_prohibited_predsymbs_global));
    GLOBAL(ans_prohibited_funnrs_global)=map1(init_numerify_clause_list_fn70,GLOBAL(ans_prohibited_funsymbs_global));
    GLOBAL(ans_prohibited_constnrs_global)=map1(numerify_term,GLOBAL(ans_prohibited_constsymbs_global));
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM init_numerify_clause_list_fn70(x)
SCM x;
{
  return CAR(numerify_term(cons(x,EOL)));
}

SCM init_numerify_clause_list_fn69(x)
SCM x;
{
  return CAR(numerify_literal(cons(x,EOL)));
}

SCM numerify_clause(clause)
SCM clause;
{
  GLOBAL(var_num_table_global)=EOL;
  GLOBAL(var_num_global)=GLOBAL(min_var_num_sub1_global);
  return map1(numerify_literal,clause);
}

SCM numerify_literal(lit)
SCM lit;
{
  SCM tmp,pred,predstr,polarity,purepred,place,resnr;

  tmp=MAKINUM(0);
  pred=CAR(lit);
  predstr=symbol2string(pred);
  if(MAKICHR('-')==ST_REF(predstr,MAKINUM(0)))
    polarity=BOOL_F;
  else
    polarity=BOOL_T;
  if(NFALSEP(polarity))
    purepred=pred;
  else
    purepred=string2symbol(substring(predstr,MAKINUM(1),ST_LENGTH(predstr)));
  place=assq(purepred,GLOBAL(pred_num_table_global));
  if(NFALSEP(place))
    resnr=polarize_pred_nr(CDR(place),polarity);
  else {
    GLOBAL(pred_num_global)=MAKINUM(1+INUM(GLOBAL(pred_num_global)));
    if(GLOBAL(pred_num_global)>GLOBAL(max_nr_of_preds_global))
      report_error(const_75,cons(BOOL_T,EOL));
    GLOBAL(pred_num_table_global)=cons(cons(purepred,MAKINUM(INUM(GLOBAL(pred_num_global))<<21)),GLOBAL(pred_num_table_global));
    resnr=polarize_pred_nr(MAKINUM(INUM(GLOBAL(pred_num_global))<<21),polarity);
  }
  if(NFALSEP(special_curry_purepred_pred_(purepred))) {
    tmp=numerify_curry_const(CAR(CDR(lit)));
    return cons(resnr,cons(tmp,map1(numerify_term,CDR(CDR(lit)))));
  }
  else
    return cons(resnr,map1(numerify_term,CDR(lit)));
}

SCM polarize_pred_nr(nr,boolsgn)
SCM nr,boolsgn;
{
  if(NFALSEP(boolsgn))
    return nr;
  else
    return MAKINUM(268435456)|nr;
}

SCM reverse_polarize_pred_nr(nr)
SCM nr;
{
  return MAKINUM(268435456^INUM(nr));
}

SCM numerify_term(term)
SCM term;
{
  SCM place__1,fun,nr,tmp,place,place__2;

  if(PAIR_P(term)) {
    fun=CAR(term);
    nr=MAKINUM(0);
    tmp=MAKINUM(0);
    place=assq(fun,GLOBAL(fun_num_table_global));
    if(NFALSEP(place)) {
      nr=CDR(place);
    }
    else {
      GLOBAL(fun_num_global)=MAKINUM(1+INUM(GLOBAL(fun_num_global)));
      if(GLOBAL(fun_num_global)>GLOBAL(max_nr_of_funs_global))
        report_error(const_76,cons(BOOL_T,EOL));
      GLOBAL(fun_num_table_global)=cons(cons(fun,MAKINUM(INUM(GLOBAL(fun_num_global))<<21)),GLOBAL(fun_num_table_global));
      nr=MAKINUM(INUM(GLOBAL(fun_num_global))<<21);
      GLOBAL(fun_num_arity_table_global)=cons(cons(nr,length(CDR(term))),GLOBAL(fun_num_arity_table_global));
    }
    if(NFALSEP(special_curry_fun_pred_(CAR(term)))) {
      tmp=numerify_curry_const(CAR(CDR(term)));
      return cons(nr,cons(tmp,map1(numerify_term,CDR(CDR(term)))));
    }
    else
      return cons(nr,map1(numerify_term,CDR(term)));
  }
  else
  if(NFALSEP(var_symbol_pred_(term))) {
    place__1=assq(term,GLOBAL(var_num_table_global));
    if(NFALSEP(place__1))
      return CDR(place__1);
    else {
      GLOBAL(var_num_global)=MAKINUM(1+INUM(GLOBAL(var_num_global)));
      if(GLOBAL(var_num_global)>MAKINUM(255))
        report_error(const_77,cons(BOOL_T,EOL));
      GLOBAL(var_num_table_global)=cons(cons(term,GLOBAL(var_num_global)),GLOBAL(var_num_table_global));
      return GLOBAL(var_num_global);
    }
  }
  else {
    place__2=assq(term,GLOBAL(const_num_table_global));
    if(NFALSEP(place__2))
      return CDR(place__2);
    else {
      GLOBAL(const_num_global)=MAKINUM(1+INUM(GLOBAL(const_num_global)));
      GLOBAL(const_num_table_global)=cons(cons(term,GLOBAL(const_num_global)),GLOBAL(const_num_table_global));
      return GLOBAL(const_num_global);
    }
  }
}

SCM numerify_curry_const(term)
SCM term;
{
  SCM place;

  place=assq(term,GLOBAL(const_num_table_global));
  if(NFALSEP(place))
    return CDR(place);
  else {
    GLOBAL(curry_const_num_global)=MAKINUM(1+INUM(GLOBAL(curry_const_num_global)));
    GLOBAL(const_num_table_global)=cons(cons(term,GLOBAL(curry_const_num_global)),GLOBAL(const_num_table_global));
    return GLOBAL(curry_const_num_global);
  }
}

SCM special_curry_purepred_pred_(purepred)
SCM purepred;
{
  if(!(NULL_P(GLOBAL(curried_pred_const_table_global))))
    return assq(purepred,GLOBAL(curried_appred_arities_global));
  else
    return BOOL_F;
}

SCM special_curry_fun_pred_(funsymb)
SCM funsymb;
{
  if(!(NULL_P(GLOBAL(curried_fun_const_table_global))))
    return assq(funsymb,GLOBAL(curried_apfun_arities_global));
  else
    return BOOL_F;
}

SCM curry_const_pred_(x)
SCM x;
{
  if(NUMBER_P(x)&&(x>MAKINUM(65535)))
    return SBOOL(x>=MAKINUM(200000));
  else
    return BOOL_F;
}

SCM var_symbol_pred_(symb)
SCM symb;
{
  SCM char1;

  if(SYMBOL_P(symb)) {
    char1=ST_REF(symbol2string(symb),MAKINUM(0));
    if(NFALSEP(GLOBAL(prolog_style_variables_global)))
      return SBOOL(char1==MAKICHR('^'));
    else
      return member(char1,const_78);
  }
  else
    return BOOL_F;
}

SCM print_full_clause(fullcl)
SCM fullcl;
{
  SCM otherlst,tmp,nr,new,new_var1,new_var2;

  if(0) {
    new=map1(print_full_clause_fn79,CDR(fullcl));
    nr=MAKINUM(0);
    tmp=EOL;
    otherlst=EOL;
    for(new_var1=CAR(CDR(CDR(CAR(fullcl)))),new_var2=CDR(fullcl);
        PAIR_P(new_var1)&&PAIR_P(new_var2);
        new_var1=CDR(new_var1),new_var2=CDR(new_var2))
      print_full_clause_fn77(&otherlst,&nr,new,CAR(new_var1),CAR(new_var2));
    if(!(NULL_P(otherlst))) {
      new=map1_inst3(&otherlst,&tmp,print_full_clause_fn78,new);
    }
    return print_pure_clause(new);
  }
  else {
    print_pure_clause(CDR(fullcl));
    newline(cur_output_port());
    display(const_79,cur_output_port());
    display(map1(print_full_clause_fn80,CAR(CDR(CDR(CAR(fullcl))))),cur_output_port());
    newline(cur_output_port());
    display(const_80,cur_output_port());
    display(map1(print_full_clause_fn81,CAR(CDR(CDR(CAR(fullcl))))),cur_output_port());
    newline(cur_output_port());
    display(const_81,cur_output_port());
    return display(map1(print_full_clause_fn82,CAR(CDR(CDR(CAR(fullcl))))),cur_output_port());
  }
}

SCM print_full_clause_fn82(inf)
SCM inf;
{
  return cons(SBOOL(ZERO_P(MAKINUM(16)&CAR(inf))),cons(SBOOL(ZERO_P(MAKINUM(32)&CAR(inf))),EOL));
}

SCM print_full_clause_fn81(inf)
SCM inf;
{
  return SBOOL(ZERO_P(MAKINUM(2)&CAR(inf)));
}

SCM print_full_clause_fn80(inf)
SCM inf;
{
  return SBOOL(ZERO_P(MAKINUM(1)&CAR(inf)));
}

SCM print_full_clause_fn79(x)
SCM x;
{
  return EOL;
}

SCM print_full_clause_fn78(otherlst,tmp,lit)
SCM *otherlst,*tmp;
SCM lit;
{
  if(NULL_P(lit)) {
    *tmp=CAR(*otherlst);
    *otherlst=CDR(*otherlst);
    return *tmp;
  }
  else
    return lit;
}

SCM print_full_clause_fn77(otherlst,nr,new,inf,lit)
SCM *otherlst,*nr;
SCM new,inf,lit;
{
  *nr=MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(inf))>>16);
  if(!(*nr==MAKINUM(0))) {
    SET_CAR(nth_cdr(MAKINUM(INUM(*nr)-1),new),lit);
    return UNSPECIFIED;
  }
  else {
    *otherlst=cons(lit,*otherlst);
    return UNSPECIFIED;
  }
}

SCM print_clause(fullcl)
SCM fullcl;
{
  return print_pure_clause(CDR(fullcl));
}

SCM print_pure_clause(pureclause)
SCM pureclause;
{
  SCM part,part__1;

  if(NULL_P(pureclause)) {
    if(NFALSEP(GLOBAL(list_output_global)))
      return display(EOL,cur_output_port());
    else
      return display(const_82,cur_output_port());
  }
  else
  if(NFALSEP(GLOBAL(list_output_global))) {
    display(MAKICHR('('),cur_output_port());
    for(part=pureclause;!(NULL_P(part));part=CDR(part)) {
      print_lit(CAR(part));
      if(!(NULL_P(CDR(part))))
        display(MAKICHR(' '),cur_output_port());
    }
    return display(MAKICHR(')'),cur_output_port());
  }
  else {
    for(part__1=pureclause;!(NULL_P(part__1));part__1=CDR(part__1)) {
      print_lit(CAR(part__1));
      if(!(NULL_P(CDR(part__1))))
        display(const_83,cur_output_port());
    }
    return display(MAKICHR('.'),cur_output_port());
  }
}

SCM print_lit(lit)
SCM lit;
{
  SCM part,part__1;

  if(NFALSEP(GLOBAL(list_output_global))) {
    display(MAKICHR('('),cur_output_port());
    print_pred(CAR(lit));
    if(!(NULL_P(CDR(lit))))
      display(MAKICHR(' '),cur_output_port());
    for(part=CDR(lit);!(NULL_P(part));part=CDR(part)) {
      print_term(CAR(part));
      if(!(NULL_P(CDR(part))))
        display(MAKICHR(' '),cur_output_port());
    }
    return display(MAKICHR(')'),cur_output_port());
  }
  else {
    print_pred(CAR(lit));
    display(MAKICHR('('),cur_output_port());
    for(part__1=CDR(lit);!(NULL_P(part__1));part__1=CDR(part__1)) {
      print_term(CAR(part__1));
      if(!(NULL_P(CDR(part__1)))) {
        if(NFALSEP(GLOBAL(comma_output_global)))
          display(MAKICHR(','),cur_output_port());
        else
          display(MAKICHR(' '),cur_output_port());
      }
    }
    return display(MAKICHR(')'),cur_output_port());
  }
}

SCM print_term(term)
SCM term;
{
  SCM part,part__1;

  if(!(NUMBER_P(term))) {
    if(NFALSEP(GLOBAL(list_output_global))) {
      display(MAKICHR('('),cur_output_port());
      print_fun(CAR(term));
      if(!(NULL_P(CDR(term))))
        display(MAKICHR(' '),cur_output_port());
      if(GLOBAL(if_fun_nr_global)==(MAKINUM(534773760)&CAR(term))) {
        print_lit(CAR(CDR(term)));
        display(MAKICHR(' '),cur_output_port());
        term=CDR(term);
      }
      for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
        print_term(CAR(part));
        if(!(NULL_P(CDR(part))))
          display(MAKICHR(' '),cur_output_port());
      }
      return display(MAKICHR(')'),cur_output_port());
    }
    else {
      print_fun(CAR(term));
      display(MAKICHR('('),cur_output_port());
      if(GLOBAL(if_fun_nr_global)==(MAKINUM(534773760)&CAR(term))) {
        print_lit(CAR(CDR(term)));
        if(NFALSEP(GLOBAL(comma_output_global)))
          display(MAKICHR(','),cur_output_port());
        else
          display(MAKICHR(' '),cur_output_port());
        term=CDR(term);
      }
      for(part__1=CDR(term);!(NULL_P(part__1));part__1=CDR(part__1)) {
        print_term(CAR(part__1));
        if(!(NULL_P(CDR(part__1)))) {
          if(NFALSEP(GLOBAL(comma_output_global)))
            display(MAKICHR(','),cur_output_port());
          else
            display(MAKICHR(' '),cur_output_port());
        }
      }
      return display(MAKICHR(')'),cur_output_port());
    }
  }
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535)))
    return print_var(term);
  else
    return print_const(term);
}

SCM print_pred(prednum)
SCM prednum;
{
  if(!(ZERO_P(MAKINUM(268435456)&prednum)))
    display(MAKICHR('-'),cur_output_port());
  return display(CAR(rassq(MAKINUM(266338304)&prednum,GLOBAL(pred_num_table_global))),cur_output_port());
}

SCM print_fun(funnum)
SCM funnum;
{
  return display(CAR(rassq(MAKINUM(534773760)&funnum,GLOBAL(fun_num_table_global))),cur_output_port());
}

SCM print_const(constnum)
SCM constnum;
{
  return display(CAR(rassq(constnum,GLOBAL(const_num_table_global))),cur_output_port());
}

SCM print_var(varnr)
SCM varnr;
{
  SCM yflg,try;

  yflg=BOOL_F;
  if(!(ZERO_P(MAKINUM(256)&varnr))) {
    yflg=BOOL_T;
    varnr=MAKINUM(256^INUM(varnr));
  }
  varnr=(MAKINUM(8191)&varnr);
  try=assq(varnr,GLOBAL(nr_var_table_global));
  if(NFALSEP(yflg))
    display(MAKICHR(39),cur_output_port());
  if(NFALSEP(try)) {
    if(NFALSEP(GLOBAL(prolog_style_variables_global)))
      return print_prolog_var(CDR(try));
    else
      return display(CDR(try),cur_output_port());
  }
  else {
    if(NFALSEP(GLOBAL(prolog_style_variables_global)))
      display(MAKICHR('X'),cur_output_port());
    else
      display(MAKICHR('x'),cur_output_port());
    return display(MAKINUM(INUM(varnr)-6),cur_output_port());
  }
}

SCM print_prolog_var(symb)
SCM symb;
{
  SCM str;

  str=EOL;
  if(!(SYMBOL_P(symb)))
    return display(symb,cur_output_port());
  else {
    str=symbol2string(symb);
    display(CHAR_UPCASE(ST_REF(str,MAKINUM(0))),cur_output_port());
    return display(substring(str,MAKINUM(1),ST_LENGTH(str)),cur_output_port());
  }
}

SCM print_list_as_term(lst)
SCM lst;
{
  SCM part;

  if(NFALSEP(listp(lst))&&!(NULL_P(lst))) {
    display(CAR(lst),cur_output_port());
    display(const_84,cur_output_port());
    for(part=CDR(lst);!(NULL_P(part));part=CDR(part)) {
      print_list_as_term(CAR(part));
      if(!(NULL_P(CDR(part))))
        display(const_85,cur_output_port());
    }
    return display(const_86,cur_output_port());
  }
  else
    return display(lst,cur_output_port());
}

SCM show_discr_tree(tree,litflag)
SCM tree,litflag;
{
  return apply(GLOBAL(pretty_print),((PAIR_P(tree)&&!(NULL_P(CAR(tree))&&NULL_P(CDR(tree)))) ? (NFALSEP(tree_debug_leaf_pred_(tree)) ? make_readable_discr_leaf(tree) : make_readable_discr_tree(tree,litflag)) : tree),listofnull);
}

SCM make_readable_discr_tree(tree,litflag)
SCM tree,litflag;
{
  SCM el1,el2,rst;

  el1=map1_inst1(litflag,make_readable_discr_tree_fn86,CAR(tree));
  if(!(NULL_P(CDR(tree)))&&PAIR_P(CDR(tree)))
    el2=map1(make_readable_discr_tree_fn87,CAR(CDR(tree)));
  else
    el2=EOL;
  if(!(NULL_P(CDR(tree))))
    rst=map1(make_readable_discr_tree_fn88,CDR(CDR(tree)));
  else
    rst=EOL;
  return cons(el1,((!(NULL_P(el2))||!(NULL_P(rst))) ? cons(el2,rst) : EOL));
}

SCM make_readable_discr_tree_fn88(x)
SCM x;
{
  SCM tmp__4,funnum__5,fn__6;

  tmp__4=EOL;
  funnum__5=CAR(x);
  fn__6=string2symbol(st_append(cons(const_87,cons(number2string(MAKINUM(8191)&funnum__5,MAKINUM(10)),EOL))));
  if(NFALSEP(tree_debug_leaf_pred_(CDR(x)))) {
    tmp__4=make_readable_discr_leaf(CDR(x));
  }
  else {
    tmp__4=make_readable_discr_tree(CDR(x),BOOL_F);
  }
  return cons(fn__6,tmp__4);
}

SCM make_readable_discr_tree_fn87(x)
SCM x;
{
  SCM tmp__1,funnum__2,fn__3;

  tmp__1=EOL;
  funnum__2=CAR(x);
  fn__3=CAR(rassq(funnum__2,GLOBAL(const_num_table_global)));
  if(NFALSEP(tree_debug_leaf_pred_(CDR(x)))) {
    tmp__1=make_readable_discr_leaf(CDR(x));
  }
  else {
    tmp__1=make_readable_discr_tree(CDR(x),BOOL_F);
  }
  return cons(fn__3,tmp__1);
}

SCM make_readable_discr_tree_fn86(litflag,x)
SCM litflag,x;
{
  SCM tmp,funnum,fn;

  tmp=EOL;
  funnum=CAR(x);
  if(NFALSEP(litflag))
    fn=CAR(rassq(funnum,GLOBAL(pred_num_table_global)));
  else
    fn=CAR(rassq(funnum,GLOBAL(fun_num_table_global)));
  if(NFALSEP(tree_debug_leaf_pred_(CDR(x)))) {
    tmp=make_readable_discr_leaf(CDR(x));
  }
  else {
    tmp=make_readable_discr_tree(CDR(x),BOOL_F);
  }
  return cons(fn,tmp);
}

SCM tree_debug_leaf_pred_(tree)
SCM tree;
{
  SCM new_var2,new_var1,new_var3;

  new_var1=SBOOL(NULL_P(tree));
  if(NFALSEP(new_var1))
    return new_var1;
  else {
    if(PAIR_P(CAR(tree)))
      new_var2=NOT(SBOOL(PAIR_P(CAR(CAR(tree)))));
    else
      new_var2=BOOL_F;
    if(NFALSEP(new_var2))
      return new_var2;
    else {
      if(PAIR_P(CDR(tree))) {
        if(PAIR_P(CAR(CDR(tree))))
          new_var3=NOT(SBOOL(PAIR_P(CAR(CAR(CDR(tree))))));
        else
          new_var3=BOOL_F;
      }
      else
        new_var3=BOOL_F;
      if(NFALSEP(new_var3))
        return new_var3;
      else
      if(PAIR_P(CDR(tree))) {
        if(PAIR_P(CDR(CDR(tree))))
          return SBOOL(PAIR_P(CAR(CAR(CDR(CDR(tree))))));
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
  }
}

SCM make_readable_discr_leaf(leaf)
SCM leaf;
{
  SCM el1,el2,el3;

  if(NFALSEP(GLOBAL(nonunit_discr_flag_global)))
    return leaf;
  else {
    if(PAIR_P(CAR(leaf)))
      el1=make_readable_lit(CAR(leaf));
    else
      el1=EOL;
    if(!(NULL_P(CDR(leaf)))&&PAIR_P(CAR(CDR(leaf))))
      el2=make_readable_lit(CAR(CDR(leaf)));
    else
      el2=EOL;
    if(!(NULL_P(CDR(leaf)))&&!(NULL_P(CDR(CDR(leaf)))))
      el3=make_readable_fullcl(CAR(CDR(CDR(leaf))));
    else
      el3=EOL;
    return cons(el1,((!(NULL_P(el2))||!(NULL_P(el3))) ? cons(el2,(!(NULL_P(el3)) ? cons(el3,EOL) : EOL)) : EOL));
  }
}

SCM make_readable_fullcl(fullcl)
SCM fullcl;
{
  return cons(cons(CAR(CAR(fullcl)),cons(CAR(CDR(CAR(fullcl))),EOL)),map1(make_readable_lit,CDR(fullcl)));
}

SCM make_readable_cl(cl)
SCM cl;
{
  return map1(make_readable_lit,cl);
}

SCM make_readable_lit(lit)
SCM lit;
{
  SCM funnum;

  funnum=CAR(lit);
  return cons((!(ZERO_P(MAKINUM(268435456)&funnum)) ? string2symbol(st_append(cons(const_88,cons(symbol2string(CAR(rassq(MAKINUM(266338304)&funnum,GLOBAL(pred_num_table_global)))),EOL)))) : CAR(rassq(MAKINUM(266338304)&funnum,GLOBAL(pred_num_table_global)))),((GLOBAL(lambda_fun_nr_global)==(MAKINUM(534773760)&funnum)) ? cons(make_readable_term(CAR(CDR(lit))),map1(make_readable_term,CDR(CDR(lit)))) : map1(make_readable_term,CDR(lit))));
}

SCM make_readable_term(term)
SCM term;
{
  if(PAIR_P(term))
    return cons(CAR(rassq(MAKINUM(534773760)&CAR(term),GLOBAL(fun_num_table_global))),((GLOBAL(lambda_fun_nr_global)==(MAKINUM(534773760)&CAR(term))) ? cons(make_readable_term(CAR(CDR(term))),map1(make_readable_term,CDR(CDR(term)))) : map1(make_readable_term,CDR(term))));
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535)))
    return string2symbol(st_append(cons(const_89,cons(number2string(MAKINUM(8191)&term,MAKINUM(10)),EOL))));
  else
    return CAR(rassq(term,GLOBAL(const_num_table_global)));
}

SCM debug_print_clause(cl)
SCM cl;
{
  SCM info,pure,num;

  newline(cur_output_port());
  info=CAR(cl);
  pure=CDR(cl);
  num=CAR(info);
  display(vector(cons(MAKINUM(INUM(MAKINUM(528482304)&num)>>23),cons(MAKINUM(INUM(MAKINUM(8257536)&num)>>17),cons(MAKINUM(INUM(MAKINUM(65536)&num)>>16),cons(MAKINUM(INUM(MAKINUM(63488)&num)>>11),cons(MAKINUM(INUM(MAKINUM(2016)&num)>>5),cons(MAKINUM(31)&num,EOL))))))),cur_output_port());
  display(MAKICHR(' '),cur_output_port());
  display(number2string(CAR(CDR(info)),MAKINUM(2)),cur_output_port());
  display(MAKICHR(' '),cur_output_port());
  newline(cur_output_port());
  display(map1(debug_print_clause_fn90,CAR(CDR(CDR(info)))),cur_output_port());
  newline(cur_output_port());
  display(CDR(CDR(CDR(info))),cur_output_port());
  return debug_print_pure_clause(pure);
}

SCM debug_print_clause_fn90(el)
SCM el;
{
  if(!(PAIR_P(el)))
    return el;
  else
    return cons(vector(cons(get_litinfo_classnr(CAR(el)),cons(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(el))>>16),cons(SBOOL(ZERO_P(MAKINUM(512)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(256)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(128)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(64)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(32)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(16)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(8)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(4)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(2)&CAR(el))),cons(SBOOL(ZERO_P(MAKINUM(1)&CAR(el))),EOL))))))))))))),CDR(el));
}

SCM debug_print_pure_clause(cl)
SCM cl;
{
  newline(cur_output_port());
  display(MAKICHR('{'),cur_output_port());
  for_each1(debug_print_pure_clause_fn92,cl);
  display(MAKICHR('}'),cur_output_port());
  return newline(cur_output_port());
}

SCM debug_print_pure_clause_fn92(x)
SCM x;
{
  debug_print_lit(x);
  return display(MAKICHR(' '),cur_output_port());
}

SCM debug_print_lit(term)
SCM term;
{
  SCM part;

  display(MAKICHR('['),cur_output_port());
  debug_print_pred(CAR(term));
  if(!(NULL_P(CDR(term))))
    display(MAKICHR(' '),cur_output_port());
  for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
    debug_print_term(CAR(part));
    if(!(NULL_P(CDR(part))))
      display(MAKICHR(' '),cur_output_port());
  }
  return display(MAKICHR(']'),cur_output_port());
}

SCM debug_print_term(term)
SCM term;
{
  SCM part;

  if(!(NUMBER_P(term))) {
    display(MAKICHR('('),cur_output_port());
    debug_print_fun(CAR(term));
    if(!(NULL_P(CDR(term))))
      display(MAKICHR(' '),cur_output_port());
    for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
      debug_print_term(CAR(part));
      if(!(NULL_P(CDR(part))))
        display(MAKICHR(' '),cur_output_port());
    }
    return display(MAKICHR(')'),cur_output_port());
  }
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535)))
    return debug_print_var(term);
  else
    return debug_print_const(term);
}

SCM debug_print_pred(funnum)
SCM funnum;
{
  if(!(ZERO_P(MAKINUM(268435456)&funnum)))
    display(MAKICHR('-'),cur_output_port());
  return display(vector(cons(CAR(rassq(MAKINUM(266338304)&funnum,GLOBAL(pred_num_table_global))),cons(MAKINUM(INUM(MAKINUM(1835008)&funnum)>>18),cons(MAKINUM(INUM(MAKINUM(131072)&funnum)>>17),cons(MAKINUM(INUM(MAKINUM(65536)&funnum)>>16),cons(MAKINUM(INUM(MAKINUM(63488)&funnum)>>11),cons(MAKINUM(INUM(MAKINUM(2016)&funnum)>>5),cons(MAKINUM(31)&funnum,EOL)))))))),cur_output_port());
}

SCM debug_print_fun(funnum)
SCM funnum;
{
  return display(vector(cons(CAR(rassq(MAKINUM(534773760)&funnum,GLOBAL(fun_num_table_global))),cons(MAKINUM(INUM(MAKINUM(1835008)&funnum)>>18),cons(MAKINUM(INUM(MAKINUM(131072)&funnum)>>17),cons(MAKINUM(INUM(MAKINUM(65536)&funnum)>>16),cons(MAKINUM(INUM(MAKINUM(63488)&funnum)>>11),cons(MAKINUM(INUM(MAKINUM(2016)&funnum)>>5),cons(MAKINUM(31)&funnum,EOL)))))))),cur_output_port());
}

SCM debug_print_const(constnum)
SCM constnum;
{
  if(constnum==MAKINUM(99999999))
    return display(const_90,cur_output_port());
  else
    return display(CAR(rassq(constnum,GLOBAL(const_num_table_global))),cur_output_port());
}

SCM debug_print_var(varnr)
SCM varnr;
{
  SCM zflg,yflg,try;

  yflg=BOOL_F;
  zflg=BOOL_F;
  if(!(ZERO_P(MAKINUM(256)&varnr))) {
    yflg=BOOL_T;
    varnr=MAKINUM(256^INUM(varnr));
  }
  if(!(ZERO_P(MAKINUM(512)&varnr))) {
    zflg=BOOL_T;
    varnr=MAKINUM(512^INUM(varnr));
  }
  return display(st_append(cons(number2string(MAKINUM(INUM(MAKINUM(32768)&varnr)>>15),MAKINUM(10)),cons(number2string(MAKINUM(INUM(MAKINUM(16384)&varnr)>>14),MAKINUM(10)),cons(number2string(MAKINUM(INUM(MAKINUM(8192)&varnr)>>13),MAKINUM(10)),cons((try=assq(MAKINUM(8191)&varnr,GLOBAL(nr_var_table_global)),(NFALSEP(try) ? (NFALSEP(yflg) ? st_append(cons(const_91,cons(symbol2string(CDR(try)),EOL))) : (NFALSEP(zflg) ? st_append(cons(const_92,cons(symbol2string(CDR(try)),EOL))) : symbol2string(CDR(try)))) : (NFALSEP(yflg) ? st_append(cons(const_93,cons(number2string(MAKINUM(INUM(MAKINUM(8191)&varnr)-6),MAKINUM(10)),EOL))) : (NFALSEP(zflg) ? st_append(cons(const_94,cons(number2string(MAKINUM(INUM(MAKINUM(8191)&varnr)-6),MAKINUM(10)),EOL))) : st_append(cons(const_95,cons(number2string(MAKINUM(INUM(MAKINUM(8191)&varnr)-6),MAKINUM(10)),EOL))))))),EOL))))),cur_output_port());
}

SCM debug_print_xvars(var)
SCM var;
{
  newline(cur_output_port());
  display(const_96,cur_output_port());
  newline(cur_output_port());
  for(;!(ZERO_P(var));) {
    debug_print_var(var);
    display(const_97,cur_output_port());
    debug_print_term(STBL_VECTOR_REF(_star_var_val_table_star__velts0,var));
    display(const_98,cur_output_port());
    display(STBL_VECTOR_REF(_star_var_touched_table_star__velts0,var),cur_output_port());
    newline(cur_output_port());
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM debug_print_yvars(var)
SCM var;
{
  newline(cur_output_port());
  display(const_99,cur_output_port());
  newline(cur_output_port());
  var=(MAKINUM(256)|var);
  for(;!(MAKINUM(256)==var);) {
    debug_print_var(var);
    display(const_100,cur_output_port());
    debug_print_term(STBL_VECTOR_REF(_star_var_val_table_star__velts0,var));
    display(const_101,cur_output_port());
    display(STBL_VECTOR_REF(_star_var_touched_table_star__velts0,var),cur_output_port());
    newline(cur_output_port());
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM debug_print_zvars(var)
SCM var;
{
  newline(cur_output_port());
  display(const_102,cur_output_port());
  newline(cur_output_port());
  var=(MAKINUM(512)|var);
  for(;!(MAKINUM(512)==var);) {
    debug_print_var(var);
    display(const_103,cur_output_port());
    debug_print_term(STBL_VECTOR_REF(_star_var_val_table_star__velts0,var));
    newline(cur_output_port());
    var=MAKINUM(INUM(var)-1);
  }
  return UNSPECIFIED;
}

SCM report_error(str,obj)
SCM str,obj;
{
  newline(cur_output_port());
  display(const_104,cur_output_port());
  display(str,cur_output_port());
  display(const_105,cur_output_port());
  for_each1(report_error_fn94,obj);
  newline(cur_output_port());
  return quit(1);
}

SCM report_error_fn94(x)
SCM x;
{
  return display(x,cur_output_port());
}

SCM get_time()
{
  if(NFALSEP(GLOBAL(use_real_time_global)))
    return apply(GLOBAL(get_internal_real_time),EOL,EOL);
  else
    return my_time();
}

SCM get_check_time(x)
SCM x;
{
  SCM tmp;

  tmp=MAKINUM(0);
  if(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))) {
    GLOBAL(last_got_time_global)=get_time();
    return GLOBAL(last_got_time_global);
  }
  else
  if((GLOBAL(kept_cl_nr_global)>=CAR(GLOBAL(given_checkpoint_keptnrs_global)))&&(x==CAR(CDR(GLOBAL(given_checkpoint_keptnrs_global))))) {
    GLOBAL(last_got_time_global)=CAR(CDR(CDR(GLOBAL(given_checkpoint_keptnrs_global))));
    GLOBAL(given_checkpoint_keptnrs_global)=CDR(CDR(CDR(GLOBAL(given_checkpoint_keptnrs_global))));
    return GLOBAL(last_got_time_global);
  }
  else {
    GLOBAL(last_got_time_global)=MAKINUM(0);
    return MAKINUM(0);
  }
}

SCM store_time_checkpoint_excl_(x)
SCM x;
{
  GLOBAL(checkpoint_keptnrs_global)=cons(GLOBAL(last_got_time_global),cons(x,cons(GLOBAL(kept_cl_nr_global),GLOBAL(checkpoint_keptnrs_global))));
  return UNSPECIFIED;
}

SCM prove(raw_input,stop_real_time,display_info_level)
SCM raw_input,stop_real_time,display_info_level;
{
  SCM new_var1,compl_lit_demodulators,demodulators,lit_demodulators,sos,usable,tmp,part;

  init_stats();
  init_globals();
  make_symbs_lex_order_vector();
  make_symbs_kb_order_vector();
  GLOBAL(internal_time_units_per_second_global)=GLOBAL(internal_time_units_per_second);
  use_input_settings(raw_input);
  GLOBAL(total_time_start_global)=get_time();
  if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
    if(NFALSEP(GLOBAL(auto_mode_flag_global))) {
      display(const_106,cur_output_port());
      newline(cur_output_port());
    }
    else {
      display(const_107,cur_output_port());
      newline(cur_output_port());
    }
  }
  if(NFALSEP(GLOBAL(timelimit_global))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
      display(const_108,cur_output_port());
      display(GLOBAL(timelimit_global),cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(total_time_given_global)=MAKINUM(INUM(GLOBAL(internal_time_units_per_second_global))*INUM(string2number(GLOBAL(timelimit_global),MAKINUM(10))));
  }
  else {
    if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
      if(NFALSEP(GLOBAL(auto_mode_flag_global))) {
        display(const_109,cur_output_port());
        display(GLOBAL(default_time_limit_global),cur_output_port());
      }
      else {
        display(const_110,cur_output_port());
      }
      newline(cur_output_port());
    }
    GLOBAL(total_time_given_global)=BOOL_F;
  }
  GLOBAL(overdouble_discr_flag_global)=BOOL_F;
  GLOBAL(nonunit_discr_flag_global)=BOOL_F;
  compl_lit_demodulators=EOL;
  demodulators=assq(GLOBAL(demodulator_list_symbol_global),raw_input);
  lit_demodulators=assq(GLOBAL(lit_demodulator_list_symbol_global),raw_input);
  sos=assq(GLOBAL(sos_list_symbol_global),raw_input);
  usable=assq(GLOBAL(usable_list_symbol_global),raw_input);
  tmp=EOL;
  GLOBAL(stop_res_real_time_global)=stop_real_time;
  if(NFALSEP(demodulators)) {
    demodulators=CDR(demodulators);
    GLOBAL(demodulate_flag_global)=BOOL_T;
    GLOBAL(new_demodulators_flag_global)=BOOL_T;
    GLOBAL(demodulate_constants_flag_global)=BOOL_T;
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_111,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_fn100,demodulators);
    }
  }
  if(NFALSEP(lit_demodulators)) {
    lit_demodulators=CDR(lit_demodulators);
    GLOBAL(demodulate_lit_flag_global)=BOOL_T;
    GLOBAL(new_demodulators_flag_global)=BOOL_T;
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_112,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_fn101,lit_demodulators);
    }
  }
  else {
    GLOBAL(demodulate_lit_flag_global)=BOOL_F;
  }
  if(NFALSEP(sos)) {
    sos=CDR(sos);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_113,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_fn102,sos);
    }
  }
  if(NFALSEP(usable)) {
    usable=CDR(usable);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_114,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_fn103,usable);
    }
  }
  if(NFALSEP(sos))
    new_var1=NOT(usable);
  else
    new_var1=BOOL_F;
  if(NFALSEP(new_var1)) ;
  else
  if(NFALSEP(usable)&&!(NFALSEP(sos))) {
    sos=usable;
    usable=BOOL_F;
  }
  GLOBAL(sos_clauses_list_global)=EOL;
  GLOBAL(usable_clauses_list_global)=EOL;
  GLOBAL(subsumption_list_global)=cons(cons(MAKINUM(0),EOL),EOL);
  GLOBAL(unit_alist_global)=EOL;
  GLOBAL(discr_tree_global)=cons(EOL,EOL);
  GLOBAL(nonunit_discr_tree_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_terms_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_atoms_global)=cons(EOL,EOL);
  GLOBAL(kept_cl_nr_global)=MAKINUM(0);
  init_numerify_clause_list();
  if(NFALSEP(demodulators)) {
    if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
      demodulators=map1(prove_fn104,demodulators);
    }
    demodulators=map1(numerify_clause,demodulators);
  }
  if(NFALSEP(lit_demodulators)) {
    lit_demodulators=map1(numerify_clause,lit_demodulators);
  }
  if(NFALSEP(usable)) {
    usable=map1(numerify_clause,usable);
  }
  if(NFALSEP(sos)) {
    sos=map1(numerify_clause,sos);
  }
  if(!(NFALSEP(usable))&&NFALSEP(GLOBAL(auto_mode_flag_global))) {
    tmp=EOL;
    usable=EOL;
    for(part=sos;!(NULL_P(part));part=CDR(part))
      if(NFALSEP(negative_cl_pred_(CAR(part)))) {
        tmp=cons(CAR(part),tmp);
      }
      else {
        usable=cons(CAR(part),usable);
      }
    sos=reverse(tmp);
  }
  if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
    GLOBAL(subst_fun_nr_global)=CDR(assq(GLOBAL(subst_fun_symbol_global),GLOBAL(fun_num_table_global)));
    GLOBAL(subst_prim_fun_nr_global)=CDR(assq(GLOBAL(subst_prim_fun_symbol_global),GLOBAL(fun_num_table_global)));
    GLOBAL(lambda_fun_nr_global)=CDR(assq(GLOBAL(lambda_fun_symbol_global),GLOBAL(fun_num_table_global)));
    GLOBAL(lambda_dummypar_nr_global)=CDR(assq(GLOBAL(lambda_dummypar_symbol_global),GLOBAL(const_num_table_global)));
  }
  fill_predsymb_bit_vector_excl_();
  GLOBAL(strat_list_global)=const_115;
  GLOBAL(no_passes_started_global)=BOOL_T;
  return prove_all_passes(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
}

SCM prove_fn104(x)
SCM x;
{
  return add_typet_demod_ans(x);
}

SCM prove_fn103(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prove_fn102(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prove_fn101(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prove_fn100(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prove_make_initial_clauses(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  if(NFALSEP(demodulators)) {
    demodulators=map1(prove_make_initial_clauses_fn116,demodulators);
    for_each1(modify_to_demod_inf_excl_,demodulators);
    for_each1(intern_fullclause,demodulators);
    for_each1(prove_make_initial_clauses_fn117,(NFALSEP(GLOBAL(type_theory_stratflag_global)) ? map1(remove_typet_demod_ans,demodulators) : demodulators));
  }
  if(NFALSEP(lit_demodulators)) {
    compl_lit_demodulators=map1(prove_make_initial_clauses_fn118,lit_demodulators);
    lit_demodulators=map1(prove_make_initial_clauses_fn120,lit_demodulators);
    compl_lit_demodulators=map1(prove_make_initial_clauses_fn121,compl_lit_demodulators);
    for_each1(intern_fullclause,lit_demodulators);
    for_each1(intern_fullclause,compl_lit_demodulators);
    for_each1(prove_make_initial_clauses_fn122,lit_demodulators);
  }
  if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
    newline(cur_output_port());
    display(const_116,cur_output_port());
    newline(cur_output_port());
    newline(cur_output_port());
    for_each1(prove_make_initial_clauses_fn123,sos);
  }
  if(NFALSEP(sos)) {
    if(NFALSEP(usable)) {
      usable=map1(prove_make_initial_clauses_fn124,usable);
    }
    else {
      usable=EOL;
    }
    GLOBAL(last_usable_cl_nr_global)=GLOBAL(kept_cl_nr_global);
    sos=map1(prove_make_initial_clauses_fn125,sos);
    if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_117,cur_output_port());
      newline(cur_output_port());
      newline(cur_output_port());
      for_each1(prove_make_initial_clauses_fn126,append2(usable,sos));
    }
    if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
      GLOBAL(ans_input_sos_global)=append2(demodulators,sos);
      sos=remove_ans_from_clauses(sos);
    }
    for_each1(intern_fullclause,usable);
    for_each1(intern_fullclause,sos);
  }
  else {
    newline(cur_output_port());
    display(const_118,cur_output_port());
    newline(cur_output_port());
    quit(1);
  }
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  if(!(NFALSEP(demodulators))) {
    demodulators=EOL;
  }
  if(!(NFALSEP(sos))) {
    sos=EOL;
  }
  if(!(NFALSEP(lit_demodulators))) {
    lit_demodulators=EOL;
  }
  if(!(NFALSEP(compl_lit_demodulators))) {
    compl_lit_demodulators=EOL;
  }
  if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
    GLOBAL(sos_clauses_list_global)=append2(append2(append2(remove_ans_from_clauses(demodulators),compl_lit_demodulators),usable),sos);
  }
  else {
    GLOBAL(usable_clauses_list_global)=usable;
    GLOBAL(sos_clauses_list_global)=sos;
  }
  return cons(usable,cons(sos,cons(demodulators,cons(lit_demodulators,cons(compl_lit_demodulators,EOL)))));
}

SCM prove_make_initial_clauses_fn126(x)
SCM x;
{
  display(x,cur_output_port());
  newline(cur_output_port());
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_make_initial_clauses_fn125(x)
SCM x;
{
  return make_input_clause(x,MAKINUM(1));
}

SCM prove_make_initial_clauses_fn124(x)
SCM x;
{
  return make_input_clause(x,BOOL_F);
}

SCM prove_make_initial_clauses_fn123(x)
SCM x;
{
  display(x,cur_output_port());
  newline(cur_output_port());
  debug_print_pure_clause(x);
  return newline(cur_output_port());
}

SCM prove_make_initial_clauses_fn122(x)
SCM x;
{
  GLOBAL(cur_clause_global)=cons(CAR(x),map1(rename_x_to_z_term,CDR(x)));
  if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(CDR(GLOBAL(cur_clause_global))))))) {
    GLOBAL(cur_clause_global)=cons(CAR(GLOBAL(cur_clause_global)),cons(CAR(CDR(CDR(GLOBAL(cur_clause_global)))),cons(CAR(CDR(GLOBAL(cur_clause_global))),EOL)));
  }
  GLOBAL(cur_lit_global)=CAR(CDR(GLOBAL(cur_clause_global)));
  return insert_discr_tree_excl_(GLOBAL(discr_tree_demod_atoms_global),GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T,BOOL_F);
}

SCM prove_make_initial_clauses_fn121(x)
SCM x;
{
  return make_input_clause(x,BOOL_F);
}

SCM prove_make_initial_clauses_fn120(x)
SCM x;
{
  return make_input_clause(x,BOOL_F);
}

SCM prove_make_initial_clauses_fn118(x)
SCM x;
{
  return map1(prove_make_initial_clauses_fn119,x);
}

SCM prove_make_initial_clauses_fn119(y)
SCM y;
{
  return cons(MAKINUM(268435456^INUM(CAR(y))),CDR(y));
}

SCM prove_make_initial_clauses_fn117(x)
SCM x;
{
  GLOBAL(cur_clause_global)=cons(CAR(x),map1(rename_x_to_z_term,CDR(x)));
  GLOBAL(cur_lit_global)=CAR(CDR(GLOBAL(cur_clause_global)));
  return insert_discr_tree_excl_(GLOBAL(discr_tree_demod_terms_global),CAR(CDR(GLOBAL(cur_lit_global))),BOOL_F,BOOL_T,BOOL_T,BOOL_F);
}

SCM prove_make_initial_clauses_fn116(x)
SCM x;
{
  return make_input_clause(x,BOOL_F);
}

SCM prove_show_input_clauses(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&!(NULL_P(demodulators))) {
    newline(cur_output_port());
    display(const_119,cur_output_port());
    newline(cur_output_port());
    for_each1(prove_show_input_clauses_fn135,demodulators);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_120,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_show_input_clauses_fn136,demodulators);
    }
  }
  if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&!(NULL_P(lit_demodulators))) {
    newline(cur_output_port());
    display(const_121,cur_output_port());
    newline(cur_output_port());
    for_each1(prove_show_input_clauses_fn137,lit_demodulators);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_122,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_show_input_clauses_fn138,lit_demodulators);
    }
  }
  if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&!(NULL_P(usable))) {
    newline(cur_output_port());
    display(const_123,cur_output_port());
    newline(cur_output_port());
    for_each1(prove_show_input_clauses_fn139,usable);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_124,cur_output_port());
      newline(cur_output_port());
      for_each1(prove_show_input_clauses_fn140,usable);
    }
  }
  if((GLOBAL(display_info_level_global)>=MAKINUM(40))&&!(NULL_P(sos))) {
    newline(cur_output_port());
    display(const_125,cur_output_port());
    newline(cur_output_port());
    for_each1(prove_show_input_clauses_fn141,sos);
    if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
      newline(cur_output_port());
      display(const_126,cur_output_port());
      newline(cur_output_port());
      return for_each1(prove_show_input_clauses_fn142,sos);
    }
    else
      return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM prove_show_input_clauses_fn142(x)
SCM x;
{
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn141(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn140(x)
SCM x;
{
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn139(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn138(x)
SCM x;
{
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn137(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn136(x)
SCM x;
{
  debug_print_clause(x);
  return newline(cur_output_port());
}

SCM prove_show_input_clauses_fn135(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM prove_all_passes(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  SCM tmp,res;

  newline(cur_output_port());
  display(const_127,cur_output_port());
  newline(cur_output_port());
  tmp=EOL;
  res=BOOL_F;
  GLOBAL(all_passes_selected_clauses_global)=EOL;
  GLOBAL(strat_list_global)=const_128;
  if(!(NFALSEP(GLOBAL(auto_mode_flag_global)))) {
    if(NFALSEP(GLOBAL(total_time_given_global))) {
      GLOBAL(one_pass_time_global)=GLOBAL(total_time_given_global);
    }
    else {
      GLOBAL(one_pass_time_global)=MAKINUM(1000000);
    }
    res=prove_one_pass(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
    get_check_time(MAKINUM(20));
    store_time_checkpoint_excl_(MAKINUM(20));
    return res;
  }
  else {
    if(NFALSEP(GLOBAL(total_time_given_global))) {
      GLOBAL(all_passes_time_global)=MAKINUM(INUM(GLOBAL(total_time_given_global))/INUM(GLOBAL(internal_time_units_per_second_global)));
    }
    else {
      GLOBAL(all_passes_time_global)=GLOBAL(default_time_limit_global);
    }
    build_strat_list(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
    res=prove_all_passes_loop_strategies(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
    return res;
  }
}

SCM prove_all_passes_loop_strategies(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  SCM tmp,res;

  tmp=EOL;
  res=BOOL_F;
  for(;!(NFALSEP(res)||((NFALSEP(GLOBAL(sat_strategy_flag_global))&&NFALSEP(GLOBAL(sat_found_flag_global)))||(NULL_P(GLOBAL(strat_list_global))||(NFALSEP(GLOBAL(total_time_given_global))&&((INUM(get_check_time(MAKINUM(10)))-INUM(GLOBAL(total_time_start_global)))>INUM(GLOBAL(total_time_given_global)))))));) {
    GLOBAL(strat_selected_global)=CAR(GLOBAL(strat_list_global));
    GLOBAL(strat_given_time_global)=MAKINUM(INUM(GLOBAL(internal_time_units_per_second_global))*INUM(CAR(CDR(GLOBAL(strat_selected_global)))));
    GLOBAL(strat_start_time_global)=get_check_time(MAKINUM(40));
    store_time_checkpoint_excl_(MAKINUM(40));
    if(CAR(GLOBAL(strat_selected_global))==split_symb) {
      GLOBAL(strat_list_global)=CDR(GLOBAL(strat_list_global));
      res=prove_all_passes_split_strategy(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,GLOBAL(strat_selected_global));
    }
    else {
      res=prove_all_passes_single_strategy(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
    }
  }
  if(!(NFALSEP(GLOBAL(foundflag_global)))&&!(NULL_P(GLOBAL(strat_list_global))))
    store_time_checkpoint_excl_(MAKINUM(10));
  get_check_time(MAKINUM(30));
  store_time_checkpoint_excl_(MAKINUM(30));
  return res;
}

SCM prove_all_passes_split_strategy(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,splitinfo)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,splitinfo;
{
  SCM splitslst,origstratlist,savedstratlist,trynr,tmp,tmpstrat,res,splittime,splitclause,splitparts,splitstrats,splitsos,okflag,failflag,part;

  origstratlist=copytree(GLOBAL(strat_list_global));
  savedstratlist=EOL;
  trynr=MAKINUM(0);
  tmp=EOL;
  tmpstrat=EOL;
  res=EOL;
  splittime=EOL;
  splitclause=EOL;
  splitparts=EOL;
  splitstrats=EOL;
  splitsos=EOL;
  okflag=BOOL_T;
  failflag=BOOL_F;
  GLOBAL(split_search_active_flag_global)=BOOL_T;
  splittime=CAR(CDR(splitinfo));
  splitclause=CAR(CDR(CDR(splitinfo)));
  splitparts=CAR(CDR(CDR(CDR(splitinfo))));
  splitstrats=CAR(CDR(CDR(CDR(CDR(splitinfo)))));
  if(GLOBAL(display_info_level_global)>=MAKINUM(20)) {
    newline(cur_output_port());
    display(const_129,cur_output_port());
    display(length(splitparts),cur_output_port());
    display(const_130,cur_output_port());
    newline(cur_output_port());
  }
  for(splitslst=splitparts;!(NULL_P(splitslst)||NFALSEP(failflag));splitslst=CDR(splitslst)) {
    trynr=MAKINUM(1+INUM(trynr));
    if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
      newline(cur_output_port());
      display(const_131,cur_output_port());
      display(trynr,cur_output_port());
      display(const_132,cur_output_port());
      newline(cur_output_port());
    }
    clear_space_for_split();
    splitsos=make_split_sos(sos,splitclause,CAR(splitslst));
    GLOBAL(strat_list_global)=splitstrats;
    tmpstrat=EOL;
    for(part=GLOBAL(strat_list_global);!(NULL_P(part));part=CDR(part))
      if(NULL_P(CDR(part))) {
        tmpstrat=cons(cons(CAR(CAR(part)),cons(MAKINUM(10*INUM(CAR(CDR(CAR(part))))),CDR(CDR(CAR(part))))),tmpstrat);
      }
      else {
        tmpstrat=cons(cons(CAR(CAR(part)),cons(MAKINUM(2*INUM(CAR(CDR(CAR(part))))),CDR(CDR(CAR(part))))),tmpstrat);
      }
    GLOBAL(strat_list_global)=reverse(tmpstrat);
    GLOBAL(strat_selected_global)=CAR(GLOBAL(strat_list_global));
    GLOBAL(foundflag_global)=BOOL_F;
    savedstratlist=GLOBAL(strat_list_global);
    okflag=prove_all_passes_loop_strategies(usable,splitsos,demodulators,lit_demodulators,compl_lit_demodulators);
    GLOBAL(foundflag_global)=BOOL_F;
    GLOBAL(strat_list_global)=savedstratlist;
    GLOBAL(strat_list_global)=CDR(GLOBAL(strat_list_global));
    if(!(NFALSEP(okflag))) {
      failflag=BOOL_T;
    }
  }
  GLOBAL(split_search_active_flag_global)=BOOL_F;
  GLOBAL(strat_list_global)=origstratlist;
  if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
    newline(cur_output_port());
    display(const_133,cur_output_port());
    if(NFALSEP(failflag))
      display(const_134,cur_output_port());
    else
      display(const_135,cur_output_port());
    newline(cur_output_port());
  }
  if(NFALSEP(failflag)) {
    clear_space_for_split();
    return BOOL_F;
  }
  else {
    clear_space_for_split();
    return BOOL_T;
  }
}

SCM clear_space_for_split()
{
  GLOBAL(sos_clauses_list_global)=EOL;
  GLOBAL(usable_clauses_list_global)=EOL;
  GLOBAL(subsumption_list_global)=cons(cons(MAKINUM(0),EOL),EOL);
  GLOBAL(unit_alist_global)=EOL;
  GLOBAL(discr_tree_global)=cons(EOL,EOL);
  GLOBAL(nonunit_discr_tree_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_terms_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_demod_atoms_global)=cons(EOL,EOL);
  GLOBAL(discr_tree_list_global)=EOL;
  GLOBAL(unit_alist_list_global)=EOL;
  GLOBAL(sos_clauses_list_list_global)=EOL;
  GLOBAL(usable_clauses_list_list_global)=EOL;
  return UNSPECIFIED;
}

SCM make_split_sos(sos,splitclause,splitpart)
SCM sos,splitclause,splitpart;
{
  SCM foundflag,res,tmp,sospart;

  tmp=EOL;
  res=EOL;
  foundflag=BOOL_F;
  if(1) {
    newline(cur_output_port());
    display(const_136,cur_output_port());
    newline(cur_output_port());
    display(const_137,cur_output_port());
    newline(cur_output_port());
    display(const_138,cur_output_port());
    newline(cur_output_port());
    print_pure_clause(splitclause);
    newline(cur_output_port());
    display(const_139,cur_output_port());
    print_pure_clause(splitpart);
    newline(cur_output_port());
    display(const_140,cur_output_port());
  }
  for(sospart=sos;!(NULL_P(sospart));sospart=CDR(sospart))
    if(!(NFALSEP(foundflag))&&NFALSEP(equal(CAR(sospart),splitclause))) {
      res=cons(splitpart,res);
      foundflag=BOOL_T;
    }
    else {
      res=cons(CAR(sospart),res);
    }
  return res;
}

SCM prove_all_passes_single_strategy(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  SCM tmpsos,tmpusable,tmp,iterate_depth_flag,part;

  iterate_depth_flag=BOOL_T;
  tmp=EOL;
  tmpusable=EOL;
  tmpsos=EOL;
  for(part=sos;!(NULL_P(part));part=CDR(part)) {
    if(NFALSEP(GLOBAL(sat_strategy_flag_global))) {
      tmp=cons(EOL,EOL);
    }
    else {
      tmp=pseudo_split_input_clause(cons(EOL,CAR(part)));
    }
    if(!(NULL_P(CDR(tmp)))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(30)) {
        newline(cur_output_port());
        display(const_141,cur_output_port());
        newline(cur_output_port());
        print_pure_clause(CAR(part));
        newline(cur_output_port());
        display(const_142,cur_output_port());
        newline(cur_output_port());
        for_each1(prove_all_passes_single_strategy_fn145,tmp);
      }
      tmpsos=append2(map1(prove_all_passes_single_strategy_fn146,tmp),sos);
    }
    else {
      tmpsos=cons(CAR(part),tmpsos);
    }
  }
  sos=reverse(tmpsos);
  for(;NFALSEP(iterate_depth_flag);) {
    init_one_pass_strategical_flags();
    pick_strat_from_list();
    pick_extra_limits();
    prove_one_pass(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
    GLOBAL(strat_list_global)=CDR(GLOBAL(strat_list_global));
    GLOBAL(strat_passed_time_global)=MAKINUM(INUM(get_check_time(MAKINUM(50)))-INUM(GLOBAL(strat_start_time_global)));
    store_time_checkpoint_excl_(MAKINUM(50));
    GLOBAL(strat_left_time_global)=MAKINUM(INUM(GLOBAL(strat_given_time_global))-INUM(GLOBAL(strat_passed_time_global)));
    if(!(NFALSEP(GLOBAL(foundflag_global)))&&(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&(NFALSEP(strat_poses_depth_limit_pred_(GLOBAL(strat_selected_global)))&&((INUM(GLOBAL(strat_left_time_global))>(1*INUM(GLOBAL(internal_time_units_per_second_global))))&&((GLOBAL(strat_left_time_global)>GLOBAL(strat_passed_time_global))&&(strat_depth_limit(GLOBAL(strat_selected_global))<=MAKINUM(20))))))) {
      GLOBAL(strat_list_global)=cons(set_strat_time(increase_strat_depth_limit(GLOBAL(strat_selected_global)),MAKINUM(INUM(GLOBAL(strat_left_time_global))/INUM(GLOBAL(internal_time_units_per_second_global)))),GLOBAL(strat_list_global));
      GLOBAL(strat_selected_global)=CAR(GLOBAL(strat_list_global));
      iterate_depth_flag=BOOL_T;
    }
    else {
      iterate_depth_flag=BOOL_F;
    }
  }
  if(NFALSEP(GLOBAL(foundflag_global))) {
    return BOOL_T;
  }
  else {
    return BOOL_F;
  }
}

SCM prove_all_passes_single_strategy_fn146(x)
SCM x;
{
  return CDR(x);
}

SCM prove_all_passes_single_strategy_fn145(y)
SCM y;
{
  print_pure_clause(CDR(y));
  return newline(cur_output_port());
}

SCM strat_poses_depth_limit_pred_(strat)
SCM strat;
{
  if(!(split_symb==CAR(strat))) {
    if(!(NULL_P(CDR(strat)))) {
      if(!(NULL_P(CDR(CDR(strat))))) {
        if(!(NULL_P(CDR(CDR(CDR(strat))))))
          return SBOOL(MAKINUM(0)<CAR(CDR(CDR(CDR(strat)))));
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM strat_depth_limit(strat)
SCM strat;
{
  if(!(NULL_P(CDR(strat)))&&(!(NULL_P(CDR(CDR(strat))))&&!(NULL_P(CDR(CDR(CDR(strat)))))))
    return CAR(CDR(CDR(CDR(strat))));
  else
    return MAKINUM(0);
}

SCM set_strat_time(strat,time)
SCM strat,time;
{
  return cons(CAR(strat),cons(time,CDR(CDR(strat))));
}

SCM increase_strat_depth_limit(strat)
SCM strat;
{
  return cons(CAR(strat),cons(CAR(CDR(strat)),cons(CAR(CDR(CDR(strat))),cons(MAKINUM(1+INUM(CAR(CDR(CDR(CDR(strat)))))),CDR(CDR(CDR(CDR(strat))))))));
}

SCM pick_strat_from_list()
{
  SCM el,stratname;

  el=CAR(GLOBAL(strat_list_global));
  stratname=CAR(el);
  if(CAR(el)==binary_epr_order_symb)
    init_epr_order_strat();
  else
  if(CAR(el)==binary_posweight_kb_big_order_symb)
    init_posweight_ordered_binres_kb_big_strat();
  else
  if(CAR(el)==binary_posweight_kb_small_order_symb)
    init_posweight_ordered_binres_kb_small_strat();
  else
  if(CAR(el)==binary_posweight_order_kb_small_symb)
    init_posweight_ordered_binres_kb_small_strat();
  else
  if(CAR(el)==binary_posweight_order_kb_small_fulleq_symb)
    init_posweight_ordered_binres_kb_small_fulleq_strat();
  else
  if(CAR(el)==binary_posweight_lex_big_order_symb)
    init_posweight_ordered_binres_lex_big_strat();
  else
  if(CAR(el)==binary_posweight_lex_small_order_symb)
    init_posweight_ordered_binres_lex_small_strat();
  else
  if(CAR(el)==binary_posweight_firstpref_order_symb)
    init_posweight_ordered_firstpref_strat();
  else
  if(CAR(el)==binary_posweight_order_symb)
    init_posweight_ordered_binres_strat();
  else
  if(CAR(el)==hyper_order_uniteq_symb)
    init_ordered_hyper_uniteq_strat();
  else
  if(CAR(el)==binary_unit_uniteq_symb)
    init_unit_uniteq_strat();
  else
  if(CAR(el)==binary_bliksem_symb)
    init_binres_bliksem_strat();
  else
  if(CAR(el)==binary_rootpara_symb)
    init_binary_unit_depth_root_backdemod_alt();
  else
  if(CAR(el)==binary_nameorder_uniteq_symb)
    init_name_ordered_binres_uniteq_strat();
  else
  if(CAR(el)==binary_order_uniteq_symb)
    init_ordered_binres_uniteq_strat();
  else
  if(CAR(el)==binary_uniteq_symb)
    init_binres_uniteq_strat();
  else
  if(CAR(el)==binary_nameorder_sos_symb)
    init_name_ordered_binres_sos_strat();
  else
  if(CAR(el)==binary_order_symb)
    init_ordered_binres_strat();
  else
  if(CAR(el)==binary_order_sos_symb)
    init_ordered_binres_sos_strat();
  else
  if(CAR(el)==binary_posweightorder_sos_symb)
    init_posweight_ordered_binres_sos_strat();
  else
  if(CAR(el)==binary_order_fulleq_symb)
    init_ordered_binres_fulleq_strat();
  else
  if(CAR(el)==binary_weightorder_symb)
    init_weight_ordered_binres_strat();
  else
  if(CAR(el)==binary_weightorder_sos_symb)
    init_weight_ordered_binres_sos_strat();
  else
  if(CAR(el)==prop_unsat_nofun_strat_symb)
    init_prop_unsat_nofun_strat();
  else
  if(CAR(el)==sat_hyper_strat_symb)
    init_sat_hyper_strat();
  else
  if(CAR(el)==sat_ordered_binres_strat_symb)
    init_sat_ordered_binres_strat();
  else
  if(CAR(el)==sat_posweight_order_symb)
    init_sat_posweight_ordered_binres_strat();
  else
  if(CAR(el)==sat_weight_ordered_binres_strat_symb)
    init_sat_weight_ordered_binres_strat();
  else
  if(CAR(el)==simple_model_strat_symb)
    init_simple_model_strat();
  else
  if(CAR(el)==mace_model_strat_symb)
    init_mace_model_strat();
  else
  if(CAR(el)==sem_model_strat_symb)
    init_sem_model_strat();
  else
  if(CAR(el)==sem_model_strat_0_symb) {
    init_sem_model_strat();
    GLOBAL(props_selection_strategy_global)=MAKINUM(0);
  }
  else
  if(CAR(el)==sem_model_strat_1_symb) {
    init_sem_model_strat();
    GLOBAL(props_selection_strategy_global)=MAKINUM(1);
  }
  else
  if(CAR(el)==sem_model_strat_2_symb) {
    init_sem_model_strat();
    GLOBAL(props_selection_strategy_global)=MAKINUM(2);
  }
  else
  if(CAR(el)==sem_model_strat_3_symb) {
    init_sem_model_strat();
    GLOBAL(props_selection_strategy_global)=MAKINUM(3);
  }
  else
  if(CAR(el)==sem_model_strat_4_symb) {
    init_sem_model_strat();
    GLOBAL(props_selection_strategy_global)=MAKINUM(4);
  }
  else
  if(CAR(el)==sem_model_strat_5_symb) {
    init_sem_model_strat();
    GLOBAL(props_selection_strategy_global)=MAKINUM(5);
  }
  else
  if(CAR(el)==mace_nofuns_model_strat_symb)
    init_mace_nofuns_model_strat();
  else
  if(CAR(el)==random_model_strat_symb)
    init_random_model_strat();
  else
  if(CAR(el)==binary_hyper_sos_symb)
    init_binary_hyper_sos_strat();
  else
  if(CAR(el)==hyper_symb)
    init_hyper_strat();
  else
  if(CAR(el)==hyper_order_symb)
    init_ordered_hyper_strat();
  else
  if(CAR(el)==hyper_wos_symb)
    init_hyper_wos_strat();
  else
  if(CAR(el)==binary_symb)
    init_binres_strat();
  else
  if(CAR(el)==binary_unit_symb)
    init_unit_strat();
  else
  if(CAR(el)==binary_double_symb)
    init_double_strat();
  else
  if(CAR(el)==binary_order_symb)
    init_ordered_binres_strat();
  else
  if(CAR(el)==binary_nameorder_symb)
    init_name_ordered_binres_strat();
  else
  if(CAR(el)==binary_unit_depth_symb)
    init_binary_unit_depth();
  else
  if(CAR(el)==binary_unit_depth_sospref_symb)
    init_binary_unit_depth_sospref();
  else
  if(CAR(el)==binary_unit_depth_backdemod_symb)
    init_binary_unit_depth_backdemod();
  else
  if(CAR(el)==binary_unit_depth_sospref_alt_symb)
    init_binary_unit_depth_sospref_alt();
  else
  if(CAR(el)==binary_unit_depth_backdemod_alt_symb)
    init_binary_unit_depth_backdemod_alt();
  else
  if(CAR(el)==binary_unit_lex_backdemod_symb)
    init_binary_unit_lex_backdemod();
  else
  if(CAR(el)==binary_unit_lex_symb)
    init_binary_unit_lex();
  else
  if(CAR(el)==binary_unit_firstpref_backdemod_symb)
    init_binary_unit_firstpref_backdemod();
  else
  if(CAR(el)==binary_unit_firstpref_symb)
    init_binary_unit_firstpref();
  else
    init_posweight_ordered_binres_kb_big_strat();
  el=CDR(el);
  GLOBAL(one_pass_time_global)=MAKINUM(INUM(GLOBAL(internal_time_units_per_second_global))*INUM(CAR(el)));
  el=CDR(el);
  GLOBAL(sos_strategy_flag_global)=CAR(el);
  el=CDR(el);
  if(!(NULL_P(el))) {
    if(stratname==binary_bliksem_symb) {
      GLOBAL(clause_finalkeepsize_limit_global)=CAR(el);
      GLOBAL(clause_keepsize_limit_global)=MAKINUM(0);
      el=CDR(el);
    }
    else {
      GLOBAL(clause_keepdepth_limit_global)=CAR(el);
      el=CDR(el);
    }
  }
  if(!(NULL_P(el))) {
    GLOBAL(clause_keeplength_limit_global)=CAR(el);
    el=CDR(el);
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM pick_extra_limits()
{
  SCM tmp;

  tmp=EOL;
  if(1)
    return BOOL_F;
  else
  if(NFALSEP(GLOBAL(sat_strategy_flag_global))||(NFALSEP(GLOBAL(complete_unsat_strategy_global))||NFALSEP(GLOBAL(complete_sat_strategy_global)))) {
    GLOBAL(clause_keepsize_limit_global)=MAKINUM(0);
    GLOBAL(clause_finalkeepsize_limit_global)=MAKINUM(0);
    GLOBAL(clause_keepdepth_limit_global)=MAKINUM(0);
    GLOBAL(clause_keeplength_limit_global)=MAKINUM(0);
    return UNSPECIFIED;
  }
  else {
    if(GLOBAL(clause_keepdepth_limit_global)==MAKINUM(0)) {
      GLOBAL(clause_keepdepth_limit_global)=MAKINUM(20*INUM(GLOBAL(input_avgdepth_nr_global)));
      if((10*INUM(GLOBAL(input_maxdepth_nr_global)))>INUM(GLOBAL(clause_keepdepth_limit_global))) {
        GLOBAL(clause_keepdepth_limit_global)=MAKINUM(10*INUM(GLOBAL(input_maxdepth_nr_global)));
      }
      if(GLOBAL(clause_keepdepth_limit_global)<MAKINUM(50)) {
        GLOBAL(clause_keepdepth_limit_global)=MAKINUM(50);
      }
    }
    if(GLOBAL(clause_keepsize_limit_global)==MAKINUM(0)) {
      GLOBAL(clause_keepsize_limit_global)=MAKINUM(20*INUM(GLOBAL(input_avgsize_nr_global)));
      if((10*INUM(GLOBAL(input_maxsize_nr_global)))>INUM(GLOBAL(clause_keepsize_limit_global))) {
        GLOBAL(clause_keepsize_limit_global)=MAKINUM(10*INUM(GLOBAL(input_maxsize_nr_global)));
      }
      if(GLOBAL(clause_keepsize_limit_global)<MAKINUM(200)) {
        GLOBAL(clause_keepsize_limit_global)=MAKINUM(200);
      }
    }
    if(GLOBAL(clause_finalkeepsize_limit_global)>GLOBAL(clause_keepsize_limit_global)) {
      GLOBAL(clause_finalkeepsize_limit_global)=GLOBAL(clause_keepsize_limit_global);
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
}

SCM build_strat_list(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  SCM tmp,origclauses;

  tmp=EOL;
  origclauses=EOL;
  origclauses=cons(usable,cons(sos,cons(demodulators,cons(lit_demodulators,cons(compl_lit_demodulators,EOL)))));
  tmp=prove_make_initial_clauses(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
  usable=CAR(tmp);
  tmp=CDR(tmp);
  sos=CAR(tmp);
  tmp=CDR(tmp);
  demodulators=CAR(tmp);
  tmp=CDR(tmp);
  lit_demodulators=CAR(tmp);
  tmp=CDR(tmp);
  compl_lit_demodulators=CAR(tmp);
  tmp=CDR(tmp);
  GLOBAL(no_passes_started_global)=BOOL_T;
  if(NFALSEP(GLOBAL(no_passes_started_global))) {
    prove_show_input_clauses(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
    analyse_input(usable,sos);
    if(NFALSEP(GLOBAL(auto_mode_flag_global))) {
      select_initial_strategy();
      if(NFALSEP(GLOBAL(splitting_allowed_flag_global))&&!(NFALSEP(GLOBAL(sat_strategy_flag_global))))
        build_split_stratlist(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,origclauses);
    }
    GLOBAL(no_passes_started_global)=BOOL_F;
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM build_split_stratlist(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,origclauses)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,origclauses;
{
  SCM soslen,newsplitpartlst,newnosplitlst,maxsecondoriglen,maxsplitoriglen,maxposlit,maxoriglen,splitnrvars,maxsplitnrvars,maxsplitcomponents,res,onesplitlen,onesplit,splits,splitclause,splittimequotient,splittime,splitflag,stratlist,origstrattime,simpleorigstratlist,origstratlist,origsos,tmp,sospart;

  tmp=EOL;
  origsos=EOL;
  origstratlist=GLOBAL(strat_list_global);
  simpleorigstratlist=EOL;
  origstrattime=MAKINUM(0);
  stratlist=EOL;
  splitflag=BOOL_F;
  splittime=MAKINUM(0);
  splittimequotient=MAKINUM(1);
  splitclause=EOL;
  splits=EOL;
  onesplit=EOL;
  onesplitlen=MAKINUM(0);
  res=EOL;
  maxsplitcomponents=MAKINUM(0);
  maxsplitnrvars=MAKINUM(0);
  splitnrvars=MAKINUM(0);
  maxoriglen=MAKINUM(0);
  maxposlit=MAKINUM(0);
  maxsplitoriglen=MAKINUM(0);
  maxsecondoriglen=MAKINUM(0);
  newnosplitlst=EOL;
  newsplitpartlst=EOL;
  soslen=MAKINUM(0);
  if(!(NULL_P(origclauses))&&!(NULL_P(CDR(origclauses)))) {
    origsos=CAR(CDR(origclauses));
  }
  soslen=length(origsos);
  for(sospart=origsos;!(NULL_P(sospart));sospart=CDR(sospart)) {
    tmp=length(CAR(sospart));
    if(tmp>maxoriglen) {
      maxoriglen=tmp;
    }
    else
    if(tmp>maxsecondoriglen) {
      maxsecondoriglen=tmp;
    }
  }
  for_each1_inst1(&onesplitlen,&splitclause,&maxsplitcomponents,&maxsplitoriglen,&maxsplitnrvars,&splits,&splitflag,&splitnrvars,&onesplit,maxsecondoriglen,soslen,build_split_stratlist_fn153,origsos);
  if(NFALSEP(splitflag)&&(GLOBAL(display_info_level_global)>=MAKINUM(30))) {
    newline(cur_output_port());
    display(const_143,cur_output_port());
    newline(cur_output_port());
    print_pure_clause(splitclause);
    newline(cur_output_port());
    display(const_144,cur_output_port());
    newline(cur_output_port());
    for_each1(build_split_stratlist_fn156,splits);
  }
  if(NFALSEP(splitflag)) {
    origstrattime=MAKINUM(0);
    for_each1_inst2(&origstrattime,build_split_stratlist_fn157,origstratlist);
    if((soslen==MAKINUM(1))&&(maxsplitcomponents<=MAKINUM(5))) {
      splittimequotient=MAKINUM(3);
    }
    else {
      splittimequotient=MAKINUM(2);
    }
    if(PAIR_P(origstratlist)&&PAIR_P(CDR(origstratlist))) {
      simpleorigstratlist=cons(CAR(origstratlist),my_last_pair(origstratlist));
    }
    simpleorigstratlist=origstratlist;
    newnosplitlst=select_strategy_seconds(origstratlist,MAKINUM(INUM(origstrattime)/INUM(splittimequotient)));
    newsplitpartlst=select_strategy_seconds(simpleorigstratlist,MAKINUM((INUM(origstrattime)-(INUM(origstrattime)/INUM(splittimequotient)))/INUM(maxsplitcomponents)));
    res=append2(newnosplitlst,cons(cons(split_symb,cons(splittime,cons(splitclause,cons(splits,cons(newsplitpartlst,EOL))))),EOL));
    GLOBAL(strat_list_global)=res;
  }
  if(GLOBAL(display_info_level_global)>MAKINUM(30)) {
    newline(cur_output_port());
    display(const_145,cur_output_port());
    newline(cur_output_port());
    for_each1(build_split_stratlist_fn158,GLOBAL(strat_list_global));
    return newline(cur_output_port());
  }
  else
    return UNSPECIFIED;
}

SCM build_split_stratlist_fn158(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM build_split_stratlist_fn157(origstrattime,x)
SCM *origstrattime;
SCM x;
{
  *origstrattime=MAKINUM(INUM(*origstrattime)+INUM(CAR(CDR(x))));
  return UNSPECIFIED;
}

SCM build_split_stratlist_fn156(x)
SCM x;
{
  print_pure_clause(x);
  return newline(cur_output_port());
}

SCM build_split_stratlist_fn153(onesplitlen,splitclause,maxsplitcomponents,maxsplitoriglen,maxsplitnrvars,splits,splitflag,splitnrvars,onesplit,maxsecondoriglen,soslen,x)
SCM *onesplitlen,*splitclause,*maxsplitcomponents,*maxsplitoriglen,*maxsplitnrvars,*splits,*splitflag,*splitnrvars,*onesplit;
SCM maxsecondoriglen,soslen,x;
{
  if(length(x)>=*maxsplitcomponents) {
    *onesplit=split_full_clause(cons(EOL,x));
  }
  else {
    *onesplit=EOL;
  }
  *onesplitlen=length(*onesplit);
  *splitnrvars=MAKINUM(0);
  for_each1_inst3(splitnrvars,build_split_stratlist_fn154,*onesplit);
  if((*onesplitlen>MAKINUM(1))&&((*onesplitlen<=MAKINUM(10))&&(((INUM(length(x))>=(2*INUM(maxsecondoriglen)))||(soslen<=MAKINUM(4)))&&((INUM(*splitnrvars)>(1+INUM(*maxsplitnrvars)))||((*splitnrvars>=*maxsplitnrvars)&&((*onesplitlen>*maxsplitcomponents)||((*onesplitlen==*maxsplitcomponents)&&(length(x)>*maxsplitoriglen)))))))) {
    *splitflag=BOOL_T;
    *splitclause=x;
    *splits=map1(build_split_stratlist_fn155,*onesplit);
    *maxsplitcomponents=*onesplitlen;
    *maxsplitnrvars=*splitnrvars;
    *maxsplitoriglen=length(x);
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM build_split_stratlist_fn155(x__1)
SCM x__1;
{
  return CDR(x__1);
}

SCM build_split_stratlist_fn154(splitnrvars,y)
SCM *splitnrvars;
SCM y;
{
  *splitnrvars=MAKINUM(INUM(*splitnrvars)+INUM(length(CAR(y))));
  return UNSPECIFIED;
}

SCM prove_one_pass(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators;
{
  SCM part__1,nr,oldclauses,tmp,part,part__2;

  tmp=EOL;
  oldclauses=EOL;
  nr=MAKINUM(0);
  if(NFALSEP(GLOBAL(combinedstrat_flag_global)))
    init_one_pass_globals_combinedstrategy();
  else
    init_one_pass_globals();
  tmp=prove_make_initial_clauses(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators);
  usable=CAR(tmp);
  tmp=CDR(tmp);
  sos=CAR(tmp);
  tmp=CDR(tmp);
  demodulators=CAR(tmp);
  tmp=CDR(tmp);
  lit_demodulators=CAR(tmp);
  tmp=CDR(tmp);
  compl_lit_demodulators=CAR(tmp);
  tmp=CDR(tmp);
  if(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&(!(NULL_P(GLOBAL(all_passes_selected_clauses_global)))&&(!(NULL_P(GLOBAL(strat_list_global)))&&NULL_P(CDR(GLOBAL(strat_list_global))))))
    for(part=GLOBAL(all_passes_selected_clauses_global);!(NULL_P(part));part=CDR(part))
      if(PAIR_P(CAR(part))&&(!(NULL_P(CDR(CAR(part))))&&(NULL_P(CDR(CDR(CAR(part))))&&!(NFALSEP(list_contains_clause(CAR(part),usable)))))) {
        usable=cons(CAR(part),usable);
      }
  else
  if(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&(!(NULL_P(GLOBAL(all_passes_selected_clauses_global)))&&NULL_P(GLOBAL(strat_list_global))))
    for(part__1=GLOBAL(all_passes_selected_clauses_global);!(NULL_P(part__1));part__1=CDR(part__1))
      if(PAIR_P(CAR(part__1))&&(!(NULL_P(CDR(CAR(part__1))))&&!(NFALSEP(list_contains_clause(CAR(part__1),usable))))) {
        usable=cons(CAR(part__1),usable);
      }
  if(!(NFALSEP(GLOBAL(sos_strategy_flag_global)))) {
    sos=append2(sos,usable);
    usable=EOL;
  }
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global)))
    for_each1(prove_one_pass_fn169,append2(usable,sos));
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global))&&!(NFALSEP(GLOBAL(sos_strategy_flag_global)))) {
    for(part__2=sos;!(NULL_P(part__2));part__2=CDR(part__2))
      if(PAIR_P(CAR(part__2))&&NFALSEP(positive_cl_pred_(CDR(CAR(part__2))))) {
        if(!(NFALSEP(member(CAR(part__2),sos)))) {
          sos=cons(CAR(part__2),sos);
        }
      }
      else
      if(!(NFALSEP(member(CAR(part__2),tmp)))) {
        tmp=cons(CAR(part__2),tmp);
      }
    usable=reverse(tmp);
  }
  if(NFALSEP(GLOBAL(order_sos_strategy_flag_global))) {
    for_each1(prove_one_pass_fn170,sos);
    if(NFALSEP(GLOBAL(order_strategy_flag_global))||(NFALSEP(GLOBAL(name_order_strategy_flag_global))||(NFALSEP(GLOBAL(exp_order_strategy_flag_global))||(NFALSEP(GLOBAL(epr_order_strategy_flag_global))||(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))||(NFALSEP(GLOBAL(negweight_order_strategy_flag_global))||NFALSEP(GLOBAL(ordered_paramodulation_flag_global)))))))))
      for_each1(prove_one_pass_fn173,usable);
    sos=append2(sos,usable);
    usable=EOL;
  }
  else
  if(NFALSEP(GLOBAL(order_strategy_flag_global))||(NFALSEP(GLOBAL(name_order_strategy_flag_global))||(NFALSEP(GLOBAL(exp_order_strategy_flag_global))||(NFALSEP(GLOBAL(epr_order_strategy_flag_global))||(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))||(NFALSEP(GLOBAL(negweight_order_strategy_flag_global))||NFALSEP(GLOBAL(ordered_paramodulation_flag_global)))))))))
    for_each1(prove_one_pass_fn176,append2(usable,sos));
  show_one_pass_strategy();
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    enumerate_sos_literals(sos);
  GLOBAL(sos_clauses_list_global)=sos;
  GLOBAL(usable_clauses_list_global)=usable;
  return prove_one_pass_actually_prove(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,tmp,oldclauses,nr);
}

SCM prove_one_pass_fn176(cl)
SCM cl;
{
  SET_CAR(CDR(CDR(CAR(cl))),map1(prove_one_pass_fn177,order_prohibit_litinfos(map1(prove_one_pass_fn178,CAR(CDR(CDR(CAR(cl))))),CDR(cl))));
  return UNSPECIFIED;
}

SCM prove_one_pass_fn178(x)
SCM x;
{
  return cons(MAKINUM(0),cons(MAKINUM(0),x));
}

SCM prove_one_pass_fn177(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM prove_one_pass_fn173(cl)
SCM cl;
{
  SET_CAR(CDR(CDR(CAR(cl))),map1(prove_one_pass_fn174,order_prohibit_litinfos(map1(prove_one_pass_fn175,CAR(CDR(CDR(CAR(cl))))),CDR(cl))));
  return UNSPECIFIED;
}

SCM prove_one_pass_fn175(x)
SCM x;
{
  return cons(MAKINUM(0),cons(MAKINUM(0),x));
}

SCM prove_one_pass_fn174(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM prove_one_pass_fn170(cl)
SCM cl;
{
  SET_CAR(CDR(CDR(CAR(cl))),map1(prove_one_pass_fn171,clear_litorder_litinfo(map1(prove_one_pass_fn172,CAR(CDR(CDR(CAR(cl))))),CDR(cl))));
  return UNSPECIFIED;
}

SCM prove_one_pass_fn172(x)
SCM x;
{
  return cons(MAKINUM(0),cons(MAKINUM(0),x));
}

SCM prove_one_pass_fn171(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM prove_one_pass_fn169(cl)
SCM cl;
{
  if(!(NFALSEP(positive_cl_pred_(CDR(cl))))) {
    SET_CAR(CDR(CDR(CAR(cl))),make_input_litinfolst(CDR(cl)));
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM prove_one_pass_actually_prove(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,tmp,oldclauses,nr)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,tmp,oldclauses,nr;
{
  if(NFALSEP(GLOBAL(prop_unsat_strat_global))&&NFALSEP(GLOBAL(simple_model_strat_global))) {
    oldclauses=filter_map(prove_one_pass_actually_prove_fn180,GLOBAL(all_passes_selected_clauses_global));
    newline(cur_output_port());
    tmp=prop_build_simple_model(append2(oldclauses,append2(GLOBAL(sos_clauses_list_global),GLOBAL(usable_clauses_list_global))));
    if(NFALSEP(tmp)) {
      newline(cur_output_port());
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global)))) {
        display(const_146,cur_output_port());
        newline(cur_output_port());
        GLOBAL(sat_found_flag_global)=BOOL_T;
      }
      GLOBAL(sos_exhausted_flag_global)=BOOL_T;
    }
    else
    if(NFALSEP(GLOBAL(prop_time_ran_out_global)))
      display(const_147,cur_output_port());
    else
    if(tmp==BOOL_F) {
      GLOBAL(foundflag_global)=BOOL_T;
      newline(cur_output_port());
      display(const_148,cur_output_port());
    }
  }
  else
  if(NFALSEP(GLOBAL(mace_nofuns_model_strat_global))) {
    tmp=prop_build_nofuns_model(append2(GLOBAL(sos_clauses_list_global),GLOBAL(usable_clauses_list_global)));
    if(tmp==BOOL_T) {
      newline(cur_output_port());
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global)))) {
        display(const_149,cur_output_port());
        newline(cur_output_port());
        GLOBAL(sat_found_flag_global)=BOOL_T;
        quit(1);
        GLOBAL(sos_exhausted_flag_global)=BOOL_T;
      }
      else {
        GLOBAL(sos_exhausted_flag_global)=BOOL_F;
      }
    }
    else
    if(tmp==BOOL_F) {
      newline(cur_output_port());
      display(const_150,cur_output_port());
      newline(cur_output_port());
      quit(1);
      GLOBAL(sos_exhausted_flag_global)=BOOL_T;
    }
    else {
      newline(cur_output_port());
      display(const_151,cur_output_port());
      GLOBAL(sos_exhausted_flag_global)=BOOL_F;
    }
  }
  else
  if(NFALSEP(GLOBAL(sem_model_strat_global))) {
    tmp=props_build_model(make_sat_inclauses(GLOBAL(sos_clauses_list_global),GLOBAL(usable_clauses_list_global)));
    if(tmp==BOOL_T) {
      newline(cur_output_port());
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global)))) {
        display(const_152,cur_output_port());
        newline(cur_output_port());
        GLOBAL(sat_found_flag_global)=BOOL_T;
      }
      GLOBAL(sos_exhausted_flag_global)=BOOL_T;
    }
  }
  else
  if(NFALSEP(GLOBAL(mace_model_strat_global))) {
    tmp=prop_build_flatten_model(append2(GLOBAL(sos_clauses_list_global),GLOBAL(usable_clauses_list_global)));
    if(NFALSEP(tmp)) {
      newline(cur_output_port());
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global)))) {
        display(const_153,cur_output_port());
        newline(cur_output_port());
        GLOBAL(sat_found_flag_global)=BOOL_T;
      }
      GLOBAL(sos_exhausted_flag_global)=BOOL_T;
    }
  }
  else
  if(NFALSEP(GLOBAL(simple_model_strat_global))) {
    tmp=prop_build_simple_model(append2(GLOBAL(sos_clauses_list_global),GLOBAL(usable_clauses_list_global)));
    if(NFALSEP(tmp)) {
      newline(cur_output_port());
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global)))) {
        display(const_154,cur_output_port());
        newline(cur_output_port());
        GLOBAL(sat_found_flag_global)=BOOL_T;
      }
      GLOBAL(sos_exhausted_flag_global)=BOOL_T;
    }
  }
  else
  if(NFALSEP(GLOBAL(random_model_strat_global))) {
    tmp=prop_build_random_model(append2(GLOBAL(sos_clauses_list_global),GLOBAL(usable_clauses_list_global)));
    if(NFALSEP(tmp)) {
      newline(cur_output_port());
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global)))) {
        display(const_155,cur_output_port());
        newline(cur_output_port());
        GLOBAL(sat_found_flag_global)=BOOL_T;
      }
      GLOBAL(sos_exhausted_flag_global)=BOOL_T;
    }
  }
  else {
    if(NFALSEP(GLOBAL(combinedstrat_flag_global))) {
      if(PAIR_P(GLOBAL(sos_clauses_list_list_global))&&PAIR_P(CAR(GLOBAL(sos_clauses_list_list_global)))) {
        GLOBAL(sos_clauses_list_global)=append2(GLOBAL(sos_clauses_list_global),CAR(GLOBAL(sos_clauses_list_list_global)));
      }
      if(PAIR_P(GLOBAL(usable_clauses_list_list_global))&&(PAIR_P(CAR(GLOBAL(usable_clauses_list_list_global)))&&PAIR_P(CDR(CAR(GLOBAL(usable_clauses_list_list_global)))))) {
        GLOBAL(sos_clauses_list_global)=append2(GLOBAL(sos_clauses_list_global),CDR(CAR(GLOBAL(usable_clauses_list_list_global))));
      }
    }
    tmp=given_clause_slow_loop();
    if(NFALSEP(tmp)&&(GLOBAL(display_info_level_global)>=MAKINUM(30))) {
      newline(cur_output_port());
      if(!(NULL_P(GLOBAL(answer_cl_global)))) {
        display(const_156,cur_output_port());
        print_pure_clause(GLOBAL(answer_cl_global));
        newline(cur_output_port());
      }
      if(!(NFALSEP(GLOBAL(prop_unsat_strat_global))))
        show_history(GLOBAL(answer_history_global));
    }
    if(NFALSEP(GLOBAL(sat_strategy_flag_global))&&(NFALSEP(GLOBAL(complete_unsat_strategy_global))&&(NFALSEP(GLOBAL(sos_exhausted_flag_global))&&!(NFALSEP(tmp))))) {
      newline(cur_output_port());
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global)))) {
        display(const_157,cur_output_port());
        newline(cur_output_port());
        GLOBAL(sat_found_flag_global)=BOOL_T;
      }
      GLOBAL(sos_exhausted_flag_global)=BOOL_T;
    }
  }
  if(NFALSEP(GLOBAL(combinedstrat_flag_global)))
    return prove_one_pass_after_proving_combinedstrat(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,tmp,oldclauses,nr);
  else
    return prove_one_pass_after_proving(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,tmp,oldclauses,nr);
}

SCM prove_one_pass_actually_prove_fn180(cl)
SCM cl;
{
  if(PAIR_P(cl)&&(fullcl_maxvar(cl)<=MAKINUM(3)))
    return cl;
  else
    return BOOL_F;
}

SCM prove_one_pass_after_proving(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,tmp,oldclauses,nr)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,tmp,oldclauses,nr;
{
  GLOBAL(discr_tree_list_global)=cons(GLOBAL(discr_tree_global),GLOBAL(discr_tree_list_global));
  GLOBAL(unit_alist_list_global)=cons(GLOBAL(unit_alist_global),GLOBAL(unit_alist_list_global));
  if(NFALSEP(GLOBAL(full_proof_strategy_flag_global))) {
    GLOBAL(discr_tree_list_global)=EOL;
    GLOBAL(unit_alist_list_global)=EOL;
    GLOBAL(sos_clauses_list_list_global)=EOL;
    GLOBAL(usable_clauses_list_list_global)=EOL;
  }
  if(NFALSEP(GLOBAL(sat_strategy_flag_global))) {
    GLOBAL(keep_all_old_clauses_flag_global)=BOOL_F;
  }
  if(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&NFALSEP(GLOBAL(keep_all_old_clauses_flag_global))) {
    GLOBAL(sos_clauses_list_list_global)=cons(GLOBAL(sos_clauses_list_global),GLOBAL(sos_clauses_list_list_global));
    GLOBAL(usable_clauses_list_list_global)=cons(GLOBAL(usable_clauses_list_global),GLOBAL(usable_clauses_list_list_global));
  }
  if(!(NFALSEP(GLOBAL(split_search_active_flag_global)))&&!(NFALSEP(GLOBAL(foundflag_global)))) {
    if(NFALSEP(GLOBAL(sat_strategy_flag_global))) {
      GLOBAL(all_passes_selected_clauses_global)=append2(select_best_clauses(MAKINUM(20),MAKINUM(20),MAKINUM(10),MAKINUM(10),GLOBAL(sos_clauses_list_global)),GLOBAL(all_passes_selected_clauses_global));
      GLOBAL(all_passes_selected_clauses_global)=append2(select_best_clauses(MAKINUM(20),MAKINUM(20),MAKINUM(10),MAKINUM(10),GLOBAL(usable_clauses_list_global)),GLOBAL(all_passes_selected_clauses_global));
    }
    else {
      GLOBAL(all_passes_selected_clauses_global)=append2(select_best_clauses(MAKINUM(60),MAKINUM(60),MAKINUM(30),MAKINUM(20),GLOBAL(sos_clauses_list_global)),GLOBAL(all_passes_selected_clauses_global));
      GLOBAL(all_passes_selected_clauses_global)=append2(select_best_clauses(MAKINUM(40),MAKINUM(40),MAKINUM(30),MAKINUM(20),GLOBAL(usable_clauses_list_global)),GLOBAL(all_passes_selected_clauses_global));
    }
  }
  if(length(GLOBAL(all_passes_selected_clauses_global))>MAKINUM(5000)) {
    GLOBAL(all_passes_selected_clauses_global)=EOL;
  }
  nr=MAKINUM(0);
  for_each1_inst2(&nr,prove_one_pass_after_proving_fn183,GLOBAL(unit_alist_list_global));
  if(!(NFALSEP(GLOBAL(keep_all_old_clauses_flag_global)))&&(((2*INUM(nr))>INUM(GLOBAL(max_kept_clauses_nr_global)))||((2*INUM(GLOBAL(kept_size_sum_nr_global)))>INUM(GLOBAL(max_size_sum_nr_global))))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(38)) {
      newline(cur_output_port());
      display(const_158,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(discr_tree_list_global)=EOL;
    GLOBAL(unit_alist_list_global)=EOL;
    GLOBAL(sos_clauses_list_list_global)=EOL;
    GLOBAL(usable_clauses_list_list_global)=EOL;
    GLOBAL(kept_size_sum_nr_global)=MAKINUM(0);
  }
  return tmp;
}

SCM prove_one_pass_after_proving_fn183(nr,alist)
SCM *nr;
SCM alist;
{
  return for_each1_inst3(nr,prove_one_pass_after_proving_fn184,alist);
}

SCM prove_one_pass_after_proving_fn184(nr,el)
SCM *nr;
SCM el;
{
  *nr=MAKINUM(INUM(length(CDR(el)))+INUM(*nr));
  return UNSPECIFIED;
}

SCM prove_one_pass_after_proving_combinedstrat(usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,tmp,oldclauses,nr)
SCM usable,sos,demodulators,lit_demodulators,compl_lit_demodulators,tmp,oldclauses,nr;
{
  GLOBAL(discr_tree_list_global)=cons(GLOBAL(discr_tree_global),GLOBAL(discr_tree_list_global));
  GLOBAL(unit_alist_list_global)=cons(GLOBAL(unit_alist_global),GLOBAL(unit_alist_list_global));
  GLOBAL(sos_clauses_list_list_global)=cons(GLOBAL(sos_clauses_list_global),GLOBAL(sos_clauses_list_list_global));
  GLOBAL(usable_clauses_list_list_global)=cons(GLOBAL(usable_clauses_list_global),GLOBAL(usable_clauses_list_list_global));
  return tmp;
}

SCM make_sat_inclauses(sos,usable)
SCM sos,usable;
{
  SCM count,tmp,vars,old,res,part;

  res=EOL;
  old=EOL;
  vars=EOL;
  tmp=EOL;
  count=MAKINUM(0);
  res=append2(GLOBAL(sos_clauses_list_global),GLOBAL(usable_clauses_list_global));
  for(part=GLOBAL(all_passes_selected_clauses_global);!(NULL_P(part)||(count>MAKINUM(500)));part=CDR(part)) {
    tmp=CAR(part);
    if(PAIR_P(tmp)&&(PAIR_P(CAR(tmp))&&(PAIR_P(CDR(tmp))&&!(MAKINUM(0)==CAR(CAR(tmp)))))) {
      vars=(MAKINUM(528482304)&CAR(CAR(tmp)));
      vars=MAKINUM(INUM(vars)>>23);
      if(vars<MAKINUM(4)) {
        old=cons(tmp,old);
        count=MAKINUM(1+INUM(count));
      }
      else {
      }
    }
  }
  res=append2(res,old);
  return res;
}

SCM list_contains_clause(cl,lst)
SCM cl,lst;
{
  SCM foundflag,part;

  foundflag=BOOL_F;
  cl=CDR(cl);
  for(part=lst;!(NULL_P(part)||NFALSEP(foundflag));part=CDR(part))
    if(PAIR_P(CAR(part))&&(PAIR_P(CDR(CAR(part)))&&NFALSEP(equal(cl,CDR(CAR(part)))))) {
      foundflag=BOOL_T;
    }
  return foundflag;
}

SCM fullcl_maxvar(cl)
SCM cl;
{
  return MAKINUM(INUM(MAKINUM(528482304)&CAR(CAR(cl)))>>23);
}

SCM select_best_clauses(poseqnr,posnr,negnr,dblnr,clauselist)
SCM poseqnr,posnr,negnr,dblnr,clauselist;
{
  SCM new_var2,lst,res,reseqpos,respos,resneg,resdbl,cl,oldcl,clvalue,cllen,clhist,oldvalue,found_unit_pos_nr,found_unit_neg_nr,found_dbl_nr,foundnr,new_var1,new_var3;

  res=EOL;
  reseqpos=EOL;
  respos=EOL;
  resneg=EOL;
  resdbl=EOL;
  cl=EOL;
  oldcl=EOL;
  clvalue=MAKINUM(0);
  cllen=MAKINUM(0);
  clhist=EOL;
  oldvalue=MAKINUM(0);
  found_unit_pos_nr=MAKINUM(0);
  found_unit_neg_nr=MAKINUM(0);
  found_dbl_nr=MAKINUM(0);
  foundnr=MAKINUM(0);
  for(lst=clauselist;!(NULL_P(lst));lst=CDR(lst))
    if(PAIR_P(lst)&&(PAIR_P(CAR(lst))&&PAIR_P(CAR(CAR(lst))))) {
      cl=CAR(lst);
      clvalue=(MAKINUM(65535)&CAR(CAR(cl)));
      cllen=MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(cl)))>>17);
      clhist=CDR(CDR(CDR(CDR(CDR(CAR(cl))))));
      if(PAIR_P(clhist)) {
        clhist=CAR(clhist);
      }
      else {
        clhist=EOL;
      }
      new_var1=SBOOL(ZERO_P(clvalue));
      if(NFALSEP(new_var1)) ;
      else {
        new_var2=NOT(SBOOL(PAIR_P(clhist)));
        if(NFALSEP(new_var2)) ;
        else {
          new_var3=SBOOL(input_symb==CAR(clhist));
          if(NFALSEP(new_var3)) ;
          else
          if(cllen==MAKINUM(2)) {
            resdbl=insert_to_best_res(cl,clvalue,resdbl,dblnr);
          }
          else
          if((cllen==MAKINUM(1))&&(ZERO_P(MAKINUM(268435456)&CAR(CAR(CDR(cl))))&&((MAKINUM(534773760)&CAR(CAR(CDR(cl))))==GLOBAL(eq_pred_nr_global)))) {
            respos=insert_to_best_res(cl,clvalue,reseqpos,poseqnr);
          }
          else
          if((cllen==MAKINUM(1))&&ZERO_P(MAKINUM(268435456)&CAR(CAR(CDR(cl))))) {
            respos=insert_to_best_res(cl,clvalue,respos,posnr);
          }
          else
          if((cllen==MAKINUM(1))&&!(ZERO_P(MAKINUM(268435456)&CAR(CAR(CDR(cl)))))) {
            resneg=insert_to_best_res(cl,clvalue,resneg,negnr);
          }
        }
      }
    }
  res=append2(reseqpos,append2(respos,append2(resneg,resdbl)));
  if(GLOBAL(display_info_level_global)>MAKINUM(50)) {
    newline(cur_output_port());
    display(const_159,cur_output_port());
    newline(cur_output_port());
    for_each1(select_best_clauses_fn186,res);
    newline(cur_output_port());
    display(const_160,cur_output_port());
    newline(cur_output_port());
  }
  return res;
}

SCM select_best_clauses_fn186(x)
SCM x;
{
  print_full_clause(x);
  display(const_161,cur_output_port());
  display(MAKINUM(65535)&CAR(CAR(x)),cur_output_port());
  display(const_162,cur_output_port());
  display(MAKINUM(31)&CAR(CAR(x)),cur_output_port());
  display(const_163,cur_output_port());
  display(fun_real_depth(CAR(CAR(x))),cur_output_port());
  return newline(cur_output_port());
}

SCM insert_to_best_res(cl,clvalue,lst,nr)
SCM cl,clvalue,lst,nr;
{
  SCM inserted_flag,oldclvalue,oldcl,tmp,part;

  tmp=EOL;
  oldcl=EOL;
  oldclvalue=MAKINUM(0);
  inserted_flag=BOOL_F;
  for(part=lst;!(NULL_P(part)||NFALSEP(inserted_flag));part=CDR(part)) {
    oldcl=CAR(part);
    oldclvalue=(MAKINUM(65535)&CAR(CAR(oldcl)));
    if(clvalue<=oldclvalue) {
      tmp=oldcl;
      SET_CAR(part,cl);
      SET_CDR(part,cons(oldcl,CDR(part)));
      inserted_flag=BOOL_T;
    }
  }
  tmp=length(lst);
  if(ZERO_P(tmp)) {
    lst=cons(cl,EOL);
  }
  else
  if(!(NFALSEP(inserted_flag))&&(tmp<nr)) {
    SET_CDR(my_last_pair(lst),cons(cl,EOL));
  }
  else
  if(tmp>=nr) {
    lst=remove_last_excl_(lst);
  }
  return lst;
}

SCM remove_last_excl_(lst)
SCM lst;
{
  SCM lstpart;

  if(NULL_P(lst))
    return EOL;
  else
  if(NULL_P(CDR(lst)))
    return EOL;
  else {
    for(lstpart=lst;!(PAIR_P(CDR(lstpart))&&NULL_P(CDR(CDR(lstpart))));lstpart=CDR(lstpart)) ;
    SET_CDR(lstpart,EOL);
    return lst;
  }
}

SCM show_one_pass_strategy()
{
  if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
    if(NFALSEP(GLOBAL(prop_unsat_strat_global))) {
      newline(cur_output_port());
      display(const_164,cur_output_port());
    }
    else
    if(NFALSEP(GLOBAL(simple_model_strat_global))) {
      newline(cur_output_port());
      display(const_165,cur_output_port());
    }
    else
    if(NFALSEP(GLOBAL(sem_model_strat_global))) {
      newline(cur_output_port());
      display(const_166,cur_output_port());
    }
    else
    if(NFALSEP(GLOBAL(mace_nofuns_model_strat_global))) {
      newline(cur_output_port());
      display(const_167,cur_output_port());
    }
    else
    if(NFALSEP(GLOBAL(mace_model_strat_global))) {
      newline(cur_output_port());
      display(const_168,cur_output_port());
    }
    else
    if(NFALSEP(GLOBAL(random_model_strat_global))) {
      newline(cur_output_port());
      display(const_169,cur_output_port());
    }
    else
    if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
      newline(cur_output_port());
      display(const_170,cur_output_port());
    }
    else {
      newline(cur_output_port());
      display(const_171,cur_output_port());
    }
    newline(cur_output_port());
    if(NFALSEP(GLOBAL(sat_strategy_flag_global))) {
      display(const_172,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(bliksem_strategy_flag_global))) {
      display(const_173,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(order_strategy_flag_global))) {
      display(const_174,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))) {
      display(const_175,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))) {
      display(const_176,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(order_strategy_sos_flag_global))) {
      display(const_177,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(name_order_strategy_flag_global))) {
      display(const_178,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(exp_order_strategy_flag_global))) {
      display(const_179,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(sos_strategy_flag_global))) {
      display(const_180,cur_output_port());
      newline(cur_output_port());
    }
    else {
      display(const_181,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(para_pos_unit_strategy_global))) {
      display(const_182,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(para_unit_strategy_global))) {
      display(const_183,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(unit_strategy_flag_global))) {
      display(const_184,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(double_strategy_flag_global))) {
      display(const_185,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(dynamic_demodulation_flag_global))) {
      display(const_186,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(unit_equality_strat_global))) {
      display(const_187,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(root_para_strat_global))) {
      display(const_188,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(back_demodulate_flag_global))) {
      display(const_189,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))) {
      display(const_190,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(order_equality_kb_strat_global))) {
      display(const_191,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(order_equality_lex_strat_global))) {
      display(const_192,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(order_equality_firstpref_strat_global))) {
      display(const_193,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(lex_order_prefer_bigger_arity_global))) {
      display(const_194,cur_output_port());
      newline(cur_output_port());
    }
    else {
      display(const_195,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(demodulate_with_clauses_stratflag_global))) {
      display(const_196,cur_output_port());
      newline(cur_output_port());
    }
    if(!(ZERO_P(GLOBAL(clause_keeplength_limit_global)))) {
      display(const_197,cur_output_port());
      display(GLOBAL(clause_keeplength_limit_global),cur_output_port());
      newline(cur_output_port());
    }
    if(!(ZERO_P(GLOBAL(clause_keepdepth_limit_global)))) {
      if(NFALSEP(GLOBAL(bliksem_strategy_flag_global))) {
        display(const_198,cur_output_port());
      }
      else
        display(const_199,cur_output_port());
      display(GLOBAL(clause_keepdepth_limit_global),cur_output_port());
      newline(cur_output_port());
    }
    if(!(ZERO_P(GLOBAL(clause_finalkeepsize_limit_global)))) {
      display(const_200,cur_output_port());
      display(GLOBAL(clause_finalkeepsize_limit_global),cur_output_port());
      newline(cur_output_port());
    }
    if(!(NFALSEP(equal(GLOBAL(global_sos_preference_ratio_global),MAKINUM(5))))) {
      display(const_201,cur_output_port());
      display(GLOBAL(global_sos_preference_ratio_global),cur_output_port());
      newline(cur_output_port());
    }
    display(const_202,cur_output_port());
    display(MAKINUM(INUM(GLOBAL(strat_given_time_global))/INUM(GLOBAL(internal_time_units_per_second_global))),cur_output_port());
    newline(cur_output_port());
    return newline(cur_output_port());
  }
  else
    return UNSPECIFIED;
}

SCM eq_lit_in_sos_pred_(sos)
SCM sos;
{
  return some_pred_(eq_lit_in_sos_pred__fn189,sos);
}

SCM eq_lit_in_sos_pred__fn189(cl)
SCM cl;
{
  return some_pred_(eq_lit_in_sos_pred__fn190,CDR(cl));
}

SCM eq_lit_in_sos_pred__fn190(lit)
SCM lit;
{
  SCM new_var1;

  new_var1=SBOOL(GLOBAL(eq_pred_nr_global)==(MAKINUM(266338304)&CAR(lit)));
  if(NFALSEP(new_var1))
    return new_var1;
  else
  if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
    if(!(NUMBER_P(CAR(CDR(lit)))))
      return SBOOL(GLOBAL(eq_fun_nr_global)==(MAKINUM(266338304)&CAR(CAR(CDR(lit)))));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM add_typet_demod_ans(cl)
SCM cl;
{
  SCM eqlit,eqtype,eqarg1;

  eqlit=CAR(cl);
  eqtype=CAR(CDR(CDR(CDR(eqlit))));
  eqarg1=CAR(CDR(eqlit));
  return cons(cons(GLOBAL(ans_symbol_global),cons(cons(GLOBAL(id_refl_fun_symbol_global),cons(eqtype,cons(eqarg1,EOL))),EOL)),cons(cons(GLOBAL(inhabited_symbol_global),cons(CAR(cl),EOL)),EOL));
}

SCM remove_typet_demod_ans(cl)
SCM cl;
{
  SCM litlst,newcl,newlit;

  litlst=remove_if(remove_typet_demod_ans_fn192,CAR(CDR(CDR(CAR(cl)))));
  newcl=remove_ans_literals(CDR(cl));
  newlit=CAR(CDR(CAR(newcl)));
  return cons(cons(CAR(CAR(cl)),cons(CAR(CDR(CAR(cl))),cons(litlst,CDR(CDR(CDR(CAR(cl))))))),cons(newlit,EOL));
}

SCM remove_typet_demod_ans_fn192(y)
SCM y;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(4)&CAR(y))));
}

SCM remove_ans_from_clauses(cllist)
SCM cllist;
{
  SCM new_var4,new_var1,new_var2,new_var3;

  for(new_var4=cllist,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4);
      new_var4=CDR(new_var4)) {
    new_var3=remove_ans_from_clauses_fn195(CAR(new_var4));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM remove_ans_from_clauses_fn195(x)
SCM x;
{
  SCM litlst,cl;

  litlst=remove_if(remove_ans_from_clauses_fn196,CAR(CDR(CDR(CAR(x)))));
  cl=remove_ans_literals(CDR(x));
  return cons(cons(CAR(CAR(x)),cons(CAR(CDR(CAR(x))),cons(litlst,CDR(CDR(CDR(CAR(x))))))),cl);
}

SCM remove_ans_from_clauses_fn196(y)
SCM y;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(4)&CAR(y))));
}

SCM enumerate_sos_literals(sos)
SCM sos;
{
  GLOBAL(enumerate_sos_literals_nr_global)=MAKINUM(0);
  return for_each1(enumerate_sos_literals_fn199,sos);
}

SCM enumerate_sos_literals_fn199(cl)
SCM cl;
{
  SCM litinfolst;

  litinfolst=CAR(CDR(CDR(CAR(cl))));
  SET_CAR(CDR(CDR(CAR(cl))),map1(enumerate_sos_literals_fn200,litinfolst));
  return UNSPECIFIED;
}

SCM enumerate_sos_literals_fn200(litinf)
SCM litinf;
{
  GLOBAL(enumerate_sos_literals_nr_global)=MAKINUM(1+INUM(GLOBAL(enumerate_sos_literals_nr_global)));
  return append2(litinf,cons(GLOBAL(enumerate_sos_literals_nr_global),EOL));
}

SCM analyse_input(usable,sos)
SCM usable,sos;
{
  SCM part,tmp,cl,clinf,purecl,litinfolst,tmplitinfolst,prohibitlitnr,newlitinf,litnr,varlitnr,ndepth,pdepth,depth,poslitnr,neglitnr,cldepthsum,clsizesum,tmpd,tmps,clauselstpart;

  GLOBAL(input_lit_nr_global)=MAKINUM(0);
  GLOBAL(input_eqlit_nr_global)=MAKINUM(0);
  GLOBAL(input_cl_nr_global)=MAKINUM(0);
  GLOBAL(input_unitcl_nr_global)=MAKINUM(0);
  GLOBAL(input_negcl_nr_global)=MAKINUM(0);
  GLOBAL(input_poscl_nr_global)=MAKINUM(0);
  GLOBAL(input_mixcl_nr_global)=MAKINUM(0);
  GLOBAL(input_horncl_nr_global)=MAKINUM(0);
  GLOBAL(input_invhorncl_nr_global)=MAKINUM(0);
  GLOBAL(input_negdhorncl_nr_global)=MAKINUM(0);
  GLOBAL(input_wellorderedcl_nr_global)=MAKINUM(0);
  GLOBAL(input_somewhat_ordered_nr_global)=MAKINUM(0);
  GLOBAL(input_wellhyper_nr_global)=MAKINUM(0);
  GLOBAL(input_maxlen_nr_global)=MAKINUM(0);
  GLOBAL(input_maxlen_nonground_nr_global)=MAKINUM(0);
  GLOBAL(input_maxdepth_nr_global)=MAKINUM(0);
  GLOBAL(sos_maxdepth_nr_global)=MAKINUM(0);
  GLOBAL(input_contains_eq_global)=BOOL_F;
  GLOBAL(input_negun_d_global)=MAKINUM(0);
  GLOBAL(input_posun_d_global)=MAKINUM(0);
  GLOBAL(input_maxsize_nr_global)=MAKINUM(0);
  GLOBAL(input_maxdepth_nr_global)=MAKINUM(0);
  GLOBAL(input_avgdepth_nr_global)=MAKINUM(0);
  GLOBAL(input_avgsize_nr_global)=MAKINUM(0);
  if(NFALSEP(eq_lit_in_sos_pred_(sos))||NFALSEP(eq_lit_in_sos_pred_(usable))) {
    GLOBAL(input_contains_eq_global)=BOOL_T;
  }
  else {
    GLOBAL(input_contains_eq_global)=BOOL_F;
  }
  tmp=EOL;
  cl=EOL;
  clinf=EOL;
  purecl=EOL;
  litinfolst=EOL;
  tmplitinfolst=EOL;
  prohibitlitnr=MAKINUM(0);
  newlitinf=EOL;
  litnr=MAKINUM(0);
  varlitnr=MAKINUM(0);
  ndepth=MAKINUM(0);
  pdepth=MAKINUM(0);
  depth=MAKINUM(0);
  poslitnr=MAKINUM(0);
  neglitnr=MAKINUM(0);
  cldepthsum=MAKINUM(0);
  clsizesum=MAKINUM(0);
  tmpd=MAKINUM(0);
  tmps=MAKINUM(0);
  for(part=sos;!(NULL_P(part));part=CDR(part)) {
    cl=CAR(part);
    clinf=CAR(cl);
    for_each1(analyse_input_fn205,CDR(cl));
  }
  for(clauselstpart=append2(usable,sos);!(NULL_P(clauselstpart));clauselstpart=CDR(clauselstpart)) {
    cl=CAR(clauselstpart);
    clinf=CAR(cl);
    purecl=CDR(cl);
    litinfolst=CAR(CDR(CDR(clinf)));
    tmplitinfolst=map1(analyse_input_fn206,litinfolst);
    GLOBAL(input_cl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_cl_nr_global)));
    litnr=MAKINUM(0);
    varlitnr=MAKINUM(0);
    neglitnr=MAKINUM(0);
    poslitnr=MAKINUM(0);
    ndepth=MAKINUM(0);
    pdepth=MAKINUM(0);
    for_each1_inst4(&varlitnr,&poslitnr,&pdepth,&ndepth,&neglitnr,&litnr,analyse_input_fn207,purecl);
    if(varlitnr>GLOBAL(input_maxlen_nonground_nr_global)) {
      GLOBAL(input_maxlen_nonground_nr_global)=varlitnr;
    }
    if(ndepth>pdepth) {
      depth=ndepth;
    }
    else {
      depth=pdepth;
    }
    if(depth>GLOBAL(input_maxdepth_nr_global)) {
      GLOBAL(input_maxdepth_nr_global)=depth;
    }
    if(litnr>GLOBAL(input_maxlen_nr_global)) {
      GLOBAL(input_maxlen_nr_global)=litnr;
    }
    if(litnr==MAKINUM(1)) {
      if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(purecl))))&&(fun_real_depth(CAR(CAR(purecl)))>GLOBAL(input_negun_d_global))) {
        GLOBAL(input_negun_d_global)=fun_real_depth(CAR(CAR(purecl)));
      }
      if(ZERO_P(MAKINUM(268435456)&CAR(CAR(purecl)))&&(fun_real_depth(CAR(CAR(purecl)))>GLOBAL(input_posun_d_global))) {
        GLOBAL(input_posun_d_global)=fun_real_depth(CAR(CAR(purecl)));
      }
      GLOBAL(input_unitcl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_unitcl_nr_global)));
    }
    if(ZERO_P(poslitnr)) {
      GLOBAL(input_negcl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_negcl_nr_global)));
    }
    else
    if(ZERO_P(neglitnr)) {
      GLOBAL(input_poscl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_poscl_nr_global)));
    }
    else {
      GLOBAL(input_mixcl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_mixcl_nr_global)));
    }
    if((litnr>MAKINUM(1))&&(poslitnr<=MAKINUM(1))) {
      GLOBAL(input_horncl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_horncl_nr_global)));
      if(pdepth>ndepth) {
        GLOBAL(input_negdhorncl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_negdhorncl_nr_global)));
      }
    }
    if((litnr>MAKINUM(1))&&(neglitnr<=MAKINUM(1))) {
      GLOBAL(input_invhorncl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_invhorncl_nr_global)));
    }
    if((litnr>MAKINUM(1))&&((2*INUM(neglitnr))>=INUM(poslitnr))) {
      GLOBAL(input_wellhyper_nr_global)=MAKINUM(1+INUM(GLOBAL(input_wellhyper_nr_global)));
    }
    tmpd=MAKINUM(INUM(compute_term_depth_raw(cons(MAKINUM(0),purecl)))-1);
    tmps=MAKINUM(INUM(compute_term_size_raw(cons(MAKINUM(0),purecl)))-1);
    cldepthsum=MAKINUM(INUM(cldepthsum)+INUM(tmpd));
    clsizesum=MAKINUM(INUM(clsizesum)+INUM(tmps));
    if(tmpd>GLOBAL(input_maxdepth_nr_global)) {
      GLOBAL(input_maxdepth_nr_global)=tmpd;
    }
    if(tmps>GLOBAL(input_maxsize_nr_global)) {
      GLOBAL(input_maxsize_nr_global)=tmps;
    }
    prohibitlitnr=MAKINUM(0);
    if(!(NULL_P(CDR(purecl)))) {
      tmp=GLOBAL(order_strategy_flag_global);
      GLOBAL(order_strategy_flag_global)=BOOL_T;
      newlitinf=vdepth_order_litinfo_aux(tmplitinfolst,purecl);
      GLOBAL(order_strategy_flag_global)=tmp;
      for_each1_inst2(&prohibitlitnr,analyse_input_fn208,newlitinf);
      if((2*INUM(prohibitlitnr))>=INUM(litnr)) {
        GLOBAL(input_wellorderedcl_nr_global)=MAKINUM(1+INUM(GLOBAL(input_wellorderedcl_nr_global)));
      }
      if(prohibitlitnr>MAKINUM(0)) {
        GLOBAL(input_somewhat_ordered_nr_global)=MAKINUM(1+INUM(GLOBAL(input_somewhat_ordered_nr_global)));
      }
    }
  }
  GLOBAL(input_avgdepth_nr_global)=MAKINUM(INUM(GLOBAL(input_maxdepth_nr_global))/INUM(GLOBAL(input_cl_nr_global)));
  GLOBAL(input_avgsize_nr_global)=MAKINUM(INUM(GLOBAL(input_maxsize_nr_global))/INUM(GLOBAL(input_cl_nr_global)));
  return UNSPECIFIED;
}

SCM analyse_input_fn208(prohibitlitnr,inf)
SCM *prohibitlitnr;
SCM inf;
{
  if(!(!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(CDR(CDR(inf))))))) {
    *prohibitlitnr=MAKINUM(1+INUM(*prohibitlitnr));
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM analyse_input_fn207(varlitnr,poslitnr,pdepth,ndepth,neglitnr,litnr,lit)
SCM *varlitnr,*poslitnr,*pdepth,*ndepth,*neglitnr,*litnr;
SCM lit;
{
  *litnr=MAKINUM(1+INUM(*litnr));
  GLOBAL(input_lit_nr_global)=MAKINUM(1+INUM(GLOBAL(input_lit_nr_global)));
  if((GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(lit)))||(GLOBAL(eq_pred_nr_global)==MAKINUM(268435456^INUM(MAKINUM(534773760)&CAR(lit))))) {
    GLOBAL(input_eqlit_nr_global)=MAKINUM(1+INUM(GLOBAL(input_eqlit_nr_global)));
  }
  if(ZERO_P(MAKINUM(65536)&CAR(lit))) {
    *varlitnr=MAKINUM(1+INUM(*varlitnr));
  }
  if(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))) {
    *neglitnr=MAKINUM(1+INUM(*neglitnr));
    if(fun_real_depth(CAR(lit))>*ndepth) {
      *ndepth=fun_real_depth(CAR(lit));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
  else {
    *poslitnr=MAKINUM(1+INUM(*poslitnr));
    if(fun_real_depth(CAR(lit))>*pdepth) {
      *pdepth=fun_real_depth(CAR(lit));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
}

SCM analyse_input_fn206(x)
SCM x;
{
  return cons(MAKINUM(0),cons(MAKINUM(0),x));
}

SCM analyse_input_fn205(lit)
SCM lit;
{
  if(fun_real_depth(CAR(lit))>GLOBAL(sos_maxdepth_nr_global)) {
    GLOBAL(sos_maxdepth_nr_global)=fun_real_depth(CAR(lit));
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM compute_term_size_raw(term)
SCM term;
{
  SCM res,part;

  res=MAKINUM(1);
  for(part=CDR(term);!(NULL_P(part));part=CDR(part))
    if(PAIR_P(CAR(part))) {
      res=MAKINUM(INUM(res)+INUM(compute_term_size_raw(CAR(part))));
    }
    else {
      res=MAKINUM(INUM(res)+1);
    }
  return res;
}

SCM compute_term_depth_raw(term)
SCM term;
{
  SCM tmp,res,part;

  res=MAKINUM(0);
  tmp=MAKINUM(0);
  for(part=CDR(term);!(NULL_P(part));part=CDR(part))
    if(PAIR_P(CAR(part))) {
      tmp=MAKINUM(1+INUM(compute_term_depth_raw(CAR(part))));
      if(tmp>res) {
        res=tmp;
      }
    }
  return res;
}

SCM select_initial_strategy()
{
  SCM res,tmp;

  res=EOL;
  tmp=EOL;
  GLOBAL(hne_class_flag_global)=BOOL_F;
  GLOBAL(heq_class_flag_global)=BOOL_F;
  res=copytree(select_initial_strategy_aux());
  res=select_strategy_seconds(res,GLOBAL(all_passes_time_global));
  if(0) {
    tmp=my_last_pair(res);
    SET_CAR(CDR(CAR(tmp)),MAKINUM(100000));
  }
  if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
    newline(cur_output_port());
    display(const_203,cur_output_port());
    newline(cur_output_port());
    for_each1(select_initial_strategy_fn210,res);
    newline(cur_output_port());
  }
  GLOBAL(strat_list_global)=res;
  if(NFALSEP(GLOBAL(input_contains_eq_global))&&NFALSEP(GLOBAL(paramodulation_allowed_flag_global))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(35)) {
      newline(cur_output_port());
      display(const_204,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(paramodulation_strategy_flag_global)=BOOL_T;
    turn_on_demodulation();
  }
  else {
    if(GLOBAL(display_info_level_global)>=MAKINUM(35)) {
      newline(cur_output_port());
      display(const_205,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(paramodulation_strategy_flag_global)=BOOL_F;
    turn_on_demodulation();
  }
  return res;
}

SCM select_initial_strategy_fn210(x)
SCM x;
{
  if(PAIR_P(x)&&(split_symb==CAR(x))) {
    display(split_symb,cur_output_port());
    return newline(cur_output_port());
  }
  else {
    display(x,cur_output_port());
    return newline(cur_output_port());
  }
}

SCM select_strategy_seconds(stratlst,secs)
SCM stratlst,secs;
{
  SCM quotient1000,el,timesum,tmpres,tmpsecs,newsecs,oldsecs,givensecs,lstpart;

  givensecs=MAKINUM(0);
  oldsecs=MAKINUM(0);
  newsecs=MAKINUM(0);
  tmpsecs=MAKINUM(0);
  tmpres=EOL;
  timesum=MAKINUM(0);
  el=EOL;
  quotient1000=MAKINUM(0);
  for_each1_inst2(&givensecs,select_strategy_seconds_fn212,stratlst);
  for(lstpart=stratlst;!(NULL_P(lstpart));lstpart=CDR(lstpart)) {
    el=CAR(lstpart);
    tmpsecs=CAR(CDR(el));
    quotient1000=MAKINUM((1000*INUM(tmpsecs))/INUM(givensecs));
    newsecs=MAKINUM((INUM(quotient1000)*INUM(secs))/1000);
    if(newsecs<MAKINUM(1)) {
      newsecs=MAKINUM(1);
    }
    if(NULL_P(CDR(lstpart))) {
      newsecs=MAKINUM(INUM(secs)-INUM(timesum));
      if(newsecs<MAKINUM(1)) {
        newsecs=MAKINUM(1);
      }
    }
    timesum=MAKINUM(INUM(timesum)+INUM(newsecs));
    tmpres=cons(cons(CAR(el),cons(newsecs,CDR(CDR(el)))),tmpres);
  }
  return reverse(tmpres);
}

SCM select_strategy_seconds_fn212(givensecs,x)
SCM *givensecs;
SCM x;
{
  *givensecs=MAKINUM(INUM(CAR(CDR(x)))+INUM(*givensecs));
  return UNSPECIFIED;
}

SCM select_initial_strategy_aux()
{
  SCM tmp,res,maxtime,incrlen;

  tmp=EOL;
  res=EOL;
  maxtime=MAKINUM(150);
  incrlen=MAKINUM(0);
  if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
    newline(cur_output_port());
    display(const_206,cur_output_port());
    newline(cur_output_port());
    display(const_207,cur_output_port());
    display(GLOBAL(input_lit_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_208,cur_output_port());
    display(GLOBAL(input_eqlit_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_209,cur_output_port());
    display(GLOBAL(input_cl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_210,cur_output_port());
    display(GLOBAL(input_unitcl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_211,cur_output_port());
    display(GLOBAL(input_negcl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_212,cur_output_port());
    display(GLOBAL(input_poscl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_213,cur_output_port());
    display(GLOBAL(input_mixcl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_214,cur_output_port());
    display(GLOBAL(input_horncl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_215,cur_output_port());
    display(GLOBAL(input_invhorncl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_216,cur_output_port());
    display(GLOBAL(input_negdhorncl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_217,cur_output_port());
    display(GLOBAL(input_wellorderedcl_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_218,cur_output_port());
    display(GLOBAL(input_wellhyper_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_219,cur_output_port());
    display(GLOBAL(input_somewhat_ordered_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_220,cur_output_port());
    display(GLOBAL(input_maxlen_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_221,cur_output_port());
    display(GLOBAL(input_maxlen_nonground_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_222,cur_output_port());
    display(GLOBAL(input_maxdepth_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_223,cur_output_port());
    display(GLOBAL(input_contains_eq_global),cur_output_port());
    newline(cur_output_port());
    display(const_224,cur_output_port());
    newline(cur_output_port());
  }
  incrlen=MAKINUM((2*INUM(GLOBAL(input_maxlen_nr_global)))-1);
  if(NFALSEP(GLOBAL(sat_strategy_flag_global))) {
    res=select_initial_strategy_sat(incrlen);
  }
  else
  if(NFALSEP(GLOBAL(input_contains_eq_global))&&((GLOBAL(input_lit_nr_global)==GLOBAL(input_eqlit_nr_global))&&(GLOBAL(input_cl_nr_global)==GLOBAL(input_unitcl_nr_global)))) {
    res=select_initial_strategy_ueq(incrlen);
  }
  else
  if(NFALSEP(GLOBAL(input_contains_eq_global))&&(GLOBAL(input_lit_nr_global)==GLOBAL(input_eqlit_nr_global))) {
    res=select_initial_strategy_peq(incrlen);
  }
  else
  if(NFALSEP(GLOBAL(input_contains_eq_global))&&(INUM(GLOBAL(input_horncl_nr_global))==(INUM(GLOBAL(input_cl_nr_global))-INUM(GLOBAL(input_unitcl_nr_global))))) {
    res=select_initial_strategy_heq(incrlen);
  }
  else
  if(!(NFALSEP(GLOBAL(input_contains_eq_global)))&&(INUM(GLOBAL(input_horncl_nr_global))==(INUM(GLOBAL(input_cl_nr_global))-INUM(GLOBAL(input_unitcl_nr_global))))) {
    res=select_initial_strategy_hne(incrlen);
  }
  else
  if(!(NFALSEP(GLOBAL(input_contains_eq_global)))) {
    res=select_initial_strategy_nne(incrlen);
  }
  else {
    res=select_initial_strategy_neq(incrlen);
  }
  return res;
}

SCM select_initial_strategy_sat(incrlen)
SCM incrlen;
{
  SCM res;

  res=EOL;
  if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
    newline(cur_output_port());
    display(const_225,cur_output_port());
    newline(cur_output_port());
  }
  if(GLOBAL(input_maxdepth_nr_global)<=MAKINUM(1)) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
      display(const_226,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(input_contains_eq_global))) {
      res=cons(cons(hyper_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_double_symb,cons(MAKINUM(4),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_weightorder_symb,cons(MAKINUM(8),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_kb_small_fulleq_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_kb_big_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_epr_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(mace_nofuns_model_strat_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(mace_model_strat_symb,cons(MAKINUM(38),cons(BOOL_F,EOL))),EOL))))))))));
    }
    else {
      res=cons(cons(hyper_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_double_symb,cons(MAKINUM(4),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_weightorder_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_epr_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(mace_nofuns_model_strat_symb,cons(MAKINUM(18),cons(BOOL_F,EOL))),cons(cons(mace_model_strat_symb,cons(MAKINUM(33),cons(BOOL_F,EOL))),EOL)))))))));
    }
  }
  else
  if(NFALSEP(GLOBAL(input_contains_eq_global))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
      display(const_227,cur_output_port());
      newline(cur_output_port());
    }
    res=cons(cons(sem_model_strat_1_symb,cons(MAKINUM(25),cons(BOOL_F,EOL))),cons(cons(sem_model_strat_3_symb,cons(MAKINUM(12),cons(BOOL_F,EOL))),cons(cons(hyper_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(sat_posweight_order_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(sem_model_strat_1_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(sem_model_strat_3_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(sem_model_strat_5_symb,cons(MAKINUM(9),cons(BOOL_F,EOL))),cons(cons(mace_model_strat_symb,cons(MAKINUM(39),cons(BOOL_F,EOL))),EOL))))))))));
  }
  else {
    if(GLOBAL(display_info_level_global)>=MAKINUM(30)) {
      display(const_228,cur_output_port());
      newline(cur_output_port());
    }
    res=cons(cons(sem_model_strat_1_symb,cons(MAKINUM(16),cons(BOOL_F,EOL))),cons(cons(sem_model_strat_3_symb,cons(MAKINUM(17),cons(BOOL_F,EOL))),cons(cons(hyper_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(sat_ordered_binres_strat_symb,cons(MAKINUM(4),cons(BOOL_F,EOL))),cons(cons(sat_posweight_order_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(sem_model_strat_1_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(sem_model_strat_3_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(sem_model_strat_5_symb,cons(MAKINUM(9),cons(BOOL_F,EOL))),cons(cons(mace_model_strat_symb,cons(MAKINUM(40),cons(BOOL_F,EOL))),EOL)))))))))));
  }
  return res;
}

SCM select_initial_strategy_neq(incrlen)
SCM incrlen;
{
  SCM res;

  res=EOL;
  newline(cur_output_port());
  display(const_229,cur_output_port());
  newline(cur_output_port());
  if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
    display(const_230,cur_output_port());
    newline(cur_output_port());
    res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(2),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(15),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_order_sos_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_sos_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(22),cons(BOOL_T,EOL))),EOL)))))))))))))))));
  }
  else
  if(GLOBAL(input_cl_nr_global)>MAKINUM(10)) {
    display(const_231,cur_output_port());
    newline(cur_output_port());
    res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(2),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(2),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_order_sos_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(6),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(20),cons(BOOL_T,EOL))),EOL))))))))))))))));
  }
  else {
    display(const_232,cur_output_port());
    newline(cur_output_port());
    res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(2),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(2),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_double_symb,cons(MAKINUM(2),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(3),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(23),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(8),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_order_sos_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(12),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(7),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),EOL))))))))))))))));
  }
  return res;
}

SCM select_initial_strategy_nne(incrlen)
SCM incrlen;
{
  SCM res;

  res=EOL;
  newline(cur_output_port());
  display(const_233,cur_output_port());
  newline(cur_output_port());
  if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
    display(const_234,cur_output_port());
    newline(cur_output_port());
    res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(15),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(9),cons(BOOL_F,EOL))),cons(cons(binary_order_sos_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_sos_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(28),cons(BOOL_T,EOL))),EOL)))))))))))));
  }
  else
  if(GLOBAL(input_cl_nr_global)>MAKINUM(10)) {
    display(const_235,cur_output_port());
    newline(cur_output_port());
    res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(2),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(23),cons(BOOL_F,EOL))),cons(cons(binary_order_sos_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(8),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(19),cons(BOOL_T,EOL))),EOL))))))))))));
  }
  else {
    display(const_236,cur_output_port());
    newline(cur_output_port());
    res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(2),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(3),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(33),cons(BOOL_F,EOL))),cons(cons(binary_order_sos_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_weightorder_symb,cons(MAKINUM(13),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),EOL))))))))))));
  }
  return res;
}

SCM select_initial_strategy_heq(incrlen)
SCM incrlen;
{
  SCM res;

  res=EOL;
  newline(cur_output_port());
  display(const_237,cur_output_port());
  newline(cur_output_port());
  GLOBAL(heq_class_flag_global)=BOOL_T;
  if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
    display(const_238,cur_output_port());
    newline(cur_output_port());
    if(GLOBAL(input_maxlen_nonground_nr_global)>MAKINUM(3)) {
      display(const_239,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(hyper_symb,cons(MAKINUM(18),cons(BOOL_F,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(4),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_sos_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_unit_sos_symb,cons(MAKINUM(6),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(14),cons(BOOL_T,EOL))),EOL))))))))))))))));
    }
    else {
      display(const_240,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(binary_posweight_order_symb,cons(MAKINUM(9),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(8),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(22),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(6),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(4),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(7),cons(BOOL_T,EOL))),EOL))))))))))))));
    }
  }
  else
  if(GLOBAL(input_cl_nr_global)>MAKINUM(10)) {
    display(const_241,cur_output_port());
    newline(cur_output_port());
    if(GLOBAL(input_maxlen_nonground_nr_global)>MAKINUM(3)) {
      display(const_242,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(hyper_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(5),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(hyper_symb,cons(MAKINUM(18),cons(BOOL_F,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(4),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(12),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(8),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),EOL)))))))))))))));
    }
    else {
      display(const_243,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(binary_posweight_order_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(8),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(2),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(4),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(28),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(8),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),EOL))))))))))))));
    }
  }
  else {
    display(const_244,cur_output_port());
    newline(cur_output_port());
    if(GLOBAL(input_maxlen_nonground_nr_global)>MAKINUM(3)) {
      display(const_245,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(hyper_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(33),cons(BOOL_F,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(3),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(4),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(4),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(9),cons(BOOL_F,EOL))),EOL))))))))))));
    }
    else {
      display(const_246,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(20),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(40),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(4),cons(BOOL_F,EOL))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(4),cons(BOOL_T,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),EOL))))))))));
    }
  }
  return res;
}

SCM select_initial_strategy_hne(incrlen)
SCM incrlen;
{
  SCM res;

  res=EOL;
  newline(cur_output_port());
  display(const_247,cur_output_port());
  newline(cur_output_port());
  GLOBAL(hne_class_flag_global)=BOOL_T;
  if(GLOBAL(input_cl_nr_global)>MAKINUM(100)) {
    display(const_248,cur_output_port());
    newline(cur_output_port());
    if(GLOBAL(input_maxlen_nonground_nr_global)>MAKINUM(3)) {
      display(const_249,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(hyper_symb,cons(MAKINUM(23),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_sos_symb,cons(MAKINUM(15),cons(BOOL_T,EOL))),cons(cons(binary_unit_sos_symb,cons(MAKINUM(8),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(12),cons(BOOL_T,EOL))),EOL)))))))))))));
    }
    else {
      display(const_250,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(28),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(4),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(13),cons(BOOL_T,EOL))),EOL)))))))))));
    }
  }
  else
  if(GLOBAL(input_cl_nr_global)>MAKINUM(10)) {
    display(const_251,cur_output_port());
    newline(cur_output_port());
    if(GLOBAL(input_maxlen_nonground_nr_global)>MAKINUM(3)) {
      display(const_252,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(hyper_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(5),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(hyper_symb,cons(MAKINUM(28),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(15),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(7),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(8),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(7),cons(BOOL_T,EOL))),EOL))))))))))));
    }
    else {
      display(const_253,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(hyper_symb,cons(MAKINUM(2),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(15),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(8),cons(BOOL_T,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(7),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(8),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),EOL)))))))))));
    }
  }
  else {
    display(const_254,cur_output_port());
    newline(cur_output_port());
    if(GLOBAL(input_maxlen_nonground_nr_global)>MAKINUM(3)) {
      display(const_255,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(hyper_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(11),cons(BOOL_F,EOL))),cons(cons(hyper_symb,cons(MAKINUM(28),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(27),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(4),cons(BOOL_T,EOL))),EOL))))))))));
    }
    else {
      display(const_256,cur_output_port());
      newline(cur_output_port());
      res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(2),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_double_symb,cons(MAKINUM(3),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(6),cons(BOOL_F,EOL))),cons(cons(binary_weightorder_symb,cons(MAKINUM(7),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(3),cons(BOOL_T,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(19),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_order_symb,cons(MAKINUM(47),cons(BOOL_F,EOL))),EOL))))))))));
    }
  }
  return res;
}

SCM select_initial_strategy_peq(incrlen)
SCM incrlen;
{
  SCM res;

  res=EOL;
  newline(cur_output_port());
  display(const_257,cur_output_port());
  newline(cur_output_port());
  if(1) {
    res=cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_unit_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_unit_uniteq_symb,cons(MAKINUM(2),cons(BOOL_F,EOL))),cons(cons(binary_posweight_kb_big_order_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_posweight_kb_big_order_symb,cons(MAKINUM(26),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(17),cons(BOOL_F,EOL))),cons(cons(binary_posweight_firstpref_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),cons(cons(binary_posweight_kb_small_order_symb,cons(MAKINUM(8),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(5),cons(BOOL_F,EOL))),EOL))))))))))));
  }
  return res;
}

SCM select_initial_strategy_ueq(incrlen)
SCM incrlen;
{
  SCM res;

  res=EOL;
  newline(cur_output_port());
  display(const_258,cur_output_port());
  newline(cur_output_port());
  if(1) {
    res=cons(cons(binary_posweight_kb_big_order_symb,cons(MAKINUM(10),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(5),cons(BOOL_F,cons(GLOBAL(input_maxdepth_nr_global),cons(incrlen,EOL))))),cons(cons(binary_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_posweight_kb_big_order_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_big_order_symb,cons(MAKINUM(20),cons(BOOL_F,EOL))),cons(cons(binary_posweight_firstpref_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_posweight_kb_small_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_posweight_lex_small_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),EOL))))))));
  }
  return res;
}

SCM break_nonkeyword()
{
  SCM flag,tmp;

  flag=BOOL_F;
  for(;!(NFALSEP(flag));) {
    newline(cur_output_port());
    display(const_259,cur_output_port());
    tmp=eval(lread(cur_input_port()));
    if(tmp==quit_symb) {
      flag=BOOL_T;
    }
    else
      display(tmp,cur_output_port());
    newline(cur_output_port());
  }
  return UNSPECIFIED;
}

SCM hprove(x,y,z)
SCM x,y,z;
{
  init_hyper_strat();
  return prove(x,y,z);
}

SCM hfprove(x,y)
SCM x,y;
{
  init_hyper_strat();
  return fprove(x);
}

SCM init()
{
  return init_hyper_strat();
}

SCM curry_input_readylst(readylst)
SCM readylst;
{
  SCM sospart,usablepart,res,tmp;

  sospart=assq(sos_symb,readylst);
  usablepart=assq(usable_symb,readylst);
  res=EOL;
  tmp=EOL;
  tmp=filter_map(curry_input_readylst_fn214,readylst);
  init_curry_clause_list();
  GLOBAL(max_curry_pred_nr_global)=MAKINUM(INUM(GLOBAL(absolute_max_curry_pred_nr_global))-(INUM(length(make_set(GLOBAL(special_curry_predsymbs_global))))+INUM(length(GLOBAL(curried_appred_arities_global)))));
  GLOBAL(max_curry_fun_nr_global)=MAKINUM(INUM(GLOBAL(absolute_max_curry_fun_nr_global))-(INUM(length(make_set(GLOBAL(special_curry_funsymbs_global))))+INUM(length(GLOBAL(curried_apfun_arities_global)))));
  if(NFALSEP(sospart)) {
    sospart=curry_clause_list(CDR(sospart));
  }
  if(NFALSEP(usablepart)) {
    usablepart=curry_clause_list(CDR(usablepart));
  }
  res=tmp;
  if(NFALSEP(sospart)) {
    res=cons(cons(sos_symb,sospart),res);
  }
  if(NFALSEP(usablepart)) {
    res=cons(cons(usable_symb,usablepart),res);
  }
  if((MAKINUM(INUM(GLOBAL(curried_pred_nr_global))+INUM(GLOBAL(not_curried_pred_nr_global)))<MAKINUM(115))&&(MAKINUM(INUM(GLOBAL(curried_fun_nr_global))+INUM(GLOBAL(not_curried_fun_nr_global)))<MAKINUM(115))) {
    res=readylst;
  }
  else {
    newline(cur_output_port());
    display(const_260,cur_output_port());
    newline(cur_output_port());
  }
  return res;
}

SCM curry_input_readylst_fn214(x)
SCM x;
{
  if(!(PAIR_P(x))||!(NFALSEP(memq(CAR(x),const_261))))
    return x;
  else
    return BOOL_F;
}

SCM make_curried_special_predfuns_data()
{
  GLOBAL(curried_appred_arities_global)=const_262;
  GLOBAL(curried_apfun_arities_global)=const_263;
  return UNSPECIFIED;
}

SCM init_curry_clause_list()
{
  GLOBAL(special_curry_predsymbs_global)=copy_list(append2(EOL,GLOBAL(special_orig_curry_predsymbs_global)));
  GLOBAL(special_curry_funsymbs_global)=copy_list(append2(EOL,GLOBAL(special_orig_curry_funsymbs_global)));
  GLOBAL(curried_pred_const_table_global)=EOL;
  GLOBAL(curried_pred_nr_global)=MAKINUM(0);
  GLOBAL(curry_pred_arity_table_global)=EOL;
  GLOBAL(not_curried_preds_global)=EOL;
  GLOBAL(not_curried_pred_nr_global)=MAKINUM(0);
  GLOBAL(curried_fun_const_table_global)=EOL;
  GLOBAL(curried_fun_nr_global)=MAKINUM(0);
  GLOBAL(curry_fun_arity_table_global)=EOL;
  GLOBAL(not_curried_fun_nr_global)=MAKINUM(0);
  GLOBAL(not_curried_funs_global)=EOL;
  return make_curried_special_predfuns_data();
}

SCM curry_clause_list(clauselst)
SCM clauselst;
{
  return map1(curry_clause_list_fn216,clauselst);
}

SCM curry_clause_list_fn216(x)
SCM x;
{
  return curry_clause(x);
}

SCM curry_clause(clause)
SCM clause;
{
  return map1(curry_clause_fn218,clause);
}

SCM curry_clause_fn218(x)
SCM x;
{
  return curry_lit(x);
}

SCM curry_lit(lit)
SCM lit;
{
  SCM predsymb,purepredsymb,predstr,polarity,prednrplace,predarityplace,tmpres,arity,appred,const_nonkeyword,tmpconst,purepredstr;

  predsymb=EOL;
  purepredsymb=EOL;
  predstr=EOL;
  polarity=EOL;
  prednrplace=EOL;
  predarityplace=EOL;
  tmpres=EOL;
  arity=MAKINUM(0);
  appred=EOL;
  const_nonkeyword=EOL;
  tmpconst=EOL;
  purepredstr=EOL;
  if(PAIR_P(lit)) {
    predsymb=CAR(lit);
  }
  else
  if(SYMBOL_P(lit)) {
    predsymb=lit;
  }
  else {
    predsymb=BOOL_F;
  }
  predstr=symbol2string(predsymb);
  if(MAKICHR('-')==ST_REF(predstr,MAKINUM(0)))
    polarity=BOOL_F;
  else
    polarity=BOOL_T;
  if(NFALSEP(polarity))
    purepredstr=predstr;
  else
    purepredstr=substring(predstr,MAKINUM(1),ST_LENGTH(predstr));
  purepredsymb=string2symbol(purepredstr);
  predarityplace=assq(purepredsymb,GLOBAL(curry_pred_arity_table_global));
  if(!(NFALSEP(predsymb))) {
    tmpres=lit;
  }
  else
  if(NFALSEP(memq(purepredsymb,GLOBAL(special_curry_predsymbs_global)))) {
    tmpres=lit;
  }
  else
  if(!(NFALSEP(predarityplace))) {
    if(GLOBAL(not_curried_pred_nr_global)>=GLOBAL(max_curry_pred_nr_global)) {
      GLOBAL(curried_pred_nr_global)=MAKINUM(1+INUM(GLOBAL(curried_pred_nr_global)));
      arity=length(CDR(lit));
      if(arity>MAKINUM(70))
        report_error(const_264,cons(BOOL_T,EOL));
      tmpconst=make_curry_const(GLOBAL(curried_pred_nr_global));
      GLOBAL(curried_pred_const_table_global)=cons(cons(purepredsymb,tmpconst),GLOBAL(curried_pred_const_table_global));
      GLOBAL(curry_pred_arity_table_global)=cons(cons(purepredsymb,length(CDR(lit))),GLOBAL(curry_pred_arity_table_global));
      appred=CAR(rassq(arity,GLOBAL(curried_appred_arities_global)));
      tmpres=cons(polarize_purepred_symb(appred,polarity),cons(tmpconst,CDR(lit)));
    }
    else {
      GLOBAL(not_curried_pred_nr_global)=MAKINUM(1+INUM(GLOBAL(not_curried_pred_nr_global)));
      GLOBAL(not_curried_preds_global)=cons(purepredsymb,GLOBAL(not_curried_preds_global));
      GLOBAL(curry_pred_arity_table_global)=cons(cons(purepredsymb,length(CDR(lit))),GLOBAL(curry_pred_arity_table_global));
      tmpres=lit;
    }
  }
  else
  if(!(NFALSEP(memq(purepredsymb,GLOBAL(not_curried_preds_global))))) {
    arity=length(CDR(lit));
    const_nonkeyword=CDR(assq(purepredsymb,GLOBAL(curried_pred_const_table_global)));
    if(arity>MAKINUM(70))
      report_error(const_265,cons(BOOL_T,EOL));
    appred=CAR(rassq(arity,GLOBAL(curried_appred_arities_global)));
    tmpres=cons(polarize_purepred_symb(appred,polarity),cons(const_nonkeyword,CDR(lit)));
  }
  else {
    tmpres=lit;
  }
  if(PAIR_P(tmpres))
    return cons(CAR(tmpres),map1(curry_lit_fn220,CDR(tmpres)));
  else
    return tmpres;
}

SCM curry_lit_fn220(x)
SCM x;
{
  return curry_term(x);
}

SCM polarize_purepred_symb(symb,polarity)
SCM symb,polarity;
{
  if(NFALSEP(polarity))
    return symb;
  else
    return string2symbol(st_append(cons(const_266,cons(symbol2string(symb),EOL))));
}

SCM curry_term(term)
SCM term;
{
  SCM funsymb,purefunsymb,funnrplace,funarityplace,tmpres,arity,tmpconst,apfun,const_nonkeyword;

  funsymb=EOL;
  purefunsymb=EOL;
  funnrplace=EOL;
  funarityplace=EOL;
  tmpres=EOL;
  arity=MAKINUM(0);
  tmpconst=EOL;
  apfun=EOL;
  const_nonkeyword=EOL;
  if(!(PAIR_P(term)))
    return term;
  else {
    term=cons(CAR(term),map1(curry_term_fn222,CDR(term)));
    funsymb=CAR(term);
    purefunsymb=funsymb;
    funarityplace=assq(purefunsymb,GLOBAL(curry_fun_arity_table_global));
    if(NFALSEP(memq(purefunsymb,GLOBAL(special_curry_funsymbs_global)))) {
      tmpres=term;
    }
    else
    if(!(NFALSEP(funarityplace))) {
      if(GLOBAL(not_curried_fun_nr_global)>=GLOBAL(max_curry_fun_nr_global)) {
        GLOBAL(curried_fun_nr_global)=MAKINUM(1+INUM(GLOBAL(curried_fun_nr_global)));
        tmpconst=make_curry_const(GLOBAL(curried_fun_nr_global));
        arity=length(CDR(term));
        if(arity>MAKINUM(70))
          report_error(const_267,cons(BOOL_T,EOL));
        GLOBAL(curried_fun_const_table_global)=cons(cons(purefunsymb,tmpconst),GLOBAL(curried_fun_const_table_global));
        GLOBAL(curry_fun_arity_table_global)=cons(cons(purefunsymb,length(CDR(term))),GLOBAL(curry_fun_arity_table_global));
        apfun=CAR(rassq(arity,GLOBAL(curried_apfun_arities_global)));
        tmpres=cons(apfun,cons(tmpconst,CDR(term)));
      }
      else {
        GLOBAL(not_curried_fun_nr_global)=MAKINUM(1+INUM(GLOBAL(not_curried_fun_nr_global)));
        GLOBAL(not_curried_funs_global)=cons(purefunsymb,GLOBAL(not_curried_funs_global));
        GLOBAL(curry_fun_arity_table_global)=cons(cons(purefunsymb,length(CDR(term))),GLOBAL(curry_fun_arity_table_global));
        tmpres=term;
      }
    }
    else
    if(!(NFALSEP(memq(purefunsymb,GLOBAL(not_curried_funs_global))))) {
      arity=length(CDR(term));
      const_nonkeyword=CDR(assq(purefunsymb,GLOBAL(curried_fun_const_table_global)));
      if(arity>MAKINUM(70))
        report_error(const_268,cons(BOOL_T,EOL));
      apfun=CAR(rassq(arity,GLOBAL(curried_apfun_arities_global)));
      tmpres=cons(apfun,cons(const_nonkeyword,CDR(term)));
    }
    else {
      tmpres=term;
    }
    return tmpres;
  }
}

SCM curry_term_fn222(x)
SCM x;
{
  return curry_term(x);
}

SCM make_curry_const(nr)
SCM nr;
{
  return string2symbol(st_append(cons(const_269,cons(number2string(nr,MAKINUM(10)),EOL))));
}

SCM make_set(lst)
SCM lst;
{
tailrecursion:
  if(NULL_P(lst))
    return EOL;
  else
  if(NFALSEP(member(CAR(lst),CDR(lst)))) {
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
    return cons(CAR(lst),make_set(CDR(lst)));
}

SCM groundprocess_input_readylst(readylst)
SCM readylst;
{
  SCM sospart,usablepart,res,tmp,sosaddedflag;

  sospart=assq(sos_symb,readylst);
  usablepart=assq(usable_symb,readylst);
  res=EOL;
  tmp=EOL;
  sosaddedflag=BOOL_F;
  GLOBAL(groundprocess_const_nr_global)=MAKINUM(0);
  GLOBAL(groundprocess_term_const_pairs_global)=EOL;
  tmp=filter_map(groundprocess_input_readylst_fn224,readylst);
  if(NFALSEP(sospart)) {
    sospart=groundprocess_clause_list(CDR(sospart));
  }
  if(NFALSEP(usablepart)) {
    usablepart=groundprocess_clause_list(CDR(usablepart));
  }
  res=tmp;
  if(GLOBAL(groundprocess_const_nr_global)==MAKINUM(0)) {
    res=readylst;
  }
  else {
    if(NFALSEP(sospart)) {
      sosaddedflag=BOOL_T;
      sospart=append2(groundprocess_make_equalities(),sospart);
      res=cons(cons(sos_symb,sospart),res);
    }
    if(NFALSEP(usablepart)) {
      if(!(NFALSEP(sosaddedflag))) {
        usablepart=append2(groundprocess_make_equalities(),usablepart);
      }
      res=cons(cons(usable_symb,usablepart),res);
    }
    newline(cur_output_port());
    display(const_270,cur_output_port());
    newline(cur_output_port());
  }
  return res;
}

SCM groundprocess_input_readylst_fn224(x)
SCM x;
{
  if(!(PAIR_P(x))||!(NFALSEP(memq(CAR(x),const_271))))
    return x;
  else
    return BOOL_F;
}

SCM groundprocess_make_equalities()
{
  SCM tmp,varsymb;

  tmp=EOL;
  varsymb=EOL;
  tmp=map1(groundprocess_make_equalities_fn226,GLOBAL(groundprocess_term_const_pairs_global));
  if(NFALSEP(GLOBAL(prolog_style_variables_global))) {
    varsymb=_exp_x_symb;
  }
  else {
    varsymb=x_symb;
  }
  tmp=cons(cons(cons(equal_symb,cons(varsymb,cons(varsymb,EOL))),EOL),tmp);
  return tmp;
}

SCM groundprocess_make_equalities_fn226(x)
SCM x;
{
  return cons(cons(equal_symb,cons(CAR(x),cons(CDR(x),EOL))),EOL);
}

SCM groundprocess_clause_list(clauselst)
SCM clauselst;
{
  return map1(groundprocess_clause_list_fn228,clauselst);
}

SCM groundprocess_clause_list_fn228(x)
SCM x;
{
  return groundprocess_clause(x);
}

SCM groundprocess_clause(clause)
SCM clause;
{
  return map1(groundprocess_clause_fn230,clause);
}

SCM groundprocess_clause_fn230(x)
SCM x;
{
  return groundprocess_lit(x);
}

SCM groundprocess_lit(lit)
SCM lit;
{
  SCM tmp;

  tmp=EOL;
  if(!(PAIR_P(lit)))
    return lit;
  else {
    tmp=map1(groundprocess_lit_fn232,CDR(lit));
    return cons(CAR(lit),tmp);
  }
}

SCM groundprocess_lit_fn232(x)
SCM x;
{
  return groundprocess_term(x);
}

SCM groundprocess_term(term)
SCM term;
{
  SCM tmp,newc;

  tmp=EOL;
  newc=EOL;
  if(!(PAIR_P(term)))
    return term;
  else {
    tmp=map1(groundprocess_term_fn235,CDR(term));
    if(NFALSEP(every_pred_(groundprocess_term_fn236,tmp))) {
      newc=assoc(cons(CAR(term),tmp),GLOBAL(groundprocess_term_const_pairs_global));
      if(NFALSEP(newc))
        return CDR(newc);
      else {
        newc=groundprocess_term_newconstant();
        GLOBAL(groundprocess_term_const_pairs_global)=cons(cons(cons(CAR(term),tmp),newc),GLOBAL(groundprocess_term_const_pairs_global));
        return newc;
      }
    }
    else
      return cons(CAR(term),tmp);
  }
}

SCM groundprocess_term_fn236(y)
SCM y;
{
  return SBOOL(!(PAIR_P(y))&&!(NFALSEP(var_symbol_pred_(y))));
}

SCM groundprocess_term_fn235(x)
SCM x;
{
  return groundprocess_term(x);
}

SCM groundprocess_term_newconstant()
{
  GLOBAL(groundprocess_const_nr_global)=MAKINUM(1+INUM(GLOBAL(groundprocess_const_nr_global)));
  return string2symbol(st_append(cons(const_272,cons(number2string(GLOBAL(groundprocess_const_nr_global),MAKINUM(10)),EOL))));
}

SCM abs_path_part(path)
SCM path;
{
  return substring(path,MAKINUM(0),MAKINUM(INUM(ST_LENGTH(path))-INUM(ST_LENGTH(const_273))));
}

SCM show_old_units()
{
  return for_each1(show_old_units_fn240,GLOBAL(unit_alist_list_global));
}

SCM show_old_units_fn240(x)
SCM x;
{
  display(const_274,cur_output_port());
  newline(cur_output_port());
  return for_each1(show_old_units_fn241,x);
}

SCM show_old_units_fn241(sublist)
SCM sublist;
{
  return for_each1(show_old_units_fn242,CDR(sublist));
}

SCM show_old_units_fn242(el)
SCM el;
{
  print_clause(el);
  return newline(cur_output_port());
}

SCM show_derived()
{
  newline(cur_output_port());
  display(const_275,cur_output_port());
  newline(cur_output_port());
  for_each1(show_derived_fn245,GLOBAL(sos_clauses_list_global));
  newline(cur_output_port());
  display(const_276,cur_output_port());
  newline(cur_output_port());
  return for_each1(show_derived_fn246,GLOBAL(usable_clauses_list_global));
}

SCM show_derived_fn246(x)
SCM x;
{
  if(PAIR_P(x))
    print_clause(x);
  return newline(cur_output_port());
}

SCM show_derived_fn245(x)
SCM x;
{
  if(PAIR_P(x))
    print_clause(x);
  return newline(cur_output_port());
}

SCM go()
{
  return fprove(const_277);
}

SCM sgo()
{
  return fsat(const_278);
}

SCM q()
{
  return quit(1);
}

SCM bgo()
{
  SCM part__1,part,place,nr,clause,clauselst,literals,clauses,table,purepred,polarity,predstr,pred,res,lst_end,lst,iport,filename,obj,new_var1,clpart;

  filename=const_279;
  iport=open_file(filename,const_280);
  lst=EOL;
  lst_end=EOL;
  res=EOL;
  pred=EOL;
  predstr=EOL;
  polarity=EOL;
  purepred=EOL;
  table=EOL;
  clauses=MAKINUM(0);
  literals=MAKINUM(0);
  clauselst=EOL;
  clause=EOL;
  nr=MAKINUM(0);
  place=EOL;
  lst=cons(EOL,EOL);
  lst_end=lst;
  for(obj=lread(iport);!(NFALSEP(eof_objectp(obj)));obj=lread(iport)) {
    SET_CDR(lst_end,cons(obj,EOL));
    lst_end=CDR(lst_end);
  }
  close_port(iport);
  lst=CDR(lst);
  res=lst;
  newline(cur_output_port());
  display(const_281,cur_output_port());
  display(length(res),cur_output_port());
  newline(cur_output_port());
  table=EOL;
  nr=MAKINUM(0);
  clauses=MAKINUM(0);
  literals=MAKINUM(0);
  clauselst=EOL;
  clause=EOL;
  for(part=res;!(NULL_P(part));part=CDR(part)) {
    pred=CAR(part);
    if(pred==endofline_symb) {
      clauselst=cons(clause,clauselst);
      clause=EOL;
      clauses=MAKINUM(1+INUM(clauses));
    }
    else {
      new_var1=SBOOL(pred==_vbar__symb);
      if(NFALSEP(new_var1)) ;
      else
      if(SYMBOL_P(pred)) {
        predstr=symbol2string(pred);
        if(MAKICHR('-')==ST_REF(predstr,MAKINUM(0)))
          polarity=BOOL_F;
        else
          polarity=BOOL_T;
        if(NFALSEP(polarity))
          purepred=pred;
        else
          purepred=string2symbol(substring(predstr,MAKINUM(1),ST_LENGTH(predstr)));
        literals=MAKINUM(1+INUM(literals));
        place=assq(purepred,table);
        if(NFALSEP(place)) {
          if(NFALSEP(polarity)) {
            clause=cons(CDR(place),clause);
          }
          else {
            clause=cons(MAKINUM(0-INUM(CDR(place))),clause);
          }
        }
        else {
          nr=MAKINUM(1+INUM(nr));
          table=cons(cons(purepred,nr),table);
          if(NFALSEP(polarity)) {
            clause=cons(nr,clause);
          }
          else {
            clause=cons(MAKINUM(0-INUM(nr)),clause);
          }
        }
      }
    }
  }
  newline(cur_output_port());
  display(const_282,cur_output_port());
  newline(cur_output_port());
  display(const_283,cur_output_port());
  display(nr,cur_output_port());
  newline(cur_output_port());
  display(const_284,cur_output_port());
  display(literals,cur_output_port());
  newline(cur_output_port());
  display(const_285,cur_output_port());
  display(clauses,cur_output_port());
  newline(cur_output_port());
  clauselst=reverse(clauselst);
  display(const_286,cur_output_port());
  display(nr,cur_output_port());
  display(const_287,cur_output_port());
  display(clauses,cur_output_port());
  newline(cur_output_port());
  for(part__1=clauselst;!(NULL_P(part__1));part__1=CDR(part__1)) {
    for(clpart=CAR(part__1);!(NULL_P(clpart));clpart=CDR(clpart)) {
      display(CAR(clpart),cur_output_port());
      display(const_288,cur_output_port());
    }
    display(const_289,cur_output_port());
    newline(cur_output_port());
  }
  return UNSPECIFIED;
}

SCM display_kept_nr()
{
  newline(cur_output_port());
  display(const_290,cur_output_port());
  display(GLOBAL(checkpoint_keptnrs_global),cur_output_port());
  display(const_291,cur_output_port());
  return newline(cur_output_port());
}

SCM given_clause_slow_loop()
{
  SCM given_cl_place,given_cl,tmp;

  GLOBAL(sos_exhausted_flag_global)=BOOL_F;
  GLOBAL(last_best_weight_global)=MAKINUM(0);
  GLOBAL(last_best_clausesize_global)=MAKINUM(0);
  GLOBAL(foundflag_global)=BOOL_F;
  GLOBAL(sat_found_flag_global)=BOOL_F;
  GLOBAL(answer_cl_global)=EOL;
  GLOBAL(new_demodulators_list_global)=EOL;
  GLOBAL(answer_history_global)=EOL;
  GLOBAL(slow_start_time_global)=get_check_time(MAKINUM(0));
  store_time_checkpoint_excl_(MAKINUM(0));
  if(!(NFALSEP(GLOBAL(int_logic_flag_global)))) {
    GLOBAL(sos_clauses_list_end_global)=my_last_pair(GLOBAL(sos_clauses_list_global));
  }
  GLOBAL(usable_clauses_list_global)=cons(EOL,GLOBAL(usable_clauses_list_global));
  GLOBAL(usable_clauses_list_end_global)=my_last_pair(GLOBAL(usable_clauses_list_global));
  clear_x_vars_and_touched_excl_(MAKINUM(255));
  clear_y_vars_and_touched_excl_(MAKINUM(255));
  clear_z_vars_and_touched_excl_(MAKINUM(255));
  GLOBAL(one_step_hyper_phase_global)=BOOL_F;
  if(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))&&(NFALSEP(GLOBAL(heq_class_flag_global))||NFALSEP(GLOBAL(hne_class_flag_global)))) {
    GLOBAL(sos_preference_exp_ratio_global)=MAKINUM(2);
  }
  else {
    GLOBAL(sos_preference_exp_ratio_global)=MAKINUM(33);
  }
  GLOBAL(sos_preference_cur_ratio_global)=GLOBAL(sos_preference_ratio_global);
  GLOBAL(sos_preference_cur_distance_global)=GLOBAL(sos_preference_distance_ratio_global);
  GLOBAL(sos_preference_cur_exp_global)=GLOBAL(sos_preference_exp_ratio_global);
  if(NFALSEP(GLOBAL(factors_stratflag_global)))
    factor_sos(GLOBAL(sos_clauses_list_global));
  for(;!(NULL_P(GLOBAL(sos_clauses_list_global))||(NFALSEP(GLOBAL(foundflag_global))||((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))));) {
    if(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(NFALSEP(GLOBAL(unit_equality_strat_global))&&((GLOBAL(sos_preference_ratio_global)<MAKINUM(5))&&((100*(INUM(get_check_time(MAKINUM(2)))-INUM(GLOBAL(slow_start_time_global))))>(20*INUM(GLOBAL(one_pass_time_global)))))))) {
      store_time_checkpoint_excl_(MAKINUM(55));
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_292,cur_output_port());
        newline(cur_output_port());
      }
      GLOBAL(sos_preference_ratio_global)=MAKINUM(5);
    }
    if(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(NFALSEP(GLOBAL(unit_equality_strat_global))&&((GLOBAL(sos_preference_ratio_global)<MAKINUM(100))&&((100*(INUM(get_check_time(MAKINUM(2)))-INUM(GLOBAL(slow_start_time_global))))>(50*INUM(GLOBAL(one_pass_time_global)))))))) {
      store_time_checkpoint_excl_(MAKINUM(45));
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_293,cur_output_port());
        newline(cur_output_port());
      }
      GLOBAL(sos_preference_ratio_global)=MAKINUM(100000);
    }
    if(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(!(NFALSEP(GLOBAL(unit_equality_strat_global)))&&(NFALSEP(GLOBAL(binary_hyper_sos_strategy_global))&&(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))&&((100*(INUM(get_check_time(MAKINUM(2)))-INUM(GLOBAL(slow_start_time_global))))>(50*INUM(GLOBAL(one_pass_time_global))))))))) {
      store_time_checkpoint_excl_(MAKINUM(2));
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_294,cur_output_port());
        newline(cur_output_port());
      }
      GLOBAL(unit_strategy_flag_global)=BOOL_F;
      GLOBAL(double_strategy_flag_global)=BOOL_F;
      GLOBAL(name_order_strategy_flag_global)=BOOL_F;
      GLOBAL(hyper_strategy_flag_global)=BOOL_T;
      GLOBAL(para_pos_unit_strategy_global)=BOOL_T;
      GLOBAL(hyper_strategy_flag_global)=BOOL_T;
    }
    if(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(!(NFALSEP(GLOBAL(unit_equality_strat_global)))&&((!(NFALSEP(GLOBAL(unit_strategy_flag_global)))||(GLOBAL(sos_preference_ratio_global)<MAKINUM(100)))&&(!(NFALSEP(GLOBAL(binary_hyper_sos_strategy_global)))&&(!(NFALSEP(GLOBAL(hyper_contradiction_strategy_global)))&&(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))&&((100*(INUM(get_check_time(MAKINUM(3)))-INUM(GLOBAL(slow_start_time_global))))>(50*INUM(GLOBAL(one_pass_time_global))))))))))) {
      store_time_checkpoint_excl_(MAKINUM(3));
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_295,cur_output_port());
        newline(cur_output_port());
      }
      GLOBAL(sos_preference_ratio_global)=MAKINUM(100000);
      GLOBAL(para_unit_strategy_global)=BOOL_T;
      GLOBAL(unit_strategy_flag_global)=BOOL_T;
    }
    if(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&NFALSEP(GLOBAL(bliksem_strategy_flag_global))) {
      if(INUM(GLOBAL(kept_clauses_nr_global))>(300+INUM(GLOBAL(one_pass_kept_clauses_firstnr_global)))) {
        GLOBAL(clause_keepsize_limit_global)=GLOBAL(clause_finalkeepsize_limit_global);
      }
    }
    if(!(NFALSEP(GLOBAL(sat_strategy_flag_global)))&&((NFALSEP(GLOBAL(one_pass_time_global))||!(NULL_P(GLOBAL(given_checkpoint_keptnrs_global))))&&(!(NFALSEP(GLOBAL(unit_equality_strat_global)))&&(!(NFALSEP(GLOBAL(binary_hyper_sos_strategy_global)))&&(!(NFALSEP(GLOBAL(hyper_contradiction_strategy_global)))&&((100*(INUM(get_check_time(MAKINUM(4)))-INUM(GLOBAL(slow_start_time_global))))>(75*INUM(GLOBAL(one_pass_time_global))))))))) {
      store_time_checkpoint_excl_(MAKINUM(4));
      if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
        if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
          newline(cur_output_port());
          display(const_296,cur_output_port());
          newline(cur_output_port());
        }
        start_backward_hyper_analysis();
        GLOBAL(usable_clauses_list_global)=cons(EOL,GLOBAL(usable_clauses_list_global));
        GLOBAL(usable_clauses_list_end_global)=my_last_pair(GLOBAL(usable_clauses_list_global));
        GLOBAL(sos_preference_cur_ratio_global)=GLOBAL(sos_preference_ratio_global);
      }
      else {
        if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
          newline(cur_output_port());
          display(const_297,cur_output_port());
          newline(cur_output_port());
        }
        start_binary_hypercheck_strategy();
        if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
          newline(cur_output_port());
          display(const_298,cur_output_port());
          newline(cur_output_port());
        }
      }
    }
    given_cl_place=select_given_cl_place(GLOBAL(sos_clauses_list_global));
    given_cl=CAR(given_cl_place);
    tmp=EOL;
    if(given_cl_place==GLOBAL(sos_clauses_list_global)) {
      GLOBAL(sos_clauses_list_global)=CDR(GLOBAL(sos_clauses_list_global));
    }
    else
    if(NULL_P(CDR(given_cl_place))) {
      remove_at_place_excl_(given_cl_place,GLOBAL(sos_clauses_list_global));
      GLOBAL(sos_clauses_list_end_global)=my_last_pair(GLOBAL(sos_clauses_list_global));
    }
    else {
      remove_at_place_excl_(given_cl_place,GLOBAL(sos_clauses_list_global));
    }
    if(!(ZERO_P(MAKINUM(65535)&CAR(CAR(given_cl))))&&(!(NFALSEP(GLOBAL(foundflag_global)))&&(NFALSEP((!(NFALSEP(GLOBAL(back_demodulate_flag_global))) ? BOOL_T : (GLOBAL(special_insertion_place_global)=cons(EOL,EOL),UNSPECIFIED,tmp=demodulate_clause(given_cl),UNSPECIFIED,GLOBAL(special_insertion_place_global)=EOL,UNSPECIFIED,(!(NFALSEP(tmp)) ? BOOL_T : (given_cl=CDR(tmp),UNSPECIFIED)),BOOL_T)))&&(0||!(NFALSEP(given_cl_havealready_pred_(given_cl))))))) {
      if(!(NULL_P(CDR(CDR(given_cl))))) {
        given_cl=handle_ready_clause(given_cl);
      }
      GLOBAL(given_clause_nr_global)=MAKINUM(1+INUM(GLOBAL(given_clause_nr_global)));
      SET_CDR(GLOBAL(usable_clauses_list_end_global),cons(given_cl,EOL));
      GLOBAL(usable_clauses_list_end_global)=CDR(GLOBAL(usable_clauses_list_end_global));
      insert_to_subsumption_list_excl_(MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(given_cl)))>>17),MAKINUM(65535)&CAR(CAR(given_cl)),given_cl);
      if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
        newline(cur_output_port());
        display(const_299,cur_output_port());
        display(GLOBAL(given_clause_nr_global),cur_output_port());
        display(const_300,cur_output_port());
        newline(cur_output_port());
        print_full_clause(given_cl);
        newline(cur_output_port());
        display(const_301,cur_output_port());
        display(clinfo_distance(CAR(given_cl)),cur_output_port());
        newline(cur_output_port());
        display(const_302,cur_output_port());
        display(GLOBAL(kept_size_sum_nr_global),cur_output_port());
        newline(cur_output_port());
        if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
          newline(cur_output_port());
          display(const_303,cur_output_port());
          newline(cur_output_port());
          debug_print_clause(given_cl);
          newline(cur_output_port());
        }
      }
      GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
      if(NFALSEP(GLOBAL(back_demodulate_flag_global))&&!(NULL_P(GLOBAL(new_demodulators_list_global))))
        back_demodulate_usable();
      GLOBAL(new_demodulators_list_global)=EOL;
      if(NFALSEP(GLOBAL(int_logic_flag_global)))
        apply(GLOBAL(int_usable_clauses_fast_loop),given_cl,cons(BOOL_T,listofnull));
      else
        usable_clauses_fast_loop(given_cl,BOOL_T);
    }
    else
    if(NFALSEP(GLOBAL(keep_all_old_clauses_flag_global))) {
      GLOBAL(all_back_subsumed_clauses_global)=cons(given_cl,GLOBAL(all_back_subsumed_clauses_global));
    }
  }
  if(!(NULL_P(GLOBAL(sos_clauses_list_global)))&&!(NFALSEP(GLOBAL(foundflag_global)))) {
    GLOBAL(sos_exhausted_flag_global)=BOOL_F;
    store_time_checkpoint_excl_(MAKINUM(1));
    if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
      newline(cur_output_port());
      display(const_304,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(answer_history_global)=not_enough_time_symb;
  }
  else {
    GLOBAL(sos_exhausted_flag_global)=BOOL_T;
    if(NULL_P(GLOBAL(sos_clauses_list_global))&&(GLOBAL(display_info_level_global)>MAKINUM(38))) {
      newline(cur_output_port());
      display(const_305,cur_output_port());
      newline(cur_output_port());
    }
  }
  return GLOBAL(foundflag_global);
}

SCM select_given_cl_place(lst)
SCM lst;
{
  SCM lstpart,bestpl,hist,clinf,distanceflag,bestdistance,expflag,thisweight,bestweight,lstpart__1;

  if(NULL_P(lst)) {
    lst=copytree(const_306);
  }
  if(GLOBAL(sos_preference_cur_ratio_global)<=MAKINUM(0)) {
    GLOBAL(sos_preference_cur_ratio_global)=GLOBAL(sos_preference_ratio_global);
    return lst;
  }
  else {
    bestpl=lst;
    hist=EOL;
    clinf=EOL;
    distanceflag=BOOL_F;
    bestdistance=BOOL_F;
    expflag=BOOL_F;
    thisweight=MAKINUM(0);
    bestweight=(MAKINUM(2047)&CAR(CAR(CAR(lst))));
    if(GLOBAL(sos_preference_cur_distance_global)<=MAKINUM(0)) {
      GLOBAL(sos_preference_cur_distance_global)=GLOBAL(sos_preference_distance_ratio_global);
      distanceflag=BOOL_T;
    }
    if(GLOBAL(sos_preference_cur_exp_global)<=MAKINUM(0)) {
      GLOBAL(sos_preference_cur_exp_global)=GLOBAL(sos_preference_exp_ratio_global);
      expflag=BOOL_T;
    }
    GLOBAL(last_best_weight_global)=MAKINUM(9999999);
    GLOBAL(sos_preference_cur_ratio_global)=MAKINUM(INUM(GLOBAL(sos_preference_cur_ratio_global))-1);
    GLOBAL(sos_preference_cur_distance_global)=MAKINUM(INUM(GLOBAL(sos_preference_cur_distance_global))-1);
    GLOBAL(sos_preference_cur_exp_global)=MAKINUM(INUM(GLOBAL(sos_preference_cur_exp_global))-1);
    if(NFALSEP(GLOBAL(split_strategy_flag_global))) {
      for(lstpart=lst;!(NULL_P(lstpart));lstpart=CDR(lstpart))
        if(((MAKINUM(2047)&CAR(CDR(CDR(CDR(CAR(CAR(lstpart)))))))<bestweight)&&!(ZERO_P(MAKINUM(2047)&CAR(CAR(CAR(lstpart)))))) {
          bestpl=lstpart;
          GLOBAL(last_best_weight_global)=bestweight;
          bestweight=(MAKINUM(2047)&CAR(CDR(CDR(CDR(CAR(CAR(lstpart)))))));
        }
      if(!(NULL_P(bestpl))) {
        GLOBAL(last_best_clausesize_global)=compute_real_clausesize(CDR(CAR(bestpl)));
      }
      if(NFALSEP(equal(GLOBAL(last_best_weight_global),MAKINUM(9999999)))) {
        GLOBAL(last_best_weight_global)=bestweight;
      }
      return bestpl;
    }
    else {
      for(lstpart__1=lst;!(NULL_P(lstpart__1));lstpart__1=CDR(lstpart__1)) {
        clinf=CAR(CAR(lstpart__1));
        if(NFALSEP(expflag)) {
          thisweight=(MAKINUM(65535)&CAR(clinf));
        }
        else {
          thisweight=(MAKINUM(2047)&CAR(clinf));
        }
        if((NFALSEP(distanceflag)&&(!(NFALSEP(bestdistance))&&NFALSEP(clinfo_distance(clinf))))||((thisweight<bestweight)&&(!(ZERO_P(MAKINUM(2047)&CAR(clinf)))&&(!(NFALSEP(distanceflag))||(!(NFALSEP(bestdistance))||NFALSEP(clinfo_distance(clinf))))))) {
          bestpl=lstpart__1;
          GLOBAL(last_best_weight_global)=(MAKINUM(2047)&CAR(clinf));
          if(NFALSEP(GLOBAL(sos_preference_cur_distance_global))) {
            bestdistance=clinfo_distance(clinf);
          }
          bestweight=thisweight;
        }
      }
      if(!(NULL_P(bestpl))) {
        GLOBAL(last_best_clausesize_global)=compute_real_clausesize(CDR(CAR(bestpl)));
      }
      if(NFALSEP(equal(GLOBAL(last_best_weight_global),MAKINUM(9999999)))) {
        GLOBAL(last_best_weight_global)=bestweight;
      }
      return bestpl;
    }
  }
}

SCM given_cl_havealready_pred_(given_cl)
SCM given_cl;
{
  SCM tmp,res,cl;

  tmp=BOOL_F;
  res=BOOL_F;
  cl=given_cl;
  GLOBAL(subsuming_clause_global)=BOOL_F;
  GLOBAL(prohibit_subs_clnr_global)=CAR(CDR(CDR(CDR(CDR(CAR(given_cl))))));
  if(NULL_P(CDR(CDR(given_cl)))) {
    tmp=check_discr_tree(GLOBAL(discr_tree_global),CAR(CDR(given_cl)));
    if(NFALSEP(tmp)&&(!(NULL_P(CDR(tmp)))&&(!(NULL_P(CDR(CDR(tmp))))&&((MAKINUM(268435456)&CAR(CAR(CDR(given_cl))))==(MAKINUM(268435456)&CAR(CAR(CDR(CAR(CDR(CDR(tmp))))))))))) {
      res=CAR(CDR(CDR(tmp)));
    }
    else {
      res=BOOL_F;
    }
  }
  else {
    res=some_pred__inst3(&tmp,given_cl_havealready_pred__fn248,CDR(given_cl));
    if(!(NFALSEP(res))) {
      res=havealready_clause_pred_(CAR(given_cl),CDR(given_cl));
    }
  }
  GLOBAL(prohibit_subs_clnr_global)=BOOL_F;
  if(NFALSEP(res)) {
    GLOBAL(back_subsumed_nr_global)=MAKINUM(1+INUM(GLOBAL(back_subsumed_nr_global)));
    SET_CAR(CAR(given_cl),MAKINUM(65535^INUM(MAKINUM(65535)|CAR(CAR(given_cl)))));
  }
  if(NFALSEP(res)&&(GLOBAL(display_info_level_global)>=MAKINUM(50))) {
    newline(cur_output_port());
    display(const_307,cur_output_port());
    newline(cur_output_port());
    print_pure_clause(CDR(given_cl));
    display(const_308,cur_output_port());
    newline(cur_output_port());
    if(NFALSEP(GLOBAL(subsuming_clause_global)))
      print_pure_clause(CDR(GLOBAL(subsuming_clause_global)));
    else
      print_pure_clause(CDR(res));
    newline(cur_output_port());
  }
  return res;
}

SCM given_cl_havealready_pred__fn248(tmp,lit)
SCM *tmp;
SCM lit;
{
  *tmp=check_discr_tree(GLOBAL(discr_tree_global),lit);
  if(NFALSEP(*tmp)&&(!(NULL_P(CDR(*tmp)))&&(!(NULL_P(CDR(CDR(*tmp))))&&((MAKINUM(268435456)&CAR(lit))==(MAKINUM(268435456)&CAR(CAR(CDR(CAR(CDR(CDR(*tmp)))))))))))
    return CAR(CDR(CDR(*tmp)));
  else
    return BOOL_F;
}

SCM usable_clauses_fast_loop(given_cl,full_nucleus_flag)
SCM given_cl,full_nucleus_flag;
{
  SCM usable_clauses_list_part,one_step_results,ycl,yinf,ylitinf,yclmaxvar,given_cl_is_nuc_flag,given_cl_is_neg_flag,given_cl_is_final_nuc_flag,given_final_nuc_premiss_lit,given_final_nuc_complfunpure,given_cl_contains_eq_flag,given_is_unit_flag,given_is_double_flag,results_part,usable_cl,xcl,xinf;

  ycl=CDR(given_cl);
  yinf=CAR(given_cl);
  ylitinf=CAR(CDR(CDR(yinf)));
  yclmaxvar=give_cl_maxvar(yinf);
  given_cl_is_nuc_flag=BOOL_F;
  given_cl_is_neg_flag=BOOL_F;
  given_cl_is_final_nuc_flag=BOOL_F;
  given_final_nuc_premiss_lit=EOL;
  given_final_nuc_complfunpure=EOL;
  given_cl_contains_eq_flag=BOOL_F;
  given_is_unit_flag=BOOL_F;
  given_is_double_flag=BOOL_F;
  GLOBAL(used_demodulators_global)=EOL;
  if(NFALSEP(full_nucleus_flag)) {
    ycl=map1(rename_x_to_y_term,ycl);
  }
  else {
    ycl=map1(rename_x_to_y_term,ycl);
  }
  if(NFALSEP(unit_cl_pred_(ycl))) {
    given_is_unit_flag=BOOL_T;
  }
  if(NFALSEP(double_cl_pred_(ycl))) {
    given_is_double_flag=BOOL_T;
  }
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
    if(NFALSEP((NFALSEP(GLOBAL(neg_hyper_strategy_flag_global)) ? negative_cl_pred_(ycl) : positive_cl_pred_(ycl)))) {
      given_cl_is_nuc_flag=BOOL_F;
      if(NFALSEP(contains_eqlit_cl_pred_(ycl))) {
        given_cl_contains_eq_flag=BOOL_T;
      }
      else {
        given_cl_contains_eq_flag=BOOL_F;
      }
    }
    else {
      if(NFALSEP(has_single_hyper_premiss_pred_(ycl))) {
        given_cl_is_final_nuc_flag=BOOL_T;
        given_final_nuc_premiss_lit=first_hyper_premiss_lit(ycl);
        given_final_nuc_complfunpure=MAKINUM(268435456^INUM(MAKINUM(534773760)&CAR(given_final_nuc_premiss_lit)));
      }
      if(NFALSEP(negative_cl_pred_(ycl))) {
        given_cl_is_neg_flag=BOOL_T;
      }
      given_cl_is_nuc_flag=BOOL_T;
    }
  }
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global))&&(NFALSEP(given_cl_is_nuc_flag)&&!(NFALSEP(given_cl_is_final_nuc_flag)))) {
    one_step_results=one_step_for_hyper(cons(CAR(given_cl),ycl));
    for(results_part=one_step_results;!(NULL_P(results_part)||(NFALSEP(GLOBAL(stop_fast_loop_flag_global))||NFALSEP(GLOBAL(foundflag_global))));results_part=CDR(results_part)) {
      GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
      usable_clauses_fast_loop(CAR(results_part),BOOL_F);
    }
  }
  if(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))||(!(NFALSEP(given_cl_is_nuc_flag))||NFALSEP(given_cl_is_final_nuc_flag))) {
    for(usable_clauses_list_part=CDR(GLOBAL(usable_clauses_list_global));!(NULL_P(usable_clauses_list_part)||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));usable_clauses_list_part=CDR(usable_clauses_list_part)) {
      usable_cl=CAR(usable_clauses_list_part);
      xcl=CDR(usable_cl);
      xinf=CAR(usable_cl);
      if(GLOBAL(display_info_level_global)>=MAKINUM(90)) {
        debug_print_xvars(MAKINUM(5));
        debug_print_yvars(MAKINUM(5));
        newline(cur_output_port());
        display(const_309,cur_output_port());
        newline(cur_output_port());
        print_pure_clause(CDR(usable_cl));
        newline(cur_output_port());
        if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
          display(const_310,cur_output_port());
          newline(cur_output_port());
          debug_print_clause(usable_cl);
          newline(cur_output_port());
        }
      }
      if(!(ZERO_P(MAKINUM(65535)&CAR(xinf)))) {
        if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
          if(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))) {
            if(!(NFALSEP(given_cl_is_nuc_flag)&&(!(NFALSEP(given_cl_is_neg_flag))&&NFALSEP(mixed_cl_pred_(xcl)))))
              two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
          }
          else
          if(NFALSEP(given_cl_is_nuc_flag)) {
            if(NFALSEP(positive_cl_pred_(xcl))) {
              if(NULL_P(CDR(xcl))) {
                if(given_final_nuc_complfunpure==(MAKINUM(534773760)&CAR(CAR(xcl))))
                  unit_and_final_nuc_res(xcl,ycl,CAR(xcl),given_final_nuc_premiss_lit,xinf,yinf,ylitinf,yclmaxvar,MAKINUM(1),CAR(CAR(CDR(CDR(xinf)))));
              }
              else
                final_nuc_res(xcl,ycl,given_final_nuc_premiss_lit,xinf,yinf,ylitinf,yclmaxvar,given_final_nuc_complfunpure);
            }
          }
          else
          if(NFALSEP(GLOBAL(type_theory_stratflag_global))) {
            if(NFALSEP(positive_cl_pred_(xcl))) {
              if(NFALSEP(GLOBAL(paramodulation_strategy_flag_global)))
                two_posunits_typet_para(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
            }
            else
              two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
          }
          else
          if(NFALSEP(given_cl_contains_eq_flag))
            two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
          else
          if(NFALSEP(contains_eqorneg_cl_pred_(xcl)))
            two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
        }
        else
        if(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))) {
          if((NFALSEP(given_cl_is_neg_flag)&&!(NFALSEP(negative_cl_pred_(xcl))))||(NFALSEP(negative_cl_pred_(xcl))&&!(NFALSEP(given_cl_is_neg_flag))))
            two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
        }
        else
        if((!(NFALSEP(GLOBAL(unit_strategy_flag_global)))&&!(NFALSEP(GLOBAL(double_strategy_flag_global))))||(NFALSEP(given_is_unit_flag)||(NFALSEP(unit_cl_pred_(xcl))||(NFALSEP(GLOBAL(double_strategy_flag_global))&&(NFALSEP(given_is_double_flag)||NFALSEP(double_cl_pred_(xcl))))))) {
          two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
          if(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(NFALSEP(GLOBAL(paramodulation_strategy_flag_global))&&(NFALSEP(given_is_unit_flag)&&(NFALSEP(unit_cl_pred_(xcl))&&(NFALSEP(positive_cl_pred_(xcl))&&NFALSEP(positive_cl_pred_(ycl)))))))
            two_posunits_typet_para(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar);
        }
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM two_clause_binres_loop(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar)
SCM xcl,ycl,xinf,yinf,ylitinf,yclmaxvar;
{
  SCM res__1,res,xtmp,ytmp,unused,xlitnr,xlitinfpart,xpart,new_var1,ylitcurinf,yfun,ylit,ans_inf,yhistsublist,xhistsublist,distance,history,xlitinf,ypart,ylitinfpart,ylitnr,compl_yfunpure,new_var2,xlit,xfun,condlit,new_var3;

  if(0) {
    newline(cur_output_port());
    display(const_311,cur_output_port());
    newline(cur_output_port());
    debug_print_clause(cons(xinf,xcl));
    debug_print_clause(cons(yinf,ycl));
    newline(cur_output_port());
    display(xinf,cur_output_port());
    newline(cur_output_port());
    newline(cur_output_port());
    display(yinf,cur_output_port());
    newline(cur_output_port());
  }
  xlitinf=CAR(CDR(CDR(xinf)));
  history=EOL;
  distance=EOL;
  xhistsublist=EOL;
  yhistsublist=EOL;
  ans_inf=BOOL_F;
  GLOBAL(used_demodulators_global)=EOL;
  for(ypart=ycl,ylitinfpart=ylitinf,ylitnr=MAKINUM(1);
      !(NULL_P(ypart)||(NFALSEP(GLOBAL(foundflag_global))||(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))&&((GLOBAL(clause_keeplength_limit_global)>MAKINUM(0))&&((INUM(length(ycl))+INUM(length(xcl)))>(1+INUM(GLOBAL(clause_keeplength_limit_global))))))));
      ypart=CDR(ypart),ylitinfpart=CDR(ylitinfpart),ylitnr=MAKINUM(1+INUM(ylitnr))) {
    ylit=CAR(ypart);
    yfun=CAR(ylit);
    ylitcurinf=CAR(ylitinfpart);
    if(!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(ylitcurinf)))) {
      compl_yfunpure=MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun));
      if(NFALSEP(GLOBAL(paramodulation_strategy_flag_global))&&((GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&yfun))&&((!(NFALSEP(GLOBAL(para_unit_strategy_global)))||(NFALSEP(unit_cl_pred_(ycl))&&NFALSEP(unit_cl_pred_(xcl))))&&(!(NFALSEP(GLOBAL(para_pos_unit_strategy_global)))||(NFALSEP(unit_cl_pred_(ycl))&&(NFALSEP(unit_cl_pred_(xcl))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(first_nonans_lit(xcl))))))))))) {
        GLOBAL(used_demodulators_global)=EOL;
        GLOBAL(param_eqlit_global)=ylit;
        GLOBAL(param_tocl_global)=xcl;
        GLOBAL(param_fromcl_global)=ycl;
        GLOBAL(param_tofullinf_global)=xinf;
        GLOBAL(param_fromfullinf_global)=yinf;
        GLOBAL(param_left_arg_global)=CAR(CDR(ylit));
        GLOBAL(param_right_arg_global)=CAR(CDR(CDR(ylit)));
        GLOBAL(param_toinf_global)=xlitinf;
        GLOBAL(param_frominf_global)=ylitinf;
        GLOBAL(param_from_is_y_flag_global)=BOOL_T;
        GLOBAL(param_yclmaxvar_global)=yclmaxvar;
        GLOBAL(param_xclmaxvar_global)=give_cl_maxvar(xinf);
        GLOBAL(param_fromhist_global)=CAR(CDR(CDR(CDR(CDR(CDR(yinf))))));
        GLOBAL(param_tohist_global)=CAR(CDR(CDR(CDR(CDR(CDR(xinf))))));
        GLOBAL(param_fromlitnr_global)=ylitnr;
        new_var1=GLOBAL(root_para_strat_global);
        if(NFALSEP(new_var1))
          param_use_left_flag_global=new_var1;
        else
          param_use_left_flag_global=SBOOL(ZERO_P(MAKINUM(16)&CAR(ylitcurinf)));
        new_var2=GLOBAL(root_para_strat_global);
        if(NFALSEP(new_var2))
          param_use_right_flag_global=new_var2;
        else
          param_use_right_flag_global=SBOOL(ZERO_P(MAKINUM(32)&CAR(ylitcurinf)));
      }
      else {
        GLOBAL(param_eqlit_global)=BOOL_F;
      }
      for(xpart=xcl,xlitinfpart=xlitinf,xlitnr=MAKINUM(1);
          !(NULL_P(xpart)||(NFALSEP(GLOBAL(stop_fast_loop_flag_global))||NFALSEP(GLOBAL(foundflag_global))));
          xpart=CDR(xpart),xlitinfpart=CDR(xlitinfpart),xlitnr=MAKINUM(1+INUM(xlitnr))) {
        xlit=CAR(xpart);
        xfun=CAR(xlit);
        if(!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(CAR(xlitinfpart))))) {
          if(NFALSEP(GLOBAL(param_eqlit_global))&&(ZERO_P(MAKINUM(8)&CAR(CAR(xlitinfpart)))&&(NFALSEP(param_use_left_flag_global)||NFALSEP(param_use_right_flag_global)))) {
            GLOBAL(param_tolit_global)=xlit;
            GLOBAL(param_tolitnr_global)=xlitnr;
            if(!(GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(xlit))))
              paramodulate_into_term(xlit,EOL,BOOL_T);
            else
            if(ZERO_P(MAKINUM(16)&CAR(CAR(xlitinfpart)))&&!(ZERO_P(MAKINUM(32)&CAR(CAR(xlitinfpart)))))
              paramodulate_into_term(CAR(CDR(xlit)),cons(MAKINUM(1),EOL),BOOL_F);
            else
            if(ZERO_P(MAKINUM(32)&CAR(CAR(xlitinfpart)))&&!(ZERO_P(MAKINUM(16)&CAR(CAR(xlitinfpart)))))
              paramodulate_into_term(CAR(CDR(CDR(xlit))),cons(MAKINUM(2),EOL),BOOL_F);
            else
              paramodulate_into_term(xlit,EOL,BOOL_T);
          }
          if(NFALSEP(GLOBAL(paramodulation_strategy_flag_global))&&((GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&xfun))&&(ZERO_P(MAKINUM(8)&CAR(ylitcurinf))&&((!(NFALSEP(GLOBAL(para_unit_strategy_global)))||(NFALSEP(unit_cl_pred_(ycl))&&NFALSEP(unit_cl_pred_(xcl))))&&((!(NFALSEP(GLOBAL(para_pos_unit_strategy_global)))||(NFALSEP(unit_cl_pred_(ycl))&&(NFALSEP(unit_cl_pred_(xcl))&&!(!(ZERO_P(MAKINUM(268435456)&yfun))))))&&((ZERO_P(MAKINUM(16)&CAR(CAR(xlitinfpart)))||ZERO_P(MAKINUM(32)&CAR(CAR(xlitinfpart))))&&!(NFALSEP(GLOBAL(foundflag_global)))))))))
            paramodulate_into_ycl(ylit,xlit,ycl,xcl,yinf,xinf,ylitinf,xlitinf,CAR(xlitinfpart),give_cl_maxvar(xinf),yclmaxvar,CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),ylitnr,xlitnr,ylitcurinf);
          if(compl_yfunpure==(MAKINUM(534773760)&xfun)) {
            if(NFALSEP(resolve_unify_ordinary(xfun,yfun,xlit,ylit))&&!(NFALSEP(GLOBAL(foundflag_global)))) {
              GLOBAL(used_demodulators_global)=EOL;
              unused=UNSPECIFIED;
              ytmp=make_rest_inf_cl(ycl,ylit,CAR(CDR(CDR(yinf))));
              xtmp=make_rest_inf_cl(xcl,xlit,CAR(CDR(CDR(xinf))));
              res=make_raw_inf_cl_pair(CDR(xtmp),CDR(ytmp),CAR(xtmp),CAR(ytmp));
              if(NFALSEP(GLOBAL(classical_synth_stratflag_global))&&(NFALSEP(res)&&NFALSEP(several_answer_literals_pred_(CDR(res))))) {
                if(NFALSEP(xvars_set_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(xlit)))
                  condlit=subst_deco_term_nodemodulate(xlit,BOOL_T);
                else
                  condlit=xlit;
                ans_inf=cons(condlit,cons(MAKINUM(1),cons(give_cl_maxvar(xinf),cons(yclmaxvar,EOL))));
              }
              xhistsublist=CDR(CDR(CDR(CDR(CDR(xinf)))));
              yhistsublist=CDR(CDR(CDR(CDR(CDR(yinf)))));
              if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
                history=make_hyper_history(xcl,ycl,xinf,yinf,CAR(xhistsublist),CAR(yhistsublist),CAR(xlitinfpart),ylitcurinf,xlitnr,ylitnr,BOOL_F);
              }
              else {
                res__1=EOL;
                if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
                  res__1=cons(binary_symb,cons(cons(clinfo_clnr(xinf),cons(xlitnr,EOL)),cons(cons(clinfo_clnr(yinf),cons(ylitnr,EOL)),EOL)));
                  if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
                    res__1=append2(make_demod_history(GLOBAL(used_demodulators_global)),res__1);
                  }
                  history=res__1;
                }
                else
                if(NULL_P(GLOBAL(used_demodulators_global)))
                  history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(xhistsublist),cons(xlitnr,EOL))),cons(cons(literal_symb,cons(CAR(yhistsublist),cons(ylitnr,EOL))),EOL))));
                else
                  history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(xhistsublist),cons(xlitnr,EOL))),cons(cons(literal_symb,cons(CAR(yhistsublist),cons(ylitnr,EOL))),cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL)))));
              }
              if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
                newline(cur_output_port());
                display(const_312,cur_output_port());
                newline(cur_output_port());
                print_pure_clause(xcl);
                newline(cur_output_port());
                print_pure_clause(ycl);
                newline(cur_output_port());
                print_pure_clause(CDR(res));
                newline(cur_output_port());
              }
              clear_y_vars_and_touched_excl_(yclmaxvar);
              clear_x_vars_and_touched_excl_(give_cl_maxvar(xinf));
              new_var3=CAR(CDR(xhistsublist));
              if(NFALSEP(new_var3))
                distance=new_var3;
              else
                distance=CAR(CDR(yhistsublist));
              res=handle_derived_inf_cl_pair(res,history,BOOL_F,ans_inf,distance);
              ans_inf=BOOL_F;
              if(NFALSEP(res)&&(NFALSEP(GLOBAL(factors_stratflag_global))&&!(NFALSEP(GLOBAL(foundflag_global)))))
                factor(CAR(res),CDR(res));
            }
            else {
              if(NFALSEP(yvars_set_flag_global))
                clear_y_vars_excl_(yclmaxvar);
              if(NFALSEP(xvars_set_flag_global))
                clear_x_vars_excl_(give_cl_maxvar(xinf));
            }
          }
        }
      }
    }
  }
  return UNSPECIFIED;
}

SCM final_nuc_res(xcl,ycl,yneglit,xinf,yinf,ylitinf,yclmaxvar,given_final_nuc_complfunpure)
SCM xcl,ycl,yneglit,xinf,yinf,ylitinf,yclmaxvar,given_final_nuc_complfunpure;
{
  SCM xpart,xlitinfpart,xlitnr;

  for(xpart=xcl,xlitinfpart=CAR(CDR(CDR(xinf))),xlitnr=MAKINUM(1);
      !(NULL_P(xpart)||(NFALSEP(GLOBAL(stop_fast_loop_flag_global))||NFALSEP(GLOBAL(foundflag_global))));
      xpart=CDR(xpart),xlitinfpart=CDR(xlitinfpart),xlitnr=MAKINUM(1+INUM(xlitnr)))
    if((given_final_nuc_complfunpure==(MAKINUM(534773760)&CAR(CAR(xpart))))&&!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(CAR(xlitinfpart)))))
      unit_and_final_nuc_res(xcl,ycl,CAR(xpart),yneglit,xinf,yinf,ylitinf,yclmaxvar,xlitnr,CAR(xlitinfpart));
  return UNSPECIFIED;
}

SCM unit_and_final_nuc_res(xcl,ycl,xlit,yneglit,xinf,yinf,ylitinf,yclmaxvar,xlitnr,xcurinf)
SCM xcl,ycl,xlit,yneglit,xinf,yinf,ylitinf,yclmaxvar,xlitnr,xcurinf;
{
  SCM ycurinf,ycurnr,history,res,xtmp,ytmp,unused,ypart,ylitinfpart,ylitnr;

  if(NFALSEP(resolve_unify_ordinary(CAR(xlit),CAR(yneglit),xlit,yneglit))) {
    GLOBAL(used_demodulators_global)=EOL;
    unused=UNSPECIFIED;
    ytmp=make_rest_inf_cl(ycl,yneglit,CAR(CDR(CDR(yinf))));
    xtmp=make_rest_inf_cl(xcl,xlit,CAR(CDR(CDR(xinf))));
    res=make_raw_inf_cl_pair(CDR(xtmp),CDR(ytmp),CAR(xtmp),CAR(ytmp));
    history=EOL;
    ycurnr=MAKINUM(0);
    ycurinf=EOL;
    for(ypart=ycl,ylitinfpart=ylitinf,ylitnr=MAKINUM(1);
        !(CAR(ypart)==yneglit);
        ypart=CDR(ypart),ylitinfpart=CDR(ylitinfpart),ylitnr=MAKINUM(1+INUM(ylitnr))) ;
    ycurnr=ylitnr;
    ycurinf=CAR(ylitinfpart);
    history=make_hyper_history(xcl,ycl,xinf,yinf,CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),xcurinf,ycurinf,xlitnr,ycurnr,BOOL_F);
    if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
      newline(cur_output_port());
      display(const_313,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(xcl);
      newline(cur_output_port());
      print_pure_clause(ycl);
      newline(cur_output_port());
      print_pure_clause(CDR(res));
      newline(cur_output_port());
    }
    clear_y_vars_and_touched_excl_(yclmaxvar);
    clear_x_vars_and_touched_excl_(give_cl_maxvar(xinf));
    res=handle_derived_inf_cl_pair(res,history,BOOL_F,BOOL_F,BOOL_F);
    if(NFALSEP(res)&&(NFALSEP(GLOBAL(factors_stratflag_global))&&!(NFALSEP(GLOBAL(foundflag_global)))))
      return factor(CAR(res),CDR(res));
    else
      return UNSPECIFIED;
  }
  else {
    if(NFALSEP(yvars_set_flag_global))
      clear_y_vars_excl_(yclmaxvar);
    if(NFALSEP(xvars_set_flag_global))
      return clear_x_vars_excl_(give_cl_maxvar(xinf));
    else
      return UNSPECIFIED;
  }
}

SCM two_posunits_typet_para(xcl,ycl,xinf,yinf,ylitinf,yclmaxvar)
SCM xcl,ycl,xinf,yinf,ylitinf,yclmaxvar;
{
  SCM xlitinf,history,ylitnr,ylit,ylitcurinf,xlitnr,xlit,xlitcurinf;

  xlitinf=CAR(CDR(CDR(xinf)));
  history=EOL;
  ylitnr=MAKINUM(1);
  ylit=CAR(ycl);
  ylitcurinf=CAR(ylitinf);
  xlitnr=MAKINUM(1);
  xlit=CAR(xcl);
  xlitcurinf=CAR(xlitinf);
  if(!(NUMBER_P(CAR(CDR(ylit))))&&((GLOBAL(eq_fun_nr_global)==(MAKINUM(534773760)&CAR(CAR(CDR(ylit)))))&&(ZERO_P(MAKINUM(8)&CAR(xlitcurinf))&&(ZERO_P(MAKINUM(16)&CAR(ylitcurinf))||ZERO_P(MAKINUM(32)&CAR(ylitcurinf)))))) {
    GLOBAL(param_tolit_global)=xlit;
    GLOBAL(param_eqlit_global)=ylit;
    GLOBAL(param_tocl_global)=xcl;
    GLOBAL(param_fromcl_global)=ycl;
    GLOBAL(param_left_arg_global)=CAR(CDR(CAR(CDR(ylit))));
    GLOBAL(param_right_arg_global)=CAR(CDR(CDR(CAR(CDR(ylit)))));
    GLOBAL(param_toinf_global)=xlitinf;
    GLOBAL(param_frominf_global)=ylitinf;
    GLOBAL(param_from_is_y_flag_global)=BOOL_T;
    GLOBAL(param_yclmaxvar_global)=yclmaxvar;
    GLOBAL(param_xclmaxvar_global)=give_cl_maxvar(xinf);
    GLOBAL(param_fromhist_global)=CAR(CDR(CDR(CDR(CDR(CDR(yinf))))));
    GLOBAL(param_tohist_global)=CAR(CDR(CDR(CDR(CDR(CDR(xinf))))));
    GLOBAL(param_fromlitnr_global)=ylitnr;
    GLOBAL(param_tolitnr_global)=xlitnr;
    param_use_left_flag_global=SBOOL(ZERO_P(MAKINUM(16)&CAR(ylitcurinf)));
    param_use_right_flag_global=SBOOL(ZERO_P(MAKINUM(32)&CAR(ylitcurinf)));
    paramodulate_into_term(xlit,EOL,BOOL_T);
  }
  if(!(NUMBER_P(CAR(CDR(xlit))))&&((GLOBAL(eq_fun_nr_global)==(MAKINUM(534773760)&CAR(CAR(CDR(xlit)))))&&(ZERO_P(MAKINUM(8)&CAR(ylitcurinf))&&(ZERO_P(MAKINUM(16)&CAR(xlitcurinf))||ZERO_P(MAKINUM(32)&CAR(xlitcurinf)))))) {
    GLOBAL(param_tolit_global)=ylit;
    GLOBAL(param_eqlit_global)=xlit;
    GLOBAL(param_tocl_global)=ycl;
    GLOBAL(param_fromcl_global)=xcl;
    GLOBAL(param_left_arg_global)=CAR(CDR(CAR(CDR(xlit))));
    GLOBAL(param_right_arg_global)=CAR(CDR(CDR(CAR(CDR(xlit)))));
    GLOBAL(param_toinf_global)=ylitinf;
    GLOBAL(param_frominf_global)=xlitinf;
    GLOBAL(param_from_is_y_flag_global)=BOOL_F;
    GLOBAL(param_yclmaxvar_global)=yclmaxvar;
    GLOBAL(param_xclmaxvar_global)=give_cl_maxvar(xinf);
    GLOBAL(param_fromhist_global)=CAR(CDR(CDR(CDR(CDR(CDR(xinf))))));
    GLOBAL(param_tohist_global)=CAR(CDR(CDR(CDR(CDR(CDR(yinf))))));
    GLOBAL(param_fromlitnr_global)=xlitnr;
    GLOBAL(param_tolitnr_global)=ylitnr;
    param_use_left_flag_global=SBOOL(ZERO_P(MAKINUM(16)&CAR(xlitcurinf)));
    param_use_right_flag_global=SBOOL(ZERO_P(MAKINUM(32)&CAR(xlitcurinf)));
    return paramodulate_into_term(ylit,EOL,BOOL_T);
  }
  else
    return UNSPECIFIED;
}

SCM one_step_for_hyper(fullycl)
SCM fullycl;
{
  SCM history,res__1,xtmp,ytmp,unused,usable_list_part,success_nr,tmp,res,ynegpurefun,yfun,yclmaxvar,ylitinf,xinf,xcl,fullxcl,yinf,ycl,negfun,ylit,locresults,results,min_nr,ypart,ylitinfpart,ylitnr,xclpart,xlitinfpart,xlitnr,res__2;

  GLOBAL(one_step_hyper_phase_global)=BOOL_T;
  min_nr=MAKINUM(999999);
  results=EOL;
  locresults=EOL;
  ylit=EOL;
  negfun=EOL;
  ycl=CDR(fullycl);
  yinf=CAR(fullycl);
  fullxcl=EOL;
  xcl=EOL;
  xinf=EOL;
  ylitinf=CAR(CDR(CDR(yinf)));
  yclmaxvar=give_cl_maxvar(yinf);
  yfun=EOL;
  ynegpurefun=EOL;
  res=EOL;
  tmp=EOL;
  success_nr=MAKINUM(0);
  yvars_set_flag_global=BOOL_F;
  xvars_set_flag_global=BOOL_F;
  for(ypart=ycl,ylitinfpart=CAR(CDR(CDR(yinf))),ylitnr=MAKINUM(1);
      !(NULL_P(ypart)||(NFALSEP(GLOBAL(foundflag_global))||ZERO_P(min_nr)));
      ypart=CDR(ypart),ylitinfpart=CDR(ylitinfpart),ylitnr=MAKINUM(1+INUM(ylitnr)))
    if(NFALSEP(GLOBAL(unit_clash_flag_global))||!(ZERO_P(MAKINUM(268435456)&CAR(CAR(ypart))))) {
      success_nr=MAKINUM(0);
      ylit=CAR(ypart);
      yfun=CAR(ylit);
      ynegpurefun=MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun));
      for(usable_list_part=(NFALSEP(GLOBAL(unit_clash_flag_global)) ? (tmp=assq(ynegpurefun,GLOBAL(unit_alist_global)),UNSPECIFIED,(NFALSEP(tmp) ? CDR(tmp) : EOL)) : CDR(GLOBAL(usable_clauses_list_global)));!(NULL_P(usable_list_part)||(NFALSEP(GLOBAL(foundflag_global))||(NFALSEP(GLOBAL(stop_fast_loop_flag_global))||(success_nr>=min_nr))));usable_list_part=CDR(usable_list_part)) {
        fullxcl=CAR(usable_list_part);
        xinf=CAR(fullxcl);
        xcl=CDR(fullxcl);
        if(!(ZERO_P(MAKINUM(63488)&CAR(xinf)))&&(NFALSEP(GLOBAL(unit_clash_flag_global))||NFALSEP(positive_cl_pred_(xcl)))) {
          for(xclpart=xcl,xlitinfpart=CAR(CDR(CDR(xinf))),xlitnr=MAKINUM(1);
              !(NULL_P(xclpart)||NFALSEP(GLOBAL(foundflag_global)));
              xclpart=CDR(xclpart),xlitinfpart=CDR(xlitinfpart),xlitnr=MAKINUM(1+INUM(xlitnr)))
            if(((MAKINUM(534773760)&CAR(CAR(xclpart)))==ynegpurefun)&&(!(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&CAR(CAR(xlitinfpart))))&&NFALSEP(resolve_unify_ordinary(CAR(CAR(xclpart)),yfun,CAR(xclpart),ylit)))) {
              GLOBAL(used_demodulators_global)=EOL;
              unused=UNSPECIFIED;
              ytmp=make_rest_inf_cl(ycl,ylit,CAR(CDR(CDR(yinf))));
              xtmp=make_rest_inf_cl(xcl,CAR(xclpart),CAR(CDR(CDR(xinf))));
              res__1=make_raw_inf_cl_pair(CDR(xtmp),CDR(ytmp),CAR(xtmp),CAR(ytmp));
              history=EOL;
              if(NFALSEP(GLOBAL(unit_clash_flag_global))) {
                res__2=EOL;
                if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
                  res__2=cons(binary_symb,cons(cons(clinfo_clnr(xinf),cons(xlitnr,EOL)),cons(cons(clinfo_clnr(yinf),cons(ylitnr,EOL)),EOL)));
                  if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
                    res__2=append2(make_demod_history(GLOBAL(used_demodulators_global)),res__2);
                  }
                  history=res__2;
                }
                else
                if(NULL_P(GLOBAL(used_demodulators_global)))
                  history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),cons(xlitnr,EOL))),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),cons(ylitnr,EOL))),EOL))));
                else
                  history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),cons(xlitnr,EOL))),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),cons(ylitnr,EOL))),cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL)))));
              }
              else
                history=make_hyper_history(xcl,ycl,xinf,yinf,CAR(CDR(CDR(CDR(CDR(CDR(xinf)))))),CAR(CDR(CDR(CDR(CDR(CDR(yinf)))))),CAR(xlitinfpart),CAR(ylitinfpart),xlitnr,ylitnr,BOOL_F);
              if(GLOBAL(display_info_level_global)>=MAKINUM(110)) {
                newline(cur_output_port());
                display(const_314,cur_output_port());
                newline(cur_output_port());
                debug_print_yvars(yclmaxvar);
                debug_print_xvars(give_cl_maxvar(xinf));
                newline(cur_output_port());
                display(const_315,cur_output_port());
                newline(cur_output_port());
                print_pure_clause(xcl);
                newline(cur_output_port());
                print_pure_clause(ycl);
                newline(cur_output_port());
                print_pure_clause(CDR(res__1));
                newline(cur_output_port());
              }
              clear_y_vars_and_touched_excl_(yclmaxvar);
              clear_x_vars_and_touched_excl_(give_cl_maxvar(xinf));
              res__1=handle_derived_inf_cl_pair(res__1,history,BOOL_F,BOOL_F,BOOL_F);
              if(NFALSEP(res__1)) {
                success_nr=MAKINUM(1+INUM(success_nr));
                locresults=cons(res__1,locresults);
              }
            }
            else {
              if(NFALSEP(yvars_set_flag_global))
                clear_y_vars_excl_(yclmaxvar);
              if(NFALSEP(xvars_set_flag_global))
                clear_x_vars_excl_(give_cl_maxvar(xinf));
            }
        }
      }
      if(success_nr<min_nr) {
        min_nr=success_nr;
        results=locresults;
      }
    }
  GLOBAL(one_step_hyper_phase_global)=BOOL_F;
  return results;
}

SCM make_hyper_history(xcl,ycl,xinf,yinf,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr,chain)
SCM xcl,ycl,xinf,yinf,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr,chain;
{
  SCM x,res,tmp;

  x=EOL;
  res=EOL;
  tmp=make_hyper_history_aux(xcl,ycl,xinf,yinf,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr);
  chain=BOOL_F;
  if(NFALSEP(chain)) {
    tmp=append2(cons(chain_symb,CDR(chain)),tmp);
  }
  if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
    if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
      tmp=append2(make_demod_history(GLOBAL(used_demodulators_global)),tmp);
    }
    else {
      x=my_last_pair(tmp);
      SET_CDR(x,cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL));
    }
    res=tmp;
  }
  else {
    res=tmp;
  }
  return res;
}

SCM make_hyper_history_aux(xcl,ycl,xinf,yinf,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr)
SCM xcl,ycl,xinf,yinf,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr;
{
  if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
    if(!(NFALSEP(positive_cl_pred_(ycl)))&&NFALSEP(memq(hyper_symb,yhist)))
      return append2(yhist,cons(clinfo_clnr(xinf),EOL));
    else
    if(!(NFALSEP(positive_cl_pred_(xcl)))&&NFALSEP(memq(hyper_symb,xhist)))
      return append2(xhist,cons(clinfo_clnr(yinf),EOL));
    else
      return cons(hyper_symb,cons((NFALSEP(positive_cl_pred_(xcl)) ? clinfo_clnr(yinf) : clinfo_clnr(xinf)),cons((NFALSEP(positive_cl_pred_(xcl)) ? clinfo_clnr(xinf) : clinfo_clnr(yinf)),EOL)));
  }
  else
    return make_hyper_history_aux_complex(xcl,ycl,xinf,yinf,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr);
}

SCM make_hyper_history_aux_complex(xcl,ycl,xinf,yinf,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr)
SCM xcl,ycl,xinf,yinf,xhist,yhist,xlitcurinf,ylitcurinf,xlitnr,ylitnr;
{
  SCM res,res__1;

  if(NFALSEP(positive_cl_pred_(xcl))) {
    if(NULL_P(xhist)||(NULL_P(yhist)||((binary_symb==CAR(yhist))||((binres_symb==CAR(yhist))||((binres_demod_symb==CAR(yhist))||((para_symb==CAR(yhist))||(factor_symb==CAR(yhist)))))))) {
      res=EOL;
      if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
        res=cons(binary_symb,cons(cons(clinfo_clnr(xinf),cons(xlitnr,EOL)),cons(cons(clinfo_clnr(yinf),cons(ylitnr,EOL)),EOL)));
        if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
          res=append2(make_demod_history(GLOBAL(used_demodulators_global)),res);
        }
        return res;
      }
      else
      if(NULL_P(GLOBAL(used_demodulators_global)))
        return cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),EOL))));
      else
        return cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL)))));
    }
    else {
      if(ZERO_P(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(ylitcurinf))>>16))) {
        if(NFALSEP(fresh_nucleus_hist_pred_(yhist)))
          return cons(hyper_symb,cons(MAKINUM(0),cons(yhist,cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),EOL))));
        else {
          SET_CDR(CDR(CDR(yhist)),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),CDR(CDR(CDR(yhist)))));
          return yhist;
        }
      }
      else {
        return replace_nth((NFALSEP(fresh_nucleus_hist_pred_(yhist)) ? cons(hyper_symb,cons(MAKINUM(0),cons(yhist,make_null_neg_list(ycl)))) : yhist),MAKINUM(3+(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(ylitcurinf))>>16)),cons(literal_symb,cons(xhist,cons(xlitnr,EOL))));
      }
    }
  }
  else
  if(NULL_P(xhist)||(NULL_P(yhist)||((binary_symb==CAR(xhist))||((binres_symb==CAR(xhist))||((binres_demod_symb==CAR(xhist))||((para_symb==CAR(xhist))||(factor_symb==CAR(xhist)))))))) {
    res__1=EOL;
    if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
      res__1=cons(binary_symb,cons(cons(clinfo_clnr(xinf),cons(xlitnr,EOL)),cons(cons(clinfo_clnr(yinf),cons(ylitnr,EOL)),EOL)));
      if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
        res__1=append2(make_demod_history(GLOBAL(used_demodulators_global)),res__1);
      }
      return res__1;
    }
    else
    if(NULL_P(GLOBAL(used_demodulators_global)))
      return cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),EOL))));
    else
      return cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL)))));
  }
  else {
    if(ZERO_P(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(xlitcurinf))>>16))) {
      if(NFALSEP(fresh_nucleus_hist_pred_(xhist)))
        return cons(hyper_symb,cons(MAKINUM(0),cons(xhist,cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),EOL))));
      else {
        SET_CDR(CDR(CDR(xhist)),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),CDR(CDR(CDR(xhist)))));
        return yhist;
      }
    }
    else {
      return replace_nth((NFALSEP(fresh_nucleus_hist_pred_(xhist)) ? cons(hyper_symb,cons(MAKINUM(0),cons(xhist,make_null_neg_list(xcl)))) : xhist),MAKINUM(3+(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(xlitcurinf))>>16)),cons(literal_symb,cons(yhist,cons(ylitnr,EOL))));
    }
  }
}

SCM make_binres_history(xcl,ycl,xinf,yinf,xhist,yhist,xlitnr,ylitnr,chain)
SCM xcl,ycl,xinf,yinf,xhist,yhist,xlitnr,ylitnr,chain;
{
  SCM res;

  res=EOL;
  if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
    res=cons(binary_symb,cons(cons(clinfo_clnr(xinf),cons(xlitnr,EOL)),cons(cons(clinfo_clnr(yinf),cons(ylitnr,EOL)),EOL)));
    if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
      res=append2(make_demod_history(GLOBAL(used_demodulators_global)),res);
    }
    return res;
  }
  else
  if(NULL_P(GLOBAL(used_demodulators_global)))
    return cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),EOL))));
  else
    return cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(xhist,cons(xlitnr,EOL))),cons(cons(literal_symb,cons(yhist,cons(ylitnr,EOL))),cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL)))));
}

SCM make_demod_history(demodlst)
SCM demodlst;
{
  if(NFALSEP(GLOBAL(simple_history_stratflag_global)))
    return cons(demod_symb,map1(make_demod_history_fn250,demodlst));
  else
    return cons(demod_symb,demodlst);
}

SCM make_demod_history_fn250(x)
SCM x;
{
  return clinfo_clnr(CAR(x));
}

SCM make_chain_history_for_resolution(xcl,ycl,xlitnr,ylitnr)
SCM xcl,ycl,xlitnr,ylitnr;
{
  SCM xlit,ylit;

  xlit=CAR(nth_cdr(MAKINUM(INUM(xlitnr)-1),xcl));
  ylit=CAR(nth_cdr(MAKINUM(INUM(ylitnr)-1),ycl));
  if((MAKINUM(534773760)&CAR(xlit))==MAKINUM(268435456^INUM(MAKINUM(534773760)&CAR(ylit))))
    return EOL;
  else
    return EOL;
}

SCM fresh_nucleus_hist_pred_(hist)
SCM hist;
{
  if(PAIR_P(hist))
    return SBOOL(input_symb==CAR(hist));
  else
    return BOOL_F;
}

SCM make_null_neg_list(nuc)
SCM nuc;
{
  SCM res,nucpart;

  res=EOL;
  for(nucpart=nuc;!(NULL_P(nucpart));nucpart=CDR(nucpart))
    if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(nucpart))))) {
      res=cons(EOL,res);
    }
  return res;
}

SCM paramodulate_into_ycl(tolit,eqlit,tocl,fromcl,tofullinf,fromfullinf,toinf,frominf,curfrominf,xclmaxvar,yclmaxvar,yhist,xhist,ylitnr,xlitnr,ylitinf)
SCM tolit,eqlit,tocl,fromcl,tofullinf,fromfullinf,toinf,frominf,curfrominf,xclmaxvar,yclmaxvar,yhist,xhist,ylitnr,xlitnr,ylitinf;
{
  SCM tmp_tolit,tmp_eqlit,tmp_tocl,tmp_fromcl,tmp_tofullinf,tmp_fromfullinf,tmp_left_arg,tmp_right_arg,tmp_use_left_flag,tmp_use_right_flag,tmp_toinf,tmp_frominf,tmp_from_is_y_flag,tmp_fromhist,tmp_tohist,tmp_fromlitnr,tmp_tolitnr;

  tmp_tolit=GLOBAL(param_tolit_global);
  tmp_eqlit=GLOBAL(param_eqlit_global);
  tmp_tocl=GLOBAL(param_tocl_global);
  tmp_fromcl=GLOBAL(param_fromcl_global);
  tmp_tofullinf=GLOBAL(param_tofullinf_global);
  tmp_fromfullinf=GLOBAL(param_fromfullinf_global);
  tmp_left_arg=GLOBAL(param_left_arg_global);
  tmp_right_arg=GLOBAL(param_right_arg_global);
  tmp_use_left_flag=param_use_left_flag_global;
  tmp_use_right_flag=param_use_right_flag_global;
  tmp_toinf=GLOBAL(param_toinf_global);
  tmp_frominf=GLOBAL(param_frominf_global);
  tmp_from_is_y_flag=GLOBAL(param_from_is_y_flag_global);
  tmp_fromhist=GLOBAL(param_fromhist_global);
  tmp_tohist=GLOBAL(param_tohist_global);
  tmp_fromlitnr=GLOBAL(param_fromlitnr_global);
  tmp_tolitnr=GLOBAL(param_tolitnr_global);
  GLOBAL(used_demodulators_global)=EOL;
  GLOBAL(param_tolit_global)=tolit;
  GLOBAL(param_eqlit_global)=eqlit;
  GLOBAL(param_tocl_global)=tocl;
  GLOBAL(param_fromcl_global)=fromcl;
  GLOBAL(param_tofullinf_global)=tofullinf;
  GLOBAL(param_fromfullinf_global)=fromfullinf;
  GLOBAL(param_left_arg_global)=CAR(CDR(eqlit));
  GLOBAL(param_right_arg_global)=CAR(CDR(CDR(eqlit)));
  param_use_left_flag_global=SBOOL(ZERO_P(MAKINUM(16)&CAR(curfrominf)));
  param_use_right_flag_global=SBOOL(ZERO_P(MAKINUM(32)&CAR(curfrominf)));
  GLOBAL(param_toinf_global)=toinf;
  GLOBAL(param_frominf_global)=frominf;
  GLOBAL(param_xclmaxvar_global)=xclmaxvar;
  GLOBAL(param_yclmaxvar_global)=yclmaxvar;
  GLOBAL(param_from_is_y_flag_global)=BOOL_F;
  GLOBAL(param_fromhist_global)=xhist;
  GLOBAL(param_tohist_global)=yhist;
  GLOBAL(param_fromlitnr_global)=xlitnr;
  GLOBAL(param_tolitnr_global)=ylitnr;
  if(!(GLOBAL(eq_pred_nr_global)==(MAKINUM(534773760)&CAR(tolit))))
    paramodulate_into_term(tolit,EOL,BOOL_T);
  else
  if(ZERO_P(MAKINUM(16)&CAR(ylitinf))&&!(ZERO_P(MAKINUM(32)&CAR(ylitinf))))
    paramodulate_into_term(CAR(CDR(tolit)),cons(MAKINUM(1),EOL),BOOL_F);
  else
  if(ZERO_P(MAKINUM(32)&CAR(ylitinf))&&!(ZERO_P(MAKINUM(16)&CAR(ylitinf))))
    paramodulate_into_term(CAR(CDR(CDR(tolit))),cons(MAKINUM(2),EOL),BOOL_F);
  else
    paramodulate_into_term(tolit,EOL,BOOL_T);
  GLOBAL(param_tolit_global)=tmp_tolit;
  GLOBAL(param_eqlit_global)=tmp_eqlit;
  GLOBAL(param_tocl_global)=tmp_tocl;
  GLOBAL(param_fromcl_global)=tmp_fromcl;
  GLOBAL(param_left_arg_global)=tmp_left_arg;
  GLOBAL(param_right_arg_global)=tmp_right_arg;
  param_use_left_flag_global=tmp_use_left_flag;
  param_use_right_flag_global=tmp_use_right_flag;
  GLOBAL(param_toinf_global)=tmp_toinf;
  GLOBAL(param_frominf_global)=tmp_frominf;
  GLOBAL(param_from_is_y_flag_global)=tmp_from_is_y_flag;
  GLOBAL(param_fromhist_global)=tmp_fromhist;
  GLOBAL(param_tohist_global)=tmp_tohist;
  GLOBAL(param_fromlitnr_global)=tmp_fromlitnr;
  GLOBAL(param_tolitnr_global)=tmp_tolitnr;
  return UNSPECIFIED;
}

SCM paramodulate_into_term(term,path,litflag)
SCM term,path,litflag;
{
  SCM new_var2,nr,termpart,new_var5,new_var4,new_var6,new_var1,new_var3;

  if(!(NUMBER_P(term))) {
    if(NFALSEP(param_use_left_flag_global)) {
      new_var4=litflag;
      if(NFALSEP(new_var4)) ;
      else
      if(!(NUMBER_P(GLOBAL(param_left_arg_global)))) {
        if((MAKINUM(534773760)&CAR(term))==(MAKINUM(534773760)&CAR(GLOBAL(param_left_arg_global)))) {
          GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_T;
          if(NFALSEP((NFALSEP(GLOBAL(param_from_is_y_flag_global)) ? resolve_unify_ordinary(CAR(term),CAR(GLOBAL(param_left_arg_global)),term,GLOBAL(param_left_arg_global)) : resolve_unify_ordinary(CAR(GLOBAL(param_left_arg_global)),CAR(term),GLOBAL(param_left_arg_global),term))))
            paramodulate_into_term_aux(path,GLOBAL(param_right_arg_global),BOOL_T);
          else {
            GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
            if(NFALSEP(yvars_set_flag_global))
              clear_y_vars_and_touched_excl_(GLOBAL(param_yclmaxvar_global));
            if(NFALSEP(xvars_set_flag_global))
              clear_x_vars_and_touched_excl_(GLOBAL(param_xclmaxvar_global));
          }
        }
      }
      else
      if(NFALSEP(GLOBAL(paramodulate_from_vars_stratflag_global))&&(MAKINUM(65535)>GLOBAL(param_left_arg_global))) {
        STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_left_arg_global),term);
        if(ZERO_P(MAKINUM(256)&GLOBAL(param_left_arg_global))) {
          xvars_set_flag_global=BOOL_T;
          yvars_set_flag_global=BOOL_F;
        }
        else {
          xvars_set_flag_global=BOOL_F;
          yvars_set_flag_global=BOOL_T;
        }
        paramodulate_into_term_aux(path,GLOBAL(param_right_arg_global),BOOL_T);
      }
    }
    if(NFALSEP(param_use_right_flag_global)) {
      new_var5=litflag;
      if(NFALSEP(new_var5)) ;
      else {
        new_var6=GLOBAL(foundflag_global);
        if(NFALSEP(new_var6)) ;
        else
        if(!(NUMBER_P(GLOBAL(param_right_arg_global)))) {
          if((MAKINUM(534773760)&CAR(term))==(MAKINUM(534773760)&CAR(GLOBAL(param_right_arg_global)))) {
            GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_T;
            if(NFALSEP((NFALSEP(GLOBAL(param_from_is_y_flag_global)) ? resolve_unify_ordinary(CAR(term),CAR(GLOBAL(param_right_arg_global)),term,GLOBAL(param_right_arg_global)) : resolve_unify_ordinary(CAR(GLOBAL(param_right_arg_global)),CAR(term),GLOBAL(param_right_arg_global),term))))
              paramodulate_into_term_aux(path,GLOBAL(param_left_arg_global),BOOL_F);
            else {
              GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
              if(NFALSEP(yvars_set_flag_global))
                clear_y_vars_and_touched_excl_(GLOBAL(param_yclmaxvar_global));
              if(NFALSEP(xvars_set_flag_global))
                clear_x_vars_and_touched_excl_(GLOBAL(param_xclmaxvar_global));
            }
          }
        }
        else
        if(NFALSEP(GLOBAL(paramodulate_from_vars_stratflag_global))&&(MAKINUM(65535)>GLOBAL(param_right_arg_global))) {
          STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_right_arg_global),term);
          if(ZERO_P(MAKINUM(256)&GLOBAL(param_right_arg_global))) {
            xvars_set_flag_global=BOOL_T;
            yvars_set_flag_global=BOOL_F;
          }
          else {
            xvars_set_flag_global=BOOL_F;
            yvars_set_flag_global=BOOL_T;
          }
          paramodulate_into_term_aux(path,GLOBAL(param_left_arg_global),BOOL_F);
        }
      }
    }
    if(!(NFALSEP(GLOBAL(foundflag_global)))) {
      for(termpart=CDR(term),nr=MAKINUM(1);
          !(NULL_P(termpart));
          termpart=CDR(termpart),nr=MAKINUM(1+INUM(nr)))
        paramodulate_into_term(CAR(termpart),cons(nr,path),BOOL_F);
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
  else {
    new_var1=SBOOL(MAKINUM(65535)>term);
    if(NFALSEP(new_var1))
      return new_var1;
    else {
      new_var2=SBOOL(term>=MAKINUM(200000));
      if(NFALSEP(new_var2))
        return new_var2;
      else {
        if(NFALSEP(param_use_left_flag_global)) {
          if(NFALSEP(GLOBAL(paramodulate_from_vars_stratflag_global))&&(NUMBER_P(GLOBAL(param_left_arg_global))&&(GLOBAL(param_left_arg_global)<=MAKINUM(65535)))) {
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_left_arg_global),term);
            if(ZERO_P(MAKINUM(256)&GLOBAL(param_left_arg_global))) {
              xvars_set_flag_global=BOOL_T;
              yvars_set_flag_global=BOOL_F;
            }
            else {
              xvars_set_flag_global=BOOL_F;
              yvars_set_flag_global=BOOL_T;
            }
            paramodulate_into_term_aux(path,GLOBAL(param_right_arg_global),BOOL_T);
          }
          else
          if(GLOBAL(param_left_arg_global)==term) {
            xvars_set_flag_global=BOOL_F;
            yvars_set_flag_global=BOOL_F;
            paramodulate_into_term_aux(path,GLOBAL(param_right_arg_global),BOOL_T);
          }
        }
        if(NFALSEP(param_use_right_flag_global)) {
          new_var3=GLOBAL(foundflag_global);
          if(NFALSEP(new_var3))
            return new_var3;
          else
          if(NFALSEP(GLOBAL(paramodulate_from_vars_stratflag_global))&&(NUMBER_P(GLOBAL(param_right_arg_global))&&(GLOBAL(param_right_arg_global)<=MAKINUM(65535)))) {
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_right_arg_global),term);
            if(ZERO_P(MAKINUM(256)&GLOBAL(param_right_arg_global))) {
              xvars_set_flag_global=BOOL_T;
              yvars_set_flag_global=BOOL_F;
            }
            else {
              xvars_set_flag_global=BOOL_F;
              yvars_set_flag_global=BOOL_T;
            }
            return paramodulate_into_term_aux(path,GLOBAL(param_left_arg_global),BOOL_F);
          }
          else
          if(GLOBAL(param_right_arg_global)==term) {
            xvars_set_flag_global=BOOL_F;
            yvars_set_flag_global=BOOL_F;
            return paramodulate_into_term_aux(path,GLOBAL(param_left_arg_global),BOOL_F);
          }
          else
            return UNSPECIFIED;
        }
        else
          return UNSPECIFIED;
      }
    }
  }
}

SCM paramodulate_into_term_aux(path,replterm,left_used_flag)
SCM path,replterm,left_used_flag;
{
  SCM condlit,newlit,tmpto,tmpfrom,res,history,distance,ans_inf,new_var1;

  GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
  GLOBAL(used_demodulators_global)=EOL;
  newlit=subst_deco_replace_term(GLOBAL(param_tolit_global),reverse(path),replterm,BOOL_T);
  tmpto=make_rest_inf_cl(GLOBAL(param_tocl_global),GLOBAL(param_tolit_global),GLOBAL(param_toinf_global));
  tmpfrom=make_rest_inf_cl(GLOBAL(param_fromcl_global),GLOBAL(param_eqlit_global),GLOBAL(param_frominf_global));
  res=EOL;
  history=EOL;
  distance=EOL;
  ans_inf=BOOL_F;
  if(!(NFALSEP(newlit)))
    return BOOL_F;
  else {
    if(NFALSEP(GLOBAL(param_from_is_y_flag_global))) {
      res=make_raw_inf_cl_pair(CDR(tmpto),CDR(tmpfrom),CAR(tmpto),CAR(tmpfrom));
    }
    else {
      res=make_raw_inf_cl_pair(CDR(tmpfrom),CDR(tmpto),CAR(tmpfrom),CAR(tmpto));
    }
    if(NFALSEP(GLOBAL(classical_synth_stratflag_global))&&(NFALSEP(res)&&NFALSEP(several_answer_literals_pred_(CDR(res))))) {
      if((NFALSEP(GLOBAL(param_from_is_y_flag_global))&&(NFALSEP(xvars_set_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(GLOBAL(param_tolit_global)))))||(!(NFALSEP(GLOBAL(param_from_is_y_flag_global)))&&(NFALSEP(yvars_set_flag_global)&&ZERO_P(MAKINUM(65536)&CAR(GLOBAL(param_tolit_global))))))
        condlit=subst_deco_term_nodemodulate(GLOBAL(param_tolit_global),BOOL_T);
      else
        condlit=GLOBAL(param_tolit_global);
      if(NFALSEP(GLOBAL(param_from_is_y_flag_global))) {
        ans_inf=cons(condlit,cons(MAKINUM(1),cons(GLOBAL(param_xclmaxvar_global),cons(GLOBAL(param_yclmaxvar_global),EOL))));
      }
      else {
        ans_inf=cons(condlit,cons(MAKINUM(1),cons(GLOBAL(param_xclmaxvar_global),cons(GLOBAL(param_yclmaxvar_global),EOL))));
      }
    }
    clear_y_vars_and_touched_excl_(GLOBAL(param_yclmaxvar_global));
    clear_x_vars_and_touched_excl_(GLOBAL(param_xclmaxvar_global));
    if(!(NFALSEP(res)))
      return BOOL_F;
    else {
      res=cons(cons(cons(BOOL_T,cons(BOOL_F,cons(MAKINUM(0),EOL))),CAR(res)),cons(newlit,CDR(res)));
      if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
        history=cons(para_symb,cons(cons(clinfo_clnr(GLOBAL(param_fromfullinf_global)),cons(GLOBAL(param_fromlitnr_global),EOL)),cons(cons(clinfo_clnr(GLOBAL(param_tofullinf_global)),cons(GLOBAL(param_tolitnr_global),cons(left_used_flag,cons(path,EOL)))),EOL)));
        if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
          history=append2(make_demod_history(GLOBAL(used_demodulators_global)),history);
        }
      }
      else
      if(NULL_P(GLOBAL(used_demodulators_global))) {
        history=cons(para_symb,cons(MAKINUM(0),cons(GLOBAL(param_fromhist_global),cons(GLOBAL(param_tohist_global),cons(GLOBAL(param_fromlitnr_global),cons(GLOBAL(param_tolitnr_global),cons(left_used_flag,cons(reverse(path),EOL))))))));
      }
      else {
        history=cons(para_symb,cons(MAKINUM(0),cons(GLOBAL(param_fromhist_global),cons(GLOBAL(param_tohist_global),cons(GLOBAL(param_fromlitnr_global),cons(GLOBAL(param_tolitnr_global),cons(left_used_flag,cons(reverse(path),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL)))))))));
      }
      if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
        display(const_316,cur_output_port());
        display(const_317,cur_output_port());
        newline(cur_output_port());
        print_pure_clause(GLOBAL(param_tocl_global));
        newline(cur_output_port());
        print_pure_clause(GLOBAL(param_fromcl_global));
        newline(cur_output_port());
        display(GLOBAL(param_tocl_global),cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(param_fromcl_global),cur_output_port());
        newline(cur_output_port());
        if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
          print_lit(GLOBAL(param_eqlit_global));
        else
          print_lit(GLOBAL(param_eqlit_global));
        newline(cur_output_port());
        print_pure_clause(CDR(res));
        newline(cur_output_port());
      }
      new_var1=clinfo_distance(GLOBAL(param_tofullinf_global));
      if(NFALSEP(new_var1))
        distance=new_var1;
      else
        distance=clinfo_distance(GLOBAL(param_fromfullinf_global));
      res=handle_derived_inf_cl_pair(res,history,BOOL_F,ans_inf,distance);
      if(NFALSEP(res)&&(NFALSEP(GLOBAL(factors_stratflag_global))&&!(NFALSEP(GLOBAL(foundflag_global)))))
        return factor(CAR(res),CDR(res));
      else
        return UNSPECIFIED;
    }
  }
}

SCM give_cl_maxvar(clinf)
SCM clinf;
{
  SCM clmaxvar;

  clmaxvar=MAKINUM(INUM(MAKINUM(528482304)&CAR(clinf))>>23);
  if(clmaxvar==MAKINUM(63))
    return MAKINUM(255);
  else
    return clmaxvar;
}

SCM handle_derived_inf_cl_pair(pr,history,fac_gen_flag,ans_inf,distance)
SCM pr,history,fac_gen_flag,ans_inf,distance;
{
  SCM new_var2,tmp_triple,tmp_pr,cl,inf,clauseinf,tmp_fullcl,new_var1,kept_cl;

  if(GLOBAL(display_info_level_global)>MAKINUM(100)) {
    newline(cur_output_port());
    display(const_318,cur_output_port());
    display(CAR(pr),cur_output_port());
    newline(cur_output_port());
    debug_print_pure_clause(CDR(pr));
    newline(cur_output_port());
    display(const_319,cur_output_port());
    display(fac_gen_flag,cur_output_port());
    newline(cur_output_port());
    display(const_320,cur_output_port());
    display(distance,cur_output_port());
  }
  GLOBAL(derived_clauses_nr_global)=MAKINUM(1+INUM(GLOBAL(derived_clauses_nr_global)));
  if(NFALSEP(ans_inf)) {
    pr=make_unique_answer_pair(pr,history,ans_inf);
  }
  cl=CDR(pr);
  inf=CAR(pr);
  clauseinf=EOL;
  tmp_fullcl=EOL;
  if(!(NFALSEP(cl))||(NFALSEP(GLOBAL(classical_synth_stratflag_global))&&(!(NFALSEP(ans_inf))&&NFALSEP(some_pred_(handle_derived_inf_cl_pair_fn259,cl)))))
    return BOOL_F;
  else
  if(NFALSEP(empty_cl_pred_(cl))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(20)) {
      newline(cur_output_port());
      display(const_321,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(answer_cl_global)=cl;
    GLOBAL(answer_history_global)=history;
    GLOBAL(foundflag_global)=BOOL_T;
    return UNSPECIFIED;
  }
  else {
    tmp_pr=EOL;
    tmp_triple=EOL;
    tmp_pr=remove_double_lits_excl_(inf,cl,GLOBAL(hyper_strategy_flag_global));
    if(NFALSEP(removable_tautology_pr_pred_(tmp_pr))||(NFALSEP(GLOBAL(int_logic_flag_global))&&NFALSEP(apply(GLOBAL(int_prohibited_pr_pred_),tmp_pr,listofnull))))
      return BOOL_F;
    else {
      if((NFALSEP(GLOBAL(user_criterias_post_flag_global))&&!(NFALSEP(clause_pass_user_crit_post_pred_(CAR(tmp_pr),CDR(tmp_pr),history))))||!(NFALSEP(clause_pass_user_limits_post_pred_(CDR(tmp_pr))))) {
        tmp_pr=BOOL_F;
      }
      if(NFALSEP(tmp_pr)) {
        tmp_triple=unit_handle_cl_excl_(CAR(tmp_pr),CDR(tmp_pr),history);
      }
      else {
        tmp_triple=BOOL_F;
      }
      if(!(NFALSEP(GLOBAL(stop_fast_loop_flag_global)))&&((INUM(get_check_time(MAKINUM(5)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))) {
        store_time_checkpoint_excl_(MAKINUM(5));
        GLOBAL(sos_exhausted_flag_global)=BOOL_F;
        GLOBAL(stop_fast_loop_flag_global)=BOOL_T;
      }
      if(GLOBAL(display_info_level_global)>MAKINUM(110)) {
        if(NFALSEP(tmp_pr)) {
          newline(cur_output_port());
          display(const_322,cur_output_port());
          display(CAR(tmp_pr),cur_output_port());
          newline(cur_output_port());
          debug_print_pure_clause(CDR(tmp_pr));
          newline(cur_output_port());
        }
      }
      if(NFALSEP(tmp_triple)&&!(NFALSEP(clause_pass_user_limits_post_pred_(CDR(CDR(tmp_triple)))))) {
        tmp_triple=BOOL_F;
        if(GLOBAL(display_info_level_global)>=MAKINUM(80)) {
          newline(cur_output_port());
          display(const_323,cur_output_port());
          newline(cur_output_port());
        }
      }
      if(!(NFALSEP(tmp_triple)))
        return BOOL_F;
      else {
        history=CAR(tmp_triple);
        tmp_pr=CDR(tmp_triple);
        new_var1=BOOL_F;
        if(NFALSEP(new_var1))
          return new_var1;
        else
        if(NFALSEP(empty_cl_pred_(CDR(tmp_pr)))) {
          GLOBAL(answer_cl_global)=CDR(tmp_pr);
          GLOBAL(answer_history_global)=history;
          GLOBAL(foundflag_global)=BOOL_T;
          if(GLOBAL(display_info_level_global)>=MAKINUM(20)) {
            newline(cur_output_port());
            display(const_324,cur_output_port());
            return newline(cur_output_port());
          }
          else
            return UNSPECIFIED;
        }
        else {
          tmp_pr=sort_clause(handle_derived_inf_cl_pair_aux775(tmp_pr),BOOL_T);
          tmp_pr=cons(map1(handle_derived_inf_cl_pair_fn265,tmp_pr),map1(handle_derived_inf_cl_pair_fn266,tmp_pr));
          clauseinf=make_clause_info(CDR(tmp_pr),history,distance);
          tmp_fullcl=cons(clauseinf,CDR(tmp_pr));
          new_var2=BOOL_F;
          if(NFALSEP(new_var2))
            return new_var2;
          else
          if(NFALSEP(fac_gen_flag)&&(NFALSEP(some_pred__inst2(tmp_fullcl,handle_derived_inf_cl_pair_fn260,GLOBAL(locfactorpool_global)))||NFALSEP(some_pred__inst2(tmp_fullcl,handle_derived_inf_cl_pair_fn261,GLOBAL(factorpool_global)))))
            return BOOL_F;
          else
          if(!(NFALSEP(fac_gen_flag))&&(!(NFALSEP(unit_cl_pred_(CDR(tmp_pr))))&&(!(NFALSEP(GLOBAL(handle_derived_inf_cl_pair_return_directly_global)))&&NFALSEP(havealready_clause_pred_(clauseinf,CDR(tmp_pr))))))
            return BOOL_F;
          else {
            kept_cl=make_kept_clause(clauseinf,tmp_pr);
            if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
              newline(cur_output_port());
              display(const_325,cur_output_port());
              display(CAR(CDR(CDR(CDR(CDR(CAR(kept_cl)))))),cur_output_port());
              display(const_326,cur_output_port());
              newline(cur_output_port());
              print_clause(kept_cl);
              newline(cur_output_port());
              if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
                debug_print_clause(kept_cl);
                newline(cur_output_port());
              }
            }
            else
            if(NFALSEP(GLOBAL(display_info_char_flag_global)))
              display(MAKICHR('+'),cur_output_port());
            tmp_pr=full_unit_cutoff_excl_(CAR(tmp_pr),kept_cl);
            if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
              debug_print_clause(kept_cl);
              newline(cur_output_port());
            }
            kept_cl=CDR(tmp_pr);
            if(NFALSEP(empty_cl_pred_(CDR(kept_cl)))) {
              if(!(NFALSEP(GLOBAL(classical_synth_stratflag_global))&&NFALSEP(some_pred_(handle_derived_inf_cl_pair_fn262,CDR(kept_cl))))) {
                GLOBAL(answer_cl_global)=CDR(kept_cl);
                GLOBAL(answer_history_global)=CAR(CDR(CDR(CDR(CDR(CDR(CAR(kept_cl)))))));
                GLOBAL(foundflag_global)=BOOL_T;
                if(GLOBAL(display_info_level_global)>=MAKINUM(20)) {
                  newline(cur_output_port());
                  display(const_327,cur_output_port());
                  return newline(cur_output_port());
                }
                else
                  return UNSPECIFIED;
              }
              else
                return UNSPECIFIED;
            }
            else
            if(NFALSEP(GLOBAL(handle_derived_inf_cl_pair_return_directly_global)))
              return tmp_pr;
            else
            if(!(NFALSEP(fac_gen_flag)))
              return handle_derived_inf_cl_pair_aux(tmp_pr,BOOL_F);
            else {
              GLOBAL(locfactorpool_global)=remove_if_inst1(kept_cl,handle_derived_inf_cl_pair_fn263,GLOBAL(locfactorpool_global));
              GLOBAL(factorpool_global)=remove_if_inst1(kept_cl,handle_derived_inf_cl_pair_fn264,GLOBAL(factorpool_global));
              return tmp_pr;
            }
          }
        }
      }
    }
  }
}

SCM handle_derived_inf_cl_pair_aux775(tmp_pr)
SCM tmp_pr;
{
  SCM new_var6,new_var7,new_var3,new_var4,new_var5;

  for(new_var6=CAR(tmp_pr),new_var7=CDR(tmp_pr),new_var3=EOL,new_var4=EOL,new_var5=EOL;
      PAIR_P(new_var6)&&PAIR_P(new_var7);
      new_var6=CDR(new_var6),new_var7=CDR(new_var7)) {
    new_var5=cons(CAR(new_var6),CAR(new_var7));
    if(NULL_P(new_var3)) {
      new_var3=cons(new_var5,EOL);
      new_var4=new_var3;
    }
    else {
      SET_CDR(new_var4,cons(new_var5,EOL));
      new_var4=CDR(new_var4);
    }
  }
  return new_var3;
}

SCM handle_derived_inf_cl_pair_fn266(x)
SCM x;
{
  return CDR(x);
}

SCM handle_derived_inf_cl_pair_fn265(x)
SCM x;
{
  return CAR(x);
}

SCM handle_derived_inf_cl_pair_fn264(kept_cl,x)
SCM kept_cl,x;
{
  return subsumed_clause_pred_(CDR(x),kept_cl);
}

SCM handle_derived_inf_cl_pair_fn263(kept_cl,x)
SCM kept_cl,x;
{
  return subsumed_clause_pred_(CDR(x),kept_cl);
}

SCM handle_derived_inf_cl_pair_fn262(x)
SCM x;
{
  return SBOOL(NFALSEP(answer_lit_pred_(x))&&!(NFALSEP(ans_computable_lit_pred_(x))));
}

SCM handle_derived_inf_cl_pair_fn261(tmp_fullcl,x)
SCM tmp_fullcl,x;
{
  return subsumed_clause_pred_(tmp_fullcl,CDR(x));
}

SCM handle_derived_inf_cl_pair_fn260(tmp_fullcl,x)
SCM tmp_fullcl,x;
{
  return subsumed_clause_pred_(tmp_fullcl,CDR(x));
}

SCM handle_derived_inf_cl_pair_fn259(x)
SCM x;
{
  return SBOOL(NFALSEP(answer_lit_pred_(x))&&!(NFALSEP(ans_computable_lit_pred_(x))));
}

SCM handle_ready_clause(fullclause)
SCM fullclause;
{
  SCM tmp_triple,tmp_pr,tmp2,tmp,res2,res1,cl,history,clhistsublist,litinftmp,litinforig,inf,tmpres,tmpcl,kept_cl,litinfolst,strengthint,len,strength;

  inf=CAR(fullclause);
  litinforig=CAR(CDR(CDR(inf)));
  litinftmp=EOL;
  clhistsublist=CDR(CDR(CDR(CDR(CDR(inf)))));
  history=EOL;
  cl=EOL;
  res1=EOL;
  res2=EOL;
  tmp=EOL;
  tmp2=EOL;
  tmp_pr=EOL;
  tmp_triple=EOL;
  litinftmp=litinforig;
  history=CAR(clhistsublist);
  res1=map1(handle_ready_clause_fn271,litinftmp);
  res1=cons(res1,copy_list(CDR(fullclause)));
  GLOBAL(handle_derived_inf_cl_pair_return_directly_global)=BOOL_T;
  tmp=GLOBAL(discr_tree_subsume_stratflag_global);
  GLOBAL(discr_tree_subsume_stratflag_global)=BOOL_F;
  res2=handle_derived_inf_cl_pair(res1,history,BOOL_F,BOOL_F,CAR(CDR(clhistsublist)));
  GLOBAL(discr_tree_subsume_stratflag_global)=tmp;
  GLOBAL(handle_derived_inf_cl_pair_return_directly_global)=BOOL_F;
  if(NFALSEP(GLOBAL(foundflag_global))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(20)) {
      res2=cons(EOL,fullclause);
      newline(cur_output_port());
      display(const_328,cur_output_port());
      newline(cur_output_port());
      display(const_329,cur_output_port());
      newline(cur_output_port());
    }
  }
  else {
    BOOL_F;
  }
  tmp_pr=res2;
  if(!(NFALSEP(res2))||(length(fullclause)==length(CDR(res2))))
    return fullclause;
  else {
    tmpres=EOL;
    tmpcl=EOL;
    kept_cl=CDR(tmp_pr);
    if(NFALSEP(GLOBAL(order_strategy_flag_global))||(NFALSEP(GLOBAL(poslitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(name_order_strategy_flag_global))||(NFALSEP(GLOBAL(epr_order_strategy_flag_global))||(NFALSEP(GLOBAL(exp_order_strategy_flag_global))||(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))||NFALSEP(GLOBAL(ordered_paramodulation_flag_global)))))))))
      litinfolst=map1(handle_ready_clause_fn273,order_prohibit_litinfos(CAR(tmp_pr),CDR(kept_cl)));
    else
      litinfolst=map1(handle_ready_clause_fn274,CAR(tmp_pr));
    strengthint=CAR(CAR(kept_cl));
    len=MAKINUM(INUM(MAKINUM(8257536)&strengthint)>>17);
    strength=(MAKINUM(131071)&strengthint);
    if(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))&&(NFALSEP(GLOBAL(order_sos_strategy_flag_global))&&NFALSEP(clinfo_distance(CAR(kept_cl))))) {
      litinfolst=map1(handle_ready_clause_fn272,clear_litorder_litinfo(CAR(tmp_pr),CDR(kept_cl)));
    }
    if(NFALSEP(GLOBAL(keep_all_old_clauses_flag_global))) {
      GLOBAL(all_back_subsumed_clauses_global)=cons(fullclause,GLOBAL(all_back_subsumed_clauses_global));
    }
    SET_CAR(CDR(CDR(CAR(kept_cl))),litinfolst);
    if((length(CDR(fullclause))==length(CDR(kept_cl)))&&NFALSEP(term_list_equal_pred_(CDR(fullclause),CDR(kept_cl)))) {
      kept_cl=fullclause;
    }
    else
      BOOL_F;
    return kept_cl;
  }
}

SCM handle_ready_clause_fn274(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM handle_ready_clause_fn273(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM handle_ready_clause_fn272(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM handle_ready_clause_fn271(x)
SCM x;
{
  return cons(BOOL_T,cons(MAKINUM(1),cons(CAR(x),EOL)));
}

SCM too_many_kept_pred_(tmp_pr,fac_gen_flag)
SCM tmp_pr,fac_gen_flag;
{
  if((GLOBAL(kept_size_sum_nr_global)>GLOBAL(max_size_sum_nr_global))||((((3*INUM(GLOBAL(kept_size_sum_nr_global)))>INUM(GLOBAL(max_size_sum_nr_global)))&&(INUM(compute_real_clausesize(CAR(CDR(CDR(tmp_pr)))))>(3*INUM(GLOBAL(last_best_clausesize_global)))))||((((3*INUM(GLOBAL(kept_size_sum_nr_global)))>(2*INUM(GLOBAL(max_size_sum_nr_global))))&&((INUM(compute_real_clausesize(CAR(CDR(CDR(tmp_pr)))))>(2*INUM(GLOBAL(last_best_clausesize_global))))&&(INUM(compute_real_clausesize(CAR(CDR(CDR(tmp_pr)))))>(10+INUM(GLOBAL(last_best_clausesize_global))))))||((((5*INUM(GLOBAL(kept_size_sum_nr_global)))>(4*INUM(GLOBAL(max_size_sum_nr_global))))&&(INUM(compute_real_clausesize(CAR(CDR(CDR(tmp_pr)))))>(10+INUM(GLOBAL(last_best_clausesize_global)))))||((INUM(GLOBAL(kept_clauses_nr_global))>((INUM(GLOBAL(one_pass_kept_clauses_firstnr_global))+INUM(GLOBAL(max_kept_clauses_nr_global)))-3000))&&(!((INUM(GLOBAL(kept_clauses_nr_global))<((INUM(GLOBAL(one_pass_kept_clauses_firstnr_global))+INUM(GLOBAL(max_kept_clauses_nr_global)))-1500))&&((MAKINUM(2047)&CAR(CAR(CDR(tmp_pr))))<=GLOBAL(last_best_weight_global)))&&!((INUM(GLOBAL(kept_clauses_nr_global))<(INUM(GLOBAL(one_pass_kept_clauses_firstnr_global))+INUM(GLOBAL(max_kept_clauses_nr_global))))&&((MAKINUM(2047)&CAR(CAR(CDR(tmp_pr))))<GLOBAL(last_best_weight_global))))))))) {
    if(NFALSEP(GLOBAL(complete_unsat_strategy_global)))
      return BOOL_F;
    else
      return BOOL_T;
  }
  else
    return BOOL_F;
}

SCM handle_derived_inf_cl_pair_aux(tmp_pr,fac_gen_flag)
SCM tmp_pr,fac_gen_flag;
{
  SCM strength,len,strengthint,litinfolst__2,kept_cl__1,tmpcl,tmpres,kept_cl,litinfolst,new_var1,new_var2;

  if((NFALSEP(GLOBAL(hyper_strategy_flag_global))&&(!(NFALSEP(fac_gen_flag))&&!(NFALSEP(positive_cl_pred_(CDR(CDR(tmp_pr)))))))||NFALSEP(GLOBAL(unit_clash_flag_global))) {
    kept_cl=CDR(tmp_pr);
    litinfolst=map1(handle_derived_inf_cl_pair_aux_fn280,CAR(tmp_pr));
    GLOBAL(kept_mid_nucleus_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_mid_nucleus_nr_global)));
    SET_CAR(CDR(CDR(CAR(kept_cl))),litinfolst);
    if(NFALSEP(GLOBAL(unit_clash_flag_global)))
      insert_clause_discr_tree_excl_(GLOBAL(discr_tree_global),CDR(tmp_pr),CAR(tmp_pr),BOOL_F);
    else
      insert_clause_discr_tree_excl_(GLOBAL(discr_tree_global),CDR(tmp_pr),CAR(tmp_pr),BOOL_F);
    if(GLOBAL(display_info_level_global)>=MAKINUM(100)) {
      newline(cur_output_port());
      display(const_330,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(CDR(kept_cl));
      newline(cur_output_port());
      debug_print_xvars(MAKINUM(3));
      debug_print_yvars(MAKINUM(3));
      if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
        newline(cur_output_port());
        display(const_331,cur_output_port());
        newline(cur_output_port());
        debug_print_clause(kept_cl);
      }
    }
    else
    if(NFALSEP(GLOBAL(display_info_char_flag_global)))
      display(MAKICHR('$'),cur_output_port());
    if(NFALSEP(GLOBAL(one_step_hyper_phase_global)))
      return kept_cl;
    else {
      GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
      usable_clauses_fast_loop(kept_cl,BOOL_F);
      return BOOL_F;
    }
  }
  else
  if(NFALSEP(too_many_kept_pred_(tmp_pr,fac_gen_flag)))
    return BOOL_F;
  else {
    tmpres=EOL;
    tmpcl=EOL;
    kept_cl__1=CDR(tmp_pr);
    if(NFALSEP(GLOBAL(order_strategy_flag_global))||(NFALSEP(GLOBAL(poslitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(name_order_strategy_flag_global))||(NFALSEP(GLOBAL(epr_order_strategy_flag_global))||(NFALSEP(GLOBAL(exp_order_strategy_flag_global))||(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))||(NFALSEP(GLOBAL(posweight_order_strategy_flag_global))||NFALSEP(GLOBAL(ordered_paramodulation_flag_global)))))))))
      litinfolst__2=map1(handle_derived_inf_cl_pair_aux_fn283,order_prohibit_litinfos(CAR(tmp_pr),CDR(kept_cl__1)));
    else
      litinfolst__2=map1(handle_derived_inf_cl_pair_aux_fn284,CAR(tmp_pr));
    strengthint=CAR(CAR(kept_cl__1));
    len=MAKINUM(INUM(MAKINUM(8257536)&strengthint)>>17);
    strength=(MAKINUM(131071)&strengthint);
    if(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global))&&(NFALSEP(GLOBAL(order_sos_strategy_flag_global))&&NFALSEP(clinfo_distance(CAR(kept_cl__1))))) {
      litinfolst__2=map1(handle_derived_inf_cl_pair_aux_fn281,clear_litorder_litinfo(CAR(tmp_pr),CDR(kept_cl__1)));
    }
    GLOBAL(kept_clauses_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_clauses_nr_global)));
    GLOBAL(kept_size_sum_nr_global)=MAKINUM(INUM(GLOBAL(kept_size_sum_nr_global))+INUM(compute_real_clausesize(CDR(kept_cl__1))));
    SET_CAR(CDR(CDR(CAR(kept_cl__1))),litinfolst__2);
    insert_clause_discr_tree_excl_(GLOBAL(discr_tree_global),CDR(tmp_pr),CAR(tmp_pr),BOOL_T);
    if(len==MAKINUM(1))
      insert_unit_alist(kept_cl__1);
    if(NFALSEP(GLOBAL(demodulate_with_clauses_stratflag_global))) {
      tmpres=demodulation_clause_test(CAR(tmp_pr),CDR(kept_cl__1));
      if(NFALSEP(tmpres)) {
        for(new_var1=tmpres,new_var2=CDR(kept_cl__1);
            PAIR_P(new_var1)&&PAIR_P(new_var2);
            new_var1=CDR(new_var1),new_var2=CDR(new_var2))
          handle_derived_inf_cl_pair_aux_fn282(&tmpcl,kept_cl__1,CAR(new_var1),CAR(new_var2));
      }
      GLOBAL(cur_lit_global)=EOL;
      GLOBAL(cur_clause_global)=EOL;
      tmpcl=EOL;
      tmpres=EOL;
    }
    if(NFALSEP(GLOBAL(back_subsume_stratflag_global)))
      back_subsume(CAR(kept_cl__1),CDR(kept_cl__1));
    if(GLOBAL(display_info_level_global)>=MAKINUM(60)) {
      newline(cur_output_port());
      display(const_332,cur_output_port());
      newline(cur_output_port());
      print_full_clause(kept_cl__1);
      newline(cur_output_port());
      if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
        newline(cur_output_port());
        display(const_333,cur_output_port());
        newline(cur_output_port());
        display(CDR(kept_cl__1),cur_output_port());
        newline(cur_output_port());
        debug_print_clause(kept_cl__1);
      }
    }
    else
    if(NFALSEP(GLOBAL(display_info_char_flag_global)))
      display(MAKICHR('+'),cur_output_port());
    if(!(NULL_P(GLOBAL(special_insertion_place_global)))) {
      SET_CDR(GLOBAL(special_insertion_place_global),cons(kept_cl__1,CDR(GLOBAL(special_insertion_place_global))));
    }
    else
    if(NULL_P(GLOBAL(sos_clauses_list_global))) {
      GLOBAL(sos_clauses_list_global)=cons(kept_cl__1,EOL);
      GLOBAL(sos_clauses_list_end_global)=GLOBAL(sos_clauses_list_global);
    }
    else {
      SET_CDR(GLOBAL(sos_clauses_list_end_global),cons(kept_cl__1,EOL));
      GLOBAL(sos_clauses_list_end_global)=CDR(GLOBAL(sos_clauses_list_end_global));
    }
    if(NFALSEP(GLOBAL(dynamic_demodulation_flag_global)))
      attempt_to_make_a_demodulator(kept_cl__1);
    if(NFALSEP(GLOBAL(int_logic_flag_global)))
      apply(GLOBAL(use_all_single_premiss_rules),kept_cl__1,listofnull);
    if(NFALSEP(GLOBAL(demodulate_with_clauses_stratflag_global)))
      demodulate_with_clauses(kept_cl__1);
    if(NFALSEP(GLOBAL(hyper_contradiction_strategy_global))&&!(NFALSEP(unit_cl_pred_(CDR(kept_cl__1)))))
      hyper_contradiction_pred_(kept_cl__1);
    if(NFALSEP(GLOBAL(one_step_hyper_phase_global)))
      return BOOL_F;
    else
      return tmp_pr;
  }
}

SCM handle_derived_inf_cl_pair_aux_fn284(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM handle_derived_inf_cl_pair_aux_fn283(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM handle_derived_inf_cl_pair_aux_fn282(tmpcl,kept_cl__1,res,lit)
SCM *tmpcl;
SCM kept_cl__1,res,lit;
{
  if(NFALSEP(res)) {
    *tmpcl=cons(lit,remove_eq(lit,CDR(kept_cl__1)));
    GLOBAL(cur_clause_global)=cons(CAR(kept_cl__1),CDR(rename_x_to_z_term(cons(MAKINUM(0),*tmpcl))));
    GLOBAL(cur_lit_global)=CAR(CDR(GLOBAL(cur_clause_global)));
    return insert_discr_tree_excl_(GLOBAL(discr_tree_demod_atoms_global),GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T,BOOL_T);
  }
  else
    return UNSPECIFIED;
}

SCM handle_derived_inf_cl_pair_aux_fn281(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM handle_derived_inf_cl_pair_aux_fn280(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM attempt_to_make_a_demodulator(fullcl)
SCM fullcl;
{
  SCM inf,cl,lit,litinfnr,eqlit;

  inf=CAR(fullcl);
  cl=CDR(fullcl);
  lit=CAR(cl);
  litinfnr=CAR(CAR(CAR(CDR(CDR(inf)))));
  eqlit=EOL;
  if(NULL_P(CDR(cl))&&(((MAKINUM(534773760)&CAR(lit))==GLOBAL(eq_pred_nr_global))&&(!(!(ZERO_P(MAKINUM(16)&litinfnr))&&!(ZERO_P(MAKINUM(32)&litinfnr)))&&((!(ZERO_P(MAKINUM(16)&litinfnr))&&(!(NFALSEP(GLOBAL(order_equality_firstpref_strat_global)))||NFALSEP(terminating_demod_bigger_pred_(CAR(CDR(CDR(lit))),CAR(CDR(lit))))))||(!(ZERO_P(MAKINUM(32)&litinfnr))&&(!(NFALSEP(GLOBAL(order_equality_firstpref_strat_global)))||NFALSEP(terminating_demod_bigger_pred_(CAR(CDR(lit)),CAR(CDR(CDR(lit))))))))))) {
    GLOBAL(new_demodulators_flag_global)=BOOL_T;
    if(!(ZERO_P(MAKINUM(16)&litinfnr))) {
      eqlit=cons(CAR(lit),cons(CAR(CDR(CDR(lit))),cons(CAR(CDR(lit)),CDR(CDR(CDR(lit))))));
    }
    else {
      eqlit=lit;
    }
    if(NUMBER_P(CAR(CDR(eqlit)))&&(CAR(CDR(eqlit))>MAKINUM(65535))) {
      GLOBAL(demodulate_constants_flag_global)=BOOL_T;
    }
    GLOBAL(cur_lit_global)=rename_x_to_z_term(eqlit);
    GLOBAL(cur_clause_global)=cons(inf,cons(GLOBAL(cur_lit_global),EOL));
    if(1) {
      if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
        newline(cur_output_port());
        display(const_334,cur_output_port());
        newline(cur_output_port());
        debug_print_clause(GLOBAL(cur_clause_global));
      }
    }
    else
    if(NFALSEP(GLOBAL(display_info_char_flag_global)))
      display(MAKICHR('+'),cur_output_port());
    GLOBAL(new_demodulators_list_global)=cons(GLOBAL(cur_clause_global),GLOBAL(new_demodulators_list_global));
    GLOBAL(kept_new_demodulators_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_new_demodulators_nr_global)));
    return insert_discr_tree_excl_(GLOBAL(discr_tree_demod_terms_global),CAR(CDR(GLOBAL(cur_lit_global))),BOOL_T,BOOL_T,BOOL_T,BOOL_F);
  }
  else
    return UNSPECIFIED;
}

SCM terminating_demod_bigger_pred_(lterm,rterm)
SCM lterm,rterm;
{
  SCM tmp,rdepths,ldepths,new_var1;

  ldepths=make_var_depth_info(lterm);
  rdepths=make_var_depth_info(rterm);
  tmp=EOL;
  if(!(NULL_P(ldepths))&&!(PAIR_P(CAR(ldepths)))) {
    ldepths=cons(ldepths,EOL);
  }
  if(!(NULL_P(rdepths))&&!(PAIR_P(CAR(rdepths)))) {
    rdepths=cons(rdepths,EOL);
  }
  new_var1=SBOOL(NULL_P(rdepths));
  if(NFALSEP(new_var1))
    return new_var1;
  else
    return vdepth__grtr__varinfolit_pred_(cons(ldepths,lterm),cons(rdepths,rterm));
}

SCM make_kept_clause(clinfo,inflist_cl_pair)
SCM clinfo,inflist_cl_pair;
{
  SCM cl,tmp;

  cl=CDR(inflist_cl_pair);
  tmp=EOL;
  clause_var_nr_global=MAKINUM(0);
  if(NFALSEP(pure_clause_may_cont_vars_pred_(cl))) {
    cl=copy_list(cl);
    make_varinfo_lst_excl_(cl,const_335);
    GLOBAL(new_var_names_global)=EOL;
    make_fulldeco_clause_excl_(cl);
  }
  if(clause_var_nr_global>MAKINUM(63)) {
    clause_var_nr_global=MAKINUM(63);
  }
  SET_CAR(clinfo,MAKINUM(INUM(clause_var_nr_global)<<23)|CAR(clinfo));
  GLOBAL(kept_cl_nr_global)=MAKINUM(1+INUM(GLOBAL(kept_cl_nr_global)));
  SET_CAR(CDR(CDR(clinfo)),make_kept_litinflist(CAR(inflist_cl_pair),cl));
  SET_CAR(CDR(CDR(CDR(CDR(clinfo)))),GLOBAL(kept_cl_nr_global));
  tmp=CDR(CDR(CDR(CDR(CDR(clinfo)))));
  if(!(NFALSEP(GLOBAL(simple_history_stratflag_global)))) {
    tmp=CDR(CDR(CDR(CDR(CDR(clinfo)))));
    if(!(PAIR_P(CAR(tmp)))) {
      SET_CAR(tmp,cons(unknown_symb,cons(GLOBAL(kept_cl_nr_global),CAR(tmp))));
    }
    else {
      SET_CAR(tmp,cons(CAR(CAR(tmp)),cons(GLOBAL(kept_cl_nr_global),CDR(CDR(CAR(tmp))))));
    }
  }
  return cons(clinfo,cl);
}

SCM make_kept_litinflist(litinf,newcl)
SCM litinf,newcl;
{
  return map1(make_kept_litinflist_fn286,litinf);
}

SCM make_kept_litinflist_fn286(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM litinf_binrespara_pred_(inf)
SCM inf;
{
  return NOT(SBOOL(litinf_nobinrespara_mask_global==(litinf_nobinrespara_mask_global&inf)));
}

SCM litinf_use_pred_(inf)
SCM inf;
{
  return SBOOL(ZERO_P(litinf_nouse_mask_global&inf));
}

SCM litinf_left_para_pred_(inf)
SCM inf;
{
  return SBOOL(ZERO_P(MAKINUM(16)&inf));
}

SCM litinf_right_para_pred_(inf)
SCM inf;
{
  return SBOOL(ZERO_P(MAKINUM(32)&inf));
}

SCM litinf_parainto_pred_(inf)
SCM inf;
{
  return SBOOL(ZERO_P(MAKINUM(8)&inf));
}

SCM modify_to_demod_inf_excl_(fullcl)
SCM fullcl;
{
  SCM inflist,res;

  inflist=CAR(CDR(CDR(CAR(fullcl))));
  res=CAR(inflist);
  res=cons(MAKINUM(0)|(MAKINUM(32)|CAR(res)),CDR(res));
  SET_CAR(inflist,res);
  return UNSPECIFIED;
}

SCM make_clause_info(cl,history,distance)
SCM cl,history,distance;
{
  SCM fun,lit,tmp,minw,clinfo,weight,litinfolst,predsymbsint,len,strengthint,clpart,clpart__1;

  strengthint=MAKINUM(0);
  len=MAKINUM(0);
  predsymbsint=MAKINUM(0);
  litinfolst=map1(make_clause_info_fn296,cl);
  weight=MAKINUM(0);
  clinfo=EOL;
  minw=MAKINUM(0);
  tmp=EOL;
  for(clpart=cl;!(NULL_P(clpart));clpart=CDR(clpart)) {
    lit=CAR(clpart);
    fun=CAR(lit);
    if(NFALSEP(countable_pred_pred_(fun))) {
      if(ZERO_P(strengthint)) {
        strengthint=(MAKINUM(131071)&fun);
      }
      else {
        strengthint=sum_fun_strengths(fun,strengthint);
      }
      if(!(ZERO_P(predsymb_bit(fun)&predsymbsint))) {
        predsymbsint=(MAKINUM(134217728)|predsymbsint);
      }
      predsymbsint=(predsymb_bit(fun)|predsymbsint);
      len=MAKINUM(1+INUM(len));
      weight=MAKINUM(INUM(weight)+INUM(lit_weight(lit)));
    }
  }
  if(NFALSEP(GLOBAL(split_strategy_flag_global))) {
    weight=strengthint;
  }
  if(NFALSEP(GLOBAL(split_strategy_flag_global))&&!(NULL_P(CDR(cl)))) {
    weight=strengthint;
    tmp=map1(make_clause_info_fn292,cl);
    if(NFALSEP(every_pred__inst1(tmp,make_clause_info_fn293,tmp))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
        newline(cur_output_port());
        display(const_336,cur_output_port());
        print_pure_clause(cl);
        newline(cur_output_port());
      }
      for(clpart__1=cl;!(NULL_P(clpart__1));clpart__1=CDR(clpart__1))
        if(ZERO_P(minw)) {
          minw=(MAKINUM(131071)&CAR(CAR(clpart__1)));
        }
        else
        if((MAKINUM(131071)&CAR(CAR(clpart__1)))>minw) {
          minw=(MAKINUM(131071)&CAR(CAR(clpart__1)));
        }
      weight=minw;
    }
  }
  if(len>MAKINUM(63)) {
    len=MAKINUM(63);
  }
  strengthint=(MAKINUM(INUM(len)<<17)|strengthint);
  clinfo=cons(strengthint,cons(predsymbsint,cons(litinfolst,cons(weight,cons(EOL,cons(history,cons(distance,EOL)))))));
  return clinfo;
}

SCM make_clause_info_fn296(x)
SCM x;
{
  return cons(MAKINUM(0),EOL);
}

SCM make_clause_info_fn293(tmp,el)
SCM tmp,el;
{
  return SBOOL(!(NULL_P(el))&&NFALSEP(every_pred__inst1(el,make_clause_info_fn294,tmp)));
}

SCM make_clause_info_fn294(el,el2)
SCM el,el2;
{
  return SBOOL((el2==el)||NFALSEP(every_pred__inst1(el2,make_clause_info_fn295,el)));
}

SCM make_clause_info_fn295(el2,v)
SCM el2,v;
{
  return SBOOL(!(NFALSEP(assq(CAR(v),el2))));
}

SCM make_clause_info_fn292(x)
SCM x;
{
  return make_var_depth_info(x);
}

SCM intern_fullclause(cl)
SCM cl;
{
  SCM tmpres,tmp_litinfolst,strength,len,tmpcl,strengthint,new_var1,new_var2;

  insert_clause_discr_tree_excl_(GLOBAL(discr_tree_global),cl,map1(intern_fullclause_fn300,CDR(cl)),BOOL_T);
  strengthint=CAR(CAR(cl));
  tmpcl=EOL;
  len=MAKINUM(INUM(MAKINUM(8257536)&strengthint)>>17);
  strength=(MAKINUM(131071)&strengthint);
  tmp_litinfolst=map1(intern_fullclause_fn302,CDR(cl));
  tmpres=EOL;
  if(NFALSEP(GLOBAL(demodulate_with_clauses_stratflag_global))) {
    tmpres=demodulation_clause_test(tmp_litinfolst,CDR(cl));
    if(NFALSEP(tmpres)) {
      for(new_var1=tmpres,new_var2=CDR(cl);
          PAIR_P(new_var1)&&PAIR_P(new_var2);
          new_var1=CDR(new_var1),new_var2=CDR(new_var2))
        intern_fullclause_fn301(&tmpcl,cl,CAR(new_var1),CAR(new_var2));
    }
  }
  if(len==MAKINUM(1))
    insert_unit_alist(cl);
  return insert_to_subsumption_list_excl_(len,strength,cl);
}

SCM intern_fullclause_fn302(x)
SCM x;
{
  return cons(BOOL_T,EOL);
}

SCM intern_fullclause_fn301(tmpcl,cl,res,lit)
SCM *tmpcl;
SCM cl,res,lit;
{
  if(NFALSEP(res)) {
    *tmpcl=cons(lit,remove_eq(lit,CDR(cl)));
    GLOBAL(cur_clause_global)=cons(CAR(cl),CDR(rename_x_to_z_term(cons(MAKINUM(0),*tmpcl))));
    GLOBAL(cur_lit_global)=CAR(CDR(GLOBAL(cur_clause_global)));
    return insert_discr_tree_excl_(GLOBAL(discr_tree_demod_atoms_global),GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T,BOOL_T);
  }
  else
    return UNSPECIFIED;
}

SCM intern_fullclause_fn300(x)
SCM x;
{
  return cons(BOOL_T,EOL);
}

SCM back_demodulate_usable()
{
  SCM newlist,new,given_cl,tmp,part;

  if(GLOBAL(display_info_level_global)>=MAKINUM(60)) {
    newline(cur_output_port());
    display(const_337,cur_output_port());
    newline(cur_output_port());
  }
  tmp=EOL;
  given_cl=EOL;
  new=EOL;
  newlist=EOL;
  for(part=GLOBAL(usable_clauses_list_global);!(NULL_P(part));part=CDR(part)) {
    given_cl=CAR(part);
    if(PAIR_P(given_cl)&&!(ZERO_P(MAKINUM(65535)&CAR(CAR(given_cl))))) {
      tmp=demodulate_clause(given_cl);
      if(NFALSEP(tmp)) {
        new=CDR(tmp);
        newlist=cons(new,newlist);
        SET_CAR(CAR(given_cl),MAKINUM(65535^INUM(MAKINUM(65535)|CAR(CAR(given_cl)))));
        insert_to_subsumption_list_excl_(MAKINUM(INUM(MAKINUM(8257536)&CAR(CAR(new)))>>17),MAKINUM(65535)&CAR(CAR(new)),new);
      }
    }
  }
  if(GLOBAL(display_info_level_global)>=MAKINUM(60)) {
    newline(cur_output_port());
    display(const_338,cur_output_port());
    newline(cur_output_port());
  }
  return for_each1(back_demodulate_usable_fn304,newlist);
}

SCM back_demodulate_usable_fn304(cl)
SCM cl;
{
  SET_CDR(GLOBAL(usable_clauses_list_end_global),cons(cl,EOL));
  GLOBAL(usable_clauses_list_end_global)=CDR(GLOBAL(usable_clauses_list_end_global));
  return UNSPECIFIED;
}

SCM demodulate_clause(cl)
SCM cl;
{
  SCM inf,purecl,part,newlitinf,history,res,demods,new;

  inf=CAR(cl);
  purecl=CDR(cl);
  part=EOL;
  newlitinf=EOL;
  history=EOL;
  res=EOL;
  demods=EOL;
  new=EOL;
  GLOBAL(used_demodulators_global)=EOL;
  new=map1(demodulate_clause_fn308,purecl);
  if(NULL_P(GLOBAL(used_demodulators_global)))
    return BOOL_F;
  else {
    demods=GLOBAL(used_demodulators_global);
    newlitinf=map1(demodulate_clause_fn309,CAR(CDR(CDR(CAR(cl)))));
    history=cons(backdemod_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(inf)))))),cons(MAKINUM(1),EOL))),cons(cons(demod_symb,GLOBAL(used_demodulators_global)),EOL))));
    res=handle_derived_inf_cl_pair(cons(newlitinf,new),history,BOOL_F,BOOL_F,BOOL_F);
    if(NFALSEP(res)&&((GLOBAL(display_info_level_global)>=MAKINUM(60))&&!(NFALSEP(GLOBAL(foundflag_global))))) {
      newline(cur_output_port());
      display(const_339,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(CDR(cl));
      newline(cur_output_port());
      display(const_340,cur_output_port());
      newline(cur_output_port());
      print_pure_clause(CDR(CDR(res)));
      newline(cur_output_port());
      display(const_341,cur_output_port());
      newline(cur_output_port());
      for_each1(demodulate_clause_fn310,demods);
      if(NFALSEP(GLOBAL(display_debug_info_flag_global))) {
        newline(cur_output_port());
        display(const_342,cur_output_port());
        newline(cur_output_port());
        debug_print_clause(CDR(res));
      }
    }
    if(NFALSEP(GLOBAL(foundflag_global))) {
      res=BOOL_F;
    }
    return res;
  }
}

SCM demodulate_clause_fn310(x)
SCM x;
{
  print_pure_clause(CDR(x));
  return newline(cur_output_port());
}

SCM demodulate_clause_fn309(inf__1)
SCM inf__1;
{
  return cons(BOOL_T,cons(MAKINUM(1),inf__1));
}

SCM demodulate_clause_fn308(lit)
SCM lit;
{
  return demodulate_fully_lit(lit);
}

SCM demodulate_composite(comp)
SCM comp;
{
  SCM tmp;

  tmp=demodulate_composite_aux10(comp);
  return tmp;
}

SCM demodulate_composite_aux10(comp)
SCM comp;
{
  SCM tmp2,tmp1,checkres,demodcl,demodlit,maxdemodvar,nr;

  checkres=check_discr_tree(GLOBAL(discr_tree_demod_terms_global),comp);
  if(!(NFALSEP(checkres))) {
    if(GLOBAL(case_fun_nr_global)==(MAKINUM(534773760)&CAR(comp)))
      return subst_deco_case_term(comp);
    else
      return comp;
  }
  else {
    demodcl=CAR(CDR(CDR(checkres)));
    demodlit=CAR(CDR(demodcl));
    maxdemodvar=give_cl_maxvar(CAR(demodcl));
    if(!(NFALSEP(memq(demodcl,GLOBAL(used_demodulators_global))))) {
      GLOBAL(used_demodulators_global)=cons(demodcl,GLOBAL(used_demodulators_global));
    }
    subsumed_term_list_ordinary_pred_(CDR(comp),CDR(CAR(CDR(demodlit))));
    tmp1=EOL;
    tmp2=EOL;
    comp=subst_deco_term_nodemodulate_spec(CAR(CDR(CDR(demodlit))));
    tmp2=EOL;
    for(nr=(MAKINUM(512)|maxdemodvar);!(nr<=MAKINUM(512));nr=MAKINUM(INUM(nr)-1)) {
      tmp1=STBL_VECTOR_REF(_star_var_val_table_star__velts0,nr);
      if(!(NUMBER_P(tmp1))&&1) {
        tmp2=cons(tmp1,tmp2);
      }
    }
    clear_z_vars_and_touched_excl_(maxdemodvar);
    var_set_flag_global=BOOL_F;
    alt_var_set_flag_global=BOOL_F;
    return demodulate_fully(comp,tmp2,BOOL_F);
  }
}

SCM demodulate_equivalent_lit(lit)
SCM lit;
{
  SCM new,tmp3,tmp2,tmp1,tmp0,checkres,atom,demodcl,demodatom,maxdemodvar,nr;

  if(!(ZERO_P(MAKINUM(268435456)&CAR(lit))))
    atom=cons(MAKINUM(268435456^INUM(CAR(lit))),CDR(lit));
  else
    atom=lit;
  checkres=check_discr_tree(GLOBAL(discr_tree_demod_atoms_global),atom);
  if(!(NFALSEP(checkres)))
    return lit;
  else {
    demodcl=CAR(CDR(CDR(checkres)));
    demodatom=CAR(CDR(demodcl));
    maxdemodvar=give_cl_maxvar(CAR(demodcl));
    if(!(NFALSEP(memq(demodcl,GLOBAL(used_demodulators_global))))) {
      GLOBAL(used_demodulators_global)=cons(demodcl,GLOBAL(used_demodulators_global));
    }
    subsumed_term_list_ordinary_pred_(CDR(atom),CDR(demodatom));
    tmp0=GLOBAL(demodulate_flag_global);
    tmp1=GLOBAL(demodulate_constants_flag_global);
    tmp2=GLOBAL(new_demodulators_flag_global);
    tmp3=GLOBAL(demodulate_lit_flag_global);
    new=EOL;
    GLOBAL(demodulate_flag_global)=BOOL_F;
    GLOBAL(demodulate_constants_flag_global)=BOOL_F;
    GLOBAL(new_demodulators_flag_global)=BOOL_F;
    GLOBAL(demodulate_lit_flag_global)=BOOL_F;
    new=subst_deco_term(CAR(CDR(CDR(demodcl))),BOOL_T);
    if(atom==lit) {
      new=cons(MAKINUM(268435456^INUM(CAR(new))),CDR(new));
    }
    GLOBAL(demodulate_flag_global)=tmp0;
    GLOBAL(demodulate_constants_flag_global)=tmp1;
    GLOBAL(new_demodulators_flag_global)=tmp2;
    GLOBAL(demodulate_lit_flag_global)=tmp3;
    tmp2=EOL;
    for(nr=(MAKINUM(512)|maxdemodvar);!(nr<=MAKINUM(512));nr=MAKINUM(INUM(nr)-1)) {
      tmp1=STBL_VECTOR_REF(_star_var_val_table_star__velts0,nr);
      if(!(NUMBER_P(tmp1))&&1) {
        tmp2=cons(tmp1,tmp2);
      }
    }
    clear_z_vars_and_touched_excl_(maxdemodvar);
    var_set_flag_global=BOOL_F;
    alt_var_set_flag_global=BOOL_F;
    return demodulate_fully(new,tmp2,BOOL_T);
  }
}

SCM demodulate_lit(lit)
SCM lit;
{
  SCM maxdemodvar,demodatom,demodcl,tmp,atom,checkres,tmp0,tmp1,tmp2,tmp3,new;

  tmp=EOL;
  atom=cons(MAKINUM(268435456^INUM(CAR(lit))),CDR(lit));
  checkres=check_discr_tree_signed(GLOBAL(discr_tree_demod_atoms_global),atom);
  if(!(NFALSEP(checkres)))
    return lit;
  else {
    demodcl=checkres;
    demodatom=CAR(CDR(demodcl));
    maxdemodvar=give_cl_maxvar(CAR(demodcl));
    if(!(NFALSEP(memq(demodcl,GLOBAL(used_demodulators_global))))) {
      GLOBAL(used_demodulators_global)=cons(demodcl,GLOBAL(used_demodulators_global));
    }
    subsumed_term_list_ordinary_pred_(CDR(atom),CDR(demodatom));
    tmp0=GLOBAL(demodulate_flag_global);
    tmp1=GLOBAL(demodulate_constants_flag_global);
    tmp2=GLOBAL(new_demodulators_flag_global);
    tmp3=GLOBAL(demodulate_lit_flag_global);
    new=EOL;
    GLOBAL(demodulate_flag_global)=BOOL_F;
    GLOBAL(demodulate_constants_flag_global)=BOOL_F;
    GLOBAL(new_demodulators_flag_global)=BOOL_F;
    GLOBAL(demodulate_lit_flag_global)=BOOL_F;
    new=subst_deco_term(CAR(CDR(CDR(demodcl))),BOOL_T);
    GLOBAL(demodulate_flag_global)=tmp0;
    GLOBAL(demodulate_constants_flag_global)=tmp1;
    GLOBAL(new_demodulators_flag_global)=tmp2;
    GLOBAL(demodulate_lit_flag_global)=tmp3;
    clear_z_vars_and_touched_excl_(maxdemodvar);
    var_set_flag_global=BOOL_F;
    alt_var_set_flag_global=BOOL_F;
    tmp=demodulate_fully(new,EOL,BOOL_T);
    if(NFALSEP(tmp)&&!(NULL_P(tmp)))
      return tmp;
    else
      return lit;
  }
}

SCM demodulate_constant(const_nonkeyword)
SCM const_nonkeyword;
{
  SCM checkres,demodcl,demodlit;

  GLOBAL(nonunit_discr_flag_global)=BOOL_T;
  checkres=check_discr_tree_part(GLOBAL(discr_tree_demod_terms_global),cons(const_nonkeyword,EOL),EOL);
  if(!(NFALSEP(checkres)))
    return const_nonkeyword;
  else {
    demodcl=CAR(CDR(CDR(checkres)));
    demodlit=CAR(CDR(demodcl));
    return CAR(CDR(CDR(demodlit)));
  }
}

SCM demodulate_fully(term,done_terms,litflag)
SCM term,done_terms,litflag;
{
  SCM part,res,resend,str,new;

  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return term;
    else
    if(NFALSEP(GLOBAL(demodulate_constants_flag_global)))
      return demodulate_constant(term);
    else
      return term;
  }
  else
  if(NFALSEP(memq(term,done_terms)))
    return term;
  else
  if(!(1))
    return term;
  else {
    res=cons(EOL,EOL);
    resend=res;
    str=MAKINUM(65536);
    for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
      new=demodulate_fully(CAR(part),done_terms,BOOL_F);
      SET_CDR(resend,cons(new,EOL));
      if(resend==res) {
        if(NUMBER_P(new)) {
          if(MAKINUM(65535)>new) {
            str=GLOBAL(var_strength_global);
          }
          else {
            str=GLOBAL(const_strength_global);
          }
        }
        else {
          str=CAR(new);
        }
      }
      else
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=sum_fun_strengths(GLOBAL(var_strength_global),str);
        }
        else {
          str=sum_fun_strengths(GLOBAL(const_strength_global),str);
        }
      }
      else {
        str=sum_fun_strengths(CAR(new),str);
      }
      resend=CDR(resend);
    }
    SET_CAR(res,create_new_fun_pos_object(CAR(term),str));
    if(NFALSEP(litflag))
      return demodulate_lit(res);
    else
      return demodulate_composite(res);
  }
}

SCM may_be_demodulated_pred_(term)
SCM term;
{
  return BOOL_T;
}

SCM eq_lit_arg1(lit)
SCM lit;
{
  return CAR(CDR(lit));
}

SCM eq_lit_arg2(lit)
SCM lit;
{
  return CAR(CDR(CDR(lit)));
}

SCM eq_lit_type(lit)
SCM lit;
{
  return CAR(CDR(CDR(CDR(lit))));
}

SCM demodulate_fully_lit(term)
SCM term;
{
  SCM part,res,resend,str,new;

  res=cons(EOL,EOL);
  resend=res;
  str=MAKINUM(65536);
  for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
    new=demodulate_fully(CAR(part),EOL,BOOL_F);
    SET_CDR(resend,cons(new,EOL));
    if(resend==res) {
      if(NUMBER_P(new)) {
        if(MAKINUM(65535)>new) {
          str=GLOBAL(var_strength_global);
        }
        else {
          str=GLOBAL(const_strength_global);
        }
      }
      else {
        str=CAR(new);
      }
    }
    else
    if(NUMBER_P(new)) {
      if(MAKINUM(65535)>new) {
        str=sum_fun_strengths(GLOBAL(var_strength_global),str);
      }
      else {
        str=sum_fun_strengths(GLOBAL(const_strength_global),str);
      }
    }
    else {
      str=sum_fun_strengths(CAR(new),str);
    }
    resend=CDR(resend);
  }
  SET_CAR(res,create_new_fun_pos_object(CAR(term),str));
  return res;
}

SCM demodulate_with_clauses_ok(fullcl)
SCM fullcl;
{
  return BOOL_F;
}

SCM demodulate_with_clauses(fullcl)
SCM fullcl;
{
  SCM foundflag,ans_inf,history,oldhistory,infolst,tmp,res,new_var4,new_var5,new_var1,new_var2,new_var3;

  res=EOL;
  tmp=EOL;
  infolst=CAR(CDR(CDR(CAR(fullcl))));
  oldhistory=EOL;
  history=EOL;
  ans_inf=EOL;
  foundflag=BOOL_F;
  GLOBAL(used_demodulators_global)=EOL;
  GLOBAL(demodulate_lit_flag_global)=BOOL_T;
  for(new_var4=CDR(fullcl),new_var5=infolst,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=demodulate_with_clauses_fn315(&foundflag,&tmp,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  res=new_var1;
  GLOBAL(demodulate_lit_flag_global)=BOOL_F;
  if(!(NFALSEP(foundflag)))
    return BOOL_F;
  else {
    infolst=map1(demodulate_with_clauses_fn316,res);
    res=map1(demodulate_with_clauses_fn317,res);
    if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
      newline(cur_output_port());
      display(const_343,cur_output_port());
      newline(cur_output_port());
      print_clause(fullcl);
      newline(cur_output_port());
      for_each1(demodulate_with_clauses_fn318,GLOBAL(used_demodulators_global));
      print_clause(cons(EOL,res));
      newline(cur_output_port());
    }
    oldhistory=CAR(CDR(CDR(CDR(CDR(CDR(CAR(fullcl)))))));
    if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
      history=append2(cons(binarydemod_symb,CDR(make_demod_history(GLOBAL(used_demodulators_global)))),oldhistory);
    }
    else {
      history=cons(binres_demod_symb,cons(MAKINUM(0),cons(oldhistory,cons(MAKINUM(0),cons(MAKINUM(0),cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL))))));
    }
    ans_inf=BOOL_F;
    res=handle_derived_inf_cl_pair(cons(infolst,res),history,BOOL_F,ans_inf,BOOL_F);
    return UNSPECIFIED;
  }
}

SCM demodulate_with_clauses_fn318(x)
SCM x;
{
  print_full_clause(x);
  return newline(cur_output_port());
}

SCM demodulate_with_clauses_fn317(x)
SCM x;
{
  if(!(NFALSEP(CAR(CAR(x)))))
    return copy_nonground_term(CDR(x));
  else
    return CDR(x);
}

SCM demodulate_with_clauses_fn316(x)
SCM x;
{
  return CAR(x);
}

SCM demodulate_with_clauses_fn315(foundflag,tmp,lit,info)
SCM *foundflag,*tmp;
SCM lit,info;
{
  *tmp=demodulate_lit(lit);
  if(!(*tmp==lit)) {
    *foundflag=BOOL_T;
    return cons(cons(BOOL_T,cons(MAKINUM(1),info)),*tmp);
  }
  else
    return cons(cons(BOOL_F,cons(MAKINUM(1),info)),*tmp);
}

SCM factor_sos(soslist)
SCM soslist;
{
  SCM newlitinflist,litinflist,purecl,cl,sospart;

  cl=EOL;
  purecl=EOL;
  litinflist=EOL;
  newlitinflist=EOL;
  if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
    newline(cur_output_port());
    display(const_344,cur_output_port());
    newline(cur_output_port());
  }
  for(sospart=soslist;!(NULL_P(sospart)||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));sospart=CDR(sospart)) {
    cl=CAR(sospart);
    purecl=CDR(cl);
    litinflist=CAR(CDR(CDR(CAR(cl))));
    if(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))||NFALSEP(positive_cl_pred_(purecl))) {
      newlitinflist=map1(factor_sos_fn320,litinflist);
      factor(newlitinflist,cl);
    }
  }
  if(GLOBAL(display_info_level_global)>=MAKINUM(50)) {
    newline(cur_output_port());
    display(const_345,cur_output_port());
    return newline(cur_output_port());
  }
  else
    return UNSPECIFIED;
}

SCM factor_sos_fn320(inf)
SCM inf;
{
  return cons(BOOL_T,cons((NFALSEP(GLOBAL(ordered_factor_flag_global)) ? NOT(SBOOL(ZERO_P(MAKINUM(2)&CAR(inf)))) : BOOL_F),inf));
}

SCM factor(infolist,fullcl)
SCM infolist,fullcl;
{
  SCM inf_fullcl_pr,fullcl__1,infolist__2;

  if(!(NULL_P(CDR(CDR(fullcl))))&&(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))||((!(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global)))&&NFALSEP(positive_cl_pred_(CDR(fullcl))))||(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))&&NFALSEP(negative_cl_pred_(CDR(fullcl))))))) {
    GLOBAL(locfactorpool_global)=EOL;
    GLOBAL(factorpool_global)=EOL;
    GLOBAL(subs_factor_derived_flag_global)=BOOL_F;
    factor_aux(infolist,fullcl);
    for(;!(NULL_P(GLOBAL(factorpool_global))||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));) {
      if(!(NULL_P(CDR(GLOBAL(factorpool_global))))) {
        GLOBAL(factorpool_global)=filter_map(factor_fn323,GLOBAL(factorpool_global));
      }
      inf_fullcl_pr=CAR(GLOBAL(factorpool_global));
      fullcl__1=CDR(inf_fullcl_pr);
      infolist__2=CAR(inf_fullcl_pr);
      GLOBAL(factorpool_global)=CDR(GLOBAL(factorpool_global));
      if(0) {
        handle_derived_inf_cl_pair_aux(inf_fullcl_pr,BOOL_T);
        factor_aux(infolist__2,fullcl__1);
      }
      else
      if(NULL_P(CDR(CDR(fullcl__1)))||!(NFALSEP(havealready_clause_pred_(CAR(fullcl__1),CDR(fullcl__1))))) {
        handle_derived_inf_cl_pair_aux(inf_fullcl_pr,BOOL_T);
        factor_aux(infolist__2,fullcl__1);
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM factor_fn323(cl1)
SCM cl1;
{
  if(NFALSEP(member_if_inst1(cl1,factor_fn324,GLOBAL(factorpool_global))))
    return BOOL_F;
  else
    return cl1;
}

SCM factor_fn324(cl1,cl2)
SCM cl1,cl2;
{
  return SBOOL(!(cl1==cl2)&&NFALSEP(subsumed_clause_pred_(CDR(cl1),CDR(cl2))));
}

SCM factor_aux(infolist,fullclause)
SCM infolist,fullclause;
{
  SCM res,lit_ordnr,inf_part,cl_part,slow_lit_ordnr,slow_info_part,slow_cl_part,clause,clinf,maxvar,history,slow_list_ordnr,xlit,xlitinf,xlitnr,ylit,ylitinf,new_var1;

  clause=CDR(fullclause);
  clinf=CAR(fullclause);
  maxvar=give_cl_maxvar(clinf);
  history=CAR(CDR(CDR(CDR(CDR(CDR(CAR(fullclause)))))));
  slow_list_ordnr=MAKINUM(0);
  GLOBAL(subs_factor_derived_flag_global)=BOOL_F;
  GLOBAL(locfactorpool_global)=EOL;
  for(slow_cl_part=clause,slow_info_part=infolist,slow_lit_ordnr=MAKINUM(1);
      !(NULL_P(slow_cl_part));
      slow_cl_part=CDR(slow_cl_part),slow_info_part=CDR(slow_info_part),slow_lit_ordnr=MAKINUM(1+INUM(slow_lit_ordnr))) {
    xlit=CAR(slow_cl_part);
    xlitinf=CAR(slow_info_part);
    xlitnr=CAR(CDR(xlitinf));
    if(!(BOOL_T==xlitnr))
      for(cl_part=CDR(slow_cl_part),inf_part=CDR(slow_info_part),lit_ordnr=MAKINUM(1);
          !(NULL_P(cl_part));
          cl_part=CDR(cl_part),inf_part=CDR(inf_part),lit_ordnr=MAKINUM(1+INUM(lit_ordnr))) {
        ylit=CAR(cl_part);
        ylitinf=CAR(inf_part);
        if(!(xlitnr==CAR(CDR(ylitinf)))||((xlitnr==BOOL_F)||NFALSEP(GLOBAL(hyper_strategy_flag_global)))) {
          GLOBAL(used_demodulators_global)=EOL;
          if(NFALSEP(factor_unify_ordinary(ylit,xlit))) {
            res=subst_deco_cl(remove_at_place(cl_part,clause),merge_infos(slow_info_part,inf_part,infolist),BOOL_F,BOOL_T);
            clear_x_vars_and_touched_excl_(maxvar);
            fac_vars_set_global=BOOL_F;
            var_set_flag_global=BOOL_F;
            alt_var_set_flag_global=BOOL_F;
            if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
              history=cons(factor_symb,history);
            }
            else
            if(NULL_P(GLOBAL(used_demodulators_global))) {
              history=cons(factor_symb,cons(MAKINUM(0),cons(history,cons(slow_list_ordnr,cons(lit_ordnr,EOL)))));
            }
            else {
              history=cons(factor_symb,cons(MAKINUM(0),cons(history,cons(slow_list_ordnr,cons(lit_ordnr,cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL))))));
            }
            res=handle_derived_inf_cl_pair(res,history,BOOL_T,BOOL_F,BOOL_F);
            if(NFALSEP(GLOBAL(foundflag_global))) {
              slow_cl_part=GLOBAL(listofnull_global);
              cl_part=GLOBAL(listofnull_global);
            }
            else {
              new_var1=NOT(res);
              if(NFALSEP(new_var1)) ;
              else
              if(NFALSEP(subsumed_clause_pred_(fullclause,CDR(res)))) {
                GLOBAL(subs_factor_derived_flag_global)=BOOL_T;
                fac_vars_set_global=BOOL_F;
                var_set_flag_global=BOOL_F;
                GLOBAL(locfactorpool_global)=EOL;
                GLOBAL(factorpool_global)=cons(res,GLOBAL(factorpool_global));
                slow_cl_part=GLOBAL(listofnull_global);
                cl_part=GLOBAL(listofnull_global);
              }
              else {
                GLOBAL(locfactorpool_global)=cons(res,GLOBAL(locfactorpool_global));
              }
            }
          }
          else {
            if(NFALSEP(fac_vars_set_global)||(NFALSEP(var_set_flag_global)||NFALSEP(alt_var_set_flag_global))) {
              clear_x_vars_and_touched_excl_(maxvar);
              fac_vars_set_global=BOOL_F;
              var_set_flag_global=BOOL_F;
              alt_var_set_flag_global=BOOL_F;
            }
          }
        }
      }
  }
  GLOBAL(factorpool_global)=append2(GLOBAL(factorpool_global),GLOBAL(locfactorpool_global));
  return UNSPECIFIED;
}

SCM merge_infos(kept_infolist_place,removed_infolist_place,infolist)
SCM kept_infolist_place,removed_infolist_place,infolist;
{
  SCM ipart,new_orig,res,resend,new_var1;

  new_orig=append2(CAR(kept_infolist_place),CDR(CDR(CAR(removed_infolist_place))));
  res=cons(EOL,EOL);
  resend=res;
  for(ipart=infolist;!(NULL_P(ipart));ipart=CDR(ipart)) {
    new_var1=SBOOL(ipart==removed_infolist_place);
    if(NFALSEP(new_var1)) ;
    else
    if(ipart==kept_infolist_place) {
      SET_CDR(resend,cons(new_orig,EOL));
      resend=CDR(resend);
    }
    else {
      SET_CDR(resend,cons(CAR(ipart),EOL));
      resend=CDR(resend);
    }
  }
  return CDR(res);
}

SCM make_unique_answer_pair(pr,history,ans_inf)
SCM pr,history,ans_inf;
{
  SCM fact_pr,tmp_pr,tmp_pr1,case_pr,caseans,alit1inf,inf,cl,alit1pl,alit2pl,part,infpart;

  alit1pl=member_if(make_unique_answer_pair_fn327,CDR(pr));
  alit2pl=member_if(make_unique_answer_pair_fn328,CDR(alit1pl));
  if(!(NFALSEP(alit1pl)))
    return pr;
  else
  if(!(NFALSEP(ans_computable_lit_pred_(CAR(alit1pl)))))
    return const_346;
  else
  if(!(NFALSEP(alit2pl)))
    return pr;
  else
  if(!(NFALSEP(ans_computable_lit_pred_(CAR(alit2pl)))))
    return const_347;
  else
  if(NFALSEP(term_list_equal_strong_pred_(CDR(CAR(alit1pl)),CDR(CAR(alit2pl)))))
    return pr;
  else {
    cl=CDR(pr);
    inf=CAR(pr);
    alit1inf=EOL;
    caseans=EOL;
    case_pr=BOOL_F;
    tmp_pr1=EOL;
    tmp_pr=EOL;
    fact_pr=BOOL_F;
    if(!(NFALSEP(ans_computable_term_pred_(CAR(ans_inf),BOOL_T)))) {
      case_pr=const_348;
    }
    else {
      tmp_pr1=make_rest_inf_cl(cl,CAR(alit1pl),inf);
      tmp_pr=make_rest_inf_cl(CDR(tmp_pr1),CAR(alit2pl),CAR(tmp_pr1));
      for(part=cl,infpart=inf;
          !(part==alit1pl);
          part=CDR(part),infpart=CDR(infpart)) ;
      alit1inf=CAR(infpart);
      caseans=subst_deco_term_nodemodulate(((CAR(CDR(alit1inf))==CAR(CDR(ans_inf))) ? cons(GLOBAL(ans_pred_nr_global),cons(cons(GLOBAL(if_fun_nr_global),cons(CAR(ans_inf),cons(CAR(CDR(CAR(alit2pl))),cons(CAR(CDR(CAR(alit1pl))),EOL)))),EOL)) : cons(GLOBAL(ans_pred_nr_global),cons(cons(GLOBAL(if_fun_nr_global),cons(CAR(ans_inf),cons(CAR(CDR(CAR(alit1pl))),cons(CAR(CDR(CAR(alit2pl))),EOL)))),EOL))),BOOL_T);
      case_pr=cons(cons(alit1inf,CAR(tmp_pr)),cons(caseans,CDR(tmp_pr)));
    }
    if(NFALSEP(factor_unify_ordinary(CAR(alit1pl),CAR(alit2pl)))) {
      fact_pr=subst_deco_cl(CDR(tmp_pr1),CAR(tmp_pr1),BOOL_F,fac_vars_set_global);
    }
    if(NFALSEP(fac_vars_set_global)) {
      clear_x_vars_and_touched_excl_(CAR(CDR(CDR(ans_inf))));
      clear_y_vars_and_touched_excl_(CAR(CDR(CDR(CDR(ans_inf)))));
    }
    if(NFALSEP(case_pr)&&NFALSEP(fact_pr)) {
      GLOBAL(res)=handle_derived_inf_cl_pair(case_pr,history,BOOL_F,BOOL_F,BOOL_F);
      return fact_pr;
    }
    else
    if(NFALSEP(case_pr))
      return case_pr;
    else
    if(NFALSEP(fact_pr))
      return fact_pr;
    else
      return const_349;
  }
}

SCM make_unique_answer_pair_fn328(x)
SCM x;
{
  return answer_lit_pred_(x);
}

SCM make_unique_answer_pair_fn327(x)
SCM x;
{
  return answer_lit_pred_(x);
}

SCM several_answer_literals_pred_(purecl)
SCM purecl;
{
  SCM nr,part;

  nr=MAKINUM(0);
  for(part=purecl;!(NULL_P(part)||(nr==MAKINUM(2)));part=CDR(part))
    if(NFALSEP(answer_lit_pred_(CAR(part)))) {
      nr=MAKINUM(1+INUM(nr));
    }
  return SBOOL(nr==MAKINUM(2));
}

SCM ans_computable_lit_pred_(lit)
SCM lit;
{
  SCM new_var1;

  if(NULL_P(GLOBAL(ans_prohibited_funnrs_global))) {
    if(NULL_P(GLOBAL(ans_prohibited_prednrs_global)))
      new_var1=SBOOL(NULL_P(GLOBAL(ans_prohibited_constnrs_global)));
    else
      new_var1=BOOL_F;
  }
  else
    new_var1=BOOL_F;
  if(NFALSEP(new_var1))
    return new_var1;
  else
    return ans_computable_term_pred_(CAR(CDR(lit)),BOOL_F);
}

SCM ans_computable_term_pred_(x,litflag)
SCM x,litflag;
{
  SCM tmp_var2,tmp_var1,new_var1;

tailrecursion:
  if(PAIR_P(x)) {
    if(GLOBAL(if_fun_nr_global)==(MAKINUM(534773760)&CAR(x))) {
      if(NFALSEP(ans_computable_term_pred_(CAR(x),BOOL_T))) {
        if(NFALSEP(ans_computable_term_pred_(CAR(CDR(x)),BOOL_F))) {
          tmp_var1=CAR(CDR(CDR(x)));
          tmp_var2=BOOL_F;
          x=tmp_var1;
          litflag=tmp_var2;
          goto tailrecursion;
        }
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
    else
    if(!(NFALSEP(memq(MAKINUM(266338304)&CAR(x),(NFALSEP(litflag) ? GLOBAL(ans_prohibited_prednrs_global) : GLOBAL(ans_prohibited_funnrs_global))))))
      return every_pred_(ans_computable_term_pred__fn330,CDR(x));
    else
      return BOOL_F;
  }
  else {
    if(NUMBER_P(x))
      new_var1=SBOOL(x<=MAKINUM(65535));
    else
      new_var1=BOOL_F;
    if(NFALSEP(new_var1))
      return new_var1;
    else
      return NOT(memq(x,GLOBAL(ans_prohibited_constnrs_global)));
  }
}

SCM ans_computable_term_pred__fn330(y)
SCM y;
{
  return ans_computable_term_pred_(y,BOOL_F);
}

SCM sort_clause(clause,pair_flag)
SCM clause,pair_flag;
{
  return sort_clause_aux(clause,length(clause),pair_flag);
}

SCM sort_clause_aux(cl,len,pair_flag)
SCM cl,len,pair_flag;
{
  SCM l1,l2,s;

  if(len<MAKINUM(2))
    return cl;
  else
  if(len==MAKINUM(2)) {
    if(NFALSEP((NFALSEP(pair_flag) ? _grtr__fun_ordering_pred_(CAR(CDR(CAR(CDR(cl)))),CAR(CDR(CAR(cl)))) : _grtr__fun_ordering_pred_(CAR(CAR(CDR(cl))),CAR(CAR(cl))))))
      return cons(CAR(CDR(cl)),cons(CAR(cl),EOL));
    else
      return cl;
  }
  else {
    l1=MAKINUM(INUM(len)/2);
    l2=MAKINUM(INUM(len)-INUM(l1));
    s=split_list(cl,l1);
    return sort_merge_clauses(sort_clause_aux(CAR(s),l1,pair_flag),sort_clause_aux(CDR(s),l2,pair_flag),pair_flag);
  }
}

SCM sort_merge_clauses(cl1,cl2,pair_flag)
SCM cl1,cl2,pair_flag;
{
  if(NULL_P(cl1))
    return cl2;
  else
  if(NULL_P(cl2))
    return cl1;
  else
  if(NFALSEP(pair_flag)&&NFALSEP(_grtr__fun_ordering_pred_(CAR(CDR(CAR(cl1))),CAR(CDR(CAR(cl2))))))
    return cons(CAR(cl1),sort_merge_clauses(CDR(cl1),cl2,BOOL_T));
  else
  if(!(NFALSEP(pair_flag))&&NFALSEP(_grtr__fun_ordering_pred_(CAR(CAR(cl1)),CAR(CAR(cl2)))))
    return cons(CAR(cl1),sort_merge_clauses(CDR(cl1),cl2,BOOL_F));
  else
    return cons(CAR(cl2),sort_merge_clauses(cl1,CDR(cl2),pair_flag));
}

SCM lit_weight(lit)
SCM lit;
{
  if(!(NFALSEP(GLOBAL(classical_synth_stratflag_global)))&&NFALSEP(answer_pred_pred_(CAR(lit))))
    return MAKINUM(0);
  else
    return composite_weight(lit);
}

SCM answer_pred_pred_(pred)
SCM pred;
{
  return SBOOL(GLOBAL(ans_pred_nr_global)==(MAKINUM(534773760)&pred));
}

SCM countable_pred_pred_(pred)
SCM pred;
{
  if(NFALSEP(GLOBAL(classical_synth_stratflag_global)))
    return BOOL_T;
  else
    return NOT(answer_pred_pred_(pred));
}

SCM answer_lit_pred_(lit)
SCM lit;
{
  return SBOOL(GLOBAL(ans_pred_nr_global)==(MAKINUM(534773760)&CAR(lit)));
}

SCM composite_weight(comp)
SCM comp;
{
  SCM size,el;

  size=(MAKINUM(2016)&CAR(comp));
  if(MAKINUM(2016)==size) {
    size=MAKINUM(1);
    comp=CDR(comp);
    for(;!(NULL_P(comp));) {
      el=CAR(comp);
      if(NUMBER_P(el)) {
        size=MAKINUM(1+INUM(size));
      }
      else {
        size=MAKINUM(INUM(size)+INUM(composite_weight(el)));
      }
      comp=CDR(comp);
    }
    return size;
  }
  else
    return MAKINUM(INUM(size)>>5);
}

SCM predsymb_bit(pred)
SCM pred;
{
  return VECTOR_REF(GLOBAL(predsymb_bit_vector_global),MAKINUM(INUM(pred)>>21));
}

SCM make_raw_inf_cl_pair(xcl,ycl,xinf,yinf)
SCM xcl,ycl,xinf,yinf;
{
  SCM tmp;

  tmp=make_raw_inf_cl_pair_aux(xcl,ycl,xinf,yinf);
  return tmp;
}

SCM make_raw_inf_cl_pair_aux(xcl,ycl,xinf,yinf)
SCM xcl,ycl,xinf,yinf;
{
  SCM new_yrest,new_xrest;

  new_yrest=subst_deco_cl(ycl,yinf,MAKINUM(2),yvars_set_flag_global);
  if(NFALSEP(new_yrest)) {
    new_xrest=subst_deco_cl(xcl,xinf,MAKINUM(1),xvars_set_flag_global);
    if(NFALSEP(new_xrest))
      return cons(my_append_excl_(CAR(new_yrest),CAR(new_xrest)),my_append_excl_(CDR(new_yrest),CDR(new_xrest)));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM make_rest_inf_cl(cl,lit,inf)
SCM cl,lit,inf;
{
  SCM passed_cl__1,passed_inf,passed_cl,clrest,infrest,clrest__2;

  if(NFALSEP(inf)) {
    if(NULL_P(CDR(cl)))
      return cons(EOL,EOL);
    else {
      passed_cl=EOL;
      passed_inf=EOL;
      for(clrest=cl,infrest=inf;
          !(CAR(clrest)==lit);
          clrest=CDR(clrest),infrest=CDR(infrest)) {
        passed_cl=cons(CAR(clrest),passed_cl);
        passed_inf=cons(CAR(infrest),passed_inf);
      }
      return cons(my_append_excl_(passed_inf,CDR(infrest)),my_append_excl_(passed_cl,CDR(clrest)));
    }
  }
  else
  if(NULL_P(CDR(cl)))
    return cons(EOL,EOL);
  else {
    passed_cl__1=EOL;
    for(clrest__2=cl;!(CAR(clrest__2)==lit);clrest__2=CDR(clrest__2)) {
      passed_cl__1=cons(CAR(clrest__2),passed_cl__1);
    }
    return cons(BOOL_F,my_append_excl_(passed_cl__1,CDR(clrest__2)));
  }
}

SCM subst_deco_cl(cl,clinf,nr,vars_set_flag)
SCM cl,clinf,nr,vars_set_flag;
{
  SCM clres,clresend,infres,infresend,changed_flag,lit,litinf,litinflstpart;

  if(NULL_P(cl))
    return cons(EOL,EOL);
  else {
    clres=cons(EOL,EOL);
    clresend=clres;
    infres=cons(EOL,EOL);
    infresend=infres;
    changed_flag=BOOL_T;
    lit=EOL;
    litinf=EOL;
    litinflstpart=clinf;
    for(;!(NULL_P(cl));) {
      lit=CAR(cl);
      if(NFALSEP(clinf)) {
        litinf=CAR(clinf);
      }
      else {
        litinf=EOL;
      }
      if((NFALSEP(vars_set_flag)&&ZERO_P(MAKINUM(65536)&CAR(lit)))||NFALSEP(GLOBAL(new_demodulators_flag_global))) {
        if(NFALSEP(answer_pred_pred_(CAR(lit)))) {
          lit=subst_deco_term_nodemodulate(lit,BOOL_T);
          changed_flag=BOOL_T;
        }
        else {
          lit=subst_deco_term(lit,BOOL_T);
          changed_flag=BOOL_T;
        }
      }
      else {
        lit=copy_nonground_term(lit);
        changed_flag=BOOL_F;
      }
      if(NFALSEP(lit)) {
        SET_CDR(clresend,cons(lit,EOL));
        clresend=CDR(clresend);
        if(NFALSEP(nr)) {
          SET_CDR(infresend,cons(cons(changed_flag,cons(nr,litinf)),EOL));
        }
        else {
          SET_CDR(infresend,cons(cons(changed_flag,CDR(litinf)),EOL));
        }
        infresend=CDR(infresend);
        cl=CDR(cl);
        if(NFALSEP(clinf)) {
          clinf=CDR(clinf);
        }
      }
      else {
        cl=EOL;
        clres=BOOL_F;
      }
    }
    if(NFALSEP(clres))
      return cons(CDR(infres),CDR(clres));
    else
      return BOOL_F;
  }
}

SCM tautology_pure_cl_pred_(list__1)
SCM list__1;
{
tailrecursion:
  if(NULL_P(list__1)||NULL_P(CDR(list__1)))
    return BOOL_F;
  else
  if(NFALSEP(member_polarity_lit(BOOL_F,CAR(list__1),CDR(list__1))))
    return BOOL_T;
  else {
    list__1=CDR(list__1);
    goto tailrecursion;
  }
}

SCM remove_double_lits_excl_(inf_list,lit_list,pos_only_flag)
SCM inf_list,lit_list,pos_only_flag;
{
  SCM lit_list_part,inf_list_part,tmp;

  if(NULL_P(lit_list))
    return cons(inf_list,lit_list);
  else {
    lit_list_part=lit_list;
    inf_list_part=inf_list;
    tmp=EOL;
    for(;!(NULL_P(CDR(lit_list_part)));) {
      tmp=CDR(lit_list_part);
      if((!(NFALSEP(pos_only_flag))||NFALSEP((!(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))) ? SBOOL(!(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(tmp)))))) : SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(tmp))))))))&&NFALSEP(member_polarity_lit(BOOL_T,CAR(tmp),CDR(tmp)))) {
        SET_CDR(lit_list_part,CDR(tmp));
        SET_CDR(inf_list_part,CDR(CDR(inf_list_part)));
      }
      else {
        lit_list_part=tmp;
        inf_list_part=CDR(inf_list_part);
      }
    }
    if((!(NFALSEP(pos_only_flag))||NFALSEP((!(NFALSEP(GLOBAL(neg_hyper_strategy_flag_global))) ? SBOOL(!(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(lit_list)))))) : SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(lit_list))))))))&&NFALSEP(member_polarity_lit(BOOL_T,CAR(lit_list),CDR(lit_list))))
      return cons(CDR(inf_list),CDR(lit_list));
    else
      return cons(inf_list,lit_list);
  }
}

SCM unit_handle_cl_excl_(inf_list,lit_list,history)
SCM inf_list,lit_list,history;
{
  SCM rescddr,rescdr,checkres,inf,tmp_inf_list,lit,tmp_lit_lst,cut_flag,foreign_checkres_flag,subsume_flag,inf_list_part,lit_list_part,inf_list__2,lit_list__1,orig_lit_list,litnr,part,leafcl,leafclpure,leafclinf;

  if(NULL_P(lit_list))
    return cons(history,cons(inf_list,lit_list));
  else {
    orig_lit_list=copy_list(lit_list);
    lit_list__1=cons(EOL,lit_list);
    inf_list__2=cons(EOL,inf_list);
    lit_list_part=lit_list__1;
    inf_list_part=inf_list__2;
    subsume_flag=BOOL_F;
    foreign_checkres_flag=BOOL_F;
    cut_flag=BOOL_F;
    GLOBAL(cut_clauses_global)=EOL;
    GLOBAL(used_demodulators_global)=EOL;
    for(litnr=MAKINUM(1);!(NULL_P(CDR(lit_list_part))||NFALSEP(subsume_flag));litnr=MAKINUM(1+INUM(litnr))) {
      cut_flag=BOOL_F;
      foreign_checkres_flag=BOOL_F;
      tmp_lit_lst=CDR(lit_list_part);
      lit=CAR(tmp_lit_lst);
      tmp_inf_list=CDR(inf_list_part);
      inf=CAR(tmp_inf_list);
      checkres=BOOL_F;
      if(NFALSEP(answer_lit_pred_(lit))) {
        checkres=BOOL_F;
      }
      else {
        checkres=check_discr_tree(GLOBAL(discr_tree_global),lit);
      }
      if(!(NFALSEP(answer_lit_pred_(lit)))) {
        for(part=GLOBAL(discr_tree_list_global);!(NULL_P(part)||NFALSEP(checkres));part=CDR(part)) {
          checkres=check_discr_tree(CAR(part),lit);
          if(!(NFALSEP(checkres)&&(!(NULL_P(CDR(checkres)))&&(!(NULL_P(CDR(CDR(checkres))))&&!((MAKINUM(268435456)&CAR(lit))==(MAKINUM(268435456)&CAR(CAR(CDR(CAR(CDR(CDR(checkres)))))))))))) {
            checkres=BOOL_F;
          }
        }
        if(NFALSEP(checkres)) {
          foreign_checkres_flag=BOOL_T;
        }
      }
      if(!(NFALSEP(checkres))&&NFALSEP(commutative_fun_pred_(CAR(lit)))) {
        checkres=check_discr_tree(GLOBAL(discr_tree_global),cons(CAR(lit),cons(CAR(CDR(CDR(lit))),cons(CAR(CDR(lit)),CDR(CDR(CDR(lit)))))));
      }
      if(NFALSEP(checkres)) {
        rescdr=CDR(checkres);
        if(NULL_P(rescdr))
          rescddr=EOL;
        else
          rescddr=CDR(rescdr);
        if(NULL_P(rescddr)) {
          if(NFALSEP(CAR(inf))) {
            if(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))) {
              if(NULL_P(rescdr)||NULL_P(CAR(rescdr))) {
                SET_CDR(lit,CDR(CAR(checkres)));
                SET_CDR(checkres,cons(lit,rescddr));
              }
              else {
                SET_CAR(tmp_lit_lst,CAR(rescdr));
              }
            }
            else
            if(NULL_P(CAR(checkres))) {
              SET_CDR(lit,CDR(CAR(rescdr)));
              SET_CAR(checkres,lit);
            }
            else {
              SET_CAR(tmp_lit_lst,CAR(checkres));
            }
          }
        }
        else {
          leafcl=CAR(rescddr);
          leafclpure=CDR(leafcl);
          leafclinf=CAR(leafcl);
          if((MAKINUM(268435456)&CAR(lit))==(MAKINUM(268435456)&CAR(CAR(leafclpure)))) {
            if(NFALSEP(GLOBAL(discr_tree_subsume_stratflag_global))||!(NULL_P(CDR(orig_lit_list)))) {
              subsume_flag=BOOL_T;
              GLOBAL(subsuming_clause_global)=leafcl;
            }
          }
          else {
            if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
              if(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))||NFALSEP(positive_cl_pred_(orig_lit_list))) {
                cut_flag=BOOL_T;
                GLOBAL(cut_clauses_global)=cons(leafcl,GLOBAL(cut_clauses_global));
              }
            }
            else {
              cut_flag=BOOL_T;
              GLOBAL(cut_clauses_global)=cons(leafcl,GLOBAL(cut_clauses_global));
            }
          }
        }
      }
      if(!(NFALSEP(subsume_flag))) {
        if(NFALSEP(cut_flag)) {
          SET_CDR(lit_list_part,CDR(tmp_lit_lst));
          SET_CDR(inf_list_part,CDR(tmp_inf_list));
          history=append2(cons(cut_symb,cons(clinfo_clnr(CAR(CAR(GLOBAL(cut_clauses_global)))),EOL)),history);
        }
        else {
          lit_list_part=tmp_lit_lst;
          inf_list_part=tmp_inf_list;
        }
      }
    }
    if(NFALSEP(subsume_flag)) {
      GLOBAL(forward_subsumed_unit_nr_global)=MAKINUM(1+INUM(GLOBAL(forward_subsumed_unit_nr_global)));
      if(GLOBAL(display_info_level_global)>=MAKINUM(80)) {
        newline(cur_output_port());
        display(const_350,cur_output_port());
        newline(cur_output_port());
        print_clause(GLOBAL(subsuming_clause_global));
        newline(cur_output_port());
      }
      else
      if(NFALSEP(GLOBAL(display_info_char_flag_global)))
        display(const_351,cur_output_port());
      return BOOL_F;
    }
    else {
      if(!(NULL_P(GLOBAL(cut_clauses_global)))) {
        GLOBAL(simple_unit_cutoff_nr_global)=MAKINUM(1+INUM(GLOBAL(simple_unit_cutoff_nr_global)));
      }
      if(!(NULL_P(GLOBAL(cut_clauses_global)))&&(GLOBAL(display_info_level_global)>=MAKINUM(80))) {
        newline(cur_output_port());
        display(const_352,cur_output_port());
        newline(cur_output_port());
        for_each1(unit_handle_cl_excl__fn332,GLOBAL(cut_clauses_global));
      }
      return cons(history,cons(CDR(inf_list__2),CDR(lit_list__1)));
    }
  }
}

SCM unit_handle_cl_excl__fn332(x)
SCM x;
{
  print_clause(x);
  return newline(cur_output_port());
}

SCM full_unit_cutoff_excl_(inf_list,fullcl)
SCM inf_list,fullcl;
{
  SCM history,distance,clhistsublist,res,len,lit_list,clauseinf,new_var1;

  clauseinf=CAR(fullcl);
  lit_list=CDR(fullcl);
  len=MAKINUM(10000);
  res=EOL;
  clhistsublist=CDR(CDR(CDR(CDR(CDR(clauseinf)))));
  distance=CAR(CDR(clhistsublist));
  history=CAR(clhistsublist);
  len=length(lit_list);
  if(!(NFALSEP(GLOBAL(int_logic_flag_global)))&&(!(NFALSEP(GLOBAL(hyper_strategy_flag_global)))||(NFALSEP(GLOBAL(simple_history_stratflag_global))||NFALSEP(positive_cl_pred_(lit_list))))) {
    res=full_unit_cutoff_double_excl_(clauseinf,inf_list,lit_list,history);
    history=CAR(res);
    inf_list=CAR(CDR(res));
    lit_list=CDR(CDR(res));
  }
  if(!(len==length(lit_list))) {
    GLOBAL(double_unit_cutoff_nr_global)=MAKINUM(1+INUM(GLOBAL(double_unit_cutoff_nr_global)));
    clauseinf=make_clause_info(lit_list,history,distance);
    fullcl=make_kept_clause(clauseinf,cons(inf_list,lit_list));
    clauseinf=CAR(fullcl);
    lit_list=CDR(fullcl);
  }
  len=MAKINUM(10000);
  for(;!((len==length(lit_list))||NFALSEP(empty_cl_pred_(lit_list)));) {
    len=length(lit_list);
    for_each1(rename_x_to_y_term_excl_,lit_list);
    res=full_unit_cutoff_aux_excl_(clauseinf,inf_list,lit_list,history);
    history=CAR(res);
    inf_list=CAR(CDR(res));
    lit_list=CDR(CDR(res));
    if(NFALSEP(empty_cl_pred_(lit_list))) {
      clauseinf=cons(MAKINUM(0),cons(MAKINUM(0),cons(EOL,cons(MAKINUM(0),cons(MAKINUM(0),cons(history,EOL))))));
      if(!(NULL_P(lit_list))) {
        clauseinf=make_clause_info(lit_list,history,distance);
        fullcl=make_kept_clause(clauseinf,cons(inf_list,lit_list));
        lit_list=CDR(fullcl);
      }
    }
    else {
      new_var1=SBOOL(len==length(lit_list));
      if(NFALSEP(new_var1)) ;
      else {
        GLOBAL(full_unit_cutoff_nr_global)=MAKINUM(1+INUM(GLOBAL(full_unit_cutoff_nr_global)));
        clauseinf=make_clause_info(lit_list,history,distance);
        fullcl=make_kept_clause(clauseinf,cons(inf_list,lit_list));
        clauseinf=CAR(fullcl);
        lit_list=CDR(fullcl);
      }
    }
  }
  for_each1(rename_y_to_x_term_excl_,lit_list);
  return cons(inf_list,cons(clauseinf,lit_list));
}

SCM full_unit_cutoff_aux_excl_(clauseinf,inf_list,lit_list,history)
SCM clauseinf,inf_list,lit_list,history;
{
  SCM i__3,xfun,xlit,new_var1,cutflag,tmp,yfun,commylit,discr_testclause,yinf,ylit,cut_flag,unit_flag,has_only_local_only_vars_flag,inf_list_beg,lit_list_beg,inf_list__2,lit_list__1,yclmaxvar,inf_list_part,lit_list_part,orig_lit_list,ylitnr,compl_yfunpure,cand_list,part,i,res;

  if(NFALSEP(empty_cl_pred_(lit_list))||NULL_P(GLOBAL(unit_alist_global)))
    return cons(history,cons(inf_list,lit_list));
  else {
    orig_lit_list=copy_list(lit_list);
    lit_list_part=lit_list;
    inf_list_part=inf_list;
    yclmaxvar=give_cl_maxvar(clauseinf);
    lit_list__1=cons(EOL,lit_list);
    inf_list__2=cons(EOL,inf_list);
    lit_list_beg=lit_list__1;
    inf_list_beg=inf_list__2;
    has_only_local_only_vars_flag=BOOL_F;
    unit_flag=unit_cl_pred_(lit_list_part);
    cut_flag=BOOL_F;
    for(ylitnr=MAKINUM(1);!(NULL_P(lit_list_part));ylitnr=MAKINUM(1+INUM(ylitnr))) {
      ylit=CAR(lit_list_part);
      yinf=CAR(inf_list_part);
      discr_testclause=EOL;
      commylit=EOL;
      yfun=CAR(ylit);
      tmp=EOL;
      cutflag=BOOL_F;
      if(NFALSEP(commutative_fun_pred_(yfun))) {
        commylit=cons(yfun,cons(CAR(CDR(CDR(ylit))),cons(CAR(CDR(ylit)),CDR(CDR(CDR(ylit))))));
      }
      if(NFALSEP(cutflag)||(NFALSEP(answer_lit_pred_(ylit))||((NFALSEP(GLOBAL(hyper_strategy_flag_global))&&(!(NFALSEP(GLOBAL(simple_history_stratflag_global)))&&(!(!(ZERO_P(MAKINUM(268435456)&yfun)))&&!(NFALSEP(positive_cl_pred_(orig_lit_list))))))||!(NFALSEP(has_some_local_only_vars_pred_(ylit)))))) {
        lit_list__1=lit_list_part;
        inf_list__2=inf_list_part;
        lit_list_part=CDR(lit_list_part);
        inf_list_part=CDR(inf_list_part);
      }
      else {
        compl_yfunpure=MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun));
        cand_list=assq(compl_yfunpure,GLOBAL(unit_alist_global));
        if(NFALSEP(cand_list)) {
          cand_list=CDR(cand_list);
        }
        else {
          cand_list=EOL;
        }
        new_var1=unit_flag;
        if(NFALSEP(new_var1))
          has_only_local_only_vars_flag=new_var1;
        else
          has_only_local_only_vars_flag=has_only_local_only_vars_pred_(ylit);
        for(part=cand_list;!(NULL_P(part)||NFALSEP(cutflag));part=CDR(part)) {
          xlit=CAR(CDR(CAR(part)));
          xfun=CAR(xlit);
          if((NFALSEP(has_only_local_only_vars_flag)||ZERO_P(MAKINUM(65536)&xfun))&&NULL_P(CDR(CDR(CAR(part))))) {
            if(GLOBAL(display_info_level_global)>MAKINUM(110)) {
              newline(cur_output_port());
              display(const_353,cur_output_port());
              newline(cur_output_port());
              debug_print_lit(xlit);
              newline(cur_output_port());
              debug_print_lit(ylit);
              newline(cur_output_port());
              newline(cur_output_port());
              for(i=MAKINUM(1);!(i>MAKINUM(10));i=MAKINUM(1+INUM(i))) {
                display(i,cur_output_port());
                display(const_354,cur_output_port());
                display(STBL_VECTOR_REF(_star_var_val_table_star__velts0,i),cur_output_port());
                display(const_355,cur_output_port());
              }
              newline(cur_output_port());
              for(i__3=MAKINUM(1+256);!(INUM(i__3)>(11+256));i__3=MAKINUM(1+INUM(i__3))) {
                display(i__3,cur_output_port());
                display(const_356,cur_output_port());
                display(STBL_VECTOR_REF(_star_var_val_table_star__velts0,i__3),cur_output_port());
                display(const_357,cur_output_port());
              }
              newline(cur_output_port());
            }
            if(NFALSEP(resolve_unify_cutoff(xfun,yfun,xlit,ylit))) {
              GLOBAL(cut_clauses_global)=cons(CAR(part),GLOBAL(cut_clauses_global));
              cutflag=BOOL_T;
            }
            else
            if(!(NULL_P(commylit))) {
              if(NFALSEP(yvars_set_flag_global))
                clear_y_vars_excl_(yclmaxvar);
              if(NFALSEP(xvars_set_flag_global))
                clear_x_vars_excl_(give_cl_maxvar(CAR(CAR(part))));
              if(NFALSEP(resolve_unify_cutoff(xfun,yfun,xlit,ylit))) {
                GLOBAL(cut_clauses_global)=cons(CAR(part),GLOBAL(cut_clauses_global));
                part=GLOBAL(listofnull_global);
              }
            }
            if(NFALSEP(yvars_set_flag_global))
              clear_y_vars_excl_(yclmaxvar);
            if(NFALSEP(xvars_set_flag_global))
              clear_x_vars_excl_(give_cl_maxvar(CAR(CAR(part))));
          }
        }
        if(NFALSEP(cutflag)) {
          lit_list_part=CDR(lit_list_part);
          inf_list_part=CDR(inf_list_part);
          SET_CDR(lit_list__1,lit_list_part);
          SET_CDR(inf_list__2,inf_list_part);
          if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
            history=append2(cons(slowcut_symb,cons(clinfo_clnr(CAR(CAR(GLOBAL(cut_clauses_global)))),EOL)),history);
          }
          else
          if(NFALSEP(GLOBAL(hyper_strategy_flag_global))||NFALSEP(GLOBAL(int_logic_flag_global))) {
            history=make_hyper_history(CDR(CAR(GLOBAL(cut_clauses_global))),orig_lit_list,EOL,EOL,CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),history,cons(MAKINUM(1<<16)|MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&MAKINUM(0))^0),EOL),CDR(CDR(yinf)),MAKINUM(1),ylitnr,BOOL_F);
          }
          else {
            res=EOL;
            if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
              res=cons(binary_symb,cons(cons(clinfo_clnr(EOL),cons(MAKINUM(1),EOL)),cons(cons(clinfo_clnr(EOL),cons(ylitnr,EOL)),EOL)));
              if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
                res=append2(make_demod_history(GLOBAL(used_demodulators_global)),res);
              }
              history=res;
            }
            else
            if(NULL_P(GLOBAL(used_demodulators_global)))
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(ylitnr,EOL))),EOL))));
            else
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(ylitnr,EOL))),cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL)))));
          }
        }
        else {
          lit_list__1=lit_list_part;
          inf_list__2=inf_list_part;
          lit_list_part=CDR(lit_list_part);
          inf_list_part=CDR(inf_list_part);
        }
      }
    }
    if(!(NULL_P(GLOBAL(cut_clauses_global)))&&(GLOBAL(display_info_level_global)>=MAKINUM(65))) {
      newline(cur_output_port());
      display(const_358,cur_output_port());
      newline(cur_output_port());
      for_each1(full_unit_cutoff_aux_excl__fn334,GLOBAL(cut_clauses_global));
    }
    return cons(history,cons(CDR(inf_list_beg),CDR(lit_list_beg)));
  }
}

SCM full_unit_cutoff_aux_excl__fn334(x)
SCM x;
{
  print_clause(x);
  return newline(cur_output_port());
}

SCM full_unit_cutoff_double_excl_(clauseinf,inf_list,lit_list,history)
SCM clauseinf,inf_list,lit_list,history;
{
  SCM cutflag,tmp,yfun,discr_testclause,yinf,ylit,cut_flag,passed_lits,unit_flag,inf_list_beg,lit_list_beg,inf_list__2,lit_list__1,yclmaxvar,inf_list_part,lit_list_part,orig_lit_list,ylitnr,res;

  if(NFALSEP(empty_cl_pred_(lit_list))||NULL_P(CDR(lit_list)))
    return cons(history,cons(inf_list,lit_list));
  else {
    orig_lit_list=copy_list(lit_list);
    lit_list_part=lit_list;
    inf_list_part=inf_list;
    yclmaxvar=give_cl_maxvar(clauseinf);
    lit_list__1=cons(EOL,lit_list);
    inf_list__2=cons(EOL,inf_list);
    lit_list_beg=lit_list__1;
    inf_list_beg=inf_list__2;
    unit_flag=unit_cl_pred_(lit_list_part);
    passed_lits=EOL;
    cut_flag=BOOL_F;
    for(ylitnr=MAKINUM(1);!(NULL_P(lit_list_part));ylitnr=MAKINUM(1+INUM(ylitnr))) {
      ylit=CAR(lit_list_part);
      yinf=CAR(inf_list_part);
      discr_testclause=EOL;
      yfun=CAR(ylit);
      tmp=EOL;
      cutflag=BOOL_F;
      if(NFALSEP(answer_lit_pred_(ylit))||(NFALSEP(GLOBAL(hyper_strategy_flag_global))&&(!(!(ZERO_P(MAKINUM(268435456)&yfun)))&&!(NFALSEP(positive_cl_pred_(orig_lit_list)))))) {
        passed_lits=cons(ylit,passed_lits);
        lit_list__1=lit_list_part;
        inf_list__2=inf_list_part;
        lit_list_part=CDR(lit_list_part);
        inf_list_part=CDR(inf_list_part);
      }
      else {
        discr_testclause=cons(cons(MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun)),CDR(ylit)),cons(EOL,append2(passed_lits,CDR(lit_list_part))));
        GLOBAL(nonunit_discr_flag_global)=BOOL_T;
        GLOBAL(overdouble_discr_flag_global)=BOOL_F;
        if(NULL_P(CAR(GLOBAL(nonunit_discr_tree_global)))) {
          tmp=BOOL_F;
        }
        else {
          tmp=check_discr_tree_part(CDR(CAR(CAR(GLOBAL(nonunit_discr_tree_global)))),discr_testclause,EOL);
        }
        GLOBAL(nonunit_discr_flag_global)=BOOL_F;
        GLOBAL(overdouble_discr_flag_global)=BOOL_F;
        if(NFALSEP(tmp)) {
          cutflag=BOOL_T;
          GLOBAL(cut_clauses_global)=cons(CAR(tmp),GLOBAL(cut_clauses_global));
          lit_list_part=CDR(lit_list_part);
          inf_list_part=CDR(inf_list_part);
          SET_CDR(lit_list__1,lit_list_part);
          SET_CDR(inf_list__2,inf_list_part);
          if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
            history=append2(cons(binarycut_symb,cons(clinfo_clnr(CAR(CAR(GLOBAL(cut_clauses_global)))),EOL)),history);
          }
          else
          if(NFALSEP(GLOBAL(hyper_strategy_flag_global))||NFALSEP(GLOBAL(int_logic_flag_global))) {
            history=make_hyper_history(CDR(CAR(GLOBAL(cut_clauses_global))),orig_lit_list,EOL,EOL,CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),history,cons(MAKINUM(1<<16)|MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&MAKINUM(0))^0),EOL),CDR(CDR(yinf)),MAKINUM(1),ylitnr,BOOL_F);
          }
          else {
            res=EOL;
            if(NFALSEP(GLOBAL(simple_history_stratflag_global))) {
              res=cons(binary_symb,cons(cons(clinfo_clnr(EOL),cons(MAKINUM(1),EOL)),cons(cons(clinfo_clnr(EOL),cons(ylitnr,EOL)),EOL)));
              if(!(NULL_P(GLOBAL(used_demodulators_global)))) {
                res=append2(make_demod_history(GLOBAL(used_demodulators_global)),res);
              }
              history=res;
            }
            else
            if(NULL_P(GLOBAL(used_demodulators_global)))
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(ylitnr,EOL))),EOL))));
            else
              history=cons(binres_symb,cons(MAKINUM(0),cons(cons(literal_symb,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(GLOBAL(cut_clauses_global))))))))),cons(MAKINUM(1),EOL))),cons(cons(literal_symb,cons(history,cons(ylitnr,EOL))),cons(make_demod_history(GLOBAL(used_demodulators_global)),EOL)))));
          }
        }
        else {
          passed_lits=cons(ylit,passed_lits);
          lit_list__1=lit_list_part;
          inf_list__2=inf_list_part;
          lit_list_part=CDR(lit_list_part);
          inf_list_part=CDR(inf_list_part);
        }
      }
    }
    if(!(NULL_P(GLOBAL(cut_clauses_global)))&&(GLOBAL(display_info_level_global)>=MAKINUM(65))) {
      newline(cur_output_port());
      display(const_359,cur_output_port());
      newline(cur_output_port());
      for_each1(full_unit_cutoff_double_excl__fn336,GLOBAL(cut_clauses_global));
    }
    return cons(history,cons(CDR(inf_list_beg),CDR(lit_list_beg)));
  }
}

SCM full_unit_cutoff_double_excl__fn336(x)
SCM x;
{
  print_clause(x);
  return newline(cur_output_port());
}

SCM has_some_local_only_vars_pred_(cterm)
SCM cterm;
{
  SCM el,success_flag,part;

  success_flag=BOOL_F;
  el=EOL;
  if(ZERO_P(MAKINUM(65536)&CAR(cterm))) {
    for(part=CDR(cterm);!(NULL_P(part)||NFALSEP(success_flag));part=CDR(part)) {
      el=CAR(part);
      if(!(NUMBER_P(el))) {
        if(NFALSEP(has_some_local_only_vars_pred_(el))) {
          success_flag=BOOL_T;
        }
      }
      else
      if((MAKINUM(65535)>el)&&!(ZERO_P(MAKINUM(16384)&el))) {
        success_flag=BOOL_T;
      }
    }
    return success_flag;
  }
  else
    return BOOL_F;
}

SCM has_only_local_only_vars_pred_(cterm)
SCM cterm;
{
  SCM el,fail_flag,part;

  fail_flag=BOOL_F;
  el=EOL;
  if(ZERO_P(MAKINUM(65536)&CAR(cterm))) {
    for(part=CDR(cterm);!(NULL_P(part)||NFALSEP(fail_flag));part=CDR(part)) {
      el=CAR(part);
      if(!(NUMBER_P(el))) {
        if(!(NFALSEP(has_only_local_only_vars_pred_(el)))) {
          fail_flag=BOOL_T;
        }
      }
      else
      if((MAKINUM(65535)>el)&&ZERO_P(MAKINUM(16384)&el)) {
        fail_flag=BOOL_T;
      }
    }
    return NOT(fail_flag);
  }
  else
    return BOOL_T;
}

SCM member_polarity_lit(samesgn_flag,lit,lst)
SCM samesgn_flag,lit,lst;
{
  SCM fun,comm_flag,res;

  if(NULL_P(lst))
    return BOOL_F;
  else {
    if(NFALSEP(samesgn_flag))
      fun=(MAKINUM(534904831)&CAR(lit));
    else
      fun=(MAKINUM(534904831)&MAKINUM(268435456^INUM(CAR(lit))));
    comm_flag=commutative_fun_pred_(fun);
    res=BOOL_F;
    for(;!(NULL_P(lst));)
      if((fun==(MAKINUM(534904831)&CAR(CAR(lst))))&&(NFALSEP(term_list_equal_strong_pred_(CDR(lit),CDR(CAR(lst))))||(NFALSEP(comm_flag)&&NFALSEP(swapped_term_list_strong_equal_pred_(CDR(lit),CDR(CAR(lst))))))) {
        res=lst;
        lst=EOL;
      }
      else {
        lst=CDR(lst);
      }
    return res;
  }
}

SCM swapped_term_list_strong_equal_pred_(x,y)
SCM x,y;
{
  return term_list_equal_strong_pred_(cons(CAR(CDR(x)),cons(CAR(x),CDR(CDR(x)))),cons(CAR(CDR(y)),cons(CAR(y),CDR(CDR(y)))));
}

SCM insert_to_subsumption_list_excl_(len,strength,fullcl)
SCM len,strength,fullcl;
{
  SCM place,lenlist,part;

  lenlist=EOL;
  place=EOL;
  for(part=GLOBAL(subsumption_list_global);!(NULL_P(CDR(part))||(CAR(CAR(CDR(part)))>=len));part=CDR(part)) ;
  if(!(NULL_P(CDR(part)))&&(CAR(CAR(CDR(part)))==len)) {
    lenlist=CAR(CDR(part));
  }
  else {
    SET_CDR(part,cons(cons(len,EOL),CDR(part)));
    lenlist=CAR(CDR(part));
  }
  place=CDR(lenlist);
  for(;!(NULL_P(place)||((MAKINUM(131071)&CAR(CAR(CAR(place))))<=strength));) {
    lenlist=place;
    place=CDR(place);
  }
  SET_CDR(lenlist,cons(fullcl,place));
  return UNSPECIFIED;
}

SCM insert_unit_alist(fullcl)
SCM fullcl;
{
  SCM purepred,part;

  purepred=(MAKINUM(534773760)&CAR(CAR(CDR(fullcl))));
  part=assq(purepred,GLOBAL(unit_alist_global));
  if(NFALSEP(part)) {
    SET_CDR(part,cons(fullcl,CDR(part)));
    return UNSPECIFIED;
  }
  else {
    GLOBAL(unit_alist_global)=cons(cons(purepred,cons(fullcl,EOL)),GLOBAL(unit_alist_global));
    return UNSPECIFIED;
  }
}

SCM insert_partial_discr_tree_excl_(tree,term,funflag,endflag,depth)
SCM tree,term,funflag,endflag,depth;
{
  SCM place;

  if(NUMBER_P(term)) {
    place=EOL;
    if(NFALSEP(funflag)) {
      term=(MAKINUM(266338304)&term);
      place=assq(term,CAR(tree));
      if(!(NFALSEP(place))) {
        SET_CAR(tree,cons(cons(term,cons(EOL,EOL)),CAR(tree)));
        place=CAR(CAR(tree));
      }
    }
    else
    if(MAKINUM(65535)>term) {
      term=MAKINUM(0);
      if(NULL_P(CDR(tree))) {
        SET_CDR(tree,cons(EOL,EOL));
      }
      tree=CDR(tree);
      place=assq(term,CDR(tree));
      if(!(NFALSEP(place))) {
        SET_CDR(tree,cons(cons(term,cons(EOL,EOL)),CDR(tree)));
        place=CAR(CDR(tree));
      }
    }
    else {
      if(NULL_P(CDR(tree))) {
        SET_CDR(tree,cons(EOL,EOL));
      }
      tree=CDR(tree);
      place=assq(term,CAR(tree));
      if(!(NFALSEP(place))) {
        SET_CAR(tree,cons(cons(term,cons(EOL,EOL)),CAR(tree)));
        place=CAR(CAR(tree));
      }
    }
    if(NFALSEP(endflag))
      return apply(GLOBAL(insert_partial_discr_tree_leaf_excl_),CDR(place),listofnull);
    else
      return CDR(place);
  }
  else {
    tree=insert_partial_discr_tree_excl_(tree,CAR(term),BOOL_T,BOOL_F,depth);
    term=CDR(term);
    for(;!(NULL_P(term));) {
      tree=insert_partial_discr_tree_excl_(tree,CAR(term),BOOL_F,(NFALSEP(endflag) ? SBOOL(NULL_P(CDR(term))) : BOOL_F),MAKINUM(INUM(depth)-1));
      term=CDR(term);
    }
    return tree;
  }
}

SCM check_discr_tree(tree,lit)
SCM tree,lit;
{
  SCM fun,res;

  fun=CAR(lit);
  res=BOOL_F;
  GLOBAL(ground_check_res_global)=BOOL_F;
  GLOBAL(nonunit_discr_flag_global)=BOOL_F;
  tree=assq(MAKINUM(266338304)&fun,CAR(tree));
  if(NFALSEP(tree)) {
    res=check_discr_tree_part(CDR(tree),CDR(lit),EOL);
  }
  else {
    res=BOOL_F;
  }
  if(!(NFALSEP(res))&&NFALSEP(commutative_fun_pred_(fun))) {
    res=check_discr_tree_part(CDR(tree),cons(CAR(CDR(CDR(lit))),cons(CAR(CDR(lit)),CDR(CDR(CDR(lit))))),EOL);
  }
  if(NFALSEP(res))
    return res;
  else
    return GLOBAL(ground_check_res_global);
}

SCM check_discr_tree_signed(tree,lit)
SCM tree,lit;
{
  SCM fun,res;

  fun=CAR(lit);
  res=BOOL_F;
  GLOBAL(ground_check_res_global)=BOOL_F;
  GLOBAL(nonunit_discr_flag_global)=BOOL_F;
  tree=assq(MAKINUM(534773760)&fun,CAR(tree));
  if(NFALSEP(tree)) {
    res=check_discr_tree_part(CDR(tree),CDR(lit),EOL);
  }
  else {
    res=BOOL_F;
  }
  if(!(NFALSEP(res))&&NFALSEP(commutative_fun_pred_(fun))) {
    res=check_discr_tree_part(CDR(tree),cons(CAR(CDR(CDR(lit))),cons(CAR(CDR(lit)),CDR(CDR(CDR(lit))))),EOL);
  }
  if(NFALSEP(res))
    return res;
  else
    return GLOBAL(ground_check_res_global);
}

SCM insert_clause_discr_tree_excl_(tree,fullcl,litinfolist,insert_flag)
SCM tree,fullcl,litinfolist,insert_flag;
{
  SCM infpart,clpart,cl,clpart__1,infpart__2;

  cl=CDR(fullcl);
  if(NULL_P(CDR(cl))&&NFALSEP(insert_flag)) {
    GLOBAL(cur_lit_global)=CAR(cl);
    GLOBAL(cur_clause_global)=fullcl;
    insert_discr_tree_excl_(tree,GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T,BOOL_F);
    SET_CAR(cl,GLOBAL(cur_lit_global));
    return UNSPECIFIED;
  }
  else
  if(!(NFALSEP(insert_flag))) {
    for(clpart=cl,infpart=litinfolist;
        !(NULL_P(clpart));
        clpart=CDR(clpart),infpart=CDR(infpart))
      if(NFALSEP(CAR(CAR(infpart)))&&(!(ZERO_P(MAKINUM(65536)&CAR(CAR(clpart))))&&!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart))))))) {
        GLOBAL(cur_lit_global)=CAR(clpart);
        GLOBAL(cur_clause_global)=BOOL_F;
        insert_discr_tree_excl_(tree,GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T,BOOL_F);
        SET_CAR(clpart,GLOBAL(cur_lit_global));
      }
    return UNSPECIFIED;
  }
  else {
    insert_discr_tree_nonunit_excl_(GLOBAL(nonunit_discr_tree_global),fullcl);
    for(clpart__1=cl,infpart__2=litinfolist;
        !(NULL_P(clpart__1));
        clpart__1=CDR(clpart__1),infpart__2=CDR(infpart__2))
      if(NFALSEP(CAR(CAR(infpart__2)))&&(!(ZERO_P(MAKINUM(65536)&CAR(CAR(clpart__1))))&&!(NFALSEP(answer_pred_pred_(CAR(CAR(clpart__1))))))) {
        GLOBAL(cur_lit_global)=CAR(clpart__1);
        GLOBAL(cur_clause_global)=BOOL_F;
        insert_discr_tree_excl_(tree,GLOBAL(cur_lit_global),BOOL_F,BOOL_T,BOOL_T,BOOL_F);
        SET_CAR(clpart__1,GLOBAL(cur_lit_global));
      }
    return UNSPECIFIED;
  }
}

SCM insert_discr_tree_excl_(tree,term,funflag,endflag,unitflag,clauseflag)
SCM tree,term,funflag,endflag,unitflag,clauseflag;
{
  SCM place;

  if(NUMBER_P(term)) {
    place=EOL;
    if(NFALSEP(funflag)) {
      if(NFALSEP(unitflag)&&!(NFALSEP(clauseflag))) {
        term=(MAKINUM(266338304)&term);
      }
      else {
        term=(MAKINUM(534773760)&term);
      }
      place=assq(term,CAR(tree));
      if(!(NFALSEP(place))) {
        SET_CAR(tree,cons(cons(term,cons(EOL,EOL)),CAR(tree)));
        place=CAR(CAR(tree));
      }
    }
    else
    if(MAKINUM(65535)>term) {
      term=(MAKINUM(8191)&term);
      if(NULL_P(CDR(tree))) {
        SET_CDR(tree,cons(EOL,EOL));
      }
      tree=CDR(tree);
      place=assq(term,CDR(tree));
      if(!(NFALSEP(place))) {
        SET_CDR(tree,cons(cons(term,cons(EOL,EOL)),CDR(tree)));
        place=CAR(CDR(tree));
      }
    }
    else {
      if(NULL_P(CDR(tree))) {
        SET_CDR(tree,cons(EOL,EOL));
      }
      tree=CDR(tree);
      place=assq(term,CAR(tree));
      if(!(NFALSEP(place))) {
        SET_CAR(tree,cons(cons(term,cons(EOL,EOL)),CAR(tree)));
        place=CAR(CAR(tree));
      }
    }
    if(NFALSEP(endflag)) {
      if(NFALSEP(clauseflag)) {
        SET_CDR(place,cons(EOL,EOL));
        return insert_discr_tree_clausedemod_leaf_excl_(CDR(place));
      }
      else
      if(NFALSEP(unitflag))
        return insert_discr_tree_leaf_excl_(CDR(place));
      else
        return insert_nonunit_discr_tree_leaf_excl_(CDR(place));
    }
    else
      return CDR(place);
  }
  else {
    tree=insert_discr_tree_excl_(tree,CAR(term),BOOL_T,BOOL_F,unitflag,clauseflag);
    term=CDR(term);
    for(;!(NULL_P(term));) {
      tree=insert_discr_tree_excl_(tree,CAR(term),BOOL_F,(NFALSEP(endflag) ? SBOOL(NULL_P(CDR(term))) : BOOL_F),unitflag,clauseflag);
      term=CDR(term);
    }
    return tree;
  }
}

SCM insert_discr_tree_leaf_excl_(place)
SCM place;
{
  if(ZERO_P(MAKINUM(268435456)&CAR(GLOBAL(cur_lit_global)))) {
    if(!(NULL_P(CAR(place)))) {
      GLOBAL(cur_lit_global)=CAR(place);
    }
    if(NULL_P(CDR(place))) {
      if(NFALSEP(GLOBAL(cur_clause_global))) {
        SET_CDR(place,cons(EOL,cons(GLOBAL(cur_clause_global),EOL)));
      }
    }
    else {
      if(!(NULL_P(CAR(CDR(place))))) {
        if(!(ZERO_P(MAKINUM(65536)&CAR(CAR(CDR(place)))))) {
          SET_CDR(GLOBAL(cur_lit_global),CDR(CAR(CDR(place))));
        }
      }
      if(NFALSEP(GLOBAL(cur_clause_global))&&NULL_P(CDR(CDR(place)))) {
        SET_CDR(CDR(place),cons(GLOBAL(cur_clause_global),EOL));
      }
    }
    SET_CAR(place,GLOBAL(cur_lit_global));
    return UNSPECIFIED;
  }
  else {
    if(!(NULL_P(CAR(place)))) {
      if(!(ZERO_P(MAKINUM(65536)&CAR(CAR(place))))) {
        SET_CDR(GLOBAL(cur_lit_global),CDR(CAR(place)));
      }
    }
    if(NULL_P(CDR(place))) {
      if(NFALSEP(GLOBAL(cur_clause_global))) {
        SET_CDR(place,cons(GLOBAL(cur_lit_global),cons(GLOBAL(cur_clause_global),EOL)));
        return UNSPECIFIED;
      }
      else {
        SET_CDR(place,cons(GLOBAL(cur_lit_global),EOL));
        return UNSPECIFIED;
      }
    }
    else {
      if(NULL_P(CAR(CDR(place)))) {
        if(NFALSEP(GLOBAL(cur_clause_global))||!(ZERO_P(MAKINUM(65536)&CAR(GLOBAL(cur_lit_global))))) {
          SET_CAR(CDR(place),GLOBAL(cur_lit_global));
        }
      }
      else {
        GLOBAL(cur_lit_global)=CAR(CDR(place));
      }
      if(NFALSEP(GLOBAL(cur_clause_global))&&NULL_P(CDR(CDR(place)))) {
        SET_CDR(CDR(place),cons(GLOBAL(cur_clause_global),EOL));
        return UNSPECIFIED;
      }
      else
        return UNSPECIFIED;
    }
  }
}

SCM insert_discr_tree_clausedemod_leaf_excl_(place)
SCM place;
{
  SET_CAR(place,CAR(GLOBAL(cur_clause_global)));
  SET_CDR(place,CDR(GLOBAL(cur_clause_global)));
  return UNSPECIFIED;
}

SCM check_discr_tree_part(tree,part,cont)
SCM tree,part,cont;
{
  SCM tmp,val,var,res,vars,el,new_var1,tmp_var1,tmp_var2;

tailrecursion:
  GLOBAL(ttt1_global)=tree;
  GLOBAL(ttt2_global)=part;
  GLOBAL(ttt3_global)=cont;
  if(NULL_P(part)) {
    if(NULL_P(cont))
      return check_discr_tree_leaf(tree);
    else
    if(NULL_P(CAR(cont))) {
      if(NULL_P(CDR(cont)))
        return BOOL_F;
      else {
        new_var1=check_discr_tree_part(tree,cons(CAR(CDR(cont)),EOL),EOL);
        if(NFALSEP(new_var1))
          return new_var1;
        else {
          tmp_var1=EOL;
          tmp_var2=cons(EOL,CDR(CDR(cont)));
          part=tmp_var1;
          cont=tmp_var2;
          goto tailrecursion;
        }
      }
    }
    else {
      tmp_var1=cont;
      tmp_var2=EOL;
      part=tmp_var1;
      cont=tmp_var2;
      goto tailrecursion;
    }
  }
  else {
    el=CAR(part);
    vars=CDR(tree);
    res=BOOL_F;
    var=BOOL_F;
    val=BOOL_F;
    if(!(NULL_P(vars))) {
      vars=CDR(vars);
    }
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        el=(MAKINUM(8191)&el);
        for(;!(NULL_P(vars)||NFALSEP(res));) {
          var=CAR(CAR(vars));
          val=STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
          if(val==MAKINUM(99999999)) {
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,el);
            res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,val);
          }
          else
          if(val==el) {
            res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
          }
          vars=CDR(vars);
        }
        return res;
      }
      else {
        tree=CDR(tree);
        if(NULL_P(tree)) {
          tree=BOOL_F;
        }
        else {
          tree=assq(el,CAR(tree));
        }
        if(NFALSEP(tree)) {
          tree=check_discr_tree_part(CDR(tree),CDR(part),cont);
        }
        if(NFALSEP(GLOBAL(nonunit_discr_flag_global))) {
          if(NFALSEP(tree)&&!(NFALSEP(CAR(tree)))) {
            if(NFALSEP(GLOBAL(overdouble_discr_flag_global))) {
              GLOBAL(nonunit_res_global)=cons(CDR(tree),GLOBAL(nonunit_res_global));
            }
            tree=BOOL_F;
          }
        }
        else
        if(NFALSEP(tree)&&(NULL_P(CDR(tree))||NULL_P(CDR(CDR(tree))))) {
          GLOBAL(ground_check_res_global)=tree;
          tree=BOOL_F;
        }
        if(NFALSEP(tree))
          return tree;
        else {
          for(;!(NULL_P(vars)||NFALSEP(res));) {
            var=CAR(CAR(vars));
            val=STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
            if(val==MAKINUM(99999999)) {
              STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,el);
              res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
              STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,val);
            }
            else
            if(val==el) {
              res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
            }
            vars=CDR(vars);
          }
          return res;
        }
      }
    }
    else
    if(NULL_P(el)) {
      tmp_var1=EOL;
      tmp_var2=part;
      part=tmp_var1;
      cont=tmp_var2;
      goto tailrecursion;
    }
    else {
      if(NFALSEP(GLOBAL(discr_depth_first_global))) {
        tree=assq(MAKINUM(534773760)&CAR(el),CAR(tree));
        if(NFALSEP(tree)) {
          tmp=EOL;
          if(NULL_P(cont)) {
            tmp=CDR(part);
          }
          else {
            tmp=append2(CDR(part),cont);
          }
          tree=check_discr_tree_part(CDR(tree),CDR(el),tmp);
        }
      }
      else {
        tree=BOOL_F;
      }
      if(NFALSEP(GLOBAL(nonunit_discr_flag_global))) {
        if(NFALSEP(tree)&&!(NFALSEP(CAR(tree)))) {
          if(NFALSEP(GLOBAL(overdouble_discr_flag_global))) {
            GLOBAL(nonunit_res_global)=cons(CDR(tree),GLOBAL(nonunit_res_global));
          }
          tree=BOOL_F;
        }
      }
      else
      if(NFALSEP(tree)&&(NULL_P(CDR(tree))||NULL_P(CDR(CDR(tree))))) {
        GLOBAL(ground_check_res_global)=tree;
        tree=BOOL_F;
      }
      if(NFALSEP(tree))
        return tree;
      else {
        for(;!(NULL_P(vars)||NFALSEP(res));) {
          var=CAR(CAR(vars));
          val=STBL_VECTOR_REF(_star_var_val_table_star__velts0,var);
          if(val==MAKINUM(99999999)) {
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,el);
            res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
            STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,val);
          }
          else
          if(NFALSEP(GLOBAL(nonunit_discr_flag_global))) {
            if(NFALSEP(term_equal_strong_pred_(val,el))) {
              res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
            }
          }
          else
          if(NFALSEP(term_equal_pred_(val,el))) {
            res=check_discr_tree_part(CDR(CAR(vars)),CDR(part),cont);
          }
          vars=CDR(vars);
        }
        if(NFALSEP(GLOBAL(discr_depth_first_global))||NFALSEP(res))
          return res;
        else {
          tree=assq(MAKINUM(534773760)&CAR(el),CAR(tree));
          if(NFALSEP(tree)) {
            if(NULL_P(cont)) {
              cont=CDR(part);
            }
            else {
              cont=append2(CDR(part),cont);
            }
            tmp_var1=CDR(tree);
            tmp_var2=CDR(el);
            tree=tmp_var1;
            part=tmp_var2;
            goto tailrecursion;
          }
          else
            return UNSPECIFIED;
        }
      }
    }
  }
}

SCM check_discr_tree_leaf(tree)
SCM tree;
{
  if(NFALSEP(GLOBAL(prohibit_subs_clnr_global))&&NFALSEP((NFALSEP(GLOBAL(nonunit_discr_flag_global)) ? SBOOL(NFALSEP(CAR(tree))&&(CAR(CDR(CDR(CDR(CDR(CAR(CAR(tree)))))))==GLOBAL(prohibit_subs_clnr_global))) : SBOOL(NFALSEP(CAR(tree))&&(!(NULL_P(CDR(tree)))&&(!(NULL_P(CDR(CDR(tree))))&&(CAR(CDR(CDR(CDR(CDR(CAR(CAR(CDR(CDR(tree)))))))))==GLOBAL(prohibit_subs_clnr_global))))))))
    return BOOL_F;
  else
  if(NFALSEP(GLOBAL(nonunit_discr_flag_global))) {
    if(NFALSEP(tree)&&!(NFALSEP(CAR(tree)))) {
      if(NFALSEP(GLOBAL(overdouble_discr_flag_global))) {
        GLOBAL(nonunit_res_global)=cons(CDR(tree),GLOBAL(nonunit_res_global));
      }
      return BOOL_F;
    }
    else
      return tree;
  }
  else
    return tree;
}

SCM insert_discr_tree_nonunit_excl_(tree,fullcl)
SCM tree,fullcl;
{
  SCM info,purecl,object;

  info=CAR(fullcl);
  purecl=CDR(fullcl);
  object=cons(MAKINUM(0),cons(CAR(purecl),cons(CAR(CDR(purecl)),EOL)));
  GLOBAL(cur_clause_global)=fullcl;
  return insert_discr_tree_excl_(tree,object,BOOL_F,BOOL_T,BOOL_F,BOOL_F);
}

SCM insert_nonunit_discr_tree_leaf_excl_(place)
SCM place;
{
  if(NULL_P(CDR(CDR(CDR(GLOBAL(cur_clause_global)))))) {
    SET_CAR(place,GLOBAL(cur_clause_global));
    return UNSPECIFIED;
  }
  else {
    SET_CAR(place,BOOL_F);
    SET_CDR(place,cons(cons(MAKINUM(0),GLOBAL(cur_clause_global)),CDR(place)));
    return UNSPECIFIED;
  }
}

SCM check_nonunit_discr_tree(tree,purecl)
SCM tree,purecl;
{
  SCM new_var1,res,tmp,passed,clpart;

  res=BOOL_F;
  tmp=EOL;
  passed=EOL;
  GLOBAL(nonunit_discr_flag_global)=BOOL_T;
  GLOBAL(nonunit_res_global)=EOL;
  if(NULL_P(CAR(tree))) {
    res=BOOL_F;
  }
  else
  if(NULL_P(CDR(purecl))) {
    res=BOOL_F;
  }
  else
  if(NULL_P(CDR(CDR(purecl)))) {
    GLOBAL(overdouble_discr_flag_global)=BOOL_F;
    new_var1=check_discr_tree_part(CDR(CAR(CAR(tree))),purecl,EOL);
    if(NFALSEP(new_var1))
      res=new_var1;
    else
      res=check_discr_tree_part(CDR(CAR(CAR(tree))),cons(CAR(CDR(purecl)),cons(CAR(purecl),EOL)),EOL);
  }
  else {
    GLOBAL(overdouble_discr_flag_global)=BOOL_T;
    for(clpart=purecl;!(NFALSEP(res)||NULL_P(clpart));clpart=CDR(clpart)) {
      if(!(NULL_P(passed))) {
        tmp=cons(CAR(clpart),cons(EOL,append2(passed,CDR(clpart))));
      }
      else {
        tmp=cons(CAR(clpart),cons(EOL,CDR(clpart)));
      }
      res=check_discr_tree_part(CDR(CAR(CAR(tree))),tmp,EOL);
      passed=cons(CAR(clpart),passed);
    }
  }
  GLOBAL(nonunit_discr_flag_global)=BOOL_F;
  GLOBAL(overdouble_discr_flag_global)=BOOL_F;
  return res;
}

SCM demodulation_clause_test(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM varinfo_purecl,ordernr,newlitinfnr,biglits,smalllits,reslst,new_var4,new_var5,new_var1,new_var2,new_var3;

  reslst=EOL;
  smalllits=EOL;
  biglits=EOL;
  newlitinfnr=MAKINUM(0);
  ordernr=MAKINUM(0);
  varinfo_purecl=EOL;
  if(NULL_P(purecl)||(NULL_P(CDR(purecl))||(!(NULL_P(CDR(CDR(purecl))))||(NFALSEP(member_ans_lit(purecl))||NFALSEP(every_pred_(demodulation_clause_test_fn341,purecl))))))
    return BOOL_F;
  else {
    varinfo_purecl=map1(demodulation_clause_test_fn342,purecl);
    ordernr=MAKINUM(0);
    for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
        PAIR_P(new_var4)&&PAIR_P(new_var5);
        new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
      new_var3=demodulation_clause_test_fn343(&ordernr,varinfo_purecl,CAR(new_var4),CAR(new_var5));
      if(NULL_P(new_var1)) {
        new_var1=cons(new_var3,EOL);
        new_var2=new_var1;
      }
      else {
        SET_CDR(new_var2,cons(new_var3,EOL));
        new_var2=CDR(new_var2);
      }
    }
    reslst=new_var1;
    if(NFALSEP(CAR(reslst))&&NFALSEP(CAR(CDR(reslst))))
      return const_360;
    else
    if(NFALSEP(CAR(reslst)))
      return reslst;
    else
    if(NFALSEP(CAR(CDR(reslst))))
      return reslst;
    else
      return reslst;
  }
}

SCM demodulation_clause_test_fn343(ordernr,varinfo_purecl,litinf,varinfolit)
SCM *ordernr;
SCM varinfo_purecl,litinf,varinfolit;
{
  *ordernr=MAKINUM(1+INUM(*ordernr));
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,demodulation_clause_test_fn344,varinfo_purecl)))
    return BOOL_F;
  else
    return BOOL_T;
}

SCM demodulation_clause_test_fn344(varinfolit,x)
SCM varinfolit,x;
{
  return SBOOL(!(x==varinfolit)&&NFALSEP((!(ZERO_P(MAKINUM(65536)&CAR(CDR(varinfolit)))) ? BOOL_F : (ZERO_P(MAKINUM(65536)&CAR(CDR(x))) ? SBOOL(((MAKINUM(63488)&CAR(CDR(x)))>(MAKINUM(63488)&CAR(CDR(varinfolit))))&&NFALSEP(vdepth__grtr__varinfolit_pred_(x,varinfolit))) : SBOOL(((MAKINUM(63488)&CAR(CDR(x)))>(MAKINUM(63488)&CAR(CDR(varinfolit))))||((MAKINUM(2016)&CAR(CDR(x)))>=(MAKINUM(2016)&CAR(CDR(varinfolit)))))))));
}

SCM demodulation_clause_test_fn342(x)
SCM x;
{
  return cons(make_var_depth_info(x),x);
}

SCM demodulation_clause_test_fn341(x)
SCM x;
{
  return SBOOL(!(ZERO_P(MAKINUM(65536)&CAR(x))));
}

SCM order_prohibit_litinfos(litinfolst,purecl)
SCM litinfolst,purecl;
{
  litinfolst=order_litinfo_eq_only(litinfolst,purecl);
  if(NFALSEP(GLOBAL(hyper_strategy_flag_global))) {
    if(NFALSEP(positive_cl_pred_(purecl))) {
      if(NFALSEP(GLOBAL(name_order_strategy_flag_global)))
        return name_order_litinfo(litinfolst,purecl);
      else
        return vdepth_order_litinfo(litinfolst,purecl);
    }
    else
      return litinfolst;
  }
  else
  if(NFALSEP(GLOBAL(name_order_strategy_flag_global)))
    return name_order_litinfo(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(epr_order_strategy_flag_global)))
    return epr_order_litinfo(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(poslitpref_order_strategy_flag_global)))
    return poslit_order_litinfo(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(firstlitpref_order_strategy_flag_global)))
    return firstlitpref_order_litinfo(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(posweight_order_strategy_flag_global)))
    return posweight_order_litinfo(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(negweight_order_strategy_flag_global)))
    return negweight_order_litinfo(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(exp_order_strategy_flag_global)))
    return exp_order_litinfo(litinfolst,purecl);
  else
    return vdepth_order_litinfo(litinfolst,purecl);
}

SCM vdepth_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  if(NFALSEP(GLOBAL(order_strategy_flag_global)))
    return vdepth_order_litinfo_aux(litinfolst,purecl);
  else
  if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global)))
    return vdepth_order_litinfo_eq_only(litinfolst,purecl);
  else
    return litinfolst;
}

SCM order_litinfo_eq_only(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM newlitinfnr,new_var4,new_var5,new_var1,new_var2,new_var3;

  newlitinfnr=MAKINUM(0);
  for(new_var4=litinfolst,new_var5=purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=order_litinfo_eq_only_fn346(&newlitinfnr,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM order_litinfo_eq_only_fn346(newlitinfnr,litinf,lit)
SCM *newlitinfnr;
SCM litinf,lit;
{
  if(((MAKINUM(534773760)&CAR(lit))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(lit))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(lit))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))))))) {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    *newlitinfnr=order_equality_litinfo(*newlitinfnr,lit);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
  else
    return litinf;
}

SCM order_equality_litinfo(litinfonr,lit)
SCM litinfonr,lit;
{
  if(NFALSEP(GLOBAL(order_equality_kb_strat_global)))
    return order_equality_litinfo_kb(litinfonr,lit);
  else
  if(NFALSEP(GLOBAL(order_equality_lex_strat_global)))
    return order_equality_litinfo_lex(litinfonr,lit);
  else
  if(NFALSEP(GLOBAL(order_equality_firstpref_strat_global)))
    return order_equality_litinfo_firstterm(litinfonr,lit);
  else
    return order_equality_litinfo_depth(litinfonr,lit);
}

SCM prohibit_right_para(litinfonr)
SCM litinfonr;
{
  return MAKINUM(32)|litinfonr;
}

SCM prohibit_left_para(litinfonr)
SCM litinfonr;
{
  return MAKINUM(16)|litinfonr;
}

SCM order_equality_litinfo_kb(litinfonr,lit)
SCM litinfonr,lit;
{
  SCM left,right,compres;

  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    left=CAR(CDR(CAR(CDR(lit))));
  else
    left=CAR(CDR(lit));
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    right=CAR(CDR(CDR(CAR(CDR(lit)))));
  else
    right=CAR(CDR(CDR(lit)));
  compres=EOL;
  compres=compare_terms_kb_order(left,right,BOOL_F);
  if(compres==MAKINUM(1))
    return prohibit_right_para(litinfonr);
  else
  if(compres==MAKINUM(-1))
    return prohibit_left_para(litinfonr);
  else
    return litinfonr;
}

SCM compare_terms_kb_order(left,right,followvarsflag)
SCM left,right,followvarsflag;
{
  SCM new_var1,leftvars,rightvars,leftsum,rightsum,leftres,rightres,varres,tmp,stopflag,lpart,rpart;

  leftvars=EOL;
  rightvars=EOL;
  leftsum=MAKINUM(0);
  rightsum=MAKINUM(0);
  leftres=EOL;
  rightres=EOL;
  varres=EOL;
  tmp=EOL;
  stopflag=BOOL_F;
  if(left==right)
    return MAKINUM(0);
  else
  if(NUMBER_P(left)&&(left<=MAKINUM(65535))) {
    if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
      return BOOL_F;
    else
    if(NUMBER_P(right))
      return BOOL_F;
    else
    if(NFALSEP(var_inside_term_pred_(left,right,followvarsflag)))
      return MAKINUM(-1);
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(right)&&(right<=MAKINUM(65535))) {
    if(NUMBER_P(left))
      return BOOL_F;
    else
    if(NFALSEP(var_inside_term_pred_(right,left,followvarsflag)))
      return MAKINUM(1);
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(left)) {
    if(NUMBER_P(right))
      return compare_const_kb_order(left,right);
    else
      return MAKINUM(-1);
  }
  else
  if(NUMBER_P(right))
    return MAKINUM(1);
  else {
    leftres=cons(MAKINUM(0),EOL);
    rightres=cons(MAKINUM(0),EOL);
    count_symbs_vars_excl_(left,leftres,followvarsflag);
    count_symbs_vars_excl_(right,rightres,followvarsflag);
    varres=compare_terms_varcount_subset(CDR(leftres),CDR(rightres));
    new_var1=BOOL_F;
    if(NFALSEP(new_var1))
      return new_var1;
    else
    if(!(NFALSEP(varres)))
      return BOOL_F;
    else
    if((varres>=MAKINUM(0))&&((CAR(leftres)>CAR(rightres))||((CAR(leftres)==CAR(rightres))&&(fun_lex_order_value(CAR(left))>fun_lex_order_value(CAR(right))))))
      return MAKINUM(1);
    else
    if((varres<=MAKINUM(0))&&((CAR(rightres)>CAR(leftres))||((CAR(leftres)==CAR(rightres))&&(fun_lex_order_value(CAR(right))>fun_lex_order_value(CAR(left))))))
      return MAKINUM(-1);
    else
    if(!(CAR(leftres)==CAR(rightres))||!(fun_lex_order_value(CAR(left))==fun_lex_order_value(CAR(right))))
      return BOOL_F;
    else {
      tmp=BOOL_F;
      stopflag=BOOL_F;
      for(lpart=CDR(left),rpart=CDR(right);
          !(NULL_P(lpart)||(NULL_P(rpart)||NFALSEP(stopflag)));
          lpart=CDR(lpart),rpart=CDR(rpart)) {
        tmp=compare_terms_kb_order(CAR(lpart),CAR(rpart),followvarsflag);
        if(!(NFALSEP(tmp))||((MAKINUM(1)==tmp)||(MAKINUM(-1)==tmp))) {
          stopflag=BOOL_T;
        }
      }
      if(tmp==MAKINUM(0)) {
        if(NULL_P(lpart)&&(NULL_P(rpart)&&(varres==MAKINUM(0))))
          return MAKINUM(0);
        else
          return BOOL_F;
      }
      else
      if(tmp==MAKINUM(1)) {
        if(varres>=MAKINUM(0))
          return MAKINUM(1);
        else
          return BOOL_F;
      }
      else
      if(tmp==MAKINUM(-1)) {
        if(varres<=MAKINUM(0))
          return MAKINUM(-1);
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
  }
}

SCM make_symbs_kb_order_vector()
{
  SCM x__1,x,x__2;

  x=MAKINUM(0);
  GLOBAL(const_kb_order_vector_global)=make_vector(MAKINUM(10000),EOL);
  GLOBAL(fun_kb_order_vector_global)=make_vector(MAKINUM(300),EOL);
  for(x__1=MAKINUM(0);!(x__1>=MAKINUM(10000));x__1=MAKINUM(1+INUM(x__1))) {
    VECTOR_SET(GLOBAL(const_kb_order_vector_global),x__1,MAKINUM(10));
  }
  for(x__2=MAKINUM(0);!(x__2>=MAKINUM(300));x__2=MAKINUM(1+INUM(x__2))) {
    VECTOR_SET(GLOBAL(fun_kb_order_vector_global),x__2,MAKINUM(11));
  }
  return UNSPECIFIED;
}

SCM const_kb_order_value(x)
SCM x;
{
  SCM tmp;

  tmp=MAKINUM(INUM(x)-65536);
  if(tmp<MAKINUM(10000))
    return VECTOR_REF(GLOBAL(const_kb_order_vector_global),tmp);
  else
    return MAKINUM(10);
}

SCM fun_kb_order_value(x)
SCM x;
{
  return VECTOR_REF(GLOBAL(fun_kb_order_vector_global),MAKINUM(INUM(MAKINUM(534773760)&x)>>21));
}

SCM compare_const_kb_order(left,right)
SCM left,right;
{
  SCM lval,rval;

  lval=const_kb_order_value(left);
  rval=const_kb_order_value(right);
  if(lval>rval)
    return MAKINUM(1);
  else
  if(rval>lval)
    return MAKINUM(-1);
  else
    return compare_symbs_lex_order(left,right);
}

SCM var_inside_term_pred_(var,term,followvarsflag)
SCM var,term,followvarsflag;
{
  if(!(!(NUMBER_P(term)))) {
    if(MAKINUM(65535)>term)
      return SBOOL((MAKINUM(8191)&var)==(MAKINUM(8191)&term));
    else
      return BOOL_F;
  }
  else
  if(ZERO_P(MAKINUM(65536)&CAR(term)))
    return some_pred__inst1(followvarsflag,var,var_inside_term_pred__fn348,CDR(term));
  else
    return BOOL_F;
}

SCM var_inside_term_pred__fn348(followvarsflag,var,x)
SCM followvarsflag,var,x;
{
  return var_inside_term_pred_(var,x,followvarsflag);
}

SCM compare_terms_varcount_subset(leftvars,rightvars)
SCM leftvars,rightvars;
{
  SCM lsubflag,rsubflag,tmp;

  lsubflag=BOOL_F;
  rsubflag=BOOL_F;
  tmp=EOL;
  lsubflag=every_pred__inst2(&tmp,rightvars,compare_terms_varcount_subset_fn351,leftvars);
  rsubflag=every_pred__inst2(&tmp,leftvars,compare_terms_varcount_subset_fn352,rightvars);
  if(NFALSEP(lsubflag)&&NFALSEP(rsubflag))
    return MAKINUM(0);
  else
  if(NFALSEP(lsubflag))
    return MAKINUM(-1);
  else
  if(NFALSEP(rsubflag))
    return MAKINUM(1);
  else
    return BOOL_F;
}

SCM compare_terms_varcount_subset_fn352(tmp,leftvars,var)
SCM *tmp;
SCM leftvars,var;
{
  *tmp=assq(CAR(var),leftvars);
  if(NFALSEP(*tmp))
    return SBOOL(CDR(*tmp)>=CDR(var));
  else
    return BOOL_F;
}

SCM compare_terms_varcount_subset_fn351(tmp,rightvars,var)
SCM *tmp;
SCM rightvars,var;
{
  *tmp=assq(CAR(var),rightvars);
  if(NFALSEP(*tmp))
    return SBOOL(CDR(*tmp)>=CDR(var));
  else
    return BOOL_F;
}

SCM count_symbs_vars_excl_(term,res,followvarsflag)
SCM term,res,followvarsflag;
{
  SCM tmp;

  tmp=EOL;
  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term) {
      tmp=assq(MAKINUM(8191)&term,CDR(res));
      if(NFALSEP(tmp)) {
        SET_CDR(tmp,MAKINUM(1+INUM(CDR(tmp))));
        return UNSPECIFIED;
      }
      else {
        SET_CDR(res,cons(cons(MAKINUM(8191)&term,MAKINUM(1)),CDR(res)));
        return UNSPECIFIED;
      }
    }
    else {
      SET_CAR(res,MAKINUM(INUM(const_kb_order_value(term))+INUM(CAR(res))));
      return UNSPECIFIED;
    }
  }
  else {
    SET_CAR(res,MAKINUM(INUM(fun_kb_order_value(CAR(term)))+INUM(CAR(res))));
    return for_each1_inst5(followvarsflag,res,count_symbs_vars_excl__fn354,CDR(term));
  }
}

SCM count_symbs_vars_excl__fn354(followvarsflag,res,x)
SCM followvarsflag,res,x;
{
  return count_symbs_vars_excl_(x,res,followvarsflag);
}

SCM order_equality_litinfo_lex_testing(litinfonr,lit)
SCM litinfonr,lit;
{
  SCM tmp;

  tmp=EOL;
  tmp=apply(GLOBAL(order_equality_litinfo_lex_real),litinfonr,cons(lit,listofnull));
  newline(cur_output_port());
  display(const_361,cur_output_port());
  newline(cur_output_port());
  return tmp;
}

SCM order_equality_litinfo_lex(litinfonr,lit)
SCM litinfonr,lit;
{
  SCM left,right,leftvars,compres,rightvars;

  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    left=CAR(CDR(CAR(CDR(lit))));
  else
    left=CAR(CDR(lit));
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    right=CAR(CDR(CDR(CAR(CDR(lit)))));
  else
    right=CAR(CDR(CDR(lit)));
  leftvars=EOL;
  compres=EOL;
  rightvars=EOL;
  leftvars=make_var_depth_info(left);
  rightvars=make_var_depth_info(right);
  if(NFALSEP(every_pred__inst1(leftvars,order_equality_litinfo_lex_fn358,rightvars))) {
    compres=compare_terms_lex_order(left,right,BOOL_F);
    if(compres==MAKINUM(1))
      return prohibit_right_para(litinfonr);
    else
    if(compres==MAKINUM(-1)) {
      if(NFALSEP(every_pred__inst1(rightvars,order_equality_litinfo_lex_fn359,leftvars)))
        return prohibit_left_para(litinfonr);
      else
        return litinfonr;
    }
    else
      return litinfonr;
  }
  else
  if(NFALSEP(every_pred__inst1(rightvars,order_equality_litinfo_lex_fn360,leftvars))) {
    compres=compare_terms_lex_order(left,right,BOOL_F);
    if(compres==MAKINUM(-1))
      return prohibit_left_para(litinfonr);
    else
      return litinfonr;
  }
  else
    return litinfonr;
}

SCM order_equality_litinfo_lex_fn360(rightvars,vd)
SCM rightvars,vd;
{
  return assq(CAR(vd),rightvars);
}

SCM order_equality_litinfo_lex_fn359(rightvars,vd)
SCM rightvars,vd;
{
  return assq(CAR(vd),rightvars);
}

SCM order_equality_litinfo_lex_fn358(leftvars,vd)
SCM leftvars,vd;
{
  return assq(CAR(vd),leftvars);
}

SCM compare_terms_lex_order_old(left,right,followvarsflag)
SCM left,right,followvarsflag;
{
  SCM new_var1,tmp,tmp2,lres,rres,stopflag,lpart,rpart;

  tmp=EOL;
  tmp2=EOL;
  lres=EOL;
  rres=EOL;
  stopflag=BOOL_F;
  if(left==right)
    return MAKINUM(0);
  else
  if(NUMBER_P(left)&&(left<=MAKINUM(65535))) {
    if(!(NUMBER_P(right))&&NFALSEP(occurs_term_for_order_pred_(right,left,followvarsflag)))
      return MAKINUM(-1);
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(right)&&(right<=MAKINUM(65535))) {
    if(!(NUMBER_P(left))&&NFALSEP(occurs_term_for_order_pred_(left,right,followvarsflag)))
      return MAKINUM(1);
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(left)) {
    if(NUMBER_P(right))
      return compare_symbs_lex_order(left,right);
    else
      return MAKINUM(-1);
  }
  else
  if(NUMBER_P(right))
    return MAKINUM(1);
  else {
    lres=some_pred__inst4(&tmp,followvarsflag,right,compare_terms_lex_order_old_fn371,CDR(left));
    rres=some_pred__inst4(&tmp,followvarsflag,left,compare_terms_lex_order_old_fn372,CDR(right));
    newline(cur_output_port());
    display(const_362,cur_output_port());
    newline(cur_output_port());
    new_var1=BOOL_F;
    if(NFALSEP(new_var1))
      return new_var1;
    else
    if(NFALSEP(lres)&&NFALSEP(rres))
      return MAKINUM(0);
    else
    if(NFALSEP(lres))
      return MAKINUM(1);
    else
    if(NFALSEP(rres))
      return MAKINUM(-1);
    else
    if(fun_lex_order_value(CAR(left))<fun_lex_order_value(CAR(right))) {
      if(NFALSEP(every_pred__inst3(&tmp,followvarsflag,right,compare_terms_lex_order_old_fn367,CDR(left))))
        return MAKINUM(-1);
      else
        return BOOL_F;
    }
    else
    if(fun_lex_order_value(CAR(left))>fun_lex_order_value(CAR(right))) {
      if(NFALSEP(every_pred__inst3(&tmp,followvarsflag,left,compare_terms_lex_order_old_fn368,CDR(right))))
        return MAKINUM(1);
      else
        return BOOL_F;
    }
    else {
      tmp=BOOL_F;
      tmp2=BOOL_F;
      stopflag=BOOL_F;
      for(lpart=CDR(left),rpart=CDR(right);
          !(NULL_P(lpart)||(NULL_P(rpart)||NFALSEP(stopflag)));
          lpart=CDR(lpart),rpart=CDR(rpart)) {
        tmp=compare_terms_lex_order(CAR(lpart),CAR(rpart),followvarsflag);
        if(!(NFALSEP(tmp))||((MAKINUM(1)==tmp)||(MAKINUM(-1)==tmp))) {
          stopflag=BOOL_T;
        }
      }
      if(!(NFALSEP(tmp)))
        return BOOL_F;
      else
      if(tmp==MAKINUM(0))
        return MAKINUM(0);
      else
      if(tmp==MAKINUM(-1)) {
        if(NFALSEP(every_pred__inst3(&tmp,followvarsflag,right,compare_terms_lex_order_old_fn369,CDR(CDR(left)))))
          return MAKINUM(-1);
        else
          return BOOL_F;
      }
      else
      if(tmp==MAKINUM(1)) {
        if(NFALSEP(every_pred__inst3(&tmp,followvarsflag,left,compare_terms_lex_order_old_fn370,CDR(right))))
          return MAKINUM(1);
        else
          return BOOL_F;
      }
      else
        return UNSPECIFIED;
    }
  }
}

SCM compare_terms_lex_order_old_fn372(tmp,followvarsflag,left,x)
SCM *tmp;
SCM followvarsflag,left,x;
{
  SCM new_var3;

  *tmp=compare_terms_lex_order(x,left,followvarsflag);
  new_var3=SBOOL(*tmp==MAKINUM(0));
  if(NFALSEP(new_var3))
    return new_var3;
  else
    return SBOOL(*tmp==MAKINUM(1));
}

SCM compare_terms_lex_order_old_fn371(tmp,followvarsflag,right,x)
SCM *tmp;
SCM followvarsflag,right,x;
{
  SCM new_var2;

  *tmp=compare_terms_lex_order(x,right,followvarsflag);
  new_var2=SBOOL(*tmp==MAKINUM(0));
  if(NFALSEP(new_var2))
    return new_var2;
  else
    return SBOOL(*tmp==MAKINUM(1));
}

SCM compare_terms_lex_order_old_fn370(tmp,followvarsflag,left,arg)
SCM *tmp;
SCM followvarsflag,left,arg;
{
  *tmp=compare_terms_lex_order(arg,left,followvarsflag);
  return SBOOL(*tmp==MAKINUM(-1));
}

SCM compare_terms_lex_order_old_fn369(tmp,followvarsflag,right,arg)
SCM *tmp;
SCM followvarsflag,right,arg;
{
  *tmp=compare_terms_lex_order(arg,right,followvarsflag);
  return SBOOL(*tmp==MAKINUM(-1));
}

SCM compare_terms_lex_order_old_fn368(tmp,followvarsflag,left,arg)
SCM *tmp;
SCM followvarsflag,left,arg;
{
  *tmp=compare_terms_lex_order(arg,left,followvarsflag);
  return SBOOL(*tmp==MAKINUM(-1));
}

SCM compare_terms_lex_order_old_fn367(tmp,followvarsflag,right,arg)
SCM *tmp;
SCM followvarsflag,right,arg;
{
  *tmp=compare_terms_lex_order(arg,right,followvarsflag);
  return SBOOL(*tmp==MAKINUM(-1));
}

SCM compare_terms_lex_order(left,right,followvarsflag)
SCM left,right,followvarsflag;
{
  SCM tmp;

  tmp=BOOL_F;
  if(NFALSEP(compare_terms_lex_equal(left,right,followvarsflag)))
    return MAKINUM(0);
  else
  if(NFALSEP(compare_terms_lex_bigger(left,right,followvarsflag)))
    return MAKINUM(1);
  else
  if(NFALSEP(compare_terms_lex_bigger(right,left,followvarsflag)))
    return MAKINUM(-1);
  else
    return BOOL_F;
}

SCM compare_terms_lex_equal(left,right,followvarsflag)
SCM left,right,followvarsflag;
{
  return equal_terms_for_order_pred_(left,right,followvarsflag);
}

SCM compare_terms_lex_bigger(left,right,followvarsflag)
SCM left,right,followvarsflag;
{
  SCM new_var1,tmp,lres,stopflag,lpart,rpart;

  tmp=EOL;
  lres=EOL;
  stopflag=BOOL_F;
  if(left==right)
    return BOOL_F;
  else
  if(NUMBER_P(left)&&(left<=MAKINUM(65535)))
    return BOOL_F;
  else
  if(NUMBER_P(right)&&(right<=MAKINUM(65535))) {
    if(!(NUMBER_P(left))&&NFALSEP(occurs_term_for_order_pred_(left,right,followvarsflag)))
      return BOOL_T;
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(left)) {
    if(NUMBER_P(right)) {
      if(compare_symbs_lex_order(left,right)==MAKINUM(1))
        return BOOL_T;
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(right))
    return BOOL_T;
  else {
    lres=some_pred__inst1(followvarsflag,right,compare_terms_lex_bigger_fn378,CDR(left));
    new_var1=BOOL_F;
    if(NFALSEP(new_var1))
      return new_var1;
    else
    if(NFALSEP(lres))
      return BOOL_T;
    else
    if(fun_lex_order_value(CAR(left))>fun_lex_order_value(CAR(right))) {
      if(NFALSEP(every_pred__inst4(followvarsflag,left,compare_terms_lex_bigger_fn376,CDR(right))))
        return BOOL_T;
      else
        return BOOL_F;
    }
    else
    if(fun_lex_order_value(CAR(right))>fun_lex_order_value(CAR(left)))
      return BOOL_F;
    else {
      tmp=BOOL_F;
      stopflag=BOOL_F;
      for(lpart=CDR(left),rpart=CDR(right);
          !(NULL_P(lpart)||(NULL_P(rpart)||NFALSEP(stopflag)));
          lpart=CDR(lpart),rpart=CDR(rpart))
        if(!(NFALSEP(compare_terms_lex_equal(CAR(lpart),CAR(rpart),followvarsflag)))) {
          stopflag=BOOL_T;
          if(NFALSEP(compare_terms_lex_bigger(CAR(lpart),CAR(rpart),followvarsflag))) {
            tmp=BOOL_T;
          }
          else {
            tmp=BOOL_F;
          }
        }
      if(!(NFALSEP(tmp)))
        return BOOL_F;
      else
      if(NFALSEP(every_pred__inst4(followvarsflag,left,compare_terms_lex_bigger_fn377,CDR(CDR(right)))))
        return BOOL_T;
      else
        return BOOL_F;
    }
  }
}

SCM compare_terms_lex_bigger_fn378(followvarsflag,right,x)
SCM followvarsflag,right,x;
{
  SCM new_var2;

  new_var2=compare_terms_lex_equal(x,right,followvarsflag);
  if(NFALSEP(new_var2))
    return new_var2;
  else
    return compare_terms_lex_bigger(x,right,followvarsflag);
}

SCM compare_terms_lex_bigger_fn377(followvarsflag,left,arg)
SCM followvarsflag,left,arg;
{
  return compare_terms_lex_bigger(left,arg,followvarsflag);
}

SCM compare_terms_lex_bigger_fn376(followvarsflag,left,arg)
SCM followvarsflag,left,arg;
{
  return compare_terms_lex_bigger(left,arg,followvarsflag);
}

SCM occurs_term_for_order_pred_(lterm,rterm,followvarsflag)
SCM lterm,rterm,followvarsflag;
{
  SCM stopflag,lpart;

  stopflag=BOOL_F;
  if(lterm==rterm)
    return BOOL_F;
  else
  if(NUMBER_P(lterm)||(!(ZERO_P(MAKINUM(65536)&CAR(lterm)))&&((NUMBER_P(rterm)&&(rterm<=MAKINUM(65535)))||(!(NUMBER_P(rterm))&&((MAKINUM(65535)&CAR(rterm))>=(MAKINUM(65535)&CAR(lterm)))))))
    return BOOL_F;
  else {
    stopflag=BOOL_F;
    for(lpart=CDR(lterm);!(NULL_P(lpart)||NFALSEP(stopflag));lpart=CDR(lpart))
      if(NFALSEP(equal_terms_for_order_pred_(CAR(lpart),rterm,followvarsflag))||NFALSEP(occurs_term_for_order_pred_(CAR(lpart),rterm,followvarsflag))) {
        stopflag=BOOL_T;
      }
    return stopflag;
  }
}

SCM equal_terms_for_order_pred_(left,right,followvarsflag)
SCM left,right,followvarsflag;
{
  SCM stopflag,lpart,rpart;

  stopflag=BOOL_F;
  if(left==right)
    return BOOL_T;
  else
  if(NUMBER_P(left)&&(left<=MAKINUM(65535))) {
    if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
      return SBOOL((MAKINUM(8191)&left)==(MAKINUM(8191)&right));
    else
      return BOOL_F;
  }
  else
  if(NUMBER_P(left)||NUMBER_P(right))
    return BOOL_F;
  else
  if(!(NFALSEP(followvarsflag))&&!(CAR(left)==CAR(right)))
    return BOOL_F;
  else
  if(NFALSEP(followvarsflag)&&NFALSEP((ZERO_P(MAKINUM(65536)&CAR(left)) ? (ZERO_P(MAKINUM(65536)&CAR(right)) ? BOOL_F : SBOOL((MAKINUM(65535)&CAR(left))>(MAKINUM(65535)&CAR(right)))) : (ZERO_P(MAKINUM(65536)&CAR(right)) ? SBOOL((MAKINUM(65535)&CAR(right))>(MAKINUM(65535)&CAR(left))) : SBOOL(!(CAR(left)==CAR(right)))))))
    return BOOL_F;
  else
  if((MAKINUM(534773760)&CAR(left))==(MAKINUM(534773760)&CAR(right))) {
    stopflag=BOOL_F;
    for(lpart=CDR(left),rpart=CDR(right);
        !(NULL_P(lpart)||(NULL_P(rpart)||NFALSEP(stopflag)));
        lpart=CDR(lpart),rpart=CDR(rpart))
      if(!(NFALSEP(equal_terms_for_order_pred_(CAR(lpart),CAR(rpart),followvarsflag)))) {
        stopflag=BOOL_T;
      }
    return NOT(stopflag);
  }
  else
    return BOOL_F;
}

SCM make_symbs_lex_order_vector()
{
  SCM x__3,x,count,constlst,funlst,x__4;

  x=MAKINUM(0);
  count=MAKINUM(0);
  constlst=EOL;
  funlst=EOL;
  GLOBAL(const_lex_order_vector_global)=make_vector(MAKINUM(10000),EOL);
  GLOBAL(fun_lex_order_vector_global)=make_vector(MAKINUM(300),EOL);
  constlst=map1(make_symbs_lex_order_vector_fn383,GLOBAL(const_num_table_global));
  funlst=map1(make_symbs_lex_order_vector_fn384,GLOBAL(fun_num_arity_table_global));
  if(NFALSEP(GLOBAL(lex_order_prefer_bigger_arity_global))) {
    funlst=sort_funlist_lex(funlst);
  }
  else {
    constlst=reverse(constlst);
    funlst=reverse(sort_funlist_lex(funlst));
  }
  for(x__3=MAKINUM(0);!(x__3>=MAKINUM(10000));x__3=MAKINUM(1+INUM(x__3))) {
    VECTOR_SET(GLOBAL(const_lex_order_vector_global),x__3,MAKINUM(100+INUM(x__3)));
  }
  for(x__4=MAKINUM(0);!(x__4>=MAKINUM(300));x__4=MAKINUM(1+INUM(x__4))) {
    VECTOR_SET(GLOBAL(fun_lex_order_vector_global),x__4,MAKINUM(1000+INUM(x__4)));
  }
  count=MAKINUM(100);
  for_each1_inst2(&count,make_symbs_lex_order_vector_fn385,reverse(constlst));
  count=MAKINUM(1000);
  return for_each1_inst2(&count,make_symbs_lex_order_vector_fn386,reverse(funlst));
}

SCM make_symbs_lex_order_vector_fn386(count,x__6)
SCM *count;
SCM x__6;
{
  *count=MAKINUM(1+INUM(*count));
  VECTOR_SET(GLOBAL(const_lex_order_vector_global),MAKINUM(INUM(MAKINUM(534773760)&x__6)>>21),*count);
  return UNSPECIFIED;
}

SCM make_symbs_lex_order_vector_fn385(count,x__5)
SCM *count;
SCM x__5;
{
  *count=MAKINUM(1+INUM(*count));
  if(MAKINUM(INUM(x__5)-65536)<MAKINUM(10000)) {
    VECTOR_SET(GLOBAL(const_lex_order_vector_global),MAKINUM(INUM(x__5)-65536),*count);
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM make_symbs_lex_order_vector_fn384(x__2)
SCM x__2;
{
  return CAR(x__2);
}

SCM make_symbs_lex_order_vector_fn383(x__1)
SCM x__1;
{
  return CDR(x__1);
}

SCM sort_funlist_lex(lst)
SCM lst;
{
  if(length(lst)>MAKINUM(1))
    return sort_funlist_lex_aux(lst,length(lst));
  else
    return lst;
}

SCM sort_funlist_lex_aux(lst,len)
SCM lst,len;
{
  SCM l1,l2,s;

  if(len<MAKINUM(2))
    return lst;
  else
  if(len==MAKINUM(2)) {
    if(NFALSEP(bigger_fun_for_lex_order_pred_(CAR(lst),CAR(CDR(lst)))))
      return cons(CAR(lst),cons(CAR(CDR(lst)),EOL));
    else
      return cons(CAR(CDR(lst)),cons(CAR(lst),EOL));
  }
  else {
    l1=MAKINUM(INUM(len)/2);
    l2=MAKINUM(INUM(len)-INUM(l1));
    s=split_list(lst,l1);
    return sort_merge_lex_funlists(sort_funlist_lex_aux(CAR(s),l1),sort_funlist_lex_aux(CDR(s),l2));
  }
}

SCM sort_merge_lex_funlists(cl1,cl2)
SCM cl1,cl2;
{
  if(NULL_P(cl1))
    return cl2;
  else
  if(NULL_P(cl2))
    return cl1;
  else
  if(NFALSEP(bigger_fun_for_lex_order_pred_(CAR(cl1),CAR(cl2))))
    return cons(CAR(cl1),sort_merge_lex_funlists(CDR(cl1),cl2));
  else
    return cons(CAR(cl2),sort_merge_lex_funlists(cl1,CDR(cl2)));
}

SCM bigger_fun_for_lex_order_pred_(f1,f2)
SCM f1,f2;
{
  SCM new_var1;

  new_var1=SBOOL(CDR(assq(MAKINUM(534773760)&f1,GLOBAL(fun_num_arity_table_global)))>CDR(assq(MAKINUM(534773760)&f2,GLOBAL(fun_num_arity_table_global))));
  if(NFALSEP(new_var1))
    return new_var1;
  else
  if(CDR(assq(MAKINUM(534773760)&f1,GLOBAL(fun_num_arity_table_global)))==CDR(assq(MAKINUM(534773760)&f2,GLOBAL(fun_num_arity_table_global))))
    return SBOOL((MAKINUM(534773760)&f1)>(MAKINUM(534773760)&f2));
  else
    return BOOL_F;
}

SCM const_lex_order_value(x)
SCM x;
{
  SCM tmp;

  tmp=MAKINUM(INUM(x)-65536);
  if(tmp<MAKINUM(10000))
    return VECTOR_REF(GLOBAL(const_lex_order_vector_global),tmp);
  else
    return MAKINUM(1);
}

SCM fun_lex_order_value(x)
SCM x;
{
  return VECTOR_REF(GLOBAL(fun_lex_order_vector_global),MAKINUM(INUM(MAKINUM(534773760)&x)>>21));
}

SCM compare_symbs_lex_order(left,right)
SCM left,right;
{
  SCM lval,rval;

  lval=const_lex_order_value(left);
  rval=const_lex_order_value(right);
  if(lval==rval)
    return MAKINUM(0);
  else
  if(lval>rval)
    return MAKINUM(1);
  else
  if(lval<rval)
    return MAKINUM(-1);
  else
    return BOOL_F;
}

SCM kb_order_litinfo_aux(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM varinfo_purecl,newlitinfnr,biglits,smalllits,new_var4,new_var5,new_var1,new_var2,new_var3;

  smalllits=EOL;
  biglits=EOL;
  newlitinfnr=MAKINUM(0);
  varinfo_purecl=map1(kb_order_litinfo_aux_fn392,purecl);
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=kb_order_litinfo_aux_fn390(&newlitinfnr,varinfo_purecl,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM kb_order_litinfo_aux_fn392(x)
SCM x;
{
  return cons(make_var_depth_info(x),x);
}

SCM kb_order_litinfo_aux_fn390(newlitinfnr,varinfo_purecl,litinf,varinfolit)
SCM *newlitinfnr;
SCM varinfo_purecl,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,kb_order_litinfo_aux_fn391,varinfo_purecl))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM kb_order_litinfo_aux_fn391(varinfolit,x)
SCM varinfolit,x;
{
  return SBOOL(!(x==varinfolit)&&((NFALSEP(GLOBAL(order_strategy_flag_global))||((MAKINUM(534773760)&CAR(CDR(x)))==GLOBAL(eq_pred_nr_global)))&&NFALSEP((!(ZERO_P(MAKINUM(65536)&CAR(CDR(varinfolit)))) ? SBOOL(!(ZERO_P(MAKINUM(65536)&CAR(CDR(x))))&&((MAKINUM(63488)&CAR(CDR(x)))>(MAKINUM(63488)&CAR(CDR(varinfolit))))) : SBOOL(ZERO_P(MAKINUM(65536)&CAR(CDR(x)))&&(((MAKINUM(63488)&CAR(CDR(x)))>(MAKINUM(63488)&CAR(CDR(varinfolit))))&&NFALSEP((NFALSEP(GLOBAL(sat_strategy_flag_global)) ? vdepth__grtr__varinfolit_pred_(x,varinfolit) : vdepth__grtr__weak_varinfolit_pred_(x,varinfolit)))))))));
}

SCM make_kb_order_term_info(term)
SCM term;
{
  SCM sum_nonkeyword;

  sum_nonkeyword=MAKINUM(0);
  GLOBAL(tmp_var_occurrences_table_global)=EOL;
  if(!(NUMBER_P(term))) {
    sum_nonkeyword=make_kb_order_term_info_aux(term,MAKINUM(1),MAKINUM(0));
  }
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535))) {
    GLOBAL(tmp_var_occurrences_table_global)=cons(MAKINUM(8191)&term,MAKINUM(1));
  }
  else {
    sum_nonkeyword=apply(GLOBAL(get_const_term_lex),term,listofnull);
  }
  return cons(sum_nonkeyword,GLOBAL(tmp_var_occurrences_table_global));
}

SCM make_kb_order_term_info_aux(origterm,depth,sum_nonkeyword)
SCM origterm,depth,sum_nonkeyword;
{
  SCM term,tmp,part;

  tmp=EOL;
  term=EOL;
  for(part=CDR(origterm);!(NULL_P(part));part=CDR(part)) {
    term=CAR(part);
    if(NUMBER_P(term)) {
      if(MAKINUM(65535)>term) {
        tmp=assq(MAKINUM(8191)&term,GLOBAL(tmp_var_occurrences_table_global));
        if(NFALSEP(tmp)) {
          SET_CDR(tmp,MAKINUM(1+INUM(CDR(tmp))));
        }
        else {
          GLOBAL(tmp_var_occurrences_table_global)=cons(cons(MAKINUM(8191)&term,MAKINUM(1)),GLOBAL(tmp_var_occurrences_table_global));
        }
      }
      else {
        sum_nonkeyword=MAKINUM(INUM(sum_nonkeyword)+INUM(apply(GLOBAL(get_const_term_lex),term,listofnull)));
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(term)))
      apply(GLOBAL(make_var_depth_occurrences_aux),term,cons(MAKINUM(1+INUM(depth)),listofnull));
  }
  return MAKINUM(INUM(apply(GLOBAL(get_fun_term_lex),term,listofnull))+INUM(sum_nonkeyword));
}

SCM lex_bigger_pred_(left,right)
SCM left,right;
{
  SCM new_var1,new_var3,foundflag,res,lp,rp,lp__1,rp__2,new_var2;

  foundflag=BOOL_F;
  res=BOOL_F;
  lp=EOL;
  rp=EOL;
  if(NUMBER_P(left)&&NUMBER_P(right)) {
    if(NUMBER_P(left)&&(left<=MAKINUM(65535)))
      return BOOL_F;
    else
    if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
      return BOOL_F;
    else
    if(NFALSEP(lex_symbol_bigger_pred_(left,right)))
      return BOOL_T;
    else
    if(NFALSEP(lex_symbol_bigger_pred_(right,left)))
      return BOOL_F;
    else
    if(left==right)
      return BOOL_F;
    else {
      make_lex_symbol_bigger_excl_(left,right);
      return BOOL_T;
    }
  }
  else
  if(NUMBER_P(right)) {
    new_var3=NOT(SBOOL(NUMBER_P(right)&&(right<=MAKINUM(65535))));
    if(NFALSEP(new_var3))
      return new_var3;
    else
      return lex_occur_check_pred_(right,left);
  }
  else
  if(NUMBER_P(left))
    return BOOL_F;
  else
  if((MAKINUM(534773760)&CAR(left))==(MAKINUM(534773760)&CAR(right))) {
    for(lp__1=CDR(left),rp__2=CDR(right);
        !(NULL_P(lp__1)||NFALSEP(foundflag));
        lp__1=CDR(lp__1),rp__2=CDR(rp__2))
      if(NFALSEP(lex_bigger_pred_(CAR(lp__1),CAR(rp__2)))) {
        foundflag=BOOL_T;
        res=BOOL_T;
      }
      else {
        new_var2=term_equal_pred_(CAR(lp__1),CAR(rp__2));
        if(NFALSEP(new_var2))
          new_var1=new_var2;
        else
        if(NUMBER_P(CAR(rp__2))&&(CAR(rp__2)<=MAKINUM(65535))) {
          if(!(NUMBER_P(CAR(lp__1))))
            new_var1=lex_occur_check_pred_(CAR(rp__2),CAR(lp__1));
          else
            new_var1=BOOL_F;
        }
        else
          new_var1=BOOL_F;
        if(NFALSEP(new_var1)) ;
        else {
          foundflag=BOOL_T;
          res=BOOL_F;
        }
      }
    if(NFALSEP(res))
      return lex_bigger_than_subterms_pred_(left,right);
    else
      return BOOL_F;
  }
  else
  if((length(right)>length(left))&&(NFALSEP(lex_symbol_bigger_pred_(CAR(left),CAR(right)))&&NFALSEP(lex_bigger_than_subterms_pred_(left,right))))
    return BOOL_T;
  else
  if(NFALSEP(lex_symbol_bigger_pred_(CAR(left),CAR(right))))
    return lex_bigger_than_subterms_pred_(left,right);
  else
  if(NFALSEP(lex_symbol_bigger_pred_(CAR(right),CAR(left))))
    return BOOL_F;
  else {
    make_lex_symbol_bigger_excl_(CAR(left),CAR(right));
    return lex_bigger_than_subterms_pred_(left,right);
  }
}

SCM lex_occur_check_pred_(var,composite)
SCM var,composite;
{
  SCM el;

  composite=CDR(composite);
  for(;!(NULL_P(composite));) {
    el=CAR(composite);
    if(NUMBER_P(el)) {
      if(MAKINUM(65535)>el) {
        if(((NUMBER_P(el)&&(el<=MAKINUM(65535)))&&(var==(MAKINUM(8191)&el)))||(!(NUMBER_P(el))&&(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(lex_occur_check_pred_(var,el))))) {
          composite=EOL;
          var=BOOL_T;
        }
        else {
          composite=CDR(composite);
        }
      }
      else {
        composite=CDR(composite);
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(el))&&NFALSEP(lex_occur_check_pred_(var,el))) {
      composite=EOL;
      var=BOOL_T;
    }
    else {
      composite=CDR(composite);
    }
  }
  return SBOOL(var==BOOL_T);
}

SCM lex_bigger_than_subterms_pred_(left,right)
SCM left,right;
{
  SCM new_var1;

  new_var1=SBOOL(NUMBER_P(right));
  if(NFALSEP(new_var1))
    return new_var1;
  else
    return every_pred__inst1(left,lex_bigger_than_subterms_pred__fn394,CDR(right));
}

SCM lex_bigger_than_subterms_pred__fn394(left,x)
SCM left,x;
{
  return lex_bigger_pred_(left,x);
}

SCM lex_subterm_bigger_than(left,right)
SCM left,right;
{
  if(!(NUMBER_P(left)))
    return some_pred__inst2(right,lex_subterm_bigger_than_fn396,CDR(left));
  else
    return BOOL_F;
}

SCM lex_subterm_bigger_than_fn396(right,x)
SCM right,x;
{
  return lex_bigger_pred_(x,right);
}

SCM lex_symbol_bigger_pred_(left,right)
SCM left,right;
{
  SCM tmp;

  tmp=memq(MAKINUM(534773760)&right,GLOBAL(lex_symbol_orderlst_global));
  if(!(NFALSEP(tmp)))
    return BOOL_F;
  else
  if(NFALSEP(memq(MAKINUM(534773760)&left,CDR(tmp))))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM make_lex_symbol_bigger_excl_(left,right)
SCM left,right;
{
  left=(MAKINUM(534773760)&left);
  right=(MAKINUM(534773760)&right);
  if(!(NFALSEP(memq(left,GLOBAL(lex_symbol_orderlst_global))))) {
    GLOBAL(lex_symbol_orderlst_global)=append2(GLOBAL(lex_symbol_orderlst_global),cons(left,EOL));
  }
  if(!(NFALSEP(memq(right,GLOBAL(lex_symbol_orderlst_global))))) {
    GLOBAL(lex_symbol_orderlst_global)=cons(right,GLOBAL(lex_symbol_orderlst_global));
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM order_equality_litinfo_firstterm(litinfonr,lit)
SCM litinfonr,lit;
{
  SCM left,right,leftvars,rightvars;

  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    left=CAR(CDR(CAR(CDR(lit))));
  else
    left=CAR(CDR(lit));
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    right=CAR(CDR(CDR(CAR(CDR(lit)))));
  else
    right=CAR(CDR(CDR(lit)));
  leftvars=make_var_depth_info(left);
  rightvars=make_var_depth_info(right);
  if(NUMBER_P(left)&&NUMBER_P(right)) {
    if(NUMBER_P(left)&&(left<=MAKINUM(65535))) {
      if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
        return prohibit_left_para(prohibit_right_para(litinfonr));
      else
        return prohibit_right_para(litinfonr);
    }
    else
    if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
      return prohibit_left_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if(NUMBER_P(right)) {
    if(!(NUMBER_P(right)&&(right<=MAKINUM(65535)))||NFALSEP(assq(MAKINUM(8191)&right,leftvars)))
      return prohibit_right_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if(NUMBER_P(left)) {
    if(!(NUMBER_P(left)&&(left<=MAKINUM(65535)))||NFALSEP(assq(MAKINUM(8191)&left,rightvars)))
      return prohibit_left_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if(NFALSEP(vdepth_superset_varinfolit_pred_(cons(leftvars,left),cons(rightvars,right)))&&NFALSEP(first_term_depth_bigger_pred_(left,right)))
    return prohibit_right_para(litinfonr);
  else
  if(NFALSEP(vdepth_superset_varinfolit_pred_(cons(rightvars,right),cons(leftvars,left)))&&NFALSEP(first_term_depth_bigger_pred_(right,left)))
    return prohibit_left_para(litinfonr);
  else
    return litinfonr;
}

SCM first_term_depth_bigger_pred_(xterm,yterm)
SCM xterm,yterm;
{
  if((MAKINUM(63488)&CAR(xterm))>=(MAKINUM(63488)&CAR(yterm)))
    return SBOOL(first_term_depth(xterm)>first_term_depth(yterm));
  else
    return BOOL_F;
}

SCM first_term_depth(term)
SCM term;
{
  if(NUMBER_P(term))
    return MAKINUM(0);
  else
    return MAKINUM(1+INUM(first_term_depth(CAR(CDR(term)))));
}

SCM order_equality_litinfo_depth(litinfonr,lit)
SCM litinfonr,lit;
{
  SCM left,right,leftvars,rightvars;

  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    left=CAR(CDR(CAR(CDR(lit))));
  else
    left=CAR(CDR(lit));
  if(NFALSEP(GLOBAL(type_theory_stratflag_global)))
    right=CAR(CDR(CDR(CAR(CDR(lit)))));
  else
    right=CAR(CDR(CDR(lit)));
  leftvars=make_var_depth_info(left);
  rightvars=make_var_depth_info(right);
  if(NUMBER_P(left)&&NUMBER_P(right)) {
    if(NUMBER_P(left)&&(left<=MAKINUM(65535))) {
      if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
        return prohibit_left_para(prohibit_right_para(litinfonr));
      else
        return prohibit_right_para(litinfonr);
    }
    else
    if(NUMBER_P(right)&&(right<=MAKINUM(65535)))
      return prohibit_left_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if(NUMBER_P(right)) {
    if(!(NUMBER_P(right)&&(right<=MAKINUM(65535)))||NFALSEP(assq(MAKINUM(8191)&right,leftvars)))
      return prohibit_right_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if(NUMBER_P(left)) {
    if(!(NUMBER_P(left)&&(left<=MAKINUM(65535)))||NFALSEP(assq(MAKINUM(8191)&left,rightvars)))
      return prohibit_left_para(litinfonr);
    else
      return litinfonr;
  }
  else
  if((NFALSEP(vdepth__grtr__varinfolit_pred_(cons(leftvars,left),cons(rightvars,right)))&&((MAKINUM(63488)&CAR(left))>(MAKINUM(63488)&CAR(right))))||(NULL_P(rightvars)&&((MAKINUM(63488)&CAR(left))>(MAKINUM(63488)&CAR(right)))))
    return prohibit_right_para(litinfonr);
  else
  if((NFALSEP(vdepth__grtr__varinfolit_pred_(cons(rightvars,right),cons(leftvars,left)))&&((MAKINUM(63488)&CAR(right))>(MAKINUM(63488)&CAR(left))))||(NULL_P(leftvars)&&((MAKINUM(63488)&CAR(right))>(MAKINUM(63488)&CAR(left)))))
    return prohibit_left_para(litinfonr);
  else
    return litinfonr;
}

SCM vdepth_order_litinfo_aux(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM varinfo_purecl,newlitinfnr,biglits,smalllits,new_var4,new_var5,new_var1,new_var2,new_var3;

  smalllits=EOL;
  biglits=EOL;
  newlitinfnr=MAKINUM(0);
  varinfo_purecl=map1(vdepth_order_litinfo_aux_fn402,purecl);
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=vdepth_order_litinfo_aux_fn400(&newlitinfnr,varinfo_purecl,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM vdepth_order_litinfo_aux_fn402(x)
SCM x;
{
  return cons(make_var_depth_info(x),x);
}

SCM vdepth_order_litinfo_aux_fn400(newlitinfnr,varinfo_purecl,litinf,varinfolit)
SCM *newlitinfnr;
SCM varinfo_purecl,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,vdepth_order_litinfo_aux_fn401,varinfo_purecl))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM vdepth_order_litinfo_aux_fn401(varinfolit,x)
SCM varinfolit,x;
{
  return SBOOL(!(x==varinfolit)&&((NFALSEP(GLOBAL(order_strategy_flag_global))||((MAKINUM(534773760)&CAR(CDR(x)))==GLOBAL(eq_pred_nr_global)))&&NFALSEP((!(ZERO_P(MAKINUM(65536)&CAR(CDR(varinfolit)))) ? SBOOL(!(ZERO_P(MAKINUM(65536)&CAR(CDR(x))))&&NFALSEP((NFALSEP(GLOBAL(complete_unsat_strategy_global)) ? SBOOL((MAKINUM(63488)&CAR(CDR(x)))>(MAKINUM(63488)&CAR(CDR(varinfolit)))) : SBOOL(fun_depth_size(CAR(CDR(x)))>fun_depth_size(CAR(CDR(varinfolit))))))) : SBOOL(ZERO_P(MAKINUM(65536)&CAR(CDR(x)))&&(NFALSEP((NFALSEP(GLOBAL(complete_unsat_strategy_global)) ? SBOOL((MAKINUM(63488)&CAR(CDR(x)))>(MAKINUM(63488)&CAR(CDR(varinfolit)))) : SBOOL(fun_depth_size(CAR(CDR(x)))>fun_depth_size(CAR(CDR(varinfolit))))))&&NFALSEP((NFALSEP(GLOBAL(sat_strategy_flag_global)) ? vdepth__grtr__varinfolit_pred_(x,varinfolit) : vdepth__grtr__weak_varinfolit_pred_(x,varinfolit)))))))));
}

SCM vdepth_order_weak_litinfo_aux(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM varinfo_purecl,newlitinfnr,biglits,smalllits,new_var4,new_var5,new_var1,new_var2,new_var3;

  smalllits=EOL;
  biglits=EOL;
  newlitinfnr=MAKINUM(0);
  varinfo_purecl=map1(vdepth_order_weak_litinfo_aux_fn408,purecl);
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=vdepth_order_weak_litinfo_aux_fn406(&newlitinfnr,varinfo_purecl,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM vdepth_order_weak_litinfo_aux_fn408(x)
SCM x;
{
  return cons(make_var_depth_info(x),x);
}

SCM vdepth_order_weak_litinfo_aux_fn406(newlitinfnr,varinfo_purecl,litinf,varinfolit)
SCM *newlitinfnr;
SCM varinfo_purecl,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,vdepth_order_weak_litinfo_aux_fn407,varinfo_purecl))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM vdepth_order_weak_litinfo_aux_fn407(varinfolit,x)
SCM varinfolit,x;
{
  return SBOOL(!(x==varinfolit)&&((NFALSEP(GLOBAL(order_strategy_flag_global))||((MAKINUM(534773760)&CAR(CDR(x)))==GLOBAL(eq_pred_nr_global)))&&NFALSEP((NFALSEP(apply(GLOBAL(ground_pred_),CAR(CDR(varinfolit)),listofnull)) ? SBOOL(NFALSEP(apply(GLOBAL(ground_pred_),CAR(CDR(x)),listofnull))&&NFALSEP(apply(GLOBAL(_grtr__depth_pred_),CAR(CDR(x)),cons(CAR(CDR(varinfolit)),listofnull)))) : SBOOL(NFALSEP(apply(GLOBAL(non_ground),CAR(CDR(x)),listofnull))&&NFALSEP(vdepth__grtr__weak_varinfolit_pred_(x,varinfolit)))))));
}

SCM vdepth_order_litinfo_eq_only(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM newlitinfnr,new_var4,new_var5,new_var1,new_var2,new_var3;

  newlitinfnr=MAKINUM(0);
  for(new_var4=litinfolst,new_var5=purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=vdepth_order_litinfo_eq_only_fn410(&newlitinfnr,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM vdepth_order_litinfo_eq_only_fn410(newlitinfnr,litinf,lit)
SCM *newlitinfnr;
SCM litinf,lit;
{
  if(((MAKINUM(534773760)&CAR(lit))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(lit))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(lit))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))))))) {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    *newlitinfnr=order_equality_litinfo(*newlitinfnr,lit);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
  else
    return litinf;
}

SCM name_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM newlitinfnr,varinfo_purecl,new_var4,new_var5,new_var1,new_var2,new_var3;

  varinfo_purecl=map1(name_order_litinfo_fn416,purecl);
  newlitinfnr=MAKINUM(0);
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=name_order_litinfo_fn414(&newlitinfnr,varinfo_purecl,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM name_order_litinfo_fn416(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM name_order_litinfo_fn414(newlitinfnr,varinfo_purecl,litinf,varinfolit)
SCM *newlitinfnr;
SCM varinfo_purecl,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,name_order_litinfo_fn415,varinfo_purecl))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM name_order_litinfo_fn415(varinfolit,x)
SCM varinfolit,x;
{
  return SBOOL(!(x==varinfolit)&&((MAKINUM(534773760)&CAR(CDR(varinfolit)))>(MAKINUM(534773760)&CAR(CDR(x)))));
}

SCM epr_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM newlitinfnr,varinfo_purecl,new_var4,new_var5,new_var1,new_var2,new_var3;

  varinfo_purecl=map1(epr_order_litinfo_fn422,purecl);
  newlitinfnr=MAKINUM(0);
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=epr_order_litinfo_fn420(&newlitinfnr,varinfo_purecl,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM epr_order_litinfo_fn422(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM epr_order_litinfo_fn420(newlitinfnr,varinfo_purecl,litinf,varinfolit)
SCM *newlitinfnr;
SCM varinfo_purecl,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,epr_order_litinfo_fn421,varinfo_purecl))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM epr_order_litinfo_fn421(varinfolit,x)
SCM varinfolit,x;
{
  return epr_order_litinfo_aux(varinfolit,x);
}

SCM epr_order_litinfo_aux(ailit,bilit)
SCM ailit,bilit;
{
  SCM new_var2,blen,alen,new_var1,new_var3;

  alen=length(CDR(ailit));
  blen=length(CDR(bilit));
  if(!(ailit==bilit)) {
    new_var1=SBOOL(alen<blen);
    if(NFALSEP(new_var1))
      return new_var1;
    else
    if(alen==blen) {
      if(!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(ailit))))))
        new_var2=NOT(SBOOL(ZERO_P(MAKINUM(268435456)&CAR(CDR(bilit)))));
      else
        new_var2=BOOL_F;
      if(NFALSEP(new_var2))
        return new_var2;
      else
      if(!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(ailit))))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(bilit))))))) {
        new_var3=SBOOL((MAKINUM(534773760)&CAR(CDR(ailit)))<(MAKINUM(534773760)&CAR(CDR(bilit))));
        if(NFALSEP(new_var3))
          return new_var3;
        else
        if((MAKINUM(534773760)&CAR(CDR(ailit)))==(MAKINUM(534773760)&CAR(CDR(bilit)))) {
          if(NUMBER_P(CAR(CDR(CDR(ailit))))&&(CAR(CDR(CDR(ailit)))>MAKINUM(65535))) {
            if(NUMBER_P(CAR(CDR(CDR(bilit))))&&(CAR(CDR(CDR(bilit)))>MAKINUM(65535)))
              return SBOOL(CAR(CDR(CDR(ailit)))<CAR(CDR(CDR(bilit))));
            else
              return BOOL_F;
          }
          else
            return BOOL_F;
        }
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM poslit_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM newlitinfnr,mix_flag,varinfo_purecl,new_var4,new_var5,new_var1,new_var2,new_var3;

  varinfo_purecl=map1(poslit_order_litinfo_fn426,purecl);
  mix_flag=mixed_cl_pred_(purecl);
  newlitinfnr=MAKINUM(0);
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=poslit_order_litinfo_fn425(&newlitinfnr,mix_flag,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM poslit_order_litinfo_fn426(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM poslit_order_litinfo_fn425(newlitinfnr,mix_flag,litinf,varinfolit)
SCM *newlitinfnr;
SCM mix_flag,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||(NFALSEP(mix_flag)&&!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM firstlitpref_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM first_flag,newlitinfnr,varinfo_purecl,new_var4,new_var5,new_var1,new_var2,new_var3;

  varinfo_purecl=map1(firstlitpref_order_litinfo_fn430,purecl);
  newlitinfnr=MAKINUM(0);
  first_flag=BOOL_T;
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=firstlitpref_order_litinfo_fn429(&newlitinfnr,&first_flag,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM firstlitpref_order_litinfo_fn430(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM firstlitpref_order_litinfo_fn429(newlitinfnr,first_flag,litinf,varinfolit)
SCM *newlitinfnr,*first_flag;
SCM litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||!(NFALSEP(*first_flag))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *first_flag=BOOL_F;
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM posweight_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM negallowedflag,hasnegflag,newlitinfnr,varinfo_purecl,new_var4,new_var5,new_var1,new_var2,new_var3;

  varinfo_purecl=map1(posweight_order_litinfo_fn435,purecl);
  newlitinfnr=MAKINUM(0);
  hasnegflag=some_pred_(posweight_order_litinfo_fn436,varinfo_purecl);
  negallowedflag=BOOL_F;
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=posweight_order_litinfo_fn434(&newlitinfnr,&negallowedflag,hasnegflag,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM posweight_order_litinfo_fn436(x)
SCM x;
{
  return NOT(SBOOL(ZERO_P(MAKINUM(268435456)&CAR(CDR(x)))));
}

SCM posweight_order_litinfo_fn435(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM posweight_order_litinfo_fn434(newlitinfnr,negallowedflag,hasnegflag,litinf,varinfolit)
SCM *newlitinfnr,*negallowedflag;
SCM hasnegflag,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||((NFALSEP(hasnegflag)&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit))))))||NFALSEP(*negallowedflag))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    if(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit))))) {
      *negallowedflag=BOOL_T;
    }
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM negweight_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM tmporderflag,res,posallowedflag,hasposflag,newlitinfnr,varinfo_purecl,new_var4,new_var5,new_var1,new_var2,new_var3;

  varinfo_purecl=map1(negweight_order_litinfo_fn441,purecl);
  newlitinfnr=MAKINUM(0);
  hasposflag=some_pred_(negweight_order_litinfo_fn442,varinfo_purecl);
  posallowedflag=BOOL_F;
  res=EOL;
  tmporderflag=GLOBAL(order_strategy_flag_global);
  if(NFALSEP(hasposflag)) {
    for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
        PAIR_P(new_var4)&&PAIR_P(new_var5);
        new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
      new_var3=negweight_order_litinfo_fn440(&newlitinfnr,&posallowedflag,hasposflag,CAR(new_var4),CAR(new_var5));
      if(NULL_P(new_var1)) {
        new_var1=cons(new_var3,EOL);
        new_var2=new_var1;
      }
      else {
        SET_CDR(new_var2,cons(new_var3,EOL));
        new_var2=CDR(new_var2);
      }
    }
    return new_var1;
  }
  else {
    tmporderflag=GLOBAL(order_strategy_flag_global);
    GLOBAL(order_strategy_flag_global)=BOOL_T;
    res=vdepth_order_litinfo(litinfolst,purecl);
    GLOBAL(order_strategy_flag_global)=tmporderflag;
    return res;
  }
}

SCM negweight_order_litinfo_fn442(x)
SCM x;
{
  return NOT(SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(x))))));
}

SCM negweight_order_litinfo_fn441(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM negweight_order_litinfo_fn440(newlitinfnr,posallowedflag,hasposflag,litinf,varinfolit)
SCM *newlitinfnr,*posallowedflag;
SCM hasposflag,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||((NFALSEP(hasposflag)&&!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))||NFALSEP(*posallowedflag))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    if(!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))) {
      *posallowedflag=BOOL_T;
    }
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM exp_order_litinfo_suva(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM varinfo_purecl,newlitinfnr,biglits,smalllits,new_var4,new_var5,new_var1,new_var2,new_var3;

  smalllits=EOL;
  biglits=EOL;
  newlitinfnr=MAKINUM(0);
  varinfo_purecl=map1(exp_order_litinfo_suva_fn448,purecl);
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=exp_order_litinfo_suva_fn446(&newlitinfnr,varinfo_purecl,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM exp_order_litinfo_suva_fn448(x)
SCM x;
{
  return cons(make_var_depth_info(x),x);
}

SCM exp_order_litinfo_suva_fn446(newlitinfnr,varinfo_purecl,litinf,varinfolit)
SCM *newlitinfnr;
SCM varinfo_purecl,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,exp_order_litinfo_suva_fn447,varinfo_purecl))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM exp_order_litinfo_suva_fn447(varinfolit,x)
SCM varinfolit,x;
{
  return SBOOL(!(x==varinfolit)&&NFALSEP((!(ZERO_P(MAKINUM(65536)&CAR(CDR(varinfolit)))) ? (!(ZERO_P(MAKINUM(65536)&CAR(CDR(x)))) ? SBOOL(fun_depth_size(CAR(CDR(x)))>fun_depth_size(CAR(CDR(varinfolit)))) : SBOOL(fun_depth_size(CAR(CDR(x)))>=fun_depth_size(CAR(CDR(varinfolit))))) : SBOOL(ZERO_P(MAKINUM(65536)&CAR(CDR(x)))&&((NFALSEP(vdepth_superset_varinfolit_pred_(x,varinfolit))&&!(NFALSEP(vdepth_superset_varinfolit_pred_(varinfolit,x))))||(fun_depth_size(CAR(CDR(x)))>fun_depth_size(CAR(CDR(varinfolit)))))))));
}

SCM exp_order_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM newlitinfnr,varinfo_purecl,new_var4,new_var5,new_var1,new_var2,new_var3;

  varinfo_purecl=map1(exp_order_litinfo_fn454,purecl);
  newlitinfnr=MAKINUM(0);
  for(new_var4=litinfolst,new_var5=varinfo_purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=exp_order_litinfo_fn452(&newlitinfnr,varinfo_purecl,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM exp_order_litinfo_fn454(x)
SCM x;
{
  return cons(BOOL_T,x);
}

SCM exp_order_litinfo_fn452(newlitinfnr,varinfo_purecl,litinf,varinfolit)
SCM *newlitinfnr;
SCM varinfo_purecl,litinf,varinfolit;
{
  if(NFALSEP(answer_lit_pred_(CDR(varinfolit)))||NFALSEP(some_pred__inst2(varinfolit,exp_order_litinfo_fn453,varinfo_purecl))) {
    SET_CAR(varinfolit,EOL);
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global,CDR(CDR(CDR(litinf))))));
  }
  else {
    *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
    if(NFALSEP(GLOBAL(ordered_paramodulation_flag_global))&&(((MAKINUM(534773760)&CAR(CDR(varinfolit)))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(CDR(varinfolit)))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(CDR(varinfolit)))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(CDR(varinfolit)))))))))) {
      *newlitinfnr=order_equality_litinfo(*newlitinfnr,CDR(varinfolit));
    }
    return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
  }
}

SCM exp_order_litinfo_fn453(varinfolit,x)
SCM varinfolit,x;
{
  return exp_order_litinfo_aux(CDR(varinfolit),CDR(x));
}

SCM exp_order_litinfo_aux(ailit,bilit)
SCM ailit,bilit;
{
  SCM tmp,new_var1;

  tmp=EOL;
  if(ailit==bilit)
    return BOOL_F;
  else {
    tmp=compare_terms_kb_order(ailit,bilit,BOOL_F);
    new_var1=BOOL_F;
    if(NFALSEP(new_var1))
      return new_var1;
    else
    if(tmp==MAKINUM(-1))
      return BOOL_T;
    else
      return BOOL_F;
  }
}

SCM clear_litorder_litinfo(litinfolst,purecl)
SCM litinfolst,purecl;
{
  SCM newlitinfnr,new_var4,new_var5,new_var1,new_var2,new_var3;

  newlitinfnr=MAKINUM(0);
  for(new_var4=litinfolst,new_var5=purecl,new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=clear_litorder_litinfo_fn456(&newlitinfnr,CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM clear_litorder_litinfo_fn456(newlitinfnr,litinf,lit)
SCM *newlitinfnr;
SCM litinf,lit;
{
  *newlitinfnr=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(CAR(CDR(CDR(litinf)))|litinf_nouse_mask_global));
  if(((MAKINUM(534773760)&CAR(lit))==GLOBAL(eq_pred_nr_global))||(NFALSEP(GLOBAL(type_theory_stratflag_global))&&(!(NUMBER_P(CAR(CDR(lit))))&&(((MAKINUM(534773760)&CAR(CAR(CDR(lit))))==GLOBAL(eq_fun_nr_global))&&!(!(ZERO_P(MAKINUM(268435456)&CAR(lit)))))))) {
    *newlitinfnr=order_equality_litinfo(*newlitinfnr,lit);
  }
  return cons(CAR(litinf),cons(CAR(CDR(litinf)),cons(*newlitinfnr,CDR(CDR(CDR(litinf))))));
}

SCM vdepth__grtr__varinfolit_pred_(alit,blit)
SCM alit,blit;
{
  if(!(NULL_P(CAR(blit))))
    return every_pred__inst1(alit,vdepth__grtr__varinfolit_pred__fn458,CAR(blit));
  else
    return BOOL_F;
}

SCM vdepth__grtr__varinfolit_pred__fn458(alit,pr)
SCM alit,pr;
{
  SCM tmp;

  tmp=assq(CAR(pr),CAR(alit));
  if(NFALSEP(tmp))
    return SBOOL(CDR(tmp)>CDR(pr));
  else
    return BOOL_F;
}

SCM vdepth__grtr__weak_varinfolit_pred_(alit,blit)
SCM alit,blit;
{
  if(!(NULL_P(CAR(blit)))) {
    if(NFALSEP(every_pred__inst1(alit,vdepth__grtr__weak_varinfolit_pred__fn461,CAR(blit))))
      return some_pred__inst2(alit,vdepth__grtr__weak_varinfolit_pred__fn462,CAR(blit));
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM vdepth__grtr__weak_varinfolit_pred__fn462(alit,pr)
SCM alit,pr;
{
  SCM tmp__1;

  tmp__1=assq(CAR(pr),CAR(alit));
  if(NFALSEP(tmp__1))
    return SBOOL(CDR(tmp__1)>CDR(pr));
  else
    return BOOL_F;
}

SCM vdepth__grtr__weak_varinfolit_pred__fn461(alit,pr)
SCM alit,pr;
{
  SCM tmp;

  tmp=assq(CAR(pr),CAR(alit));
  return SBOOL(NFALSEP(tmp)&&(CDR(tmp)>=CDR(pr)));
}

SCM vdepth_superset_varinfolit_pred_(alit,blit)
SCM alit,blit;
{
  SCM new_var1;

  new_var1=SBOOL(NULL_P(CAR(blit)));
  if(NFALSEP(new_var1))
    return new_var1;
  else
    return every_pred__inst1(alit,vdepth_superset_varinfolit_pred__fn464,CAR(blit));
}

SCM vdepth_superset_varinfolit_pred__fn464(alit,pr)
SCM alit,pr;
{
  return assq(CAR(pr),CAR(alit));
}

SCM make_var_depth_info(term)
SCM term;
{
  GLOBAL(tmp_var_depth_table_global)=EOL;
  if(!(NUMBER_P(term))&&(ZERO_P(MAKINUM(65536)&CAR(term))&&!(NFALSEP(answer_lit_pred_(term)))))
    make_var_depth_info_aux(term,MAKINUM(1));
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535))) {
    GLOBAL(tmp_var_depth_table_global)=cons(cons(MAKINUM(8191)&term,MAKINUM(0)),EOL);
  }
  return GLOBAL(tmp_var_depth_table_global);
}

SCM make_var_depth_info_aux(term,depth)
SCM term,depth;
{
  SCM tmp,part;

  tmp=EOL;
  for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
    term=CAR(part);
    if(NUMBER_P(term)) {
      if(MAKINUM(65535)>term) {
        tmp=assq(MAKINUM(8191)&term,GLOBAL(tmp_var_depth_table_global));
        if(NFALSEP(tmp)) {
          if(depth>CDR(tmp)) {
            SET_CDR(tmp,depth);
          }
        }
        else {
          GLOBAL(tmp_var_depth_table_global)=cons(cons(MAKINUM(8191)&term,depth),GLOBAL(tmp_var_depth_table_global));
        }
      }
    }
    else
    if(ZERO_P(MAKINUM(65536)&CAR(term)))
      make_var_depth_info_aux(term,MAKINUM(1+INUM(depth)));
  }
  return UNSPECIFIED;
}

SCM show_history(history)
SCM history;
{
  if(NFALSEP(GLOBAL(simple_history_stratflag_global)))
    return show_history_simple(history);
  else
    return show_history_complex(history);
}

SCM show_history_simple(history)
SCM history;
{
  SCM propclnumbers;

  propclnumbers=EOL;
  if(!(NULL_P(GLOBAL(checkpoint_keptnrs_global)))&&(GLOBAL(display_info_level_global)>=MAKINUM(20))) {
    newline(cur_output_port());
    display(const_363,cur_output_port());
    print_list_as_term(cons(c_symb,reverse(GLOBAL(checkpoint_keptnrs_global))));
    newline(cur_output_port());
    newline(cur_output_port());
  }
  for_each1(show_history_simple_fn467,GLOBAL(sos_clauses_list_list_global));
  if(!(NULL_P(GLOBAL(usable_clauses_list_global)))) {
    GLOBAL(usable_clauses_list_global)=CDR(GLOBAL(usable_clauses_list_global));
  }
  for_each1(show_history_simple_fn468,GLOBAL(usable_clauses_list_list_global));
  GLOBAL(usable_clauses_list_global)=cons(EOL,GLOBAL(usable_clauses_list_global));
  GLOBAL(all_history_clauses_list_global)=append2(GLOBAL(all_back_subsumed_clauses_global),append2(GLOBAL(sos_clauses_list_global),CDR(GLOBAL(usable_clauses_list_global))));
  GLOBAL(otter_prepared_history_global)=EOL;
  GLOBAL(shown_clausenrs_global)=EOL;
  GLOBAL(simple_history_clausenr_stack_global)=EOL;
  if(PAIR_P(history)&&((CAR(history)==propositional_from_input_symb)&&!(NULL_P(GLOBAL(unsprop_history_global))))) {
    propclnumbers=apply(GLOBAL(show_history_simple_propclauses),GLOBAL(unsprop_history_global),listofnull);
    GLOBAL(simple_history_clausenr_stack_global)=propclnumbers;
  }
  show_history_simple_onehistory(history);
  GLOBAL(simple_prepared_history_global)=cons(cons(MAKINUM(1+INUM(GLOBAL(kept_cl_nr_global))),cons(history,cons(EOL,EOL))),EOL);
  show_history_simple_stackprocess();
  newline(cur_output_port());
  display(const_364,cur_output_port());
  show_history_simple_printout(GLOBAL(simple_prepared_history_global));
  newline(cur_output_port());
  display(const_365,cur_output_port());
  newline(cur_output_port());
  GLOBAL(display_info_level_global)=MAKINUM(40);
  newline(cur_output_port());
  display(const_366,cur_output_port());
  newline(cur_output_port());
  return show_one_pass_strategy();
}

SCM show_history_simple_fn468(lst)
SCM lst;
{
  GLOBAL(usable_clauses_list_global)=append2((NULL_P(lst) ? EOL : CDR(lst)),GLOBAL(usable_clauses_list_global));
  return UNSPECIFIED;
}

SCM show_history_simple_fn467(lst)
SCM lst;
{
  GLOBAL(sos_clauses_list_global)=append2(lst,GLOBAL(sos_clauses_list_global));
  return UNSPECIFIED;
}

SCM show_history_simple_printout(prepared_history)
SCM prepared_history;
{
  SCM histelem,sorted_history,histpart;

  sorted_history=sort_by_firstel(prepared_history);
  histelem=EOL;
  for(histpart=sorted_history;!(NULL_P(histpart));histpart=CDR(histpart)) {
    histelem=CAR(histpart);
    newline(cur_output_port());
    display(CAR(histelem),cur_output_port());
    display(const_367,cur_output_port());
    show_history_simple_printparents(show_history_simple_split_proofsteps(CAR(CDR(histelem))),BOOL_F);
    display(const_368,cur_output_port());
    if(PAIR_P(CAR(CDR(CDR(histelem)))))
      print_pure_clause(CAR(CDR(CDR(histelem))));
    else
    if(_pred__symb==CAR(CDR(CDR(histelem))))
      display(_pred__symb,cur_output_port());
    else
    if(NULL_P(CAR(CDR(CDR(histelem)))))
      display(contradiction_symb,cur_output_port());
    else
      display(_pred__pred__symb,cur_output_port());
  }
  return UNSPECIFIED;
}

SCM show_history_simple_split_proofsteps(history)
SCM history;
{
  SCM resel,res,histpart;

  res=EOL;
  resel=EOL;
  for(histpart=history;!(NULL_P(histpart));histpart=CDR(histpart))
    if(SYMBOL_P(CAR(histpart))) {
      res=append2(reverse(resel),res);
      resel=cons(CAR(histpart),EOL);
    }
    else {
      resel=cons(CAR(histpart),resel);
    }
  res=append2(reverse(resel),res);
  return res;
}

SCM show_history_simple_printparents(lst,inputflag)
SCM lst,inputflag;
{
  SCM new_var1;

tailrecursion:
  new_var1=SBOOL(NULL_P(lst));
  if(NFALSEP(new_var1))
    return new_var1;
  else
  if((CAR(lst)==input_symb)&&(NFALSEP(every_pred_(show_history_simple_printparents_fn470,CDR(lst)))&&!(NFALSEP(inputflag))))
    return BOOL_F;
  else
  if((para_symb==CAR(lst))&&(PAIR_P(CAR(CDR(lst)))&&PAIR_P(CAR(CDR(CDR(lst)))))) {
    display(const_369,cur_output_port());
    show_history_simple_printparents_aux(CAR(CDR(lst)));
    if(PAIR_P(CDR(CDR(CAR(CDR(CDR(lst))))))) {
      if(NFALSEP(CAR(CDR(CDR(CAR(CDR(CDR(lst))))))))
        display(const_370,cur_output_port());
      else
        display(const_371,cur_output_port());
    }
    display(const_372,cur_output_port());
    show_history_simple_printparents_aux(cons(CAR(CAR(CDR(CDR(lst)))),cons(CAR(CDR(CAR(CDR(CDR(lst))))),EOL)));
    display(const_373,cur_output_port());
    show_history_simple_printparents_aux(reverse(CAR(CDR(CDR(CDR(CAR(CDR(CDR(lst)))))))));
    if(PAIR_P(CDR(CDR(CDR(lst)))))
      display(const_374,cur_output_port());
    lst=CDR(CDR(CDR(lst)));
    goto tailrecursion;
  }
  else
  if(SYMBOL_P(CAR(lst))) {
    display(CAR(lst),cur_output_port());
    if(!(NULL_P(CDR(lst))))
      display(const_375,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
  if(PAIR_P(CAR(lst))&&(NUMBER_P(CAR(CAR(lst)))&&(NFALSEP(equal(CAR(CDR(CAR(lst))),MAKINUM(1)))&&NULL_P(CDR(CDR(CAR(lst))))))) {
    display(CAR(CAR(lst)),cur_output_port());
    if(!(NULL_P(CDR(lst))))
      display(const_376,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
  if(PAIR_P(CAR(lst))) {
    show_history_simple_printparents_aux(CAR(lst));
    if(!(NULL_P(CDR(lst))))
      display(const_377,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
  else {
    display(CAR(lst),cur_output_port());
    if(!(NULL_P(CDR(lst))))
      display(const_378,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM show_history_simple_printparents_fn470(x)
SCM x;
{
  return SBOOL(!(SYMBOL_P(x)));
}

SCM show_history_simple_printparents_aux(y)
SCM y;
{
tailrecursion:
  if(!(NULL_P(y))) {
    display(CAR(y),cur_output_port());
    if(!(NULL_P(CDR(y))))
      display(const_379,cur_output_port());
    y=CDR(y);
    goto tailrecursion;
  }
  else
    return UNSPECIFIED;
}

SCM show_history_simple_onehistory(history)
SCM history;
{
  SCM new_var1,new_var3,new_var5,orighistory,histelem,histpart,new_var6,new_var4,new_var2;

  histelem=EOL;
  orighistory=history;
  for(histpart=history;!(NULL_P(histpart));histpart=CDR(histpart)) {
    histelem=CAR(histpart);
    if(NUMBER_P(histelem)) {
      new_var5=member(histelem,GLOBAL(simple_history_clausenr_stack_global));
      if(NFALSEP(new_var5)) ;
      else {
        new_var6=member(histelem,GLOBAL(shown_clausenrs_global));
        if(NFALSEP(new_var6)) ;
        else {
          GLOBAL(simple_history_clausenr_stack_global)=cons(histelem,GLOBAL(simple_history_clausenr_stack_global));
        }
      }
    }
    else
    if(PAIR_P(histelem)&&(SYMBOL_P(CAR(histelem))&&(PAIR_P(CDR(histelem))&&NUMBER_P(CAR(CDR(histelem)))))) {
      new_var3=member(CAR(CDR(histelem)),GLOBAL(simple_history_clausenr_stack_global));
      if(NFALSEP(new_var3)) ;
      else {
        new_var4=member(CAR(CDR(histelem)),GLOBAL(shown_clausenrs_global));
        if(NFALSEP(new_var4)) ;
        else {
          GLOBAL(simple_history_clausenr_stack_global)=cons(CAR(CDR(histelem)),GLOBAL(simple_history_clausenr_stack_global));
        }
      }
    }
    else
    if(PAIR_P(histelem)&&NUMBER_P(CAR(histelem))) {
      new_var1=member(CAR(histelem),GLOBAL(simple_history_clausenr_stack_global));
      if(NFALSEP(new_var1)) ;
      else {
        new_var2=member(CAR(histelem),GLOBAL(shown_clausenrs_global));
        if(NFALSEP(new_var2)) ;
        else {
          GLOBAL(simple_history_clausenr_stack_global)=cons(CAR(histelem),GLOBAL(simple_history_clausenr_stack_global));
        }
      }
    }
  }
  return UNSPECIFIED;
}

SCM show_history_simple_stackprocess()
{
  SCM stackelem,stackelem_clause;

  stackelem=EOL;
  stackelem_clause=EOL;
  for(;!(NULL_P(GLOBAL(simple_history_clausenr_stack_global)));) {
    stackelem=CAR(GLOBAL(simple_history_clausenr_stack_global));
    GLOBAL(simple_history_clausenr_stack_global)=CDR(GLOBAL(simple_history_clausenr_stack_global));
    GLOBAL(shown_clausenrs_global)=cons(stackelem,GLOBAL(shown_clausenrs_global));
    stackelem_clause=find_simple_history_clause(stackelem);
    if(!(NFALSEP(stackelem_clause))) {
      GLOBAL(simple_prepared_history_global)=cons(cons(stackelem,cons(const_380,cons(_pred__symb,EOL))),GLOBAL(simple_prepared_history_global));
    }
    else {
      show_history_simple_onehistory(CAR(CDR(CDR(CDR(CDR(CDR(CAR(stackelem_clause))))))));
      GLOBAL(simple_prepared_history_global)=cons(cons(stackelem,cons(CAR(CDR(CDR(CDR(CDR(CDR(CAR(stackelem_clause))))))),cons(CDR(stackelem_clause),EOL))),GLOBAL(simple_prepared_history_global));
    }
  }
  return UNSPECIFIED;
}

SCM find_simple_history_clause(stackelem)
SCM stackelem;
{
  SCM foundclause,endflag,clauselstpart;

  endflag=BOOL_F;
  foundclause=BOOL_F;
  for(clauselstpart=GLOBAL(all_history_clauses_list_global);!(NULL_P(clauselstpart)||(NFALSEP(endflag)||NFALSEP(foundclause)));clauselstpart=CDR(clauselstpart))
    if(PAIR_P(CAR(clauselstpart))&&(clinfo_clnr(CAR(CAR(clauselstpart)))==stackelem)) {
      foundclause=CAR(clauselstpart);
    }
  return foundclause;
}

SCM show_history_complex(history)
SCM history;
{
  if(!(NULL_P(GLOBAL(checkpoint_keptnrs_global)))&&(GLOBAL(display_info_level_global)>=MAKINUM(20))) {
    newline(cur_output_port());
    display(const_381,cur_output_port());
    print_list_as_term(cons(c_symb,reverse(GLOBAL(checkpoint_keptnrs_global))));
    newline(cur_output_port());
    newline(cur_output_port());
  }
  GLOBAL(otter_prepared_history_global)=EOL;
  GLOBAL(shown_clausenrs_global)=EOL;
  if(PAIR_P(history)&&(((hyper_symb==CAR(history))||((factor_symb==CAR(history))||((binres_demod_symb==CAR(history))||(binres_symb==CAR(history)))))&&ZERO_P(CAR(CDR(history))))) {
    history=cons(CAR(history),cons(MAKINUM(1+INUM(GLOBAL(kept_cl_nr_global))),CDR(CDR(history))));
  }
  otter_show_history_aux(history,BOOL_T);
  GLOBAL(otter_prepared_history_global)=sort_by_firstel(GLOBAL(otter_prepared_history_global));
  for_each1(show_history_complex_fn472,GLOBAL(otter_prepared_history_global));
  newline(cur_output_port());
  return newline(cur_output_port());
}

SCM show_history_complex_fn472(x)
SCM x;
{
  newline(cur_output_port());
  display(CAR(x),cur_output_port());
  display(const_382,cur_output_port());
  otter_show_history_printparents(but_last(CDR(x)));
  display(const_383,cur_output_port());
  if(PAIR_P(CAR(my_last_pair(x))))
    return print_clause(CAR(my_last_pair(x)));
  else
  if(_pred__symb==CAR(my_last_pair(x)))
    return display(_pred__symb,cur_output_port());
  else
    return display(const_384,cur_output_port());
}

SCM otter_show_history_printparents(lst)
SCM lst;
{
  SCM new_var1;

tailrecursion:
  new_var1=SBOOL(NULL_P(lst));
  if(NFALSEP(new_var1))
    return new_var1;
  else
  if(SYMBOL_P(CAR(lst))) {
    display(CAR(lst),cur_output_port());
    if(!(NULL_P(CDR(lst))))
      display(const_385,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
  else
  if(PAIR_P(CAR(lst))) {
    otter_show_history_printparents_aux(CAR(lst));
    if(!(NULL_P(CDR(lst))))
      display(const_386,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
  else {
    display(CAR(lst),cur_output_port());
    if(!(NULL_P(CDR(lst))))
      display(const_387,cur_output_port());
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM otter_show_history_printparents_aux(y)
SCM y;
{
tailrecursion:
  if(!(NULL_P(y))) {
    display(CAR(y),cur_output_port());
    if(!(NULL_P(CDR(y))))
      display(const_388,cur_output_port());
    y=CDR(y);
    goto tailrecursion;
  }
  else
    return UNSPECIFIED;
}

SCM otter_show_history_aux(history,pos)
SCM history,pos;
{
  SCM part,old_history,constr,dernr,premissnrs,clausepl,clause,res,b1,b2,newres,demods,tmp,part__1;

  old_history=history;
  constr=CAR(history);
  dernr=CAR(CDR(history));
  premissnrs=EOL;
  clausepl=EOL;
  clause=EOL;
  res=EOL;
  b1=EOL;
  b2=EOL;
  newres=EOL;
  demods=EOL;
  tmp=EOL;
  for(part=history;!(NULL_P(part));part=CDR(part))
    if(!(PAIR_P(CAR(part)))||!(demod_symb==CAR(CAR(part)))) {
      tmp=cons(CAR(part),tmp);
    }
  history=reverse(tmp);
  res=cons(dernr,res);
  if((factor_symb==constr)||(binres_demod_symb==constr)) {
    b1=CAR(CDR(CAR(CDR(CDR(history)))));
  }
  if(binres_symb==constr) {
    b1=CAR(CDR(CAR(CDR(CAR(CDR(CDR(history)))))));
    b2=CAR(CDR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))));
  }
  if(hyper_symb==constr) {
    b1=CAR(CDR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))));
  }
  if(((factor_symb==constr)||(binres_demod_symb==constr))&&((ZERO_P(b1)||(b1>=GLOBAL(one_pass_kept_clauses_firstnr_global)))&&!(NFALSEP(show_history_find_clausepl(b1))))) {
    tmp=otter_show_history_aux(append2(cons(CAR(CAR(CDR(CDR(history)))),cons(dernr,EOL)),CDR(CDR(CAR(CDR(CDR(history)))))),pos);
    res=append2(cons(factor_s_symb,EOL),CDR(tmp));
    res=cons(CAR(tmp),res);
  }
  else
  if((hyper_symb==constr)&&((ZERO_P(b1)||(b1>=GLOBAL(one_pass_kept_clauses_firstnr_global)))&&!(NFALSEP(show_history_find_clausepl(b1))))) {
    tmp=otter_show_history_aux(append2(cons(CAR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))),cons(dernr,EOL)),CDR(CDR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))))),pos);
    res=append2(cons(CAR(CDR(CAR(CDR(CDR(history))))),cons(hyper_s_symb,EOL)),CDR(tmp));
    res=cons(CAR(tmp),res);
    otter_show_history_aux(CAR(CDR(CDR(history))),BOOL_F);
  }
  else
  if((binres_symb==constr)&&(((ZERO_P(b1)||(b1>=GLOBAL(one_pass_kept_clauses_firstnr_global)))&&!(NFALSEP(show_history_find_clausepl(b1))))||((ZERO_P(b2)||(b2>=GLOBAL(one_pass_kept_clauses_firstnr_global)))&&!(NFALSEP(show_history_find_clausepl(b2)))))) {
    if(!(NFALSEP(show_history_find_clausepl(b1)))) {
      tmp=otter_show_history_aux(append2(cons(CAR(CAR(CDR(CAR(CDR(CDR(history)))))),cons(dernr,EOL)),CDR(CDR(CAR(CDR(CAR(CDR(CDR(history)))))))),pos);
      res=append2(cons(b2,cons(binary_s_symb,EOL)),CDR(tmp));
      res=cons(CAR(tmp),res);
      otter_show_history_aux(CAR(CDR(CAR(CDR(CDR(CDR(history)))))),BOOL_F);
    }
    else
    if(!(NFALSEP(show_history_find_clausepl(b2)))) {
      tmp=otter_show_history_aux(append2(cons(CAR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))),cons(dernr,EOL)),CDR(CDR(CAR(CDR(CAR(CDR(CDR(CDR(history))))))))),pos);
      res=append2(cons(b1,cons(binary_s_symb,EOL)),CDR(tmp));
      res=cons(CAR(tmp),res);
      otter_show_history_aux(CAR(CDR(CAR(CDR(CDR(history))))),BOOL_F);
    }
  }
  else
  if(NUMBER_P(dernr)&&(dernr<GLOBAL(one_pass_kept_clauses_firstnr_global))) {
    if(!(NFALSEP(show_history_find_clausepl(dernr)))) {
      res=cons(_pred__symb,res);
      res=cons(_pred__symb,res);
    }
    else {
      if(!(input_symb==constr)) {
        res=cons(_pred__symb,cons(constr,res));
      }
      res=cons(otter_show_history_aux_aux(dernr,EOL,EOL),res);
    }
  }
  else
  if(binres_symb==constr) {
    res=cons(binary_symb,res);
    res=cons((!(MAKINUM(1)==CAR(CDR(CDR(CAR(CDR(CDR(history))))))) ? cons(show_history_clnr(CAR(CDR(CDR(history)))),cons(CAR(CDR(CDR(CAR(CDR(CDR(history)))))),EOL)) : show_history_clnr(CAR(CDR(CDR(history))))),res);
    res=cons((!(MAKINUM(1)==CAR(CDR(CDR(CAR(CDR(CDR(CDR(history)))))))) ? cons(show_history_clnr(CAR(CDR(CDR(CDR(history))))),cons(CAR(CDR(CDR(CAR(CDR(CDR(CDR(history))))))),EOL)) : show_history_clnr(CAR(CDR(CDR(CDR(history)))))),res);
    res=cons(otter_show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),cons(CAR(CDR(CDR(CDR(history)))),EOL))),res);
  }
  else
  if(hyper_symb==constr) {
    res=cons(hyper_symb,res);
    res=cons(show_history_clnr(CAR(CDR(CDR(history)))),res);
    for_each1_inst2(&res,otter_show_history_aux_fn476,CDR(CDR(CDR(history))));
    res=cons(otter_show_history_aux_aux(dernr,history,CDR(CDR(history))),res);
  }
  else
  if(para_symb==constr) {
    res=append2(cons(show_history_clnr(CAR(CDR(CDR(CDR(history))))),cons(cons(show_history_clnr(CAR(CDR(CDR(history)))),CDR(CDR(CDR(CDR(history))))),cons(para_symb,EOL))),res);
    res=cons(otter_show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),cons(CAR(CDR(CDR(CDR(history)))),EOL))),res);
  }
  else
  if((factor_symb==constr)||(binres_demod_symb==constr)) {
    res=append2(cons(show_history_clnr(CAR(CDR(CDR(history)))),cons(constr,EOL)),res);
    res=cons(otter_show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),EOL)),res);
  }
  else
  if(input_symb==constr) {
    clausepl=show_history_find_clausepl(dernr);
    if(NFALSEP(clausepl)&&(old_symb==CAR(clausepl))) {
      clausepl=CDR(clausepl);
    }
    if(NFALSEP(clausepl)) {
      res=cons(CAR(clausepl),res);
      GLOBAL(shown_clausenrs_global)=cons(dernr,GLOBAL(shown_clausenrs_global));
    }
  }
  else
  if(backdemod_symb==constr) {
    res=append2(cons(show_history_clnr(CAR(CDR(CDR(history)))),cons(backdemod_symb,EOL)),res);
    res=cons(otter_show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),EOL)),res);
  }
  else
  if(literal_symb==constr) {
    otter_show_history_aux(CAR(CDR(history)),pos);
    res=BOOL_F;
  }
  else
  if(NUMBER_P(pos)) {
    newline(cur_output_port());
    display_spaces(pos);
  }
  else
    report_error(const_389,cons(constr,EOL));
  if(NFALSEP(res)) {
    for(part__1=old_history;!(NULL_P(part__1));part__1=CDR(part__1))
      if(PAIR_P(CAR(part__1))&&(demod_symb==CAR(CAR(part__1)))) {
        demods=append2(CDR(CAR(part__1)),demods);
      }
    if(!(NULL_P(demods))) {
      res=cons(CAR(res),append2(map1(otter_show_history_aux_fn477,demods),cons(demod_symb,CDR(res))));
    }
    for_each1_inst3(pos,otter_show_history_aux_fn478,demods);
    tmp=assq(CAR(my_last_pair(res)),GLOBAL(otter_prepared_history_global));
    if(!(NFALSEP(tmp))) {
      GLOBAL(otter_prepared_history_global)=cons(reverse(res),GLOBAL(otter_prepared_history_global));
    }
    else
    if(length(tmp)<length(res)) {
      SET_CDR(tmp,CDR(reverse(res)));
    }
  }
  return res;
}

SCM otter_show_history_aux_fn478(pos,x)
SCM pos,x;
{
  return otter_show_history_aux(CAR(CDR(CDR(CDR(CDR(CDR(CAR(x))))))),pos);
}

SCM otter_show_history_aux_fn477(x)
SCM x;
{
  return CAR(CDR(CDR(CDR(CDR(CAR(x))))));
}

SCM otter_show_history_aux_fn476(res,x)
SCM *res;
SCM x;
{
  *res=cons(show_history_clnr(x),*res);
  if(PAIR_P(x)&&((literal_symb==CAR(x))&&!(MAKINUM(1)==CAR(CDR(CDR(x)))))) {
    *res=cons(cons(CAR(CDR(CDR(x))),EOL),*res);
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM sort_by_firstel(lst)
SCM lst;
{
  SCM res,part;

  res=EOL;
  for(part=lst;!(NULL_P(part));part=CDR(part))
    if(NULL_P(res)) {
      res=cons(CAR(part),EOL);
    }
    else
    if(CAR(CAR(part))<CAR(CAR(res))) {
      res=cons(CAR(part),res);
    }
    else
      insert_to_firstel_sorted_excl_(CAR(part),res);
  return res;
}

SCM insert_to_firstel_sorted_excl_(el,lst)
SCM el,lst;
{
tailrecursion:
  if(NULL_P(CDR(lst))||(CAR(el)<CAR(CAR(CDR(lst))))) {
    SET_CDR(lst,cons(el,CDR(lst)));
    return UNSPECIFIED;
  }
  else {
    lst=CDR(lst);
    goto tailrecursion;
  }
}

SCM otter_show_history_aux_aux(dernr,history,elements)
SCM dernr,history,elements;
{
  SCM tmp,res,clausepl,old_flag;

  tmp=EOL;
  res=EOL;
  clausepl=EOL;
  old_flag=BOOL_F;
  clausepl=show_history_find_clausepl(dernr);
  if(NFALSEP(clausepl)) {
    GLOBAL(shown_clausenrs_global)=cons(dernr,GLOBAL(shown_clausenrs_global));
    if(!(PAIR_P(CAR(clausepl)))) {
      res=BOOL_F;
    }
    else {
      res=CAR(clausepl);
    }
  }
  if(!(NFALSEP(old_flag)))
    for_each1_inst6(&clausepl,&tmp,otter_show_history_aux_aux_fn480,elements);
  return res;
}

SCM otter_show_history_aux_aux_fn480(clausepl,tmp,x)
SCM *clausepl,*tmp;
SCM x;
{
  *tmp=show_history_clnr(x);
  if(!(NFALSEP(member(*tmp,GLOBAL(shown_clausenrs_global))))) {
    *clausepl=show_history_find_clausepl(*tmp);
    if(NFALSEP(*clausepl))
      return otter_show_history_aux(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(*clausepl)))))))),BOOL_T);
    else
      return otter_show_history_aux(x,BOOL_T);
  }
  else
    return UNSPECIFIED;
}

SCM show_history_aux(history,pos)
SCM history,pos;
{
  SCM tmp,clause,clausepl,premissnrs,dernr,constr,tmp_var1,tmp_var2;

tailrecursion:
  constr=CAR(history);
  dernr=CAR(CDR(history));
  premissnrs=EOL;
  clausepl=EOL;
  clause=EOL;
  tmp=EOL;
  if(hyper_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_390,cur_output_port());
    display(constr,cur_output_port());
    display(const_391,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(history)))),cur_output_port());
    display(const_392,cur_output_port());
    for_each1(show_history_aux_fn482,CDR(CDR(CDR(history))));
    return show_history_aux_aux(dernr,history,CDR(CDR(history)));
  }
  else
  if(binres_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_393,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(history)))),cur_output_port());
    if(CAR(CDR(CDR(CAR(CDR(CDR(history))))))>MAKINUM(1)) {
      display(MAKICHR('('),cur_output_port());
      display(CAR(CDR(CDR(CAR(CDR(CDR(history)))))),cur_output_port());
      display(MAKICHR(')'),cur_output_port());
    }
    display(const_394,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(CDR(history))))),cur_output_port());
    if(CAR(CDR(CDR(CAR(CDR(CDR(CDR(history)))))))>MAKINUM(1)) {
      display(MAKICHR('('),cur_output_port());
      display(CAR(CDR(CDR(CAR(CDR(CDR(CDR(history))))))),cur_output_port());
      display(MAKICHR(')'),cur_output_port());
    }
    return show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),cons(CAR(CDR(CDR(CDR(history)))),EOL)));
  }
  else
  if(para_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_395,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(history)))),cur_output_port());
    display(const_396,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(CDR(history))))),cur_output_port());
    display(const_397,cur_output_port());
    display(CDR(CDR(CDR(CDR(history)))),cur_output_port());
    return show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),cons(CAR(CDR(CDR(CDR(history)))),EOL)));
  }
  else
  if(factor_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_398,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(history)))),cur_output_port());
    display(const_399,cur_output_port());
    display(MAKINUM(1+INUM(CAR(CDR(CDR(CDR(history)))))),cur_output_port());
    display(MAKICHR(' '),cur_output_port());
    display(MAKINUM(1+INUM(CAR(CDR(CDR(CDR(CDR(history))))))),cur_output_port());
    return show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),EOL));
  }
  else
  if(binres_demod_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_400,cur_output_port());
    display(show_history_clnr(CAR(CDR(CDR(history)))),cur_output_port());
    return show_history_aux_aux(dernr,history,cons(CAR(CDR(CDR(history))),EOL));
  }
  else
  if(input_symb==constr) {
    newline(cur_output_port());
    display_spaces(pos);
    display(const_401,cur_output_port());
    newline(cur_output_port());
    clausepl=show_history_find_clausepl(dernr);
    display(dernr,cur_output_port());
    display(const_402,cur_output_port());
    if(NFALSEP(clausepl)) {
      if(NFALSEP(GLOBAL(int_logic_flag_global)))
        apply(GLOBAL(print_full_int_clause),CAR(clausepl),listofnull);
      else
        print_full_clause(CAR(clausepl));
      GLOBAL(shown_clausenrs_global)=cons(dernr,GLOBAL(shown_clausenrs_global));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
  else
  if(literal_symb==constr) {
    tmp_var1=CAR(CDR(history));
    tmp_var2=MAKINUM(0);
    history=tmp_var1;
    pos=tmp_var2;
    goto tailrecursion;
  }
  else {
    newline(cur_output_port());
    display_spaces(pos);
    return report_error(const_403,cons(constr,EOL));
  }
}

SCM show_history_aux_fn482(x)
SCM x;
{
  display(show_history_clnr(x),cur_output_port());
  if(PAIR_P(x)&&((literal_symb==CAR(x))&&!(MAKINUM(1)==CAR(CDR(CDR(x)))))) {
    display(MAKICHR('('),cur_output_port());
    display(CAR(CDR(CDR(x))),cur_output_port());
    display(MAKICHR(')'),cur_output_port());
  }
  return display(MAKICHR(' '),cur_output_port());
}

SCM show_history_aux_aux(dernr,history,elements)
SCM dernr,history,elements;
{
  SCM tmp,clausepl;

  tmp=EOL;
  clausepl=EOL;
  display(const_404,cur_output_port());
  newline(cur_output_port());
  display(dernr,cur_output_port());
  display(const_405,cur_output_port());
  clausepl=show_history_find_clausepl(dernr);
  if(NFALSEP(clausepl)) {
    if(NFALSEP(GLOBAL(int_logic_flag_global)))
      apply(GLOBAL(print_full_int_clause),CAR(clausepl),listofnull);
    else
      print_full_clause(CAR(clausepl));
    GLOBAL(shown_clausenrs_global)=cons(dernr,GLOBAL(shown_clausenrs_global));
  }
  return for_each1_inst6(&clausepl,&tmp,show_history_aux_aux_fn484,elements);
}

SCM show_history_aux_aux_fn484(clausepl,tmp,x)
SCM *clausepl,*tmp;
SCM x;
{
  *tmp=show_history_clnr(x);
  if(!(NFALSEP(member(*tmp,GLOBAL(shown_clausenrs_global))))) {
    *clausepl=show_history_find_clausepl(*tmp);
    if(NFALSEP(*clausepl))
      return show_history_aux(CAR(CDR(CDR(CDR(CDR(CDR(CAR(CAR(*clausepl)))))))),MAKINUM(0));
    else
      return show_history_aux(x,MAKINUM(0));
  }
  else
    return UNSPECIFIED;
}

SCM show_history_find_clausepl(dernr)
SCM dernr;
{
  SCM clausepl;

  if(!(NUMBER_P(dernr))||ZERO_P(dernr))
    return BOOL_F;
  else {
    clausepl=BOOL_F;
    if(!(NFALSEP(clausepl))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn499,GLOBAL(sos_clauses_list_global));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(usable_clauses_list_global)))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn500,CDR(GLOBAL(usable_clauses_list_global)));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(unit_alist_global)))) {
      clausepl=some_pred__inst2(dernr,show_history_find_clausepl_fn501,GLOBAL(unit_alist_global));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(unit_alist_list_global)))) {
      clausepl=some_pred__inst2(dernr,show_history_find_clausepl_fn503,GLOBAL(unit_alist_list_global));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(sos_clauses_list_list_global)))) {
      clausepl=some_pred__inst2(dernr,show_history_find_clausepl_fn506,GLOBAL(sos_clauses_list_list_global));
    }
    if(!(NFALSEP(clausepl))&&!(NULL_P(GLOBAL(usable_clauses_list_list_global)))) {
      clausepl=some_pred__inst2(dernr,show_history_find_clausepl_fn508,GLOBAL(usable_clauses_list_list_global));
    }
    if(NFALSEP(GLOBAL(int_logic_flag_global))&&!(NFALSEP(clausepl))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn510,GLOBAL(mult_rule_clauses_list_global));
    }
    if(NFALSEP(GLOBAL(int_logic_flag_global))&&!(NFALSEP(clausepl))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn511,GLOBAL(single_rule_clauses_list_global));
    }
    if(NFALSEP(GLOBAL(int_logic_flag_global))&&!(NFALSEP(clausepl))) {
      clausepl=member_if_inst1(dernr,show_history_find_clausepl_fn512,GLOBAL(single_reduction_rule_clauses_list_global));
    }
    return clausepl;
  }
}

SCM show_history_find_clausepl_fn512(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn511(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn510(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn508(dernr,x)
SCM dernr,x;
{
  return member_if_inst1(dernr,show_history_find_clausepl_fn509,x);
}

SCM show_history_find_clausepl_fn509(dernr,y)
SCM dernr,y;
{
  if(PAIR_P(y))
    return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(y)))))));
  else
    return BOOL_F;
}

SCM show_history_find_clausepl_fn506(dernr,x)
SCM dernr,x;
{
  return member_if_inst1(dernr,show_history_find_clausepl_fn507,x);
}

SCM show_history_find_clausepl_fn507(dernr,y)
SCM dernr,y;
{
  if(PAIR_P(y))
    return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(y)))))));
  else
    return BOOL_F;
}

SCM show_history_find_clausepl_fn503(dernr,x)
SCM dernr,x;
{
  return some_pred__inst2(dernr,show_history_find_clausepl_fn504,x);
}

SCM show_history_find_clausepl_fn504(dernr,y)
SCM dernr,y;
{
  return member_if_inst1(dernr,show_history_find_clausepl_fn505,CDR(y));
}

SCM show_history_find_clausepl_fn505(dernr,x__1)
SCM dernr,x__1;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x__1)))))));
}

SCM show_history_find_clausepl_fn501(dernr,y)
SCM dernr,y;
{
  return member_if_inst1(dernr,show_history_find_clausepl_fn502,CDR(y));
}

SCM show_history_find_clausepl_fn502(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn500(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_find_clausepl_fn499(dernr,x)
SCM dernr,x;
{
  return SBOOL(dernr==CAR(CDR(CDR(CDR(CDR(CAR(x)))))));
}

SCM show_history_clnr(premiss)
SCM premiss;
{
  if(!(PAIR_P(premiss)))
    return _pred__symb;
  else
  if(CAR(premiss)==literal_symb)
    return CAR(CDR(CAR(CDR(premiss))));
  else
  if(CAR(premiss)==input_symb)
    return CAR(CDR(premiss));
  else
  if(CAR(premiss)==hyper_symb)
    return CAR(CDR(premiss));
  else
  if(CAR(premiss)==binres_symb)
    return CAR(CDR(premiss));
  else
  if(CAR(premiss)==factor_symb)
    return CAR(CDR(premiss));
  else
  if(CAR(premiss)==binres_demod_symb)
    return CAR(CDR(premiss));
  else
  if(CAR(premiss)==para_symb)
    return CAR(CDR(premiss));
  else
    return _pred__pred__symb;
}

SCM display_spaces(nr)
SCM nr;
{
  SCM i;

  for(i=MAKINUM(0);!(i>=nr);i=MAKINUM(1+INUM(i)))
    display(MAKICHR(' '),cur_output_port());
  return UNSPECIFIED;
}

SCM history__grtr_answer(history)
SCM history;
{
  SCM res;

  clear_x_vars_and_touched_excl_(MAKINUM(255));
  clear_y_vars_and_touched_excl_(MAKINUM(255));
  clear_z_vars_and_touched_excl_(MAKINUM(255));
  res=history__grtr_answer_step(history);
  clear_x_vars_and_touched_excl_(MAKINUM(255));
  clear_y_vars_and_touched_excl_(MAKINUM(255));
  clear_z_vars_and_touched_excl_(MAKINUM(255));
  return make_readable_cl(CDR(res));
}

SCM history__grtr_answer_step(history)
SCM history;
{
  SCM litnr,argspart,ans_cl,orig_cl,dernr,constr,ans_nucleon,litlst,res,tmp,arg,fromcl,tocl,fromlitnr,tolitnr,left_used_flag,path,frompurecl,res__1;

  constr=CAR(history);
  dernr=CAR(CDR(history));
  orig_cl=EOL;
  ans_cl=EOL;
  if(input_symb==constr) {
    ans_cl=input_ans_clause(dernr);
    return ans_cl;
  }
  else
  if(hyper_symb==constr) {
    ans_nucleon=history__grtr_answer_step(CAR(CDR(CDR(history))));
    litlst=CAR(CDR(CDR(CAR(ans_nucleon))));
    res=ans_nucleon;
    tmp=EOL;
    arg=EOL;
    for(argspart=CDR(CDR(CDR(history))),litnr=MAKINUM(1);
        !(NULL_P(argspart));
        argspart=CDR(argspart),litnr=MAKINUM(1+INUM(litnr))) {
      res=cons(CAR(res),map1(rename_x_to_y_term,CDR(res)));
      arg=history__grtr_answer_step(CAR(CDR(CAR(argspart))));
      res=history__grtr_answer_binstep(CDR(arg),CDR(res),CAR(arg),CAR(res),CAR(CDR(CDR(CAR(argspart)))),litnr,history,BOOL_T,EOL);
    }
    return res;
  }
  else
  if(para_symb==constr) {
    fromcl=history__grtr_answer_step(CAR(CDR(CDR(history))));
    tocl=history__grtr_answer_step(CAR(CDR(CDR(CDR(history)))));
    fromlitnr=CAR(CDR(CDR(CDR(CDR(history)))));
    tolitnr=CAR(CDR(CDR(CDR(CDR(CDR(history))))));
    left_used_flag=CAR(CDR(CDR(CDR(CDR(CDR(CDR(history)))))));
    path=CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(history))))))));
    frompurecl=map1(rename_x_to_y_term,CDR(fromcl));
    res__1=EOL;
    res__1=history__grtr_answer_binstep(CDR(tocl),frompurecl,CAR(tocl),CAR(fromcl),tolitnr,fromlitnr,history,left_used_flag,path);
    return res__1;
  }
  else
    return UNSPECIFIED;
}

SCM input_ans_clause(dernr)
SCM dernr;
{
  SCM place;

  place=member_if_inst1(dernr,input_ans_clause_fn514,GLOBAL(ans_input_sos_global));
  if(!(NFALSEP(place)))
    return report_error(const_406,cons(dernr,EOL));
  else
    return CAR(place);
}

SCM input_ans_clause_fn514(dernr,x)
SCM dernr,x;
{
  return SBOOL(CAR(CDR(CDR(CDR(CDR(CAR(x))))))==dernr);
}

SCM history__grtr_answer_binstep(xcl,ycl,xinf,yinf,xlitnr,ylitnr,derhistory,left_used_flag,path)
SCM xcl,ycl,xinf,yinf,xlitnr,ylitnr,derhistory,left_used_flag,path;
{
  SCM compl_yfunpure,ylitcurinf,xfun,xlit,yfun,ylit,litnr,lylitinfpart,lypart,xlitinf,ylitinf,yclmaxvar,ypart,ylitinfpart,xpart,xlitinfpart,subterm,tmpres,lxpart,lxlitinfpart,litnr__1,ytmp,xtmp,res;

  xlitinf=CAR(CDR(CDR(xinf)));
  ylitinf=CAR(CDR(CDR(yinf)));
  yclmaxvar=give_cl_maxvar(yinf);
  ypart=EOL;
  ylitinfpart=EOL;
  xpart=EOL;
  xlitinfpart=EOL;
  subterm=EOL;
  tmpres=EOL;
  for(lypart=ycl,lylitinfpart=ylitinf,litnr=MAKINUM(1);
      !(NFALSEP(((hyper_symb==CAR(derhistory)) ? SBOOL(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(CAR(lylitinfpart)))>>16)==ylitnr) : SBOOL((litnr==ylitnr)&&!(NFALSEP(answer_lit_pred_(CAR(lypart))))))));
      lypart=CDR(lypart),lylitinfpart=CDR(lylitinfpart),litnr=MAKINUM(1+INUM(litnr)))
    if(NFALSEP(answer_lit_pred_(CAR(lypart)))) {
      litnr=MAKINUM(INUM(litnr)-1);
    }
  ypart=lypart;
  ylitinfpart=lylitinfpart;
  for(lxpart=xcl,lxlitinfpart=xlitinf,litnr__1=MAKINUM(1);
      !((litnr__1==xlitnr)&&!(NFALSEP(answer_lit_pred_(CAR(lxpart)))));
      lxpart=CDR(lxpart),lxlitinfpart=CDR(lxlitinfpart),litnr__1=MAKINUM(1+INUM(litnr__1)))
    if(NFALSEP(answer_lit_pred_(CAR(lxpart)))) {
      litnr__1=MAKINUM(INUM(litnr__1)-1);
    }
  xpart=lxpart;
  xlitinfpart=lxlitinfpart;
  ylit=CAR(ypart);
  yfun=CAR(ylit);
  xlit=CAR(xpart);
  xfun=CAR(xlit);
  ylitcurinf=CAR(ylitinfpart);
  compl_yfunpure=MAKINUM(268435456^INUM(MAKINUM(534773760)&yfun));
  if(para_symb==CAR(derhistory)) {
    GLOBAL(param_tolit_global)=xlit;
    GLOBAL(param_eqlit_global)=ylit;
    GLOBAL(param_tocl_global)=xcl;
    GLOBAL(param_fromcl_global)=ycl;
    GLOBAL(param_fromfullinf_global)=yinf;
    GLOBAL(param_tofullinf_global)=xinf;
    GLOBAL(param_left_arg_global)=CAR(CDR(CAR(CDR(ylit))));
    GLOBAL(param_right_arg_global)=CAR(CDR(CDR(CAR(CDR(ylit)))));
    GLOBAL(param_toinf_global)=xlitinf;
    GLOBAL(param_frominf_global)=ylitinf;
    GLOBAL(param_from_is_y_flag_global)=BOOL_T;
    GLOBAL(param_yclmaxvar_global)=yclmaxvar;
    GLOBAL(param_xclmaxvar_global)=give_cl_maxvar(xinf);
    GLOBAL(param_fromhist_global)=EOL;
    GLOBAL(param_tohist_global)=EOL;
    GLOBAL(param_fromlitnr_global)=ylitnr;
    GLOBAL(param_tolitnr_global)=xlitnr;
    param_use_left_flag_global=left_used_flag;
    if(!(NFALSEP(param_use_left_flag_global))) {
      GLOBAL(param_left_arg_global)=CAR(CDR(CDR(CAR(CDR(ylit)))));
      GLOBAL(param_right_arg_global)=CAR(CDR(CAR(CDR(ylit))));
    }
    subterm=subterm_at_path(GLOBAL(param_tolit_global),path);
    if(!(NUMBER_P(GLOBAL(param_left_arg_global)))) {
      GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_T;
      if(!((MAKINUM(534773760)&CAR(subterm))==(MAKINUM(534773760)&CAR(GLOBAL(param_left_arg_global))))||!(NFALSEP(resolve_unify_ordinary(CAR(subterm),CAR(GLOBAL(param_left_arg_global)),subterm,GLOBAL(param_left_arg_global)))))
        report_error(const_407,cons(cons(subterm,cons(GLOBAL(param_left_arg_global),EOL)),EOL));
      GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
    }
    else
    if(MAKINUM(65535)>GLOBAL(param_left_arg_global)) {
      STBL_VECTOR_SET(_star_var_val_table_star__velts0,MAKINUM(8191)&GLOBAL(param_left_arg_global),subterm);
      xvars_set_flag_global=BOOL_F;
      yvars_set_flag_global=BOOL_T;
    }
    else
    if(!(GLOBAL(param_left_arg_global)==subterm))
      report_error(const_408,cons(cons(subterm,cons(GLOBAL(param_left_arg_global),EOL)),EOL));
    else {
      xvars_set_flag_global=BOOL_F;
      yvars_set_flag_global=BOOL_F;
    }
    tmpres=paramodulate_into_term_aux_typet(path,GLOBAL(param_right_arg_global),left_used_flag);
    return tmpres;
  }
  else
  if(hyper_symb==CAR(derhistory)) {
    GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_T;
    if(!((compl_yfunpure==(MAKINUM(534773760)&xfun))&&NFALSEP(resolve_unify_ordinary(xfun,yfun,xlit,ylit))))
      report_error(const_409,cons(cons(xlit,cons(ylit,EOL)),EOL));
    GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
    ytmp=make_rest_inf_cl(ycl,ylit,CAR(CDR(CDR(yinf))));
    xtmp=make_rest_inf_cl(xcl,xlit,CAR(CDR(CDR(xinf))));
    res=make_raw_inf_cl_pair_typet_hyper(CAR(ylitinfpart),BOOL_T,CDR(xtmp),CDR(ytmp),CAR(xtmp),CAR(ytmp));
    clear_y_vars_and_touched_excl_(yclmaxvar);
    clear_x_vars_and_touched_excl_(give_cl_maxvar(xinf));
    res=history__grtr_ans_handle_derived_inf_cl_pair(res,cons(dummy_symb,cons(MAKINUM(0),EOL)),BOOL_F);
    return res;
  }
  else
    return UNSPECIFIED;
}

SCM history__grtr_ans_handle_derived_inf_cl_pair(pr,history,fac_gen_flag)
SCM pr,history,fac_gen_flag;
{
  SCM cl,inf,clauseinf,tmp_pr,kept_cl,litinfolst;

  cl=CDR(pr);
  inf=CAR(pr);
  clauseinf=EOL;
  tmp_pr=EOL;
  kept_cl=EOL;
  litinfolst=EOL;
  tmp_pr=remove_double_lits_excl_(inf,cl,GLOBAL(hyper_strategy_flag_global));
  tmp_pr=sort_clause(history__grtr_ans_handle_derived_inf_cl_pair_aux776(tmp_pr),BOOL_T);
  tmp_pr=cons(map1(history__grtr_ans_handle_derived_inf_cl_pair_fn518,tmp_pr),map1(history__grtr_ans_handle_derived_inf_cl_pair_fn519,tmp_pr));
  clauseinf=make_clause_info(CDR(tmp_pr),history,BOOL_F);
  kept_cl=make_kept_clause(clauseinf,tmp_pr);
  litinfolst=map1(history__grtr_ans_handle_derived_inf_cl_pair_fn520,CAR(tmp_pr));
  SET_CAR(CDR(CDR(CAR(kept_cl))),litinfolst);
  return kept_cl;
}

SCM history__grtr_ans_handle_derived_inf_cl_pair_aux776(tmp_pr)
SCM tmp_pr;
{
  SCM new_var4,new_var5,new_var1,new_var2,new_var3;

  for(new_var4=CAR(tmp_pr),new_var5=CDR(tmp_pr),new_var1=EOL,new_var2=EOL,new_var3=EOL;
      PAIR_P(new_var4)&&PAIR_P(new_var5);
      new_var4=CDR(new_var4),new_var5=CDR(new_var5)) {
    new_var3=cons(CAR(new_var4),CAR(new_var5));
    if(NULL_P(new_var1)) {
      new_var1=cons(new_var3,EOL);
      new_var2=new_var1;
    }
    else {
      SET_CDR(new_var2,cons(new_var3,EOL));
      new_var2=CDR(new_var2);
    }
  }
  return new_var1;
}

SCM history__grtr_ans_handle_derived_inf_cl_pair_fn520(x)
SCM x;
{
  return CDR(CDR(x));
}

SCM history__grtr_ans_handle_derived_inf_cl_pair_fn519(x)
SCM x;
{
  return CDR(x);
}

SCM history__grtr_ans_handle_derived_inf_cl_pair_fn518(x)
SCM x;
{
  return CAR(x);
}

SCM make_raw_inf_cl_pair_typet_hyper(litinfel,nuc_is_y_flag,xcl,ycl,xinf,yinf)
SCM litinfel,nuc_is_y_flag,xcl,ycl,xinf,yinf;
{
  SCM new_xrest,new_yrest,nuc_ans_lit,elec_ans_lit,new_nuc_ans_lit;

  new_yrest=subst_deco_cl(ycl,yinf,MAKINUM(2),yvars_set_flag_global);
  GLOBAL(used_demodulators_global)=EOL;
  if(NFALSEP(new_yrest)) {
    new_xrest=subst_deco_cl(xcl,xinf,MAKINUM(1),xvars_set_flag_global);
    GLOBAL(used_demodulators_global)=EOL;
    if(NFALSEP(new_xrest)) {
      nuc_ans_lit=member_ans_lit((NFALSEP(nuc_is_y_flag) ? CDR(new_yrest) : CDR(new_xrest)));
      elec_ans_lit=member_ans_lit((NFALSEP(nuc_is_y_flag) ? CDR(new_xrest) : CDR(new_yrest)));
      new_nuc_ans_lit=EOL;
      if(NFALSEP(nuc_ans_lit)&&NFALSEP(elec_ans_lit)) {
        new_nuc_ans_lit=replace_subterm(CAR(nuc_ans_lit),cons(MAKINUM(1),cons(MAKINUM(INUM(GLOBAL(litinf_ordernr_mask_global)&CAR(litinfel))>>16),EOL)),CAR(CDR(CAR(elec_ans_lit))));
        if(NFALSEP(nuc_is_y_flag)) {
          new_yrest=cons(CAR(new_yrest),replace_one_eq(CAR(nuc_ans_lit),new_nuc_ans_lit,CDR(new_yrest)));
          new_xrest=make_rest_inf_cl(CDR(new_xrest),CAR(elec_ans_lit),CAR(new_xrest));
        }
        else {
          new_xrest=cons(CAR(new_xrest),replace_one_eq(CAR(nuc_ans_lit),new_nuc_ans_lit,CDR(new_xrest)));
          new_yrest=make_rest_inf_cl(CDR(new_yrest),CAR(elec_ans_lit),CAR(new_yrest));
        }
      }
      return cons(my_append_excl_(CAR(new_yrest),CAR(new_xrest)),my_append_excl_(CDR(new_yrest),CDR(new_xrest)));
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM paramodulate_into_term_aux_typet(path,replterm,left_used_flag)
SCM path,replterm,left_used_flag;
{
  SCM newtype,lambdalit,lambdabody,newleft,newright,newlit,tmpto1,tmpfrom1,to_ans_lit_lst,from_ans_lit_lst,to_ans_lit,from_ans_lit,tmpto,tmpfrom,res1,res,subst_applic,new_ans_lit;

  GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
  newtype=subst_deco_term(CAR(CDR(CDR(CDR(CAR(CDR(GLOBAL(param_eqlit_global))))))),BOOL_F);
  lambdalit=subst_deco_replace_term(GLOBAL(param_tolit_global),path,GLOBAL(lambda_dummypar_nr_global),BOOL_T);
  lambdabody=map1(paramodulate_into_term_aux_typet_fn522,remove_ans_literals(replace_one_eq(GLOBAL(param_tolit_global),lambdalit,GLOBAL(param_tocl_global))));
  newleft=subst_deco_term(GLOBAL(param_left_arg_global),BOOL_F);
  newright=subst_deco_term(GLOBAL(param_right_arg_global),BOOL_F);
  newlit=subst_deco_replace_term(GLOBAL(param_tolit_global),path,replterm,BOOL_T);
  tmpto1=make_rest_inf_cl(GLOBAL(param_tocl_global),GLOBAL(param_tolit_global),GLOBAL(param_toinf_global));
  tmpfrom1=make_rest_inf_cl(GLOBAL(param_fromcl_global),GLOBAL(param_eqlit_global),GLOBAL(param_frominf_global));
  to_ans_lit_lst=member_ans_lit(CDR(tmpto1));
  from_ans_lit_lst=member_ans_lit(CDR(tmpfrom1));
  if(NFALSEP(to_ans_lit_lst))
    to_ans_lit=subst_deco_term(CAR(to_ans_lit_lst),BOOL_T);
  else
    to_ans_lit=BOOL_F;
  if(NFALSEP(from_ans_lit_lst))
    from_ans_lit=subst_deco_term(CAR(from_ans_lit_lst),BOOL_T);
  else
    from_ans_lit=BOOL_F;
  if(NFALSEP(to_ans_lit_lst))
    tmpto=make_rest_inf_cl(CDR(tmpto1),CAR(to_ans_lit_lst),CAR(tmpto1));
  else
    tmpto=tmpto1;
  if(NFALSEP(from_ans_lit_lst))
    tmpfrom=make_rest_inf_cl(CDR(tmpfrom1),CAR(from_ans_lit_lst),CAR(tmpfrom1));
  else
    tmpfrom=tmpfrom1;
  res1=make_raw_inf_cl_pair(CDR(tmpto1),CDR(tmpfrom1),CAR(tmpto1),CAR(tmpfrom1));
  res=make_raw_inf_cl_pair(CDR(tmpto),CDR(tmpfrom),CAR(tmpto),CAR(tmpfrom));
  subst_applic=EOL;
  new_ans_lit=EOL;
  clear_y_vars_and_touched_excl_(GLOBAL(param_yclmaxvar_global));
  clear_x_vars_and_touched_excl_(GLOBAL(param_xclmaxvar_global));
  if(!(NFALSEP(to_ans_lit)&&NFALSEP(from_ans_lit))) {
    res=cons(cons(cons(BOOL_T,cons(BOOL_F,cons(MAKINUM(0),EOL))),CAR(res1)),cons(newlit,CDR(res1)));
  }
  else {
    subst_applic=deco_leading_fun(cons(GLOBAL(ans_pred_nr_global),cons(deco_leading_fun(cons((NFALSEP(param_use_left_flag_global) ? GLOBAL(subst_fun_nr_global) : GLOBAL(subst_prim_fun_nr_global)),cons(newtype,cons(deco_leading_fun(cons(GLOBAL(lambda_fun_nr_global),cons(GLOBAL(lambda_dummypar_nr_global),lambdabody))),cons(newleft,cons(newright,cons(CAR(CDR(to_ans_lit)),cons(CAR(CDR(from_ans_lit)),EOL)))))))),EOL)));
    res=cons(cons(cons(BOOL_T,cons(BOOL_T,cons(MAKINUM(0),EOL))),CAR(res)),cons(newlit,CDR(res)));
    res=cons(cons(cons(BOOL_T,cons(BOOL_T,cons(GLOBAL(answer_litinf_global),EOL))),CAR(res)),cons(subst_applic,CDR(res)));
  }
  res=history__grtr_ans_handle_derived_inf_cl_pair(res,cons(dummy_symb,cons(MAKINUM(0),EOL)),BOOL_F);
  return res;
}

SCM paramodulate_into_term_aux_typet_fn522(x)
SCM x;
{
  if(x==GLOBAL(param_tolit_global))
    return CAR(CDR(x));
  else
    return CAR(CDR(subst_deco_term(x,BOOL_T)));
}

SCM hyper_contradiction_pred_(fullcl)
SCM fullcl;
{
  SCM one_step_results,ylitinf,yinf,ycl,results_part;

  if(!(NFALSEP(GLOBAL(foundflag_global)))&&(!(NFALSEP(empty_cl_pred_(CDR(fullcl))))&&(!(NFALSEP(unit_cl_pred_(CDR(fullcl))))&&NFALSEP(every_pred_(hyper_contradiction_pred__fn524,CDR(fullcl)))))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
      newline(cur_output_port());
      display(const_410,cur_output_port());
      print_full_clause(fullcl);
      newline(cur_output_port());
    }
    GLOBAL(unit_clash_flag_global)=BOOL_T;
    ycl=map1(rename_x_to_y_term,CDR(fullcl));
    yinf=CAR(fullcl);
    ylitinf=CAR(CDR(CDR(yinf)));
    one_step_results=one_step_for_hyper(cons(yinf,ycl));
    for(results_part=one_step_results;!(NULL_P(results_part)||(NFALSEP(GLOBAL(foundflag_global))||(NFALSEP(GLOBAL(stop_fast_loop_flag_global))||NFALSEP(((!(NFALSEP(GLOBAL(stop_fast_loop_flag_global)))&&((INUM(get_check_time(MAKINUM(63)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))) ? (store_time_checkpoint_excl_(MAKINUM(63)),GLOBAL(stop_fast_loop_flag_global)=BOOL_T,UNSPECIFIED,BOOL_T) : UNSPECIFIED)))));results_part=CDR(results_part))
      hyper_contradiction_pred_(CAR(results_part));
    GLOBAL(unit_clash_flag_global)=BOOL_F;
    return GLOBAL(foundflag_global);
  }
  else
    return BOOL_F;
}

SCM hyper_contradiction_pred__fn524(lit)
SCM lit;
{
  return SBOOL(ZERO_P(MAKINUM(65536)&CAR(lit)));
}

SCM full_hyper_contradiction_pred_(fullcl)
SCM fullcl;
{
  SCM one_step_results,ylitinf,yinf,ycl,results_part;

  if(!(NFALSEP(GLOBAL(foundflag_global)))&&(!(NFALSEP(empty_cl_pred_(CDR(fullcl))))&&!(NFALSEP(unit_cl_pred_(CDR(fullcl)))))) {
    if(GLOBAL(display_info_level_global)>=MAKINUM(70)) {
      newline(cur_output_port());
      display(const_411,cur_output_port());
      print_full_clause(fullcl);
      newline(cur_output_port());
    }
    GLOBAL(unit_clash_flag_global)=BOOL_T;
    ycl=map1(rename_x_to_y_term,CDR(fullcl));
    yinf=CAR(fullcl);
    ylitinf=CAR(CDR(CDR(yinf)));
    one_step_results=one_step_for_hyper(cons(yinf,ycl));
    for(results_part=one_step_results;!(NULL_P(results_part)||(NFALSEP(GLOBAL(foundflag_global))||(NFALSEP(GLOBAL(stop_fast_loop_flag_global))||NFALSEP(((!(NFALSEP(GLOBAL(stop_fast_loop_flag_global)))&&((INUM(get_check_time(MAKINUM(62)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))) ? (store_time_checkpoint_excl_(MAKINUM(62)),GLOBAL(stop_fast_loop_flag_global)=BOOL_T,UNSPECIFIED,BOOL_T) : UNSPECIFIED)))));results_part=CDR(results_part))
      hyper_contradiction_pred_(CAR(results_part));
    GLOBAL(unit_clash_flag_global)=BOOL_F;
    return GLOBAL(foundflag_global);
  }
  else
    return BOOL_F;
}

SCM start_binary_hypercheck_strategy()
{
  SCM part,part__1;

  for(part=GLOBAL(usable_clauses_list_global);!(NULL_P(part)||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));part=CDR(part))
    if(PAIR_P(CAR(part))&&!(NFALSEP(unit_cl_pred_(CAR(part)))))
      full_hyper_contradiction_pred_(CAR(part));
  for(part__1=GLOBAL(sos_clauses_list_global);!(NULL_P(part__1)||(NFALSEP(GLOBAL(foundflag_global))||NFALSEP(GLOBAL(stop_fast_loop_flag_global))));part__1=CDR(part__1))
    if(PAIR_P(CAR(part__1))&&!(NFALSEP(unit_cl_pred_(CAR(part__1)))))
      full_hyper_contradiction_pred_(CAR(part__1));
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM start_backward_hyper_analysis()
{
  SCM part__1,part,newsos,newusable,cl,new_var1,new_var2;

  newsos=EOL;
  newusable=EOL;
  cl=EOL;
  init_binres_strat();
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_T;
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_T;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(order_strategy_flag_global)=BOOL_F;
  GLOBAL(poslitpref_order_strategy_flag_global)=BOOL_T;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(sos_preference_cur_ratio_global)=MAKINUM(2);
  GLOBAL(nonunit_discr_tree_global)=cons(EOL,EOL);
  for(part=GLOBAL(usable_clauses_list_global);!(NFALSEP(GLOBAL(foundflag_global))||NULL_P(part));part=CDR(part)) {
    cl=CAR(part);
    if(PAIR_P(cl))
      make_poslit_preferred_excl_(cl);
    new_var1=NOT(SBOOL(PAIR_P(cl)));
    if(NFALSEP(new_var1)) ;
    else
    if(NFALSEP(negative_cl_pred_(CDR(cl)))) {
      hyper_contradiction_pred_(cl);
      newsos=cons(cl,newsos);
    }
    else {
      newusable=cons(cl,newusable);
    }
  }
  GLOBAL(usable_clauses_list_global)=newusable;
  for(part__1=GLOBAL(sos_clauses_list_global);!(NFALSEP(GLOBAL(foundflag_global))||NULL_P(part__1));part__1=CDR(part__1)) {
    cl=CAR(part__1);
    if(PAIR_P(cl))
      make_poslit_preferred_excl_(cl);
    new_var2=NOT(SBOOL(PAIR_P(cl)));
    if(NFALSEP(new_var2)) ;
    else
    if(NFALSEP(negative_cl_pred_(CDR(cl)))) {
      hyper_contradiction_pred_(cl);
      newsos=cons(cl,newsos);
    }
    else {
      GLOBAL(usable_clauses_list_global)=cons(cl,GLOBAL(usable_clauses_list_global));
    }
  }
  GLOBAL(sos_clauses_list_global)=newsos;
  if(!(NFALSEP(GLOBAL(int_logic_flag_global)))) {
    GLOBAL(sos_clauses_list_end_global)=my_last_pair(GLOBAL(sos_clauses_list_global));
  }
  GLOBAL(usable_clauses_list_end_global)=my_last_pair(GLOBAL(usable_clauses_list_global));
  return UNSPECIFIED;
}

SCM make_all_resolvable_excl_(fullcl)
SCM fullcl;
{
  SCM x,tmp,lit_part;

  tmp=MAKINUM(0);
  x=MAKINUM(0);
  for(lit_part=CAR(CDR(CDR(CAR(fullcl))));!(NULL_P(lit_part));lit_part=CDR(lit_part)) {
    x=CAR(lit_part);
    if(ZERO_P(MAKINUM(4)&CAR(x))) {
      tmp=MAKINUM(INUM(litinf_nouse_mask_global)^INUM(litinf_nouse_mask_global|CAR(x)));
      SET_CAR(x,tmp);
    }
  }
  return UNSPECIFIED;
}

SCM make_poslit_preferred_excl_(fullcl)
SCM fullcl;
{
  SCM info_part,lit_part;

  if(!(NFALSEP(mixed_cl_pred_(CDR(fullcl)))))
    return make_all_resolvable_excl_(fullcl);
  else {
    for(info_part=CAR(CDR(CDR(CAR(fullcl)))),lit_part=CDR(fullcl);
        !(NULL_P(info_part));
        info_part=CDR(info_part),lit_part=CDR(lit_part))
      if(ZERO_P(MAKINUM(4)&CAR(CAR(info_part)))) {
        if(!(ZERO_P(MAKINUM(268435456)&CAR(CAR(lit_part))))) {
          SET_CAR(CAR(info_part),litinf_nouse_mask_global|CAR(CAR(info_part)));
        }
        else {
          SET_CAR(CAR(info_part),MAKINUM(INUM(litinf_nouse_mask_global)^INUM(litinf_nouse_mask_global|CAR(CAR(info_part)))));
        }
      }
    return UNSPECIFIED;
  }
}

SCM split_flat_clause_set(clauses)
SCM clauses;
{
  SCM res,tmp;

  res=EOL;
  tmp=EOL;
  for_each1_inst2(&res,split_flat_clause_set_fn526,clauses);
  return res;
}

SCM split_flat_clause_set_fn526(res,clause)
SCM *res;
SCM clause;
{
  if(NULL_P(CDR(CDR(clause)))) {
    *res=cons(clause,*res);
    return UNSPECIFIED;
  }
  else {
    *res=append2(split_flat_clause_set_aux(cons(clause,EOL)),*res);
    return UNSPECIFIED;
  }
}

SCM split_flat_clause_set_aux(clauses)
SCM clauses;
{
  SCM res,tmp;

tailrecursion:
  res=EOL;
  tmp=EOL;
  for_each1_inst2(&res,split_flat_clause_set_aux_fn528,clauses);
  if(length(res)<=length(clauses))
    return res;
  else {
    clauses=res;
    goto tailrecursion;
  }
}

SCM split_flat_clause_set_aux_fn528(res,clause)
SCM *res;
SCM clause;
{
  if(NULL_P(CDR(CDR(clause)))) {
    *res=cons(clause,*res);
    return UNSPECIFIED;
  }
  else {
    *res=append2(split_flat_clause(clause),*res);
    return UNSPECIFIED;
  }
}

SCM split_flat_clause(clause)
SCM clause;
{
  SCM gsplits,res,splitcomponents,gsplit,ngsplit,ngsplitcomponents,ngsplitvars,newclause,splitliteral,splittedclauses,gjoinclause,ngjoinclause,ngjoinclauses,joinclauses,origclause,ngsplits;

  res=EOL;
  splitcomponents=EOL;
  gsplit=EOL;
  ngsplit=EOL;
  ngsplitcomponents=EOL;
  ngsplitvars=EOL;
  newclause=EOL;
  splitliteral=EOL;
  splittedclauses=EOL;
  gjoinclause=EOL;
  ngjoinclause=EOL;
  ngjoinclauses=EOL;
  joinclauses=EOL;
  origclause=clause;
  splitcomponents=split_flat_clause_into_components(clause);
  for(gsplits=CDR(splitcomponents);!(NULL_P(gsplits));gsplits=CDR(gsplits)) {
    if(!(NULL_P(CDR(CDR(splitcomponents))))) {
      gjoinclause=cons(make_flat_split_literal(EOL),gjoinclause);
      ngjoinclause=cons(cons(MAKINUM(0-INUM(CAR(CAR(gjoinclause)))),CDR(CAR(gjoinclause))),EOL);
    }
    else {
      gjoinclause=EOL;
      ngjoinclause=EOL;
    }
    gsplit=CAR(gsplits);
    ngsplitcomponents=CDR(gsplit);
    ngsplitvars=CAR(gsplit);
    for(ngsplits=ngsplitcomponents;!(NULL_P(ngsplits));ngsplits=CDR(ngsplits))
      if(!(NULL_P(CDR(ngsplitcomponents)))) {
        ngsplit=CDR(CAR(ngsplits));
        splitliteral=make_flat_split_literal(ngsplitvars);
        newclause=cons(splitliteral,ngsplit);
        splittedclauses=cons(newclause,splittedclauses);
        ngjoinclause=cons(cons(MAKINUM(0-INUM(CAR(splitliteral))),CDR(splitliteral)),ngjoinclause);
      }
      else
      if(!(NULL_P(gjoinclause))) {
        ngsplit=CDR(CAR(ngsplits));
        ngjoinclause=EOL;
        splitliteral=cons(MAKINUM(0-INUM(CAR(CAR(gjoinclause)))),CDR(CAR(gjoinclause)));
        newclause=cons(splitliteral,ngsplit);
        splittedclauses=cons(newclause,splittedclauses);
      }
      else {
        ngsplit=CDR(CAR(ngsplits));
        ngjoinclause=EOL;
        splittedclauses=cons(ngsplit,splittedclauses);
      }
    if(!(NULL_P(ngjoinclause))) {
      ngjoinclauses=cons(ngjoinclause,ngjoinclauses);
    }
  }
  if(!(NULL_P(gjoinclause))) {
    res=cons(gjoinclause,append2(ngjoinclauses,splittedclauses));
  }
  else {
    res=append2(ngjoinclauses,splittedclauses);
  }
  res=map1(split_flat_clause_fn530,res);
  return res;
}

SCM split_flat_clause_fn530(x)
SCM x;
{
  return cons(EOL,x);
}

SCM make_flat_split_literal(vars)
SCM vars;
{
  if(NULL_P(vars)) {
    vars=cons(GLOBAL(prop_const_min_global),EOL);
  }
  GLOBAL(flat_split_literal_nr_global)=MAKINUM(1+INUM(GLOBAL(flat_split_literal_nr_global)));
  GLOBAL(prop_orig_preds_enum_global)=cons(cons(GLOBAL(flat_split_literal_nr_global),GLOBAL(flat_split_literal_nr_global)),GLOBAL(prop_orig_preds_enum_global));
  GLOBAL(prop_orig_preds_global)=cons(cons(GLOBAL(flat_split_literal_nr_global),length(vars)),GLOBAL(prop_orig_preds_global));
  return cons(GLOBAL(flat_split_literal_nr_global),vars);
}

SCM split_flat_clause_into_components(clause)
SCM clause;
{
  SCM res,splitcomponents,origclause,clausevars,joinvars,clausewithvars;

  res=EOL;
  splitcomponents=EOL;
  origclause=clause;
  clausevars=EOL;
  joinvars=EOL;
  clausewithvars=EOL;
  clausevars=get_fullclause_varslist(clause);
  clause=CDR(clause);
  clausewithvars=map1(split_flat_clause_into_components_fn533,clause);
  splitcomponents=make_flat_clause_splitcomponents(clausewithvars,joinvars);
  splitcomponents=make_flat_clause_joingroundsplits(splitcomponents);
  splitcomponents=map1(split_flat_clause_into_components_fn534,splitcomponents);
  splitcomponents=cons(EOL,splitcomponents);
  if(NULL_P(clause)||NULL_P(CDR(clause))) {
    res=cons(origclause,EOL);
  }
  else {
    res=cons(origclause,EOL);
  }
  return splitcomponents;
}

SCM split_flat_clause_into_components_fn534(x)
SCM x;
{
  return make_flat_clause_nongroundsplits(x);
}

SCM split_flat_clause_into_components_fn533(x)
SCM x;
{
  return cons(give_flat_lit_varset(x),cons(x,EOL));
}

SCM make_flat_clause_splitcomponents(clausewithvars,joinvars)
SCM clausewithvars,joinvars;
{
  SCM splitpart,tmp,compvars1,compvars2,complits1,complits2,newcomp,split,res,joinflag,splitrest;

  tmp=EOL;
  compvars1=EOL;
  compvars2=EOL;
  complits1=EOL;
  complits2=EOL;
  newcomp=EOL;
  split=EOL;
  res=EOL;
  joinflag=BOOL_T;
  split=clausewithvars;
  for(;NFALSEP(joinflag);) {
    joinflag=BOOL_F;
    for(splitpart=split;!(NULL_P(splitpart)||NFALSEP(joinflag));splitpart=CDR(splitpart)) {
      compvars1=CAR(CAR(splitpart));
      complits1=CDR(CAR(splitpart));
      for(splitrest=CDR(splitpart);!(NULL_P(splitrest)||NFALSEP(joinflag));splitrest=CDR(splitrest)) {
        compvars2=CAR(CAR(splitrest));
        complits2=CDR(CAR(splitrest));
        if(NFALSEP(some_pred__inst1(compvars2,joinvars,make_flat_clause_splitcomponents_fn537,compvars1))) {
          joinflag=BOOL_T;
          newcomp=cons(union_nonkeyword(compvars1,compvars2),append2(complits1,complits2));
          split=filter_map_inst1(splitrest,splitpart,make_flat_clause_splitcomponents_fn538,split);
          split=cons(newcomp,split);
        }
      }
    }
  }
  res=split;
  return split;
}

SCM make_flat_clause_splitcomponents_fn538(splitrest,splitpart,comp)
SCM splitrest,splitpart,comp;
{
  if((comp==CAR(splitpart))||(comp==CAR(splitrest)))
    return BOOL_F;
  else
    return comp;
}

SCM make_flat_clause_splitcomponents_fn537(compvars2,joinvars,var)
SCM compvars2,joinvars,var;
{
  return SBOOL(!(NFALSEP(memq(var,joinvars)))&&NFALSEP(memq(var,compvars2)));
}

SCM make_flat_clause_joingroundsplits(split)
SCM split;
{
  SCM tmp,maincomp,origmaincomp,newcomp,res;

  tmp=EOL;
  maincomp=EOL;
  origmaincomp=EOL;
  newcomp=EOL;
  res=EOL;
  maincomp=member_if(make_flat_clause_joingroundsplits_fn541,split);
  if(NFALSEP(maincomp)) {
    maincomp=CAR(maincomp);
  }
  else {
    maincomp=CAR(split);
  }
  origmaincomp=maincomp;
  res=filter_map_inst2(&maincomp,origmaincomp,make_flat_clause_joingroundsplits_fn542,split);
  res=cons(maincomp,res);
  return res;
}

SCM make_flat_clause_joingroundsplits_fn542(maincomp,origmaincomp,x)
SCM *maincomp;
SCM origmaincomp,x;
{
  if(x==origmaincomp)
    return BOOL_F;
  else
  if(NULL_P(CAR(x))) {
    *maincomp=append2(*maincomp,CDR(x));
    return BOOL_F;
  }
  else
    return x;
}

SCM make_flat_clause_joingroundsplits_fn541(comp)
SCM comp;
{
  return NOT(SBOOL(NULL_P(CAR(comp))));
}

SCM make_flat_clause_nongroundsplits(split)
SCM split;
{
  SCM splitvars,splitfoundflag,clausewithvars,varcombinationsnr,varcombinations,clausevars,clause,vars,res,tmp,varspart;

  tmp=EOL;
  res=EOL;
  vars=EOL;
  clause=EOL;
  clausevars=EOL;
  varcombinations=EOL;
  varcombinationsnr=MAKINUM(0);
  clausewithvars=EOL;
  splitfoundflag=BOOL_F;
  splitvars=EOL;
  if(NULL_P(split)||(NULL_P(CDR(split))||(NULL_P(CDR(CDR(split)))||(NULL_P(CAR(split))||(NULL_P(CDR(CAR(split)))||NULL_P(CDR(CDR(CAR(split))))))))) {
    return cons(EOL,cons(split,EOL));
  }
  else {
    res=cons(EOL,cons(split,EOL));
    clausevars=CAR(split);
    clause=CDR(split);
    clausewithvars=map1(make_flat_clause_nongroundsplits_fn544,clause);
    varcombinations=make_flat_nongroundsplit_varcombinations(clausevars);
    for(varspart=varcombinations;!(NULL_P(varspart)||NFALSEP(splitfoundflag));varspart=CDR(varspart)) {
      splitvars=CAR(varspart);
      tmp=make_flat_clause_splitcomponents(clausewithvars,splitvars);
      tmp=make_flat_clause_joingroundsplits(tmp);
      if(!(NULL_P(CDR(tmp)))&&NFALSEP(good_flat_split_pred_(splitvars,clausevars,tmp))) {
        splitfoundflag=BOOL_T;
        res=cons(splitvars,tmp);
      }
    }
    return res;
  }
}

SCM make_flat_clause_nongroundsplits_fn544(x)
SCM x;
{
  return cons(give_flat_lit_varset(x),cons(x,EOL));
}

SCM make_flat_nongroundsplit_varcombinations_justatry(clausevars)
SCM clausevars;
{
  SCM clausevarslen,res;

  clausevarslen=length(clausevars);
  res=EOL;
  if(MAKINUM(0)==clausevarslen) {
    res=EOL;
  }
  else
  if(MAKINUM(1)==clausevarslen) {
    res=EOL;
  }
  else
  if(MAKINUM(2)==clausevarslen) {
    res=EOL;
  }
  else
  if(MAKINUM(3)==clausevarslen) {
    res=map1(make_flat_nongroundsplit_varcombinations_justatry_fn549,clausevars);
  }
  else
  if(MAKINUM(4)==clausevarslen) {
    res=append2(map1(make_flat_nongroundsplit_varcombinations_justatry_fn550,clausevars),make_subsets_of_len_2(clausevars));
  }
  else
  if((MAKINUM(4)<clausevarslen)&&(MAKINUM(6)>=clausevarslen)) {
    res=append2(map1(make_flat_nongroundsplit_varcombinations_justatry_fn551,clausevars),append2(make_subsets_of_len_2(clausevars),make_subsets_of_len_3(clausevars)));
  }
  else {
    res=map1(make_flat_nongroundsplit_varcombinations_justatry_fn552,clausevars);
  }
  return res;
}

SCM make_flat_nongroundsplit_varcombinations_justatry_fn552(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_justatry_fn551(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_justatry_fn550(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_justatry_fn549(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations(clausevars)
SCM clausevars;
{
  SCM clausevarslen,res;

  clausevarslen=length(clausevars);
  res=EOL;
  if(MAKINUM(0)==clausevarslen) {
    res=EOL;
  }
  else
  if(MAKINUM(1)==clausevarslen) {
    res=EOL;
  }
  else
  if(MAKINUM(2)==clausevarslen) {
    res=EOL;
  }
  else
  if(MAKINUM(3)==clausevarslen) {
    res=map1(make_flat_nongroundsplit_varcombinations_fn562,clausevars);
  }
  else
  if(MAKINUM(4)==clausevarslen) {
    res=append2(map1(make_flat_nongroundsplit_varcombinations_fn563,clausevars),make_subsets_of_len_2(clausevars));
  }
  else
  if((MAKINUM(4)<clausevarslen)&&(MAKINUM(6)>=clausevarslen)) {
    res=append2(map1(make_flat_nongroundsplit_varcombinations_fn564,clausevars),append2(make_subsets_of_len_2(clausevars),make_subsets_of_len_3(clausevars)));
  }
  else
  if((MAKINUM(6)<clausevarslen)&&(MAKINUM(8)>=clausevarslen)) {
    res=append2(map1(make_flat_nongroundsplit_varcombinations_fn565,clausevars),append2(make_subsets_of_len_2(clausevars),append2(make_subsets_of_len_3(clausevars),make_subsets_of_len_4(clausevars))));
  }
  else
  if((MAKINUM(8)<clausevarslen)&&(MAKINUM(20)>=clausevarslen)) {
    if(1) {
      res=append2(map1(make_flat_nongroundsplit_varcombinations_fn566,clausevars),append2(make_subsets_of_len_2(clausevars),append2(make_subsets_of_len_3(clausevars),make_subsets_of_len_4(clausevars))));
    }
    else {
      res=append2(map1(make_flat_nongroundsplit_varcombinations_fn567,clausevars),append2(EOL,make_subsets_of_len_2(clausevars)));
    }
  }
  else
  if((MAKINUM(20)<clausevarslen)&&(MAKINUM(40)>=clausevarslen)) {
    if(1) {
      res=append2(map1(make_flat_nongroundsplit_varcombinations_fn568,clausevars),make_subsets_of_len_2(clausevars));
    }
    else {
      res=map1(make_flat_nongroundsplit_varcombinations_fn569,clausevars);
    }
  }
  else {
    res=map1(make_flat_nongroundsplit_varcombinations_fn570,clausevars);
  }
  return res;
}

SCM make_flat_nongroundsplit_varcombinations_fn570(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_fn569(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_fn568(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_fn567(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_fn566(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_fn565(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_fn564(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_fn563(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_flat_nongroundsplit_varcombinations_fn562(x)
SCM x;
{
  return cons(x,EOL);
}

SCM make_subsets_of_len_2(lst)
SCM lst;
{
  SCM lstpart1,res,lstpart2;

  res=EOL;
  for(lstpart1=lst;!(NULL_P(lstpart1));lstpart1=CDR(lstpart1))
    for(lstpart2=CDR(lstpart1);!(NULL_P(lstpart2));lstpart2=CDR(lstpart2)) {
      res=cons(cons(CAR(lstpart1),cons(CAR(lstpart2),EOL)),res);
    }
  return res;
}

SCM make_subsets_of_len_3(lst)
SCM lst;
{
  SCM lstpart2,res,tmp,lstpart1,lstpart3;

  tmp=EOL;
  res=EOL;
  for(lstpart1=lst;!(NULL_P(lstpart1));lstpart1=CDR(lstpart1))
    for(lstpart2=CDR(lstpart1);!(NULL_P(lstpart2));lstpart2=CDR(lstpart2))
      for(lstpart3=CDR(lstpart2);!(NULL_P(lstpart3));lstpart3=CDR(lstpart3)) {
        res=cons(cons(CAR(lstpart1),cons(CAR(lstpart2),cons(CAR(lstpart3),EOL))),res);
      }
  return res;
}

SCM make_subsets_of_len_4(lst)
SCM lst;
{
  SCM lstpart3,lstpart1,res,tmp,lstpart2,lstpart4;

  res=EOL;
  tmp=EOL;
  for(lstpart1=lst;!(NULL_P(lstpart1));lstpart1=CDR(lstpart1))
    for(lstpart2=CDR(lstpart1);!(NULL_P(lstpart2));lstpart2=CDR(lstpart2))
      for(lstpart3=CDR(lstpart2);!(NULL_P(lstpart3));lstpart3=CDR(lstpart3)) {
        tmp=cons(CAR(lstpart1),cons(CAR(lstpart2),cons(CAR(lstpart3),EOL)));
        for(lstpart4=CDR(lstpart3);!(NULL_P(lstpart4));lstpart4=CDR(lstpart4)) {
          res=cons(cons(CAR(lstpart4),tmp),res);
        }
      }
  return res;
}

SCM make_subsets_of_len_5(lst)
SCM lst;
{
  SCM lstpart4,lstpart2,tmp,res,lstpart1,lstpart3,lstpart5;

  res=EOL;
  tmp=EOL;
  for(lstpart1=lst;!(NULL_P(lstpart1));lstpart1=CDR(lstpart1))
    for(lstpart2=CDR(lstpart1);!(NULL_P(lstpart2));lstpart2=CDR(lstpart2))
      for(lstpart3=CDR(lstpart2);!(NULL_P(lstpart3));lstpart3=CDR(lstpart3)) {
        tmp=cons(CAR(lstpart1),cons(CAR(lstpart2),cons(CAR(lstpart3),EOL)));
        for(lstpart4=CDR(lstpart3);!(NULL_P(lstpart4));lstpart4=CDR(lstpart4)) {
          tmp=cons(CAR(lstpart4),tmp);
          for(lstpart5=CDR(lstpart4);!(NULL_P(lstpart5));lstpart5=CDR(lstpart5)) {
            res=cons(cons(CAR(lstpart5),tmp),res);
          }
        }
      }
  return res;
}

SCM good_flat_split_pred_(splitvars,clausevars,splits)
SCM splitvars,clausevars,splits;
{
  SCM clausevarsnr;

  clausevarsnr=length(clausevars);
  return every_pred__inst1(clausevarsnr,good_flat_split_pred__fn572,splits);
}

SCM good_flat_split_pred__fn572(clausevarsnr,split)
SCM clausevarsnr,split;
{
  return SBOOL(length(CAR(split))<clausevarsnr);
}

SCM give_flat_lit_varset(lit)
SCM lit;
{
  return get_fullclause_varslist(cons(EOL,cons(lit,EOL)));
}

SCM pseudo_split_input_clause(clause)
SCM clause;
{
  SCM gsplits,res,bestlen,bestsplit,splitcomponents,gsplit,ngsplit,ngsplitcomponents,ngsplitvars,newclause,splitliteral,splittedclauses,gjoinclause,ngjoinclause,ngjoinclauses,joinclauses,tmp,origclause,ngsplits;

  res=EOL;
  bestlen=MAKINUM(99999);
  bestsplit=EOL;
  splitcomponents=EOL;
  gsplit=EOL;
  ngsplit=EOL;
  ngsplitcomponents=EOL;
  ngsplitvars=EOL;
  newclause=EOL;
  splitliteral=EOL;
  splittedclauses=EOL;
  gjoinclause=EOL;
  ngjoinclause=EOL;
  ngjoinclauses=EOL;
  joinclauses=EOL;
  tmp=EOL;
  origclause=clause;
  splitcomponents=split_input_clause_into_components(clause);
  for(gsplits=CDR(splitcomponents);!(NULL_P(gsplits));gsplits=CDR(gsplits)) {
    if(!(NULL_P(CDR(CDR(splitcomponents))))) {
      tmp=make_input_split_literal(EOL);
      gjoinclause=cons(cons(polarize_pred_nr(CAR(tmp),BOOL_F),CDR(tmp)),gjoinclause);
      ngjoinclause=cons(cons(CAR(tmp),CDR(CAR(gjoinclause))),EOL);
    }
    else {
      gjoinclause=EOL;
      ngjoinclause=EOL;
    }
    gsplit=CAR(gsplits);
    ngsplitcomponents=CDR(gsplit);
    ngsplitvars=CAR(gsplit);
    bestlen=MAKINUM(99999);
    bestsplit=EOL;
    for(ngsplits=ngsplitcomponents;!(NULL_P(ngsplits));ngsplits=CDR(ngsplits))
      if(!(NULL_P(CDR(ngsplitcomponents)))) {
        ngsplit=CDR(CAR(ngsplits));
        splitliteral=make_input_split_literal(ngsplitvars);
        newclause=cons(splitliteral,ngsplit);
        splittedclauses=cons(newclause,splittedclauses);
        ngjoinclause=cons(cons(polarize_pred_nr(CAR(splitliteral),BOOL_F),CDR(splitliteral)),ngjoinclause);
      }
      else
      if(!(NULL_P(gjoinclause))) {
        ngsplit=CDR(CAR(ngsplits));
        ngjoinclause=EOL;
        splitliteral=cons(reverse_polarize_pred_nr(CAR(CAR(gjoinclause))),CDR(CAR(gjoinclause)));
        newclause=cons(splitliteral,ngsplit);
        splittedclauses=cons(newclause,splittedclauses);
      }
      else {
        ngsplit=CDR(CAR(ngsplits));
        ngjoinclause=EOL;
        splittedclauses=cons(ngsplit,splittedclauses);
      }
    if(!(NULL_P(ngjoinclause))) {
      ngjoinclauses=cons(ngjoinclause,ngjoinclauses);
    }
  }
  if(!(NULL_P(gjoinclause))) {
    res=cons(gjoinclause,append2(ngjoinclauses,splittedclauses));
  }
  else {
    res=append2(ngjoinclauses,splittedclauses);
  }
  res=map1(pseudo_split_input_clause_fn574,res);
  return res;
}

SCM pseudo_split_input_clause_fn574(x)
SCM x;
{
  return cons(EOL,x);
}

SCM make_input_split_literal(vars)
SCM vars;
{
  SCM tmp1,tmp0,nr;

  tmp0=EOL;
  tmp1=EOL;
  tmp0=assoc(string2symbol(const_412),GLOBAL(pred_num_table_global));
  tmp1=assoc(string2symbol(const_413),GLOBAL(pred_num_table_global));
  if(NFALSEP(tmp0)) {
    tmp0=CDR(tmp0);
  }
  else {
    GLOBAL(pred_num_global)=MAKINUM(1+INUM(GLOBAL(pred_num_global)));
    tmp0=MAKINUM(INUM(GLOBAL(pred_num_global))<<21);
    GLOBAL(pred_num_table_global)=cons(cons(string2symbol(const_414),tmp0),GLOBAL(pred_num_table_global));
  }
  if(NFALSEP(tmp1)) {
    tmp1=CDR(tmp1);
  }
  else {
    GLOBAL(pred_num_global)=MAKINUM(1+INUM(GLOBAL(pred_num_global)));
    tmp1=MAKINUM(INUM(GLOBAL(pred_num_global))<<21);
    GLOBAL(pred_num_table_global)=cons(cons(string2symbol(const_415),tmp1),GLOBAL(pred_num_table_global));
  }
  for(nr=MAKINUM(1+INUM(GLOBAL(input_split_constant_nr_global)));NFALSEP(rassq(nr,GLOBAL(const_num_table_global)));nr=MAKINUM(1+INUM(nr))) ;
  GLOBAL(input_split_constant_nr_global)=nr;
  GLOBAL(const_num_table_global)=cons(cons(string2symbol(st_append(cons(const_416,cons(number2string(MAKINUM(INUM(GLOBAL(input_split_constant_nr_global))-70000),MAKINUM(10)),EOL)))),GLOBAL(input_split_constant_nr_global)),GLOBAL(const_num_table_global));
  if(GLOBAL(pred_num_global)>GLOBAL(max_nr_of_preds_global))
    return report_error(const_417,cons(BOOL_T,EOL));
  else
  if(NULL_P(vars))
    return cons(tmp0,cons(GLOBAL(input_split_constant_nr_global),EOL));
  else
  if(NULL_P(CDR(vars)))
    return cons(tmp1,cons(GLOBAL(input_split_constant_nr_global),vars));
  else {
    newline(cur_output_port());
    display(const_418,cur_output_port());
    newline(cur_output_port());
    return quit(1);
  }
}

SCM make_input_clause_nongroundsplits(split)
SCM split;
{
  SCM splitvars,splitfoundflag,clausewithvars,varcombinationsnr,varcombinations,clausevars,clause,vars,res,tmp,varspart;

  tmp=EOL;
  res=EOL;
  vars=EOL;
  clause=EOL;
  clausevars=EOL;
  varcombinations=EOL;
  varcombinationsnr=MAKINUM(0);
  clausewithvars=EOL;
  splitfoundflag=BOOL_F;
  splitvars=EOL;
  if(NULL_P(split)||(NULL_P(CDR(split))||(NULL_P(CDR(CDR(split)))||(NULL_P(CAR(split))||(NULL_P(CDR(CAR(split)))||NULL_P(CDR(CDR(CAR(split))))))))) {
    return cons(EOL,cons(split,EOL));
  }
  else {
    res=cons(EOL,cons(split,EOL));
    clausevars=CAR(split);
    clause=CDR(split);
    clausewithvars=map1(make_input_clause_nongroundsplits_fn576,clause);
    varcombinations=make_input_nongroundsplit_varcombinations(clausevars);
    for(varspart=varcombinations;!(NULL_P(varspart)||NFALSEP(splitfoundflag));varspart=CDR(varspart)) {
      splitvars=CAR(varspart);
      tmp=make_flat_clause_splitcomponents(clausewithvars,splitvars);
      tmp=make_flat_clause_joingroundsplits(tmp);
      if(!(NULL_P(CDR(tmp)))&&NFALSEP(good_flat_split_pred_(splitvars,clausevars,tmp))) {
        splitfoundflag=BOOL_T;
        res=cons(splitvars,tmp);
      }
    }
    return res;
  }
}

SCM make_input_clause_nongroundsplits_fn576(x)
SCM x;
{
  return cons(give_flat_lit_varset(x),cons(x,EOL));
}

SCM make_input_nongroundsplit_varcombinations(clausevars)
SCM clausevars;
{
  SCM clausevarslen,res;

  clausevarslen=length(clausevars);
  res=EOL;
  if(MAKINUM(0)==clausevarslen) {
    res=EOL;
  }
  else
  if(MAKINUM(1)==clausevarslen) {
    res=EOL;
  }
  else
  if(MAKINUM(2)==clausevarslen) {
    res=EOL;
  }
  else {
    res=map1(make_input_nongroundsplit_varcombinations_fn578,clausevars);
  }
  return res;
}

SCM make_input_nongroundsplit_varcombinations_fn578(x)
SCM x;
{
  return cons(x,EOL);
}

SCM split_input_clause_into_components(clause)
SCM clause;
{
  SCM res,splitcomponents,origclause,clausevars,joinvars,clausewithvars;

  res=EOL;
  splitcomponents=EOL;
  origclause=clause;
  clausevars=EOL;
  joinvars=EOL;
  clausewithvars=EOL;
  clausevars=get_fullclause_varslist(clause);
  clause=CDR(clause);
  clausewithvars=map1(split_input_clause_into_components_fn581,clause);
  splitcomponents=make_flat_clause_splitcomponents(clausewithvars,joinvars);
  splitcomponents=make_flat_clause_joingroundsplits(splitcomponents);
  splitcomponents=map1(split_input_clause_into_components_fn582,splitcomponents);
  splitcomponents=cons(EOL,splitcomponents);
  if(NULL_P(clause)||NULL_P(CDR(clause))) {
    res=cons(origclause,EOL);
  }
  else {
    res=cons(origclause,EOL);
  }
  return splitcomponents;
}

SCM split_input_clause_into_components_fn582(x)
SCM x;
{
  return make_input_clause_nongroundsplits(x);
}

SCM split_input_clause_into_components_fn581(x)
SCM x;
{
  return cons(give_flat_lit_varset(x),cons(x,EOL));
}

SCM find_good_splittable_sos_clause(sos)
SCM sos;
{
  SCM rpart,cl,stopflag,purenegnr,splittablemaxlen,purenegsplittablenr,nongsplittablenr,splittablenr,soslen,tmp,preres,res,part,new_var1;

  res=EOL;
  preres=EOL;
  tmp=EOL;
  soslen=MAKINUM(0);
  splittablenr=MAKINUM(0);
  nongsplittablenr=MAKINUM(0);
  purenegsplittablenr=MAKINUM(0);
  splittablemaxlen=MAKINUM(0);
  purenegnr=MAKINUM(0);
  stopflag=BOOL_F;
  cl=EOL;
  for(part=sos;!(NULL_P(part));part=CDR(part)) {
    cl=CAR(part);
    soslen=MAKINUM(1+INUM(soslen));
    if(NFALSEP(every_pred_(find_good_splittable_sos_clause_fn588,cl))) {
      purenegnr=MAKINUM(1+INUM(purenegnr));
    }
    if(!(NULL_P(CDR(cl)))) {
      tmp=split_full_clause(cl);
      if(!(NULL_P(CDR(tmp)))) {
        if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
          newline(cur_output_port());
          display(const_419,cur_output_port());
          print_pure_clause(cl);
          newline(cur_output_port());
        }
        splittablenr=MAKINUM(1+INUM(splittablenr));
        if(NFALSEP(some_pred_(find_good_splittable_sos_clause_fn589,tmp))) {
          nongsplittablenr=MAKINUM(1+INUM(nongsplittablenr));
        }
        if(length(cl)>splittablemaxlen) {
          splittablemaxlen=length(cl);
        }
        if(NFALSEP(every_pred_(find_good_splittable_sos_clause_fn590,cl))) {
          purenegsplittablenr=MAKINUM(1+INUM(purenegsplittablenr));
        }
        preres=cons(CAR(part),preres);
      }
    }
  }
  newline(cur_output_port());
  display(const_420,cur_output_port());
  for_each1(find_good_splittable_sos_clause_fn591,preres);
  newline(cur_output_port());
  stopflag=BOOL_F;
  res=EOL;
  for(rpart=preres;!(NULL_P(rpart)||NFALSEP(stopflag));rpart=CDR(rpart)) {
    cl=CAR(rpart);
    if(NULL_P(CDR(preres))) {
      res=cl;
      stopflag=BOOL_T;
    }
    else
    if(nongsplittablenr==MAKINUM(1)) {
      if(NFALSEP(some_pred_(find_good_splittable_sos_clause_fn592,cl))) {
        res=cl;
        stopflag=BOOL_T;
      }
    }
    else {
      new_var1=SBOOL(purenegnr==MAKINUM(1));
      if(NFALSEP(new_var1)) ;
    }
  }
  if(!(NFALSEP(res))||NULL_P(res))
    return BOOL_F;
  else
    return res;
}

SCM find_good_splittable_sos_clause_fn592(x)
SCM x;
{
  return SBOOL(ZERO_P(MAKINUM(65536)&CAR(x)));
}

SCM find_good_splittable_sos_clause_fn591(x)
SCM x;
{
  return display(x,cur_output_port());
}

SCM find_good_splittable_sos_clause_fn590(lit)
SCM lit;
{
  return SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(lit))));
}

SCM find_good_splittable_sos_clause_fn589(el)
SCM el;
{
  return SBOOL(!(NULL_P(el)));
}

SCM find_good_splittable_sos_clause_fn588(lit)
SCM lit;
{
  return SBOOL(!(ZERO_P(MAKINUM(268435456)&CAR(lit))));
}

SCM split_full_clause(cl)
SCM cl;
{
  SCM tmp,clinf,purecl,splitted,res;

  tmp=EOL;
  clinf=CAR(cl);
  purecl=CDR(cl);
  splitted=EOL;
  res=EOL;
  splitted=map1(split_full_clause_fn594,purecl);
  res=make_clause_splitcomponents(splitted,EOL);
  return res;
}

SCM split_full_clause_fn594(x)
SCM x;
{
  return cons(get_lit_split_varlist(x),cons(x,EOL));
}

SCM get_lit_split_varlist(lit)
SCM lit;
{
  GLOBAL(lit_split_varlist_tmp_global)=EOL;
  get_lit_split_varlist_aux_excl_(lit);
  return GLOBAL(lit_split_varlist_tmp_global);
}

SCM get_lit_split_varlist_aux_excl_(term)
SCM term;
{
  SCM tmp,part;

  tmp=EOL;
  if(PAIR_P(term)) {
    for(part=CDR(term);!(NULL_P(part));part=CDR(part))
      get_lit_split_varlist_aux_excl_(CAR(part));
    return UNSPECIFIED;
  }
  else
  if(NUMBER_P(term)&&(term<=MAKINUM(65535))) {
    tmp=(MAKINUM(8191)&term);
    if(!(NFALSEP(memq(tmp,GLOBAL(lit_split_varlist_tmp_global))))) {
      GLOBAL(lit_split_varlist_tmp_global)=cons(tmp,GLOBAL(lit_split_varlist_tmp_global));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM make_clause_splitcomponents(clausewithvars,joinvars)
SCM clausewithvars,joinvars;
{
  SCM splitpart,tmp,compvars1,compvars2,complits1,complits2,newcomp,split,res,joinflag,splitrest;

  tmp=EOL;
  compvars1=EOL;
  compvars2=EOL;
  complits1=EOL;
  complits2=EOL;
  newcomp=EOL;
  split=EOL;
  res=EOL;
  joinflag=BOOL_T;
  split=clausewithvars;
  for(;NFALSEP(joinflag);) {
    joinflag=BOOL_F;
    for(splitpart=split;!(NULL_P(splitpart)||NFALSEP(joinflag));splitpart=CDR(splitpart)) {
      compvars1=CAR(CAR(splitpart));
      complits1=CDR(CAR(splitpart));
      for(splitrest=CDR(splitpart);!(NULL_P(splitrest)||NFALSEP(joinflag));splitrest=CDR(splitrest)) {
        compvars2=CAR(CAR(splitrest));
        complits2=CDR(CAR(splitrest));
        if(NFALSEP(some_pred__inst1(compvars2,joinvars,make_clause_splitcomponents_fn597,compvars1))) {
          joinflag=BOOL_T;
          newcomp=cons(union_nonkeyword(compvars1,compvars2),append2(complits1,complits2));
          split=filter_map_inst1(splitrest,splitpart,make_clause_splitcomponents_fn598,split);
          split=cons(newcomp,split);
        }
      }
    }
  }
  res=split;
  return split;
}

SCM make_clause_splitcomponents_fn598(splitrest,splitpart,comp)
SCM splitrest,splitpart,comp;
{
  if((comp==CAR(splitpart))||(comp==CAR(splitrest)))
    return BOOL_F;
  else
    return comp;
}

SCM make_clause_splitcomponents_fn597(compvars2,joinvars,var)
SCM compvars2,joinvars,var;
{
  return SBOOL(!(NFALSEP(memq(var,joinvars)))&&NFALSEP(memq(var,compvars2)));
}

SCM prop_build_simple_model(predclauses)
SCM predclauses;
{
  SCM res,tmpnr,domainsize,stopflag,domainsize__1;

  stopflag=BOOL_F;
  domainsize=MAKINUM(0);
  tmpnr=MAKINUM(0);
  res=BOOL_F;
  GLOBAL(prop_clauses_generation_limit_global)=BOOL_F;
  GLOBAL(prop_clauses_generation_limited_flag_global)=BOOL_F;
  GLOBAL(prop_time_ran_out_global)=BOOL_F;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(slow_start_time_global)=get_check_time(MAKINUM(0));
  store_time_checkpoint_excl_(MAKINUM(0));
  predclauses=prop_uncurry_clauses(predclauses);
  extract_pred_data_to_prop(predclauses);
  if(NULL_P(GLOBAL(prop_orig_funs_global))) {
    domainsize=length(GLOBAL(prop_orig_constants_global));
    if(ZERO_P(domainsize)) {
      domainsize=MAKINUM(1);
    }
    if(GLOBAL(display_info_level_global)>MAKINUM(30)) {
      display(const_421,cur_output_port());
      display(domainsize,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(prop_interp_value_pairs_global)=EOL;
    make_prop_interpretation_lists(domainsize,BOOL_T,BOOL_F);
    create_prop_var_vectors(GLOBAL(prop_atom_maxnr_global));
    res=check_prop_one_interpretation(predclauses,domainsize);
    if(NFALSEP(GLOBAL(prop_time_ran_out_global))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
        newline(cur_output_port());
        display(const_422,cur_output_port());
        newline(cur_output_port());
      }
      return BOOL_F;
    }
    else
      return res;
  }
  else {
    for(domainsize__1=MAKINUM(1);!(NFALSEP(stopflag)||(NFALSEP(res)||((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))));domainsize__1=MAKINUM(1+INUM(domainsize__1))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(28)) {
        newline(cur_output_port());
        display(const_423,cur_output_port());
        display(domainsize__1,cur_output_port());
        newline(cur_output_port());
      }
      make_prop_interpretation_lists(domainsize__1,BOOL_T,BOOL_F);
      create_prop_var_vectors(GLOBAL(prop_atom_maxnr_global));
      if(NFALSEP(GLOBAL(prop_debug_global))) {
        display(const_424,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_interp_value_pairs_global),cur_output_port());
        newline(cur_output_port());
        display(const_425,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_constants_mapping_global),cur_output_port());
        newline(cur_output_port());
        display(const_426,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_fun_mappings_global),cur_output_port());
        newline(cur_output_port());
        display(const_427,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_lit_mappings_global),cur_output_port());
        newline(cur_output_port());
        display(const_428,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_atom_maxnr_global),cur_output_port());
        newline(cur_output_port());
      }
      res=check_prop_interpretations(predclauses,domainsize__1,MAKINUM(0));
    }
    if(NFALSEP(GLOBAL(prop_time_ran_out_global))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
        newline(cur_output_port());
        display(const_429,cur_output_port());
        newline(cur_output_port());
      }
      return BOOL_F;
    }
    else
      return res;
  }
}

SCM prop_build_flatten_model(predclauses)
SCM predclauses;
{
  SCM res,tmpnr,flatclauses,domainsize,stopflag,domainsize__1;

  stopflag=BOOL_F;
  domainsize=MAKINUM(0);
  flatclauses=EOL;
  tmpnr=MAKINUM(0);
  res=BOOL_F;
  newline(cur_output_port());
  display(const_430,cur_output_port());
  newline(cur_output_port());
  GLOBAL(prop_clauses_generation_limit_global)=BOOL_F;
  GLOBAL(prop_clauses_generation_limited_flag_global)=BOOL_F;
  GLOBAL(prop_conversion_to_file_global)=BOOL_T;
  GLOBAL(prop_conversion_file_name_global)=st_append(cons(GLOBAL(prop_conversion_file_name_start_global),cons(GLOBAL(run_id_global),EOL)));
  GLOBAL(prop_conversion_temp_file_name_global)=st_append(cons(GLOBAL(prop_conversion_temp_file_name_start_global),cons(GLOBAL(run_id_global),EOL)));
  GLOBAL(prop_conversion_header_file_name_global)=st_append(cons(GLOBAL(prop_conversion_header_file_name_start_global),cons(GLOBAL(run_id_global),EOL)));
  GLOBAL(prop_conversion_result_file_name_global)=st_append(cons(GLOBAL(prop_conversion_result_file_name_start_global),cons(GLOBAL(run_id_global),EOL)));
  GLOBAL(max_var_stat_pre_global)=MAKINUM(0);
  GLOBAL(max_var_stat_post_global)=MAKINUM(0);
  GLOBAL(prop_time_ran_out_global)=BOOL_F;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(slow_start_time_global)=get_check_time(MAKINUM(0));
  store_time_checkpoint_excl_(MAKINUM(0));
  predclauses=prop_uncurry_clauses(predclauses);
  predclauses=prop_groundprocess_clauses(predclauses);
  extract_pred_data_to_prop(predclauses);
  flatclauses=flatten_clause_set(predclauses);
  GLOBAL(flat_split_literal_nr_global)=MAKINUM(10000);
  flatclauses=split_flat_clause_set(flatclauses);
  GLOBAL(prop_clauses_generation_limit_global)=BOOL_F;
  GLOBAL(prop_clauses_generation_limited_flag_global)=BOOL_F;
  for(domainsize__1=MAKINUM(1);!(NFALSEP(stopflag)||(NFALSEP(res)||((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))));domainsize__1=MAKINUM(1+INUM(domainsize__1))) {
    if(GLOBAL(display_info_level_global)>MAKINUM(28)) {
      newline(cur_output_port());
      display(const_431,cur_output_port());
      display(domainsize__1,cur_output_port());
      newline(cur_output_port());
    }
    make_prop_interpretation_lists(domainsize__1,BOOL_F,BOOL_T);
    create_prop_var_vectors(GLOBAL(prop_atom_maxnr_global));
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(const_432,cur_output_port());
      newline(cur_output_port());
      for_each1(prop_build_flatten_model_fn602,GLOBAL(prop_interp_value_pairs_global));
      display(const_433,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_constants_mapping_global),cur_output_port());
      newline(cur_output_port());
      display(const_434,cur_output_port());
      newline(cur_output_port());
      for_each1(prop_build_flatten_model_fn603,GLOBAL(prop_fun_mappings_global));
      display(const_435,cur_output_port());
      newline(cur_output_port());
      for_each1(prop_build_flatten_model_fn604,GLOBAL(prop_lit_mappings_global));
      display(const_436,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_atom_maxnr_global),cur_output_port());
      newline(cur_output_port());
    }
    res=check_prop_flatten_interpretations(predclauses,flatclauses,domainsize__1,BOOL_T);
  }
  GLOBAL(prop_conversion_to_file_global)=BOOL_F;
  lsystem(st_append(cons(const_437,cons(GLOBAL(prop_conversion_file_name_global),EOL))));
  lsystem(st_append(cons(const_438,cons(GLOBAL(prop_conversion_temp_file_name_global),EOL))));
  lsystem(st_append(cons(const_439,cons(GLOBAL(prop_conversion_header_file_name_global),EOL))));
  lsystem(st_append(cons(const_440,cons(GLOBAL(prop_conversion_result_file_name_global),EOL))));
  if(NFALSEP(GLOBAL(prop_time_ran_out_global))) {
    if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
      newline(cur_output_port());
      display(const_441,cur_output_port());
      newline(cur_output_port());
    }
    return BOOL_F;
  }
  else
    return res;
}

SCM prop_build_flatten_model_fn604(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prop_build_flatten_model_fn603(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prop_build_flatten_model_fn602(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM prop_build_nofuns_model(predclauses)
SCM predclauses;
{
  SCM stopflag,domainsize,flatclauses,tmpnr,tmp,checkres,eqaxioms,res;

  stopflag=BOOL_F;
  domainsize=MAKINUM(0);
  flatclauses=EOL;
  tmpnr=MAKINUM(0);
  tmp=EOL;
  checkres=EOL;
  eqaxioms=EOL;
  res=BOOL_F;
  GLOBAL(sos_exhausted_flag_global)=BOOL_F;
  GLOBAL(prop_conversion_to_file_global)=BOOL_T;
  GLOBAL(prop_conversion_file_name_global)=st_append(cons(GLOBAL(prop_conversion_file_name_start_global),cons(GLOBAL(run_id_global),EOL)));
  GLOBAL(prop_conversion_temp_file_name_global)=st_append(cons(GLOBAL(prop_conversion_temp_file_name_start_global),cons(GLOBAL(run_id_global),EOL)));
  GLOBAL(prop_conversion_header_file_name_global)=st_append(cons(GLOBAL(prop_conversion_header_file_name_start_global),cons(GLOBAL(run_id_global),EOL)));
  GLOBAL(prop_conversion_result_file_name_global)=st_append(cons(GLOBAL(prop_conversion_result_file_name_start_global),cons(GLOBAL(run_id_global),EOL)));
  GLOBAL(max_var_stat_pre_global)=MAKINUM(0);
  GLOBAL(max_var_stat_post_global)=MAKINUM(0);
  GLOBAL(prop_time_ran_out_global)=BOOL_F;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(slow_start_time_global)=get_check_time(MAKINUM(0));
  store_time_checkpoint_excl_(MAKINUM(0));
  predclauses=prop_uncurry_clauses(predclauses);
  extract_pred_data_to_prop(predclauses);
  domainsize=length(GLOBAL(prop_orig_constants_global));
  if(domainsize<=MAKINUM(0)) {
    domainsize=MAKINUM(1);
  }
  newline(cur_output_port());
  display(const_442,cur_output_port());
  display(domainsize,cur_output_port());
  newline(cur_output_port());
  if(domainsize>=MAKINUM(200))
    return EOL;
  else {
    tmp=MAKINUM(100000-1);
    GLOBAL(prop_orig_constants_to_flat_domainels_global)=map1_inst4(&tmp,prop_build_nofuns_model_fn606,GLOBAL(prop_orig_constants_global));
    GLOBAL(prop_orig_constants_global)=EOL;
    flatclauses=pseudo_flatten_clause_set(predclauses);
    if(NFALSEP(GLOBAL(input_contains_eq_global))) {
      eqaxioms=make_nofuns_equality_axioms();
    }
    else {
      eqaxioms=EOL;
    }
    flatclauses=append2(eqaxioms,flatclauses);
    GLOBAL(flat_split_literal_nr_global)=MAKINUM(10000);
    flatclauses=split_flat_clause_set(flatclauses);
    make_prop_interpretation_lists(domainsize,BOOL_F,BOOL_T);
    create_prop_var_vectors(GLOBAL(prop_atom_maxnr_global));
    if(0) {
      display(const_443,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_interp_value_pairs_global),cur_output_port());
      newline(cur_output_port());
      display(const_444,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_constants_mapping_global),cur_output_port());
      newline(cur_output_port());
      display(const_445,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_fun_mappings_global),cur_output_port());
      newline(cur_output_port());
      display(const_446,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_lit_mappings_global),cur_output_port());
      newline(cur_output_port());
      display(const_447,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_atom_maxnr_global),cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(prop_pre_evalres_global)=EOL;
    GLOBAL(prop_clauses_generation_limit_global)=MAKINUM(1000000);
    GLOBAL(prop_clauses_generation_limited_flag_global)=BOOL_F;
    res=check_prop_flatten_interpretations(predclauses,flatclauses,domainsize,BOOL_F);
    GLOBAL(prop_conversion_to_file_global)=BOOL_F;
    checkres=EOL;
    if(GLOBAL(prop_pre_evalres_global)==BOOL_T) {
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global)))&&NFALSEP(check_prop_prover_outfile(GLOBAL(prop_conversion_result_file_name_global),const_448))) {
        checkres=BOOL_T;
      }
      else
      if(NFALSEP(check_prop_prover_outfile(GLOBAL(prop_conversion_result_file_name_global),const_449))) {
        checkres=BOOL_F;
      }
    }
    else {
      checkres=BOOL_F;
    }
    lsystem(st_append(cons(const_450,cons(GLOBAL(prop_conversion_file_name_global),EOL))));
    lsystem(st_append(cons(const_451,cons(GLOBAL(prop_conversion_temp_file_name_global),EOL))));
    lsystem(st_append(cons(const_452,cons(GLOBAL(prop_conversion_header_file_name_global),EOL))));
    lsystem(st_append(cons(const_453,cons(GLOBAL(prop_conversion_result_file_name_global),EOL))));
    return checkres;
  }
}

SCM prop_build_nofuns_model_fn606(tmp,x)
SCM *tmp;
SCM x;
{
  *tmp=MAKINUM(1+INUM(*tmp));
  return cons(x,*tmp);
}

SCM compute_max_vars_in_clauses(clauses)
SCM clauses;
{
  SCM mx,nr,vars;

  mx=MAKINUM(0);
  nr=MAKINUM(0);
  vars=EOL;
  for_each1_inst7(&nr,&mx,&vars,compute_max_vars_in_clauses_fn608,clauses);
  return mx;
}

SCM compute_max_vars_in_clauses_fn608(nr,mx,vars,cl)
SCM *nr,*mx,*vars;
SCM cl;
{
  *vars=get_fullclause_varslist(cl);
  *nr=length(*vars);
  if(*nr>*mx) {
    *mx=*nr;
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM prop_build_random_model(predclauses)
SCM predclauses;
{
  SCM res,tmpnr,randomsize,domainsize,stopflag,domainsize__1;

  stopflag=BOOL_F;
  domainsize=MAKINUM(0);
  randomsize=MAKINUM(20);
  tmpnr=MAKINUM(0);
  res=BOOL_F;
  GLOBAL(prop_time_ran_out_global)=BOOL_F;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(slow_start_time_global)=get_check_time(MAKINUM(0));
  store_time_checkpoint_excl_(MAKINUM(0));
  predclauses=prop_uncurry_clauses(predclauses);
  extract_pred_data_to_prop(predclauses);
  for(domainsize__1=MAKINUM(1);!(NFALSEP(stopflag)||((domainsize__1>MAKINUM(30))||(NFALSEP(res)||((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))))));domainsize__1=MAKINUM(1+INUM(domainsize__1))) {
    if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
      newline(cur_output_port());
      display(const_454,cur_output_port());
      display(domainsize__1,cur_output_port());
      newline(cur_output_port());
    }
    make_prop_interpretation_lists(domainsize__1,BOOL_T,BOOL_F);
    create_prop_var_vectors(GLOBAL(prop_atom_maxnr_global));
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(const_455,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_interp_value_pairs_global),cur_output_port());
      newline(cur_output_port());
      display(const_456,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_constants_mapping_global),cur_output_port());
      newline(cur_output_port());
      display(const_457,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_fun_mappings_global),cur_output_port());
      newline(cur_output_port());
      display(const_458,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_lit_mappings_global),cur_output_port());
      newline(cur_output_port());
      display(const_459,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_atom_maxnr_global),cur_output_port());
      newline(cur_output_port());
    }
    res=check_prop_interpretations(predclauses,domainsize__1,randomsize);
  }
  if(NFALSEP(GLOBAL(prop_time_ran_out_global))) {
    if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
      newline(cur_output_port());
      display(const_460,cur_output_port());
      newline(cur_output_port());
    }
    return BOOL_F;
  }
  else
    return res;
}

SCM prop_build_incremental_model(predclauses)
SCM predclauses;
{
  SCM res,tmpnr,domainsize,stopflag,domainsize__1;

  stopflag=BOOL_F;
  domainsize=MAKINUM(0);
  tmpnr=MAKINUM(0);
  res=BOOL_F;
  GLOBAL(prop_time_ran_out_global)=BOOL_F;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(slow_start_time_global)=get_check_time(MAKINUM(0));
  store_time_checkpoint_excl_(MAKINUM(0));
  predclauses=prop_uncurry_clauses(predclauses);
  extract_pred_data_to_prop(predclauses);
  if(NULL_P(GLOBAL(prop_orig_funs_global))) {
    domainsize=length(GLOBAL(prop_orig_constants_global));
    if(ZERO_P(domainsize)) {
      domainsize=MAKINUM(1);
    }
    if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
      newline(cur_output_port());
      display(const_461,cur_output_port());
      display(domainsize,cur_output_port());
      newline(cur_output_port());
    }
    GLOBAL(prop_interp_value_pairs_global)=EOL;
    make_prop_interpretation_lists(domainsize,BOOL_T,BOOL_F);
    create_prop_var_vectors(GLOBAL(prop_atom_maxnr_global));
    res=check_prop_one_interpretation(predclauses,domainsize);
    if(NFALSEP(GLOBAL(prop_time_ran_out_global))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
        newline(cur_output_port());
        display(const_462,cur_output_port());
        newline(cur_output_port());
      }
      return BOOL_F;
    }
    else
      return res;
  }
  else {
    for(domainsize__1=MAKINUM(1);!(NFALSEP(stopflag)||(NFALSEP(res)||((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))));domainsize__1=MAKINUM(1+INUM(domainsize__1))) {
      if(1) {
        newline(cur_output_port());
        display(const_463,cur_output_port());
        newline(cur_output_port());
        display(const_464,cur_output_port());
        display(domainsize__1,cur_output_port());
        newline(cur_output_port());
        display(const_465,cur_output_port());
        newline(cur_output_port());
        newline(cur_output_port());
      }
      make_prop_interpretation_lists(domainsize__1,BOOL_T,BOOL_F);
      create_prop_var_vectors(GLOBAL(prop_atom_maxnr_global));
      if(NFALSEP(GLOBAL(prop_debug_global))) {
        display(const_466,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_interp_value_pairs_global),cur_output_port());
        newline(cur_output_port());
        display(const_467,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_constants_mapping_global),cur_output_port());
        newline(cur_output_port());
        display(const_468,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_fun_mappings_global),cur_output_port());
        newline(cur_output_port());
        display(const_469,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_lit_mappings_global),cur_output_port());
        newline(cur_output_port());
        display(const_470,cur_output_port());
        newline(cur_output_port());
        display(GLOBAL(prop_atom_maxnr_global),cur_output_port());
        newline(cur_output_port());
      }
      res=check_prop_interpretations_incremental(predclauses,domainsize__1,MAKINUM(0));
    }
    if(NFALSEP(GLOBAL(prop_time_ran_out_global))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
        newline(cur_output_port());
        display(const_471,cur_output_port());
        newline(cur_output_port());
      }
      return BOOL_F;
    }
    else
      return res;
  }
}

SCM extract_pred_data_to_prop(predclauselist)
SCM predclauselist;
{
  GLOBAL(prop_orig_constants_global)=EOL;
  GLOBAL(prop_orig_funs_global)=EOL;
  GLOBAL(prop_orig_preds_global)=EOL;
  GLOBAL(prop_last_enum_value_global)=MAKINUM(0);
  for_each1(extract_pred_data_to_prop_fn614,predclauselist);
  GLOBAL(prop_orig_constants_enum_global)=map1(extract_pred_data_to_prop_fn616,GLOBAL(prop_orig_constants_global));
  GLOBAL(prop_orig_funs_enum_global)=map1(extract_pred_data_to_prop_fn617,GLOBAL(prop_orig_funs_global));
  GLOBAL(prop_orig_preds_enum_global)=map1(extract_pred_data_to_prop_fn618,GLOBAL(prop_orig_preds_global));
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    display(GLOBAL(prop_orig_constants_global),cur_output_port());
    display(GLOBAL(prop_orig_funs_global),cur_output_port());
    display(GLOBAL(prop_orig_preds_global),cur_output_port());
    display(GLOBAL(prop_orig_constants_enum_global),cur_output_port());
    display(GLOBAL(prop_orig_funs_enum_global),cur_output_port());
    return display(GLOBAL(prop_orig_preds_enum_global),cur_output_port());
  }
  else
    return UNSPECIFIED;
}

SCM extract_pred_data_to_prop_fn618(x)
SCM x;
{
  GLOBAL(prop_last_enum_value_global)=MAKINUM(1+INUM(GLOBAL(prop_last_enum_value_global)));
  if(GLOBAL(eq_pred_nr_global)==CAR(x)) {
    GLOBAL(prop_flat_eq_symb_global)=GLOBAL(prop_last_enum_value_global);
  }
  return cons(CAR(x),GLOBAL(prop_last_enum_value_global));
}

SCM extract_pred_data_to_prop_fn617(x)
SCM x;
{
  GLOBAL(prop_last_enum_value_global)=MAKINUM(1+INUM(GLOBAL(prop_last_enum_value_global)));
  return cons(CAR(x),GLOBAL(prop_last_enum_value_global));
}

SCM extract_pred_data_to_prop_fn616(x)
SCM x;
{
  GLOBAL(prop_last_enum_value_global)=MAKINUM(1+INUM(GLOBAL(prop_last_enum_value_global)));
  return cons(x,GLOBAL(prop_last_enum_value_global));
}

SCM extract_pred_data_to_prop_fn614(fullcl)
SCM fullcl;
{
  if(PAIR_P(fullcl)&&PAIR_P(CDR(fullcl)))
    return for_each1(extract_pred_data_to_prop_fn615,CDR(fullcl));
  else
    return UNSPECIFIED;
}

SCM extract_pred_data_to_prop_fn615(lit)
SCM lit;
{
  return extract_pred_data_to_prop_aux_lit(lit);
}

SCM extract_pred_data_to_prop_aux_lit(lit)
SCM lit;
{
  SCM argpart,symb,argpart__1;

  symb=EOL;
  argpart=EOL;
  symb=prop_spec_pure_unsigned_fun(CAR(lit));
  if(!(NFALSEP(assq(symb,GLOBAL(prop_orig_preds_global))))) {
    GLOBAL(prop_orig_preds_global)=cons(cons(symb,length(CDR(lit))),GLOBAL(prop_orig_preds_global));
  }
  else {
  }
  for(argpart__1=CDR(lit);!(NULL_P(argpart__1));argpart__1=CDR(argpart__1))
    extract_pred_data_to_prop_aux_fun(CAR(argpart__1));
  return UNSPECIFIED;
}

SCM extract_pred_data_to_prop_aux_fun(term)
SCM term;
{
  SCM argpart,symb,argpart__1;

  symb=EOL;
  argpart=EOL;
  if(PAIR_P(term)) {
    symb=prop_spec_pure_fun(CAR(term));
    if(!(NFALSEP(assq(symb,GLOBAL(prop_orig_funs_global))))) {
      GLOBAL(prop_orig_funs_global)=cons(cons(symb,length(CDR(term))),GLOBAL(prop_orig_funs_global));
    }
    for(argpart__1=CDR(term);!(NULL_P(argpart__1));argpart__1=CDR(argpart__1))
      extract_pred_data_to_prop_aux_fun(CAR(argpart__1));
    return UNSPECIFIED;
  }
  else
  if(NUMBER_P(term)&&(term>MAKINUM(65535))) {
    symb=term;
    if(!(NFALSEP(memq(symb,GLOBAL(prop_orig_constants_global))))) {
      GLOBAL(prop_orig_constants_global)=cons(symb,GLOBAL(prop_orig_constants_global));
      return UNSPECIFIED;
    }
    else
      return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM make_prop_interpretation_lists(domainsize,interpconstants,flattenflag)
SCM domainsize,interpconstants,flattenflag;
{
  SCM tmp,modified;

  tmp=EOL;
  modified=EOL;
  GLOBAL(prop_interp_value_pairs_global)=EOL;
  GLOBAL(prop_interp_termlist_global)=EOL;
  GLOBAL(prop_constants_mapping_global)=EOL;
  GLOBAL(prop_fun_mappings_global)=EOL;
  GLOBAL(prop_lit_mappings_global)=EOL;
  GLOBAL(prop_atom_maxnr_global)=MAKINUM(0);
  if(NFALSEP(flattenflag)) {
    modified=append2(map1_inst4(&tmp,make_prop_interpretation_lists_fn626,GLOBAL(prop_orig_preds_global)),append2(map1_inst4(&tmp,make_prop_interpretation_lists_fn627,GLOBAL(prop_orig_funs_global)),map1_inst4(&tmp,make_prop_interpretation_lists_fn628,GLOBAL(prop_orig_constants_global))));
    GLOBAL(prop_lit_mappings_global)=map1_inst2(flattenflag,domainsize,make_prop_interpretation_lists_fn629,modified);
    return UNSPECIFIED;
  }
  else {
    GLOBAL(prop_lit_mappings_global)=map1_inst2(flattenflag,domainsize,make_prop_interpretation_lists_fn630,GLOBAL(prop_orig_preds_global));
    GLOBAL(prop_fun_mappings_global)=map1_inst2(flattenflag,domainsize,make_prop_interpretation_lists_fn631,GLOBAL(prop_orig_funs_global));
    GLOBAL(prop_constants_mapping_global)=map1_inst5(&tmp,interpconstants,make_prop_interpretation_lists_fn632,GLOBAL(prop_orig_constants_global));
    return UNSPECIFIED;
  }
}

SCM make_prop_interpretation_lists_fn632(tmp,interpconstants,const_nonkeyword)
SCM *tmp;
SCM interpconstants,const_nonkeyword;
{
  *tmp=cons(const_nonkeyword,EOL);
  if(NFALSEP(interpconstants)) {
    GLOBAL(prop_interp_termlist_global)=cons(cons(const_nonkeyword,EOL),GLOBAL(prop_interp_termlist_global));
    GLOBAL(prop_interp_value_pairs_global)=cons(*tmp,GLOBAL(prop_interp_value_pairs_global));
  }
  return *tmp;
}

SCM make_prop_interpretation_lists_fn631(flattenflag,domainsize,funinfo)
SCM flattenflag,domainsize,funinfo;
{
  return cons(CAR(funinfo),make_prop_interpretation_lists_aux(CDR(funinfo),cons(CAR(funinfo),EOL),domainsize,BOOL_T,flattenflag));
}

SCM make_prop_interpretation_lists_fn630(flattenflag,domainsize,funinfo)
SCM flattenflag,domainsize,funinfo;
{
  return cons(CAR(funinfo),make_prop_interpretation_lists_aux(CDR(funinfo),cons(CAR(funinfo),EOL),domainsize,BOOL_F,flattenflag));
}

SCM make_prop_interpretation_lists_fn629(flattenflag,domainsize,funinfo)
SCM flattenflag,domainsize,funinfo;
{
  return cons(CAR(funinfo),make_prop_interpretation_lists_aux(CDR(funinfo),cons(CAR(funinfo),EOL),domainsize,BOOL_F,flattenflag));
}

SCM make_prop_interpretation_lists_fn628(tmp,x)
SCM *tmp;
SCM x;
{
  *tmp=assq(x,GLOBAL(prop_orig_constants_enum_global));
  return cons(CDR(*tmp),MAKINUM(1));
}

SCM make_prop_interpretation_lists_fn627(tmp,x)
SCM *tmp;
SCM x;
{
  *tmp=assq(CAR(x),GLOBAL(prop_orig_funs_enum_global));
  return cons(CDR(*tmp),MAKINUM(1+INUM(CDR(x))));
}

SCM make_prop_interpretation_lists_fn626(tmp,x)
SCM *tmp;
SCM x;
{
  *tmp=assq(CAR(x),GLOBAL(prop_orig_preds_enum_global));
  return cons(CDR(*tmp),CDR(x));
}

SCM make_prop_interpretation_lists_aux(argsleft,term,domainsize,addinterpflag,flattenflag)
SCM argsleft,term,domainsize,addinterpflag,flattenflag;
{
  SCM res,tmp,nr,nr__1;

  nr=MAKINUM(0);
  tmp=EOL;
  res=EOL;
  for(nr__1=MAKINUM(0);!(nr__1>=domainsize);nr__1=MAKINUM(1+INUM(nr__1)))
    if(argsleft<=MAKINUM(1)) {
      if(NFALSEP(addinterpflag)) {
        tmp=cons(nr__1,EOL);
        GLOBAL(prop_interp_value_pairs_global)=cons(tmp,GLOBAL(prop_interp_value_pairs_global));
        GLOBAL(prop_interp_termlist_global)=cons(reverse(cons(nr__1,term)),GLOBAL(prop_interp_termlist_global));
        res=cons(tmp,res);
      }
      else {
        GLOBAL(prop_atom_maxnr_global)=MAKINUM(1+INUM(GLOBAL(prop_atom_maxnr_global)));
        tmp=cons(nr__1,GLOBAL(prop_atom_maxnr_global));
        res=cons(tmp,res);
      }
    }
    else {
      tmp=cons(nr__1,make_prop_interpretation_lists_aux(MAKINUM(INUM(argsleft)-1),cons(nr__1,term),domainsize,addinterpflag,flattenflag));
      res=cons(tmp,res);
    }
  return res;
}

SCM check_prop_one_interpretation(predclauses,domainsize)
SCM predclauses,domainsize;
{
  SCM maxval,tmpnr,allchecked,evalres,pre_evalres,selectedvals,valuations,new_var1,new_var2;

  valuations=EOL;
  selectedvals=EOL;
  pre_evalres=BOOL_T;
  evalres=BOOL_T;
  allchecked=BOOL_F;
  tmpnr=MAKINUM(-1);
  maxval=MAKINUM(INUM(domainsize)-1);
  newline(cur_output_port());
  display(const_472,cur_output_port());
  display(domainsize,cur_output_port());
  newline(cur_output_port());
  GLOBAL(propclause_tree_global)=EOL;
  valuations=map1_inst4(&tmpnr,check_prop_one_interpretation_fn635,GLOBAL(prop_interp_value_pairs_global));
  insert_valuations_excl_(GLOBAL(prop_interp_value_pairs_global),valuations);
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_473,cur_output_port());
    display(valuations,cur_output_port());
  }
  if(GLOBAL(display_info_level_global)>MAKINUM(50)) {
    for(new_var1=GLOBAL(prop_interp_termlist_global),new_var2=valuations;
        PAIR_P(new_var1)&&PAIR_P(new_var2);
        new_var1=CDR(new_var1),new_var2=CDR(new_var2))
      check_prop_one_interpretation_fn636(CAR(new_var1),CAR(new_var2));
    newline(cur_output_port());
  }
  if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
    newline(cur_output_port());
    display(const_474,cur_output_port());
    newline(cur_output_port());
    display(GLOBAL(prop_interp_value_pairs_global),cur_output_port());
    newline(cur_output_port());
  }
  apply(GLOBAL(vector_fill_excl_),GLOBAL(propvar_enqued_value_global),cons(EOL,listofnull));
  pre_evalres=make_predclauses_to_propclauses(predclauses,domainsize,BOOL_F);
  if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
    newline(cur_output_port());
    if(NFALSEP(pre_evalres))
      display(const_475,cur_output_port());
    else
      display(const_476,cur_output_port());
    newline(cur_output_port());
  }
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_477,cur_output_port());
    display(pre_evalres,cur_output_port());
  }
  if(NFALSEP(pre_evalres)) {
    evalres=solve_prop_clauses(GLOBAL(propclauses_global),GLOBAL(prop_atom_maxnr_global));
  }
  if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
    newline(cur_output_port());
    if(NFALSEP(evalres)) {
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global))))
        display(const_478,cur_output_port());
    }
    else
      display(const_479,cur_output_port());
    newline(cur_output_port());
  }
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    display(const_480,cur_output_port());
    display(valuations,cur_output_port());
    newline(cur_output_port());
  }
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_481,cur_output_port());
    display(evalres,cur_output_port());
    newline(cur_output_port());
  }
  return evalres;
}

SCM check_prop_one_interpretation_fn636(x,y)
SCM x,y;
{
  display(x,cur_output_port());
  display(const_482,cur_output_port());
  display(y,cur_output_port());
  return newline(cur_output_port());
}

SCM check_prop_one_interpretation_fn635(tmpnr,x)
SCM *tmpnr;
SCM x;
{
  *tmpnr=MAKINUM(1+INUM(*tmpnr));
  return *tmpnr;
}

SCM check_prop_flatten_interpretations(predclauses,flatclauses,domainsize,extraflag)
SCM predclauses,flatclauses,domainsize,extraflag;
{
  SCM valuations,selectedvals,pre_evalres,evalres,extraclauses,allchecked,tmpnr,maxval;

  valuations=EOL;
  selectedvals=EOL;
  pre_evalres=BOOL_F;
  evalres=BOOL_F;
  extraclauses=EOL;
  allchecked=BOOL_F;
  tmpnr=MAKINUM(-1);
  maxval=MAKINUM(INUM(domainsize)-1);
  GLOBAL(propclause_tree_global)=EOL;
  if(NFALSEP(GLOBAL(global_prop_prover_global))&&(NFALSEP(GLOBAL(prop_conversion_to_file_global))&&NFALSEP(GLOBAL(sat_strategy_flag_global)))) {
    open_prop_temp_output_file(GLOBAL(prop_conversion_temp_file_name_global));
  }
  else {
    GLOBAL(prop_conversion_to_file_global)=BOOL_F;
  }
  apply(GLOBAL(vector_fill_excl_),GLOBAL(propvar_enqued_value_global),cons(EOL,listofnull));
  GLOBAL(prop_pred_maxval_pairs_global)=make_prop_pred_maxval_pairs(flatclauses,domainsize);
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_483,cur_output_port());
    newline(cur_output_port());
    display(GLOBAL(prop_pred_maxval_pairs_global),cur_output_port());
  }
  if(NFALSEP(extraflag)) {
    extraclauses=make_extra_flatten_propclauses(domainsize);
    if(0) {
      newline(cur_output_port());
      for_each1(check_prop_flatten_interpretations_fn638,extraclauses);
      newline(cur_output_port());
    }
    flatclauses=append2(extraclauses,flatclauses);
  }
  pre_evalres=make_predclauses_to_propclauses(flatclauses,domainsize,BOOL_T);
  if(1) {
    newline(cur_output_port());
    if(NFALSEP(pre_evalres))
      display(const_484,cur_output_port());
    else
      display(const_485,cur_output_port());
    newline(cur_output_port());
  }
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_486,cur_output_port());
    display(pre_evalres,cur_output_port());
  }
  if(NFALSEP(pre_evalres)) {
    GLOBAL(prop_pre_evalres_global)=BOOL_T;
    if(NFALSEP(GLOBAL(global_prop_prover_global))) {
      evalres=external_solve_prop_clauses(GLOBAL(propclauses_global),GLOBAL(prop_atom_maxnr_global),GLOBAL(one_pass_time_global));
    }
    else {
      evalres=solve_prop_clauses(GLOBAL(propclauses_global),GLOBAL(prop_atom_maxnr_global));
    }
  }
  else {
    GLOBAL(prop_pre_evalres_global)=BOOL_F;
  }
  if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
    newline(cur_output_port());
    if(NFALSEP(evalres)) {
      if(!(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global))))
        display(const_487,cur_output_port());
    }
    else
      display(const_488,cur_output_port());
    newline(cur_output_port());
  }
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_489,cur_output_port());
    display(evalres,cur_output_port());
    newline(cur_output_port());
  }
  return evalres;
}

SCM check_prop_flatten_interpretations_fn638(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM check_prop_interpretations(predclauses,domainsize,randomsize)
SCM predclauses,domainsize,randomsize;
{
  SCM new_var2,new_var1,maxval,allchecked,count,evalres,pre_evalres,selectedvals,valuations,count__1,new_var3;

  valuations=EOL;
  selectedvals=EOL;
  pre_evalres=BOOL_F;
  evalres=BOOL_F;
  count=MAKINUM(0);
  allchecked=BOOL_F;
  maxval=MAKINUM(INUM(domainsize)-1);
  GLOBAL(propclause_tree_global)=EOL;
  valuations=map1(check_prop_interpretations_fn641,GLOBAL(prop_interp_value_pairs_global));
  for(count__1=MAKINUM(0);!(NFALSEP(evalres)||(NFALSEP(allchecked)||(((randomsize>MAKINUM(0))&&(count__1>randomsize))||((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))))));count__1=MAKINUM(1+INUM(count__1))) {
    insert_valuations_excl_(GLOBAL(prop_interp_value_pairs_global),valuations);
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      newline(cur_output_port());
      display(const_490,cur_output_port());
      display(valuations,cur_output_port());
    }
    if(GLOBAL(display_info_level_global)>MAKINUM(50)) {
      display(const_491,cur_output_port());
      newline(cur_output_port());
      for(new_var1=GLOBAL(prop_interp_termlist_global),new_var2=valuations;
          PAIR_P(new_var1)&&PAIR_P(new_var2);
          new_var1=CDR(new_var1),new_var2=CDR(new_var2))
        check_prop_interpretations_fn642(CAR(new_var1),CAR(new_var2));
      newline(cur_output_port());
    }
    if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
      newline(cur_output_port());
      display(const_492,cur_output_port());
      newline(cur_output_port());
      display(GLOBAL(prop_interp_value_pairs_global),cur_output_port());
      newline(cur_output_port());
    }
    apply(GLOBAL(vector_fill_excl_),GLOBAL(propvar_enqued_value_global),cons(EOL,listofnull));
    pre_evalres=make_predclauses_to_propclauses(predclauses,domainsize,BOOL_F);
    if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
      newline(cur_output_port());
      if(NFALSEP(pre_evalres))
        display(const_493,cur_output_port());
      else
        display(const_494,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      newline(cur_output_port());
      display(const_495,cur_output_port());
      display(pre_evalres,cur_output_port());
    }
    if(NFALSEP(pre_evalres)) {
      evalres=solve_prop_clauses(GLOBAL(propclauses_global),GLOBAL(prop_atom_maxnr_global));
    }
    if(GLOBAL(display_info_level_global)>MAKINUM(70)) {
      newline(cur_output_port());
      if(NFALSEP(evalres))
        display(const_496,cur_output_port());
      else
        display(const_497,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(const_498,cur_output_port());
      display(valuations,cur_output_port());
      newline(cur_output_port());
    }
    if(randomsize>MAKINUM(0))
      valuation_list_nextrandomvalues(valuations,valuations,domainsize);
    else {
      new_var3=SBOOL(NULL_P(valuations));
      if(NFALSEP(new_var3))
        allchecked=new_var3;
      else
        allchecked=valuation_list_nextvalues(valuations,valuations,domainsize);
    }
  }
  if(!(NFALSEP(evalres))&&!(NFALSEP(allchecked))) {
    GLOBAL(prop_time_ran_out_global)=BOOL_T;
  }
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_499,cur_output_port());
    display(evalres,cur_output_port());
    newline(cur_output_port());
  }
  return evalres;
}

SCM check_prop_interpretations_fn642(x,y)
SCM x,y;
{
  display(x,cur_output_port());
  display(const_500,cur_output_port());
  display(y,cur_output_port());
  return newline(cur_output_port());
}

SCM check_prop_interpretations_fn641(x)
SCM x;
{
  return MAKINUM(0);
}

SCM check_prop_interpretations_incremental(predclauses,domainsize,randomsize)
SCM predclauses,domainsize,randomsize;
{
  SCM valuations,selectedvals,pre_evalres,evalres,count,allchecked,maxval;

  valuations=EOL;
  selectedvals=EOL;
  pre_evalres=BOOL_F;
  evalres=BOOL_F;
  count=MAKINUM(0);
  allchecked=BOOL_F;
  maxval=MAKINUM(INUM(domainsize)-1);
  GLOBAL(incremental_model_flag_global)=BOOL_F;
  GLOBAL(propclause_tree_global)=EOL;
  valuations=map1(check_prop_interpretations_incremental_fn644,GLOBAL(prop_interp_value_pairs_global));
  evalres=check_prop_interpretations_incremental_aux(EOL,valuations,predclauses,domainsize,randomsize);
  return evalres;
}

SCM check_prop_interpretations_incremental_fn644(x)
SCM x;
{
  return BOOL_F;
}

SCM check_prop_interpretations_incremental_aux(filledvaluations,unfilledvaluations,predclauses,domainsize,randomsize)
SCM filledvaluations,unfilledvaluations,predclauses,domainsize,randomsize;
{
  SCM i,partialokflag,evalres,pre_evalres,res,new_filledvaluations,new_var3,new_var4,new_var1,new_var2;

  new_filledvaluations=EOL;
  res=BOOL_F;
  pre_evalres=BOOL_F;
  evalres=BOOL_F;
  partialokflag=BOOL_F;
  if(NULL_P(unfilledvaluations)) {
    GLOBAL(propclause_tree_global)=EOL;
    insert_valuations_excl_(GLOBAL(prop_interp_value_pairs_global),filledvaluations);
    apply(GLOBAL(vector_fill_excl_),GLOBAL(propvar_enqued_value_global),cons(EOL,listofnull));
    if(GLOBAL(display_info_level_global)>MAKINUM(50)) {
      display(const_501,cur_output_port());
      newline(cur_output_port());
      for(new_var3=GLOBAL(prop_interp_termlist_global),new_var4=filledvaluations;
          PAIR_P(new_var3)&&PAIR_P(new_var4);
          new_var3=CDR(new_var3),new_var4=CDR(new_var4))
        check_prop_interpretations_incremental_aux_fn647(CAR(new_var3),CAR(new_var4));
      newline(cur_output_port());
    }
    GLOBAL(incremental_model_flag_global)=BOOL_F;
    evalres=BOOL_F;
    GLOBAL(propclauses_global)=EOL;
    pre_evalres=make_predclauses_to_propclauses(predclauses,domainsize,BOOL_F);
    if(NFALSEP(pre_evalres)) {
      evalres=solve_prop_clauses(GLOBAL(propclauses_global),GLOBAL(prop_atom_maxnr_global));
    }
    return evalres;
  }
  else
  if((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global)))
    return BOOL_F;
  else {
    res=BOOL_F;
    for(i=MAKINUM(0);!(NFALSEP(res)||(i>=domainsize));i=MAKINUM(1+INUM(i))) {
      new_filledvaluations=cons(i,filledvaluations);
      partialokflag=BOOL_F;
      if(NULL_P(CDR(unfilledvaluations))) {
        partialokflag=BOOL_T;
      }
      else {
        GLOBAL(propclause_tree_global)=EOL;
        GLOBAL(incremental_model_flag_global)=BOOL_T;
        insert_valuations_excl_(GLOBAL(prop_interp_value_pairs_global),append2(CDR(unfilledvaluations),new_filledvaluations));
        apply(GLOBAL(vector_fill_excl_),GLOBAL(propvar_enqued_value_global),cons(EOL,listofnull));
        if(GLOBAL(display_info_level_global)>MAKINUM(50)) {
          display(const_502,cur_output_port());
          newline(cur_output_port());
          for(new_var1=GLOBAL(prop_interp_termlist_global),new_var2=append2(CDR(unfilledvaluations),new_filledvaluations);
              PAIR_P(new_var1)&&PAIR_P(new_var2);
              new_var1=CDR(new_var1),new_var2=CDR(new_var2))
            check_prop_interpretations_incremental_aux_fn648(CAR(new_var1),CAR(new_var2));
          newline(cur_output_port());
        }
        evalres=BOOL_F;
        GLOBAL(propclauses_global)=EOL;
        pre_evalres=make_predclauses_to_propclauses(predclauses,domainsize,BOOL_F);
        if(NFALSEP(pre_evalres))
          display(const_503,cur_output_port());
        else
          display(const_504,cur_output_port());
        if(NFALSEP(pre_evalres)) {
          evalres=solve_prop_clauses(GLOBAL(propclauses_global),GLOBAL(prop_atom_maxnr_global));
        }
        if(NFALSEP(pre_evalres)) {
          if(NFALSEP(evalres))
            display(const_505,cur_output_port());
          else
            display(const_506,cur_output_port());
        }
        GLOBAL(incremental_model_flag_global)=BOOL_F;
        partialokflag=evalres;
      }
      if(NFALSEP(partialokflag)) {
        res=check_prop_interpretations_incremental_aux(new_filledvaluations,CDR(unfilledvaluations),predclauses,domainsize,randomsize);
      }
    }
    return res;
  }
}

SCM check_prop_interpretations_incremental_aux_fn648(x,y)
SCM x,y;
{
  display(x,cur_output_port());
  display(const_507,cur_output_port());
  display(y,cur_output_port());
  return newline(cur_output_port());
}

SCM check_prop_interpretations_incremental_aux_fn647(x,y)
SCM x,y;
{
  display(x,cur_output_port());
  display(const_508,cur_output_port());
  display(y,cur_output_port());
  return newline(cur_output_port());
}

SCM valuation_list_nextvalues(valuationlist,origvaluations,domainsize)
SCM valuationlist,origvaluations,domainsize;
{
tailrecursion:
  if(PAIR_P(valuationlist)&&((PAIR_P(origvaluations)&&(CAR(valuationlist)>max_of_two(max_of_list(CDR(valuationlist)),max_of_corr_fun_args(valuationlist,origvaluations))))||(INUM(CAR(valuationlist))>=(INUM(domainsize)-1)))) {
    if(NULL_P(CDR(valuationlist)))
      return BOOL_T;
    else {
      SET_CAR(valuationlist,MAKINUM(0));
      valuationlist=CDR(valuationlist);
      goto tailrecursion;
    }
  }
  else {
    SET_CAR(valuationlist,MAKINUM(1+INUM(CAR(valuationlist))));
    return BOOL_F;
  }
}

SCM max_of_two(one,two)
SCM one,two;
{
  if(one>two)
    return one;
  else
    return two;
}

SCM max_of_list(lst)
SCM lst;
{
  SCM res,part;

  res=MAKINUM(0);
  for(part=lst;!(NULL_P(part));part=CDR(part))
    if(CAR(lst)>res) {
      res=CAR(lst);
    }
  return res;
}

SCM max_of_corr_fun_args(valuationlist,origvaluationlist)
SCM valuationlist,origvaluationlist;
{
  SCM term;

  term=get_valuationlistpos_term(valuationlist,origvaluationlist);
  if(PAIR_P(term))
    return max_of_list(CDR(term));
  else
    return term;
}

SCM get_valuationlistpos_term(valuationlist,origvaluationlist)
SCM valuationlist,origvaluationlist;
{
  SCM res,part1,part2;

  res=EOL;
  for(part1=origvaluationlist,part2=GLOBAL(prop_interp_termlist_global);
      !(NULL_P(part1)||(part1==valuationlist));
      part1=CDR(part1),part2=CDR(part2)) ;
  if(NULL_P(part1))
    return MAKINUM(999999);
  else
    return CAR(part2);
}

SCM insert_valuations_excl_(value_pairs,valuations)
SCM value_pairs,valuations;
{
  SCM new_var1,new_var2;

  for(new_var1=value_pairs,new_var2=valuations;
      PAIR_P(new_var1)&&PAIR_P(new_var2);
      new_var1=CDR(new_var1),new_var2=CDR(new_var2))
    insert_valuations_excl__fn650(CAR(new_var1),CAR(new_var2));
  return UNSPECIFIED;
}

SCM insert_valuations_excl__fn650(x,y)
SCM x,y;
{
  SET_CDR(x,y);
  return UNSPECIFIED;
}

SCM valuation_list_nextrandomvalues(valuationlist,origvaluations,domainsize)
SCM valuationlist,origvaluations,domainsize;
{
  SCM tmp,part;

  tmp=MAKINUM(0);
  for(part=valuationlist;!(NULL_P(part));part=CDR(part)) {
    tmp=random_random(domainsize,EOL);
    if(!(INTEGER_P(tmp))||((tmp<MAKINUM(0))||(tmp>=domainsize))) {
      display(const_509,cur_output_port());
      display(tmp,cur_output_port());
      newline(cur_output_port());
      tmp=MAKINUM(0);
    }
    SET_CAR(part,tmp);
  }
  return UNSPECIFIED;
}

SCM make_predclauses_to_propclauses(predclauses,domainsize,flatflag)
SCM predclauses,domainsize,flatflag;
{
  SCM predclausespart,unsatisfiable,tmp,predclausespart__1;

  tmp=EOL;
  unsatisfiable=BOOL_F;
  predclausespart=EOL;
  GLOBAL(prop_clauses_generated_global)=MAKINUM(0);
  GLOBAL(propclauses_global)=EOL;
  GLOBAL(propclause_tree_global)=EOL;
  if(NFALSEP(flatflag)) {
    predclauses=sort_predclauses_for_propconversion(predclauses);
  }
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    display(const_510,cur_output_port());
    newline(cur_output_port());
    newline(cur_output_port());
    for_each1(make_predclauses_to_propclauses_fn652,predclauses);
    newline(cur_output_port());
    display(const_511,cur_output_port());
    newline(cur_output_port());
  }
  for(predclausespart__1=predclauses;!(NULL_P(predclausespart__1)||NFALSEP(unsatisfiable));predclausespart__1=CDR(predclausespart__1)) {
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(CAR(predclausespart__1),cur_output_port());
      newline(cur_output_port());
    }
    if(PAIR_P(CAR(predclausespart__1))&&PAIR_P(CDR(CAR(predclausespart__1)))) {
      tmp=make_predclause_to_propclauses(CAR(predclausespart__1),domainsize,flatflag);
      if(NFALSEP(GLOBAL(prop_debug_global))) {
        newline(cur_output_port());
        display(const_512,cur_output_port());
        display(tmp,cur_output_port());
        newline(cur_output_port());
      }
      if(NFALSEP(tmp)) {
        unsatisfiable=BOOL_T;
      }
    }
  }
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_513,cur_output_port());
    display(unsatisfiable,cur_output_port());
    newline(cur_output_port());
  }
  return NOT(unsatisfiable);
}

SCM make_predclauses_to_propclauses_fn652(x)
SCM x;
{
  newline(cur_output_port());
  return display(x,cur_output_port());
}

SCM sort_predclauses_for_propconversion(predclauses)
SCM predclauses;
{
  SCM new_var1,res,res5,res4,res3,res2,res1,res0,cl,part,new_var2;

  cl=EOL;
  res0=EOL;
  res1=EOL;
  res2=EOL;
  res3=EOL;
  res4=EOL;
  res5=EOL;
  res=EOL;
  for(part=predclauses;!(NULL_P(part));part=CDR(part)) {
    cl=CAR(part);
    new_var1=NOT(SBOOL(PAIR_P(cl)));
    if(NFALSEP(new_var1)) ;
    else {
      new_var2=NOT(SBOOL(PAIR_P(CDR(cl))));
      if(NFALSEP(new_var2)) ;
      else
      if(NULL_P(CDR(CDR(cl)))) {
        if(ZERO_P(MAKINUM(65536)&CAR(CAR(CDR(cl))))) {
          res1=cons(cl,res1);
        }
        else {
          res0=cons(cl,res0);
        }
      }
      else
      if(NULL_P(CDR(CDR(CDR(cl))))) {
        res2=cons(cl,res2);
      }
      else
      if(NULL_P(CDR(CDR(CDR(CDR(cl)))))) {
        res3=cons(cl,res3);
      }
      else
      if(NULL_P(CDR(CDR(CDR(CDR(CDR(cl))))))) {
        res4=cons(cl,res4);
      }
      else {
        res5=cons(cl,res5);
      }
    }
  }
  return append2(res0,append2(res1,append2(res2,append2(res3,append2(res4,res5)))));
}

SCM make_predclause_to_propclauses(fullpredclause,domainsize,flatflag)
SCM fullpredclause,domainsize,flatflag;
{
  SCM new_var1,varlimits,clausepart,tautology,tmp,unsatisfiable,allchecked,maxvar,varvaluations,varslist,poscurproplit,curproplit,litvalue,curlit,propclauseneg,propclausepos,clausesgenerated,limitlocalclausesnr,info,clausepart__1,new_var2;

  info=CAR(fullpredclause);
  limitlocalclausesnr=BOOL_F;
  clausesgenerated=MAKINUM(0);
  propclausepos=EOL;
  propclauseneg=EOL;
  curlit=EOL;
  litvalue=EOL;
  curproplit=EOL;
  poscurproplit=EOL;
  if(NFALSEP(flatflag))
    varslist=get_fullclause_varslist(fullpredclause);
  else
    varslist=get_fullclause_varslist(fullpredclause);
  varvaluations=EOL;
  maxvar=MAKINUM(INUM(domainsize)-1);
  allchecked=BOOL_F;
  unsatisfiable=BOOL_F;
  tmp=EOL;
  tautology=BOOL_F;
  clausepart=EOL;
  varlimits=EOL;
  if(NFALSEP(GLOBAL(prop_clauses_generation_limited_flag_global))||(NFALSEP(GLOBAL(prop_clauses_generation_limit_global))&&(GLOBAL(prop_clauses_generated_global)>=GLOBAL(prop_clauses_generation_limit_global)))) {
    limitlocalclausesnr=MAKINUM(1000);
    GLOBAL(prop_clauses_generation_limited_flag_global)=BOOL_T;
  }
  else {
    limitlocalclausesnr=BOOL_F;
  }
  if(!(NULL_P(varslist))) {
    varvaluations=map1(make_predclause_to_propclauses_fn654,varslist);
  }
  for(;!(NFALSEP(unsatisfiable)||(NFALSEP(allchecked)||((NFALSEP(limitlocalclausesnr)&&(clausesgenerated>limitlocalclausesnr))||((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))))));) {
    propclausepos=EOL;
    propclauseneg=EOL;
    varlimits=EOL;
    varlimits=create_prop_flat_varlimits(varslist,fullpredclause,domainsize);
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      newline(cur_output_port());
      display(const_514,cur_output_port());
      newline(cur_output_port());
      display(varslist,cur_output_port());
      newline(cur_output_port());
      display(const_515,cur_output_port());
      newline(cur_output_port());
      display(varvaluations,cur_output_port());
      newline(cur_output_port());
      display(const_516,cur_output_port());
      newline(cur_output_port());
      display(varlimits,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP((NULL_P(varlimits) ? (set_pred_var_values(varslist,varvaluations),BOOL_T) : set_pred_var_values_limited(varslist,varvaluations,varlimits)))) {
      tautology=BOOL_F;
      for(clausepart__1=CDR(fullpredclause);!(NULL_P(clausepart__1)||(NFALSEP(tautology)||NFALSEP(unsatisfiable)));clausepart__1=CDR(clausepart__1)) {
        curlit=CAR(clausepart__1);
        if(NFALSEP(GLOBAL(incremental_model_flag_global))) {
          curproplit=make_pred_to_proplit_incremental(curlit);
        }
        else
        if(NFALSEP(flatflag)) {
          curproplit=make_flat_pred_to_proplit(curlit);
        }
        else {
          curproplit=make_pred_to_proplit(curlit);
        }
        if(NFALSEP(GLOBAL(prop_debug_global))) {
          newline(cur_output_port());
          display(const_517,cur_output_port());
          display(curproplit,cur_output_port());
          newline(cur_output_port());
          display(const_518,cur_output_port());
          if(NFALSEP(curproplit)&&INTEGER_P(curproplit))
            display(VECTOR_REF(GLOBAL(propvar_enqued_value_global),((curproplit<MAKINUM(0)) ? MAKINUM(0-INUM(curproplit)) : curproplit)),cur_output_port());
        }
        if(curproplit==BOOL_T) {
          tautology=BOOL_T;
        }
        else {
          new_var1=SBOOL(curproplit==BOOL_F);
          if(NFALSEP(new_var1)) ;
          else
          if(NFALSEP((((curproplit<MAKINUM(0)) ? (poscurproplit=MAKINUM(0-INUM(curproplit)),UNSPECIFIED) : (poscurproplit=curproplit,UNSPECIFIED)),litvalue=VECTOR_REF(GLOBAL(propvar_enqued_value_global),poscurproplit),UNSPECIFIED,SBOOL(!(NULL_P(litvalue)))))) {
            if(BOOL_T==litvalue) {
              if(curproplit>=MAKINUM(0)) {
                tautology=BOOL_T;
              }
            }
            else
            if(curproplit<MAKINUM(0)) {
              tautology=BOOL_T;
            }
          }
          else
          if(curproplit<MAKINUM(0)) {
            tmp=poscurproplit;
            if(NFALSEP(memq(tmp,propclausepos))) {
              tautology=BOOL_T;
            }
            else
            if(!(NFALSEP(memq(tmp,propclauseneg)))) {
              propclauseneg=cons(tmp,propclauseneg);
            }
          }
          else
          if(NFALSEP(memq(curproplit,propclauseneg))) {
            tautology=BOOL_T;
          }
          else
          if(!(NFALSEP(memq(curproplit,propclausepos)))) {
            propclausepos=cons(curproplit,propclausepos);
          }
        }
      }
      if(!(NFALSEP(tautology))&&(NULL_P(propclauseneg)&&NULL_P(propclausepos))) {
        unsatisfiable=BOOL_T;
      }
      if(!(NFALSEP(unsatisfiable))) {
        if(!(NFALSEP(tautology))) {
          clausesgenerated=MAKINUM(1+INUM(clausesgenerated));
          GLOBAL(prop_clauses_generated_global)=MAKINUM(1+INUM(GLOBAL(prop_clauses_generated_global)));
          tmp=add_new_prop_clause(cons(propclauseneg,propclausepos));
        }
        if(!(NFALSEP(tmp))) {
          unsatisfiable=BOOL_T;
        }
      }
    }
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      newline(cur_output_port());
      display(const_519,cur_output_port());
      display(maxvar,cur_output_port());
      newline(cur_output_port());
      display(const_520,cur_output_port());
      display(varvaluations,cur_output_port());
      newline(cur_output_port());
    }
    new_var2=SBOOL(NULL_P(varvaluations));
    if(NFALSEP(new_var2))
      allchecked=new_var2;
    else
      allchecked=valuation_list_nextvalues(varvaluations,BOOL_T,domainsize);
  }
  if(NFALSEP(limitlocalclausesnr)&&(clausesgenerated>limitlocalclausesnr)) {
    GLOBAL(prop_clauses_generation_limited_flag_global)=BOOL_T;
  }
  if(!(NFALSEP(unsatisfiable))&&!(NFALSEP(allchecked))) {
    GLOBAL(prop_time_ran_out_global)=BOOL_T;
  }
  return unsatisfiable;
}

SCM make_predclause_to_propclauses_fn654(x)
SCM x;
{
  return MAKINUM(0);
}

SCM make_prop_pred_maxval_pairs(flatclauses,domainsize)
SCM flatclauses,domainsize;
{
  SCM res,cnstpart,maxel;

  res=EOL;
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_521,cur_output_port());
    newline(cur_output_port());
    display(const_522,cur_output_port());
    newline(cur_output_port());
    display(flatclauses,cur_output_port());
    newline(cur_output_port());
    display(const_523,cur_output_port());
    newline(cur_output_port());
    display(domainsize,cur_output_port());
    newline(cur_output_port());
    display(const_524,cur_output_port());
    newline(cur_output_port());
    display(GLOBAL(prop_orig_constants_enum_global),cur_output_port());
    newline(cur_output_port());
    display(const_525,cur_output_port());
    newline(cur_output_port());
    display(GLOBAL(prop_orig_funs_enum_global),cur_output_port());
    newline(cur_output_port());
  }
  for(cnstpart=GLOBAL(prop_orig_constants_enum_global),maxel=MAKINUM(0);
      !((maxel>=domainsize)||NULL_P(cnstpart));
      cnstpart=CDR(cnstpart),maxel=MAKINUM(1+INUM(maxel))) {
    res=cons(cons(CDR(CAR(cnstpart)),maxel),res);
  }
  return res;
}

SCM create_prop_flat_varlimits(varslist,fullpredclause,domainsize)
SCM varslist,fullpredclause,domainsize;
{
  SCM varspart,res,predabs,tmp,foundoneflag,maxel,foundflag,clpart;

  res=EOL;
  predabs=MAKINUM(0);
  tmp=BOOL_F;
  foundoneflag=BOOL_F;
  maxel=MAKINUM(INUM(domainsize)-1);
  foundflag=BOOL_F;
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_526,cur_output_port());
    newline(cur_output_port());
    display(const_527,cur_output_port());
    newline(cur_output_port());
    display(varslist,cur_output_port());
    newline(cur_output_port());
    display(const_528,cur_output_port());
    newline(cur_output_port());
    display(fullpredclause,cur_output_port());
    newline(cur_output_port());
    display(const_529,cur_output_port());
    newline(cur_output_port());
    display(domainsize,cur_output_port());
    newline(cur_output_port());
  }
  for(varspart=varslist;!(NULL_P(varspart));varspart=CDR(varspart)) {
    foundoneflag=BOOL_F;
    for(clpart=CDR(fullpredclause);!(NULL_P(clpart)||NFALSEP(foundoneflag));clpart=CDR(clpart))
      if(CAR(varspart)==CAR(CDR(CAR(clpart)))) {
        if(CAR(CAR(clpart))<MAKINUM(0)) {
          predabs=MAKINUM(0-INUM(CAR(CAR(clpart))));
        }
        else {
          predabs=CAR(CAR(clpart));
        }
        tmp=assq(predabs,GLOBAL(prop_pred_maxval_pairs_global));
        if(NFALSEP(tmp)&&(CDR(tmp)<maxel)) {
          foundoneflag=BOOL_T;
          foundflag=BOOL_T;
          res=cons(CDR(tmp),res);
        }
      }
    if(!(NFALSEP(foundoneflag))) {
      res=cons(maxel,res);
    }
  }
  if(NFALSEP(foundflag)) {
    res=reverse(res);
  }
  else {
    res=EOL;
  }
  return res;
}

SCM make_extra_flatten_propclauses(domainsize)
SCM domainsize;
{
  SCM u,x,funinfolist,maxel,args,var,funinfo,closedaxiom,wholeresult,res,tmp,lstpart,y,v;

  tmp=EOL;
  res=EOL;
  wholeresult=EOL;
  closedaxiom=EOL;
  funinfo=EOL;
  var=MAKINUM(0);
  args=EOL;
  maxel=EOL;
  funinfolist=EOL;
  funinfolist=append2(map1_inst4(&tmp,make_extra_flatten_propclauses_fn658,GLOBAL(prop_orig_funs_global)),map1_inst4(&tmp,make_extra_flatten_propclauses_fn659,GLOBAL(prop_orig_constants_global)));
  GLOBAL(prop_funinfolist_global)=funinfolist;
  for(lstpart=funinfolist;!(NULL_P(lstpart));lstpart=CDR(lstpart)) {
    funinfo=CAR(lstpart);
    args=EOL;
    for(x=MAKINUM(1);!(x>=CDR(funinfo));x=MAKINUM(1+INUM(x))) {
      args=cons(x,args);
    }
    tmp=assq(CAR(funinfo),GLOBAL(prop_pred_maxval_pairs_global));
    if(NFALSEP(tmp)&&(INUM(CDR(tmp))<(INUM(domainsize)-1))) {
      maxel=CDR(tmp);
    }
    else {
      maxel=MAKINUM(INUM(domainsize)-1);
    }
    closedaxiom=EOL;
    for(y=MAKINUM(0);!(y>maxel);y=MAKINUM(1+INUM(y))) {
      tmp=cons(CAR(funinfo),cons(MAKINUM(INUM(y)+100000),args));
      closedaxiom=cons(tmp,closedaxiom);
    }
    closedaxiom=cons(EOL,closedaxiom);
    if(!(NULL_P(closedaxiom))) {
      wholeresult=cons(closedaxiom,wholeresult);
    }
    for(u=MAKINUM(0);!(u>=domainsize);u=MAKINUM(1+INUM(u))) {
      res=EOL;
      for(v=MAKINUM(0);!(v>=u);v=MAKINUM(1+INUM(v))) {
        res=cons(EOL,cons(cons(MAKINUM(0-INUM(CAR(funinfo))),cons(MAKINUM(INUM(v)+100000),args)),cons(cons(MAKINUM(0-INUM(CAR(funinfo))),cons(MAKINUM(INUM(u)+100000),args)),EOL)));
        if(!(NULL_P(res))) {
          wholeresult=cons(res,wholeresult);
        }
      }
    }
  }
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_530,cur_output_port());
    newline(cur_output_port());
    for_each1(make_extra_flatten_propclauses_fn660,wholeresult);
    newline(cur_output_port());
  }
  return wholeresult;
}

SCM make_extra_flatten_propclauses_fn660(x)
SCM x;
{
  display(x,cur_output_port());
  return newline(cur_output_port());
}

SCM make_extra_flatten_propclauses_fn659(tmp,x)
SCM *tmp;
SCM x;
{
  *tmp=assq(x,GLOBAL(prop_orig_constants_enum_global));
  return cons(CDR(*tmp),MAKINUM(1));
}

SCM make_extra_flatten_propclauses_fn658(tmp,x)
SCM *tmp;
SCM x;
{
  *tmp=assq(CAR(x),GLOBAL(prop_orig_funs_enum_global));
  return cons(CDR(*tmp),MAKINUM(1+INUM(CDR(x))));
}

SCM make_nofuns_equality_axioms()
{
  SCM x,funinfolist,maxarg,args,var,funinfo,closedaxiom,wholeresult,res,tmp,lstpart,x__1;

  tmp=EOL;
  res=EOL;
  wholeresult=EOL;
  closedaxiom=EOL;
  funinfo=EOL;
  var=MAKINUM(0);
  args=EOL;
  maxarg=MAKINUM(0);
  funinfolist=EOL;
  funinfolist=map1_inst4(&tmp,make_nofuns_equality_axioms_fn662,GLOBAL(prop_orig_preds_global));
  wholeresult=cons(cons(EOL,cons(cons(GLOBAL(prop_flat_eq_symb_global),cons(MAKINUM(1),cons(MAKINUM(1),EOL))),EOL)),wholeresult);
  wholeresult=cons(cons(EOL,cons(cons(MAKINUM(0-INUM(GLOBAL(prop_flat_eq_symb_global))),cons(MAKINUM(1),cons(MAKINUM(2),EOL))),cons(cons(GLOBAL(prop_flat_eq_symb_global),cons(MAKINUM(2),cons(MAKINUM(1),EOL))),EOL))),wholeresult);
  wholeresult=cons(cons(EOL,cons(cons(MAKINUM(0-INUM(GLOBAL(prop_flat_eq_symb_global))),cons(MAKINUM(1),cons(MAKINUM(2),EOL))),cons(cons(MAKINUM(0-INUM(GLOBAL(prop_flat_eq_symb_global))),cons(MAKINUM(2),cons(MAKINUM(3),EOL))),cons(cons(GLOBAL(prop_flat_eq_symb_global),cons(MAKINUM(1),cons(MAKINUM(3),EOL))),EOL)))),wholeresult);
  for(lstpart=funinfolist;!(NULL_P(lstpart));lstpart=CDR(lstpart)) {
    funinfo=CAR(lstpart);
    if(!(GLOBAL(prop_flat_eq_symb_global)==CAR(funinfo))) {
      args=EOL;
      for(x=MAKINUM(1);!(x>CDR(funinfo));x=MAKINUM(1+INUM(x))) {
        args=cons(x,args);
      }
      maxarg=x;
      for(x__1=MAKINUM(1);!(x__1>CDR(funinfo));x__1=MAKINUM(1+INUM(x__1))) {
        wholeresult=cons(cons(EOL,cons(cons(MAKINUM(0-INUM(GLOBAL(prop_flat_eq_symb_global))),cons(maxarg,cons(MAKINUM(1+INUM(maxarg)),EOL))),cons(cons(MAKINUM(0-INUM(CAR(funinfo))),replace_one_eq(x__1,maxarg,args)),cons(cons(CAR(funinfo),replace_one_eq(x__1,MAKINUM(1+INUM(maxarg)),args)),EOL)))),wholeresult);
      }
    }
  }
  return wholeresult;
}

SCM make_nofuns_equality_axioms_fn662(tmp,x)
SCM *tmp;
SCM x;
{
  *tmp=assq(CAR(x),GLOBAL(prop_orig_preds_enum_global));
  return cons(CDR(*tmp),CDR(x));
}

SCM add_prop_lit_to_clause(lit,clause)
SCM lit,clause;
{
  if(NULL_P(clause))
    return cons(lit,EOL);
  else
  if(lit<=CAR(clause))
    return cons(lit,clause);
  else
    return cons(CAR(clause),add_prop_lit_to_clause(lit,CDR(clause)));
}

SCM add_new_prop_clause(propclause)
SCM propclause;
{
  SCM tmp;

  tmp=BOOL_T;
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_531,cur_output_port());
    display(propclause,cur_output_port());
  }
  if(NULL_P(CAR(propclause))&&NULL_P(CDR(CDR(propclause)))) {
    VECTOR_SET(GLOBAL(propvar_enqued_value_global),CAR(CDR(propclause)),BOOL_T);
  }
  else
  if(NULL_P(CDR(propclause))&&NULL_P(CDR(CAR(propclause)))) {
    VECTOR_SET(GLOBAL(propvar_enqued_value_global),CAR(CAR(propclause)),BOOL_F);
  }
  if(NFALSEP(GLOBAL(prop_conversion_to_file_global))&&NFALSEP(GLOBAL(sat_strategy_flag_global))) {
    output_prop_clause(propclause,GLOBAL(prop_conversion_temp_file_port_global));
  }
  else {
    GLOBAL(propclauses_global)=cons(propclause,GLOBAL(propclauses_global));
  }
  return BOOL_T;
}

SCM check_exist_propclause(neglits,poslits)
SCM neglits,poslits;
{
  SCM found,part;

  found=BOOL_F;
  for(part=GLOBAL(propclauses_global);!(NFALSEP(found)||NULL_P(part));part=CDR(part))
    if(NFALSEP(sub_ordered_list_pred_(CAR(CAR(part)),neglits))&&NFALSEP(sub_ordered_list_pred_(CDR(CAR(part)),poslits))) {
      found=BOOL_T;
    }
  return NOT(found);
}

SCM sub_ordered_list_pred_(slist,glist)
SCM slist,glist;
{
  SCM new_var1,new_var2;

tailrecursion:
  new_var1=SBOOL(NULL_P(slist));
  if(NFALSEP(new_var1))
    return new_var1;
  else
  if(!(NULL_P(glist))) {
    if(CAR(slist)==CAR(glist))
      new_var2=sub_ordered_list_pred_(CDR(slist),CDR(glist));
    else
      new_var2=BOOL_F;
    if(NFALSEP(new_var2))
      return new_var2;
    else
    if(CAR(slist)>CAR(glist)) {
      glist=CDR(glist);
      goto tailrecursion;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM get_fullclause_varslist(fullpredclause)
SCM fullpredclause;
{
  GLOBAL(tmp_varlist_global)=EOL;
  for_each1(get_fullclause_varslist_fn664,CDR(fullpredclause));
  return GLOBAL(tmp_varlist_global);
}

SCM get_fullclause_varslist_fn664(lit)
SCM lit;
{
  return get_fullclause_varslist_aux_excl_(lit);
}

SCM get_fullclause_varslist_aux_excl_(term)
SCM term;
{
  SCM part;

  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_532,cur_output_port());
    display(term,cur_output_port());
    newline(cur_output_port());
    display(const_533,cur_output_port());
    display(SBOOL(ZERO_P(MAKINUM(65536)&CAR(term))),cur_output_port());
    newline(cur_output_port());
  }
  for(part=CDR(term);!(NULL_P(part));part=CDR(part)) {
    term=CAR(part);
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      newline(cur_output_port());
      display(const_534,cur_output_port());
      display(term,cur_output_port());
      newline(cur_output_port());
      display(const_535,cur_output_port());
      if(PAIR_P(term))
        display(SBOOL(ZERO_P(MAKINUM(65536)&CAR(term))),cur_output_port());
      newline(cur_output_port());
    }
    if(NUMBER_P(term)) {
      if(MAKINUM(65535)>term) {
        if(!(NFALSEP(memq(MAKINUM(8191)&term,GLOBAL(tmp_varlist_global))))) {
          GLOBAL(tmp_varlist_global)=cons(MAKINUM(8191)&term,GLOBAL(tmp_varlist_global));
        }
      }
    }
    else
    if(1)
      get_fullclause_varslist_aux_excl_(term);
  }
  return UNSPECIFIED;
}

SCM set_pred_var_values(varslist,varvaluations)
SCM varslist,varvaluations;
{
  SCM new_var1,new_var2;

  for(new_var1=varslist,new_var2=varvaluations;
      PAIR_P(new_var1)&&PAIR_P(new_var2);
      new_var1=CDR(new_var1),new_var2=CDR(new_var2))
    set_pred_var_values_fn666(CAR(new_var1),CAR(new_var2));
  return UNSPECIFIED;
}

SCM set_pred_var_values_fn666(var,val)
SCM var,val;
{
  STBL_VECTOR_SET(_star_var_val_table_star__velts0,var,val);
  return UNSPECIFIED;
}

SCM set_pred_var_values_limited(varslist,varvaluations,varlimits)
SCM varslist,varvaluations,varlimits;
{
  SCM part1,part2,part3;

  for(part1=varslist,part2=varvaluations,part3=varlimits;
      !(NULL_P(part2)||(CAR(part2)>CAR(part3)));
      part1=CDR(part1),part2=CDR(part2),part3=CDR(part3)) {
    STBL_VECTOR_SET(_star_var_val_table_star__velts0,CAR(part1),CAR(part2));
  }
  if(NULL_P(part2))
    return BOOL_T;
  else
    return BOOL_F;
}

SCM make_pred_to_proplit(curlit)
SCM curlit;
{
  SCM negflag,purefun,arg1,arg2,treepart,res;

  negflag=NOT(SBOOL(ZERO_P(MAKINUM(268435456)&CAR(curlit))));
  purefun=prop_spec_pure_unsigned_fun(CAR(curlit));
  arg1=EOL;
  arg2=EOL;
  treepart=EOL;
  res=EOL;
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    display(const_536,cur_output_port());
    display(curlit,cur_output_port());
    newline(cur_output_port());
    display(const_537,cur_output_port());
    display(GLOBAL(prop_lit_mappings_global),cur_output_port());
    newline(cur_output_port());
  }
  if(GLOBAL(eq_pred_nr_global)==purefun) {
    if(get_pred_term_interpvalue(CAR(CDR(curlit)))==get_pred_term_interpvalue(CAR(CDR(CDR(curlit))))) {
      if(NFALSEP(negflag)) {
        res=BOOL_F;
      }
      else {
        res=BOOL_T;
      }
    }
    else
    if(NFALSEP(negflag)) {
      res=BOOL_T;
    }
    else {
      res=BOOL_F;
    }
    BOOL_F;
  }
  else {
    treepart=assq(purefun,GLOBAL(prop_lit_mappings_global));
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(const_538,cur_output_port());
      display(treepart,cur_output_port());
      newline(cur_output_port());
    }
    if(!(NFALSEP(treepart))) {
      display(const_539,cur_output_port());
      quit(1);
    }
    treepart=make_pred_to_proplit_aux(CDR(curlit),CDR(treepart));
    if(NFALSEP(negflag)) {
      res=MAKINUM(0-INUM(treepart));
    }
    else {
      res=treepart;
    }
  }
  return res;
}

SCM make_pred_to_proplit_incremental(curlit)
SCM curlit;
{
  SCM negflag,purefun,arg1,arg2,treepart,res;

  negflag=NOT(SBOOL(ZERO_P(MAKINUM(268435456)&CAR(curlit))));
  purefun=prop_spec_pure_unsigned_fun(CAR(curlit));
  arg1=EOL;
  arg2=EOL;
  treepart=EOL;
  res=EOL;
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_540,cur_output_port());
    display(curlit,cur_output_port());
    newline(cur_output_port());
  }
  if(GLOBAL(eq_pred_nr_global)==purefun) {
    arg1=get_pred_term_interpvalue_incremental(CAR(CDR(curlit)));
    arg2=get_pred_term_interpvalue_incremental(CAR(CDR(CDR(curlit))));
    if(!(INTEGER_P(arg1))) {
      res=BOOL_T;
    }
    else
    if(!(INTEGER_P(arg2))) {
      res=BOOL_T;
    }
    else
    if(arg1==arg2) {
      if(NFALSEP(negflag)) {
        res=BOOL_F;
      }
      else {
        res=BOOL_T;
      }
    }
    else
    if(NFALSEP(negflag)) {
      res=BOOL_T;
    }
    else {
      res=BOOL_F;
    }
    BOOL_F;
  }
  else {
    treepart=assq(purefun,GLOBAL(prop_lit_mappings_global));
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(const_541,cur_output_port());
      display(treepart,cur_output_port());
      newline(cur_output_port());
    }
    if(!(NFALSEP(treepart))) {
      display(const_542,cur_output_port());
      quit(1);
    }
    treepart=make_pred_to_proplit_incremental_aux(CDR(curlit),CDR(treepart));
    if(BOOL_T==treepart) {
      res=BOOL_T;
    }
    else
    if(NFALSEP(negflag)) {
      res=MAKINUM(0-INUM(treepart));
    }
    else {
      res=treepart;
    }
  }
  return res;
}

SCM make_flat_pred_to_proplit(curlit)
SCM curlit;
{
  SCM negflag,purefun,arg1,arg2,treepart,res;

  negflag=SBOOL(CAR(curlit)<MAKINUM(0));
  if(NFALSEP(negflag))
    purefun=MAKINUM(0-INUM(CAR(curlit)));
  else
    purefun=CAR(curlit);
  arg1=EOL;
  arg2=EOL;
  treepart=EOL;
  res=EOL;
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_543,cur_output_port());
    newline(cur_output_port());
    display(const_544,cur_output_port());
    display(curlit,cur_output_port());
    newline(cur_output_port());
    display(const_545,cur_output_port());
    display(GLOBAL(prop_flat_eq_symb_global),cur_output_port());
    newline(cur_output_port());
  }
  if((GLOBAL(prop_flat_eq_symb_global)==purefun)&&!(NFALSEP(GLOBAL(mace_nofuns_model_strat_global)))) {
    if(get_pred_term_interpvalue(CAR(CDR(curlit)))==get_pred_term_interpvalue(CAR(CDR(CDR(curlit))))) {
      if(NFALSEP(negflag)) {
        res=BOOL_F;
      }
      else {
        res=BOOL_T;
      }
    }
    else
    if(NFALSEP(negflag)) {
      res=BOOL_T;
    }
    else {
      res=BOOL_F;
    }
  }
  else {
    treepart=assq(purefun,GLOBAL(prop_lit_mappings_global));
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(const_546,cur_output_port());
      display(treepart,cur_output_port());
      newline(cur_output_port());
    }
    if(!(NFALSEP(treepart))) {
      display(const_547,cur_output_port());
      quit(1);
    }
    treepart=make_flat_pred_to_proplit_aux(CDR(curlit),CDR(treepart));
    if(NFALSEP(negflag)) {
      res=MAKINUM(0-INUM(treepart));
    }
    else {
      res=treepart;
    }
  }
  return res;
}

SCM make_pred_to_proplit_aux(funargs,treepart)
SCM funargs,treepart;
{
  SCM argval,tmp,argspart;

  tmp=EOL;
  argval=EOL;
  for(argspart=funargs;!(NULL_P(argspart));argspart=CDR(argspart)) {
    argval=get_pred_term_interpvalue(CAR(argspart));
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(const_548,cur_output_port());
      display(funargs,cur_output_port());
      newline(cur_output_port());
      display(const_549,cur_output_port());
      display(argval,cur_output_port());
      newline(cur_output_port());
    }
    tmp=assq(argval,treepart);
    if(!(NFALSEP(tmp))) {
      display(const_550,cur_output_port());
      abrt();
    }
    treepart=CDR(tmp);
  }
  return treepart;
}

SCM make_pred_to_proplit_incremental_aux(funargs,treepart)
SCM funargs,treepart;
{
  SCM argval,stopflag,tmp,argspart;

  tmp=EOL;
  stopflag=BOOL_F;
  argval=EOL;
  for(argspart=funargs;!(NULL_P(argspart)||NFALSEP(stopflag));argspart=CDR(argspart)) {
    argval=get_pred_term_interpvalue_incremental(CAR(argspart));
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(const_551,cur_output_port());
      display(funargs,cur_output_port());
      newline(cur_output_port());
      display(const_552,cur_output_port());
      display(argval,cur_output_port());
      newline(cur_output_port());
    }
    if(BOOLEAN_P(argval)) {
      stopflag=BOOL_T;
      treepart=BOOL_T;
    }
    else {
      tmp=assq(argval,treepart);
      if(!(NFALSEP(tmp))) {
        stopflag=BOOL_T;
        treepart=BOOL_T;
      }
      else
      if(tmp==BOOL_T) {
        stopflag=BOOL_T;
        treepart=BOOL_T;
      }
      else {
        treepart=CDR(tmp);
      }
    }
  }
  return treepart;
}

SCM make_flat_pred_to_proplit_aux(funargs,treepart)
SCM funargs,treepart;
{
  SCM argval,arg,tmp,argspart;

  tmp=EOL;
  arg=EOL;
  argval=EOL;
  for(argspart=funargs;!(NULL_P(argspart));argspart=CDR(argspart)) {
    arg=CAR(argspart);
    if(MAKINUM(100000)<=arg) {
      argval=MAKINUM(INUM(arg)-100000);
    }
    else
    if(GLOBAL(prop_const_min_global)<=arg) {
      argval=MAKINUM(INUM(arg)-INUM(GLOBAL(prop_const_min_global)));
    }
    else {
      argval=STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&arg);
    }
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(const_553,cur_output_port());
      display(argspart,cur_output_port());
      newline(cur_output_port());
      display(const_554,cur_output_port());
      display(argval,cur_output_port());
      newline(cur_output_port());
      display(const_555,cur_output_port());
      display(treepart,cur_output_port());
      newline(cur_output_port());
    }
    tmp=assq(argval,treepart);
    if(!(NFALSEP(tmp))) {
      display(const_556,cur_output_port());
      abrt();
    }
    treepart=CDR(tmp);
  }
  return treepart;
}

SCM get_pred_term_interpvalue(term)
SCM term;
{
  SCM tmp,treepart;

  tmp=EOL;
  treepart=EOL;
  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&term);
    else
    if(MAKINUM(100000)<=term)
      return MAKINUM(INUM(term)-100000);
    else {
      tmp=assq(term,GLOBAL(prop_constants_mapping_global));
      if(!(NFALSEP(tmp))) {
        display(const_557,cur_output_port());
        quit(1);
      }
      return CDR(tmp);
    }
  }
  else {
    treepart=assq(prop_spec_pure_fun(CAR(term)),GLOBAL(prop_fun_mappings_global));
    if(!(NFALSEP(treepart))) {
      display(const_558,cur_output_port());
      quit(1);
    }
    return make_pred_to_proplit_aux(CDR(term),CDR(treepart));
  }
}

SCM get_pred_term_interpvalue_incremental(term)
SCM term;
{
  SCM tmp,treepart;

  tmp=EOL;
  treepart=EOL;
  if(NUMBER_P(term)) {
    if(MAKINUM(65535)>term)
      return STBL_VECTOR_REF(_star_var_val_table_star__velts0,MAKINUM(8191)&term);
    else {
      tmp=assq(term,GLOBAL(prop_constants_mapping_global));
      if(!(NFALSEP(tmp)))
        return BOOL_T;
      else
        return CDR(tmp);
    }
  }
  else {
    treepart=assq(prop_spec_pure_fun(CAR(term)),GLOBAL(prop_fun_mappings_global));
    if(!(NFALSEP(treepart)))
      return BOOL_T;
    else
      return make_pred_to_proplit_incremental_aux(CDR(term),CDR(treepart));
  }
}

SCM flatten_clause_set(clauses)
SCM clauses;
{
  SCM res,clause,tmp,clpart;

  tmp=EOL;
  clause=EOL;
  res=EOL;
  for(clpart=clauses;!(NULL_P(clpart));clpart=CDR(clpart)) {
    clause=CAR(clpart);
    if(PAIR_P(clause)&&PAIR_P(CDR(clause))) {
      tmp=flatten_clause(clause);
      res=append2(tmp,res);
    }
  }
  return res;
}

SCM flatten_clause(clause)
SCM clause;
{
  SCM preprocessed;

  preprocessed=EOL;
  GLOBAL(prop_flatten_lastvar_global)=MAKINUM(100);
  preprocessed=preprocess_flatten_clause(CDR(clause));
  if(GLOBAL(prop_flatten_lastvar_global)>=MAKINUM(150)) {
    display(const_559,cur_output_port());
    quit(1);
  }
  return map1(flatten_clause_fn668,preprocessed);
}

SCM flatten_clause_fn668(cl)
SCM cl;
{
  return flatten_clause_aux(cl);
}

SCM preprocess_flatten_clause(pureclause)
SCM pureclause;
{
  SCM lit,fun,purefun,negfun,negflag,eqflag,var,l1,l2,tmp;

  lit=EOL;
  fun=EOL;
  purefun=EOL;
  negfun=EOL;
  negflag=BOOL_F;
  eqflag=BOOL_F;
  var=EOL;
  l1=EOL;
  l2=EOL;
  tmp=EOL;
  if(NULL_P(pureclause))
    return cons(EOL,EOL);
  else {
    lit=CAR(pureclause);
    fun=CAR(lit);
    purefun=prop_spec_pure_unsigned_fun(fun);
    negflag=NOT(SBOOL(ZERO_P(MAKINUM(268435456)&fun)));
    eqflag=SBOOL(GLOBAL(eq_pred_nr_global)==purefun);
    if(NFALSEP(eqflag)&&(!(NFALSEP(negflag))&&(!(NUMBER_P(CAR(CDR(lit)))&&(MAKINUM(65535)>CAR(CDR(lit))))&&!(NUMBER_P(CAR(CDR(CDR(lit))))&&(MAKINUM(65535)>CAR(CDR(CDR(lit)))))))) {
      var=make_prop_flatten_newvar();
      l1=cons(purefun,cons(CAR(CDR(lit)),cons(var,EOL)));
      l2=cons(purefun,cons(CAR(CDR(CDR(lit))),cons(var,EOL)));
      negfun=(MAKINUM(268435456)|purefun);
      tmp=preprocess_flatten_clause(CDR(pureclause));
      return append2(map1_inst6(negfun,l2,l1,preprocess_flatten_clause_fn672,tmp),map1_inst6(l2,l1,negfun,preprocess_flatten_clause_fn673,tmp));
    }
    else {
      tmp=preprocess_flatten_clause(CDR(pureclause));
      return map1_inst1(lit,preprocess_flatten_clause_fn674,tmp);
    }
  }
}

SCM preprocess_flatten_clause_fn674(lit,cl)
SCM lit,cl;
{
  return cons(lit,cl);
}

SCM preprocess_flatten_clause_fn673(l2,l1,negfun,cl)
SCM l2,l1,negfun,cl;
{
  return cons(cons(negfun,CDR(l1)),cons(l2,cl));
}

SCM preprocess_flatten_clause_fn672(negfun,l2,l1,cl)
SCM negfun,l2,l1,cl;
{
  return cons(l1,cons(cons(negfun,CDR(l2)),cl));
}

SCM flatten_clause_aux(clause)
SCM clause;
{
  SCM processed_lit,res,varslist,eqflag,negflag,purefun,fun,lit,clpart;

  lit=EOL;
  fun=EOL;
  purefun=EOL;
  negflag=BOOL_F;
  eqflag=BOOL_F;
  varslist=get_fullclause_varslist(clause);
  res=EOL;
  processed_lit=EOL;
  if(length(varslist)>MAKINUM(40)) {
    display(const_560,cur_output_port());
    quit(1);
  }
  GLOBAL(prop_flatten_varslist_global)=varslist;
  GLOBAL(prop_flatten_lastvar_global)=MAKINUM(150);
  GLOBAL(prop_flatten_newlits_global)=EOL;
  GLOBAL(prop_flatten_clause_processed_terms_global)=EOL;
  for(clpart=clause;!(NULL_P(clpart));clpart=CDR(clpart)) {
    processed_lit=flatten_composite_term(CAR(clpart),BOOL_T);
    res=cons(processed_lit,res);
  }
  if(GLOBAL(prop_flatten_lastvar_global)>MAKINUM(250)) {
    display(const_561,cur_output_port());
    quit(1);
  }
  return cons(EOL,append2(reverse(GLOBAL(prop_flatten_newlits_global)),reverse(res)));
}

SCM flatten_composite_term(term,litflag)
SCM term,litflag;
{
  SCM funsymb,fun,negflag,eqflag,purefun,tmp,newargs,newvar;

  funsymb=EOL;
  fun=EOL;
  negflag=BOOL_F;
  eqflag=BOOL_F;
  purefun=EOL;
  tmp=EOL;
  newargs=EOL;
  newvar=EOL;
  if(!(NFALSEP(litflag))) {
    funsymb=CDR(assq(prop_spec_pure_fun(CAR(term)),GLOBAL(prop_orig_funs_enum_global)));
    term=cons(funsymb,CDR(term));
  }
  else {
    fun=CAR(term);
    purefun=prop_spec_pure_unsigned_fun(fun);
    negflag=NOT(SBOOL(ZERO_P(MAKINUM(268435456)&fun)));
    eqflag=SBOOL(GLOBAL(eq_pred_nr_global)==purefun);
    funsymb=CDR(assq(purefun,GLOBAL(prop_orig_preds_enum_global)));
    if(!(NFALSEP(eqflag))) {
      if(NFALSEP(negflag)) {
        funsymb=MAKINUM(0-INUM(funsymb));
      }
      term=cons(funsymb,CDR(term));
    }
    else
    if(NFALSEP(eqflag)&&(NUMBER_P(CAR(CDR(term)))&&((MAKINUM(65535)>CAR(CDR(term)))&&(NUMBER_P(CAR(CDR(CDR(term))))&&(MAKINUM(65535)>CAR(CDR(CDR(term)))))))) {
      if(NFALSEP(negflag)) {
        funsymb=MAKINUM(0-INUM(funsymb));
      }
      term=cons(funsymb,CDR(term));
    }
    else
    if(NFALSEP(eqflag)&&(NUMBER_P(CAR(CDR(term)))&&(MAKINUM(65535)>CAR(CDR(term))))) {
      if(NUMBER_P(CAR(CDR(CDR(term))))) {
        tmp=assq(CAR(CDR(CDR(term))),GLOBAL(prop_orig_constants_enum_global));
        term=cons((NFALSEP(negflag) ? MAKINUM(0-INUM(CDR(tmp))) : CDR(tmp)),cons(CAR(CDR(term)),EOL));
      }
      else {
        tmp=assq(prop_spec_pure_fun(CAR(CAR(CDR(CDR(term))))),GLOBAL(prop_orig_funs_enum_global));
        term=cons((NFALSEP(negflag) ? MAKINUM(0-INUM(CDR(tmp))) : CDR(tmp)),cons(CAR(CDR(term)),CDR(CAR(CDR(CDR(term))))));
      }
    }
    else
    if(NFALSEP(eqflag)&&(NUMBER_P(CAR(CDR(CDR(term))))&&(MAKINUM(65535)>CAR(CDR(CDR(term)))))) {
      if(NUMBER_P(CAR(CDR(term)))) {
        tmp=assq(CAR(CDR(term)),GLOBAL(prop_orig_constants_enum_global));
        term=cons((NFALSEP(negflag) ? MAKINUM(0-INUM(CDR(tmp))) : CDR(tmp)),cons(CAR(CDR(CDR(term))),EOL));
      }
      else {
        tmp=assq(prop_spec_pure_fun(CAR(CAR(CDR(term)))),GLOBAL(prop_orig_funs_enum_global));
        term=cons((NFALSEP(negflag) ? MAKINUM(0-INUM(CDR(tmp))) : CDR(tmp)),cons(CAR(CDR(CDR(term))),CDR(CAR(CDR(term)))));
      }
    }
    else
    if(NFALSEP(eqflag)&&NFALSEP(negflag)) {
      term=cons(MAKINUM(0-INUM(funsymb)),CDR(term));
    }
    else {
      display(const_562,cur_output_port());
      abrt();
    }
  }
  newargs=map1_inst3(&newvar,&tmp,flatten_composite_term_fn676,CDR(term));
  return cons(CAR(term),newargs);
}

SCM flatten_composite_term_fn676(newvar,tmp,curterm)
SCM *newvar,*tmp;
SCM curterm;
{
  if(NUMBER_P(curterm)) {
    if(MAKINUM(65535)>curterm) {
      *tmp=(MAKINUM(8191)&curterm);
    }
    else {
      *tmp=assoc(curterm,GLOBAL(prop_flatten_clause_processed_terms_global));
      if(NFALSEP(*tmp)) {
        *tmp=CDR(*tmp);
      }
      else {
        *tmp=assq(curterm,GLOBAL(prop_orig_constants_enum_global));
        if(!(NFALSEP(*tmp))) {
          display(const_563,cur_output_port());
          quit(1);
        }
        *newvar=make_prop_flatten_newvar();
        make_prop_flatten_addpair(curterm,cons(CDR(*tmp),EOL),*newvar);
        *tmp=*newvar;
      }
    }
  }
  else {
    *tmp=assoc(curterm,GLOBAL(prop_flatten_clause_processed_terms_global));
    if(NFALSEP(*tmp)) {
      *tmp=CDR(*tmp);
    }
    else {
      *tmp=flatten_composite_term(curterm,BOOL_F);
      *newvar=make_prop_flatten_newvar();
      make_prop_flatten_addpair(curterm,*tmp,*newvar);
      *tmp=*newvar;
    }
  }
  return *tmp;
}

SCM make_prop_flatten_newvar()
{
  GLOBAL(prop_flatten_lastvar_global)=MAKINUM(1+INUM(GLOBAL(prop_flatten_lastvar_global)));
  GLOBAL(prop_flatten_varslist_global)=cons(GLOBAL(prop_flatten_lastvar_global),GLOBAL(prop_flatten_varslist_global));
  return GLOBAL(prop_flatten_lastvar_global);
}

SCM make_prop_flatten_addpair(origterm,newterm,newvar)
SCM origterm,newterm,newvar;
{
  SCM newlit;

  newlit=EOL;
  GLOBAL(prop_flatten_clause_processed_terms_global)=cons(cons(origterm,newvar),GLOBAL(prop_flatten_clause_processed_terms_global));
  newlit=cons(MAKINUM(0-INUM(CAR(newterm))),cons(newvar,CDR(newterm)));
  GLOBAL(prop_flatten_newlits_global)=cons(newlit,GLOBAL(prop_flatten_newlits_global));
  return UNSPECIFIED;
}

SCM pseudo_flatten_clause_set(clauses)
SCM clauses;
{
  SCM res,clause,tmp,clpart;

  tmp=EOL;
  clause=EOL;
  res=EOL;
  for(clpart=clauses;!(NULL_P(clpart));clpart=CDR(clpart)) {
    clause=CAR(clpart);
    if(PAIR_P(clause)&&PAIR_P(CDR(clause))) {
      tmp=pseudo_flatten_clause(clause);
      res=append2(tmp,res);
    }
  }
  return res;
}

SCM pseudo_flatten_clause(clause)
SCM clause;
{
  SCM preprocessed;

  preprocessed=EOL;
  GLOBAL(prop_flatten_lastvar_global)=MAKINUM(100);
  preprocessed=pseudo_preprocess_flatten_clause(CDR(clause));
  if(GLOBAL(prop_flatten_lastvar_global)>=MAKINUM(150)) {
    display(const_564,cur_output_port());
    quit(1);
  }
  return map1(pseudo_flatten_clause_fn678,preprocessed);
}

SCM pseudo_flatten_clause_fn678(cl)
SCM cl;
{
  return pseudo_flatten_clause_aux(cl);
}

SCM pseudo_preprocess_flatten_clause(pureclause)
SCM pureclause;
{
  SCM lit,fun,purefun,negfun,negflag,eqflag,var,l1,l2,tmp;

  lit=EOL;
  fun=EOL;
  purefun=EOL;
  negfun=EOL;
  negflag=BOOL_F;
  eqflag=BOOL_F;
  var=EOL;
  l1=EOL;
  l2=EOL;
  tmp=EOL;
  if(NULL_P(pureclause))
    return cons(EOL,EOL);
  else {
    lit=CAR(pureclause);
    fun=CAR(lit);
    purefun=prop_spec_pure_unsigned_fun(fun);
    negflag=NOT(SBOOL(ZERO_P(MAKINUM(268435456)&fun)));
    eqflag=SBOOL(GLOBAL(eq_pred_nr_global)==purefun);
    tmp=pseudo_preprocess_flatten_clause(CDR(pureclause));
    return map1_inst1(lit,pseudo_preprocess_flatten_clause_fn680,tmp);
  }
}

SCM pseudo_preprocess_flatten_clause_fn680(lit,cl)
SCM lit,cl;
{
  return cons(lit,cl);
}

SCM pseudo_flatten_clause_aux(clause)
SCM clause;
{
  SCM processed_lit,res,varslist,eqflag,negflag,purefun,fun,lit,clpart;

  lit=EOL;
  fun=EOL;
  purefun=EOL;
  negflag=BOOL_F;
  eqflag=BOOL_F;
  varslist=get_fullclause_varslist(clause);
  res=EOL;
  processed_lit=EOL;
  if(length(varslist)>MAKINUM(40)) {
    display(const_565,cur_output_port());
    quit(1);
  }
  GLOBAL(prop_flatten_varslist_global)=varslist;
  GLOBAL(prop_flatten_lastvar_global)=MAKINUM(150);
  GLOBAL(prop_flatten_newlits_global)=EOL;
  GLOBAL(prop_flatten_clause_processed_terms_global)=EOL;
  for(clpart=clause;!(NULL_P(clpart));clpart=CDR(clpart)) {
    processed_lit=pseudo_flatten_composite_term(CAR(clpart),BOOL_T);
    res=cons(processed_lit,res);
  }
  if(GLOBAL(prop_flatten_lastvar_global)>MAKINUM(250)) {
    display(const_566,cur_output_port());
    quit(1);
  }
  return cons(EOL,append2(reverse(GLOBAL(prop_flatten_newlits_global)),reverse(res)));
}

SCM pseudo_flatten_composite_term(term,litflag)
SCM term,litflag;
{
  SCM funsymb,fun,negflag,eqflag,purefun,tmp,newargs,newvar;

  funsymb=EOL;
  fun=EOL;
  negflag=BOOL_F;
  eqflag=BOOL_F;
  purefun=EOL;
  tmp=EOL;
  newargs=EOL;
  newvar=EOL;
  fun=CAR(term);
  purefun=prop_spec_pure_unsigned_fun(fun);
  negflag=NOT(SBOOL(ZERO_P(MAKINUM(268435456)&fun)));
  eqflag=SBOOL(GLOBAL(eq_pred_nr_global)==purefun);
  funsymb=CDR(assq(purefun,GLOBAL(prop_orig_preds_enum_global)));
  if(NFALSEP(negflag)) {
    funsymb=MAKINUM(0-INUM(funsymb));
  }
  term=cons(funsymb,CDR(term));
  newargs=map1_inst4(&tmp,pseudo_flatten_composite_term_fn682,CDR(term));
  return cons(CAR(term),newargs);
}

SCM pseudo_flatten_composite_term_fn682(tmp,curterm)
SCM *tmp;
SCM curterm;
{
  if(NUMBER_P(curterm)) {
    if(MAKINUM(65535)>curterm) {
      *tmp=(MAKINUM(8191)&curterm);
    }
    else {
      *tmp=assq(curterm,GLOBAL(prop_orig_constants_to_flat_domainels_global));
      *tmp=CDR(*tmp);
    }
  }
  else {
    newline(cur_output_port());
    display(const_567,cur_output_port());
    newline(cur_output_port());
    quit(1);
  }
  return *tmp;
}

SCM create_prop_var_vectors(maxvar)
SCM maxvar;
{
  GLOBAL(propvar_value_global)=make_vector(MAKINUM(1+INUM(maxvar)),EOL);
  GLOBAL(propvar_positive_occ_clauses_global)=make_vector(MAKINUM(1+INUM(maxvar)),EOL);
  GLOBAL(propvar_negative_occ_clauses_global)=make_vector(MAKINUM(1+INUM(maxvar)),EOL);
  GLOBAL(propvar_enqued_value_global)=make_vector(MAKINUM(1+INUM(maxvar)),EOL);
  return UNSPECIFIED;
}

SCM initialize_prop_var_values(maxvar)
SCM maxvar;
{
  apply(GLOBAL(vector_fill_excl_),GLOBAL(propvar_value_global),cons(EOL,listofnull));
  apply(GLOBAL(vector_fill_excl_),GLOBAL(propvar_positive_occ_clauses_global),cons(EOL,listofnull));
  apply(GLOBAL(vector_fill_excl_),GLOBAL(propvar_negative_occ_clauses_global),cons(EOL,listofnull));
  return apply(GLOBAL(vector_fill_excl_),GLOBAL(propvar_enqued_value_global),cons(EOL,listofnull));
}

SCM build_prop_internal_structure(clauses)
SCM clauses;
{
  SCM part__1,poslits,neglits,resclause,repeatflag,var,tmp,resclauses,part,part__2;

  resclauses=EOL;
  tmp=EOL;
  var=EOL;
  repeatflag=BOOL_F;
  resclause=EOL;
  neglits=EOL;
  poslits=EOL;
  for(part=clauses;!(NULL_P(part));part=CDR(part)) {
    poslits=CDR(CAR(part));
    neglits=CAR(CAR(part));
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(poslits,cur_output_port());
      newline(cur_output_port());
      display(neglits,cur_output_port());
      newline(cur_output_port());
    }
    resclause=cons(length(neglits),cons(length(poslits),cons(neglits,cons(poslits,cons(EOL,EOL)))));
    resclauses=cons(resclause,resclauses);
    for(part__1=poslits;!(NULL_P(part__1));part__1=CDR(part__1)) {
      var=CAR(part__1);
      VECTOR_SET(GLOBAL(propvar_positive_occ_clauses_global),var,cons(resclause,VECTOR_REF(GLOBAL(propvar_positive_occ_clauses_global),var)));
    }
    for(part__2=neglits;!(NULL_P(part__2));part__2=CDR(part__2)) {
      var=CAR(part__2);
      VECTOR_SET(GLOBAL(propvar_negative_occ_clauses_global),var,cons(resclause,VECTOR_REF(GLOBAL(propvar_negative_occ_clauses_global),var)));
    }
  }
  return resclauses;
}

SCM solve_prop_clauses(clauses,maxvar)
SCM clauses,maxvar;
{
  SCM res,internalclauses,newsplitvar,splittableclauses,new_var1;

  splittableclauses=EOL;
  newsplitvar=EOL;
  internalclauses=EOL;
  res=EOL;
  initialize_prop_var_values(maxvar);
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_568,cur_output_port());
    newline(cur_output_port());
    show_prop_internal_data(EOL,maxvar);
  }
  internalclauses=build_prop_internal_structure(clauses);
  GLOBAL(prop_internal_clauses_global)=internalclauses;
  GLOBAL(prop_maxvar_global)=maxvar;
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_569,cur_output_port());
    newline(cur_output_port());
    show_prop_internal_data(internalclauses,maxvar);
  }
  if(0) {
    newline(cur_output_port());
    display(length(clauses),cur_output_port());
    display(const_570,cur_output_port());
    display(maxvar,cur_output_port());
    display(const_571,cur_output_port());
    newline(cur_output_port());
  }
  if(GLOBAL(display_info_level_global)>MAKINUM(90)) {
    newline(cur_output_port());
    display(const_572,cur_output_port());
    newline(cur_output_port());
    for_each1(solve_prop_clauses_fn687,GLOBAL(prop_internal_clauses_global));
    newline(cur_output_port());
  }
  if(0) {
    newline(cur_output_port());
    newline(cur_output_port());
    newline(cur_output_port());
    for_each1(solve_prop_clauses_fn688,GLOBAL(prop_internal_clauses_global));
    newline(cur_output_port());
    newline(cur_output_port());
    newline(cur_output_port());
  }
  GLOBAL(prop_var_assignment_queue_global)=EOL;
  GLOBAL(prop_assigned_varvalpairs_global)=EOL;
  GLOBAL(prop_unsat_found_occlistpart_global)=EOL;
  res=initial_prop_unit_propagate(internalclauses);
  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_573,cur_output_port());
    newline(cur_output_port());
    display(const_574,cur_output_port());
    display(NOT(res),cur_output_port());
    newline(cur_output_port());
    show_prop_internal_data(internalclauses,maxvar);
  }
  if(NFALSEP(res))
    return BOOL_F;
  else {
    splittableclauses=prop_find_splittable(internalclauses);
    newsplitvar=prop_give_next_split(splittableclauses);
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      newline(cur_output_port());
      display(const_575,cur_output_port());
      display(newsplitvar,cur_output_port());
      newline(cur_output_port());
    }
    if(NULL_P(newsplitvar))
      return BOOL_T;
    else {
      new_var1=solve_prop_clauses_branch(newsplitvar,BOOL_T,splittableclauses);
      if(NFALSEP(new_var1))
        return new_var1;
      else
        return solve_prop_clauses_branch(newsplitvar,BOOL_F,splittableclauses);
    }
  }
}

SCM solve_prop_clauses_fn688(cl)
SCM cl;
{
  for_each1(solve_prop_clauses_fn689,CAR(CDR(CDR(cl))));
  for_each1(solve_prop_clauses_fn690,CAR(CDR(CDR(CDR(cl)))));
  display(const_576,cur_output_port());
  return newline(cur_output_port());
}

SCM solve_prop_clauses_fn690(p)
SCM p;
{
  display(const_577,cur_output_port());
  display(p,cur_output_port());
  return display(const_578,cur_output_port());
}

SCM solve_prop_clauses_fn689(n)
SCM n;
{
  display(const_579,cur_output_port());
  display(const_580,cur_output_port());
  display(n,cur_output_port());
  return display(const_581,cur_output_port());
}

SCM solve_prop_clauses_fn687(cl)
SCM cl;
{
  display(cl,cur_output_port());
  return newline(cur_output_port());
}

SCM initial_prop_unit_propagate(clauses)
SCM clauses;
{
  SCM res,tmp2,tmp,part;

  tmp=EOL;
  tmp2=EOL;
  res=BOOL_F;
  for(part=clauses;!(NULL_P(part)||NFALSEP(res));part=CDR(part)) {
    tmp=CAR(part);
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      display(tmp,cur_output_port());
      newline(cur_output_port());
    }
    if(1==(INUM(CAR(tmp))+INUM(CAR(CDR(tmp))))) {
      tmp2=CDR(CDR(tmp));
      if(NULL_P(CAR(tmp2))) {
        res=prop_enque_unit(CAR(CAR(CDR(tmp2))),BOOL_T);
      }
      else {
        res=prop_enque_unit(CAR(CAR(tmp2)),BOOL_F);
      }
    }
  }
  if(NFALSEP(res))
    return res;
  else
    return loop_prop_unit_queue();
}

SCM solve_prop_clauses_branch(splitvar,splitvalue,splittableclauses)
SCM splitvar,splitvalue,splittableclauses;
{
  SCM res,newsplitvar,local_assignment_queue,local_assigned_varvalpairs;

  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_582,cur_output_port());
    newline(cur_output_port());
    display(const_583,cur_output_port());
    display(splitvar,cur_output_port());
    display(const_584,cur_output_port());
    display(splitvalue,cur_output_port());
    newline(cur_output_port());
  }
  res=EOL;
  newsplitvar=EOL;
  local_assignment_queue=EOL;
  local_assigned_varvalpairs=EOL;
  GLOBAL(prop_time_ran_out_global)=BOOL_F;
  GLOBAL(prop_var_assignment_queue_global)=EOL;
  GLOBAL(prop_assigned_varvalpairs_global)=EOL;
  GLOBAL(prop_unsat_found_occlistpart_global)=EOL;
  GLOBAL(prop_var_assignment_queue_global)=cons(cons(splitvar,splitvalue),EOL);
  res=loop_prop_unit_queue();
  if(NFALSEP(res)) {
    prop_undo_assignments(GLOBAL(prop_assigned_varvalpairs_global));
    prop_undo_queue_assignments(GLOBAL(prop_var_assignment_queue_global));
    return BOOL_F;
  }
  else
  if((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))) {
    GLOBAL(prop_time_ran_out_global)=BOOL_T;
    return BOOL_F;
  }
  else {
    local_assigned_varvalpairs=GLOBAL(prop_assigned_varvalpairs_global);
    GLOBAL(prop_assigned_varvalpairs_global)=EOL;
    local_assignment_queue=GLOBAL(prop_var_assignment_queue_global);
    GLOBAL(prop_var_assignment_queue_global)=EOL;
    newsplitvar=prop_give_next_split(splittableclauses);
    if(NFALSEP(GLOBAL(prop_debug_global))) {
      newline(cur_output_port());
      display(const_585,cur_output_port());
      display(newsplitvar,cur_output_port());
      newline(cur_output_port());
    }
    if(NULL_P(newsplitvar))
      return BOOL_T;
    else
    if(NFALSEP(((length(VECTOR_REF(GLOBAL(propvar_negative_occ_clauses_global),newsplitvar))>length(VECTOR_REF(GLOBAL(propvar_positive_occ_clauses_global),newsplitvar))) ? SBOOL(NFALSEP(solve_prop_clauses_branch(newsplitvar,BOOL_T,splittableclauses))||NFALSEP(solve_prop_clauses_branch(newsplitvar,BOOL_F,splittableclauses))) : SBOOL(NFALSEP(solve_prop_clauses_branch(newsplitvar,BOOL_F,splittableclauses))||NFALSEP(solve_prop_clauses_branch(newsplitvar,BOOL_T,splittableclauses))))))
      return BOOL_T;
    else {
      GLOBAL(prop_unsat_found_occlistpart_global)=BOOL_F;
      GLOBAL(prop_assigned_varvalpairs_global)=local_assigned_varvalpairs;
      prop_undo_assignments(local_assigned_varvalpairs);
      prop_undo_queue_assignments(local_assignment_queue);
      return BOOL_F;
    }
  }
}

SCM prop_find_splittable(clauses)
SCM clauses;
{
  SCM res,part;

  res=EOL;
  for(part=clauses;!(NULL_P(part));part=CDR(part))
    if(CAR(CDR(CAR(part)))>MAKINUM(1)) {
      res=cons(CAR(part),res);
    }
  return res;
}

SCM prop_give_next_split_tst(splittableclauses)
SCM splittableclauses;
{
  SCM part,bestclause,bestlen,foundflag,foundlit,tmp,litpart;

  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_586,cur_output_port());
    newline(cur_output_port());
    for_each1(prop_give_next_split_tst_fn693,splittableclauses);
    newline(cur_output_port());
  }
  bestclause=EOL;
  bestlen=MAKINUM(0);
  foundflag=BOOL_F;
  foundlit=BOOL_F;
  tmp=EOL;
  for(part=splittableclauses;!(NULL_P(part)||NFALSEP(foundflag));part=CDR(part)) {
    tmp=MAKINUM(0);
    if((MAKINUM(0)==CAR(CAR(part)))&&((CAR(CDR(CAR(part)))>MAKINUM(1))&&(NULL_P(CAR(CDR(CDR(CDR(CDR(CAR(part)))))))&&(NFALSEP((for_each1_inst2(&tmp,prop_give_next_split_tst_fn694,CAR(CDR(CDR(CDR(CAR(part)))))),BOOL_T))&&(tmp>bestlen))))) {
      if(!(NFALSEP(prop_clause_subsumed_by_var_pred_(CAR(part))))) {
        bestclause=CAR(part);
        bestlen=tmp;
      }
    }
  }
  if(NULL_P(bestclause))
    return bestclause;
  else {
    for(litpart=CAR(CDR(CDR(CDR(bestclause))));!(NULL_P(litpart)||NFALSEP(foundlit));litpart=CDR(litpart))
      if(NULL_P(VECTOR_REF(GLOBAL(propvar_value_global),CAR(litpart)))) {
        foundlit=CAR(litpart);
      }
    return foundlit;
  }
}

SCM prop_give_next_split_tst_fn694(tmp,x)
SCM *tmp;
SCM x;
{
  *tmp=MAKINUM(INUM(*tmp)+(INUM(length(VECTOR_REF(GLOBAL(propvar_negative_occ_clauses_global),x)))+INUM(length(VECTOR_REF(GLOBAL(propvar_positive_occ_clauses_global),x)))));
  return UNSPECIFIED;
}

SCM prop_give_next_split_tst_fn693(cl)
SCM cl;
{
  display(const_587,cur_output_port());
  display(cl,cur_output_port());
  return newline(cur_output_port());
}

SCM prop_give_next_split(splittableclauses)
SCM splittableclauses;
{
  SCM part,bestclause,bestlen,foundflag,foundlit,tmp,litpart;

  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_588,cur_output_port());
    newline(cur_output_port());
    for_each1(prop_give_next_split_fn696,splittableclauses);
    newline(cur_output_port());
  }
  bestclause=EOL;
  bestlen=MAKINUM(100000);
  foundflag=BOOL_F;
  foundlit=BOOL_F;
  tmp=EOL;
  for(part=splittableclauses;!(NULL_P(part)||NFALSEP(foundflag));part=CDR(part))
    if((MAKINUM(0)==CAR(CAR(part)))&&(NFALSEP((tmp=CAR(CDR(CAR(part))),UNSPECIFIED,SBOOL(tmp>MAKINUM(1))))&&(NULL_P(CAR(CDR(CDR(CDR(CDR(CAR(part)))))))&&((MAKINUM(2)==tmp)||(tmp<bestlen))))) {
      if(!(NFALSEP(prop_clause_subsumed_by_var_pred_(CAR(part))))) {
        bestclause=CAR(part);
        bestlen=tmp;
        if(MAKINUM(2)==tmp) {
          foundflag=BOOL_T;
        }
      }
    }
  if(NULL_P(bestclause))
    return bestclause;
  else {
    for(litpart=CAR(CDR(CDR(CDR(bestclause))));!(NULL_P(litpart)||NFALSEP(foundlit));litpart=CDR(litpart))
      if(NULL_P(VECTOR_REF(GLOBAL(propvar_value_global),CAR(litpart)))) {
        foundlit=CAR(litpart);
      }
    return foundlit;
  }
}

SCM prop_give_next_split_fn696(cl)
SCM cl;
{
  display(const_589,cur_output_port());
  display(cl,cur_output_port());
  return newline(cur_output_port());
}

SCM prop_clause_subsumed_by_var_pred_(clause)
SCM clause;
{
  SCM part,subsflag,part__1;

  subsflag=BOOL_F;
  for(part=CAR(CDR(CDR(clause)));!(NULL_P(part)||NFALSEP(subsflag));part=CDR(part))
    if(VECTOR_REF(GLOBAL(propvar_value_global),CAR(part))==BOOL_F) {
      subsflag=BOOL_T;
    }
  if(NFALSEP(subsflag))
    return subsflag;
  else {
    for(part__1=CAR(CDR(CDR(CDR(clause))));!(NULL_P(part__1)||NFALSEP(subsflag));part__1=CDR(part__1))
      if(VECTOR_REF(GLOBAL(propvar_value_global),CAR(part__1))==BOOL_T) {
        subsflag=BOOL_T;
      }
    return subsflag;
  }
}

SCM loop_prop_unit_queue()
{
  SCM unsat_flag,tmp;

  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_590,cur_output_port());
    newline(cur_output_port());
    show_prop_internal_data(EOL,MAKINUM(4));
  }
  unsat_flag=BOOL_F;
  tmp=EOL;
  for(;!(NULL_P(GLOBAL(prop_var_assignment_queue_global))||NFALSEP(unsat_flag));) {
    tmp=CAR(GLOBAL(prop_var_assignment_queue_global));
    GLOBAL(prop_var_assignment_queue_global)=CDR(GLOBAL(prop_var_assignment_queue_global));
    unsat_flag=assign_prop_var(tmp);
  }
  return unsat_flag;
}

SCM assign_prop_var(varvalpair)
SCM varvalpair;
{
  SCM occlist,varnr,varval,tmpres,unsat_flag,occlist__1;

  if(NFALSEP(GLOBAL(prop_debug_global))) {
    newline(cur_output_port());
    display(const_591,cur_output_port());
    display(varvalpair,cur_output_port());
    newline(cur_output_port());
  }
  varnr=CAR(varvalpair);
  varval=CDR(varvalpair);
  tmpres=BOOL_F;
  unsat_flag=BOOL_F;
  VECTOR_SET(GLOBAL(propvar_value_global),varnr,varval);
  GLOBAL(prop_assigned_varvalpairs_global)=cons(varvalpair,GLOBAL(prop_assigned_varvalpairs_global));
  if(NFALSEP(varval)) {
    for(occlist=VECTOR_REF(GLOBAL(propvar_negative_occ_clauses_global),varnr);!(NULL_P(occlist));occlist=CDR(occlist)) {
      if(NFALSEP(GLOBAL(prop_debug_global))) {
        display(CAR(occlist),cur_output_port());
        newline(cur_output_port());
      }
      tmpres=prop_resolve_clause(occlist,varval);
      if(NFALSEP(tmpres)) {
        unsat_flag=BOOL_T;
      }
    }
    return unsat_flag;
  }
  else {
    for(occlist__1=VECTOR_REF(GLOBAL(propvar_positive_occ_clauses_global),varnr);!(NULL_P(occlist__1));occlist__1=CDR(occlist__1)) {
      if(NFALSEP(GLOBAL(prop_debug_global))) {
        display(CAR(occlist__1),cur_output_port());
        newline(cur_output_port());
      }
      tmpres=prop_resolve_clause(occlist__1,varval);
      if(NFALSEP(tmpres)) {
        unsat_flag=BOOL_T;
      }
    }
    return unsat_flag;
  }
}

SCM prop_resolve_clause(propclauselst,varval)
SCM propclauselst,varval;
{
  SCM propclause__1,propclause,clcdr,clsum,unsat_flag,propclause__2;

  if(NFALSEP(GLOBAL(prop_debug_global))) {
    display(const_592,cur_output_port());
    newline(cur_output_port());
    display(propclauselst,cur_output_port());
    newline(cur_output_port());
    display(varval,cur_output_port());
    newline(cur_output_port());
  }
  propclause=CAR(propclauselst);
  clcdr=CDR(propclause);
  clsum=MAKINUM(INUM(CAR(propclause))+INUM(CAR(clcdr)));
  unsat_flag=BOOL_F;
  if(NFALSEP(varval)) {
    SET_CAR(propclause,MAKINUM(INUM(CAR(propclause))-1));
  }
  else {
    SET_CAR(clcdr,MAKINUM(INUM(CAR(clcdr))-1));
  }
  if(clsum>MAKINUM(2))
    return BOOL_F;
  else
  if(clsum<=MAKINUM(1))
    return BOOL_T;
  else {
    varval=BOOL_F;
    for(propclause__1=CAR(CDR(clcdr));!(NULL_P(propclause__1)||NFALSEP(varval));propclause__1=CDR(propclause__1)) {
      if(NFALSEP(GLOBAL(prop_debug_global))) {
        display(CAR(propclause__1),cur_output_port());
        display(const_593,cur_output_port());
        display(VECTOR_REF(GLOBAL(propvar_value_global),CAR(propclause__1)),cur_output_port());
        newline(cur_output_port());
      }
      if(NULL_P(VECTOR_REF(GLOBAL(propvar_value_global),CAR(propclause__1)))) {
        varval=BOOL_T;
        unsat_flag=prop_enque_unit(CAR(propclause__1),BOOL_F);
      }
    }
    if(NFALSEP(unsat_flag))
      return unsat_flag;
    else
    if(NFALSEP(varval))
      return BOOL_F;
    else {
      for(propclause__2=CAR(CDR(CDR(clcdr)));!(NULL_P(propclause__2)||NFALSEP(varval));propclause__2=CDR(propclause__2)) {
        if(NFALSEP(GLOBAL(prop_debug_global))) {
          display(CAR(propclause__2),cur_output_port());
          display(const_594,cur_output_port());
          display(VECTOR_REF(GLOBAL(propvar_value_global),CAR(propclause__2)),cur_output_port());
          newline(cur_output_port());
        }
        if(NULL_P(VECTOR_REF(GLOBAL(propvar_value_global),CAR(propclause__2)))) {
          varval=BOOL_T;
          unsat_flag=prop_enque_unit(CAR(propclause__2),BOOL_T);
        }
      }
      return unsat_flag;
    }
  }
}

SCM prop_enque_unit(varnr,varval)
SCM varnr,varval;
{
  SCM queue_val;

  queue_val=VECTOR_REF(GLOBAL(propvar_enqued_value_global),varnr);
  if(NULL_P(queue_val)) {
    GLOBAL(prop_var_assignment_queue_global)=cons(cons(varnr,varval),GLOBAL(prop_var_assignment_queue_global));
    VECTOR_SET(GLOBAL(propvar_enqued_value_global),varnr,varval);
    return BOOL_F;
  }
  else
  if(queue_val==varval)
    return BOOL_F;
  else
    return BOOL_T;
}

SCM prop_undo_assignments(assignmentlist)
SCM assignmentlist;
{
  SCM occlist,varnr,stopflag,tmp,part,occlist__1;

  tmp=EOL;
  stopflag=BOOL_F;
  varnr=EOL;
  for(part=assignmentlist;!(NULL_P(part));part=CDR(part)) {
    tmp=CAR(part);
    varnr=CAR(tmp);
    VECTOR_SET(GLOBAL(propvar_value_global),varnr,EOL);
    VECTOR_SET(GLOBAL(propvar_enqued_value_global),varnr,EOL);
    if(NFALSEP(CDR(tmp)))
      for(occlist=VECTOR_REF(GLOBAL(propvar_negative_occ_clauses_global),varnr);!(NULL_P(occlist)||NFALSEP(stopflag));occlist=CDR(occlist)) {
        SET_CAR(CAR(occlist),MAKINUM(INUM(CAR(CAR(occlist)))+1));
        if(0) {
          stopflag=BOOL_T;
        }
      }
    else
      for(occlist__1=VECTOR_REF(GLOBAL(propvar_positive_occ_clauses_global),varnr);!(NULL_P(occlist__1)||NFALSEP(stopflag));occlist__1=CDR(occlist__1)) {
        SET_CAR(CDR(CAR(occlist__1)),MAKINUM(INUM(CAR(CDR(CAR(occlist__1))))+1));
        if(0) {
          stopflag=BOOL_T;
        }
      }
  }
  return UNSPECIFIED;
}

SCM prop_undo_queue_assignments(queue)
SCM queue;
{
  SCM part;

  for(part=queue;!(NULL_P(part));part=CDR(part)) {
    VECTOR_SET(GLOBAL(propvar_enqued_value_global),CAR(CAR(part)),EOL);
  }
  return UNSPECIFIED;
}

SCM test_prop_undo_assignments(assignmentlist)
SCM assignmentlist;
{
  SCM varnr,stopflag,tmp,part;

  tmp=EOL;
  stopflag=BOOL_F;
  varnr=EOL;
  for(part=assignmentlist;!(NULL_P(part));part=CDR(part)) {
    tmp=CAR(part);
    varnr=CAR(tmp);
    VECTOR_SET(GLOBAL(propvar_value_global),varnr,EOL);
    VECTOR_SET(GLOBAL(propvar_enqued_value_global),varnr,EOL);
  }
  return UNSPECIFIED;
}

SCM prop_try_subsume(clauses)
SCM clauses;
{
  SCM nr,part;

  newline(cur_output_port());
  display(const_595,cur_output_port());
  newline(cur_output_port());
  nr=MAKINUM(0);
  for(part=clauses;!(NULL_P(part));part=CDR(part))
    if(NFALSEP(prop_subsumed_clause_pred_(CAR(part),clauses))) {
      nr=MAKINUM(1+INUM(nr));
      display(const_596,cur_output_port());
    }
  newline(cur_output_port());
  display(const_597,cur_output_port());
  display(nr,cur_output_port());
  return newline(cur_output_port());
}

SCM prop_subsumed_clause_pred_(cl,clauses)
SCM cl,clauses;
{
  SCM foundflag,part;

  foundflag=BOOL_F;
  if(NFALSEP(prop_unit_subsumed_pred_(cl))) {
    foundflag=BOOL_T;
  }
  for(part=clauses;!(NULL_P(part));part=CDR(part))
    if(NFALSEP(prop_subsumes_pred_(CAR(part),cl))&&!(CAR(part)==cl)) {
      foundflag=BOOL_T;
    }
  return foundflag;
}

SCM prop_unit_subsumed_pred_(cl)
SCM cl;
{
  SCM new_var1;

  new_var1=some_pred_(prop_unit_subsumed_pred__fn700,CAR(CDR(CDR(cl))));
  if(NFALSEP(new_var1))
    return new_var1;
  else
    return some_pred_(prop_unit_subsumed_pred__fn699,CAR(CDR(CDR(CDR(cl)))));
}

SCM prop_unit_subsumed_pred__fn700(x)
SCM x;
{
  return SBOOL(BOOL_F==VECTOR_REF(GLOBAL(propvar_value_global),x));
}

SCM prop_unit_subsumed_pred__fn699(x)
SCM x;
{
  return SBOOL(BOOL_T==VECTOR_REF(GLOBAL(propvar_value_global),x));
}

SCM prop_subsumes_pred_(gencl,subscl)
SCM gencl,subscl;
{
  if(CAR(gencl)>=CAR(subscl)) {
    if(CAR(CDR(gencl))>=CAR(CDR(subscl))) {
      if(NFALSEP(prop_subclause_polarity_pred_(CAR(CDR(CDR(CDR(gencl)))),CAR(CDR(CDR(CDR(subscl)))),BOOL_T)))
        return prop_subclause_polarity_pred_(CAR(CDR(CDR(gencl))),CAR(CDR(CDR(subscl))),BOOL_F);
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM prop_subclause_polarity_pred_(glist,slist,polarity)
SCM glist,slist,polarity;
{
  SCM gpart,foundflag,lit,val,npol,spart;

  foundflag=BOOL_T;
  lit=EOL;
  val=EOL;
  npol=NOT(polarity);
  for(gpart=glist;!(NULL_P(gpart)||!(NFALSEP(foundflag)));gpart=CDR(gpart)) {
    foundflag=BOOL_F;
    lit=CAR(gpart);
    val=VECTOR_REF(GLOBAL(propvar_value_global),lit);
    if(val==npol) {
      foundflag=BOOL_T;
    }
    else
      for(spart=slist;!(NULL_P(spart));spart=CDR(spart))
        if(lit==CAR(spart)) {
          foundflag=BOOL_T;
        }
  }
  return foundflag;
}

SCM prop_sort_splittable(clauselst)
SCM clauselst;
{
  SCM tmp;

  tmp=map1(prop_sort_splittable_fn704,clauselst);
  return map1(prop_sort_splittable_fn703,prop_sort_splittable_aux(tmp));
}

SCM prop_sort_splittable_fn704(x)
SCM x;
{
  return cons(prop_clause_occ_sum(x),x);
}

SCM prop_sort_splittable_fn703(x)
SCM x;
{
  return CDR(x);
}

SCM prop_clause_occ_sum(cl)
SCM cl;
{
  SCM sum_nonkeyword;

  sum_nonkeyword=MAKINUM(0);
  for_each1_inst2(&sum_nonkeyword,prop_clause_occ_sum_fn706,CAR(CDR(CDR(CDR(cl)))));
  return sum_nonkeyword;
}

SCM prop_clause_occ_sum_fn706(sum_nonkeyword,x)
SCM *sum_nonkeyword;
SCM x;
{
  *sum_nonkeyword=MAKINUM(INUM(*sum_nonkeyword)+(INUM(length(VECTOR_REF(GLOBAL(propvar_negative_occ_clauses_global),x)))+INUM(length(VECTOR_REF(GLOBAL(propvar_positive_occ_clauses_global),x)))));
  return UNSPECIFIED;
}

SCM prop_sort_splittable_aux(clauselst)
SCM clauselst;
{
  SCM part1,part2,tmp,len;

  part1=EOL;
  part2=EOL;
  tmp=EOL;
  len=length(clauselst);
  if(NULL_P(clauselst))
    return clauselst;
  else
  if(NULL_P(CDR(clauselst)))
    return clauselst;
  else {
    tmp=prop_sort_splittable_split(clauselst,MAKINUM(INUM(len)/2));
    return prop_sort_splittable_merge(prop_sort_splittable_aux(CAR(tmp)),prop_sort_splittable_aux(CDR(tmp)));
  }
}

SCM prop_sort_splittable_merge(lst1,lst2)
SCM lst1,lst2;
{
  SCM m1,m2;

  m1=MAKINUM(0);
  m2=MAKINUM(0);
  if(NULL_P(lst1))
    return lst2;
  else
  if(NULL_P(lst2))
    return lst1;
  else
  if(CAR(CAR(lst1))>=CAR(CAR(lst2)))
    return cons(CAR(lst1),prop_sort_splittable_merge(CDR(lst1),lst2));
  else
    return cons(CAR(lst2),prop_sort_splittable_merge(lst1,CDR(lst2)));
}

SCM prop_sort_splittable_split(clause,halfnr)
SCM clause,halfnr;
{
  SCM p1,part,nr;

  p1=EOL;
  for(part=clause,nr=MAKINUM(0);
      !(NULL_P(part)||(nr>=halfnr));
      part=CDR(part),nr=MAKINUM(1+INUM(nr))) {
    p1=cons(CAR(part),p1);
  }
  return cons(p1,part);
}

SCM external_solve_prop_clauses(propclauses,prop_atom_maxnr,one_pass_time)
SCM propclauses,prop_atom_maxnr,one_pass_time;
{
  SCM time,callstr,infile,mainport,tempport,headerport,res;

  time=MAKINUM((INUM(one_pass_time)/2)/INUM(GLOBAL(internal_time_units_per_second_global)));
  callstr=const_598;
  infile=EOL;
  mainport=EOL;
  tempport=EOL;
  headerport=EOL;
  res=EOL;
  infile=GLOBAL(prop_conversion_file_name_global);
  if(NFALSEP(GLOBAL(prop_conversion_to_file_global))&&NFALSEP(GLOBAL(sat_strategy_flag_global))) {
    if(NFALSEP(GLOBAL(prop_conversion_temp_file_port_global)))
      close_port(GLOBAL(prop_conversion_temp_file_port_global));
    headerport=open_file(GLOBAL(prop_conversion_header_file_name_global),const_599);
    display(st_append(cons(const_600,cons(number2string(prop_atom_maxnr,MAKINUM(10)),cons(const_601,cons(number2string(GLOBAL(prop_conversion_output_clause_nr_global),MAKINUM(10)),cons(const_602,EOL)))))),headerport);
    close_port(headerport);
    callstr=st_append(cons(const_603,cons(GLOBAL(prop_conversion_header_file_name_global),cons(const_604,cons(GLOBAL(prop_conversion_temp_file_name_global),cons(const_605,cons(GLOBAL(prop_conversion_file_name_global),EOL)))))));
    display(const_606,cur_output_port());
    display(callstr,cur_output_port());
    newline(cur_output_port());
    lsystem(callstr);
  }
  else
    make_prop_infile(infile,propclauses,prop_atom_maxnr,one_pass_time);
  res=call_prop_prover(GLOBAL(global_prop_prover_global),infile,time);
  if(res==BOOL_F) {
    GLOBAL(prop_time_ran_out_global)=BOOL_F;
    return BOOL_F;
  }
  else
  if(res==BOOL_T) {
    GLOBAL(prop_time_ran_out_global)=BOOL_F;
    return BOOL_T;
  }
  else
  if(res==EOL) {
    GLOBAL(prop_time_ran_out_global)=BOOL_T;
    return BOOL_T;
  }
  else {
    GLOBAL(prop_time_ran_out_global)=BOOL_T;
    return BOOL_F;
  }
}

SCM call_prop_prover(prover,file,time)
SCM prover,file,time;
{
  SCM callstring,tmp,tmptime,timelimit;

  callstring=const_607;
  tmp=EOL;
  tmptime=MAKINUM(0);
  timelimit=const_608;
  tmptime=MAKINUM(INUM(GLOBAL(one_pass_time_global))-(INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global))));
  if(INUM(tmptime)<(2*INUM(GLOBAL(internal_time_units_per_second_global)))) {
    tmptime=MAKINUM(0);
  }
  timelimit=MAKINUM(INUM(tmptime)/INUM(GLOBAL(internal_time_units_per_second_global)));
  timelimit=number2string(timelimit,MAKINUM(10));
  callstring=st_append(cons(st_append(cons((NFALSEP(GLOBAL(intepreter_mode_global)) ? symbol2string(prover) : st_append(cons(path_string_startpart(CAR(GLOBAL(gandalf_program_arguments_global))),cons(symbol2string(prover),EOL)))),cons(st_append(cons(const_609,cons(st_append(cons(file,cons(st_append(cons(const_610,cons(timelimit,EOL))),EOL))),EOL))),EOL))),cons(st_append(cons(const_611,cons(GLOBAL(prop_conversion_result_file_name_global),EOL))),EOL)));
  display(const_612,cur_output_port());
  display(callstring,cur_output_port());
  newline(cur_output_port());
  tmp=lsystem(callstring);
  if(NFALSEP(check_prop_prover_outfile(GLOBAL(prop_conversion_result_file_name_global),const_613)))
    return BOOL_T;
  else
  if(NFALSEP(check_prop_prover_outfile(GLOBAL(prop_conversion_result_file_name_global),const_614)))
    return BOOL_F;
  else
    return EOL;
}

SCM check_prop_prover_outfile(filename,checkstring)
SCM filename,checkstring;
{
  SCM line,searchlst,searchstr,lst,chr,port,chr__1;

  port=open_file(filename,const_615);
  chr=EOL;
  lst=EOL;
  searchstr=const_616;
  searchlst=EOL;
  line=const_617;
  searchstr=checkstring;
  searchlst=string2list(searchstr);
  if(!(NFALSEP(port))||NULL_P(port)) {
    newline(cur_output_port());
    display(const_618,cur_output_port());
    newline(cur_output_port());
    return quit(1);
  }
  else {
    for(chr__1=scm_read_char(port);!(NFALSEP(eof_objectp(chr__1)));chr__1=scm_read_char(port)) {
      lst=cons(chr__1,lst);
    }
    close_port(port);
    lst=reverse(lst);
    if(NFALSEP(sublist_pred_(searchlst,lst))) {
      return BOOL_T;
    }
    else {
      return BOOL_F;
    }
  }
}

SCM sublist_pred_(small,big)
SCM small,big;
{
  SCM new_var1;

tailrecursion:
  if(NULL_P(small))
    return BOOL_T;
  else
  if(NULL_P(big))
    return BOOL_F;
  else {
    new_var1=sublist_aux_pred_(small,big);
    if(NFALSEP(new_var1))
      return new_var1;
    else {
      big=CDR(big);
      goto tailrecursion;
    }
  }
}

SCM sublist_aux_pred_(small,big)
SCM small,big;
{
  SCM tmp_var1,tmp_var2;

tailrecursion:
  if(NULL_P(small))
    return BOOL_T;
  else
  if(NULL_P(big))
    return BOOL_F;
  else
  if(CAR(small)==CAR(big)) {
    tmp_var1=CDR(small);
    tmp_var2=CDR(big);
    small=tmp_var1;
    big=tmp_var2;
    goto tailrecursion;
  }
  else
    return BOOL_F;
}

SCM make_prop_infile(filename,propclauses,prop_atom_maxnr,one_pass_time)
SCM filename,propclauses,prop_atom_maxnr,one_pass_time;
{
  SCM port;

  port=EOL;
  port=open_file(filename,const_619);
  display(const_620,port);
  display(prop_atom_maxnr,port);
  display(const_621,port);
  display(length(propclauses),port);
  newline(port);
  if(0) {
    display(const_622,cur_output_port());
    newline(cur_output_port());
    for_each1(make_prop_infile_fn711,propclauses);
  }
  for_each1_inst3(port,make_prop_infile_fn714,propclauses);
  return close_port(port);
}

SCM make_prop_infile_fn714(port,cl)
SCM port,cl;
{
  return output_prop_clause(cl,port);
}

SCM make_prop_infile_fn711(cl)
SCM cl;
{
  for_each1(make_prop_infile_fn712,CAR(cl));
  for_each1(make_prop_infile_fn713,CDR(cl));
  return newline(cur_output_port());
}

SCM make_prop_infile_fn713(lit)
SCM lit;
{
  display(lit,cur_output_port());
  return display(const_623,cur_output_port());
}

SCM make_prop_infile_fn712(lit)
SCM lit;
{
  display(MAKINUM(0-INUM(lit)),cur_output_port());
  return display(const_624,cur_output_port());
}

SCM output_prop_clause(cl,port)
SCM cl,port;
{
  if(0) {
    for_each1(output_prop_clause_fn719,CAR(cl));
    for_each1(output_prop_clause_fn720,CDR(cl));
    display(MAKINUM(0),cur_output_port());
    newline(cur_output_port());
  }
  for_each1_inst3(port,output_prop_clause_fn721,CAR(cl));
  for_each1_inst3(port,output_prop_clause_fn722,CDR(cl));
  GLOBAL(prop_conversion_output_clause_nr_global)=MAKINUM(1+INUM(GLOBAL(prop_conversion_output_clause_nr_global)));
  display(MAKINUM(0),port);
  return newline(port);
}

SCM output_prop_clause_fn722(port,lit)
SCM port,lit;
{
  display(lit,port);
  return display(const_625,port);
}

SCM output_prop_clause_fn721(port,lit)
SCM port,lit;
{
  display(MAKINUM(0-INUM(lit)),port);
  return display(const_626,port);
}

SCM output_prop_clause_fn720(lit)
SCM lit;
{
  display(lit,cur_output_port());
  return display(const_627,cur_output_port());
}

SCM output_prop_clause_fn719(lit)
SCM lit;
{
  display(MAKINUM(0-INUM(lit)),cur_output_port());
  return display(const_628,cur_output_port());
}

SCM open_prop_temp_output_file(filename)
SCM filename;
{
  SCM port;

  port=EOL;
  if(NFALSEP(GLOBAL(prop_conversion_temp_file_port_global)))
    close_port(GLOBAL(prop_conversion_temp_file_port_global));
  port=open_file(filename,const_629);
  GLOBAL(prop_conversion_output_clause_nr_global)=MAKINUM(0);
  GLOBAL(prop_conversion_temp_file_port_global)=port;
  return UNSPECIFIED;
}

SCM tstprop()
{
  SCM maxvar,internalclauses,res;

  maxvar=MAKINUM(5);
  internalclauses=EOL;
  res=EOL;
  create_prop_var_vectors(maxvar);
  res=solve_prop_clauses(GLOBAL(prop_in_global),maxvar);
  newline(cur_output_port());
  display(const_630,cur_output_port());
  display(res,cur_output_port());
  newline(cur_output_port());
  return show_prop_internal_data(internalclauses,maxvar);
}

SCM show_prop_internal_data(clauses,maxvar)
SCM clauses,maxvar;
{
  SCM var;

  maxvar=GLOBAL(prop_atom_maxnr_global);
  newline(cur_output_port());
  display(const_631,cur_output_port());
  display(maxvar,cur_output_port());
  display(const_632,cur_output_port());
  newline(cur_output_port());
  for(var=MAKINUM(0);!(var>maxvar);var=MAKINUM(1+INUM(var))) {
    display(var,cur_output_port());
    display(const_633,cur_output_port());
    display(VECTOR_REF(GLOBAL(propvar_value_global),var),cur_output_port());
    display(const_634,cur_output_port());
    display(VECTOR_REF(GLOBAL(propvar_enqued_value_global),var),cur_output_port());
    display(const_635,cur_output_port());
    newline(cur_output_port());
    display(const_636,cur_output_port());
    display(VECTOR_REF(GLOBAL(propvar_positive_occ_clauses_global),var),cur_output_port());
    newline(cur_output_port());
    display(const_637,cur_output_port());
    display(VECTOR_REF(GLOBAL(propvar_negative_occ_clauses_global),var),cur_output_port());
    newline(cur_output_port());
  }
  newline(cur_output_port());
  display(const_638,cur_output_port());
  newline(cur_output_port());
  for_each1(show_prop_internal_data_fn724,clauses);
  newline(cur_output_port());
  display(const_639,cur_output_port());
  newline(cur_output_port());
  display(const_640,cur_output_port());
  display(GLOBAL(prop_var_assignment_queue_global),cur_output_port());
  newline(cur_output_port());
  display(const_641,cur_output_port());
  newline(cur_output_port());
  display(const_642,cur_output_port());
  display(GLOBAL(prop_assigned_varvalpairs_global),cur_output_port());
  newline(cur_output_port());
  display(const_643,cur_output_port());
  newline(cur_output_port());
  display(const_644,cur_output_port());
  display(GLOBAL(prop_unsat_found_occlistpart_global),cur_output_port());
  return newline(cur_output_port());
}

SCM show_prop_internal_data_fn724(cl)
SCM cl;
{
  display(cl,cur_output_port());
  return newline(cur_output_port());
}

SCM tst(x)
SCM x;
{
  GLOBAL(prop_orig_constants_global)=const_645;
  GLOBAL(prop_orig_funs_global)=const_646;
  GLOBAL(prop_orig_preds_global)=const_647;
  apply(GLOBAL(pretty_print),GLOBAL(prop_interp_value_pairs_global),listofnull);
  newline(cur_output_port());
  apply(GLOBAL(pretty_print),GLOBAL(prop_constants_mapping_global),listofnull);
  newline(cur_output_port());
  apply(GLOBAL(pretty_print),GLOBAL(prop_fun_mappings_global),listofnull);
  return newline(cur_output_port());
}

SCM random_size_int(l)
SCM l;
{
  SCM trial;

tailrecursion:
  trial=string2number(make_string(l,MAKICHR('f')),MAKINUM(16));
  if(NFALSEP(exactp(trial))&&(GLOBAL(most_positive_fixnum)>=trial))
    return l;
  else {
    l=MAKINUM(INUM(l)-1);
    goto tailrecursion;
  }
}

SCM random_chunk(v)
SCM v;
{
  SCM p,ans;

  p=VECTOR_REF(v,GLOBAL(random_size));
  ans=MAKINUM(INUM(VECTOR_REF(v,modulo(MAKINUM(INUM(p)-INUM(GLOBAL(random_tap))),GLOBAL(random_size))))^INUM(VECTOR_REF(v,p)));
  VECTOR_SET(v,p,ans);
  VECTOR_SET(v,GLOBAL(random_size),modulo(MAKINUM(INUM(p)-1),GLOBAL(random_size)));
  return ans;
}

SCM random_random(modu,args)
SCM modu,args;
{
  SCM s,ilen,state,slop;

  if(NULL_P(args))
    state=GLOBAL(random_state_global);
  else
    state=CAR(args);
  if(1) {
    for(ilen=MAKINUM(0),s=GLOBAL(random_mask);
        !(INUM(s)>=(INUM(modu)-1));
        ilen=MAKINUM(1+INUM(ilen)),s=MAKINUM(INUM(GLOBAL(random_mask))+((1+INUM(GLOBAL(random_mask)))*INUM(s)))) ;
    slop=modulo(MAKINUM(INUM(s)+(1-INUM(modu))),modu);
    return random_random_fn725(slop,ilen,modu,state,ilen,random_chunk(state));
  }
  else
    return MAKINUM(1);
}

SCM random_random_fn725(slop,ilen,modu,state,n,r)
SCM slop,ilen,modu,state,n,r;
{
  SCM tmp_var1,tmp_var2;

tailrecursion:
  if(!(ZERO_P(n))) {
    tmp_var1=MAKINUM(-1+INUM(n));
    tmp_var2=MAKINUM((INUM(r)*(1+INUM(GLOBAL(random_mask))))+INUM(random_chunk(state)));
    n=tmp_var1;
    r=tmp_var2;
    goto tailrecursion;
  }
  else
  if(r>=slop)
    return modulo(r,modu);
  else {
    tmp_var1=ilen;
    tmp_var2=random_chunk(state);
    n=tmp_var1;
    r=tmp_var2;
    goto tailrecursion;
  }
}

SCM random_make_random_state(args)
SCM args;
{
  SCM state;

  if(NULL_P(args))
    state=GLOBAL(random_state_global);
  else
    state=CAR(args);
  return vector(vector2list(state));
}

SCM prop_uncurry_clauses(clauses)
SCM clauses;
{
  SCM res;

  res=EOL;
  res=map1(prop_uncurry_clauses_fn727,clauses);
  return res;
}

SCM prop_uncurry_clauses_fn727(x)
SCM x;
{
  return cons(CAR(x),prop_uncurry_clause(CDR(x)));
}

SCM prop_uncurry_clause(clause)
SCM clause;
{
  SCM res;

  res=EOL;
  res=map1(prop_uncurry_clause_fn729,clause);
  return res;
}

SCM prop_uncurry_clause_fn729(x)
SCM x;
{
  return prop_uncurry_term(x);
}

SCM prop_uncurry_term(term)
SCM term;
{
  SCM res,fun,args;

  res=EOL;
  fun=EOL;
  args=EOL;
  if(PAIR_P(term)) {
    fun=CAR(term);
    args=CDR(term);
    if(PAIR_P(args)&&NFALSEP(curry_const_pred_(CAR(args)))) {
      fun=(MAKINUM(INUM(CAR(args))-200000)|(MAKINUM(534773760)&fun));
      args=CDR(args);
    }
    else {
      fun=(MAKINUM(534773760)&fun);
    }
    args=map1(prop_uncurry_term_fn731,args);
    return cons(fun,args);
  }
  else
    return term;
}

SCM prop_uncurry_term_fn731(x)
SCM x;
{
  return prop_uncurry_term(x);
}

SCM prop_spec_pure_fun(x)
SCM x;
{
  return x;
}

SCM prop_spec_pure_unsigned_fun(x)
SCM x;
{
  if(!(ZERO_P(MAKINUM(268435456)&x)))
    return MAKINUM(INUM(x)^268435456);
  else
    return x;
}

SCM prop_groundprocess_clauses(readylst)
SCM readylst;
{
  SCM res,tmp,sosaddedflag;

  res=EOL;
  tmp=EOL;
  sosaddedflag=BOOL_F;
  GLOBAL(prop_groundprocess_const_nr_global)=MAKINUM(100000);
  GLOBAL(prop_groundprocess_term_const_pairs_global)=EOL;
  res=prop_groundprocess_clause_list(readylst);
  if(NULL_P(GLOBAL(prop_groundprocess_term_const_pairs_global))) {
    res=readylst;
  }
  else {
    res=append2(prop_groundprocess_make_equalities(),res);
    newline(cur_output_port());
    display(const_648,cur_output_port());
    newline(cur_output_port());
  }
  return res;
}

SCM prop_groundprocess_make_equalities()
{
  SCM tmp,varsymb,eqfun;

  tmp=EOL;
  varsymb=EOL;
  eqfun=EOL;
  eqfun=GLOBAL(eq_pred_nr_global);
  tmp=map1_inst1(eqfun,prop_groundprocess_make_equalities_fn733,GLOBAL(prop_groundprocess_term_const_pairs_global));
  varsymb=MAKINUM(1);
  tmp=cons(cons(EOL,cons(cons(eqfun,cons(varsymb,cons(varsymb,EOL))),EOL)),tmp);
  return tmp;
}

SCM prop_groundprocess_make_equalities_fn733(eqfun,x)
SCM eqfun,x;
{
  return cons(EOL,cons(cons(eqfun,cons(CAR(x),cons(CDR(x),EOL))),EOL));
}

SCM prop_groundprocess_clause_list(clauselst)
SCM clauselst;
{
  return map1(prop_groundprocess_clause_list_fn735,clauselst);
}

SCM prop_groundprocess_clause_list_fn735(x)
SCM x;
{
  return cons(CAR(x),prop_groundprocess_clause(CDR(x)));
}

SCM prop_groundprocess_clause(clause)
SCM clause;
{
  return map1(prop_groundprocess_clause_fn737,clause);
}

SCM prop_groundprocess_clause_fn737(x)
SCM x;
{
  return prop_groundprocess_lit(x);
}

SCM prop_groundprocess_lit(lit)
SCM lit;
{
  SCM tmp;

  tmp=EOL;
  if(!(PAIR_P(lit)))
    return lit;
  else {
    tmp=map1(prop_groundprocess_lit_fn739,CDR(lit));
    return cons(CAR(lit),tmp);
  }
}

SCM prop_groundprocess_lit_fn739(x)
SCM x;
{
  return prop_groundprocess_term(x);
}

SCM prop_groundprocess_term(term)
SCM term;
{
  SCM tmp,newc;

  tmp=EOL;
  newc=EOL;
  if(!(PAIR_P(term)))
    return term;
  else {
    tmp=map1(prop_groundprocess_term_fn742,CDR(term));
    if(NFALSEP(every_pred_(prop_groundprocess_term_fn743,tmp))) {
      newc=assoc(cons(CAR(term),tmp),GLOBAL(prop_groundprocess_term_const_pairs_global));
      if(NFALSEP(newc))
        return CDR(newc);
      else {
        newc=prop_groundprocess_term_newconstant();
        GLOBAL(prop_groundprocess_term_const_pairs_global)=cons(cons(cons(CAR(term),tmp),newc),GLOBAL(prop_groundprocess_term_const_pairs_global));
        return newc;
      }
    }
    else
      return cons(CAR(term),tmp);
  }
}

SCM prop_groundprocess_term_fn743(y)
SCM y;
{
  return SBOOL(NUMBER_P(y)&&(y>MAKINUM(65535)));
}

SCM prop_groundprocess_term_fn742(x)
SCM x;
{
  return prop_groundprocess_term(x);
}

SCM prop_groundprocess_term_newconstant()
{
  GLOBAL(prop_groundprocess_const_nr_global)=MAKINUM(1+INUM(GLOBAL(prop_groundprocess_const_nr_global)));
  return GLOBAL(prop_groundprocess_const_nr_global);
}

SCM props_build_model(predclauses)
SCM predclauses;
{
  return props_build_model_aux(predclauses);
}

SCM props_build_model_0(predclauses)
SCM predclauses;
{
  GLOBAL(props_selection_strategy_global)=MAKINUM(0);
  return props_build_model_aux(predclauses);
}

SCM props_build_model_1(predclauses)
SCM predclauses;
{
  GLOBAL(props_selection_strategy_global)=MAKINUM(1);
  return props_build_model_aux(predclauses);
}

SCM props_build_model_2(predclauses)
SCM predclauses;
{
  GLOBAL(props_selection_strategy_global)=MAKINUM(2);
  return props_build_model_aux(predclauses);
}

SCM props_build_model_3(predclauses)
SCM predclauses;
{
  GLOBAL(props_selection_strategy_global)=MAKINUM(3);
  return props_build_model_aux(predclauses);
}

SCM props_build_model_4(predclauses)
SCM predclauses;
{
  GLOBAL(props_selection_strategy_global)=MAKINUM(4);
  return props_build_model_aux(predclauses);
}

SCM props_build_model_5(predclauses)
SCM predclauses;
{
  GLOBAL(props_selection_strategy_global)=MAKINUM(5);
  return props_build_model_aux(predclauses);
}

SCM props_build_model_6(predclauses)
SCM predclauses;
{
  GLOBAL(props_selection_strategy_global)=MAKINUM(6);
  return props_build_model_aux(predclauses);
}

SCM props_build_model_aux(predclauses)
SCM predclauses;
{
  SCM res,groundpropclauses,nongroundpropclauses,tmpnr,tmp,domainsize,stopflag,domainsize__1;

  stopflag=BOOL_F;
  domainsize=MAKINUM(0);
  tmp=EOL;
  tmpnr=MAKINUM(0);
  nongroundpropclauses=EOL;
  groundpropclauses=EOL;
  res=BOOL_F;
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(0)) {
    newline(cur_output_port());
    display(const_649,cur_output_port());
  }
  else
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(1)) {
    newline(cur_output_port());
    display(const_650,cur_output_port());
  }
  else
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(2)) {
    newline(cur_output_port());
    display(const_651,cur_output_port());
  }
  else
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(3)) {
    newline(cur_output_port());
    display(const_652,cur_output_port());
  }
  else
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(4)) {
    newline(cur_output_port());
    display(const_653,cur_output_port());
  }
  else
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(5)) {
    newline(cur_output_port());
    display(const_654,cur_output_port());
  }
  else {
    newline(cur_output_port());
    display(const_655,cur_output_port());
  }
  newline(cur_output_port());
  GLOBAL(props_timecheck_counter_global)=MAKINUM(0);
  GLOBAL(props_stop_search_flag_global)=BOOL_F;
  GLOBAL(prop_time_ran_out_global)=BOOL_F;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(slow_start_time_global)=get_check_time(MAKINUM(0));
  store_time_checkpoint_excl_(MAKINUM(0));
  extract_pred_data_to_prop(predclauses);
  if(NFALSEP(GLOBAL(props_debug_global))) {
    newline(cur_output_port());
    display(const_656,cur_output_port());
    newline(cur_output_port());
    display(const_657,cur_output_port());
    newline(cur_output_port());
    for_each1(props_build_model_aux_fn752,predclauses);
    newline(cur_output_port());
  }
  GLOBAL(props_eq_fun_global)=BOOL_F;
  nongroundpropclauses=props_make_nonground_clauses(predclauses);
  if(NFALSEP(GLOBAL(props_debug_global))) {
    newline(cur_output_port());
    display(const_658,cur_output_port());
    newline(cur_output_port());
    for_each1(props_build_model_aux_fn753,nongroundpropclauses);
    newline(cur_output_port());
    for_each1(props_build_model_aux_fn754,nongroundpropclauses);
    newline(cur_output_port());
  }
  if(NULL_P(GLOBAL(prop_orig_funs_global)))
    return EOL;
  else {
    for(domainsize__1=MAKINUM(1);!(NFALSEP(stopflag)||(NFALSEP(GLOBAL(props_stop_search_flag_global))||((res==BOOL_T)||NFALSEP((((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))) ? (store_time_checkpoint_excl_(MAKINUM(110)),GLOBAL(prop_time_ran_out_global)=BOOL_T,UNSPECIFIED,BOOL_T) : BOOL_F)))));domainsize__1=MAKINUM(1+INUM(domainsize__1))) {
      if(1) {
        newline(cur_output_port());
        display(const_659,cur_output_port());
        display(domainsize__1,cur_output_port());
        newline(cur_output_port());
      }
      GLOBAL(props_split_sel_count_global)=MAKINUM(0);
      GLOBAL(props_assign_count_global)=MAKINUM(0);
      GLOBAL(props_restrict_count_global)=MAKINUM(0);
      GLOBAL(props_rewrite_count_global)=MAKINUM(0);
      GLOBAL(props_nterm_assign_count_global)=MAKINUM(0);
      GLOBAL(props_nterm_restrict_count_global)=MAKINUM(0);
      GLOBAL(props_nterm_derive_count_global)=MAKINUM(0);
      GLOBAL(props_clause_count_global)=MAKINUM(0);
      groundpropclauses=props_saturate_clauses(nongroundpropclauses,domainsize__1);
      if(!(groundpropclauses==BOOL_T)) {
        if(NFALSEP(GLOBAL(props_debug_global))&&NFALSEP(res)) {
          newline(cur_output_port());
          display(const_660,cur_output_port());
          newline(cur_output_port());
          for_each1(props_build_model_aux_fn755,groundpropclauses);
          newline(cur_output_port());
        }
        if(!(NFALSEP(GLOBAL(props_stop_search_flag_global))))
          props_init_indexes(domainsize__1);
        if(!(NFALSEP(GLOBAL(props_stop_search_flag_global))))
          props_store_initial_occurrences(groundpropclauses,domainsize__1);
        if(NFALSEP(GLOBAL(props_debug_global))) {
          newline(cur_output_port());
          display(const_661,cur_output_port());
          newline(cur_output_port());
          for_each1(props_build_model_aux_fn756,groundpropclauses);
          newline(cur_output_port());
          props_print_vectors();
        }
        if(!(NFALSEP(GLOBAL(props_stop_search_flag_global))))
          props_init_equality(domainsize__1);
        if(!(NFALSEP(GLOBAL(props_stop_search_flag_global)))) {
          res=props_initial_propagate(groundpropclauses,domainsize__1);
        }
        if(NFALSEP(res)&&NFALSEP(GLOBAL(props_debug_global))) {
          newline(cur_output_port());
          display(const_662,cur_output_port());
          for_each1(props_build_model_aux_fn757,groundpropclauses);
          newline(cur_output_port());
          props_print_vectors();
        }
        if(!(res==BOOL_F)&&!(NFALSEP(GLOBAL(props_stop_search_flag_global)))) {
          res=props_initial_analyze_clauses(groundpropclauses,domainsize__1);
        }
        if(NFALSEP(GLOBAL(props_small_debug_global))||NFALSEP(GLOBAL(props_debug_global))) {
          newline(cur_output_port());
          display(const_663,cur_output_port());
          for_each1(props_build_model_aux_fn758,groundpropclauses);
          newline(cur_output_port());
          props_print_vectors();
        }
        if(!(GLOBAL(props_selection_strategy_global)==MAKINUM(0))) {
          props_make_cell_measures_excl_(domainsize__1);
        }
        props_sort_cells_excl_(domainsize__1);
        if(!(res==BOOL_F)&&!(NFALSEP(GLOBAL(props_stop_search_flag_global)))) {
          res=props_split_cells_incremental(groundpropclauses,domainsize__1,MAKINUM(0),EOL,MAKINUM(1));
        }
        if(NFALSEP(GLOBAL(props_debug_global))) {
          newline(cur_output_port());
          display(const_664,cur_output_port());
          for_each1(props_build_model_aux_fn759,groundpropclauses);
          newline(cur_output_port());
          display(const_665,cur_output_port());
          newline(cur_output_port());
          props_print_vectors();
        }
        if(NFALSEP(GLOBAL(prop_time_ran_out_global))) {
          res=BOOL_F;
        }
        if(res==BOOL_T) {
          tmp=props_check_model(nongroundpropclauses,domainsize__1);
          if(NFALSEP(tmp)) {
            newline(cur_output_port());
            display(const_666,cur_output_port());
            BOOL_T;
          }
          else {
            GLOBAL(props_stop_search_flag_global)=BOOL_T;
            res=BOOL_F;
          }
        }
        else
          props_show_size_end_stats(domainsize__1);
      }
    }
    if(NFALSEP(GLOBAL(prop_time_ran_out_global))||NFALSEP(GLOBAL(props_stop_search_flag_global))) {
      if(GLOBAL(display_info_level_global)>MAKINUM(38)) {
        newline(cur_output_port());
        display(const_667,cur_output_port());
        newline(cur_output_port());
      }
      return BOOL_F;
    }
    else
      return res;
  }
}

SCM props_build_model_aux_fn759(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_ground_clause(x);
}

SCM props_build_model_aux_fn758(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_ground_clause(x);
}

SCM props_build_model_aux_fn757(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_ground_clause(x);
}

SCM props_build_model_aux_fn756(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_ground_clause(x);
}

SCM props_build_model_aux_fn755(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_ground_clause(x);
}

SCM props_build_model_aux_fn754(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_nonground_clause(x);
}

SCM props_build_model_aux_fn753(x)
SCM x;
{
  newline(cur_output_port());
  return display(x,cur_output_port());
}

SCM props_build_model_aux_fn752(x)
SCM x;
{
  newline(cur_output_port());
  return display(x,cur_output_port());
}

SCM props_initial_propagate(clauses,domainsize)
SCM clauses,domainsize;
{
  SCM stopflag,assignres,stack,value,selcell,range,res,i;

  res=EOL;
  range=EOL;
  selcell=EOL;
  value=EOL;
  stack=cons(EOL,EOL);
  assignres=EOL;
  stopflag=BOOL_F;
  for(i=MAKINUM(0);!(NFALSEP(stopflag)||(i>=GLOBAL(props_cell_nr_global)));i=MAKINUM(1+INUM(i))) {
    range=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    if(INTEGER_P(range)||NULL_P(CDR(range))) {
      if(INTEGER_P(range)) {
        value=range;
      }
      else {
        value=CAR(range);
      }
      selcell=i;
      if(NFALSEP(GLOBAL(props_debug_global))) {
        newline(cur_output_port());
        display(const_668,cur_output_port());
        display(selcell,cur_output_port());
        display(const_669,cur_output_port());
        display(value,cur_output_port());
        newline(cur_output_port());
      }
      assignres=props_propagate_cell_excl_(selcell,stack,domainsize);
      if(NFALSEP(GLOBAL(props_debug_global))) {
        newline(cur_output_port());
        display(const_670,cur_output_port());
        display(assignres,cur_output_port());
        newline(cur_output_port());
        display(const_671,cur_output_port());
        for_each1(props_initial_propagate_fn761,clauses);
        newline(cur_output_port());
        display(const_672,cur_output_port());
        newline(cur_output_port());
        props_print_vectors();
      }
      if(assignres==BOOL_T) {
        stopflag=BOOL_T;
        res=assignres;
        newline(cur_output_port());
        display(const_673,cur_output_port());
        BOOL_T;
      }
      else
      if(assignres==BOOL_F) {
        stopflag=BOOL_T;
        res=BOOL_F;
      }
    }
  }
  return res;
}

SCM props_initial_propagate_fn761(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_ground_clause(x);
}

SCM props_init_equality(domainsize)
SCM domainsize;
{
  SCM l,cell_nonkeyword,vec,r;

  cell_nonkeyword=MAKINUM(0);
  vec=EOL;
  if(!(GLOBAL(props_eq_fun_global)==BOOL_F)) {
    vec=make_vector(MAKINUM(4),EOL);
    VECTOR_SET(vec,MAKINUM(1),GLOBAL(props_eq_fun_global));
    for(l=MAKINUM(0);!(l>=domainsize);l=MAKINUM(1+INUM(l))) {
      VECTOR_SET(vec,MAKINUM(2),l);
      for(r=MAKINUM(0);!(r>=domainsize);r=MAKINUM(1+INUM(r))) {
        VECTOR_SET(vec,MAKINUM(3),r);
        cell_nonkeyword=props_cterm_index_nr(vec,domainsize);
        if(l==r) {
          VECTOR_SET(GLOBAL(props_cell_range_vector_global),cell_nonkeyword,cons(MAKINUM(1),EOL));
        }
        else {
          VECTOR_SET(GLOBAL(props_cell_range_vector_global),cell_nonkeyword,cons(MAKINUM(0),EOL));
        }
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM props_initial_analyze_clauses(clauses,domainsize)
SCM clauses,domainsize;
{
  SCM res,stack,clause,stopflag,clausespart;

  stopflag=BOOL_F;
  clause=EOL;
  stack=cons(EOL,EOL);
  res=EOL;
  for(clausespart=clauses;!(NFALSEP(stopflag)||NULL_P(clausespart));clausespart=CDR(clausespart)) {
    clause=CAR(clausespart);
    res=props_analyze_clause_excl_(clause,domainsize,stack);
    if(res==BOOL_F) {
      stopflag=BOOL_T;
    }
  }
  if(NFALSEP(stopflag))
    return BOOL_F;
  else
    return EOL;
}

SCM props_split_cells_incremental(clauses,domainsize,maxsplitvalue,touched,depth)
SCM clauses,domainsize,maxsplitvalue,touched,depth;
{
  SCM m__3,rpart,m,selcell,selcellorig,selcellrange,selcelloccurrences,selcelllength,selcellispredflag,value,stopflag,res,assignres,recres,stack,tmp,m__1,m__2,m__4;

  selcell=EOL;
  selcellorig=EOL;
  selcellrange=EOL;
  selcelloccurrences=EOL;
  selcelllength=MAKINUM(0);
  selcellispredflag=BOOL_F;
  value=MAKINUM(0);
  stopflag=BOOL_F;
  res=EOL;
  assignres=EOL;
  recres=EOL;
  stack=cons(EOL,EOL);
  tmp=EOL;
  if(NFALSEP(GLOBAL(props_debug_global))) {
    newline(cur_output_port());
    display(const_674,cur_output_port());
    display(depth,cur_output_port());
    newline(cur_output_port());
  }
  if((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))) {
    store_time_checkpoint_excl_(MAKINUM(111));
    GLOBAL(prop_time_ran_out_global)=BOOL_T;
    GLOBAL(props_stop_search_flag_global)=BOOL_T;
  }
  if(!(NFALSEP(GLOBAL(props_stop_search_flag_global)))) {
    selcell=props_select_split_cell(clauses,domainsize,maxsplitvalue,depth);
  }
  if(NFALSEP(GLOBAL(props_small_debug_global))||NFALSEP(GLOBAL(props_debug_global))) {
    newline(cur_output_port());
    for(m=MAKINUM(0);!(m>=depth);m=MAKINUM(1+INUM(m)))
      display(const_675,cur_output_port());
    display(const_676,cur_output_port());
    display(selcell,cur_output_port());
  }
  if(!(NFALSEP(selcell))||NFALSEP(GLOBAL(props_stop_search_flag_global))) {
    if(NFALSEP(GLOBAL(props_stop_search_flag_global))) {
      return BOOL_F;
    }
    else {
      props_show_success_stats(domainsize,depth);
      return BOOL_T;
    }
  }
  else {
    GLOBAL(props_split_sel_count_global)=MAKINUM(1+INUM(GLOBAL(props_split_sel_count_global)));
    selcellorig=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),selcell);
    selcellrange=VECTOR_REF(GLOBAL(props_cell_range_vector_global),selcell);
    selcelloccurrences=VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),selcell);
    selcelllength=VECTOR_LENGTH(selcellorig);
    selcellispredflag=props_term_is_surely_lit_pred_(selcellorig);
    if(NFALSEP(selcellispredflag)) {
      tmp=MAKINUM(-1);
    }
    else {
      tmp=apply(GLOBAL(props_cterm_max_arg),selcellorig,listofnull);
    }
    if(tmp>=maxsplitvalue) {
      maxsplitvalue=MAKINUM(1+INUM(tmp));
    }
    if(NFALSEP(GLOBAL(props_small_debug_global))||NFALSEP(GLOBAL(props_debug_global))) {
      newline(cur_output_port());
      for(m__1=MAKINUM(0);!(m__1>=depth);m__1=MAKINUM(1+INUM(m__1)))
        display(const_677,cur_output_port());
      display(const_678,cur_output_port());
      display(maxsplitvalue,cur_output_port());
    }
    stopflag=BOOL_F;
    res=EOL;
    for(rpart=selcellrange;!(NULL_P(rpart)||(NFALSEP(stopflag)||NFALSEP(GLOBAL(props_stop_search_flag_global))));rpart=CDR(rpart)) {
      value=CAR(rpart);
      if(value<=maxsplitvalue) {
        if(NFALSEP(GLOBAL(props_debug_global))) {
          display(const_679,cur_output_port());
          for_each1(props_split_cells_incremental_fn765,clauses);
          newline(cur_output_port());
          display(const_680,cur_output_port());
          newline(cur_output_port());
          props_print_vectors();
          newline(cur_output_port());
        }
        if(NFALSEP(GLOBAL(props_small_debug_global))||NFALSEP(GLOBAL(props_debug_global))) {
          newline(cur_output_port());
          for(m__2=MAKINUM(0);!(m__2>=depth);m__2=MAKINUM(1+INUM(m__2)))
            display(const_681,cur_output_port());
          display(const_682,cur_output_port());
          display(value,cur_output_port());
        }
        assignres=props_assign_cell_excl_(selcell,value,stack,domainsize);
        if(NFALSEP(GLOBAL(props_small_debug_global))||NFALSEP(GLOBAL(props_debug_global))) {
          newline(cur_output_port());
          for(m__3=MAKINUM(0);!(m__3>=depth);m__3=MAKINUM(1+INUM(m__3)))
            display(const_683,cur_output_port());
          display(const_684,cur_output_port());
          display(assignres,cur_output_port());
        }
        if(NFALSEP(GLOBAL(props_debug_global))) {
          newline(cur_output_port());
          display(const_685,cur_output_port());
          for_each1(props_split_cells_incremental_fn766,clauses);
          newline(cur_output_port());
          display(const_686,cur_output_port());
          newline(cur_output_port());
          props_print_vectors();
        }
        if(assignres==BOOL_T) {
          stopflag=BOOL_T;
          res=assignres;
          newline(cur_output_port());
          display(const_687,cur_output_port());
          BOOL_T;
        }
        else
        if(assignres==BOOL_F) {
          if(0) {
            newline(cur_output_port());
            display(const_688,cur_output_port());
            for_each1(props_split_cells_incremental_fn767,clauses);
            newline(cur_output_port());
            display(const_689,cur_output_port());
            newline(cur_output_port());
            props_print_vectors();
          }
          props_restore_stack_excl_(assignres,stack);
        }
        else {
          recres=props_split_cells_incremental(clauses,domainsize,((!(NFALSEP(selcellispredflag))&&(value>=maxsplitvalue)) ? MAKINUM(1+INUM(value)) : maxsplitvalue),(!(NFALSEP(memq(value,touched))) ? cons(value,touched) : touched),MAKINUM(1+INUM(depth)));
          if(NFALSEP(GLOBAL(props_small_debug_global))||NFALSEP(GLOBAL(props_debug_global))) {
            newline(cur_output_port());
            for(m__4=MAKINUM(0);!(m__4>=depth);m__4=MAKINUM(1+INUM(m__4)))
              display(const_690,cur_output_port());
            display(const_691,cur_output_port());
            display(recres,cur_output_port());
          }
          if(recres==BOOL_T) {
            stopflag=BOOL_T;
            res=recres;
          }
          else {
            props_restore_stack_excl_(assignres,stack);
          }
        }
      }
    }
    if(NFALSEP(stopflag))
      return res;
    else
      return EOL;
  }
}

SCM props_split_cells_incremental_fn767(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_ground_clause(x);
}

SCM props_split_cells_incremental_fn766(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_ground_clause(x);
}

SCM props_split_cells_incremental_fn765(x)
SCM x;
{
  newline(cur_output_port());
  return print_props_ground_clause(x);
}

SCM props_show_success_stats(domainsize,depth)
SCM domainsize,depth;
{
  SCM i;

  if(1) {
    newline(cur_output_port());
    display(const_692,cur_output_port());
    newline(cur_output_port());
    newline(cur_output_port());
    display(const_693,cur_output_port());
    display(domainsize,cur_output_port());
    newline(cur_output_port());
    display(const_694,cur_output_port());
    display(GLOBAL(props_cell_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_695,cur_output_port());
    display(depth,cur_output_port());
    newline(cur_output_port());
    display(const_696,cur_output_port());
    display(GLOBAL(props_split_sel_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_697,cur_output_port());
    display(GLOBAL(props_assign_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_698,cur_output_port());
    display(GLOBAL(props_restrict_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_699,cur_output_port());
    display(GLOBAL(props_rewrite_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_700,cur_output_port());
    display(GLOBAL(props_nterm_assign_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_701,cur_output_port());
    display(GLOBAL(props_nterm_restrict_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_702,cur_output_port());
    display(GLOBAL(props_nterm_derive_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_703,cur_output_port());
    display(GLOBAL(props_clause_count_global),cur_output_port());
    newline(cur_output_port());
    newline(cur_output_port());
    display(const_704,cur_output_port());
    newline(cur_output_port());
    for(i=MAKINUM(0);!((i>=GLOBAL(props_cell_nr_global))||!(VECTOR_P(GLOBAL(props_cell_cterm_vector_global))));i=MAKINUM(1+INUM(i))) {
      print_props_model_term(VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i));
      display(const_705,cur_output_port());
      if(1&&NFALSEP(VECTOR_REF(GLOBAL(props_fun_ispred_vector_global),GLOBAL(props_funnr_mask_global)&VECTOR_REF(VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i),MAKINUM(1))))) {
        if(MAKINUM(1)==CAR(VECTOR_REF(GLOBAL(props_cell_range_vector_global),i)))
          display(const_706,cur_output_port());
        else
          display(const_707,cur_output_port());
      }
      else
        display(CAR(VECTOR_REF(GLOBAL(props_cell_range_vector_global),i)),cur_output_port());
      newline(cur_output_port());
    }
    display(const_708,cur_output_port());
    return newline(cur_output_port());
  }
  else
    return UNSPECIFIED;
}

SCM props_show_size_end_stats(domainsize)
SCM domainsize;
{
  if((NFALSEP(GLOBAL(props_debug_global))||NFALSEP(GLOBAL(props_small_debug_global)))&&!(NFALSEP(GLOBAL(props_stop_search_flag_global)))) {
    newline(cur_output_port());
    display(const_709,cur_output_port());
    display(GLOBAL(props_cell_nr_global),cur_output_port());
    newline(cur_output_port());
    display(const_710,cur_output_port());
    display(GLOBAL(props_split_sel_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_711,cur_output_port());
    display(GLOBAL(props_assign_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_712,cur_output_port());
    display(GLOBAL(props_restrict_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_713,cur_output_port());
    display(GLOBAL(props_rewrite_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_714,cur_output_port());
    display(GLOBAL(props_nterm_assign_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_715,cur_output_port());
    display(GLOBAL(props_nterm_restrict_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_716,cur_output_port());
    display(GLOBAL(props_nterm_derive_count_global),cur_output_port());
    newline(cur_output_port());
    display(const_717,cur_output_port());
    display(GLOBAL(props_clause_count_global),cur_output_port());
    return newline(cur_output_port());
  }
  else
    return UNSPECIFIED;
}

SCM make_touched_list(oldtouched,newcell,domainsize)
SCM oldtouched,newcell,domainsize;
{
  SCM i,stopflag,elem,celllen,cterm,cellrange,touchedlen,touched,j,j__1;

  touched=EOL;
  touchedlen=MAKINUM(0);
  cellrange=EOL;
  cterm=EOL;
  celllen=MAKINUM(0);
  elem=MAKINUM(0);
  stopflag=BOOL_F;
  touched=oldtouched;
  touchedlen=length(touched);
  cterm=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),newcell);
  celllen=VECTOR_LENGTH(cterm);
  for(j=MAKINUM(2);!((touchedlen>=domainsize)||(j>=celllen));j=MAKINUM(1+INUM(j))) {
    elem=VECTOR_REF(cterm,j);
    if(!(NFALSEP(memq(elem,touched)))) {
      touched=cons(elem,touched);
      touchedlen=MAKINUM(1+INUM(touchedlen));
    }
  }
  for(i=MAKINUM(0);!((touchedlen>=domainsize)||(i>=GLOBAL(props_cell_nr_global)));i=MAKINUM(1+INUM(i))) {
    cellrange=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    if(INTEGER_P(cellrange)||NULL_P(CDR(cellrange))) {
      if(PAIR_P(cellrange)) {
        cellrange=CAR(cellrange);
      }
      if(!(NFALSEP(memq(cellrange,touched)))) {
        touched=cons(cellrange,touched);
        touchedlen=MAKINUM(1+INUM(touchedlen));
      }
      cterm=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i);
      celllen=VECTOR_LENGTH(cterm);
      for(j__1=MAKINUM(2);!((touchedlen>=domainsize)||(j__1>=celllen));j__1=MAKINUM(1+INUM(j__1))) {
        elem=VECTOR_REF(cterm,j__1);
        if(!(NFALSEP(memq(elem,touched)))) {
          touched=cons(elem,touched);
          touchedlen=MAKINUM(1+INUM(touchedlen));
        }
      }
    }
  }
  return touched;
}

SCM props_select_split_cell(clauses,domainsize,maxsplitvalue,depth)
SCM clauses,domainsize,maxsplitvalue,depth;
{
  SCM i,j;

  i=MAKINUM(0);
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    newline(cur_output_port());
    display(const_718,cur_output_port());
    newline(cur_output_port());
    display(const_719,cur_output_port());
    display(maxsplitvalue,cur_output_port());
    display(const_720,cur_output_port());
    display(domainsize,cur_output_port());
    newline(cur_output_port());
    display(const_721,cur_output_port());
    newline(cur_output_port());
    for(j=MAKINUM(0);!(j>=GLOBAL(props_cell_nr_global));j=MAKINUM(1+INUM(j))) {
      i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j);
      display(j,cur_output_port());
      display(const_722,cur_output_port());
      display(i,cur_output_port());
      display(const_723,cur_output_port());
      display(const_724,cur_output_port());
      print_props_ground_term(VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i));
      display(const_725,cur_output_port());
      display(VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i),cur_output_port());
      display(const_726,cur_output_port());
      display(VECTOR_REF(GLOBAL(props_cell_range_vector_global),i),cur_output_port());
      display(const_727,cur_output_port());
      display(length(VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),i)),cur_output_port());
      newline(cur_output_port());
    }
  }
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(0)) {
    if(INUM(maxsplitvalue)<(INUM(domainsize)-1))
      return props_select_split_cell_restricted_initial(clauses,domainsize,maxsplitvalue,depth);
    else
      return props_select_split_cell_unrestricted(clauses,domainsize,maxsplitvalue,depth);
  }
  else
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(1)) {
    if(INUM(maxsplitvalue)<(INUM(domainsize)-1))
      return props_select_split_cell_restricted_initial(clauses,domainsize,maxsplitvalue,depth);
    else
      return props_select_split_cell_unrestricted(clauses,domainsize,maxsplitvalue,depth);
  }
  else
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(2)) {
    if(INUM(maxsplitvalue)<(INUM(domainsize)-1))
      return props_select_split_cell_restricted_initial(clauses,domainsize,maxsplitvalue,depth);
    else
      return props_select_split_cell_occurrences(clauses,domainsize,maxsplitvalue,depth);
  }
  else
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(3)) {
    if(INUM(maxsplitvalue)<(INUM(domainsize)-1))
      return props_select_split_cell_restricted_initial(clauses,domainsize,maxsplitvalue,depth);
    else
    if(props_open_occ_cell_count()>MAKINUM(2))
      return props_select_split_cell_preassign(domainsize);
    else
      return props_select_split_cell_unrestricted(clauses,domainsize,maxsplitvalue,depth);
  }
  else
  if(GLOBAL(props_selection_strategy_global)==MAKINUM(4))
    return props_select_split_cell_occurrences(clauses,domainsize,maxsplitvalue,depth);
  else
  if(props_open_occ_cell_count()>MAKINUM(2))
    return props_select_split_cell_preassign(domainsize);
  else
    return props_select_split_cell_unrestricted(clauses,domainsize,maxsplitvalue,depth);
}

SCM props_select_split_cell_restricted_initial_experiment(clauses,domainsize,maxsplitvalue,depth)
SCM clauses,domainsize,maxsplitvalue,depth;
{
  SCM bestcell,foundcell,bestnr,maxarg,nr,tmp2,tmp,i,stopflag,j;

  stopflag=BOOL_F;
  i=MAKINUM(0);
  tmp=EOL;
  tmp2=EOL;
  nr=MAKINUM(0);
  maxarg=MAKINUM(-1);
  bestnr=domainsize;
  foundcell=BOOL_F;
  bestcell=BOOL_F;
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    newline(cur_output_port());
    display(const_728,cur_output_port());
  }
  bestcell=BOOL_F;
  foundcell=BOOL_F;
  for(j=MAKINUM(0);!(NFALSEP(stopflag)||(j>=GLOBAL(props_cell_nr_global)));j=MAKINUM(1+INUM(j))) {
    i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j);
    tmp=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    if(PAIR_P(tmp)&&!(NULL_P(CDR(tmp)))) {
      nr=length(tmp);
      tmp2=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i);
      if(NFALSEP(props_term_is_surely_lit_pred_(tmp2))) {
        maxarg=MAKINUM(-1);
      }
      else {
        maxarg=apply(GLOBAL(props_cterm_max_arg),tmp2,listofnull);
      }
      if((nr<bestnr)&&(maxarg<maxsplitvalue)) {
        if(NFALSEP(props_term_is_surely_lit_pred_(tmp2))) {
          if(!(NFALSEP(foundcell))) {
            foundcell=i;
          }
        }
        else {
          if(nr<MAKINUM(3)) {
            stopflag=BOOL_T;
          }
          bestcell=i;
          bestnr=nr;
        }
      }
    }
  }
  if(NFALSEP(bestcell))
    return bestcell;
  else
  if(NFALSEP(foundcell))
    return foundcell;
  else
    return props_select_split_cell_restricted_secondary(clauses,domainsize,maxsplitvalue,depth);
}

SCM props_select_split_cell_restricted_initial(clauses,domainsize,maxsplitvalue,depth)
SCM clauses,domainsize,maxsplitvalue,depth;
{
  SCM bestcell,foundcell,bestnr,maxarg,nr,tmp2,tmp,i,stopflag,j;

  stopflag=BOOL_F;
  i=MAKINUM(0);
  tmp=EOL;
  tmp2=EOL;
  nr=MAKINUM(0);
  maxarg=MAKINUM(-1);
  bestnr=domainsize;
  foundcell=BOOL_F;
  bestcell=BOOL_F;
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    newline(cur_output_port());
    display(const_729,cur_output_port());
  }
  bestcell=BOOL_F;
  foundcell=BOOL_F;
  for(j=MAKINUM(0);!(NFALSEP(stopflag)||(j>=GLOBAL(props_cell_nr_global)));j=MAKINUM(1+INUM(j))) {
    i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j);
    tmp=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    if(PAIR_P(tmp)&&!(NULL_P(CDR(tmp)))) {
      nr=length(tmp);
      tmp2=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i);
      maxarg=apply(GLOBAL(props_cterm_max_arg),tmp2,listofnull);
      if((nr<bestnr)&&(apply(GLOBAL(props_cterm_max_arg),tmp2,listofnull)<maxsplitvalue)) {
        if(NFALSEP(props_term_is_surely_lit_pred_(tmp2))) {
          if(!(NFALSEP(foundcell))) {
            foundcell=i;
          }
        }
        else {
          if(nr<MAKINUM(3)) {
            stopflag=BOOL_T;
          }
          bestcell=i;
          bestnr=nr;
        }
      }
    }
  }
  if(NFALSEP(bestcell))
    return bestcell;
  else
  if(NFALSEP(foundcell))
    return foundcell;
  else
    return props_select_split_cell_restricted_secondary(clauses,domainsize,maxsplitvalue,depth);
}

SCM props_select_split_cell_restricted_secondary(clauses,domainsize,maxsplitvalue,depth)
SCM clauses,domainsize,maxsplitvalue,depth;
{
  SCM j,stopflag,i,tmp,tmp2,nr,bestnr,maxarg,bestcell,foundcell,j__1;

  stopflag=BOOL_F;
  i=MAKINUM(0);
  tmp=EOL;
  tmp2=EOL;
  nr=MAKINUM(0);
  bestnr=MAKINUM(2+INUM(domainsize));
  maxarg=MAKINUM(0);
  bestcell=BOOL_F;
  foundcell=BOOL_F;
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    newline(cur_output_port());
    display(const_730,cur_output_port());
  }
  for(j=MAKINUM(0);!(NFALSEP(stopflag)||(j>=GLOBAL(props_cell_nr_global)));j=MAKINUM(1+INUM(j))) {
    i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j);
    tmp=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    if(PAIR_P(tmp)&&!(NULL_P(CDR(tmp)))) {
      tmp2=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i);
      nr=apply(GLOBAL(props_cterm_max_arg),tmp2,listofnull);
      if(nr<bestnr) {
        if(nr<MAKINUM(0)) {
          stopflag=BOOL_T;
        }
        bestnr=nr;
      }
    }
  }
  maxarg=bestnr;
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    newline(cur_output_port());
    display(const_731,cur_output_port());
    display(bestnr,cur_output_port());
    newline(cur_output_port());
    display(const_732,cur_output_port());
    display(maxarg,cur_output_port());
    newline(cur_output_port());
  }
  bestnr=MAKINUM(2+INUM(domainsize));
  bestcell=BOOL_F;
  foundcell=BOOL_F;
  stopflag=BOOL_F;
  for(j__1=MAKINUM(0);!(NFALSEP(stopflag)||(j__1>=GLOBAL(props_cell_nr_global)));j__1=MAKINUM(1+INUM(j__1))) {
    i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j__1);
    tmp=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    if(PAIR_P(tmp)&&!(NULL_P(CDR(tmp)))) {
      if(!(NFALSEP(foundcell))) {
        foundcell=i;
      }
      nr=length(tmp);
      tmp2=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i);
      if(NFALSEP(props_term_is_surely_lit_pred_(tmp2))) {
        nr=domainsize;
      }
      if((nr<bestnr)&&(apply(GLOBAL(props_cterm_max_arg),tmp2,listofnull)<=maxarg)) {
        if(nr<MAKINUM(3)) {
          stopflag=BOOL_T;
        }
        bestcell=i;
        bestnr=nr;
      }
    }
  }
  if(NFALSEP(bestcell))
    return bestcell;
  else
    return foundcell;
}

SCM props_select_split_cell_restricted_secondary_experiment(clauses,domainsize,maxsplitvalue,depth)
SCM clauses,domainsize,maxsplitvalue,depth;
{
  SCM j,stopflag,i,tmp,tmp2,nr,bestnr,maxarg,bestcell,foundcell,j__1;

  stopflag=BOOL_F;
  i=MAKINUM(0);
  tmp=EOL;
  tmp2=EOL;
  nr=MAKINUM(0);
  bestnr=MAKINUM(2+INUM(domainsize));
  maxarg=MAKINUM(0);
  bestcell=BOOL_F;
  foundcell=BOOL_F;
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    newline(cur_output_port());
    display(const_733,cur_output_port());
  }
  for(j=MAKINUM(0);!(NFALSEP(stopflag)||(j>=GLOBAL(props_cell_nr_global)));j=MAKINUM(1+INUM(j))) {
    i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j);
    tmp=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    if(PAIR_P(tmp)&&!(NULL_P(CDR(tmp)))) {
      tmp2=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i);
      if(NFALSEP(props_term_is_surely_lit_pred_(tmp2))) {
        nr=MAKINUM(-1);
      }
      else {
        nr=apply(GLOBAL(props_cterm_max_arg),tmp2,listofnull);
      }
      if(nr<bestnr) {
        if(nr<MAKINUM(0)) {
          stopflag=BOOL_T;
        }
        bestnr=nr;
      }
    }
  }
  maxarg=bestnr;
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    newline(cur_output_port());
    display(const_734,cur_output_port());
    display(bestnr,cur_output_port());
    newline(cur_output_port());
    display(const_735,cur_output_port());
    display(maxarg,cur_output_port());
    newline(cur_output_port());
  }
  bestnr=MAKINUM(2+INUM(domainsize));
  bestcell=BOOL_F;
  foundcell=BOOL_F;
  stopflag=BOOL_F;
  for(j__1=MAKINUM(0);!(NFALSEP(stopflag)||(j__1>=GLOBAL(props_cell_nr_global)));j__1=MAKINUM(1+INUM(j__1))) {
    i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j__1);
    tmp=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    if(PAIR_P(tmp)&&!(NULL_P(CDR(tmp)))) {
      if(!(NFALSEP(foundcell))) {
        foundcell=i;
      }
      nr=length(tmp);
      tmp2=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i);
      if(NFALSEP(props_term_is_surely_lit_pred_(tmp2))) {
        nr=domainsize;
      }
      if((nr<bestnr)&&(apply(GLOBAL(props_cterm_max_arg),tmp2,listofnull)<=maxarg)) {
        if(nr<MAKINUM(3)) {
          stopflag=BOOL_T;
        }
        bestcell=i;
        bestnr=nr;
      }
    }
  }
  if(NFALSEP(bestcell))
    return bestcell;
  else
    return foundcell;
}

SCM props_select_split_cell_unrestricted(clauses,domainsize,maxsplitvalue,depth)
SCM clauses,domainsize,maxsplitvalue,depth;
{
  SCM foundcell,bestcell,bestnr,nr,tmp2,tmp,i,stopflag,j;

  stopflag=BOOL_F;
  i=MAKINUM(0);
  tmp=EOL;
  tmp2=EOL;
  nr=MAKINUM(0);
  bestnr=MAKINUM(2+INUM(domainsize));
  bestcell=BOOL_F;
  foundcell=BOOL_F;
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    newline(cur_output_port());
    display(const_736,cur_output_port());
  }
  for(j=MAKINUM(0);!(NFALSEP(stopflag)||(j>=GLOBAL(props_cell_nr_global)));j=MAKINUM(1+INUM(j))) {
    i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j);
    tmp=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    if(PAIR_P(tmp)&&!(NULL_P(CDR(tmp)))) {
      if(!(NFALSEP(foundcell))) {
        foundcell=i;
      }
      nr=length(tmp);
      tmp2=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i);
      if((nr<bestnr)&&!(NFALSEP(props_term_is_surely_lit_pred_(tmp2)))) {
        if(nr<MAKINUM(3)) {
          stopflag=BOOL_T;
        }
        bestcell=i;
        bestnr=nr;
      }
    }
  }
  if(NFALSEP(bestcell))
    return bestcell;
  else
    return foundcell;
}

SCM props_select_split_cell_occurrences(clauses,domainsize,maxsplitvalue,depth)
SCM clauses,domainsize,maxsplitvalue,depth;
{
  SCM foundcell,bestcell,bestnr,occ,nr,tmp2,tmp,i,stopflag,j;

  stopflag=BOOL_F;
  i=MAKINUM(0);
  tmp=EOL;
  tmp2=EOL;
  nr=MAKINUM(0);
  occ=EOL;
  bestnr=MAKINUM(-1);
  bestcell=BOOL_F;
  foundcell=BOOL_F;
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    newline(cur_output_port());
    display(const_737,cur_output_port());
  }
  for(j=MAKINUM(0);!(NFALSEP(stopflag)||(j>=GLOBAL(props_cell_nr_global)));j=MAKINUM(1+INUM(j))) {
    i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j);
    tmp=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    occ=VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),i);
    if(PAIR_P(tmp)&&(!(NULL_P(CDR(tmp)))&&!(NULL_P(occ)))) {
      if(!(NFALSEP(foundcell))) {
        foundcell=i;
      }
      nr=length(occ);
      if(nr>bestnr) {
        bestcell=i;
        bestnr=nr;
      }
    }
  }
  if(NFALSEP(bestcell))
    return bestcell;
  else
    return foundcell;
}

SCM props_make_cell_measures_excl_(domainsize)
SCM domainsize;
{
  SCM bestcell,bestnr,nr,tmp,stopflag,i;

  stopflag=BOOL_F;
  tmp=EOL;
  nr=MAKINUM(0-1);
  bestnr=MAKINUM(0-1);
  bestcell=BOOL_F;
  GLOBAL(props_cell_measures_vector_global)=make_vector(GLOBAL(props_cell_nr_global),MAKINUM(0-1));
  for(i=MAKINUM(0);!(i>=GLOBAL(props_cell_nr_global));i=MAKINUM(1+INUM(i))) {
    nr=length(VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),i));
    VECTOR_SET(GLOBAL(props_cell_measures_vector_global),i,nr);
  }
  return UNSPECIFIED;
}

SCM props_sort_cells_excl_(domainsize)
SCM domainsize;
{
  SCM lst,i,part;

  lst=EOL;
  lst=props_sort_cells_aux_excl_(MAKINUM(0),MAKINUM(INUM(GLOBAL(props_cell_nr_global))-1),domainsize);
  for(i=MAKINUM(0),part=lst;
      !(NULL_P(part));
      i=MAKINUM(1+INUM(i)),part=CDR(part)) {
    VECTOR_SET(GLOBAL(props_cell_order_vector_global),i,CAR(part));
  }
  return UNSPECIFIED;
}

SCM props_sort_cells_aux_excl_(lower,upper,domainsize)
SCM lower,upper,domainsize;
{
  SCM half;

  half=MAKINUM(0);
  if(lower>upper)
    return EOL;
  else
  if(lower==upper)
    return cons(lower,EOL);
  else
  if(upper==MAKINUM(1+INUM(lower))) {
    if(NFALSEP(props_cell_nr_less_pred_(lower,upper,domainsize)))
      return cons(lower,cons(upper,EOL));
    else
      return cons(upper,cons(lower,EOL));
  }
  else {
    half=MAKINUM((INUM(lower)+INUM(upper))/2);
    return props_merge(props_sort_cells_aux_excl_(lower,half,domainsize),props_sort_cells_aux_excl_(MAKINUM(1+INUM(half)),upper,domainsize),domainsize);
  }
}

SCM props_merge(lst1,lst2,domainsize)
SCM lst1,lst2,domainsize;
{
  if(NULL_P(lst1))
    return lst2;
  else
  if(NULL_P(lst2))
    return lst1;
  else
  if(NFALSEP(props_cell_nr_less_pred_(CAR(lst1),CAR(lst2),domainsize)))
    return cons(CAR(lst1),props_merge(CDR(lst1),lst2,domainsize));
  else
    return cons(CAR(lst2),props_merge(lst1,CDR(lst2),domainsize));
}

SCM props_cell_nr_less_pred_(cell1,cell2,domainsize)
SCM cell1,cell2,domainsize;
{
  SCM new_var2,arity2,arity1,occ2,occ1,sum2,sum1,max2,max1,iseq2,iseq1,fun2,fun1,cterm2,cterm1,new_var1,new_var3;

  cterm1=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),cell1);
  cterm2=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),cell2);
  fun1=VECTOR_REF(cterm1,MAKINUM(1));
  fun2=VECTOR_REF(cterm2,MAKINUM(1));
  iseq1=SBOOL((GLOBAL(props_purefun_mask_global)&fun1)==GLOBAL(props_eq_fun_global));
  iseq2=SBOOL((GLOBAL(props_purefun_mask_global)&fun2)==GLOBAL(props_eq_fun_global));
  max1=MAKINUM(0);
  max2=MAKINUM(0);
  sum1=MAKINUM(0);
  sum2=MAKINUM(0);
  occ1=MAKINUM(0);
  occ2=MAKINUM(0);
  arity1=MAKINUM(0);
  arity2=MAKINUM(0);
  if(NFALSEP(iseq1)&&NFALSEP(iseq2))
    return SBOOL(cell1<cell2);
  else
  if(NFALSEP(iseq2))
    return BOOL_T;
  else
  if(NFALSEP(iseq1))
    return BOOL_F;
  else {
    max1=apply(GLOBAL(props_cterm_max_arg),cterm1,listofnull);
    max2=apply(GLOBAL(props_cterm_max_arg),cterm2,listofnull);
    new_var1=BOOL_F;
    if(NFALSEP(new_var1))
      return new_var1;
    else
    if(max1<max2)
      return BOOL_T;
    else
    if(max1>max2)
      return BOOL_F;
    else
    if(NFALSEP(props_term_is_surely_lit_pred_(cterm1))&&!(NFALSEP(props_term_is_surely_lit_pred_(cterm2))))
      return BOOL_T;
    else
    if(!(NFALSEP(props_term_is_surely_lit_pred_(cterm1)))&&NFALSEP(props_term_is_surely_lit_pred_(cterm2)))
      return BOOL_F;
    else {
      arity1=VECTOR_LENGTH(cterm1);
      arity2=VECTOR_LENGTH(cterm2);
      new_var2=BOOL_F;
      if(NFALSEP(new_var2))
        return new_var2;
      else
      if(arity1<arity2)
        return BOOL_T;
      else
      if(arity1>arity2)
        return BOOL_F;
      else
      if(fun1<fun2)
        return BOOL_T;
      else
      if(fun1>fun2)
        return BOOL_F;
      else {
        sum1=props_cterm_sum_arg(cterm1);
        sum2=props_cterm_sum_arg(cterm2);
        new_var3=BOOL_F;
        if(NFALSEP(new_var3))
          return new_var3;
        else
        if(sum1<sum2)
          return BOOL_T;
        else
        if(sum1>sum2)
          return BOOL_F;
        else
          return SBOOL(cell1<cell2);
      }
    }
  }
}

SCM props_select_split_cell_preassign(domainsize)
SCM domainsize;
{
  SCM part,stack,assignres,stopflag,bestcell,measure,minsuccvalue,onemaxmeasure,maxmeasure,minmeasure,tmprestrictcount,tmpassigncount,succvalues,value,i,occ,range,j,new_var1;

  range=EOL;
  occ=MAKINUM(0);
  i=MAKINUM(0);
  value=EOL;
  succvalues=MAKINUM(0);
  tmpassigncount=MAKINUM(0);
  tmprestrictcount=MAKINUM(0);
  minmeasure=MAKINUM(0);
  maxmeasure=MAKINUM(0);
  onemaxmeasure=MAKINUM(0);
  minsuccvalue=MAKINUM(1000000);
  measure=MAKINUM(0);
  bestcell=BOOL_F;
  stopflag=BOOL_F;
  assignres=EOL;
  stack=EOL;
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    display(const_738,cur_output_port());
    newline(cur_output_port());
  }
  maxmeasure=MAKINUM(-10000);
  onemaxmeasure=MAKINUM(-10000);
  minsuccvalue=MAKINUM(1000000);
  for(j=MAKINUM(0);!((j>=GLOBAL(props_cell_nr_global))||NFALSEP(stopflag));j=MAKINUM(1+INUM(j))) {
    i=VECTOR_REF(GLOBAL(props_cell_order_vector_global),j);
    range=VECTOR_REF(GLOBAL(props_cell_range_vector_global),i);
    occ=VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),i);
    if(!(NULL_P(CDR(range)))&&!(NULL_P(occ))) {
      if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
        display(const_739,cur_output_port());
        display(i,cur_output_port());
        display(const_740,cur_output_port());
        print_props_ground_term(VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i));
        display(const_741,cur_output_port());
        display(VECTOR_REF(GLOBAL(props_cell_range_vector_global),i),cur_output_port());
        newline(cur_output_port());
      }
      minmeasure=MAKINUM(10000000);
      succvalues=MAKINUM(0);
      for(part=range;!(NULL_P(part)||(minsuccvalue<succvalues));part=CDR(part)) {
        value=CAR(part);
        stack=cons(EOL,EOL);
        tmpassigncount=GLOBAL(props_assign_count_global);
        tmprestrictcount=GLOBAL(props_restrict_count_global);
        if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
          display(const_742,cur_output_port());
          display(value,cur_output_port());
          newline(cur_output_port());
        }
        assignres=props_assign_cell_excl_(i,value,stack,domainsize);
        new_var1=NOT(assignres);
        if(NFALSEP(new_var1)) ;
        else {
          succvalues=MAKINUM(1+INUM(succvalues));
          measure=MAKINUM((3*(INUM(GLOBAL(props_assign_count_global))-INUM(tmpassigncount)))+(INUM(GLOBAL(props_restrict_count_global))-INUM(tmprestrictcount)));
        }
        if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
          display(const_743,cur_output_port());
          display(assignres,cur_output_port());
          display(const_744,cur_output_port());
          display(MAKINUM(INUM(GLOBAL(props_assign_count_global))-INUM(tmpassigncount)),cur_output_port());
          display(const_745,cur_output_port());
          display(MAKINUM(INUM(GLOBAL(props_restrict_count_global))-INUM(tmprestrictcount)),cur_output_port());
          display(const_746,cur_output_port());
          display(measure,cur_output_port());
          newline(cur_output_port());
        }
        if(NFALSEP(assignres)&&(measure<minmeasure)) {
          minmeasure=measure;
        }
        GLOBAL(props_assign_count_global)=tmpassigncount;
        GLOBAL(props_restrict_count_global)=tmprestrictcount;
        props_restore_stack_excl_(assignres,stack);
      }
      minmeasure=MAKINUM(INUM(minmeasure)-INUM(succvalues));
      if(succvalues==MAKINUM(0)) {
        if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
          newline(cur_output_port());
          display(const_747,cur_output_port());
          newline(cur_output_port());
        }
        stopflag=BOOL_T;
        bestcell=i;
      }
      else
      if(succvalues==MAKINUM(1)) {
        if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
          newline(cur_output_port());
          display(const_748,cur_output_port());
          newline(cur_output_port());
        }
        minsuccvalue=MAKINUM(1);
        if(minmeasure>onemaxmeasure) {
          onemaxmeasure=minmeasure;
          bestcell=i;
        }
      }
      else
      if(minsuccvalue>MAKINUM(1)) {
        if(minmeasure>maxmeasure) {
          maxmeasure=minmeasure;
          bestcell=i;
        }
      }
    }
  }
  if(NFALSEP(GLOBAL(props_debug_selectcell_global))) {
    display(const_749,cur_output_port());
    display(bestcell,cur_output_port());
    newline(cur_output_port());
  }
  return bestcell;
}

SCM props_open_occ_cell_count()
{
  SCM res,j;

  res=MAKINUM(0);
  for(j=MAKINUM(0);!(j>=GLOBAL(props_cell_nr_global));j=MAKINUM(1+INUM(j)))
    if(!(NULL_P(CDR(VECTOR_REF(GLOBAL(props_cell_range_vector_global),j))))) {
      if(!(NULL_P(VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),j)))) {
        res=MAKINUM(1+INUM(res));
      }
    }
  return res;
}

SCM props_assign_cell_excl_(selcell,value,stack,domainsize)
SCM selcell,value,stack,domainsize;
{
  SCM origrange,occurrences,stopflag,res,tmp,occpart;

  tmp=EOL;
  res=EOL;
  stopflag=BOOL_F;
  occurrences=EOL;
  origrange=EOL;
  if(NFALSEP(GLOBAL(props_debug_global))) {
    newline(cur_output_port());
    display(const_750,cur_output_port());
    display(selcell,cur_output_port());
    display(const_751,cur_output_port());
    display(value,cur_output_port());
    newline(cur_output_port());
  }
  origrange=VECTOR_REF(GLOBAL(props_cell_range_vector_global),selcell);
  if(!(NFALSEP(memq(value,origrange))))
    return BOOL_F;
  else
  if(INTEGER_P(origrange)||NULL_P(CDR(origrange)))
    return EOL;
  else {
    GLOBAL(props_assign_count_global)=MAKINUM(1+INUM(GLOBAL(props_assign_count_global)));
    props_push_stack_excl_(cons(GLOBAL(props_cell_range_vector_global),cons(selcell,cons(origrange,EOL))),stack);
    VECTOR_SET(GLOBAL(props_cell_range_vector_global),selcell,cons(value,EOL));
    occurrences=VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),selcell);
    stopflag=BOOL_F;
    for(occpart=occurrences;!(NFALSEP(stopflag)||(NFALSEP(GLOBAL(prop_time_ran_out_global))||NULL_P(occpart)));occpart=CDR(occpart)) {
      GLOBAL(props_timecheck_counter_global)=MAKINUM(1+INUM(GLOBAL(props_timecheck_counter_global)));
      if(GLOBAL(props_timecheck_counter_global)>MAKINUM(1000)) {
        GLOBAL(props_timecheck_counter_global)=MAKINUM(0);
        if((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))) {
          stopflag=BOOL_T;
          GLOBAL(prop_time_ran_out_global)=BOOL_T;
          GLOBAL(props_stop_search_flag_global)=BOOL_T;
        }
      }
      res=props_rewrite_with_assignment_excl_(CAR(occpart),selcell,value,stack,domainsize);
      if(res==BOOL_F) {
        stopflag=BOOL_T;
      }
      else
      if(res==BOOL_T) {
        stopflag=BOOL_T;
      }
    }
    if(NFALSEP(res))
      return derive_from_cell_with_nterms(selcell,stack,domainsize);
    else
      return BOOL_F;
  }
}

SCM props_restrict_cell_excl_(selcell,value,stack,domainsize)
SCM selcell,value,stack,domainsize;
{
  SCM tmp,origrange;

  tmp=EOL;
  origrange=EOL;
  if(NFALSEP(GLOBAL(props_debug_global))) {
    newline(cur_output_port());
    display(const_752,cur_output_port());
    display(selcell,cur_output_port());
    display(const_753,cur_output_port());
    display(value,cur_output_port());
    newline(cur_output_port());
  }
  origrange=VECTOR_REF(GLOBAL(props_cell_range_vector_global),selcell);
  if(INTEGER_P(origrange)||NULL_P(CDR(origrange))) {
    if(!(INTEGER_P(origrange))) {
      origrange=CAR(origrange);
    }
    if(value==origrange)
      return BOOL_F;
    else
      return EOL;
  }
  else
  if(!(NFALSEP(memq(value,origrange))))
    return EOL;
  else {
    GLOBAL(props_restrict_count_global)=MAKINUM(1+INUM(GLOBAL(props_restrict_count_global)));
    props_push_stack_excl_(cons(GLOBAL(props_cell_range_vector_global),cons(selcell,cons(origrange,EOL))),stack);
    tmp=remove_one_from_list(value,origrange);
    VECTOR_SET(GLOBAL(props_cell_range_vector_global),selcell,tmp);
    if(NULL_P(CDR(tmp))) {
      tmp=props_propagate_cell_excl_(selcell,stack,domainsize);
      if(NFALSEP(tmp))
        return derive_from_cell_with_nterms(selcell,stack,domainsize);
      else
        return BOOL_F;
    }
    else
      return EOL;
  }
}

SCM props_propagate_cell_excl_(selcell,stack,domainsize)
SCM selcell,stack,domainsize;
{
  SCM origrange,occurrences,stopflag,value,res,tmp,occpart;

  tmp=EOL;
  res=EOL;
  value=EOL;
  stopflag=BOOL_F;
  occurrences=EOL;
  origrange=EOL;
  origrange=VECTOR_REF(GLOBAL(props_cell_range_vector_global),selcell);
  if(!(INTEGER_P(origrange)||NULL_P(CDR(origrange))))
    return EOL;
  else {
    value=CAR(origrange);
    occurrences=VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),selcell);
    stopflag=BOOL_F;
    for(occpart=occurrences;!(NFALSEP(stopflag)||NULL_P(occpart));occpart=CDR(occpart)) {
      res=props_rewrite_with_assignment_excl_(CAR(occpart),selcell,value,stack,domainsize);
      if(res==BOOL_F) {
        stopflag=BOOL_T;
      }
      else
      if(res==BOOL_T) {
        stopflag=BOOL_T;
      }
    }
    return res;
  }
}

SCM props_rewrite_with_assignment_excl_(occurrence,selcell,value,stack,domainsize)
SCM occurrence,selcell,value,stack,domainsize;
{
  SCM new_var1,tmp,tmpval,tmpocc,fun,len,stopflag,parentterm,parentindex,parent,tmp_var1,tmp_var2,tmp_var3;

tailrecursion:
  tmp=EOL;
  tmpval=EOL;
  tmpocc=EOL;
  fun=MAKINUM(0);
  len=MAKINUM(0);
  stopflag=BOOL_F;
  parentterm=EOL;
  parentindex=MAKINUM(0);
  parent=EOL;
  GLOBAL(props_timecheck_counter_global)=MAKINUM(1+INUM(GLOBAL(props_timecheck_counter_global)));
  if(GLOBAL(props_timecheck_counter_global)>MAKINUM(1000)) {
    GLOBAL(props_timecheck_counter_global)=MAKINUM(0);
    if((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))) {
      stopflag=BOOL_T;
      GLOBAL(prop_time_ran_out_global)=BOOL_T;
      GLOBAL(props_stop_search_flag_global)=BOOL_T;
    }
  }
  if(!(NFALSEP(GLOBAL(prop_time_ran_out_global)))) {
    GLOBAL(props_rewrite_count_global)=MAKINUM(1+INUM(GLOBAL(props_rewrite_count_global)));
    parent=VECTOR_REF(occurrence,MAKINUM(0));
    fun=VECTOR_REF(occurrence,MAKINUM(1));
    parentterm=CAR(parent);
    parentindex=CDR(parent);
    props_push_stack_excl_(cons(parentterm,cons(parentindex,cons(occurrence,EOL))),stack);
    if(!(ZERO_P(GLOBAL(props_islit_mask_global)&fun))) {
      if(!(ZERO_P(GLOBAL(props_isneglit_mask_global)&fun))) {
        if(value==MAKINUM(0)) {
          value=MAKINUM(1);
        }
        else {
          value=MAKINUM(0);
        }
      }
      VECTOR_SET(parentterm,parentindex,value);
      if(value==MAKINUM(1)) {
        remove_term_occurrences_excl_(parentterm,BOOL_T,stack,domainsize);
        return EOL;
      }
      else
        return props_analyze_clause_excl_(parentterm,domainsize,stack);
    }
    else {
      VECTOR_SET(parentterm,parentindex,value);
      tmp=props_cterm_index_nr(parentterm,domainsize);
      if(NFALSEP(tmp)) {
        tmpval=VECTOR_REF(GLOBAL(props_cell_range_vector_global),tmp);
        new_var1=SBOOL(INTEGER_P(tmpval));
        if(NFALSEP(new_var1)) ;
        else
        if(NULL_P(CDR(tmpval))) {
          tmpval=CAR(tmpval);
        }
        if(INTEGER_P(tmpval)) {
          tmp_var1=parentterm;
          tmp_var2=tmp;
          tmp_var3=tmpval;
          occurrence=tmp_var1;
          selcell=tmp_var2;
          value=tmp_var3;
          goto tailrecursion;
        }
        else {
          tmpocc=VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),tmp);
          props_push_stack_excl_(cons(GLOBAL(props_cell_occurrences_vector_global),cons(tmp,cons(tmpocc,EOL))),stack);
          VECTOR_SET(GLOBAL(props_cell_occurrences_vector_global),tmp,cons(parentterm,tmpocc));
          if(!(ZERO_P(GLOBAL(props_islit_mask_global)&VECTOR_REF(parentterm,MAKINUM(1)))))
            return props_analyze_clause_excl_(CAR(VECTOR_REF(parentterm,MAKINUM(0))),domainsize,stack);
          else {
            tmp=CAR(VECTOR_REF(parentterm,MAKINUM(0)));
            if(!(ZERO_P(GLOBAL(props_islit_mask_global)&VECTOR_REF(tmp,MAKINUM(1)))))
              return props_analyze_clause_excl_(CAR(VECTOR_REF(tmp,MAKINUM(0))),domainsize,stack);
            else
            if((GLOBAL(props_purefun_mask_global)&VECTOR_REF(CAR(VECTOR_REF(tmp,MAKINUM(0))),MAKINUM(1)))==GLOBAL(props_eq_fun_global))
              return props_analyze_clause_excl_(CAR(VECTOR_REF(CAR(VECTOR_REF(tmp,MAKINUM(0))),MAKINUM(0))),domainsize,stack);
            else
              return EOL;
          }
        }
      }
      else
      if(!(ZERO_P(GLOBAL(props_islit_mask_global)&VECTOR_REF(parentterm,MAKINUM(1)))))
        return props_analyze_clause_excl_(CAR(VECTOR_REF(parentterm,MAKINUM(0))),domainsize,stack);
      else
      if((GLOBAL(props_purefun_mask_global)&VECTOR_REF(CAR(VECTOR_REF(parentterm,MAKINUM(0))),MAKINUM(1)))==GLOBAL(props_eq_fun_global))
        return props_analyze_clause_excl_(CAR(VECTOR_REF(CAR(VECTOR_REF(parentterm,MAKINUM(0))),MAKINUM(0))),domainsize,stack);
      else
        return EOL;
    }
  }
  else
    return UNSPECIFIED;
}

SCM props_analyze_clause_excl_(clause,domainsize,stack)
SCM clause,domainsize,stack;
{
  SCM tmp,tmpposflag,lst,foundtype,len,elem,oldfoundposflag,foundposflag,oldfoundres,oldfoundlit,foundres,foundlit,tautflag,stopflag,falseflag,i;

  if(NFALSEP(GLOBAL(props_debug_global))) {
    newline(cur_output_port());
    display(const_754,cur_output_port());
    print_props_ground_clause(clause);
    newline(cur_output_port());
  }
  falseflag=BOOL_T;
  stopflag=BOOL_F;
  tautflag=BOOL_F;
  foundlit=BOOL_F;
  foundres=BOOL_F;
  oldfoundlit=BOOL_F;
  oldfoundres=BOOL_F;
  foundposflag=BOOL_F;
  oldfoundposflag=BOOL_F;
  elem=BOOL_F;
  len=MAKINUM(0);
  foundtype=BOOL_F;
  lst=EOL;
  tmpposflag=BOOL_F;
  tmp=EOL;
  if(MAKINUM(1)==VECTOR_REF(clause,MAKINUM(0)))
    return EOL;
  else {
    len=VECTOR_LENGTH(clause);
    for(i=MAKINUM(2);!(NFALSEP(stopflag)||(i>=len));i=MAKINUM(INUM(i)+1)) {
      elem=VECTOR_REF(clause,i);
      if(INTEGER_P(elem)) {
        if(elem==MAKINUM(1)) {
          stopflag=BOOL_T;
          tautflag=BOOL_T;
          falseflag=BOOL_F;
        }
      }
      else
      if((NFALSEP(falseflag)||(foundtype==MAKINUM(1)))&&NFALSEP((foundres=props_cterm_index_nr(elem,domainsize),UNSPECIFIED,foundres))) {
        falseflag=BOOL_F;
        foundposflag=SBOOL(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(elem,MAKINUM(1))));
        if(NFALSEP(oldfoundres)&&(!(oldfoundres==foundres)||!(oldfoundposflag==foundposflag))) {
          stopflag=BOOL_T;
        }
        else {
          foundtype=MAKINUM(1);
          oldfoundres=foundres;
          oldfoundposflag=foundposflag;
        }
      }
      else
      if((NFALSEP(falseflag)||(foundtype==MAKINUM(2)))&&(((GLOBAL(props_purefun_mask_global)&VECTOR_REF(elem,MAKINUM(1)))==GLOBAL(props_eq_fun_global))&&NFALSEP((foundres=props_check_eq_assign(elem,domainsize),UNSPECIFIED,foundres)))) {
        falseflag=BOOL_F;
        if(NFALSEP(oldfoundres)&&!(NFALSEP(equal(oldfoundres,foundres)))) {
          stopflag=BOOL_T;
        }
        else {
          foundtype=MAKINUM(2);
          oldfoundres=foundres;
        }
      }
      else
      if(!((GLOBAL(props_purefun_mask_global)&VECTOR_REF(elem,MAKINUM(1)))==GLOBAL(props_eq_fun_global))&&NFALSEP((tmp=props_check_nterm_index_nr(elem,domainsize),UNSPECIFIED,tmp))) {
        tmpposflag=SBOOL(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(elem,MAKINUM(1))));
        lst=VECTOR_REF(GLOBAL(props_nterm_vector_global),CAR(tmp));
        lst=assq(CAR(CDR(CDR(tmp))),lst);
        if(NFALSEP(lst)&&NULL_P(CDR(CDR(lst)))) {
          lst=CAR(CDR(lst));
          if(NFALSEP(tmpposflag)) {
            if(MAKINUM(1)==lst) {
              stopflag=BOOL_T;
              tautflag=BOOL_T;
              falseflag=BOOL_F;
            }
          }
          else
          if(MAKINUM(0)==lst) {
            stopflag=BOOL_T;
            tautflag=BOOL_T;
            falseflag=BOOL_F;
          }
        }
        else {
          if(NFALSEP(falseflag)) {
            falseflag=BOOL_F;
            foundtype=MAKINUM(3);
            foundposflag=tmpposflag;
            foundres=tmp;
          }
          else {
            stopflag=BOOL_T;
            falseflag=BOOL_F;
          }
        }
      }
      else
      if(NFALSEP(falseflag)&&(((GLOBAL(props_purefun_mask_global)&VECTOR_REF(elem,MAKINUM(1)))==GLOBAL(props_eq_fun_global))&&NFALSEP((foundres=props_check_nterm_eq_assign(elem,domainsize),UNSPECIFIED,foundres)))) {
        falseflag=BOOL_F;
        foundtype=MAKINUM(4);
      }
      else {
        falseflag=BOOL_F;
        stopflag=BOOL_T;
      }
    }
    if(NFALSEP(GLOBAL(props_debug_global))) {
      newline(cur_output_port());
      display(const_755,cur_output_port());
      newline(cur_output_port());
      display(const_756,cur_output_port());
      display(falseflag,cur_output_port());
      newline(cur_output_port());
      display(const_757,cur_output_port());
      display(stopflag,cur_output_port());
      newline(cur_output_port());
      display(const_758,cur_output_port());
      display(foundtype,cur_output_port());
      newline(cur_output_port());
      display(const_759,cur_output_port());
      display(foundres,cur_output_port());
      newline(cur_output_port());
    }
    if(NFALSEP(tautflag)) {
      props_push_stack_excl_(cons(clause,cons(MAKINUM(0),cons(VECTOR_REF(clause,MAKINUM(0)),EOL))),stack);
      VECTOR_SET(clause,MAKINUM(0),MAKINUM(1));
      remove_term_occurrences_excl_(clause,BOOL_T,stack,domainsize);
      return EOL;
    }
    else
    if(NFALSEP(falseflag))
      return BOOL_F;
    else
    if(NFALSEP(stopflag))
      return EOL;
    else
    if(!(NFALSEP(foundres)))
      return EOL;
    else
    if(foundtype==MAKINUM(1)) {
      if(NFALSEP(foundposflag))
        return props_assign_cell_excl_(foundres,MAKINUM(1),stack,domainsize);
      else
        return props_assign_cell_excl_(foundres,MAKINUM(0),stack,domainsize);
    }
    else
    if(foundtype==MAKINUM(2)) {
      if(NFALSEP(CAR(CDR(CDR(foundres)))))
        return props_assign_cell_excl_(CAR(foundres),CAR(CDR(foundres)),stack,domainsize);
      else
        return props_restrict_cell_excl_(CAR(foundres),CAR(CDR(foundres)),stack,domainsize);
    }
    else
    if(foundtype==MAKINUM(3)) {
      if(NFALSEP(foundposflag))
        return props_assign_nterm_excl_(CAR(foundres),CAR(CDR(foundres)),CAR(CDR(CDR(foundres))),MAKINUM(1),stack,domainsize);
      else
        return props_assign_nterm_excl_(CAR(foundres),CAR(CDR(foundres)),CAR(CDR(CDR(foundres))),MAKINUM(0),stack,domainsize);
    }
    else
    if(foundtype==MAKINUM(4)) {
      tmp=CAR(foundres);
      if(NFALSEP(CAR(CDR(CDR(foundres)))))
        return props_assign_nterm_excl_(CAR(tmp),CAR(CDR(tmp)),CAR(CDR(CDR(tmp))),CAR(CDR(foundres)),stack,domainsize);
      else
        return props_restrict_nterm_excl_(CAR(tmp),CAR(CDR(tmp)),CAR(CDR(CDR(tmp))),CAR(CDR(foundres)),stack,domainsize);
    }
    else
      return EOL;
  }
}

SCM props_analyze_clause_old_excl_(clause,domainsize,stack)
SCM clause,domainsize,stack;
{
  SCM tmp,foundtype,len,elem,oldfoundposflag,foundposflag,oldfoundres,oldfoundlit,foundres,foundlit,tautflag,stopflag,falseflag,i;

  if(NFALSEP(GLOBAL(props_debug_global))) {
    newline(cur_output_port());
    display(const_760,cur_output_port());
    print_props_ground_clause(clause);
    newline(cur_output_port());
  }
  falseflag=BOOL_T;
  stopflag=BOOL_F;
  tautflag=BOOL_F;
  foundlit=BOOL_F;
  foundres=BOOL_F;
  oldfoundlit=BOOL_F;
  oldfoundres=BOOL_F;
  foundposflag=BOOL_F;
  oldfoundposflag=BOOL_F;
  elem=BOOL_F;
  len=MAKINUM(0);
  foundtype=BOOL_F;
  tmp=EOL;
  len=VECTOR_LENGTH(clause);
  for(i=MAKINUM(2);!(NFALSEP(stopflag)||(i>=len));i=MAKINUM(INUM(i)+1)) {
    elem=VECTOR_REF(clause,i);
    if(INTEGER_P(elem)) {
      if(elem==MAKINUM(1)) {
        stopflag=BOOL_T;
        tautflag=BOOL_T;
        falseflag=BOOL_F;
      }
    }
    else
    if((NFALSEP(falseflag)||(foundtype==MAKINUM(1)))&&NFALSEP((foundres=props_cterm_index_nr(elem,domainsize),UNSPECIFIED,foundres))) {
      falseflag=BOOL_F;
      foundposflag=SBOOL(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(elem,MAKINUM(1))));
      if(NFALSEP(oldfoundres)&&(!(oldfoundres==foundres)||!(oldfoundposflag==foundposflag))) {
        stopflag=BOOL_T;
      }
      else {
        foundtype=MAKINUM(1);
        oldfoundres=foundres;
        oldfoundposflag=foundposflag;
      }
    }
    else
    if((NFALSEP(falseflag)||(foundtype==MAKINUM(2)))&&(((GLOBAL(props_purefun_mask_global)&VECTOR_REF(elem,MAKINUM(1)))==GLOBAL(props_eq_fun_global))&&NFALSEP((foundres=props_check_eq_assign(elem,domainsize),UNSPECIFIED,foundres)))) {
      falseflag=BOOL_F;
      if(NFALSEP(oldfoundres)&&!(NFALSEP(equal(oldfoundres,foundres)))) {
        stopflag=BOOL_T;
      }
      else {
        foundtype=MAKINUM(2);
        oldfoundres=foundres;
      }
    }
    else
    if(NFALSEP(falseflag)&&(!((GLOBAL(props_purefun_mask_global)&VECTOR_REF(elem,MAKINUM(1)))==GLOBAL(props_eq_fun_global))&&NFALSEP((foundres=props_check_nterm_index_nr(elem,domainsize),UNSPECIFIED,foundres)))) {
      falseflag=BOOL_F;
      foundposflag=SBOOL(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(elem,MAKINUM(1))));
      foundtype=MAKINUM(3);
      foundlit=elem;
    }
    else
    if(NFALSEP(falseflag)&&(((GLOBAL(props_purefun_mask_global)&VECTOR_REF(elem,MAKINUM(1)))==GLOBAL(props_eq_fun_global))&&NFALSEP((foundres=props_check_nterm_eq_assign(elem,domainsize),UNSPECIFIED,foundres)))) {
      falseflag=BOOL_F;
      foundtype=MAKINUM(4);
    }
    else {
      falseflag=BOOL_F;
      stopflag=BOOL_T;
    }
  }
  if(NFALSEP(GLOBAL(props_debug_global))) {
    newline(cur_output_port());
    display(const_761,cur_output_port());
    newline(cur_output_port());
    display(const_762,cur_output_port());
    display(falseflag,cur_output_port());
    newline(cur_output_port());
    display(const_763,cur_output_port());
    display(stopflag,cur_output_port());
    newline(cur_output_port());
    display(const_764,cur_output_port());
    display(foundtype,cur_output_port());
    newline(cur_output_port());
    display(const_765,cur_output_port());
    display(foundres,cur_output_port());
    newline(cur_output_port());
  }
  if(NFALSEP(tautflag)) {
    remove_term_occurrences_excl_(clause,BOOL_T,stack,domainsize);
    return EOL;
  }
  else
  if(NFALSEP(falseflag))
    return BOOL_F;
  else
  if(NFALSEP(stopflag))
    return EOL;
  else
  if(!(NFALSEP(foundres)))
    return EOL;
  else
  if(foundtype==MAKINUM(1)) {
    if(NFALSEP(foundposflag))
      return props_assign_cell_excl_(foundres,MAKINUM(1),stack,domainsize);
    else
      return props_assign_cell_excl_(foundres,MAKINUM(0),stack,domainsize);
  }
  else
  if(foundtype==MAKINUM(2)) {
    if(NFALSEP(CAR(CDR(CDR(foundres)))))
      return props_assign_cell_excl_(CAR(foundres),CAR(CDR(foundres)),stack,domainsize);
    else
      return props_restrict_cell_excl_(CAR(foundres),CAR(CDR(foundres)),stack,domainsize);
  }
  else
  if(foundtype==MAKINUM(3)) {
    if(NFALSEP(foundposflag))
      return props_assign_nterm_excl_(CAR(foundres),CAR(CDR(foundres)),CAR(CDR(CDR(foundres))),MAKINUM(1),stack,domainsize);
    else
      return props_assign_nterm_excl_(CAR(foundres),CAR(CDR(foundres)),CAR(CDR(CDR(foundres))),MAKINUM(0),stack,domainsize);
  }
  else
  if(foundtype==MAKINUM(4)) {
    tmp=CAR(foundres);
    if(NFALSEP(CAR(CDR(CDR(foundres)))))
      return props_assign_nterm_excl_(CAR(tmp),CAR(CDR(tmp)),CAR(CDR(CDR(tmp))),CAR(CDR(foundres)),stack,domainsize);
    else
      return props_restrict_nterm_excl_(CAR(tmp),CAR(CDR(tmp)),CAR(CDR(CDR(tmp))),CAR(CDR(foundres)),stack,domainsize);
  }
  else
    return EOL;
}

SCM remove_term_occurrences_old_excl_(term,clauseflag,stack,domainsize)
SCM term,clauseflag,stack,domainsize;
{
  return EOL;
}

SCM remove_term_occurrences_excl_(term,clauseflag,stack,domainsize)
SCM term,clauseflag,stack,domainsize;
{
  SCM new_var2,i,len,nr,range,occs,place,bigsub,new_var1,new_var3;

  if(!(NFALSEP(GLOBAL(props_remove_terms_strat_global))))
    return EOL;
  else {
    len=VECTOR_LENGTH(term);
    nr=EOL;
    range=EOL;
    occs=EOL;
    place=EOL;
    bigsub=BOOL_F;
    for(i=MAKINUM(2);!(i>=len);i=MAKINUM(1+INUM(i))) {
      place=VECTOR_REF(term,i);
      if(!(INTEGER_P(place))) {
        bigsub=BOOL_T;
        remove_term_occurrences_excl_(place,BOOL_F,stack,domainsize);
      }
    }
    if(!(NFALSEP(bigsub))&&!(NFALSEP(clauseflag))) {
      nr=props_cterm_index_nr(term,domainsize);
      range=VECTOR_REF(GLOBAL(props_cell_range_vector_global),nr);
      new_var1=SBOOL(NULL_P(CDR(range)));
      if(NFALSEP(new_var1))
        return new_var1;
      else {
        occs=VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),nr);
        new_var2=BOOL_F;
        if(NFALSEP(new_var2))
          return new_var2;
        else {
          new_var3=SBOOL(NULL_P(occs));
          if(NFALSEP(new_var3))
            return new_var3;
          else
          if(term==CAR(occs)) {
            props_push_stack_excl_(cons(GLOBAL(props_cell_occurrences_vector_global),cons(nr,cons(occs,EOL))),stack);
            VECTOR_SET(GLOBAL(props_cell_occurrences_vector_global),nr,CDR(occs));
            return UNSPECIFIED;
          }
          else {
            place=props_pre_memq(term,occs);
            if(NFALSEP(place)) {
              props_push_stack_excl_(cons(place,cons(MAKINUM(1),cons(CDR(place),EOL))),stack);
              SET_CDR(place,CDR(CDR(place)));
              return UNSPECIFIED;
            }
            else
              return UNSPECIFIED;
          }
        }
      }
    }
    else
      return UNSPECIFIED;
  }
}

SCM props_pre_memq(el,lst)
SCM el,lst;
{
  SCM res,tmp,part;

  res=BOOL_F;
  tmp=lst;
  part=lst;
  for(;!(NFALSEP(res)||NULL_P(tmp));) {
    tmp=CDR(part);
    if(!(NULL_P(tmp))&&(el==CAR(tmp))) {
      res=part;
    }
    part=tmp;
  }
  return res;
}

SCM props_check_eq_assign(eqterm,domainsize)
SCM eqterm,domainsize;
{
  SCM tmp,a1,a2;

  tmp=EOL;
  a1=VECTOR_REF(eqterm,MAKINUM(2));
  a2=VECTOR_REF(eqterm,MAKINUM(3));
  if(INTEGER_P(a1)) {
    if(!(INTEGER_P(a2))) {
      tmp=props_cterm_index_nr(a2,domainsize);
      if(NFALSEP(tmp)) {
        if(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(eqterm,MAKINUM(1))))
          return cons(tmp,cons(a1,cons(BOOL_T,EOL)));
        else
          return cons(tmp,cons(a1,cons(BOOL_F,EOL)));
      }
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
  else
  if(INTEGER_P(a2)) {
    tmp=props_cterm_index_nr(a1,domainsize);
    if(NFALSEP(tmp)) {
      if(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(eqterm,MAKINUM(1))))
        return cons(tmp,cons(a2,cons(BOOL_T,EOL)));
      else
        return cons(tmp,cons(a2,cons(BOOL_F,EOL)));
    }
    else
      return BOOL_F;
  }
  else
    return BOOL_F;
}

SCM props_push_stack_excl_(assignment,stack)
SCM assignment,stack;
{
  SET_CDR(stack,cons(assignment,CDR(stack)));
  return UNSPECIFIED;
}

SCM props_restore_stack_excl_(assignments,stack)
SCM assignments,stack;
{
  SCM tmp,stpart;

  tmp=EOL;
  for(stpart=stack;!(NULL_P(stpart));stpart=CDR(stpart)) {
    tmp=CAR(stpart);
    if(PAIR_P(tmp)) {
      if(VECTOR_P(CAR(tmp))) {
        VECTOR_SET(CAR(tmp),CAR(CDR(tmp)),CAR(CDR(CDR(tmp))));
      }
      else
      if(PAIR_P(CAR(tmp))) {
        if(MAKINUM(0)==CAR(CDR(tmp))) {
          SET_CAR(CAR(tmp),CAR(CDR(CDR(tmp))));
        }
        else {
          SET_CDR(CAR(tmp),CAR(CDR(CDR(tmp))));
        }
      }
    }
  }
  SET_CDR(stack,EOL);
  return UNSPECIFIED;
}

SCM props_init_indexes(domainsize)
SCM domainsize;
{
  SCM i__9,j__6,i__4,i__2,part,k,i__1,arity,stopflag,varvaluations,allchecked,lst,matchnr,tmp3,tmp2,tmp,base,nr,curbase,i,j,new_var1,i__3,i__5,k__7,part__8,new_var2;

  curbase=MAKINUM(0);
  nr=MAKINUM(0);
  base=MAKINUM(0);
  tmp=EOL;
  tmp2=EOL;
  tmp3=EOL;
  matchnr=BOOL_F;
  lst=EOL;
  allchecked=BOOL_F;
  varvaluations=EOL;
  stopflag=BOOL_F;
  arity=MAKINUM(0);
  if(NFALSEP(GLOBAL(props_dynamic_vectors_global))) {
    GLOBAL(props_fun_basenr_vector_global)=make_vector(MAKINUM(10000),BOOL_F);
  }
  for(i=MAKINUM(0);!(i>=GLOBAL(props_fun_counter_global));i=MAKINUM(1+INUM(i))) {
    VECTOR_SET(GLOBAL(props_fun_basenr_vector_global),i,curbase);
    arity=VECTOR_REF(GLOBAL(props_fun_arities_vector_global),i);
    nr=int_power(domainsize,arity);
    curbase=MAKINUM(INUM(nr)+INUM(curbase));
  }
  GLOBAL(props_cell_nr_global)=curbase;
  if(GLOBAL(props_cell_nr_global)>GLOBAL(props_max_allowed_cells_global)) {
    GLOBAL(props_stop_search_flag_global)=BOOL_T;
  }
  if(!(NFALSEP(GLOBAL(props_stop_search_flag_global)))) {
    if(NFALSEP(GLOBAL(props_dynamic_vectors_global))) {
      GLOBAL(props_cell_cterm_vector_global)=make_vector(curbase,BOOL_F);
      GLOBAL(props_cell_occurrences_vector_global)=make_vector(curbase,EOL);
      GLOBAL(props_cell_range_vector_global)=make_vector(curbase,EOL);
      GLOBAL(props_cell_order_vector_global)=make_vector(curbase,EOL);
    }
    for(i__1=MAKINUM(0);!(i__1>=GLOBAL(props_fun_counter_global));i__1=MAKINUM(1+INUM(i__1))) {
      base=VECTOR_REF(GLOBAL(props_fun_basenr_vector_global),i__1);
      arity=VECTOR_REF(GLOBAL(props_fun_arities_vector_global),i__1);
      varvaluations=make_list(arity,MAKINUM(0));
      allchecked=BOOL_F;
      for(j=MAKINUM(0);!(NFALSEP(allchecked));j=MAKINUM(1+INUM(j))) {
        tmp=make_vector(MAKINUM(2+INUM(arity)),MAKINUM(0));
        VECTOR_SET(tmp,MAKINUM(0),EOL);
        VECTOR_SET(tmp,MAKINUM(1),i__1);
        for(k=MAKINUM(2),part=varvaluations;
            !(k>=VECTOR_LENGTH(tmp));
            k=MAKINUM(1+INUM(k)),part=CDR(part)) {
          VECTOR_SET(tmp,k,CAR(part));
        }
        VECTOR_SET(GLOBAL(props_cell_cterm_vector_global),props_cterm_index_nr(tmp,domainsize),tmp);
        new_var1=SBOOL(NULL_P(varvaluations));
        if(NFALSEP(new_var1))
          allchecked=new_var1;
        else
          allchecked=props_valuation_list_nextvalues_excl_(varvaluations,domainsize);
      }
    }
    for(i__2=MAKINUM(0);!(i__2>=GLOBAL(props_cell_nr_global));i__2=MAKINUM(INUM(i__2)+1)) {
      tmp=props_make_initial_range(VECTOR_REF(VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i__2),MAKINUM(1)),domainsize);
      VECTOR_SET(GLOBAL(props_cell_order_vector_global),i__2,i__2);
      VECTOR_SET(GLOBAL(props_cell_range_vector_global),i__2,tmp);
      VECTOR_SET(GLOBAL(props_cell_occurrences_vector_global),i__2,EOL);
    }
    if(NFALSEP(GLOBAL(props_dynamic_vectors_global))) {
      GLOBAL(props_nterm_fun_basenr_vector_global)=make_vector(MAKINUM(10000),EOL);
    }
    curbase=MAKINUM(0);
    for(i__3=MAKINUM(0);!(i__3>=GLOBAL(props_fun_counter_global));i__3=MAKINUM(1+INUM(i__3))) {
      VECTOR_SET(GLOBAL(props_nterm_fun_basenr_vector_global),i__3,curbase);
      arity=VECTOR_REF(GLOBAL(props_fun_arities_vector_global),i__3);
      nr=int_power(MAKINUM(1+INUM(domainsize)),arity);
      if((nr>MAKINUM(10000000))||(nr<MAKINUM(0)))
        report_error(const_766,EOL);
      curbase=MAKINUM(INUM(nr)+INUM(curbase));
    }
    GLOBAL(props_nterm_nr_global)=curbase;
    if(NFALSEP(GLOBAL(props_dynamic_vectors_global))) {
      GLOBAL(props_nterm_vector_global)=make_vector(GLOBAL(props_nterm_nr_global),EOL);
      GLOBAL(props_nterm_originals_vector_global)=make_vector(GLOBAL(props_nterm_nr_global),EOL);
      GLOBAL(props_nterm_matchcells_vector_global)=make_vector(GLOBAL(props_nterm_nr_global),EOL);
      GLOBAL(props_nterm_clauses_vector_global)=make_vector(GLOBAL(props_nterm_nr_global),EOL);
    }
    tmp2=VECTOR_LENGTH(GLOBAL(props_nterm_vector_global));
    for(i__4=MAKINUM(0);!(i__4>=tmp2);i__4=MAKINUM(1+INUM(i__4))) {
      VECTOR_SET(GLOBAL(props_nterm_vector_global),i__4,EOL);
      VECTOR_SET(GLOBAL(props_nterm_originals_vector_global),i__4,EOL);
      VECTOR_SET(GLOBAL(props_nterm_originals_vector_global),i__4,EOL);
    }
    for(i__5=MAKINUM(0);!(0||(i__5>=GLOBAL(props_fun_counter_global)));i__5=MAKINUM(1+INUM(i__5))) {
      base=VECTOR_REF(GLOBAL(props_fun_basenr_vector_global),i__5);
      arity=VECTOR_REF(GLOBAL(props_fun_arities_vector_global),i__5);
      varvaluations=make_list(arity,MAKINUM(0));
      allchecked=BOOL_F;
      for(j__6=MAKINUM(0);!(NFALSEP(allchecked));j__6=MAKINUM(1+INUM(j__6))) {
        tmp=make_vector(MAKINUM(2+INUM(arity)),MAKINUM(0));
        VECTOR_SET(tmp,MAKINUM(0),EOL);
        VECTOR_SET(tmp,MAKINUM(1),i__5);
        tmp3=make_vector(MAKINUM(2+INUM(arity)),MAKINUM(0));
        VECTOR_SET(tmp3,MAKINUM(0),EOL);
        VECTOR_SET(tmp3,MAKINUM(1),i__5);
        for(k__7=MAKINUM(2),part__8=varvaluations;
            !(k__7>=VECTOR_LENGTH(tmp));
            k__7=MAKINUM(1+INUM(k__7)),part__8=CDR(part__8))
          if(domainsize==CAR(part__8)) {
            VECTOR_SET(tmp,k__7,tmp3);
          }
          else {
            VECTOR_SET(tmp,k__7,CAR(part__8));
          }
        tmp2=props_check_nterm_index_nr(tmp,domainsize);
        if(NFALSEP(tmp2)) {
          VECTOR_SET(tmp,CAR(CDR(tmp2)),domainsize);
          VECTOR_SET(GLOBAL(props_nterm_originals_vector_global),CAR(tmp2),tmp);
          lst=EOL;
          for(i__9=MAKINUM(0);!(i__9>=domainsize);i__9=MAKINUM(1+INUM(i__9))) {
            VECTOR_SET(tmp,CAR(CDR(tmp2)),i__9);
            matchnr=props_cterm_index_nr(tmp,domainsize);
            lst=cons(matchnr,lst);
          }
          VECTOR_SET(GLOBAL(props_nterm_matchcells_vector_global),CAR(tmp2),lst);
          VECTOR_SET(tmp,CAR(CDR(tmp2)),domainsize);
        }
        new_var2=SBOOL(NULL_P(varvaluations));
        if(NFALSEP(new_var2))
          allchecked=new_var2;
        else
          allchecked=props_valuation_list_nextvalues_excl_(varvaluations,MAKINUM(INUM(domainsize)+1));
      }
    }
    return UNSPECIFIED;
  }
  else
    return UNSPECIFIED;
}

SCM props_store_initial_occurrences(clauses,domainsize)
SCM clauses,domainsize;
{
  SCM clausespart,clause,len,lit,occ,tmp2,tmp3,tmp,i;

  clause=EOL;
  len=MAKINUM(0);
  lit=EOL;
  occ=EOL;
  tmp2=EOL;
  tmp3=EOL;
  tmp=EOL;
  for(clausespart=clauses;!(NULL_P(clausespart));clausespart=CDR(clausespart)) {
    clause=CAR(clausespart);
    len=VECTOR_LENGTH(clause);
    for(i=MAKINUM(2);!(i>=len);i=MAKINUM(1+INUM(i))) {
      lit=VECTOR_REF(clause,i);
      if(VECTOR_P(lit)) {
        tmp=props_cterm_index_nr(lit,domainsize);
        if(NFALSEP(tmp)) {
          occ=VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),tmp);
          VECTOR_SET(GLOBAL(props_cell_occurrences_vector_global),tmp,cons(lit,occ));
        }
        else {
          if(len>MAKINUM(3)) {
            tmp=props_check_nterm_index_nr(lit,domainsize);
            if(NFALSEP(tmp)) {
              tmp2=VECTOR_REF(GLOBAL(props_nterm_clauses_vector_global),CAR(tmp));
              tmp3=assq(CAR(CDR(CDR(tmp))),tmp2);
              if(NFALSEP(tmp3)) {
                SET_CDR(tmp3,cons(clause,CDR(tmp3)));
              }
              else {
                VECTOR_SET(GLOBAL(props_nterm_clauses_vector_global),CAR(tmp),cons(cons(CAR(CDR(CDR(tmp))),cons(clause,EOL)),tmp2));
              }
            }
          }
          props_store_subterm_occurrences(lit,domainsize);
        }
      }
    }
  }
  return UNSPECIFIED;
}

SCM props_store_subterm_occurrences(term,domainsize)
SCM term,domainsize;
{
  SCM tmp,occ,sterm,len,i;

  len=MAKINUM(0);
  sterm=EOL;
  occ=EOL;
  tmp=EOL;
  len=VECTOR_LENGTH(term);
  for(i=MAKINUM(2);!(i>=len);i=MAKINUM(1+INUM(i))) {
    sterm=VECTOR_REF(term,i);
    if(VECTOR_P(sterm)) {
      tmp=props_cterm_index_nr(sterm,domainsize);
      if(NFALSEP(tmp)) {
        occ=VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),tmp);
        VECTOR_SET(GLOBAL(props_cell_occurrences_vector_global),tmp,cons(sterm,occ));
      }
      else {
        props_store_subterm_occurrences(sterm,domainsize);
      }
    }
  }
  return UNSPECIFIED;
}

SCM props_make_initial_range(fun,domainsize)
SCM fun,domainsize;
{
  SCM tmp,ispred,i;

  ispred=BOOL_F;
  tmp=EOL;
  ispred=VECTOR_REF(GLOBAL(props_fun_ispred_vector_global),fun);
  if(NFALSEP(ispred))
    return cons(MAKINUM(0),cons(MAKINUM(1),EOL));
  else {
    for(i=MAKINUM(INUM(domainsize)-1);!(i<MAKINUM(0));i=MAKINUM(INUM(i)-1)) {
      tmp=cons(i,tmp);
    }
    return tmp;
  }
}

SCM props_cterm_fun_basenr(fun)
SCM fun;
{
  return VECTOR_REF(GLOBAL(props_fun_basenr_vector_global),GLOBAL(props_funnr_mask_global)&fun);
}

SCM props_cterm_index_nr(term,domainsize)
SCM term,domainsize;
{
  SCM nr,tmp,pwr,len,stopflag,part,i;

  part=term;
  stopflag=BOOL_F;
  len=VECTOR_LENGTH(term);
  pwr=MAKINUM(1);
  tmp=MAKINUM(0);
  nr=MAKINUM(0);
  for(i=MAKINUM(2);!(NFALSEP(stopflag)||(i>=len));i=MAKINUM(1+INUM(i))) {
    tmp=VECTOR_REF(term,i);
    if(!(INTEGER_P(tmp))) {
      stopflag=BOOL_T;
      nr=BOOL_F;
    }
    else {
      nr=MAKINUM((INUM(tmp)*INUM(pwr))+INUM(nr));
      pwr=MAKINUM(INUM(pwr)*INUM(domainsize));
    }
  }
  if(NFALSEP(stopflag))
    return nr;
  else
    return MAKINUM(INUM(props_cterm_fun_basenr(VECTOR_REF(term,MAKINUM(1))))+INUM(nr));
}

SCM props_nterm_fun_basenr(fun)
SCM fun;
{
  return VECTOR_REF(GLOBAL(props_nterm_fun_basenr_vector_global),GLOBAL(props_funnr_mask_global)&fun);
}

SCM props_nterm_index_nr(term,cellpos,domainsize)
SCM term,cellpos,domainsize;
{
  SCM nr,tmp,pwr,len,stopflag,part,i;

  part=term;
  stopflag=BOOL_F;
  len=VECTOR_LENGTH(term);
  pwr=MAKINUM(1);
  tmp=MAKINUM(0);
  nr=MAKINUM(0);
  for(i=MAKINUM(2);!(NFALSEP(stopflag)||(i>=len));i=MAKINUM(1+INUM(i))) {
    if(i==cellpos) {
      tmp=domainsize;
    }
    else {
      tmp=VECTOR_REF(term,i);
    }
    if(!(INTEGER_P(tmp))) {
      stopflag=BOOL_T;
      nr=BOOL_F;
    }
    else {
      nr=MAKINUM((INUM(tmp)*INUM(pwr))+INUM(nr));
      pwr=MAKINUM(INUM(pwr)*(1+INUM(domainsize)));
    }
  }
  if(NFALSEP(stopflag))
    return nr;
  else
    return MAKINUM(INUM(props_nterm_fun_basenr(VECTOR_REF(term,MAKINUM(1))))+INUM(nr));
}

SCM props_check_nterm_index_nr(term,domainsize)
SCM term,domainsize;
{
  SCM nr,cpos,cval,tmp,pwr,len,stopflag,i;

  if(!(NFALSEP(GLOBAL(props_use_nterms_strat_global))))
    return BOOL_F;
  else {
    stopflag=BOOL_F;
    len=VECTOR_LENGTH(term);
    pwr=MAKINUM(1);
    tmp=MAKINUM(0);
    cval=BOOL_F;
    cpos=BOOL_F;
    nr=MAKINUM(0);
    for(i=MAKINUM(2);!(NFALSEP(stopflag)||(i>=len));i=MAKINUM(1+INUM(i))) {
      tmp=VECTOR_REF(term,i);
      if(!(INTEGER_P(tmp))) {
        if(NFALSEP(cval)) {
          stopflag=BOOL_T;
        }
        else {
          cval=props_cterm_index_nr(tmp,domainsize);
          if(NFALSEP(cval)) {
            cpos=i;
            nr=MAKINUM((INUM(domainsize)*INUM(pwr))+INUM(nr));
            pwr=MAKINUM(INUM(pwr)*(1+INUM(domainsize)));
          }
          else {
            stopflag=BOOL_T;
          }
        }
      }
      else {
        nr=MAKINUM((INUM(tmp)*INUM(pwr))+INUM(nr));
        pwr=MAKINUM(INUM(pwr)*(1+INUM(domainsize)));
      }
    }
    if(NFALSEP(stopflag)||!(NFALSEP(cval)))
      return BOOL_F;
    else
      return cons(MAKINUM(INUM(props_nterm_fun_basenr(VECTOR_REF(term,MAKINUM(1))))+INUM(nr)),cons(cpos,cons(cval,EOL)));
  }
}

SCM props_check_nterm_eq_assign(eqterm,domainsize)
SCM eqterm,domainsize;
{
  SCM tmp,a1,a2;

  if(!(NFALSEP(GLOBAL(props_use_nterms_strat_global))))
    return BOOL_F;
  else {
    tmp=EOL;
    a1=VECTOR_REF(eqterm,MAKINUM(2));
    a2=VECTOR_REF(eqterm,MAKINUM(3));
    if(INTEGER_P(a1)) {
      if(!(INTEGER_P(a2))) {
        tmp=props_check_nterm_index_nr(a2,domainsize);
        if(NFALSEP(tmp)) {
          if(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(eqterm,MAKINUM(1))))
            return cons(tmp,cons(a1,cons(BOOL_T,EOL)));
          else
            return cons(tmp,cons(a1,cons(BOOL_F,EOL)));
        }
        else
          return BOOL_F;
      }
      else
        return BOOL_F;
    }
    else
    if(INTEGER_P(a2)) {
      tmp=props_check_nterm_index_nr(a1,domainsize);
      if(NFALSEP(tmp)) {
        if(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(eqterm,MAKINUM(1))))
          return cons(tmp,cons(a2,cons(BOOL_T,EOL)));
        else
          return cons(tmp,cons(a2,cons(BOOL_F,EOL)));
      }
      else
        return BOOL_F;
    }
    else
      return BOOL_F;
  }
}

SCM props_assign_nterm_excl_(ntermnr,pos,ctermnr,value,stack,domainsize)
SCM ntermnr,pos,ctermnr,value,stack,domainsize;
{
  SCM celem,res,clauses,lst,tmp,part;

  if(!(NFALSEP(GLOBAL(props_use_nterms_strat_global))))
    return EOL;
  else {
    tmp=EOL;
    lst=EOL;
    clauses=EOL;
    res=BOOL_F;
    celem=BOOL_F;
    if(NFALSEP(GLOBAL(props_debug_global))) {
      newline(cur_output_port());
      display(const_767,cur_output_port());
      newline(cur_output_port());
      display(const_768,cur_output_port());
      display(ntermnr,cur_output_port());
      newline(cur_output_port());
      display(const_769,cur_output_port());
      display(ctermnr,cur_output_port());
      newline(cur_output_port());
      display(const_770,cur_output_port());
      display(value,cur_output_port());
      newline(cur_output_port());
    }
    lst=VECTOR_REF(GLOBAL(props_nterm_vector_global),ntermnr);
    celem=assq(ctermnr,lst);
    if(!(NFALSEP(celem))) {
      GLOBAL(props_nterm_assign_count_global)=MAKINUM(1+INUM(GLOBAL(props_nterm_assign_count_global)));
      props_push_stack_excl_(cons(GLOBAL(props_nterm_vector_global),cons(ntermnr,cons(lst,EOL))),stack);
      VECTOR_SET(GLOBAL(props_nterm_vector_global),ntermnr,cons(cons(ctermnr,cons(value,EOL)),lst));
      res=derive_from_nterm_with_cells(ntermnr,pos,ctermnr,stack,domainsize);
      if(0) {
        clauses=assq(ctermnr,VECTOR_REF(GLOBAL(props_nterm_clauses_vector_global),ntermnr));
        if(NFALSEP(clauses)) {
          for(part=CDR(clauses);!(NULL_P(part)||!(NFALSEP(res)));part=CDR(part)) {
            tmp=props_analyze_clause_excl_(CAR(part),domainsize,stack);
            if(!(NFALSEP(tmp))) {
              res=BOOL_F;
            }
          }
        }
        return res;
      }
      else
        return res;
    }
    else
    if(!(NFALSEP(memq(value,CDR(celem)))))
      return BOOL_F;
    else
    if(NULL_P(CDR(CDR(celem))))
      return EOL;
    else {
      GLOBAL(props_nterm_assign_count_global)=MAKINUM(1+INUM(GLOBAL(props_nterm_assign_count_global)));
      props_push_stack_excl_(cons(celem,cons(MAKINUM(1),cons(CDR(celem),EOL))),stack);
      SET_CDR(celem,cons(value,EOL));
      return derive_from_nterm_with_cells(ntermnr,pos,ctermnr,stack,domainsize);
    }
  }
}

SCM props_restrict_nterm_excl_(ntermnr,pos,ctermnr,value,stack,domainsize)
SCM ntermnr,pos,ctermnr,value,stack,domainsize;
{
  SCM tmp,lst,celem;

  if(!(NFALSEP(GLOBAL(props_use_nterms_strat_global))))
    return EOL;
  else {
    tmp=EOL;
    lst=EOL;
    celem=BOOL_F;
    if(NFALSEP(GLOBAL(props_debug_global))) {
      newline(cur_output_port());
      display(const_771,cur_output_port());
      newline(cur_output_port());
      display(const_772,cur_output_port());
      display(ntermnr,cur_output_port());
      newline(cur_output_port());
      display(const_773,cur_output_port());
      display(ctermnr,cur_output_port());
      newline(cur_output_port());
      display(const_774,cur_output_port());
      display(value,cur_output_port());
      newline(cur_output_port());
    }
    lst=VECTOR_REF(GLOBAL(props_nterm_vector_global),ntermnr);
    celem=assq(ctermnr,lst);
    if(!(NFALSEP(celem))) {
      GLOBAL(props_nterm_restrict_count_global)=MAKINUM(1+INUM(GLOBAL(props_nterm_restrict_count_global)));
      tmp=props_make_initial_range(VECTOR_REF(VECTOR_REF(GLOBAL(props_nterm_originals_vector_global),ntermnr),MAKINUM(1)),domainsize);
      tmp=remove_one_from_list(value,tmp);
      if(NULL_P(tmp))
        return BOOL_F;
      else {
        props_push_stack_excl_(cons(GLOBAL(props_nterm_vector_global),cons(ntermnr,cons(lst,EOL))),stack);
        VECTOR_SET(GLOBAL(props_nterm_vector_global),ntermnr,cons(cons(ctermnr,tmp),lst));
        return derive_from_nterm_with_cells(ntermnr,pos,ctermnr,stack,domainsize);
      }
    }
    else
    if(!(NFALSEP(memq(value,CDR(celem)))))
      return EOL;
    else
    if(NULL_P(CDR(CDR(celem))))
      return BOOL_F;
    else {
      GLOBAL(props_nterm_restrict_count_global)=MAKINUM(1+INUM(GLOBAL(props_nterm_restrict_count_global)));
      props_push_stack_excl_(cons(celem,cons(MAKINUM(1),cons(CDR(celem),EOL))),stack);
      SET_CDR(celem,remove_one_from_list(value,CDR(celem)));
      return derive_from_nterm_with_cells(ntermnr,pos,ctermnr,stack,domainsize);
    }
  }
}

SCM derive_from_cell_with_nterms(cell_nonkeyword,stack,domainsize)
SCM cell_nonkeyword,stack,domainsize;
{
  SCM i,stopflag,nindex,range,origcterm,elem,res,lst,len,part;

  stopflag=BOOL_F;
  nindex=EOL;
  range=EOL;
  origcterm=EOL;
  elem=EOL;
  res=EOL;
  lst=EOL;
  len=MAKINUM(0);
  range=VECTOR_REF(GLOBAL(props_cell_range_vector_global),cell_nonkeyword);
  origcterm=VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),cell_nonkeyword);
  len=VECTOR_LENGTH(origcterm);
  for(i=MAKINUM(2);!(NFALSEP(stopflag)||(i>=len));i=MAKINUM(INUM(i)+1)) {
    nindex=props_nterm_index_nr(origcterm,i,domainsize);
    lst=VECTOR_REF(GLOBAL(props_nterm_vector_global),nindex);
    for(part=lst;!(NFALSEP(stopflag)||NULL_P(part));part=CDR(part)) {
      elem=CAR(part);
      if(NFALSEP(props_no_intersection(range,CDR(elem)))) {
        GLOBAL(props_nterm_derive_count_global)=MAKINUM(1+INUM(GLOBAL(props_nterm_derive_count_global)));
        res=props_restrict_cell_excl_(CAR(elem),VECTOR_REF(origcterm,i),stack,domainsize);
        if(!(NFALSEP(res))) {
          stopflag=BOOL_T;
        }
      }
    }
  }
  if(NFALSEP(stopflag))
    return BOOL_F;
  else
    return EOL;
}

SCM derive_from_nterm_with_cells(ntermindex,pos,cell_nonkeyword,stack,domainsize)
SCM ntermindex,pos,cell_nonkeyword,stack,domainsize;
{
  SCM res,matchcell,matchrange,matchcells,range,elem,stopflag,part;

  stopflag=BOOL_F;
  elem=EOL;
  range=EOL;
  matchcells=EOL;
  matchrange=EOL;
  matchcell=EOL;
  res=EOL;
  elem=assq(cell_nonkeyword,VECTOR_REF(GLOBAL(props_nterm_vector_global),ntermindex));
  if(NFALSEP(elem)&&!(NULL_P(CDR(elem)))) {
    range=CDR(elem);
    matchcells=VECTOR_REF(GLOBAL(props_nterm_matchcells_vector_global),ntermindex);
    for(part=matchcells;!(NFALSEP(stopflag)||NULL_P(part));part=CDR(part)) {
      matchcell=CAR(part);
      matchrange=VECTOR_REF(GLOBAL(props_cell_range_vector_global),matchcell);
      if(NFALSEP(props_no_intersection(range,matchrange))) {
        GLOBAL(props_nterm_derive_count_global)=MAKINUM(1+INUM(GLOBAL(props_nterm_derive_count_global)));
        res=props_restrict_cell_excl_(cell_nonkeyword,VECTOR_REF(VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),matchcell),pos),stack,domainsize);
        if(!(NFALSEP(res))) {
          stopflag=BOOL_T;
        }
      }
    }
    if(NFALSEP(stopflag))
      return BOOL_F;
    else
      return EOL;
  }
  else
    return UNSPECIFIED;
}

SCM props_saturate_clauses(clauselst,domainsize)
SCM clauselst,domainsize;
{
  SCM unsatisfiable,satres,lstpart;

  satres=BOOL_F;
  unsatisfiable=BOOL_F;
  GLOBAL(props_ground_clauses_global)=EOL;
  for(lstpart=clauselst;!(NULL_P(lstpart)||(NFALSEP(unsatisfiable)||(NFALSEP(GLOBAL(props_stop_search_flag_global))||((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))))));lstpart=CDR(lstpart)) {
    unsatisfiable=props_saturate_clause_excl_(CAR(lstpart),domainsize);
  }
  if(NFALSEP(unsatisfiable))
    return BOOL_T;
  else
    return GLOBAL(props_ground_clauses_global);
}

SCM props_saturate_clause_excl_(clause,domainsize)
SCM clause,domainsize;
{
  SCM propclause,allchecked,unsatisfiable,varvaluations,varslist,new_var1;

  varslist=VECTOR_REF(clause,MAKINUM(0));
  varvaluations=EOL;
  unsatisfiable=BOOL_F;
  allchecked=BOOL_F;
  propclause=EOL;
  if(!(NULL_P(varslist))) {
    varvaluations=map1(props_saturate_clause_excl__fn769,varslist);
  }
  for(;!(NFALSEP(unsatisfiable)||(NFALSEP(allchecked)||NFALSEP(GLOBAL(props_stop_search_flag_global))));) {
    if((INUM(get_check_time(MAKINUM(1)))-INUM(GLOBAL(slow_start_time_global)))>INUM(GLOBAL(one_pass_time_global))) {
      GLOBAL(props_stop_search_flag_global)=BOOL_T;
    }
    set_pred_var_values(varslist,varvaluations);
    propclause=props_make_ground_clause(clause);
    if(!(NFALSEP(propclause))) {
      unsatisfiable=BOOL_T;
    }
    else
    if(!(NULL_P(propclause))) {
      GLOBAL(props_clause_count_global)=MAKINUM(1+INUM(GLOBAL(props_clause_count_global)));
      if(GLOBAL(props_clause_count_global)>GLOBAL(props_max_allowed_clauses_global)) {
        GLOBAL(props_stop_search_flag_global)=BOOL_T;
      }
      GLOBAL(props_ground_clauses_global)=cons(propclause,GLOBAL(props_ground_clauses_global));
    }
    new_var1=SBOOL(NULL_P(varvaluations));
    if(NFALSEP(new_var1))
      allchecked=new_var1;
    else
      allchecked=props_valuation_list_nextvalues_excl_(varvaluations,domainsize);
  }
  if(NFALSEP(GLOBAL(props_stop_search_flag_global)))
    return BOOL_F;
  else
    return unsatisfiable;
}

SCM props_saturate_clause_excl__fn769(x)
SCM x;
{
  return MAKINUM(0);
}

SCM props_make_ground_clause(term)
SCM term;
{
  SCM part,len,vec,falseflag,tautflag,sameflag,lstlen,lst,tmp,i,i__1,part__2;

  tmp=EOL;
  lst=EOL;
  lstlen=MAKINUM(0);
  sameflag=BOOL_F;
  tautflag=BOOL_F;
  falseflag=BOOL_F;
  vec=EOL;
  len=MAKINUM(0);
  len=VECTOR_LENGTH(term);
  vec=EOL;
  for(i=MAKINUM(2);!(NFALSEP(tautflag)||(i>=len));i=MAKINUM(1+INUM(i))) {
    tmp=VECTOR_REF(term,i);
    if(INTEGER_P(tmp)) {
      tmp=STBL_VECTOR_REF(_star_var_val_table_star__velts0,tmp);
    }
    else {
      tmp=props_make_ground_term(tmp,vec,i);
    }
    sameflag=BOOL_F;
    tautflag=BOOL_F;
    falseflag=BOOL_F;
    if(BOOL_T==tmp) {
      tautflag=BOOL_T;
    }
    else
    if(BOOL_F==tmp) {
      falseflag=BOOL_T;
    }
    for(part=lst;!(NFALSEP(tautflag)||(NFALSEP(falseflag)||NULL_P(part)));part=CDR(part))
      if(NFALSEP(props_equal_terms_nopolarity(CAR(lst),tmp))) {
        if((GLOBAL(props_isneglit_mask_global)&VECTOR_REF(CAR(lst),MAKINUM(1)))==(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(tmp,MAKINUM(1)))) {
          sameflag=BOOL_T;
        }
        else {
          tautflag=BOOL_T;
        }
      }
    if(!(NFALSEP(sameflag))&&(!(NFALSEP(tautflag))&&!(NFALSEP(falseflag)))) {
      lst=cons(tmp,lst);
    }
  }
  if(NFALSEP(tautflag))
    return EOL;
  else
  if(NULL_P(lst))
    return BOOL_F;
  else {
    lstlen=length(lst);
    len=MAKINUM(2+INUM(lstlen));
    vec=make_vector(len,EOL);
    for(i__1=MAKINUM(2),part__2=lst;
        !(i__1>=len);
        i__1=MAKINUM(1+INUM(i__1)),part__2=CDR(part__2)) {
      tmp=CAR(part__2);
      VECTOR_SET(tmp,MAKINUM(0),cons(vec,i__1));
      VECTOR_SET(vec,i__1,tmp);
    }
    VECTOR_SET(vec,MAKINUM(0),EOL);
    VECTOR_SET(vec,MAKINUM(1),EOL);
    return vec;
  }
}

SCM props_make_ground_term(term,parent,index)
SCM term,parent,index;
{
  SCM len,fun,vec,tmp,i;

  tmp=EOL;
  vec=EOL;
  fun=MAKINUM(0);
  len=MAKINUM(0);
  if(INTEGER_P(term))
    return STBL_VECTOR_REF(_star_var_val_table_star__velts0,term);
  else {
    len=VECTOR_LENGTH(term);
    vec=make_vector(len,EOL);
    for(i=MAKINUM(2);!(i>=len);i=MAKINUM(1+INUM(i))) {
      tmp=VECTOR_REF(term,i);
      if(INTEGER_P(tmp)) {
        tmp=STBL_VECTOR_REF(_star_var_val_table_star__velts0,tmp);
      }
      else {
        tmp=props_make_ground_term(tmp,vec,i);
      }
      VECTOR_SET(vec,i,tmp);
    }
    VECTOR_SET(vec,MAKINUM(0),cons(parent,index));
    fun=VECTOR_REF(term,MAKINUM(1));
    VECTOR_SET(vec,MAKINUM(1),fun);
    if((GLOBAL(props_purefun_mask_global)&VECTOR_REF(vec,MAKINUM(1)))==GLOBAL(props_eq_fun_global)) {
      tmp=props_eq_lit_value_check(vec);
      if(NULL_P(tmp))
        return vec;
      else
        return tmp;
    }
    else
      return vec;
  }
}

SCM props_eq_lit_value_check(term)
SCM term;
{
  SCM a1,a2;

  a1=VECTOR_REF(term,MAKINUM(2));
  a2=VECTOR_REF(term,MAKINUM(3));
  if(NFALSEP(props_equal_terms_nopolarity(a1,a2))) {
    if(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(term,MAKINUM(1))))
      return BOOL_T;
    else
      return BOOL_F;
  }
  else
  if(INTEGER_P(a1)&&(INTEGER_P(a2)&&!(a1==a2))) {
    if(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(term,MAKINUM(1))))
      return BOOL_F;
    else
      return BOOL_T;
  }
  else
    return EOL;
}

SCM props_eq_lit_fast_value_check(term)
SCM term;
{
  SCM a1,a2;

  a1=VECTOR_REF(term,MAKINUM(2));
  a2=VECTOR_REF(term,MAKINUM(3));
  if(INTEGER_P(a1)&&INTEGER_P(a2)) {
    if(a1==a2) {
      if(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(term,MAKINUM(1))))
        return BOOL_T;
      else
        return BOOL_F;
    }
    else
    if(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(term,MAKINUM(1))))
      return BOOL_F;
    else
      return BOOL_T;
  }
  else
    return EOL;
}

SCM props_valuation_list_nextvalues_excl_(valuationlist,domainsize)
SCM valuationlist,domainsize;
{
tailrecursion:
  if(PAIR_P(valuationlist)&&(INUM(CAR(valuationlist))>=(INUM(domainsize)-1))) {
    if(NULL_P(CDR(valuationlist)))
      return BOOL_T;
    else {
      SET_CAR(valuationlist,MAKINUM(0));
      valuationlist=CDR(valuationlist);
      goto tailrecursion;
    }
  }
  else {
    SET_CAR(valuationlist,MAKINUM(1+INUM(CAR(valuationlist))));
    return BOOL_F;
  }
}

SCM props_equal_terms_nopolarity(term1,term2)
SCM term1,term2;
{
  SCM stopflag,len,i;

  len=MAKINUM(0);
  stopflag=BOOL_F;
  if(NUMBER_P(term1))
    return SBOOL(term1==term2);
  else
  if(NUMBER_P(term2))
    return BOOL_F;
  else
  if(!((GLOBAL(props_funnr_mask_global)&VECTOR_REF(term1,MAKINUM(1)))==(GLOBAL(props_funnr_mask_global)&VECTOR_REF(term2,MAKINUM(1)))))
    return BOOL_F;
  else {
    len=VECTOR_LENGTH(term1);
    for(i=MAKINUM(2);!(NFALSEP(stopflag)||(i>=len));i=MAKINUM(INUM(i)+1))
      if(!(NFALSEP(props_equal_terms_nopolarity(VECTOR_REF(term1,i),VECTOR_REF(term2,i))))) {
        stopflag=BOOL_T;
      }
    return NOT(stopflag);
  }
}

SCM props_make_nonground_clauses(clauses)
SCM clauses;
{
  SCM res;

  res=EOL;
  GLOBAL(props_pred_nr_table_global)=EOL;
  GLOBAL(props_fun_nr_table_global)=EOL;
  GLOBAL(props_const_nr_table_global)=EOL;
  GLOBAL(props_fun_counter_global)=MAKINUM(0);
  return map1(props_make_nonground_clauses_fn771,clauses);
}

SCM props_make_nonground_clauses_fn771(cl)
SCM cl;
{
  return props_make_nonground_clause(cl);
}

SCM props_make_nonground_clause(cl)
SCM cl;
{
  SCM len,vec,tmp,i;

  tmp=EOL;
  vec=EOL;
  len=length(CDR(cl));
  GLOBAL(props_nonground_vars_tmp_global)=EOL;
  vec=make_vector(MAKINUM(2+INUM(len)),EOL);
  cl=CDR(cl);
  for(i=MAKINUM(2);!(NULL_P(cl));i=MAKINUM(1+INUM(i))) {
    tmp=props_make_nonground_lit(CAR(cl));
    cl=CDR(cl);
    VECTOR_SET(vec,i,tmp);
  }
  VECTOR_SET(vec,MAKINUM(0),GLOBAL(props_nonground_vars_tmp_global));
  return vec;
}

SCM props_make_nonground_lit(lit)
SCM lit;
{
  SCM len,lpart,vec,tmp,i;

  tmp=EOL;
  vec=EOL;
  lpart=CDR(lit);
  len=length(lit);
  vec=make_vector(MAKINUM(1+INUM(len)),EOL);
  for(i=MAKINUM(2);!(NULL_P(lpart));i=MAKINUM(1+INUM(i))) {
    tmp=props_make_nonground_term(CAR(lpart));
    lpart=CDR(lpart);
    VECTOR_SET(vec,i,tmp);
  }
  tmp=props_make_pred_nr(CAR(lit),MAKINUM(INUM(len)-1));
  VECTOR_SET(vec,MAKINUM(1),tmp);
  return vec;
}

SCM props_make_nonground_term(term)
SCM term;
{
  SCM len,tpart,vec,tmp,i;

  tmp=EOL;
  vec=EOL;
  tpart=term;
  len=MAKINUM(0);
  if(NUMBER_P(term)&&(term<=MAKINUM(65535))) {
    if(!(NFALSEP(memq(props_var_nr(term),GLOBAL(props_nonground_vars_tmp_global))))) {
      GLOBAL(props_nonground_vars_tmp_global)=cons(props_var_nr(term),GLOBAL(props_nonground_vars_tmp_global));
    }
    return props_var_nr(term);
  }
  else
  if(!(!(NUMBER_P(term)))) {
    vec=make_vector(MAKINUM(2),EOL);
    VECTOR_SET(vec,MAKINUM(1),props_make_const_nr(term));
    return vec;
  }
  else {
    len=length(term);
    tpart=CDR(term);
    vec=make_vector(MAKINUM(1+INUM(len)),EOL);
    for(i=MAKINUM(2);!(NULL_P(tpart));i=MAKINUM(1+INUM(i))) {
      tmp=props_make_nonground_term(CAR(tpart));
      tpart=CDR(tpart);
      VECTOR_SET(vec,i,tmp);
    }
    tmp=props_make_fun_nr(CAR(term),MAKINUM(INUM(len)-1));
    VECTOR_SET(vec,MAKINUM(1),tmp);
    return vec;
  }
}

SCM props_var_nr(term)
SCM term;
{
  return MAKINUM(8191)&term;
}

SCM props_make_const_nr(term)
SCM term;
{
  SCM tmp;

  tmp=EOL;
  tmp=assq(term,GLOBAL(props_const_nr_table_global));
  if(NFALSEP(tmp))
    return CDR(tmp);
  else {
    tmp=GLOBAL(props_fun_counter_global);
    GLOBAL(props_const_nr_table_global)=cons(cons(term,tmp),GLOBAL(props_const_nr_table_global));
    VECTOR_SET(GLOBAL(props_fun_arities_vector_global),GLOBAL(props_fun_counter_global),MAKINUM(0));
    VECTOR_SET(GLOBAL(props_fun_originals_vector_global),GLOBAL(props_fun_counter_global),term);
    VECTOR_SET(GLOBAL(props_fun_originalsymb_vector_global),GLOBAL(props_fun_counter_global),CAR(rassq(term,GLOBAL(const_num_table_global))));
    GLOBAL(props_fun_counter_global)=MAKINUM(1+INUM(GLOBAL(props_fun_counter_global)));
    return tmp;
  }
}

SCM props_make_fun_nr(term,arity)
SCM term,arity;
{
  SCM tmp,tmp2,pterm;

  tmp=EOL;
  tmp2=EOL;
  pterm=(MAKINUM(534773760)&term);
  tmp=assq(pterm,GLOBAL(props_fun_nr_table_global));
  if(NFALSEP(tmp))
    return CDR(tmp);
  else {
    tmp2=rassq(pterm,GLOBAL(fun_num_table_global));
    tmp=GLOBAL(props_fun_counter_global);
    GLOBAL(props_fun_nr_table_global)=cons(cons(pterm,tmp),GLOBAL(props_fun_nr_table_global));
    VECTOR_SET(GLOBAL(props_fun_arities_vector_global),GLOBAL(props_fun_counter_global),arity);
    VECTOR_SET(GLOBAL(props_fun_originals_vector_global),GLOBAL(props_fun_counter_global),pterm);
    VECTOR_SET(GLOBAL(props_fun_originalsymb_vector_global),GLOBAL(props_fun_counter_global),CAR(tmp2));
    VECTOR_SET(GLOBAL(props_fun_ispred_vector_global),GLOBAL(props_fun_counter_global),BOOL_F);
    GLOBAL(props_fun_counter_global)=MAKINUM(1+INUM(GLOBAL(props_fun_counter_global)));
    return tmp;
  }
}

SCM props_make_pred_nr(term,arity)
SCM term,arity;
{
  SCM tmp,tmp2,polarity,pterm;

  tmp=EOL;
  tmp2=EOL;
  polarity=BOOL_T;
  pterm=(MAKINUM(266338304)&term);
  if(!(ZERO_P(MAKINUM(268435456)&term))) {
    polarity=BOOL_F;
  }
  else {
    polarity=BOOL_T;
  }
  tmp=assq(pterm,GLOBAL(props_pred_nr_table_global));
  if(NFALSEP(tmp)) {
    if(NFALSEP(polarity))
      return GLOBAL(props_islit_mask_global)|CDR(tmp);
    else
      return GLOBAL(props_islit_mask_global)|(MAKINUM(268435456)|CDR(tmp));
  }
  else {
    if(pterm==GLOBAL(eq_pred_nr_global)) {
      GLOBAL(props_eq_fun_global)=GLOBAL(props_fun_counter_global);
    }
    tmp2=rassq(pterm,GLOBAL(pred_num_table_global));
    tmp=GLOBAL(props_fun_counter_global);
    GLOBAL(props_pred_nr_table_global)=cons(cons(pterm,tmp),GLOBAL(props_pred_nr_table_global));
    VECTOR_SET(GLOBAL(props_fun_arities_vector_global),GLOBAL(props_fun_counter_global),arity);
    VECTOR_SET(GLOBAL(props_fun_originals_vector_global),GLOBAL(props_fun_counter_global),pterm);
    VECTOR_SET(GLOBAL(props_fun_originalsymb_vector_global),GLOBAL(props_fun_counter_global),CAR(tmp2));
    VECTOR_SET(GLOBAL(props_fun_ispred_vector_global),GLOBAL(props_fun_counter_global),BOOL_T);
    GLOBAL(props_fun_counter_global)=MAKINUM(1+INUM(GLOBAL(props_fun_counter_global)));
    if(NFALSEP(polarity))
      return GLOBAL(props_islit_mask_global)|tmp;
    else
      return GLOBAL(props_islit_mask_global)|(MAKINUM(268435456)|tmp);
  }
}

SCM print_props_nonground_clause(clause)
SCM clause;
{
  SCM i;

  display(VECTOR_REF(clause,MAKINUM(0)),cur_output_port());
  display(const_775,cur_output_port());
  for(i=MAKINUM(2);!(i>=VECTOR_LENGTH(clause));i=MAKINUM(1+INUM(i))) {
    print_props_nonground_term(VECTOR_REF(clause,i));
    if(INUM(i)<(INUM(VECTOR_LENGTH(clause))-1))
      display(const_776,cur_output_port());
    else
      display(const_777,cur_output_port());
  }
  return UNSPECIFIED;
}

SCM print_props_ground_clause(clause)
SCM clause;
{
  SCM i;

  if(!(VECTOR_P(clause)))
    return display(clause,cur_output_port());
  else {
    display(VECTOR_REF(clause,MAKINUM(0)),cur_output_port());
    display(const_778,cur_output_port());
    for(i=MAKINUM(2);!(i>=VECTOR_LENGTH(clause));i=MAKINUM(1+INUM(i))) {
      if(NUMBER_P(VECTOR_REF(clause,i)))
        display(VECTOR_REF(clause,i),cur_output_port());
      else {
        if(!(INTEGER_P(VECTOR_REF(clause,i)))&&(!(clause==CAR(VECTOR_REF(VECTOR_REF(clause,i),MAKINUM(0))))||!(VECTOR_REF(CAR(VECTOR_REF(VECTOR_REF(clause,i),MAKINUM(0))),CDR(VECTOR_REF(VECTOR_REF(clause,i),MAKINUM(0))))==VECTOR_REF(clause,i)))) {
          newline(cur_output_port());
          display(const_779,cur_output_port());
          newline(cur_output_port());
          quit(1);
        }
        print_props_ground_term(VECTOR_REF(clause,i));
      }
      if(INUM(i)<(INUM(VECTOR_LENGTH(clause))-1))
        display(const_780,cur_output_port());
      else
        display(const_781,cur_output_port());
    }
    return UNSPECIFIED;
  }
}

SCM print_props_nonground_term(term)
SCM term;
{
  SCM tmp,i;

  tmp=EOL;
  if(NUMBER_P(term)&&(term<=MAKINUM(65535))) {
    display(const_782,cur_output_port());
    return display(term,cur_output_port());
  }
  else
  if(INTEGER_P(term)) {
    if(!(ZERO_P(GLOBAL(props_isconst_mask_global)&term)))
      display(const_783,cur_output_port());
    return display(GLOBAL(props_funnr_mask_global)&term,cur_output_port());
  }
  else {
    if(!(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(term,MAKINUM(1)))))
      display(const_784,cur_output_port());
    if(!(ZERO_P(GLOBAL(props_islit_mask_global)&VECTOR_REF(term,MAKINUM(1)))))
      display(const_785,cur_output_port());
    else
      display(const_786,cur_output_port());
    display(GLOBAL(props_funnr_mask_global)&VECTOR_REF(term,MAKINUM(1)),cur_output_port());
    display(const_787,cur_output_port());
    for(i=MAKINUM(2);!(i>=VECTOR_LENGTH(term));i=MAKINUM(1+INUM(i))) {
      print_props_nonground_term(VECTOR_REF(term,i));
      if(INUM(i)<(INUM(VECTOR_LENGTH(term))-1))
        display(const_788,cur_output_port());
    }
    return display(const_789,cur_output_port());
  }
}

SCM print_props_ground_term(term)
SCM term;
{
  SCM tmp,i;

  tmp=EOL;
  if(INTEGER_P(term)) {
    if(!(ZERO_P(GLOBAL(props_isconst_mask_global)&term)))
      display(const_790,cur_output_port());
    return display(GLOBAL(props_funnr_mask_global)&term,cur_output_port());
  }
  else {
    display(GLOBAL(props_funnr_mask_global)&VECTOR_REF(term,MAKINUM(1)),cur_output_port());
    display(const_791,cur_output_port());
    for(i=MAKINUM(2);!(i>=VECTOR_LENGTH(term));i=MAKINUM(1+INUM(i))) {
      if(!(INTEGER_P(VECTOR_REF(term,i)))&&(!(term==CAR(VECTOR_REF(VECTOR_REF(term,i),MAKINUM(0))))||!(VECTOR_REF(CAR(VECTOR_REF(VECTOR_REF(term,i),MAKINUM(0))),CDR(VECTOR_REF(VECTOR_REF(term,i),MAKINUM(0))))==VECTOR_REF(term,i)))) {
        newline(cur_output_port());
        display(const_792,cur_output_port());
        newline(cur_output_port());
        quit(1);
      }
      print_props_ground_term(VECTOR_REF(term,i));
      if(INUM(i)<(INUM(VECTOR_LENGTH(term))-1))
        display(const_793,cur_output_port());
    }
    return display(const_794,cur_output_port());
  }
}

SCM print_props_model_term(term)
SCM term;
{
  SCM tmp,i;

  tmp=EOL;
  if(INTEGER_P(term)) {
    if(!(ZERO_P(GLOBAL(props_isconst_mask_global)&term)))
      display(const_795,cur_output_port());
    display(GLOBAL(props_funnr_mask_global)&term,cur_output_port());
    return display(VECTOR_REF(GLOBAL(props_fun_originalsymb_vector_global),GLOBAL(props_funnr_mask_global)&term),cur_output_port());
  }
  else {
    if(!(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(term,MAKINUM(1)))))
      display(const_796,cur_output_port());
    if(VECTOR_REF(term,MAKINUM(1))<MAKINUM(70000))
      display(VECTOR_REF(GLOBAL(props_fun_originalsymb_vector_global),GLOBAL(props_funnr_mask_global)&VECTOR_REF(term,MAKINUM(1))),cur_output_port());
    else
      display(VECTOR_REF(GLOBAL(props_fun_originalsymb_vector_global),GLOBAL(props_funnr_mask_global)&VECTOR_REF(term,MAKINUM(1))),cur_output_port());
    display(const_797,cur_output_port());
    for(i=MAKINUM(2);!(i>=VECTOR_LENGTH(term));i=MAKINUM(1+INUM(i))) {
      if(!(INTEGER_P(VECTOR_REF(term,i)))&&(!(term==CAR(VECTOR_REF(VECTOR_REF(term,i),MAKINUM(0))))||!(VECTOR_REF(CAR(VECTOR_REF(VECTOR_REF(term,i),MAKINUM(0))),CDR(VECTOR_REF(VECTOR_REF(term,i),MAKINUM(0))))==VECTOR_REF(term,i)))) {
        newline(cur_output_port());
        display(const_798,cur_output_port());
        newline(cur_output_port());
        quit(1);
      }
      print_props_ground_term(VECTOR_REF(term,i));
      if(INUM(i)<(INUM(VECTOR_LENGTH(term))-1))
        display(const_799,cur_output_port());
    }
    return display(const_800,cur_output_port());
  }
}

SCM props_print_vectors()
{
  SCM i__1,i,i__2;

  newline(cur_output_port());
  display(const_801,cur_output_port());
  newline(cur_output_port());
  for(i=MAKINUM(0);!((i>=GLOBAL(props_fun_counter_global))||(!(VECTOR_P(GLOBAL(props_fun_originalsymb_vector_global)))||(!(VECTOR_P(GLOBAL(props_fun_arities_vector_global)))||!(VECTOR_P(GLOBAL(props_fun_basenr_vector_global))))));i=MAKINUM(1+INUM(i))) {
    display(i,cur_output_port());
    display(const_802,cur_output_port());
    display(const_803,cur_output_port());
    display(VECTOR_REF(GLOBAL(props_fun_originalsymb_vector_global),i),cur_output_port());
    display(const_804,cur_output_port());
    display(VECTOR_REF(GLOBAL(props_fun_originals_vector_global),i),cur_output_port());
    display(const_805,cur_output_port());
    display(VECTOR_REF(GLOBAL(props_fun_ispred_vector_global),i),cur_output_port());
    display(const_806,cur_output_port());
    display(VECTOR_REF(GLOBAL(props_fun_arities_vector_global),i),cur_output_port());
    display(const_807,cur_output_port());
    display(VECTOR_REF(GLOBAL(props_fun_basenr_vector_global),i),cur_output_port());
    newline(cur_output_port());
  }
  newline(cur_output_port());
  display(const_808,cur_output_port());
  newline(cur_output_port());
  for(i__1=MAKINUM(0);!((i__1>=GLOBAL(props_cell_nr_global))||!(VECTOR_P(GLOBAL(props_cell_cterm_vector_global))));i__1=MAKINUM(1+INUM(i__1))) {
    display(i__1,cur_output_port());
    display(const_809,cur_output_port());
    display(const_810,cur_output_port());
    print_props_ground_term(VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i__1));
    display(const_811,cur_output_port());
    display(VECTOR_REF(GLOBAL(props_cell_cterm_vector_global),i__1),cur_output_port());
    display(const_812,cur_output_port());
    display(VECTOR_REF(GLOBAL(props_cell_range_vector_global),i__1),cur_output_port());
    display(const_813,cur_output_port());
    display(length(VECTOR_REF(GLOBAL(props_cell_occurrences_vector_global),i__1)),cur_output_port());
    newline(cur_output_port());
  }
  newline(cur_output_port());
  display(const_814,cur_output_port());
  newline(cur_output_port());
  for(i__2=MAKINUM(0);!(i__2>=GLOBAL(props_nterm_nr_global));i__2=MAKINUM(1+INUM(i__2)))
    if(VECTOR_P(VECTOR_REF(GLOBAL(props_nterm_originals_vector_global),i__2))) {
      display(i__2,cur_output_port());
      display(const_815,cur_output_port());
      display(const_816,cur_output_port());
      print_props_ground_term(VECTOR_REF(GLOBAL(props_nterm_originals_vector_global),i__2));
      display(const_817,cur_output_port());
      display(VECTOR_REF(GLOBAL(props_nterm_vector_global),i__2),cur_output_port());
      display(const_818,cur_output_port());
      display(VECTOR_REF(GLOBAL(props_nterm_matchcells_vector_global),i__2),cur_output_port());
      newline(cur_output_port());
    }
  return UNSPECIFIED;
}

SCM props_check_model(clauses,domainsize)
SCM clauses,domainsize;
{
  SCM stopflag,res,part;

  res=EOL;
  stopflag=BOOL_F;
  for(part=clauses;!(NULL_P(part)||NFALSEP(stopflag));part=CDR(part)) {
    res=props_check_saturate_clause(CAR(part),domainsize);
    if(!(res==BOOL_T)) {
      stopflag=BOOL_T;
    }
  }
  if(NFALSEP(stopflag)) {
    newline(cur_output_port());
    display(const_819,cur_output_port());
    newline(cur_output_port());
    return BOOL_F;
  }
  else
    return BOOL_T;
}

SCM props_check_saturate_clause(clause,domainsize)
SCM clause,domainsize;
{
  SCM propclause,allchecked,badflag,varvaluations,varslist,new_var1;

  varslist=VECTOR_REF(clause,MAKINUM(0));
  varvaluations=EOL;
  badflag=BOOL_F;
  allchecked=BOOL_F;
  propclause=EOL;
  if(!(NULL_P(varslist))) {
    varvaluations=map1(props_check_saturate_clause_fn773,varslist);
  }
  for(;!(NFALSEP(badflag)||NFALSEP(allchecked));) {
    set_pred_var_values(varslist,varvaluations);
    propclause=props_check_make_ground_clause(clause,domainsize);
    if(!(BOOL_T==propclause)) {
      badflag=BOOL_T;
    }
    new_var1=SBOOL(NULL_P(varvaluations));
    if(NFALSEP(new_var1))
      allchecked=new_var1;
    else
      allchecked=props_valuation_list_nextvalues_excl_(varvaluations,domainsize);
  }
  if(NFALSEP(badflag))
    return BOOL_F;
  else
    return BOOL_T;
}

SCM props_check_saturate_clause_fn773(x)
SCM x;
{
  return MAKINUM(0);
}

SCM props_check_make_ground_clause(term,domainsize)
SCM term,domainsize;
{
  SCM len,vec,tautflag,res,tmp,i;

  tmp=EOL;
  res=EOL;
  tautflag=BOOL_F;
  vec=EOL;
  len=MAKINUM(0);
  len=VECTOR_LENGTH(term);
  for(i=MAKINUM(2);!(NFALSEP(tautflag)||(i>=len));i=MAKINUM(1+INUM(i))) {
    tmp=VECTOR_REF(term,i);
    if(INTEGER_P(tmp)) {
      res=STBL_VECTOR_REF(_star_var_val_table_star__velts0,tmp);
    }
    else {
      res=props_check_make_ground_term(tmp,domainsize);
    }
    if(res==MAKINUM(1)) {
      if(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(tmp,MAKINUM(1)))) {
        tautflag=BOOL_T;
      }
    }
    else
    if(res==MAKINUM(0)) {
      if(!(ZERO_P(GLOBAL(props_isneglit_mask_global)&VECTOR_REF(tmp,MAKINUM(1))))) {
        tautflag=BOOL_T;
      }
    }
  }
  if(!(NFALSEP(tautflag)))
    return BOOL_F;
  else
    return BOOL_T;
}

SCM props_check_make_ground_term(term,domainsize)
SCM term,domainsize;
{
  SCM len,fun,vec,tmp,i;

  tmp=EOL;
  vec=EOL;
  fun=MAKINUM(0);
  len=MAKINUM(0);
  if(INTEGER_P(term))
    return STBL_VECTOR_REF(_star_var_val_table_star__velts0,term);
  else {
    len=VECTOR_LENGTH(term);
    vec=make_vector(len,EOL);
    for(i=MAKINUM(2);!(i>=len);i=MAKINUM(1+INUM(i))) {
      tmp=VECTOR_REF(term,i);
      if(INTEGER_P(tmp)) {
        tmp=STBL_VECTOR_REF(_star_var_val_table_star__velts0,tmp);
      }
      else {
        tmp=props_check_make_ground_term(tmp,domainsize);
      }
      VECTOR_SET(vec,i,tmp);
    }
    VECTOR_SET(vec,MAKINUM(0),EOL);
    fun=VECTOR_REF(term,MAKINUM(1));
    VECTOR_SET(vec,MAKINUM(1),fun);
    tmp=props_check_compute_term(vec,domainsize);
    return tmp;
  }
}

SCM props_check_compute_term(term,domainsize)
SCM term,domainsize;
{
  SCM res,cell_nonkeyword;

  res=EOL;
  cell_nonkeyword=EOL;
  cell_nonkeyword=props_cterm_index_nr(term,domainsize);
  if(NFALSEP(cell_nonkeyword))
    return CAR(VECTOR_REF(GLOBAL(props_cell_range_vector_global),cell_nonkeyword));
  else
    return term;
}

SCM props_eq_pred_pred_(prednr)
SCM prednr;
{
  return SBOOL((GLOBAL(props_purefun_mask_global)&prednr)==GLOBAL(props_eq_fun_global));
}

SCM props_is_pred_pred_(prednr)
SCM prednr;
{
  return NOT(SBOOL(ZERO_P(GLOBAL(props_islit_mask_global)&prednr)));
}

SCM props_term_is_surely_lit_pred_(term)
SCM term;
{
  SCM fun;

  fun=VECTOR_REF(term,MAKINUM(1));
  return VECTOR_REF(GLOBAL(props_fun_ispred_vector_global),fun);
}

SCM props_pos_pred_pred_(prednr)
SCM prednr;
{
  return SBOOL(ZERO_P(GLOBAL(props_isneglit_mask_global)&prednr));
}

SCM props_pure_fun(funnr)
SCM funnr;
{
  return GLOBAL(props_purefun_mask_global)&funnr;
}

SCM int_power(nr,exp_nonkeyword)
SCM nr,exp_nonkeyword;
{
  SCM new_var1;

  new_var1=exp_nonkeyword;
  if(MAKINUM(0)==new_var1)
    return MAKINUM(1);
  else
  if(MAKINUM(1)==new_var1)
    return nr;
  else
  if(MAKINUM(2)==new_var1)
    return MAKINUM(INUM(nr)*INUM(nr));
  else
  if(MAKINUM(3)==new_var1)
    return MAKINUM(INUM(nr)*(INUM(nr)*INUM(nr)));
  else
  if(MAKINUM(4)==new_var1)
    return MAKINUM(INUM(nr)*(INUM(nr)*(INUM(nr)*INUM(nr))));
  else
  if(MAKINUM(5)==new_var1)
    return MAKINUM(INUM(nr)*(INUM(nr)*(INUM(nr)*(INUM(nr)*INUM(nr)))));
  else
  if(MAKINUM(6)==new_var1)
    return MAKINUM(INUM(nr)*(INUM(nr)*(INUM(nr)*(INUM(nr)*(INUM(nr)*INUM(nr))))));
  else
  if(MAKINUM(7)==new_var1)
    return MAKINUM(INUM(nr)*(INUM(nr)*(INUM(nr)*(INUM(nr)*(INUM(nr)*(INUM(nr)*INUM(nr)))))));
  else
    return slow_int_power(nr,exp_nonkeyword);
}

SCM slow_int_power(nr,exp_nonkeyword)
SCM nr,exp_nonkeyword;
{
  SCM res,i;

  res=MAKINUM(1);
  for(i=exp_nonkeyword;!(i<MAKINUM(1));i=MAKINUM(INUM(i)-1)) {
    res=MAKINUM(INUM(res)*INUM(nr));
  }
  return res;
}

SCM props_cterm_sum_arg(cterm)
SCM cterm;
{
  SCM tmp,res,len,i;

  len=VECTOR_LENGTH(cterm);
  res=MAKINUM(0);
  tmp=MAKINUM(0);
  for(i=MAKINUM(2);!(i>=len);i=MAKINUM(1+INUM(i))) {
    tmp=VECTOR_REF(cterm,i);
    res=MAKINUM(INUM(res)+INUM(tmp));
  }
  return res;
}

SCM make_list(nr,elem)
SCM nr,elem;
{
  if(nr<MAKINUM(1))
    return EOL;
  else
    return cons(elem,make_list(MAKINUM(INUM(nr)-1),elem));
}

SCM remove_one_from_list(elem,lst)
SCM elem,lst;
{
  if(NULL_P(lst))
    return lst;
  else
  if(elem==CAR(lst))
    return CDR(lst);
  else
    return cons(CAR(lst),remove_one_from_list(elem,CDR(lst)));
}

SCM props_no_intersection(alst,blst)
SCM alst,blst;
{
  SCM stopflag,part;

  stopflag=BOOL_F;
  for(part=alst;!(NFALSEP(stopflag)||NULL_P(part));part=CDR(part))
    if(NFALSEP(memq(CAR(part),blst))) {
      stopflag=BOOL_T;
    }
  return NOT(stopflag);
}

SCM top_level_actions()
{
  SCM filename,prog_args_nonkeyword,timelimit,tmp;

  prolixity(MAKINUM(0));
  filename=EOL;
  prog_args_nonkeyword=apply(GLOBAL(program_arguments),EOL,EOL);
  timelimit=MAKINUM(300);
  tmp=EOL;
  if(PAIR_P(prog_args_nonkeyword)&&(PAIR_P(CDR(prog_args_nonkeyword))&&(NFALSEP(equal(const_820,CAR(CDR(prog_args_nonkeyword))))&&PAIR_P(CDR(CDR(prog_args_nonkeyword)))))) {
    timelimit=CAR(CDR(CDR(prog_args_nonkeyword)));
    if(!(NFALSEP(string2number(timelimit,MAKINUM(10))))) {
      newline(cur_output_port());
      display(const_821,cur_output_port());
      newline(cur_output_port());
      quit(1);
    }
    GLOBAL(timelimit_global)=timelimit;
    GLOBAL(args_timelimit_global)=timelimit;
    prog_args_nonkeyword=cons(CAR(prog_args_nonkeyword),CDR(CDR(CDR(prog_args_nonkeyword))));
  }
  if(NULL_P(prog_args_nonkeyword)||NULL_P(CDR(prog_args_nonkeyword))) {
    newline(cur_output_port());
    display(const_822,cur_output_port());
    newline(cur_output_port());
    display(const_823,cur_output_port());
    newline(cur_output_port());
    return quit(1);
  }
  else
  if(!(NULL_P(CDR(CDR(prog_args_nonkeyword))))&&NFALSEP(equal(const_824,CAR(CDR(prog_args_nonkeyword))))) {
    filename=CAR(CDR(CDR(prog_args_nonkeyword)));
    display(const_825,cur_output_port());
    display(filename,cur_output_port());
    newline(cur_output_port());
    GLOBAL(sat_strategy_flag_global)=BOOL_T;
    GLOBAL(full_proof_strategy_flag_global)=BOOL_F;
    return fprove(filename);
  }
  else
  if(!(NULL_P(CDR(CDR(prog_args_nonkeyword))))&&NFALSEP(equal(const_826,CAR(CDR(prog_args_nonkeyword))))) {
    filename=CAR(CDR(CDR(prog_args_nonkeyword)));
    display(const_827,cur_output_port());
    display(filename,cur_output_port());
    newline(cur_output_port());
    GLOBAL(sat_strategy_flag_global)=BOOL_F;
    GLOBAL(full_proof_strategy_flag_global)=BOOL_T;
    return fprove(filename);
  }
  else {
    filename=CAR(CDR(prog_args_nonkeyword));
    newline(cur_output_port());
    display(const_828,cur_output_port());
    display(filename,cur_output_port());
    newline(cur_output_port());
    GLOBAL(sat_strategy_flag_global)=BOOL_F;
    GLOBAL(full_proof_strategy_flag_global)=BOOL_F;
    fprove(filename);
    newline(cur_output_port());
    return quit(1);
  }
}

SCM top_actions_1_resbase()
{
  make_subr((char *)"shiftleft",tc7_subr_2,shiftleft);
  make_subr((char *)"shiftright",tc7_subr_2,shiftright);
  GLOBAL(max_nr_of_vars_in_clause_global)=MAKINUM(255);
  GLOBAL(maxvar_global)=MAKINUM(65535);
  GLOBAL(max_x_var_global)=MAKINUM(256);
  GLOBAL(max_y_var_global)=MAKINUM(512);
  GLOBAL(minconst_global)=MAKINUM(65536);
  GLOBAL(mincurryconst_global)=MAKINUM(200000);
  GLOBAL(maxconst_global)=MAKINUM(99999998);
  GLOBAL(unassigned_global)=MAKINUM(99999999);
  GLOBAL(default_time_limit_global)=BOOL_F;
  GLOBAL(timelimit_global)=BOOL_F;
  GLOBAL(args_timelimit_global)=BOOL_F;
  GLOBAL(listofnull_global)=const_829;
  GLOBAL(foundflag_global)=BOOL_F;
  GLOBAL(sat_found_flag_global)=BOOL_F;
  GLOBAL(answer_cl_global)=EOL;
  GLOBAL(answer_history_global)=EOL;
  GLOBAL(too_many_vars_flag_global)=BOOL_F;
  occurcheck_flag_global=BOOL_F;
  repeatedvars_flag_global=BOOL_F;
  var_set_flag_global=BOOL_F;
  alt_var_set_flag_global=BOOL_F;
  clause_var_nr_global=MAKINUM(0);
  GLOBAL(new_var_names_global)=EOL;
  xvars_set_flag_global=BOOL_F;
  yvars_set_flag_global=BOOL_F;
  fac_vars_set_global=BOOL_F;
  GLOBAL(cut_clauses_global)=EOL;
  gcl_maxvar_global=MAKINUM(0);
  GLOBAL(gcl_varsstack_global)=EOL;
  GLOBAL(collected_vars_global)=EOL;
  GLOBAL(subsuming_clause_global)=EOL;
  GLOBAL(stopsubsuming_flag_global)=BOOL_F;
  GLOBAL(prohibit_subs_clnr_global)=BOOL_F;
  GLOBAL(subs_factor_derived_flag_global)=BOOL_F;
  GLOBAL(subsumed_clauses_global)=EOL;
  GLOBAL(used_demodulators_global)=EOL;
  GLOBAL(ground_check_res_global)=EOL;
  GLOBAL(compare_ground_litcdr_equal_flag_global)=BOOL_F;
  GLOBAL(one_step_hyper_phase_global)=BOOL_F;
  GLOBAL(noncomputable_ans_funs_global)=EOL;
  GLOBAL(noncomputable_ans_preds_global)=EOL;
  GLOBAL(cur_lit_global)=EOL;
  GLOBAL(cur_clause_global)=BOOL_F;
  GLOBAL(overdouble_discr_flag_global)=BOOL_F;
  GLOBAL(nonunit_discr_flag_global)=BOOL_F;
  GLOBAL(nonunit_res_global)=EOL;
  GLOBAL(param_tolit_global)=EOL;
  GLOBAL(param_eqlit_global)=EOL;
  return UNSPECIFIED;
}

SCM top_actions_2_resbase()
{
  GLOBAL(param_tocl_global)=EOL;
  GLOBAL(param_fromcl_global)=EOL;
  GLOBAL(param_tofullinf_global)=EOL;
  GLOBAL(param_fromfullinf_global)=EOL;
  GLOBAL(param_left_arg_global)=EOL;
  GLOBAL(param_right_arg_global)=EOL;
  param_use_left_flag_global=BOOL_F;
  param_use_right_flag_global=BOOL_F;
  GLOBAL(param_toinf_global)=EOL;
  GLOBAL(param_frominf_global)=EOL;
  GLOBAL(param_from_is_y_flag_global)=BOOL_F;
  GLOBAL(param_yclmaxvar_global)=EOL;
  GLOBAL(param_xclmaxvar_global)=EOL;
  GLOBAL(param_fromhist_global)=EOL;
  GLOBAL(param_tohist_global)=EOL;
  GLOBAL(param_fromlitnr_global)=EOL;
  GLOBAL(param_tolitnr_global)=EOL;
  GLOBAL(var_info_mask_global)=MAKINUM(57344);
  GLOBAL(single_occ_lit_var_mask_global)=MAKINUM(32768);
  GLOBAL(no_occ_otherlit_var_mask_global)=MAKINUM(16384);
  GLOBAL(single_occ_clause_var_mask_global)=MAKINUM(49152);
  GLOBAL(no_occ_folllit_var_mask_global)=MAKINUM(8192);
  GLOBAL(var_nr_mask_global)=MAKINUM(8191);
  GLOBAL(y_var_mask_global)=MAKINUM(256);
  GLOBAL(z_var_mask_global)=MAKINUM(512);
  GLOBAL(var_val_table_global)=make_vector(MAKINUM(1+INUM(MAKINUM(255)|MAKINUM(512))),MAKINUM(99999999));
  GLOBAL(var_touched_table_global)=make_vector(MAKINUM(1+INUM(MAKINUM(255)|MAKINUM(512))),BOOL_F);
  GLOBAL(sgn_mask_global)=MAKINUM(268435456);
  GLOBAL(signedfnsymb_mask_global)=MAKINUM(534773760);
  GLOBAL(fnsymb_mask_global)=MAKINUM(534773760);
  GLOBAL(fnsymb_shift_global)=MAKINUM(21);
  GLOBAL(predsymb_mask_global)=MAKINUM(266338304);
  GLOBAL(maxvar_mask_global)=MAKINUM(1835008);
  GLOBAL(fun_except_varinf_mask_global)=MAKINUM(534904831);
  GLOBAL(repeated_vars_mask_global)=MAKINUM(131072);
  GLOBAL(ground_mask_global)=MAKINUM(65536);
  GLOBAL(strength_mask_global)=MAKINUM(131071);
  GLOBAL(term_depth_strength_mask_global)=MAKINUM(65535);
  GLOBAL(term_depth_mask_global)=MAKINUM(63488);
  GLOBAL(term_depth_max_global)=MAKINUM(31);
  GLOBAL(term_depth_max_shift_global)=MAKINUM(63488);
  GLOBAL(term_depth_shift_global)=MAKINUM(11);
  GLOBAL(term_depth_1_shift_global)=MAKINUM(2048);
  GLOBAL(term_size_strength_mask_global)=MAKINUM(2047);
  GLOBAL(term_size_mask_global)=MAKINUM(2016);
  GLOBAL(term_size_shift_global)=MAKINUM(5);
  GLOBAL(term_size_max_global)=MAKINUM(63);
  GLOBAL(term_size_max_shift_global)=MAKINUM(2016);
  GLOBAL(term_size_1_shift_global)=MAKINUM(32);
  GLOBAL(const_number_mask_global)=MAKINUM(31);
  return UNSPECIFIED;
}

SCM top_actions_3_resbase()
{
  GLOBAL(const_number_max_global)=MAKINUM(31);
  GLOBAL(g_and_const_mask_global)=(MAKINUM(65536)|MAKINUM(31));
  GLOBAL(var_strength_global)=MAKINUM(32);
  GLOBAL(const_strength_global)=(MAKINUM(65536)|(MAKINUM(32)|MAKINUM(1)));
  GLOBAL(cl_strength_mask_global)=MAKINUM(8388607);
  GLOBAL(cl_maxvar_global)=MAKINUM(63);
  GLOBAL(cl_ground_flag_global)=MAKINUM(65536);
  GLOBAL(cl_maxvar_shift_global)=MAKINUM(23);
  GLOBAL(cl_maxvar_mask_global)=MAKINUM(528482304);
  GLOBAL(cl_maxlen_global)=MAKINUM(63);
  GLOBAL(cl_len_shift_global)=MAKINUM(17);
  GLOBAL(cl_len_mask_global)=MAKINUM(8257536);
  GLOBAL(predsymb_bit_vector_global)=make_vector(MAKINUM(255),MAKINUM(0));
  GLOBAL(cl_rep_predsymbs_mask_global)=MAKINUM(134217728);
  GLOBAL(cl_pred_overflow_mask_global)=MAKINUM(67108864);
  GLOBAL(cl_predsymbs_area_mask_global)=MAKINUM(67108863);
  GLOBAL(cl_predsymbs_neg_shift_global)=MAKINUM(13);
  GLOBAL(cl_predsymbs_neg_mask_global)=MAKINUM(67100672);
  GLOBAL(cl_predsymbs_pos_max_global)=MAKINUM(4096);
  GLOBAL(cl_predsymbs_pos_mask_global)=MAKINUM(8191);
  GLOBAL(kept_cl_nr_global)=MAKINUM(0);
  GLOBAL(last_usable_cl_nr_global)=MAKINUM(0);
  make_subr((char *)"clinfo-clnumber-sublist",tc7_subr_1,clinfo_clnumber_sublist);
  make_subr((char *)"clinfo-history-sublist",tc7_subr_1,clinfo_history_sublist);
  make_subr((char *)"clinfo-distance",tc7_subr_1,clinfo_distance);
  make_subr((char *)"clinfo-clnr",tc7_subr_1,clinfo_clnr);
  GLOBAL(litinf_noresolve_mask_global)=MAKINUM(1);
  GLOBAL(litinf_nofactor_mask_global)=MAKINUM(2);
  GLOBAL(litinf_isanswer_mask_global)=MAKINUM(4);
  GLOBAL(litinf_noparainto_mask_global)=MAKINUM(8);
  GLOBAL(litinf_noparafromleft_mask_global)=MAKINUM(16);
  GLOBAL(litinf_noparafromright_mask_global)=MAKINUM(32);
  GLOBAL(litinf_rulelit_mask_global)=MAKINUM(64);
  GLOBAL(litinf_leftorrulelit_mask_global)=MAKINUM(128);
  GLOBAL(litinf_rightimplrulelit_mask_global)=MAKINUM(256);
  GLOBAL(litinf_reductionrulelit_mask_global)=MAKINUM(512);
  litinf_nouse_mask_global=(MAKINUM(1)|(MAKINUM(2)|(MAKINUM(8)|(MAKINUM(16)|MAKINUM(32)))));
  litinf_nobinrespara_mask_global=(MAKINUM(1)|(MAKINUM(8)|(MAKINUM(16)|MAKINUM(32))));
  GLOBAL(litinf_ordernr_mask_global)=MAKINUM(INUM(string2number(const_830,MAKINUM(2)))<<16);
  make_subr((char *)"get-litinfo-ordernr",tc7_subr_1,get_litinfo_ordernr);
  make_subr((char *)"put-litinfo-ordernr",tc7_subr_2,put_litinfo_ordernr);
  GLOBAL(litinf_classnr_mask_global)=MAKINUM(INUM(string2number(const_831,MAKINUM(2)))<<24);
  make_subr((char *)"get-litinfo-classnr",tc7_subr_1,get_litinfo_classnr);
  make_subr((char *)"put-litinfo-classnr",tc7_subr_2,put_litinfo_classnr);
  GLOBAL(sos_clauses_list_global)=EOL;
  GLOBAL(sos_clauses_list_end_global)=EOL;
  GLOBAL(ans_input_sos_global)=EOL;
  GLOBAL(usable_clauses_list_global)=EOL;
  GLOBAL(usable_clauses_list_end_global)=EOL;
  GLOBAL(subsumption_list_global)=const_832;
  return UNSPECIFIED;
}

SCM top_actions_4_resbase()
{
  GLOBAL(unit_alist_global)=EOL;
  GLOBAL(unit_alist_list_global)=EOL;
  GLOBAL(sos_clauses_list_list_global)=EOL;
  GLOBAL(usable_clauses_list_list_global)=EOL;
  GLOBAL(all_back_subsumed_clauses_global)=EOL;
  GLOBAL(discr_tree_global)=const_833;
  GLOBAL(nonunit_discr_tree_global)=const_834;
  GLOBAL(discr_tree_list_global)=EOL;
  GLOBAL(discr_tree_demod_terms_global)=const_835;
  GLOBAL(discr_tree_demod_atoms_global)=const_836;
  make_subr((char *)"composite?",tc7_subr_1,composite_pred_);
  make_subr((char *)"non-composite?",tc7_subr_1,non_composite_pred_);
  make_subr((char *)"var?",tc7_subr_1,var_pred_);
  make_subr((char *)"non-composite:-var?",tc7_subr_1,non_composite_colon__var_pred_);
  make_subr((char *)"const?",tc7_subr_1,const_pred_);
  make_subr((char *)"single-occ-lit-var?",tc7_subr_1,single_occ_lit_var_pred_);
  make_subr((char *)"repeated-occ-lit-var?",tc7_subr_1,repeated_occ_lit_var_pred_);
  make_subr((char *)"later-occurrences-var?",tc7_subr_1,later_occurrences_var_pred_);
  make_subr((char *)"term-may-cont-vars?",tc7_subr_1,term_may_cont_vars_pred_);
  make_subr((char *)"fun-may-cont-vars?",tc7_subr_1,fun_may_cont_vars_pred_);
  make_subr((char *)"fun-may-cont-repeatedvars?",tc7_subr_1,fun_may_cont_repeatedvars_pred_);
  make_subr((char *)"pure-fun",tc7_subr_1,pure_fun);
  make_subr((char *)"pure-unsigned-fun",tc7_subr_1,pure_unsigned_fun);
  make_subr((char *)"fun-depth-strength",tc7_subr_1,fun_depth_strength);
  make_subr((char *)"fun-depth",tc7_subr_1,fun_depth);
  make_subr((char *)"fun-depth-size",tc7_subr_1,fun_depth_size);
  make_subr((char *)"fun-real-depth",tc7_subr_1,fun_real_depth);
  make_subr((char *)"neg-fun?",tc7_subr_1,neg_fun_pred_);
  make_subr((char *)"pos-fun?",tc7_subr_1,pos_fun_pred_);
  make_subr((char *)"complementary-fun?",tc7_subr_1,complementary_fun_pred_);
  make_subr((char *)"fun-can-subsume?",tc7_subr_2,fun_can_subsume_pred_);
  make_subr((char *)"ground-lit-equal?",tc7_subr_2,ground_lit_equal_pred_);
  make_subr((char *)"term-equal?",tc7_subr_2,term_equal_pred_);
  make_subr((char *)"composite-equal?",tc7_subr_2,composite_equal_pred_);
  make_subr((char *)"term-equal-strong?",tc7_subr_2,term_equal_strong_pred_);
  make_subr((char *)"composite-equal-strong?",tc7_subr_2,composite_equal_strong_pred_);
  make_subr((char *)"term-list-equal?",tc7_subr_2,term_list_equal_pred_);
  make_subr((char *)"swapped-term-list-equal?",tc7_subr_2,swapped_term_list_equal_pred_);
  make_subr((char *)"term-list-equal-strong?",tc7_subr_2,term_list_equal_strong_pred_);
  make_subr((char *)"swapped-term-list-equal-strong?",tc7_subr_2,swapped_term_list_equal_strong_pred_);
  make_subr((char *)"clause-can-subsume?",tc7_subr_3,clause_can_subsume_pred_);
  make_subr((char *)"pure-clause-may-cont-vars?",tc7_subr_1,pure_clause_may_cont_vars_pred_);
  make_subr((char *)"var-nr",tc7_subr_1,var_nr);
  make_subr((char *)"y-var?",tc7_subr_1,y_var_pred_);
  make_subr((char *)"x-var?",tc7_subr_1,x_var_pred_);
  make_subr((char *)"unassigned-val?",tc7_subr_1,unassigned_val_pred_);
  make_subr((char *)"touched-var?",tc7_subr_1,touched_var_pred_);
  make_subr((char *)"set-var-touched!",tc7_subr_2,set_var_touched_excl_);
  make_subr((char *)"var-ref",tc7_subr_1,var_ref);
  return make_subr((char *)"set-var-ref!",tc7_subr_2,set_var_ref_excl_);
}

SCM top_actions_5_resbase()
{
  make_subr((char *)"var-val",tc7_subr_1,var_val);
  make_subr((char *)"dereference-var",tc7_subr_1,dereference_var);
  make_subr((char *)"dereference-copy-term",tc7_subr_1,dereference_copy_term);
  make_subr((char *)"dereference-copy-aux",tc7_subr_1,dereference_copy_aux);
  make_subr((char *)"clear-x-vars!",tc7_subr_1,clear_x_vars_excl_);
  make_subr((char *)"clear-x-vars-and-touched!",tc7_subr_1,clear_x_vars_and_touched_excl_);
  make_subr((char *)"clear-y-vars!",tc7_subr_1,clear_y_vars_excl_);
  make_subr((char *)"clear-y-vars-and-touched!",tc7_subr_1,clear_y_vars_and_touched_excl_);
  make_subr((char *)"clear-z-vars!",tc7_subr_1,clear_z_vars_excl_);
  make_subr((char *)"clear-z-vars-and-touched!",tc7_subr_1,clear_z_vars_and_touched_excl_);
  make_subr((char *)"set-x-vars-selfref-touched!",tc7_subr_1,set_x_vars_selfref_touched_excl_);
  make_subr((char *)"clear-gcl-vars",tc7_subr_0,clear_gcl_vars);
  make_subr((char *)"restore-gcl-vars",tc7_subr_0,restore_gcl_vars);
  make_subr((char *)"save-gcl-vars",tc7_subr_0,save_gcl_vars);
  make_subr((char *)"pop-gcl-vars-stack",tc7_subr_0,pop_gcl_vars_stack);
  make_subr((char *)"copy-nonground-term",tc7_subr_1,copy_nonground_term);
  make_subr((char *)"rename-x-to-y-term",tc7_subr_1,rename_x_to_y_term);
  make_subr((char *)"rename-y-to-x-term",tc7_subr_1,rename_y_to_x_term);
  make_subr((char *)"rename-x-to-z-term",tc7_subr_1,rename_x_to_z_term);
  make_subr((char *)"rename-x-to-y-term!",tc7_subr_1,rename_x_to_y_term_excl_);
  make_subr((char *)"rename-y-to-x-term!",tc7_subr_1,rename_y_to_x_term_excl_);
  make_subr((char *)"subst-deco-term",tc7_subr_2,subst_deco_term);
  make_subr((char *)"deco-leading-fun",tc7_subr_1,deco_leading_fun);
  make_subr((char *)"subst-deco-term-nodemodulate",tc7_subr_2,subst_deco_term_nodemodulate);
  make_subr((char *)"subst-deco-case-term",tc7_subr_1,subst_deco_case_term);
  make_subr((char *)"clear-varlist",tc7_subr_1,clear_varlist);
  make_subr((char *)"subst-deco-term-nodemodulate-spec",tc7_subr_1,subst_deco_term_nodemodulate_spec);
  make_subr((char *)"subst-deco-replace-term",tc7_lsubr,subst_deco_replace_term_wrapper);
  make_subr((char *)"subst-deco-replace-term-nodemodulate",tc7_lsubr,subst_deco_replace_term_nodemodulate_wrapper);
  make_subr((char *)"replace-subterm",tc7_subr_3,replace_subterm);
  make_subr((char *)"subterm-at-path",tc7_subr_2,subterm_at_path);
  make_subr((char *)"subst-deco-weight-term",tc7_subr_3,subst_deco_weight_term);
  make_subr((char *)"compute-term-weight",tc7_subr_3,compute_term_weight);
  make_subr((char *)"sum-fun-strengths",tc7_subr_2,sum_fun_strengths);
  make_subr((char *)"create-new-fun-pos-object",tc7_subr_2,create_new_fun_pos_object);
  make_subr((char *)"collect-vars-composite!",tc7_subr_1,collect_vars_composite_excl_);
  GLOBAL(intersection_tmp_global)=EOL;
  make_subr((char *)"intersection-union",tc7_lsubr,intersection_union_wrapper);
  make_subr((char *)"intersection-union-aux",tc7_subr_2,intersection_union_aux);
  make_subr((char *)"decorate-vars-lit!",tc7_lsubr,decorate_vars_lit_excl__wrapper);
  make_subr((char *)"decorate-vars-composite!",tc7_subr_2,decorate_vars_composite_excl_);
  make_subr((char *)"resolve-unify-ordinary",tc7_lsubr,resolve_unify_ordinary_wrapper);
  make_subr((char *)"resolve-unify-cutoff",tc7_lsubr,resolve_unify_cutoff_wrapper);
  make_subr((char *)"factor-unify-ordinary",tc7_subr_2,factor_unify_ordinary);
  make_subr((char *)"resolve-unify-ordinary-aux",tc7_subr_2,resolve_unify_ordinary_aux);
  make_subr((char *)"resolve-unify-cutoff-aux",tc7_subr_2,resolve_unify_cutoff_aux);
  make_subr((char *)"factor-unify-ordinary-aux",tc7_subr_2,factor_unify_ordinary_aux);
  make_subr((char *)"occur-check?",tc7_subr_2,occur_check_pred_);
  make_subr((char *)"factor-occur-check?",tc7_subr_2,factor_occur_check_pred_);
  return make_subr((char *)"havealready-clause?",tc7_subr_2,havealready_clause_pred_);
}

SCM top_actions_6_resbase()
{
  make_subr((char *)"subsumed-clause?",tc7_subr_2,subsumed_clause_pred_);
  make_subr((char *)"subsumed-literal?",tc7_subr_3,subsumed_literal_pred_);
  make_subr((char *)"subsumed-clause-aux?",tc7_lsubr,subsumed_clause_aux_pred__wrapper);
  make_subr((char *)"strong-subsumed-purecl?",tc7_subr_2,strong_subsumed_purecl_pred_);
  make_subr((char *)"back-subsume",tc7_subr_2,back_subsume);
  make_subr((char *)"bigger-strength?",tc7_subr_2,bigger_strength_pred_);
  make_subr((char *)"bigger-strength-aux?",tc7_subr_2,bigger_strength_aux_pred_);
  make_subr((char *)"bigger-strength-aux-aux?",tc7_subr_2,bigger_strength_aux_aux_pred_);
  make_subr((char *)"funlist-can-subsume?",tc7_lsubr,funlist_can_subsume_pred__wrapper);
  make_subr((char *)"funlist-can-subsume-aux?",tc7_subr_2,funlist_can_subsume_aux_pred_);
  make_subr((char *)">-fun-ordering?",tc7_subr_2,_grtr__fun_ordering_pred_);
  make_subr((char *)">-fun-ordering-aux?",tc7_subr_2,_grtr__fun_ordering_aux_pred_);
  make_subr((char *)"subsumed-pure-clause-ans?",tc7_subr_2,subsumed_pure_clause_ans_pred_);
  make_subr((char *)"subsumed-pure-clause-aux?",tc7_lsubr,subsumed_pure_clause_aux_pred__wrapper);
  make_subr((char *)"same-or-nonground-fun?",tc7_subr_2,same_or_nonground_fun_pred_);
  make_subr((char *)"subsumed-term-ordinary?",tc7_subr_2,subsumed_term_ordinary_pred_);
  make_subr((char *)"subsumed-term-ordinary-collectvars?",tc7_subr_2,subsumed_term_ordinary_collectvars_pred_);
  make_subr((char *)"subsumed-term-ordinary-collectvars-aux?",tc7_subr_2,subsumed_term_ordinary_collectvars_aux_pred_);
  make_subr((char *)"subsumed-term-list-ordinary?",tc7_subr_2,subsumed_term_list_ordinary_pred_);
  make_subr((char *)"swapped-subsumed-term-list-ordinary?",tc7_subr_2,swapped_subsumed_term_list_ordinary_pred_);
  make_subr((char *)"not-zero?",tc7_subr_1,not_zero_pred_);
  make_subr((char *)"mymax",tc7_subr_2,mymax);
  make_subr((char *)"maxplus",tc7_subr_3,maxplus);
  make_subr((char *)"rassq",tc7_subr_2,rassq);
  make_subr((char *)"adjoin",tc7_subr_2,adjoin);
  make_subr((char *)"union",tc7_subr_2,union_nonkeyword);
  make_subr((char *)"list-union",tc7_subr_1,list_union);
  make_subr((char *)"member-memq?",tc7_subr_2,member_memq_pred_);
  make_subr((char *)"assoc-memq",tc7_subr_2,assoc_memq);
  make_subr((char *)"nth-cdr",tc7_subr_2,nth_cdr);
  make_subr((char *)"pos-in-list",tc7_subr_2,pos_in_list);
  make_subr((char *)"pos-in-list-aux",tc7_subr_3,pos_in_list_aux);
  make_subr((char *)"split-list",tc7_subr_2,split_list);
  make_subr((char *)"split-if",tc7_subr_2,split_if_exporthof);
  make_subr((char *)"my-last-pair",tc7_subr_1,my_last_pair);
  make_subr((char *)"my-last-pair-aux",tc7_subr_1,my_last_pair_aux);
  make_subr((char *)"my-append!",tc7_subr_2,my_append_excl_);
  make_subr((char *)"but-last",tc7_subr_1,but_last);
  make_subr((char *)"map!",tc7_subr_2,map_excl__exporthof);
  make_subr((char *)"some?",tc7_subr_2,some_pred__exporthof);
  make_subr((char *)"every?",tc7_subr_2,every_pred__exporthof);
  make_subr((char *)"member-if",tc7_subr_2,member_if_exporthof);
  make_subr((char *)"remove-if",tc7_subr_2,remove_if_exporthof);
  make_subr((char *)"filter-map",tc7_subr_2,filter_map_exporthof);
  make_subr((char *)"copy-list",tc7_subr_1,copy_list);
  make_subr((char *)"sum-list",tc7_subr_1,sum_list);
  make_subr((char *)"remove-one-equal",tc7_subr_2,remove_one_equal);
  make_subr((char *)"remove-eq",tc7_subr_2,remove_eq);
  make_subr((char *)"remove-at-place",tc7_subr_2,remove_at_place);
  return make_subr((char *)"replace-one-eq",tc7_subr_3,replace_one_eq);
}

SCM top_actions_7_resbase()
{
  make_subr((char *)"replace-nth",tc7_subr_3,replace_nth);
  make_subr((char *)"remove-at-place!",tc7_subr_2,remove_at_place_excl_);
  GLOBAL(make_inside_subset_tmp_global)=EOL;
  GLOBAL(make_inside_subset_tmp_lst_global)=EOL;
  make_subr((char *)"make-inside-subset",tc7_subr_2,make_inside_subset);
  make_subr((char *)"make-inside-subset-aux!",tc7_subr_1,make_inside_subset_aux_excl_);
  make_subr((char *)"make-input-clause",tc7_subr_2,make_input_clause);
  make_subr((char *)"remove-duplicates",tc7_subr_1,remove_duplicates);
  make_subr((char *)"make-input-litinfolst",tc7_subr_1,make_input_litinfolst);
  make_subr((char *)"make-input-litinfolist-aux",tc7_subr_1,make_input_litinfolist_aux);
  make_subr((char *)"make-pos-lit-litinfo",tc7_subr_1,make_pos_lit_litinfo);
  make_subr((char *)"make-varinfo-lst!",tc7_subr_2,make_varinfo_lst_excl_);
  make_subr((char *)"make-fulldeco-clause!",tc7_subr_1,make_fulldeco_clause_excl_);
  GLOBAL(ans_pred_nr_global)=MAKINUM(0);
  GLOBAL(eq_pred_nr_global)=MAKINUM(0);
  GLOBAL(eq_fun_nr_global)=MAKINUM(0);
  GLOBAL(case_fun_nr_global)=MAKINUM(0);
  GLOBAL(if_fun_nr_global)=MAKINUM(0);
  GLOBAL(subst_fun_nr_global)=MAKINUM(0);
  GLOBAL(subst_prim_fun_nr_global)=MAKINUM(0);
  GLOBAL(lambda_fun_nr_global)=MAKINUM(0);
  GLOBAL(lambda_dummypar_nr_global)=MAKINUM(0);
  GLOBAL(int_outmost_symb_labelfun_global)=EOL;
  GLOBAL(int_outmost_label_fun_nr_global)=MAKINUM(0);
  make_subr((char *)"pos-eq-pred?",tc7_subr_1,pos_eq_pred_pred_);
  make_subr((char *)"pos-eq-fun?",tc7_subr_1,pos_eq_fun_pred_);
  make_subr((char *)"fill-predsymb-bit-vector!",tc7_subr_0,fill_predsymb_bit_vector_excl_);
  make_subr((char *)"turn-on-demodulation",tc7_subr_0,turn_on_demodulation);
  make_subr((char *)"turn-off-demodulation",tc7_subr_0,turn_off_demodulation);
  make_subr((char *)"init-binres-strat",tc7_subr_0,init_binres_strat);
  make_subr((char *)"init-hyper-strat-new",tc7_subr_0,init_hyper_strat_new);
  make_subr((char *)"init-hyper-strat",tc7_subr_0,init_hyper_strat);
  make_subr((char *)"init-synth-strat",tc7_subr_0,init_synth_strat);
  make_subr((char *)"init-binary-hyper-sos-strat",tc7_subr_0,init_binary_hyper_sos_strat);
  make_subr((char *)"init-unit-strat",tc7_subr_0,init_unit_strat);
  make_subr((char *)"init-double-strat",tc7_subr_0,init_double_strat);
  make_subr((char *)"init-binres-bliksem-strat",tc7_subr_0,init_binres_bliksem_strat);
  make_subr((char *)"init-posweight-ordered-unit-strat",tc7_subr_0,init_posweight_ordered_unit_strat);
  make_subr((char *)"init-negweight-ordered-unit-strat",tc7_subr_0,init_negweight_ordered_unit_strat);
  make_subr((char *)"init-ordered-binres-strat",tc7_subr_0,init_ordered_binres_strat);
  make_subr((char *)"init-ordered-binres-fulleq-strat",tc7_subr_0,init_ordered_binres_fulleq_strat);
  make_subr((char *)"init-ordered-binres-sos-strat",tc7_subr_0,init_ordered_binres_sos_strat);
  make_subr((char *)"init-name-ordered-binres-strat",tc7_subr_0,init_name_ordered_binres_strat);
  make_subr((char *)"init-name-ordered-binres-sos-strat",tc7_subr_0,init_name_ordered_binres_sos_strat);
  make_subr((char *)"init-weight-ordered-binres-sos-strat",tc7_subr_0,init_weight_ordered_binres_sos_strat);
  make_subr((char *)"init-weight-ordered-binres-strat",tc7_subr_0,init_weight_ordered_binres_strat);
  make_subr((char *)"init-posweight-ordered-binres-sos-strat",tc7_subr_0,init_posweight_ordered_binres_sos_strat);
  make_subr((char *)"init-negweight-ordered-binres-sos-strat",tc7_subr_0,init_negweight_ordered_binres_sos_strat);
  make_subr((char *)"init-posweight-ordered-binres-strat",tc7_subr_0,init_posweight_ordered_binres_strat);
  return make_subr((char *)"init-negweight-ordered-binres-strat",tc7_subr_0,init_negweight_ordered_binres_strat);
}

SCM top_actions_8_resbase()
{
  make_subr((char *)"init-hyper-wos-strat",tc7_subr_0,init_hyper_wos_strat);
  make_subr((char *)"init-ordered-hyper-strat",tc7_subr_0,init_ordered_hyper_strat);
  make_subr((char *)"init-typet-strat",tc7_subr_0,init_typet_strat);
  make_subr((char *)"init-binary-unit-depth-backdemod",tc7_subr_0,init_binary_unit_depth_backdemod);
  make_subr((char *)"init-binary-unit-depth-backdemod-alt",tc7_subr_0,init_binary_unit_depth_backdemod_alt);
  make_subr((char *)"init-binary-unit-depth-root-backdemod-alt",tc7_subr_0,init_binary_unit_depth_root_backdemod_alt);
  make_subr((char *)"init-binary-unit-depth",tc7_subr_0,init_binary_unit_depth);
  make_subr((char *)"init-binary-unit-depth-sospref",tc7_subr_0,init_binary_unit_depth_sospref);
  make_subr((char *)"init-binary-unit-depth-sospref-alt",tc7_subr_0,init_binary_unit_depth_sospref_alt);
  make_subr((char *)"init-binary-unit-lex",tc7_subr_0,init_binary_unit_lex);
  make_subr((char *)"init-binary-unit-lex-backdemod",tc7_subr_0,init_binary_unit_lex_backdemod);
  make_subr((char *)"init-binary-unit-firstpref",tc7_subr_0,init_binary_unit_firstpref);
  make_subr((char *)"init-binary-unit-firstpref-backdemod",tc7_subr_0,init_binary_unit_firstpref_backdemod);
  make_subr((char *)"init-ordered-hyper-uniteq-strat",tc7_subr_0,init_ordered_hyper_uniteq_strat);
  make_subr((char *)"init-unit-uniteq-strat",tc7_subr_0,init_unit_uniteq_strat);
  make_subr((char *)"init-name-ordered-binres-uniteq-strat",tc7_subr_0,init_name_ordered_binres_uniteq_strat);
  make_subr((char *)"init-ordered-binres-uniteq-strat",tc7_subr_0,init_ordered_binres_uniteq_strat);
  make_subr((char *)"init-binres-uniteq-strat",tc7_subr_0,init_binres_uniteq_strat);
  make_subr((char *)"init-exp-order-strat",tc7_subr_0,init_exp_order_strat);
  make_subr((char *)"init-epr-order-strat",tc7_subr_0,init_epr_order_strat);
  make_subr((char *)"init-posweight-ordered-binres-kb-big-strat",tc7_subr_0,init_posweight_ordered_binres_kb_big_strat);
  make_subr((char *)"init-posweight-ordered-binres-kb-small-strat",tc7_subr_0,init_posweight_ordered_binres_kb_small_strat);
  make_subr((char *)"init-posweight-ordered-binres-kb-small-fulleq-strat",tc7_subr_0,init_posweight_ordered_binres_kb_small_fulleq_strat);
  make_subr((char *)"init-posweight-ordered-binres-lex-big-strat",tc7_subr_0,init_posweight_ordered_binres_lex_big_strat);
  make_subr((char *)"init-posweight-ordered-binres-lex-small-strat",tc7_subr_0,init_posweight_ordered_binres_lex_small_strat);
  make_subr((char *)"init-posweight-ordered-firstpref-strat",tc7_subr_0,init_posweight_ordered_firstpref_strat);
  make_subr((char *)"init-sat-hyper-strat",tc7_subr_0,init_sat_hyper_strat);
  make_subr((char *)"init-sat-posweight-ordered-binres-strat",tc7_subr_0,init_sat_posweight_ordered_binres_strat);
  make_subr((char *)"init-sat-ordered-binres-strat",tc7_subr_0,init_sat_ordered_binres_strat);
  make_subr((char *)"init-sat-weight-ordered-binres-strat",tc7_subr_0,init_sat_weight_ordered_binres_strat);
  make_subr((char *)"init-prop-unsat-nofun-strat",tc7_subr_0,init_prop_unsat_nofun_strat);
  make_subr((char *)"init-simple-model-strat",tc7_subr_0,init_simple_model_strat);
  make_subr((char *)"init-mace-model-strat",tc7_subr_0,init_mace_model_strat);
  make_subr((char *)"init-sem-model-strat",tc7_subr_0,init_sem_model_strat);
  make_subr((char *)"init-mace-nofuns-model-strat",tc7_subr_0,init_mace_nofuns_model_strat);
  make_subr((char *)"init-random-model-strat",tc7_subr_0,init_random_model_strat);
  make_subr((char *)"init-prop-sat-aux",tc7_subr_0,init_prop_sat_aux);
  make_subr((char *)"clear-eq-order-strat",tc7_subr_0,clear_eq_order_strat);
  GLOBAL(complete_unsat_strategy_global)=BOOL_F;
  GLOBAL(complete_sat_strategy_global)=BOOL_F;
  GLOBAL(sat_strategy_flag_global)=BOOL_F;
  GLOBAL(full_proof_strategy_flag_global)=BOOL_F;
  GLOBAL(sos_exhausted_flag_global)=BOOL_F;
  GLOBAL(split_strategy_flag_global)=BOOL_F;
  GLOBAL(unit_equality_strat_global)=BOOL_F;
  GLOBAL(root_para_strat_global)=BOOL_F;
  GLOBAL(unit_para_flag_global)=BOOL_F;
  GLOBAL(order_equality_lex_strat_global)=BOOL_F;
  GLOBAL(order_equality_firstpref_strat_global)=BOOL_F;
  GLOBAL(sos_strategy_flag_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM top_actions_9_resbase()
{
  GLOBAL(keep_all_old_clauses_flag_global)=BOOL_F;
  GLOBAL(auto_mode_flag_global)=BOOL_F;
  GLOBAL(stop_res_real_time_global)=MAKINUM(0);
  GLOBAL(splitting_allowed_flag_global)=BOOL_T;
  GLOBAL(max_kept_clauses_nr_global)=MAKINUM(80000);
  GLOBAL(max_size_sum_nr_global)=MAKINUM(2000000);
  GLOBAL(display_info_level_global)=MAKINUM(50);
  GLOBAL(display_info_char_flag_global)=BOOL_F;
  GLOBAL(display_debug_info_flag_global)=BOOL_F;
  GLOBAL(remove_all_tautologies_stratflag_global)=BOOL_T;
  GLOBAL(prop_unsat_strat_global)=BOOL_F;
  GLOBAL(hyper_wos_strategy_flag_global)=BOOL_F;
  GLOBAL(binary_hyper_sos_strategy_global)=BOOL_F;
  GLOBAL(hyper_contradiction_strategy_global)=BOOL_F;
  GLOBAL(unit_clash_flag_global)=BOOL_F;
  GLOBAL(factors_stratflag_global)=BOOL_F;
  GLOBAL(back_subsume_stratflag_global)=BOOL_T;
  GLOBAL(demodulate_with_clauses_stratflag_global)=BOOL_T;
  GLOBAL(havealready_timecounter_global)=MAKINUM(0);
  GLOBAL(remove_identical_lit_stratflag_global)=BOOL_T;
  GLOBAL(paramodulation_allowed_flag_global)=BOOL_T;
  GLOBAL(paramodulation_strategy_flag_global)=BOOL_T;
  GLOBAL(paramodulate_from_vars_stratflag_global)=BOOL_F;
  GLOBAL(para_pos_unit_strategy_global)=BOOL_F;
  GLOBAL(para_unit_strategy_global)=BOOL_F;
  GLOBAL(unit_strategy_flag_global)=BOOL_F;
  GLOBAL(double_strategy_flag_global)=BOOL_F;
  GLOBAL(hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(bliksem_strategy_flag_global)=BOOL_F;
  GLOBAL(order_strategy_flag_global)=BOOL_F;
  GLOBAL(order_sos_strategy_flag_global)=BOOL_F;
  GLOBAL(name_order_strategy_flag_global)=BOOL_F;
  GLOBAL(exp_order_strategy_flag_global)=BOOL_F;
  GLOBAL(epr_order_strategy_flag_global)=BOOL_F;
  GLOBAL(firstlitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(poslitpref_order_strategy_flag_global)=BOOL_F;
  GLOBAL(posweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(negweight_order_strategy_flag_global)=BOOL_F;
  GLOBAL(ordered_factor_flag_global)=BOOL_F;
  GLOBAL(neg_hyper_strategy_flag_global)=BOOL_F;
  GLOBAL(type_theory_stratflag_global)=BOOL_F;
  GLOBAL(int_logic_flag_global)=BOOL_F;
  GLOBAL(int_use_binres_flag_global)=BOOL_F;
  GLOBAL(classical_synth_stratflag_global)=BOOL_F;
  GLOBAL(int_use_hyperres_flag_global)=BOOL_F;
  GLOBAL(discr_tree_subsume_stratflag_global)=BOOL_T;
  GLOBAL(mace_nofuns_model_strat_global)=BOOL_F;
  GLOBAL(simple_model_strat_global)=BOOL_F;
  GLOBAL(mace_model_strat_global)=BOOL_F;
  GLOBAL(sem_model_strat_global)=BOOL_F;
  return UNSPECIFIED;
}

SCM top_actions_10_resbase()
{
  GLOBAL(random_model_strat_global)=BOOL_F;
  GLOBAL(discr_depth_first_global)=BOOL_T;
  GLOBAL(ordered_paramodulation_flag_global)=BOOL_T;
  GLOBAL(dynamic_demodulation_flag_global)=BOOL_F;
  GLOBAL(demodulate_lit_flag_global)=BOOL_F;
  GLOBAL(back_demodulate_flag_global)=BOOL_F;
  GLOBAL(demodulate_flag_global)=BOOL_F;
  GLOBAL(demodulate_constants_flag_global)=BOOL_F;
  GLOBAL(new_demodulators_flag_global)=BOOL_F;
  GLOBAL(user_criterias_post_flag_global)=BOOL_F;
  GLOBAL(user_criterias_pre_flag_global)=BOOL_F;
  GLOBAL(clause_usenr_limits_global)=EOL;
  GLOBAL(clause_usedepth_limits_global)=EOL;
  GLOBAL(clause_usestruct_limits_global)=EOL;
  GLOBAL(clause_keepsize_limit_global)=MAKINUM(0);
  GLOBAL(clause_midsearch_keepsize_limit_global)=MAKINUM(0);
  GLOBAL(clause_finalkeepsize_limit_global)=MAKINUM(0);
  GLOBAL(clause_keepdepth_limit_global)=MAKINUM(0);
  GLOBAL(clause_uselength_limit_global)=MAKINUM(0);
  GLOBAL(clause_keeplength_limit_global)=MAKINUM(0);
  GLOBAL(order_strategy_sos_flag_global)=BOOL_F;
  GLOBAL(global_sos_preference_ratio_global)=MAKINUM(5);
  GLOBAL(special_insertion_place_global)=EOL;
  make_subr((char *)"init-one-pass-strategical-flags",tc7_subr_0,init_one_pass_strategical_flags);
  GLOBAL(answer_litinf_global)=(MAKINUM(1)|(MAKINUM(8)|MAKINUM(4)));
  make_subr((char *)"empty-cl?",tc7_subr_1,empty_cl_pred_);
  make_subr((char *)"unit-cl?",tc7_subr_1,unit_cl_pred_);
  make_subr((char *)"double-cl?",tc7_subr_1,double_cl_pred_);
  make_subr((char *)"first-nonans-lit",tc7_subr_1,first_nonans_lit);
  make_subr((char *)"member-nonans-lit",tc7_subr_1,member_nonans_lit);
  make_subr((char *)"member-ans-lit",tc7_subr_1,member_ans_lit);
  make_subr((char *)"remove-ans-literals",tc7_subr_1,remove_ans_literals);
  make_subr((char *)"ground-fullcl?",tc7_subr_1,ground_fullcl_pred_);
  make_subr((char *)"positive-cl?",tc7_subr_1,positive_cl_pred_);
  make_subr((char *)"negative-cl?",tc7_subr_1,negative_cl_pred_);
  make_subr((char *)"mixed-cl?",tc7_subr_1,mixed_cl_pred_);
  make_subr((char *)"has-single-hyper-premiss?",tc7_subr_1,has_single_hyper_premiss_pred_);
  make_subr((char *)"first-hyper-premiss-lit",tc7_subr_1,first_hyper_premiss_lit);
  make_subr((char *)"first-neg-lit",tc7_subr_1,first_neg_lit);
  make_subr((char *)"contains-eqlit-cl?",tc7_subr_1,contains_eqlit_cl_pred_);
  make_subr((char *)"contains-eqorneg-cl?",tc7_subr_1,contains_eqorneg_cl_pred_);
  make_subr((char *)"commutative-fun?",tc7_subr_1,commutative_fun_pred_);
  make_subr((char *)"reflexive-fun?",tc7_subr_1,reflexive_fun_pred_);
  make_subr((char *)"removable-tautology-pr?",tc7_subr_1,removable_tautology_pr_pred_);
  make_subr((char *)"clause-pass-user-limits-post?",tc7_subr_1,clause_pass_user_limits_post_pred_);
  make_subr((char *)"pass-keepdepth-limit?",tc7_subr_1,pass_keepdepth_limit_pred_);
  make_subr((char *)"pass-keepsize-limit?",tc7_subr_1,pass_keepsize_limit_pred_);
  make_subr((char *)"compute-real-termsize",tc7_subr_1,compute_real_termsize);
  make_subr((char *)"compute-real-clausesize",tc7_subr_1,compute_real_clausesize);
  return make_subr((char *)"pass-keeplength-limit?",tc7_subr_1,pass_keeplength_limit_pred_);
}

SCM top_actions_11_resbase()
{
  make_subr((char *)"clause-pass-user-crit-post?",tc7_subr_3,clause_pass_user_crit_post_pred_);
  make_subr((char *)"hist-pass-usenr-limits?",tc7_subr_1,hist_pass_usenr_limits_pred_);
  make_subr((char *)"hist-count-check",tc7_subr_2,hist_count_check);
  make_subr((char *)"hist-pass-usedepth-limits?",tc7_subr_1,hist_pass_usedepth_limits_pred_);
  make_subr((char *)"hist-pass-usestruct-limits?",tc7_subr_1,hist_pass_usestruct_limits_pred_);
  make_subr((char *)"hist-pass-usestruct-limits-hyper?",tc7_subr_2,hist_pass_usestruct_limits_hyper_pred_);
  make_subr((char *)"get-hyper-hist-el-limitnr",tc7_subr_1,get_hyper_hist_el_limitnr);
  make_subr((char *)"init-globals",tc7_subr_0,init_globals);
  GLOBAL(one_pass_kept_clauses_firstnr_global)=MAKINUM(1);
  make_subr((char *)"init-one-pass-globals",tc7_subr_0,init_one_pass_globals);
  make_subr((char *)"init-one-pass-globals-combinedstrategy",tc7_subr_0,init_one_pass_globals_combinedstrategy);
  GLOBAL(derived_clauses_nr_global)=MAKINUM(0);
  GLOBAL(kept_clauses_nr_global)=MAKINUM(0);
  GLOBAL(kept_size_sum_nr_global)=MAKINUM(0);
  GLOBAL(kept_mid_nucleus_nr_global)=MAKINUM(0);
  GLOBAL(kept_new_demodulators_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_unit_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_double_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_overdouble_nr_global)=MAKINUM(0);
  GLOBAL(forward_subsumed_nonunit_nr_global)=MAKINUM(0);
  GLOBAL(back_subsumed_nr_global)=MAKINUM(0);
  GLOBAL(simple_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(full_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(double_unit_cutoff_nr_global)=MAKINUM(0);
  GLOBAL(proof_start_real_time_global)=MAKINUM(0);
  GLOBAL(proof_start_run_time_global)=MAKINUM(0);
  GLOBAL(subs_tried_nr_global)=MAKINUM(0);
  GLOBAL(subs_length_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_strength_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_aux_strength_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_gclpreds_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_funlist_fail_nr_global)=MAKINUM(0);
  GLOBAL(subs_reg_subs_tried_nr_global)=MAKINUM(0);
  GLOBAL(subs_reg_subs_fail_nr_global)=MAKINUM(0);
  make_subr((char *)"init-stats",tc7_subr_0,init_stats);
  make_subr((char *)"show-stats",tc7_subr_0,show_stats);
  make_subr((char *)"show-main-stats",tc7_subr_0,show_main_stats);
  make_subr((char *)"show-subsumption-stats",tc7_subr_0,show_subsumption_stats);
  make_subr((char *)"display-time-seconds",tc7_subr_1,display_time_seconds);
  make_subr((char *)"mkstring-time-seconds",tc7_subr_1,mkstring_time_seconds);
  GLOBAL(run_id_global)=const_837;
  GLOBAL(gandalf_program_arguments_global)=EOL;
  GLOBAL(intepreter_mode_global)=BOOL_F;
  make_subr((char *)"gandalf-remove-tempfiles",tc7_subr_0,gandalf_remove_tempfiles);
  GLOBAL(gandalf_pid_global)=MAKINUM(0);
  make_subr((char *)"gandalf-set-pid",tc7_subr_1,gandalf_set_pid);
  make_subr((char *)"fsat",tc7_subr_1,fsat);
  make_subr((char *)"fprove",tc7_subr_1,fprove);
  make_subr((char *)"sprove",tc7_subr_1,sprove);
  return make_subr((char *)"path-string-endpart",tc7_subr_1,path_string_endpart);
}

SCM top_actions_12_resbase()
{
  make_subr((char *)"path-string-startpart",tc7_subr_1,path_string_startpart);
  make_subr((char *)"string-firstn",tc7_subr_2,string_firstn);
  make_subr((char *)"string-lastn",tc7_subr_2,string_lastn);
  make_subr((char *)"use-input-settings",tc7_subr_1,use_input_settings);
  make_subr((char *)"sort-out-otter-list-clauses",tc7_subr_1,sort_out_otter_list_clauses);
  make_subr((char *)"prop-conv",tc7_subr_1,prop_conv);
  make_subr((char *)"read-otter-list-clauses",tc7_subr_1,read_otter_list_clauses);
  GLOBAL(otter_or_symbol_global)=string2symbol(const_838);
  GLOBAL(parse_formula_context_global)=BOOL_F;
  make_subr((char *)"parse-otter-clause",tc7_subr_1,parse_otter_clause);
  make_subr((char *)"make-prefix-formula",tc7_subr_1,make_prefix_formula);
  make_subr((char *)"make-prefix-formula-term-aux",tc7_subr_2,make_prefix_formula_term_aux);
  make_subr((char *)"formula-syntax-error",tc7_subr_2,formula_syntax_error);
  make_subr((char *)"print-raw-formula",tc7_subr_1,print_raw_formula);
  make_subr((char *)"remove-formula-dots",tc7_subr_1,remove_formula_dots);
  make_subr((char *)"move-not-and-equiv",tc7_subr_2,move_not_and_equiv);
  make_subr((char *)"flatten-prefix-formula",tc7_subr_1,flatten_prefix_formula);
  GLOBAL(type_alist_global)=EOL;
  GLOBAL(free_var_base_string_global)=const_839;
  GLOBAL(skolemfn_base_string_global)=const_840;
  GLOBAL(type_pred_name_global)=hastype_symb;
  GLOBAL(unfold_finite_types_flag_global)=BOOL_T;
  GLOBAL(last_skolemfn_nr_global)=MAKINUM(0);
  GLOBAL(last_free_var_nr_global)=MAKINUM(0);
  GLOBAL(const_bindings_global)=EOL;
  make_subr((char *)"skolemize-formula",tc7_subr_1,skolemize_formula);
  make_subr((char *)"skolemize-formula-aux",tc7_subr_3,skolemize_formula_aux);
  make_subr((char *)"make-skolem-term-formula",tc7_subr_2,make_skolem_term_formula);
  make_subr((char *)"make-finite-subs-formula",tc7_subr_3,make_finite_subs_formula);
  make_subr((char *)"split-list-by-connective-formula",tc7_subr_2,split_list_by_connective_formula);
  make_subr((char *)"subs-into-formula",tc7_subr_3,subs_into_formula);
  make_subr((char *)"make-freevar-formula",tc7_subr_0,make_freevar_formula);
  make_subr((char *)"make-type-literal",tc7_subr_2,make_type_literal);
  make_subr((char *)"finite-type-symbol-formula",tc7_subr_1,finite_type_symbol_formula);
  make_subr((char *)"make-neg-symbol",tc7_subr_1,make_neg_symbol);
  make_subr((char *)"clausify-formula-aux",tc7_subr_1,clausify_formula_aux);
  GLOBAL(true_symbol_global)=true_symb;
  GLOBAL(false_symbol_global)=false_symb;
  GLOBAL(and_symbol_global)=_and__symb;
  GLOBAL(or_symbol_global)=_vbar__symb;
  GLOBAL(imp_symbol_global)=_equal__grtr__symb;
  GLOBAL(not_symbol_global)=__symb;
  GLOBAL(equivalent_symbol_global)=_less__equal__grtr__symb;
  GLOBAL(exists_symbol_global)=exists_symb;
  GLOBAL(all_symbol_global)=all_symb;
  make_subr((char *)"ftest",tc7_subr_0,ftest);
  make_subr((char *)"prepare-read-eqsymb",tc7_subr_2,prepare_read_eqsymb);
  make_subr((char *)"prepare-read-eqlit",tc7_subr_2,prepare_read_eqlit);
  make_subr((char *)"parse-otter-explist",tc7_subr_1,parse_otter_explist);
  GLOBAL(otter_uppercase_prefix_global)=MAKICHR('^');
  return UNSPECIFIED;
}

SCM top_actions_13_resbase()
{
  GLOBAL(otter_comma_repl_global)=_excl__symb;
  GLOBAL(otter_dot_repl_global)=_dot__dot__dot__symb;
  GLOBAL(otter_tmpfile_suffix_global)=const_841;
  GLOBAL(otter_tmpfile_prefix_global)=const_842;
  GLOBAL(otter_outputfile_suffix_global)=const_843;
  GLOBAL(otter_tmpfile_global)=const_844;
  GLOBAL(otter_inport_global)=EOL;
  GLOBAL(string_port_handler_clproc0)=make_subr((char *)"string-port-handler_clproc0",tc7_subr_1,string_port_handler);
  make_subr((char *)"preprocess-otter-file",tc7_subr_1,preprocess_otter_file);
  GLOBAL(preprocess_otter_file_aux_clproc0)=make_subr((char *)"preprocess-otter-file-aux_clproc0",tc7_subr_1,preprocess_otter_file_aux);
  make_subr((char *)"read-processed-otter-file",tc7_subr_1,read_processed_otter_file);
  GLOBAL(ans_symbol_global)=_dollar__dollar_ans_symb;
  GLOBAL(eq_symbol_global)=equal_symb;
  GLOBAL(eq_fun_symbol_global)=_dollar__dollar_eq_symb;
  GLOBAL(case_fun_symbol_global)=_dollar__dollar_case_symb;
  GLOBAL(if_fun_symbol_global)=_dollar__dollar_if_symb;
  GLOBAL(splitpred0_symbol_global)=splitpred0_symb;
  GLOBAL(splitpred1_symbol_global)=splitpred1_symb;
  GLOBAL(inhabited_symbol_global)=_dollar__dollar_inh_symb;
  GLOBAL(subst_fun_symbol_global)=_dollar__dollar_idsubst_symb;
  GLOBAL(subst_prim_fun_symbol_global)=_dollar__dollar_idsubst_prim_symb;
  GLOBAL(id_refl_fun_symbol_global)=_dollar__dollar_idrefl_symb;
  GLOBAL(lambda_fun_symbol_global)=_dollar__dollar_lambda_symb;
  GLOBAL(lambda_dummypar_symbol_global)=_dollar__dollar__star__symb;
  GLOBAL(typet_speclit_global)=cons(GLOBAL(ans_symbol_global),cons(cons(GLOBAL(lambda_fun_symbol_global),cons(cons(GLOBAL(subst_prim_fun_symbol_global),cons(GLOBAL(lambda_dummypar_symbol_global),EOL)),cons(cons(GLOBAL(subst_fun_symbol_global),cons(GLOBAL(lambda_dummypar_symbol_global),EOL)),EOL))),EOL));
  GLOBAL(classicsynth_speclit_global)=cons(GLOBAL(ans_symbol_global),cons(cons(GLOBAL(if_fun_symbol_global),cons(MAKINUM(1),cons(MAKINUM(2),cons(MAKINUM(3),EOL)))),EOL));
  GLOBAL(demodulator_list_symbol_global)=demodulators_symb;
  GLOBAL(lit_demodulator_list_symbol_global)=lit_demodulators_symb;
  GLOBAL(sos_list_symbol_global)=sos_symb;
  GLOBAL(usable_list_symbol_global)=usable_symb;
  GLOBAL(ans_prohibited_funsymbs_global)=EOL;
  GLOBAL(ans_prohibited_constsymbs_global)=EOL;
  GLOBAL(ans_prohibited_predsymbs_global)=EOL;
  GLOBAL(ans_prohibited_funnrs_global)=EOL;
  GLOBAL(ans_prohibited_constnrs_global)=EOL;
  GLOBAL(ans_prohibited_prednrs_global)=EOL;
  GLOBAL(prolog_style_variables_global)=BOOL_T;
  GLOBAL(const_num_table_global)=EOL;
  GLOBAL(const_num_global)=MAKINUM(0);
  GLOBAL(curry_const_num_global)=MAKINUM(0);
  GLOBAL(min_const_num_sub1_global)=MAKINUM(100000);
  GLOBAL(fun_num_table_global)=EOL;
  GLOBAL(fun_num_arity_table_global)=EOL;
  GLOBAL(fun_num_global)=MAKINUM(0);
  GLOBAL(min_fun_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_funs_global)=MAKINUM(255);
  GLOBAL(pred_num_table_global)=EOL;
  GLOBAL(pred_num_global)=MAKINUM(0);
  GLOBAL(min_pred_num_sub1_global)=MAKINUM(0);
  GLOBAL(max_nr_of_preds_global)=MAKINUM(127);
  return UNSPECIFIED;
}

SCM top_actions_14_resbase()
{
  GLOBAL(var_num_table_global)=EOL;
  GLOBAL(var_num_global)=MAKINUM(0);
  GLOBAL(min_var_num_sub1_global)=MAKINUM(0);
  make_subr((char *)"numerify-clause-list",tc7_subr_1,numerify_clause_list);
  make_subr((char *)"init-numerify-clause-list",tc7_subr_0,init_numerify_clause_list);
  make_subr((char *)"numerify-clause",tc7_subr_1,numerify_clause);
  make_subr((char *)"numerify-literal",tc7_subr_1,numerify_literal);
  make_subr((char *)"polarize-pred-nr",tc7_subr_2,polarize_pred_nr);
  make_subr((char *)"reverse-polarize-pred-nr",tc7_subr_1,reverse_polarize_pred_nr);
  make_subr((char *)"numerify-term",tc7_subr_1,numerify_term);
  make_subr((char *)"numerify-curry-const",tc7_subr_1,numerify_curry_const);
  make_subr((char *)"special-curry-purepred?",tc7_subr_1,special_curry_purepred_pred_);
  make_subr((char *)"special-curry-fun?",tc7_subr_1,special_curry_fun_pred_);
  make_subr((char *)"curry-const?",tc7_subr_1,curry_const_pred_);
  make_subr((char *)"var-symbol?",tc7_subr_1,var_symbol_pred_);
  GLOBAL(list_output_global)=BOOL_F;
  GLOBAL(comma_output_global)=BOOL_T;
  make_subr((char *)"print-full-clause",tc7_subr_1,print_full_clause);
  make_subr((char *)"print-clause",tc7_subr_1,print_clause);
  make_subr((char *)"print-pure-clause",tc7_subr_1,print_pure_clause);
  make_subr((char *)"print-lit",tc7_subr_1,print_lit);
  make_subr((char *)"print-term",tc7_subr_1,print_term);
  make_subr((char *)"print-pred",tc7_subr_1,print_pred);
  make_subr((char *)"print-fun",tc7_subr_1,print_fun);
  make_subr((char *)"print-const",tc7_subr_1,print_const);
  GLOBAL(nr_var_table_global)=const_845;
  make_subr((char *)"print-var",tc7_subr_1,print_var);
  make_subr((char *)"print-prolog-var",tc7_subr_1,print_prolog_var);
  make_subr((char *)"print-list-as-term",tc7_subr_1,print_list_as_term);
  make_subr((char *)"show-discr-tree",tc7_subr_2,show_discr_tree);
  make_subr((char *)"make-readable-discr-tree",tc7_subr_2,make_readable_discr_tree);
  make_subr((char *)"tree-debug-leaf?",tc7_subr_1,tree_debug_leaf_pred_);
  make_subr((char *)"make-readable-discr-leaf",tc7_subr_1,make_readable_discr_leaf);
  make_subr((char *)"make-readable-fullcl",tc7_subr_1,make_readable_fullcl);
  make_subr((char *)"make-readable-cl",tc7_subr_1,make_readable_cl);
  make_subr((char *)"make-readable-lit",tc7_subr_1,make_readable_lit);
  make_subr((char *)"make-readable-term",tc7_subr_1,make_readable_term);
  make_subr((char *)"debug-print-clause",tc7_subr_1,debug_print_clause);
  make_subr((char *)"debug-print-pure-clause",tc7_subr_1,debug_print_pure_clause);
  make_subr((char *)"debug-print-lit",tc7_subr_1,debug_print_lit);
  make_subr((char *)"debug-print-term",tc7_subr_1,debug_print_term);
  make_subr((char *)"debug-print-pred",tc7_subr_1,debug_print_pred);
  make_subr((char *)"debug-print-fun",tc7_subr_1,debug_print_fun);
  make_subr((char *)"debug-print-const",tc7_subr_1,debug_print_const);
  make_subr((char *)"debug-print-var",tc7_subr_1,debug_print_var);
  make_subr((char *)"debug-print-xvars",tc7_subr_1,debug_print_xvars);
  make_subr((char *)"debug-print-yvars",tc7_subr_1,debug_print_yvars);
  make_subr((char *)"debug-print-zvars",tc7_subr_1,debug_print_zvars);
  make_subr((char *)"report-error",tc7_lsubr,report_error_wrapper);
  GLOBAL(internal_time_units_per_second_global)=MAKINUM(100);
  return UNSPECIFIED;
}

SCM top_actions_15_resbase()
{
  GLOBAL(total_time_start_global)=MAKINUM(0);
  GLOBAL(total_time_given_global)=BOOL_F;
  GLOBAL(one_pass_time_global)=MAKINUM(0);
  GLOBAL(strat_list_global)=EOL;
  GLOBAL(given_checkpoint_keptnrs_global)=EOL;
  GLOBAL(checkpoint_keptnrs_global)=EOL;
  GLOBAL(last_got_time_global)=MAKINUM(0);
  GLOBAL(use_real_time_global)=BOOL_F;
  GLOBAL(run_forever_flag_global)=BOOL_T;
  make_subr((char *)"get-time",tc7_subr_0,get_time);
  make_subr((char *)"get-check-time",tc7_subr_1,get_check_time);
  make_subr((char *)"store-time-checkpoint!",tc7_subr_1,store_time_checkpoint_excl_);
  make_subr((char *)"prove",tc7_subr_3,prove);
  make_subr((char *)"prove-make-initial-clauses",tc7_lsubr,prove_make_initial_clauses_wrapper);
  make_subr((char *)"prove-show-input-clauses",tc7_lsubr,prove_show_input_clauses_wrapper);
  GLOBAL(no_passes_started_global)=BOOL_T;
  GLOBAL(all_passes_time_global)=MAKINUM(0);
  GLOBAL(strat_selected_global)=MAKINUM(0);
  GLOBAL(strat_given_time_global)=MAKINUM(0);
  GLOBAL(strat_start_time_global)=MAKINUM(0);
  GLOBAL(strat_passed_time_global)=MAKINUM(0);
  GLOBAL(strat_left_time_global)=MAKINUM(0);
  GLOBAL(all_passes_selected_clauses_global)=EOL;
  make_subr((char *)"prove-all-passes",tc7_lsubr,prove_all_passes_wrapper);
  make_subr((char *)"prove-all-passes-loop-strategies",tc7_lsubr,prove_all_passes_loop_strategies_wrapper);
  GLOBAL(split_search_active_flag_global)=BOOL_F;
  make_subr((char *)"prove-all-passes-split-strategy",tc7_lsubr,prove_all_passes_split_strategy_wrapper);
  make_subr((char *)"clear-space-for-split",tc7_subr_0,clear_space_for_split);
  make_subr((char *)"make-split-sos",tc7_subr_3,make_split_sos);
  make_subr((char *)"prove-all-passes-single-strategy",tc7_lsubr,prove_all_passes_single_strategy_wrapper);
  make_subr((char *)"strat-poses-depth-limit?",tc7_subr_1,strat_poses_depth_limit_pred_);
  make_subr((char *)"strat-depth-limit",tc7_subr_1,strat_depth_limit);
  make_subr((char *)"set-strat-time",tc7_subr_2,set_strat_time);
  make_subr((char *)"increase-strat-depth-limit",tc7_subr_1,increase_strat_depth_limit);
  make_subr((char *)"pick-strat-from-list",tc7_subr_0,pick_strat_from_list);
  make_subr((char *)"pick-extra-limits",tc7_subr_0,pick_extra_limits);
  make_subr((char *)"build-strat-list",tc7_lsubr,build_strat_list_wrapper);
  make_subr((char *)"build-split-stratlist",tc7_lsubr,build_split_stratlist_wrapper);
  make_subr((char *)"prove-one-pass",tc7_lsubr,prove_one_pass_wrapper);
  GLOBAL(combinedstrat_flag_global)=BOOL_F;
  make_subr((char *)"prove-one-pass-actually-prove",tc7_lsubr,prove_one_pass_actually_prove_wrapper);
  make_subr((char *)"prove-one-pass-after-proving",tc7_lsubr,prove_one_pass_after_proving_wrapper);
  make_subr((char *)"prove-one-pass-after-proving-combinedstrat",tc7_lsubr,prove_one_pass_after_proving_combinedstrat_wrapper);
  make_subr((char *)"make-sat-inclauses",tc7_subr_2,make_sat_inclauses);
  make_subr((char *)"list-contains-clause",tc7_subr_2,list_contains_clause);
  make_subr((char *)"fullcl-maxvar",tc7_subr_1,fullcl_maxvar);
  make_subr((char *)"select-best-clauses",tc7_lsubr,select_best_clauses_wrapper);
  make_subr((char *)"insert-to-best-res",tc7_lsubr,insert_to_best_res_wrapper);
  make_subr((char *)"remove-last!",tc7_subr_1,remove_last_excl_);
  return make_subr((char *)"show-one-pass-strategy",tc7_subr_0,show_one_pass_strategy);
}

SCM top_actions_16_resbase()
{
  make_subr((char *)"eq-lit-in-sos?",tc7_subr_1,eq_lit_in_sos_pred_);
  make_subr((char *)"add-typet-demod-ans",tc7_subr_1,add_typet_demod_ans);
  make_subr((char *)"remove-typet-demod-ans",tc7_subr_1,remove_typet_demod_ans);
  make_subr((char *)"remove-ans-from-clauses",tc7_subr_1,remove_ans_from_clauses);
  GLOBAL(enumerate_sos_literals_nr_global)=MAKINUM(0);
  make_subr((char *)"enumerate-sos-literals",tc7_subr_1,enumerate_sos_literals);
  GLOBAL(input_lit_nr_global)=MAKINUM(0);
  GLOBAL(input_eqlit_nr_global)=MAKINUM(0);
  GLOBAL(input_cl_nr_global)=MAKINUM(0);
  GLOBAL(input_unitcl_nr_global)=MAKINUM(0);
  GLOBAL(input_negcl_nr_global)=MAKINUM(0);
  GLOBAL(input_poscl_nr_global)=MAKINUM(0);
  GLOBAL(input_mixcl_nr_global)=MAKINUM(0);
  GLOBAL(input_horncl_nr_global)=MAKINUM(0);
  GLOBAL(input_invhorncl_nr_global)=MAKINUM(0);
  GLOBAL(input_negdhorncl_nr_global)=MAKINUM(0);
  GLOBAL(input_wellorderedcl_nr_global)=MAKINUM(0);
  GLOBAL(input_somewhat_ordered_nr_global)=MAKINUM(0);
  GLOBAL(input_wellhyper_nr_global)=MAKINUM(0);
  GLOBAL(input_maxlen_nr_global)=MAKINUM(0);
  GLOBAL(input_maxlen_nonground_nr_global)=MAKINUM(0);
  GLOBAL(input_maxdepth_nr_global)=MAKINUM(0);
  GLOBAL(input_contains_eq_global)=BOOL_F;
  GLOBAL(input_negun_d_global)=MAKINUM(0);
  GLOBAL(input_posun_d_global)=MAKINUM(0);
  GLOBAL(sos_maxdepth_nr_global)=MAKINUM(0);
  GLOBAL(input_maxsize_nr_global)=MAKINUM(0);
  GLOBAL(input_maxdepth_nr_global)=MAKINUM(0);
  GLOBAL(input_avgdepth_nr_global)=MAKINUM(0);
  GLOBAL(input_avgsize_nr_global)=MAKINUM(0);
  make_subr((char *)"analyse-input",tc7_subr_2,analyse_input);
  make_subr((char *)"compute-term-size-raw",tc7_subr_1,compute_term_size_raw);
  make_subr((char *)"compute-term-depth-raw",tc7_subr_1,compute_term_depth_raw);
  GLOBAL(hne_class_flag_global)=BOOL_F;
  GLOBAL(heq_class_flag_global)=BOOL_F;
  make_subr((char *)"select-initial-strategy",tc7_subr_0,select_initial_strategy);
  make_subr((char *)"select-strategy-seconds",tc7_subr_2,select_strategy_seconds);
  make_subr((char *)"select-initial-strategy-aux",tc7_subr_0,select_initial_strategy_aux);
  make_subr((char *)"select-initial-strategy-sat",tc7_subr_1,select_initial_strategy_sat);
  make_subr((char *)"select-initial-strategy-neq",tc7_subr_1,select_initial_strategy_neq);
  make_subr((char *)"select-initial-strategy-nne",tc7_subr_1,select_initial_strategy_nne);
  make_subr((char *)"select-initial-strategy-heq",tc7_subr_1,select_initial_strategy_heq);
  make_subr((char *)"select-initial-strategy-hne",tc7_subr_1,select_initial_strategy_hne);
  make_subr((char *)"select-initial-strategy-peq",tc7_subr_1,select_initial_strategy_peq);
  make_subr((char *)"select-initial-strategy-ueq",tc7_subr_1,select_initial_strategy_ueq);
  make_subr((char *)"break",tc7_subr_0,break_nonkeyword);
  make_subr((char *)"hprove",tc7_subr_3,hprove);
  make_subr((char *)"hfprove",tc7_subr_2,hfprove);
  make_subr((char *)"init",tc7_subr_0,init);
  GLOBAL(show_uncurry_input_predfuns_global)=BOOL_T;
  return UNSPECIFIED;
}

SCM top_actions_17_resbase()
{
  GLOBAL(absolute_max_curry_pred_nr_global)=MAKINUM(120);
  GLOBAL(absolute_max_curry_fun_nr_global)=MAKINUM(120);
  GLOBAL(max_curry_pred_nr_global)=MAKINUM(100);
  GLOBAL(max_curry_fun_nr_global)=MAKINUM(200);
  GLOBAL(special_curry_predsymbs_global)=EOL;
  GLOBAL(special_orig_curry_predsymbs_global)=cons(ans_symb,cons(equal_symb,cons(_equal_symb,cons(splitpred0_symb,cons(splitpred1_symb,EOL)))));
  GLOBAL(special_curry_funsymbs_global)=EOL;
  GLOBAL(special_orig_curry_funsymbs_global)=EOL;
  GLOBAL(curried_pred_const_table_global)=EOL;
  GLOBAL(not_curried_pred_nr_global)=MAKINUM(0);
  GLOBAL(curried_pred_nr_global)=MAKINUM(0);
  GLOBAL(curry_pred_arity_table_global)=EOL;
  GLOBAL(not_curried_preds_global)=EOL;
  GLOBAL(curried_fun_const_table_global)=EOL;
  GLOBAL(curried_fun_nr_global)=MAKINUM(0);
  GLOBAL(curry_fun_arity_table_global)=EOL;
  GLOBAL(not_curried_fun_nr_global)=MAKINUM(0);
  GLOBAL(not_curried_funs_global)=EOL;
  GLOBAL(curried_max_orig_pred_arity_global)=MAKINUM(0);
  GLOBAL(curried_max_orig_fun_arity_global)=MAKINUM(0);
  GLOBAL(curried_appred_arities_global)=EOL;
  GLOBAL(curried_apfun_arities_global)=EOL;
  make_subr((char *)"curry-input-readylst",tc7_subr_1,curry_input_readylst);
  make_subr((char *)"make-curried-special-predfuns-data",tc7_subr_0,make_curried_special_predfuns_data);
  make_subr((char *)"init-curry-clause-list",tc7_subr_0,init_curry_clause_list);
  make_subr((char *)"curry-clause-list",tc7_subr_1,curry_clause_list);
  make_subr((char *)"curry-clause",tc7_subr_1,curry_clause);
  make_subr((char *)"curry-lit",tc7_subr_1,curry_lit);
  make_subr((char *)"polarize-purepred-symb",tc7_subr_2,polarize_purepred_symb);
  make_subr((char *)"curry-term",tc7_subr_1,curry_term);
  make_subr((char *)"make-curry-const",tc7_subr_1,make_curry_const);
  make_subr((char *)"make-set",tc7_subr_1,make_set);
  GLOBAL(groundprocess_const_nr_global)=MAKINUM(0);
  GLOBAL(groundprocess_term_const_pairs_global)=EOL;
  make_subr((char *)"groundprocess-input-readylst",tc7_subr_1,groundprocess_input_readylst);
  make_subr((char *)"groundprocess-make-equalities",tc7_subr_0,groundprocess_make_equalities);
  make_subr((char *)"groundprocess-clause-list",tc7_subr_1,groundprocess_clause_list);
  make_subr((char *)"groundprocess-clause",tc7_subr_1,groundprocess_clause);
  make_subr((char *)"groundprocess-lit",tc7_subr_1,groundprocess_lit);
  make_subr((char *)"groundprocess-term",tc7_subr_1,groundprocess_term);
  make_subr((char *)"groundprocess-term-newconstant",tc7_subr_0,groundprocess_term_newconstant);
  make_subr((char *)"abs-path-part",tc7_subr_1,abs_path_part);
  GLOBAL(batch)=top_actions_17_resbase_cl1_clproc0;
  GLOBAL(batch)=top_actions_17_resbase_cl2_clproc0;
  make_subr((char *)"show-old-units",tc7_subr_0,show_old_units);
  make_subr((char *)"show-derived",tc7_subr_0,show_derived);
  make_subr((char *)"go",tc7_subr_0,go);
  make_subr((char *)"sgo",tc7_subr_0,sgo);
  make_subr((char *)"q",tc7_subr_0,q);
  return make_subr((char *)"bgo",tc7_subr_0,bgo);
}

SCM top_actions_17_resbase_cl2()
{
  if(NULL_P(CDR(apply(GLOBAL(program_arguments),EOL,EOL)))) {
    display(const_846,cur_output_port());
    newline(cur_output_port());
    abrt();
    return quit(1);
  }
  else {
    if(NULL_P(CDR(CDR(apply(GLOBAL(program_arguments),EOL,EOL))))) {
      GLOBAL(timelimit_global)=BOOL_F;
      fprove(CAR(CDR(apply(GLOBAL(program_arguments),EOL,EOL))));
    }
    else {
      GLOBAL(timelimit_global)=CAR(CDR(CDR(apply(GLOBAL(program_arguments),EOL,EOL))));
      fprove(CAR(CDR(apply(GLOBAL(program_arguments),EOL,EOL))));
    }
    newline(cur_output_port());
    return quit(1);
  }
}

SCM top_actions_17_resbase_cl1()
{
  display(apply(GLOBAL(program_arguments),EOL,EOL),cur_output_port());
  return fprove(const_847);
}

SCM top_actions_18_resbase()
{
  GLOBAL(sos_preference_ratio_global)=MAKINUM(5);
  GLOBAL(sos_preference_cur_ratio_global)=MAKINUM(0);
  GLOBAL(sos_preference_distance_ratio_global)=MAKINUM(9);
  GLOBAL(sos_preference_cur_distance_global)=MAKINUM(0);
  GLOBAL(sos_preference_exp_ratio_global)=MAKINUM(2);
  GLOBAL(sos_preference_cur_exp_global)=MAKINUM(0);
  GLOBAL(given_clause_nr_global)=MAKINUM(0);
  make_subr((char *)"display-kept-nr",tc7_subr_0,display_kept_nr);
  GLOBAL(new_demodulators_list_global)=EOL;
  GLOBAL(slow_start_time_global)=MAKINUM(0);
  GLOBAL(slow_passed_time_global)=MAKINUM(0);
  make_subr((char *)"given-clause-slow-loop",tc7_subr_0,given_clause_slow_loop);
  GLOBAL(last_best_weight_global)=MAKINUM(0);
  GLOBAL(last_best_clausesize_global)=MAKINUM(0);
  make_subr((char *)"select-given-cl-place",tc7_subr_1,select_given_cl_place);
  make_subr((char *)"given-cl-havealready?",tc7_subr_1,given_cl_havealready_pred_);
  GLOBAL(stop_fast_loop_flag_global)=BOOL_F;
  make_subr((char *)"usable-clauses-fast-loop",tc7_subr_2,usable_clauses_fast_loop);
  make_subr((char *)"two-clause-binres-loop",tc7_lsubr,two_clause_binres_loop_wrapper);
  make_subr((char *)"final-nuc-res",tc7_lsubr,final_nuc_res_wrapper);
  make_subr((char *)"unit-and-final-nuc-res",tc7_lsubr,unit_and_final_nuc_res_wrapper);
  make_subr((char *)"two-posunits-typet-para",tc7_lsubr,two_posunits_typet_para_wrapper);
  make_subr((char *)"one-step-for-hyper",tc7_subr_1,one_step_for_hyper);
  make_subr((char *)"make-hyper-history",tc7_lsubr,make_hyper_history_wrapper);
  make_subr((char *)"make-hyper-history-aux",tc7_lsubr,make_hyper_history_aux_wrapper);
  make_subr((char *)"make-hyper-history-aux-complex",tc7_lsubr,make_hyper_history_aux_complex_wrapper);
  make_subr((char *)"make-binres-history",tc7_lsubr,make_binres_history_wrapper);
  make_subr((char *)"make-demod-history",tc7_subr_1,make_demod_history);
  make_subr((char *)"make-chain-history-for-resolution",tc7_lsubr,make_chain_history_for_resolution_wrapper);
  make_subr((char *)"fresh-nucleus-hist?",tc7_subr_1,fresh_nucleus_hist_pred_);
  make_subr((char *)"make-null-neg-list",tc7_subr_1,make_null_neg_list);
  make_subr((char *)"paramodulate-into-ycl",tc7_lsubr,paramodulate_into_ycl_wrapper);
  make_subr((char *)"paramodulate-into-term",tc7_subr_3,paramodulate_into_term);
  make_subr((char *)"paramodulate-into-term-aux",tc7_subr_3,paramodulate_into_term_aux);
  make_subr((char *)"give-cl-maxvar",tc7_subr_1,give_cl_maxvar);
  make_subr((char *)"handle-derived-inf-cl-pair",tc7_lsubr,handle_derived_inf_cl_pair_wrapper);
  GLOBAL(handle_derived_inf_cl_pair_return_directly_global)=BOOL_F;
  make_subr((char *)"handle-ready-clause",tc7_subr_1,handle_ready_clause);
  make_subr((char *)"too-many-kept?",tc7_subr_2,too_many_kept_pred_);
  make_subr((char *)"handle-derived-inf-cl-pair-aux",tc7_subr_2,handle_derived_inf_cl_pair_aux);
  make_subr((char *)"attempt-to-make-a-demodulator",tc7_subr_1,attempt_to_make_a_demodulator);
  make_subr((char *)"terminating-demod-bigger?",tc7_subr_2,terminating_demod_bigger_pred_);
  make_subr((char *)"make-kept-clause",tc7_subr_2,make_kept_clause);
  make_subr((char *)"make-kept-litinflist",tc7_subr_2,make_kept_litinflist);
  make_subr((char *)"litinf-binrespara?",tc7_subr_1,litinf_binrespara_pred_);
  make_subr((char *)"litinf-use?",tc7_subr_1,litinf_use_pred_);
  make_subr((char *)"litinf-left-para?",tc7_subr_1,litinf_left_para_pred_);
  make_subr((char *)"litinf-right-para?",tc7_subr_1,litinf_right_para_pred_);
  make_subr((char *)"litinf-parainto?",tc7_subr_1,litinf_parainto_pred_);
  return make_subr((char *)"modify-to-demod-inf!",tc7_subr_1,modify_to_demod_inf_excl_);
}

SCM top_actions_19_resbase()
{
  make_subr((char *)"make-clause-info",tc7_subr_3,make_clause_info);
  make_subr((char *)"intern-fullclause",tc7_subr_1,intern_fullclause);
  make_subr((char *)"back-demodulate-usable",tc7_subr_0,back_demodulate_usable);
  make_subr((char *)"demodulate-clause",tc7_subr_1,demodulate_clause);
  make_subr((char *)"demodulate-composite",tc7_subr_1,demodulate_composite);
  make_subr((char *)"demodulate-composite-aux10",tc7_subr_1,demodulate_composite_aux10);
  make_subr((char *)"demodulate-equivalent-lit",tc7_subr_1,demodulate_equivalent_lit);
  make_subr((char *)"demodulate-lit",tc7_subr_1,demodulate_lit);
  make_subr((char *)"demodulate-constant",tc7_subr_1,demodulate_constant);
  make_subr((char *)"demodulate-fully",tc7_subr_3,demodulate_fully);
  make_subr((char *)"may-be-demodulated?",tc7_subr_1,may_be_demodulated_pred_);
  make_subr((char *)"eq-lit-arg1",tc7_subr_1,eq_lit_arg1);
  make_subr((char *)"eq-lit-arg2",tc7_subr_1,eq_lit_arg2);
  make_subr((char *)"eq-lit-type",tc7_subr_1,eq_lit_type);
  make_subr((char *)"demodulate-fully-lit",tc7_subr_1,demodulate_fully_lit);
  make_subr((char *)"demodulate-with-clauses-ok",tc7_subr_1,demodulate_with_clauses_ok);
  make_subr((char *)"demodulate-with-clauses",tc7_subr_1,demodulate_with_clauses);
  GLOBAL(locfactorpool_global)=EOL;
  GLOBAL(factorpool_global)=EOL;
  make_subr((char *)"factor-sos",tc7_subr_1,factor_sos);
  GLOBAL(factor_clproc0)=make_subr((char *)"factor_clproc0",tc7_subr_2,factor);
  make_subr((char *)"factor-aux",tc7_subr_2,factor_aux);
  make_subr((char *)"merge-infos",tc7_subr_3,merge_infos);
  make_subr((char *)"make-unique-answer-pair",tc7_subr_3,make_unique_answer_pair);
  make_subr((char *)"several-answer-literals?",tc7_subr_1,several_answer_literals_pred_);
  make_subr((char *)"ans-computable-lit?",tc7_subr_1,ans_computable_lit_pred_);
  make_subr((char *)"ans-computable-term?",tc7_subr_2,ans_computable_term_pred_);
  make_subr((char *)"sort-clause",tc7_subr_2,sort_clause);
  make_subr((char *)"sort-clause-aux",tc7_subr_3,sort_clause_aux);
  make_subr((char *)"sort-merge-clauses",tc7_subr_3,sort_merge_clauses);
  make_subr((char *)"lit-weight",tc7_subr_1,lit_weight);
  make_subr((char *)"answer-pred?",tc7_subr_1,answer_pred_pred_);
  make_subr((char *)"countable-pred?",tc7_subr_1,countable_pred_pred_);
  make_subr((char *)"answer-lit?",tc7_subr_1,answer_lit_pred_);
  make_subr((char *)"composite-weight",tc7_subr_1,composite_weight);
  make_subr((char *)"predsymb-bit",tc7_subr_1,predsymb_bit);
  make_subr((char *)"make-raw-inf-cl-pair",tc7_lsubr,make_raw_inf_cl_pair_wrapper);
  make_subr((char *)"make-raw-inf-cl-pair-aux",tc7_lsubr,make_raw_inf_cl_pair_aux_wrapper);
  make_subr((char *)"make-rest-inf-cl",tc7_subr_3,make_rest_inf_cl);
  make_subr((char *)"subst-deco-cl",tc7_lsubr,subst_deco_cl_wrapper);
  make_subr((char *)"tautology-pure-cl?",tc7_subr_1,tautology_pure_cl_pred_);
  make_subr((char *)"remove-double-lits!",tc7_subr_3,remove_double_lits_excl_);
  make_subr((char *)"unit-handle-cl!",tc7_subr_3,unit_handle_cl_excl_);
  make_subr((char *)"full-unit-cutoff!",tc7_subr_2,full_unit_cutoff_excl_);
  make_subr((char *)"full-unit-cutoff-aux!",tc7_lsubr,full_unit_cutoff_aux_excl__wrapper);
  make_subr((char *)"full-unit-cutoff-double!",tc7_lsubr,full_unit_cutoff_double_excl__wrapper);
  make_subr((char *)"has-some-local-only-vars?",tc7_subr_1,has_some_local_only_vars_pred_);
  make_subr((char *)"has-only-local-only-vars?",tc7_subr_1,has_only_local_only_vars_pred_);
  make_subr((char *)"member-polarity-lit",tc7_subr_3,member_polarity_lit);
  return make_subr((char *)"swapped-term-list-strong-equal?",tc7_subr_2,swapped_term_list_strong_equal_pred_);
}

SCM top_actions_20_resbase()
{
  make_subr((char *)"insert-to-subsumption-list!",tc7_subr_3,insert_to_subsumption_list_excl_);
  make_subr((char *)"insert-unit-alist",tc7_subr_1,insert_unit_alist);
  make_subr((char *)"insert-partial-discr-tree!",tc7_lsubr,insert_partial_discr_tree_excl__wrapper);
  make_subr((char *)"check-discr-tree",tc7_subr_2,check_discr_tree);
  make_subr((char *)"check-discr-tree-signed",tc7_subr_2,check_discr_tree_signed);
  make_subr((char *)"insert-clause-discr-tree!",tc7_lsubr,insert_clause_discr_tree_excl__wrapper);
  make_subr((char *)"insert-discr-tree!",tc7_lsubr,insert_discr_tree_excl__wrapper);
  make_subr((char *)"insert-discr-tree-leaf!",tc7_subr_1,insert_discr_tree_leaf_excl_);
  make_subr((char *)"insert-discr-tree-clausedemod-leaf!",tc7_subr_1,insert_discr_tree_clausedemod_leaf_excl_);
  GLOBAL(ttt1_global)=EOL;
  GLOBAL(ttt2_global)=EOL;
  GLOBAL(ttt3_global)=EOL;
  GLOBAL(ttt4_global)=EOL;
  make_subr((char *)"check-discr-tree-part",tc7_subr_3,check_discr_tree_part);
  make_subr((char *)"check-discr-tree-leaf",tc7_subr_1,check_discr_tree_leaf);
  make_subr((char *)"insert-discr-tree-nonunit!",tc7_subr_2,insert_discr_tree_nonunit_excl_);
  make_subr((char *)"insert-nonunit-discr-tree-leaf!",tc7_subr_1,insert_nonunit_discr_tree_leaf_excl_);
  make_subr((char *)"check-nonunit-discr-tree",tc7_subr_2,check_nonunit_discr_tree);
  make_subr((char *)"demodulation-clause-test",tc7_subr_2,demodulation_clause_test);
  make_subr((char *)"order-prohibit-litinfos",tc7_subr_2,order_prohibit_litinfos);
  make_subr((char *)"vdepth-order-litinfo",tc7_subr_2,vdepth_order_litinfo);
  make_subr((char *)"order-litinfo-eq-only",tc7_subr_2,order_litinfo_eq_only);
  make_subr((char *)"order-equality-litinfo",tc7_subr_2,order_equality_litinfo);
  make_subr((char *)"prohibit-right-para",tc7_subr_1,prohibit_right_para);
  make_subr((char *)"prohibit-left-para",tc7_subr_1,prohibit_left_para);
  GLOBAL(order_equality_kb_strat_global)=BOOL_T;
  make_subr((char *)"order-equality-litinfo-kb",tc7_subr_2,order_equality_litinfo_kb);
  make_subr((char *)"compare-terms-kb-order",tc7_subr_3,compare_terms_kb_order);
  GLOBAL(const_kb_order_vector_global)=EOL;
  GLOBAL(fun_kb_order_vector_global)=EOL;
  make_subr((char *)"make-symbs-kb-order-vector",tc7_subr_0,make_symbs_kb_order_vector);
  make_subr((char *)"const-kb-order-value",tc7_subr_1,const_kb_order_value);
  make_subr((char *)"fun-kb-order-value",tc7_subr_1,fun_kb_order_value);
  make_subr((char *)"compare-const-kb-order",tc7_subr_2,compare_const_kb_order);
  make_subr((char *)"var-inside-term?",tc7_subr_3,var_inside_term_pred_);
  make_subr((char *)"compare-terms-varcount-subset",tc7_subr_2,compare_terms_varcount_subset);
  make_subr((char *)"count-symbs-vars!",tc7_subr_3,count_symbs_vars_excl_);
  make_subr((char *)"order-equality-litinfo-lex-testing",tc7_subr_2,order_equality_litinfo_lex_testing);
  make_subr((char *)"order-equality-litinfo-lex",tc7_subr_2,order_equality_litinfo_lex);
  make_subr((char *)"compare-terms-lex-order-old",tc7_subr_3,compare_terms_lex_order_old);
  make_subr((char *)"compare-terms-lex-order",tc7_subr_3,compare_terms_lex_order);
  make_subr((char *)"compare-terms-lex-equal",tc7_subr_3,compare_terms_lex_equal);
  make_subr((char *)"compare-terms-lex-bigger",tc7_subr_3,compare_terms_lex_bigger);
  make_subr((char *)"occurs-term-for-order?",tc7_subr_3,occurs_term_for_order_pred_);
  make_subr((char *)"equal-terms-for-order?",tc7_subr_3,equal_terms_for_order_pred_);
  GLOBAL(const_lex_order_vector_global)=EOL;
  GLOBAL(fun_lex_order_vector_global)=EOL;
  GLOBAL(lex_order_prefer_bigger_arity_global)=BOOL_F;
  make_subr((char *)"make-symbs-lex-order-vector",tc7_subr_0,make_symbs_lex_order_vector);
  return make_subr((char *)"sort-funlist-lex",tc7_subr_1,sort_funlist_lex);
}

SCM top_actions_21_resbase()
{
  make_subr((char *)"sort-funlist-lex-aux",tc7_subr_2,sort_funlist_lex_aux);
  make_subr((char *)"sort-merge-lex-funlists",tc7_subr_2,sort_merge_lex_funlists);
  make_subr((char *)"bigger-fun-for-lex-order?",tc7_subr_2,bigger_fun_for_lex_order_pred_);
  make_subr((char *)"const-lex-order-value",tc7_subr_1,const_lex_order_value);
  make_subr((char *)"fun-lex-order-value",tc7_subr_1,fun_lex_order_value);
  make_subr((char *)"compare-symbs-lex-order",tc7_subr_2,compare_symbs_lex_order);
  make_subr((char *)"kb-order-litinfo-aux",tc7_subr_2,kb_order_litinfo_aux);
  GLOBAL(tmp_var_occurrences_table_global)=EOL;
  make_subr((char *)"make-kb-order-term-info",tc7_subr_1,make_kb_order_term_info);
  make_subr((char *)"make-kb-order-term-info-aux",tc7_subr_3,make_kb_order_term_info_aux);
  GLOBAL(lex_symbol_orderlst_global)=EOL;
  make_subr((char *)"lex-bigger?",tc7_subr_2,lex_bigger_pred_);
  make_subr((char *)"lex-occur-check?",tc7_subr_2,lex_occur_check_pred_);
  make_subr((char *)"lex-bigger-than-subterms?",tc7_subr_2,lex_bigger_than_subterms_pred_);
  make_subr((char *)"lex-subterm-bigger-than",tc7_subr_2,lex_subterm_bigger_than);
  make_subr((char *)"lex-symbol-bigger?",tc7_subr_2,lex_symbol_bigger_pred_);
  make_subr((char *)"make-lex-symbol-bigger!",tc7_subr_2,make_lex_symbol_bigger_excl_);
  make_subr((char *)"order-equality-litinfo-firstterm",tc7_subr_2,order_equality_litinfo_firstterm);
  make_subr((char *)"first-term-depth-bigger?",tc7_subr_2,first_term_depth_bigger_pred_);
  make_subr((char *)"first-term-depth",tc7_subr_1,first_term_depth);
  make_subr((char *)"order-equality-litinfo-depth",tc7_subr_2,order_equality_litinfo_depth);
  make_subr((char *)"vdepth-order-litinfo-aux",tc7_subr_2,vdepth_order_litinfo_aux);
  make_subr((char *)"vdepth-order-weak-litinfo-aux",tc7_subr_2,vdepth_order_weak_litinfo_aux);
  make_subr((char *)"vdepth-order-litinfo-eq-only",tc7_subr_2,vdepth_order_litinfo_eq_only);
  make_subr((char *)"name-order-litinfo",tc7_subr_2,name_order_litinfo);
  make_subr((char *)"epr-order-litinfo",tc7_subr_2,epr_order_litinfo);
  make_subr((char *)"epr-order-litinfo-aux",tc7_subr_2,epr_order_litinfo_aux);
  make_subr((char *)"poslit-order-litinfo",tc7_subr_2,poslit_order_litinfo);
  make_subr((char *)"firstlitpref-order-litinfo",tc7_subr_2,firstlitpref_order_litinfo);
  make_subr((char *)"posweight-order-litinfo",tc7_subr_2,posweight_order_litinfo);
  make_subr((char *)"negweight-order-litinfo",tc7_subr_2,negweight_order_litinfo);
  make_subr((char *)"exp-order-litinfo-suva",tc7_subr_2,exp_order_litinfo_suva);
  make_subr((char *)"exp-order-litinfo",tc7_subr_2,exp_order_litinfo);
  make_subr((char *)"exp-order-litinfo-aux",tc7_subr_2,exp_order_litinfo_aux);
  make_subr((char *)"clear-litorder-litinfo",tc7_subr_2,clear_litorder_litinfo);
  make_subr((char *)"vdepth->-varinfolit?",tc7_subr_2,vdepth__grtr__varinfolit_pred_);
  make_subr((char *)"vdepth->-weak-varinfolit?",tc7_subr_2,vdepth__grtr__weak_varinfolit_pred_);
  make_subr((char *)"vdepth-superset-varinfolit?",tc7_subr_2,vdepth_superset_varinfolit_pred_);
  GLOBAL(tmp_var_depth_table_global)=EOL;
  make_subr((char *)"make-var-depth-info",tc7_subr_1,make_var_depth_info);
  make_subr((char *)"make-var-depth-info-aux",tc7_subr_2,make_var_depth_info_aux);
  GLOBAL(simple_history_stratflag_global)=BOOL_T;
  GLOBAL(shown_clausenrs_global)=EOL;
  GLOBAL(otter_prepared_history_global)=EOL;
  GLOBAL(simple_prepared_history_global)=EOL;
  GLOBAL(simple_history_clausenr_stack_global)=EOL;
  GLOBAL(all_history_clauses_list_global)=EOL;
  make_subr((char *)"show-history",tc7_subr_1,show_history);
  make_subr((char *)"show-history-simple",tc7_subr_1,show_history_simple);
  return make_subr((char *)"show-history-simple-printout",tc7_subr_1,show_history_simple_printout);
}

SCM top_actions_22_resbase()
{
  make_subr((char *)"show-history-simple-split-proofsteps",tc7_subr_1,show_history_simple_split_proofsteps);
  make_subr((char *)"show-history-simple-printparents",tc7_subr_2,show_history_simple_printparents);
  make_subr((char *)"show-history-simple-printparents-aux",tc7_subr_1,show_history_simple_printparents_aux);
  make_subr((char *)"show-history-simple-onehistory",tc7_subr_1,show_history_simple_onehistory);
  make_subr((char *)"show-history-simple-stackprocess",tc7_subr_0,show_history_simple_stackprocess);
  make_subr((char *)"find-simple-history-clause",tc7_subr_1,find_simple_history_clause);
  make_subr((char *)"show-history-complex",tc7_subr_1,show_history_complex);
  make_subr((char *)"otter-show-history-printparents",tc7_subr_1,otter_show_history_printparents);
  make_subr((char *)"otter-show-history-printparents-aux",tc7_subr_1,otter_show_history_printparents_aux);
  make_subr((char *)"otter-show-history-aux",tc7_subr_2,otter_show_history_aux);
  make_subr((char *)"sort-by-firstel",tc7_subr_1,sort_by_firstel);
  make_subr((char *)"insert-to-firstel-sorted!",tc7_subr_2,insert_to_firstel_sorted_excl_);
  make_subr((char *)"otter-show-history-aux-aux",tc7_subr_3,otter_show_history_aux_aux);
  make_subr((char *)"show-history-aux",tc7_subr_2,show_history_aux);
  make_subr((char *)"show-history-aux-aux",tc7_subr_3,show_history_aux_aux);
  GLOBAL(single_reduction_rule_clauses_list_global)=EOL;
  GLOBAL(single_rule_clauses_list_global)=EOL;
  GLOBAL(mult_rule_clauses_list_global)=EOL;
  make_subr((char *)"show-history-find-clausepl",tc7_subr_1,show_history_find_clausepl);
  make_subr((char *)"show-history-clnr",tc7_subr_1,show_history_clnr);
  make_subr((char *)"display-spaces",tc7_subr_1,display_spaces);
  make_subr((char *)"history->answer",tc7_subr_1,history__grtr_answer);
  make_subr((char *)"history->answer-step",tc7_subr_1,history__grtr_answer_step);
  make_subr((char *)"input-ans-clause",tc7_subr_1,input_ans_clause);
  make_subr((char *)"history->answer-binstep",tc7_lsubr,history__grtr_answer_binstep_wrapper);
  make_subr((char *)"history->ans-handle-derived-inf-cl-pair",tc7_subr_3,history__grtr_ans_handle_derived_inf_cl_pair);
  make_subr((char *)"make-raw-inf-cl-pair-typet-hyper",tc7_lsubr,make_raw_inf_cl_pair_typet_hyper_wrapper);
  make_subr((char *)"paramodulate-into-term-aux-typet",tc7_subr_3,paramodulate_into_term_aux_typet);
  make_subr((char *)"hyper-contradiction?",tc7_subr_1,hyper_contradiction_pred_);
  make_subr((char *)"full-hyper-contradiction?",tc7_subr_1,full_hyper_contradiction_pred_);
  make_subr((char *)"start-binary-hypercheck-strategy",tc7_subr_0,start_binary_hypercheck_strategy);
  make_subr((char *)"start-backward-hyper-analysis",tc7_subr_0,start_backward_hyper_analysis);
  make_subr((char *)"make-all-resolvable!",tc7_subr_1,make_all_resolvable_excl_);
  make_subr((char *)"make-poslit-preferred!",tc7_subr_1,make_poslit_preferred_excl_);
  GLOBAL(prop_const_min_global)=MAKINUM(80000);
  make_subr((char *)"split-flat-clause-set",tc7_subr_1,split_flat_clause_set);
  make_subr((char *)"split-flat-clause-set-aux",tc7_subr_1,split_flat_clause_set_aux);
  make_subr((char *)"split-flat-clause",tc7_subr_1,split_flat_clause);
  GLOBAL(flat_split_literal_nr_global)=MAKINUM(1000);
  make_subr((char *)"make-flat-split-literal",tc7_subr_1,make_flat_split_literal);
  make_subr((char *)"split-flat-clause-into-components",tc7_subr_1,split_flat_clause_into_components);
  make_subr((char *)"make-flat-clause-splitcomponents",tc7_subr_2,make_flat_clause_splitcomponents);
  make_subr((char *)"make-flat-clause-joingroundsplits",tc7_subr_1,make_flat_clause_joingroundsplits);
  make_subr((char *)"make-flat-clause-nongroundsplits",tc7_subr_1,make_flat_clause_nongroundsplits);
  make_subr((char *)"make-flat-nongroundsplit-varcombinations-justatry",tc7_subr_1,make_flat_nongroundsplit_varcombinations_justatry);
  make_subr((char *)"make-flat-nongroundsplit-varcombinations",tc7_subr_1,make_flat_nongroundsplit_varcombinations);
  make_subr((char *)"make-subsets-of-len-2",tc7_subr_1,make_subsets_of_len_2);
  make_subr((char *)"make-subsets-of-len-3",tc7_subr_1,make_subsets_of_len_3);
  make_subr((char *)"make-subsets-of-len-4",tc7_subr_1,make_subsets_of_len_4);
  return make_subr((char *)"make-subsets-of-len-5",tc7_subr_1,make_subsets_of_len_5);
}

SCM top_actions_23_resbase()
{
  make_subr((char *)"good-flat-split?",tc7_subr_3,good_flat_split_pred_);
  make_subr((char *)"give-flat-lit-varset",tc7_subr_1,give_flat_lit_varset);
  make_subr((char *)"pseudo-split-input-clause",tc7_subr_1,pseudo_split_input_clause);
  GLOBAL(input_split_constant_nr_global)=MAKINUM(70000);
  make_subr((char *)"make-input-split-literal",tc7_subr_1,make_input_split_literal);
  make_subr((char *)"make-input-clause-nongroundsplits",tc7_subr_1,make_input_clause_nongroundsplits);
  make_subr((char *)"make-input-nongroundsplit-varcombinations",tc7_subr_1,make_input_nongroundsplit_varcombinations);
  make_subr((char *)"split-input-clause-into-components",tc7_subr_1,split_input_clause_into_components);
  make_subr((char *)"find-good-splittable-sos-clause",tc7_subr_1,find_good_splittable_sos_clause);
  make_subr((char *)"split-full-clause",tc7_subr_1,split_full_clause);
  GLOBAL(lit_split_varlist_tmp_global)=EOL;
  make_subr((char *)"get-lit-split-varlist",tc7_subr_1,get_lit_split_varlist);
  make_subr((char *)"get-lit-split-varlist-aux!",tc7_subr_1,get_lit_split_varlist_aux_excl_);
  make_subr((char *)"make-clause-splitcomponents",tc7_subr_2,make_clause_splitcomponents);
  GLOBAL(partial_model_check_global)=BOOL_F;
  GLOBAL(prop_clauses_generation_limit_global)=BOOL_F;
  GLOBAL(prop_clauses_generation_limited_flag_global)=BOOL_F;
  GLOBAL(prop_orig_constants_global)=EOL;
  GLOBAL(prop_orig_funs_global)=EOL;
  GLOBAL(prop_orig_preds_global)=EOL;
  GLOBAL(prop_flat_eq_symb_global)=EOL;
  GLOBAL(prop_constants_global)=EOL;
  GLOBAL(prop_constants_mapping_global)=EOL;
  GLOBAL(prop_fun_mappings_global)=EOL;
  GLOBAL(prop_lit_mappings_global)=EOL;
  GLOBAL(prop_atom_maxnr_global)=MAKINUM(10000);
  GLOBAL(prop_interp_value_pairs_global)=EOL;
  GLOBAL(prop_interp_termlist_global)=EOL;
  GLOBAL(tmp_varlist_global)=EOL;
  GLOBAL(prop_orig_constants_enum_global)=EOL;
  GLOBAL(prop_orig_funs_enum_global)=EOL;
  GLOBAL(prop_orig_preds_enum_global)=EOL;
  GLOBAL(prop_last_enum_value_global)=MAKINUM(0);
  GLOBAL(propclauses_global)=EOL;
  GLOBAL(propclause_tree_global)=EOL;
  GLOBAL(prop_time_ran_out_global)=BOOL_F;
  make_subr((char *)"prop-build-simple-model",tc7_subr_1,prop_build_simple_model);
  GLOBAL(max_var_stat_pre_global)=MAKINUM(0);
  GLOBAL(max_var_stat_post_global)=MAKINUM(0);
  make_subr((char *)"prop-build-flatten-model",tc7_subr_1,prop_build_flatten_model);
  GLOBAL(prop_orig_constants_to_flat_domainels_global)=EOL;
  make_subr((char *)"prop-build-nofuns-model",tc7_subr_1,prop_build_nofuns_model);
  make_subr((char *)"compute-max-vars-in-clauses",tc7_subr_1,compute_max_vars_in_clauses);
  make_subr((char *)"prop-build-random-model",tc7_subr_1,prop_build_random_model);
  GLOBAL(incremental_model_flag_global)=BOOL_F;
  make_subr((char *)"prop-build-incremental-model",tc7_subr_1,prop_build_incremental_model);
  make_subr((char *)"extract-pred-data-to-prop",tc7_subr_1,extract_pred_data_to_prop);
  make_subr((char *)"extract-pred-data-to-prop-aux-lit",tc7_subr_1,extract_pred_data_to_prop_aux_lit);
  make_subr((char *)"extract-pred-data-to-prop-aux-fun",tc7_subr_1,extract_pred_data_to_prop_aux_fun);
  return make_subr((char *)"make-prop-interpretation-lists",tc7_subr_3,make_prop_interpretation_lists);
}

SCM top_actions_24_resbase()
{
  make_subr((char *)"make-prop-interpretation-lists-aux",tc7_lsubr,make_prop_interpretation_lists_aux_wrapper);
  make_subr((char *)"check-prop-one-interpretation",tc7_subr_2,check_prop_one_interpretation);
  GLOBAL(prop_pre_evalres_global)=EOL;
  make_subr((char *)"check-prop-flatten-interpretations",tc7_lsubr,check_prop_flatten_interpretations_wrapper);
  make_subr((char *)"check-prop-interpretations",tc7_subr_3,check_prop_interpretations);
  make_subr((char *)"check-prop-interpretations-incremental",tc7_subr_3,check_prop_interpretations_incremental);
  make_subr((char *)"check-prop-interpretations-incremental-aux",tc7_lsubr,check_prop_interpretations_incremental_aux_wrapper);
  make_subr((char *)"valuation-list-nextvalues",tc7_subr_3,valuation_list_nextvalues);
  make_subr((char *)"max-of-two",tc7_subr_2,max_of_two);
  make_subr((char *)"max-of-list",tc7_subr_1,max_of_list);
  make_subr((char *)"max-of-corr-fun-args",tc7_subr_2,max_of_corr_fun_args);
  make_subr((char *)"get-valuationlistpos-term",tc7_subr_2,get_valuationlistpos_term);
  make_subr((char *)"insert-valuations!",tc7_subr_2,insert_valuations_excl_);
  make_subr((char *)"valuation-list-nextrandomvalues",tc7_subr_3,valuation_list_nextrandomvalues);
  GLOBAL(prop_clauses_generated_global)=MAKINUM(0);
  make_subr((char *)"make-predclauses-to-propclauses",tc7_subr_3,make_predclauses_to_propclauses);
  make_subr((char *)"sort-predclauses-for-propconversion",tc7_subr_1,sort_predclauses_for_propconversion);
  make_subr((char *)"make-predclause-to-propclauses",tc7_subr_3,make_predclause_to_propclauses);
  GLOBAL(prop_pred_maxval_pairs_global)=EOL;
  make_subr((char *)"make-prop-pred-maxval-pairs",tc7_subr_2,make_prop_pred_maxval_pairs);
  make_subr((char *)"create-prop-flat-varlimits",tc7_subr_3,create_prop_flat_varlimits);
  GLOBAL(prop_funinfolist_global)=EOL;
  make_subr((char *)"make-extra-flatten-propclauses",tc7_subr_1,make_extra_flatten_propclauses);
  make_subr((char *)"make-nofuns-equality-axioms",tc7_subr_0,make_nofuns_equality_axioms);
  make_subr((char *)"add-prop-lit-to-clause",tc7_subr_2,add_prop_lit_to_clause);
  make_subr((char *)"add-new-prop-clause",tc7_subr_1,add_new_prop_clause);
  make_subr((char *)"check-exist-propclause",tc7_subr_2,check_exist_propclause);
  make_subr((char *)"sub-ordered-list?",tc7_subr_2,sub_ordered_list_pred_);
  make_subr((char *)"get-fullclause-varslist",tc7_subr_1,get_fullclause_varslist);
  make_subr((char *)"get-fullclause-varslist-aux!",tc7_subr_1,get_fullclause_varslist_aux_excl_);
  make_subr((char *)"set-pred-var-values",tc7_subr_2,set_pred_var_values);
  make_subr((char *)"set-pred-var-values-limited",tc7_subr_3,set_pred_var_values_limited);
  make_subr((char *)"make-pred-to-proplit",tc7_subr_1,make_pred_to_proplit);
  make_subr((char *)"make-pred-to-proplit-incremental",tc7_subr_1,make_pred_to_proplit_incremental);
  make_subr((char *)"make-flat-pred-to-proplit",tc7_subr_1,make_flat_pred_to_proplit);
  make_subr((char *)"make-pred-to-proplit-aux",tc7_subr_2,make_pred_to_proplit_aux);
  make_subr((char *)"make-pred-to-proplit-incremental-aux",tc7_subr_2,make_pred_to_proplit_incremental_aux);
  make_subr((char *)"make-flat-pred-to-proplit-aux",tc7_subr_2,make_flat_pred_to_proplit_aux);
  make_subr((char *)"get-pred-term-interpvalue",tc7_subr_1,get_pred_term_interpvalue);
  make_subr((char *)"get-pred-term-interpvalue-incremental",tc7_subr_1,get_pred_term_interpvalue_incremental);
  GLOBAL(prop_flatten_lastvar_global)=MAKINUM(0);
  GLOBAL(prop_flatten_newlits_global)=EOL;
  GLOBAL(prop_flatten_varslist_global)=EOL;
  GLOBAL(prop_flatten_clause_processed_terms_global)=EOL;
  make_subr((char *)"flatten-clause-set",tc7_subr_1,flatten_clause_set);
  make_subr((char *)"flatten-clause",tc7_subr_1,flatten_clause);
  make_subr((char *)"preprocess-flatten-clause",tc7_subr_1,preprocess_flatten_clause);
  make_subr((char *)"flatten-clause-aux",tc7_subr_1,flatten_clause_aux);
  make_subr((char *)"flatten-composite-term",tc7_subr_2,flatten_composite_term);
  return make_subr((char *)"make-prop-flatten-newvar",tc7_subr_0,make_prop_flatten_newvar);
}

SCM top_actions_25_resbase()
{
  make_subr((char *)"make-prop-flatten-addpair",tc7_subr_3,make_prop_flatten_addpair);
  make_subr((char *)"pseudo-flatten-clause-set",tc7_subr_1,pseudo_flatten_clause_set);
  make_subr((char *)"pseudo-flatten-clause",tc7_subr_1,pseudo_flatten_clause);
  make_subr((char *)"pseudo-preprocess-flatten-clause",tc7_subr_1,pseudo_preprocess_flatten_clause);
  make_subr((char *)"pseudo-flatten-clause-aux",tc7_subr_1,pseudo_flatten_clause_aux);
  make_subr((char *)"pseudo-flatten-composite-term",tc7_subr_2,pseudo_flatten_composite_term);
  GLOBAL(prop_debug_global)=BOOL_F;
  GLOBAL(propvar_value_global)=EOL;
  GLOBAL(propvar_negative_occ_clauses_global)=EOL;
  GLOBAL(propvar_positive_occ_clauses_global)=EOL;
  GLOBAL(propvar_enqued_value_global)=EOL;
  GLOBAL(prop_var_assignment_queue_global)=EOL;
  GLOBAL(prop_assigned_varvalpairs_global)=EOL;
  GLOBAL(prop_unsat_found_occlistpart_global)=EOL;
  make_subr((char *)"create-prop-var-vectors",tc7_subr_1,create_prop_var_vectors);
  make_subr((char *)"initialize-prop-var-values",tc7_subr_1,initialize_prop_var_values);
  make_subr((char *)"build-prop-internal-structure",tc7_subr_1,build_prop_internal_structure);
  make_subr((char *)"solve-prop-clauses",tc7_subr_2,solve_prop_clauses);
  make_subr((char *)"initial-prop-unit-propagate",tc7_subr_1,initial_prop_unit_propagate);
  make_subr((char *)"solve-prop-clauses-branch",tc7_subr_3,solve_prop_clauses_branch);
  make_subr((char *)"prop-find-splittable",tc7_subr_1,prop_find_splittable);
  make_subr((char *)"prop-give-next-split-tst",tc7_subr_1,prop_give_next_split_tst);
  make_subr((char *)"prop-give-next-split",tc7_subr_1,prop_give_next_split);
  make_subr((char *)"prop-clause-subsumed-by-var?",tc7_subr_1,prop_clause_subsumed_by_var_pred_);
  make_subr((char *)"loop-prop-unit-queue",tc7_subr_0,loop_prop_unit_queue);
  make_subr((char *)"assign-prop-var",tc7_subr_1,assign_prop_var);
  make_subr((char *)"prop-resolve-clause",tc7_subr_2,prop_resolve_clause);
  make_subr((char *)"prop-enque-unit",tc7_subr_2,prop_enque_unit);
  make_subr((char *)"prop-undo-assignments",tc7_subr_1,prop_undo_assignments);
  make_subr((char *)"prop-undo-queue-assignments",tc7_subr_1,prop_undo_queue_assignments);
  make_subr((char *)"test-prop-undo-assignments",tc7_subr_1,test_prop_undo_assignments);
  make_subr((char *)"prop-try-subsume",tc7_subr_1,prop_try_subsume);
  make_subr((char *)"prop-subsumed-clause?",tc7_subr_2,prop_subsumed_clause_pred_);
  make_subr((char *)"prop-unit-subsumed?",tc7_subr_1,prop_unit_subsumed_pred_);
  make_subr((char *)"prop-subsumes?",tc7_subr_2,prop_subsumes_pred_);
  make_subr((char *)"prop-subclause-polarity?",tc7_subr_3,prop_subclause_polarity_pred_);
  make_subr((char *)"prop-sort-splittable",tc7_subr_1,prop_sort_splittable);
  make_subr((char *)"prop-clause-occ-sum",tc7_subr_1,prop_clause_occ_sum);
  make_subr((char *)"prop-sort-splittable-aux",tc7_subr_1,prop_sort_splittable_aux);
  make_subr((char *)"prop-sort-splittable-merge",tc7_subr_2,prop_sort_splittable_merge);
  make_subr((char *)"prop-sort-splittable-split",tc7_subr_2,prop_sort_splittable_split);
  GLOBAL(global_prop_prover_global)=zchaff_symb;
  GLOBAL(prop_conversion_to_file_global)=BOOL_F;
  GLOBAL(prop_conversion_file_port_global)=BOOL_F;
  GLOBAL(prop_conversion_temp_file_port_global)=BOOL_F;
  GLOBAL(prop_conversion_file_name_start_global)=const_848;
  GLOBAL(prop_conversion_temp_file_name_start_global)=const_849;
  GLOBAL(prop_conversion_header_file_name_start_global)=const_850;
  GLOBAL(prop_conversion_result_file_name_start_global)=const_851;
  GLOBAL(prop_conversion_file_name_global)=const_852;
  return UNSPECIFIED;
}

SCM top_actions_26_resbase()
{
  SCM nibbles,random_strings,i;

  GLOBAL(prop_conversion_temp_file_name_global)=const_853;
  GLOBAL(prop_conversion_header_file_name_global)=const_854;
  GLOBAL(prop_conversion_result_file_name_global)=const_855;
  GLOBAL(prop_conversion_output_clause_nr_global)=MAKINUM(0);
  make_subr((char *)"external-solve-prop-clauses",tc7_subr_3,external_solve_prop_clauses);
  make_subr((char *)"call-prop-prover",tc7_subr_3,call_prop_prover);
  make_subr((char *)"check-prop-prover-outfile",tc7_subr_2,check_prop_prover_outfile);
  make_subr((char *)"sublist?",tc7_subr_2,sublist_pred_);
  make_subr((char *)"sublist-aux?",tc7_subr_2,sublist_aux_pred_);
  make_subr((char *)"make-prop-infile",tc7_lsubr,make_prop_infile_wrapper);
  make_subr((char *)"output-prop-clause",tc7_subr_2,output_prop_clause);
  make_subr((char *)"open-prop-temp-output-file",tc7_subr_1,open_prop_temp_output_file);
  GLOBAL(prop_in_global)=const_856;
  GLOBAL(prop_internal_clauses_global)=EOL;
  GLOBAL(prop_maxvar_global)=MAKINUM(0);
  make_subr((char *)"tstprop",tc7_subr_0,tstprop);
  make_subr((char *)"show-prop-internal-data",tc7_subr_2,show_prop_internal_data);
  make_subr((char *)"tst",tc7_subr_1,tst);
  GLOBAL(random_tap)=MAKINUM(24);
  GLOBAL(random_size)=MAKINUM(55);
  make_subr((char *)"random-size-int",tc7_subr_1,random_size_int);
  GLOBAL(random_chunk_size)=MAKINUM(4*INUM(random_size_int(MAKINUM(8))));
  GLOBAL(random_mask)=string2number(make_string(MAKINUM(INUM(GLOBAL(random_chunk_size))/4),MAKICHR('f')),MAKINUM(16));
  GLOBAL(random_state_global)=const_857;
  random_strings=GLOBAL(random_state_global);
  GLOBAL(random_state_global)=make_vector(MAKINUM(INUM(GLOBAL(random_size))+1),MAKINUM(0));
  nibbles=MAKINUM(INUM(GLOBAL(random_chunk_size))/4);
  for(i=MAKINUM(0);!(i==GLOBAL(random_size));i=MAKINUM(INUM(i)+1)) {
    VECTOR_SET(GLOBAL(random_state_global),i,string2number(substring(VECTOR_REF(random_strings,i),MAKINUM(0),nibbles),MAKINUM(16)));
  }
  make_subr((char *)"random-chunk",tc7_subr_1,random_chunk);
  make_subr((char *)"random-random",tc7_lsubr,random_random_wrapper);
  make_subr((char *)"random-make-random-state",tc7_lsubr,random_make_random_state);
  make_subr((char *)"prop-uncurry-clauses",tc7_subr_1,prop_uncurry_clauses);
  make_subr((char *)"prop-uncurry-clause",tc7_subr_1,prop_uncurry_clause);
  make_subr((char *)"prop-uncurry-term",tc7_subr_1,prop_uncurry_term);
  make_subr((char *)"prop-spec-pure-fun",tc7_subr_1,prop_spec_pure_fun);
  make_subr((char *)"prop-spec-pure-unsigned-fun",tc7_subr_1,prop_spec_pure_unsigned_fun);
  GLOBAL(prop_groundprocess_const_nr_global)=MAKINUM(100000);
  GLOBAL(prop_groundprocess_term_const_pairs_global)=EOL;
  make_subr((char *)"prop-groundprocess-clauses",tc7_subr_1,prop_groundprocess_clauses);
  make_subr((char *)"prop-groundprocess-make-equalities",tc7_subr_0,prop_groundprocess_make_equalities);
  make_subr((char *)"prop-groundprocess-clause-list",tc7_subr_1,prop_groundprocess_clause_list);
  make_subr((char *)"prop-groundprocess-clause",tc7_subr_1,prop_groundprocess_clause);
  make_subr((char *)"prop-groundprocess-lit",tc7_subr_1,prop_groundprocess_lit);
  make_subr((char *)"prop-groundprocess-term",tc7_subr_1,prop_groundprocess_term);
  make_subr((char *)"prop-groundprocess-term-newconstant",tc7_subr_0,prop_groundprocess_term_newconstant);
  GLOBAL(props_dynamic_vectors_global)=BOOL_T;
  GLOBAL(props_eq_fun_global)=MAKINUM(0);
  GLOBAL(props_domain_size_global)=MAKINUM(0);
  GLOBAL(props_ground_clauses_global)=EOL;
  GLOBAL(props_nonground_clauses_global)=EOL;
  GLOBAL(props_max_allowed_cells_global)=MAKINUM(50000);
  GLOBAL(props_max_allowed_clauses_global)=MAKINUM(70000);
  GLOBAL(props_fun_arities_vector_global)=make_vector(MAKINUM(10000),BOOL_F);
  return UNSPECIFIED;
}

SCM top_actions_27_resbase()
{
  GLOBAL(props_fun_originals_vector_global)=make_vector(MAKINUM(10000),BOOL_F);
  GLOBAL(props_fun_originalsymb_vector_global)=make_vector(MAKINUM(10000),BOOL_F);
  GLOBAL(props_fun_ispred_vector_global)=make_vector(MAKINUM(10000),BOOL_F);
  GLOBAL(props_cell_nr_global)=MAKINUM(0);
  GLOBAL(props_cell_cterm_vector_global)=EOL;
  GLOBAL(props_cell_occurrences_vector_global)=EOL;
  GLOBAL(props_cell_range_vector_global)=EOL;
  GLOBAL(props_cell_order_vector_global)=EOL;
  GLOBAL(props_fun_basenr_vector_global)=EOL;
  GLOBAL(props_nterm_nr_global)=MAKINUM(0);
  GLOBAL(props_nterm_vector_global)=EOL;
  GLOBAL(props_nterm_originals_vector_global)=EOL;
  GLOBAL(props_nterm_matchcells_vector_global)=EOL;
  GLOBAL(props_nterm_clauses_vector_global)=EOL;
  GLOBAL(props_nterm_fun_basenr_vector_global)=EOL;
  GLOBAL(props_timecheck_counter_global)=MAKINUM(0);
  GLOBAL(props_purefun_mask_global)=MAKINUM(65535);
  GLOBAL(props_isneglit_mask_global)=MAKINUM(268435456);
  GLOBAL(props_islit_mask_global)=MAKINUM(65536);
  GLOBAL(props_isconst_mask_global)=MAKINUM(131072);
  GLOBAL(props_funnr_mask_global)=MAKINUM(65535);
  GLOBAL(props_selection_strategy_global)=MAKINUM(1);
  GLOBAL(props_debug_global)=BOOL_F;
  GLOBAL(props_small_debug_global)=BOOL_F;
  GLOBAL(props_debug_selectcell_global)=BOOL_F;
  GLOBAL(props_remove_terms_strat_global)=BOOL_T;
  GLOBAL(props_use_nterms_strat_global)=BOOL_T;
  GLOBAL(props_split_sel_count_global)=MAKINUM(0);
  GLOBAL(props_assign_count_global)=MAKINUM(0);
  GLOBAL(props_restrict_count_global)=MAKINUM(0);
  GLOBAL(props_rewrite_count_global)=MAKINUM(0);
  GLOBAL(props_nterm_assign_count_global)=MAKINUM(0);
  GLOBAL(props_nterm_restrict_count_global)=MAKINUM(0);
  GLOBAL(props_nterm_derive_count_global)=MAKINUM(0);
  GLOBAL(props_clause_count_global)=MAKINUM(0);
  GLOBAL(props_stop_search_flag_global)=BOOL_F;
  make_subr((char *)"props-build-model",tc7_subr_1,props_build_model);
  make_subr((char *)"props-build-model-0",tc7_subr_1,props_build_model_0);
  make_subr((char *)"props-build-model-1",tc7_subr_1,props_build_model_1);
  make_subr((char *)"props-build-model-2",tc7_subr_1,props_build_model_2);
  make_subr((char *)"props-build-model-3",tc7_subr_1,props_build_model_3);
  make_subr((char *)"props-build-model-4",tc7_subr_1,props_build_model_4);
  make_subr((char *)"props-build-model-5",tc7_subr_1,props_build_model_5);
  make_subr((char *)"props-build-model-6",tc7_subr_1,props_build_model_6);
  make_subr((char *)"props-build-model-aux",tc7_subr_1,props_build_model_aux);
  make_subr((char *)"props-initial-propagate",tc7_subr_2,props_initial_propagate);
  make_subr((char *)"props-init-equality",tc7_subr_1,props_init_equality);
  make_subr((char *)"props-initial-analyze-clauses",tc7_subr_2,props_initial_analyze_clauses);
  make_subr((char *)"props-split-cells-incremental",tc7_lsubr,props_split_cells_incremental_wrapper);
  return make_subr((char *)"props-show-success-stats",tc7_subr_2,props_show_success_stats);
}

SCM top_actions_28_resbase()
{
  make_subr((char *)"props-show-size-end-stats",tc7_subr_1,props_show_size_end_stats);
  make_subr((char *)"make-touched-list",tc7_subr_3,make_touched_list);
  make_subr((char *)"props-select-split-cell",tc7_lsubr,props_select_split_cell_wrapper);
  make_subr((char *)"props-select-split-cell-restricted-initial-experiment",tc7_lsubr,props_select_split_cell_restricted_initial_experiment_wrapper);
  make_subr((char *)"props-select-split-cell-restricted-initial",tc7_lsubr,props_select_split_cell_restricted_initial_wrapper);
  make_subr((char *)"props-select-split-cell-restricted-secondary",tc7_lsubr,props_select_split_cell_restricted_secondary_wrapper);
  make_subr((char *)"props-select-split-cell-restricted-secondary-experiment",tc7_lsubr,props_select_split_cell_restricted_secondary_experiment_wrapper);
  make_subr((char *)"props-select-split-cell-unrestricted",tc7_lsubr,props_select_split_cell_unrestricted_wrapper);
  make_subr((char *)"props-select-split-cell-occurrences",tc7_lsubr,props_select_split_cell_occurrences_wrapper);
  GLOBAL(props_cterm_max_arg)=top_actions_28_resbase_cl3_clproc0;
  GLOBAL(props_cell_measures_vector_global)=EOL;
  make_subr((char *)"props-make-cell-measures!",tc7_subr_1,props_make_cell_measures_excl_);
  make_subr((char *)"props-sort-cells!",tc7_subr_1,props_sort_cells_excl_);
  make_subr((char *)"props-sort-cells-aux!",tc7_subr_3,props_sort_cells_aux_excl_);
  make_subr((char *)"props-merge",tc7_subr_3,props_merge);
  make_subr((char *)"props-cell-nr-less?",tc7_subr_3,props_cell_nr_less_pred_);
  make_subr((char *)"props-select-split-cell-preassign",tc7_subr_1,props_select_split_cell_preassign);
  make_subr((char *)"props-open-occ-cell-count",tc7_subr_0,props_open_occ_cell_count);
  make_subr((char *)"props-assign-cell!",tc7_lsubr,props_assign_cell_excl__wrapper);
  make_subr((char *)"props-restrict-cell!",tc7_lsubr,props_restrict_cell_excl__wrapper);
  make_subr((char *)"props-propagate-cell!",tc7_subr_3,props_propagate_cell_excl_);
  make_subr((char *)"props-rewrite-with-assignment!",tc7_lsubr,props_rewrite_with_assignment_excl__wrapper);
  make_subr((char *)"props-analyze-clause!",tc7_subr_3,props_analyze_clause_excl_);
  make_subr((char *)"props-analyze-clause-old!",tc7_subr_3,props_analyze_clause_old_excl_);
  make_subr((char *)"remove-term-occurrences-old!",tc7_lsubr,remove_term_occurrences_old_excl__wrapper);
  make_subr((char *)"remove-term-occurrences!",tc7_lsubr,remove_term_occurrences_excl__wrapper);
  make_subr((char *)"props-pre-memq",tc7_subr_2,props_pre_memq);
  make_subr((char *)"props-check-eq-assign",tc7_subr_2,props_check_eq_assign);
  make_subr((char *)"props-push-stack!",tc7_subr_2,props_push_stack_excl_);
  make_subr((char *)"props-restore-stack!",tc7_subr_2,props_restore_stack_excl_);
  make_subr((char *)"props-init-indexes",tc7_subr_1,props_init_indexes);
  make_subr((char *)"props-store-initial-occurrences",tc7_subr_2,props_store_initial_occurrences);
  make_subr((char *)"props-store-subterm-occurrences",tc7_subr_2,props_store_subterm_occurrences);
  make_subr((char *)"props-make-initial-range",tc7_subr_2,props_make_initial_range);
  make_subr((char *)"props-cterm-fun-basenr",tc7_subr_1,props_cterm_fun_basenr);
  make_subr((char *)"props-cterm-index-nr",tc7_subr_2,props_cterm_index_nr);
  make_subr((char *)"props-nterm-fun-basenr",tc7_subr_1,props_nterm_fun_basenr);
  make_subr((char *)"props-nterm-index-nr",tc7_subr_3,props_nterm_index_nr);
  make_subr((char *)"props-check-nterm-index-nr",tc7_subr_2,props_check_nterm_index_nr);
  make_subr((char *)"props-check-nterm-eq-assign",tc7_subr_2,props_check_nterm_eq_assign);
  make_subr((char *)"props-assign-nterm!",tc7_lsubr,props_assign_nterm_excl__wrapper);
  make_subr((char *)"props-restrict-nterm!",tc7_lsubr,props_restrict_nterm_excl__wrapper);
  make_subr((char *)"derive-from-cell-with-nterms",tc7_subr_3,derive_from_cell_with_nterms);
  make_subr((char *)"derive-from-nterm-with-cells",tc7_lsubr,derive_from_nterm_with_cells_wrapper);
  GLOBAL(props_ground_clauses_global)=EOL;
  make_subr((char *)"props-saturate-clauses",tc7_subr_2,props_saturate_clauses);
  make_subr((char *)"props-saturate-clause!",tc7_subr_2,props_saturate_clause_excl_);
  make_subr((char *)"props-make-ground-clause",tc7_subr_1,props_make_ground_clause);
  make_subr((char *)"props-make-ground-term",tc7_subr_3,props_make_ground_term);
  return make_subr((char *)"props-eq-lit-value-check",tc7_subr_1,props_eq_lit_value_check);
}

SCM top_actions_28_resbase_cl3(cterm)
SCM cterm;
{
  SCM len,res,i;

  res=MAKINUM(-1);
  len=VECTOR_LENGTH(cterm);
  for(i=MAKINUM(2);!(i>=len);i=MAKINUM(1+INUM(i)))
    if(VECTOR_REF(cterm,i)>res) {
      res=VECTOR_REF(cterm,i);
    }
  return res;
}

SCM top_actions_29_resbase()
{
  make_subr((char *)"props-eq-lit-fast-value-check",tc7_subr_1,props_eq_lit_fast_value_check);
  make_subr((char *)"props-valuation-list-nextvalues!",tc7_subr_2,props_valuation_list_nextvalues_excl_);
  make_subr((char *)"props-equal-terms-nopolarity",tc7_subr_2,props_equal_terms_nopolarity);
  GLOBAL(props_pred_nr_table_global)=EOL;
  GLOBAL(props_fun_nr_table_global)=EOL;
  GLOBAL(props_const_nr_table_global)=EOL;
  GLOBAL(props_fun_counter_global)=MAKINUM(0);
  make_subr((char *)"props-make-nonground-clauses",tc7_subr_1,props_make_nonground_clauses);
  GLOBAL(props_nonground_vars_tmp_global)=EOL;
  make_subr((char *)"props-make-nonground-clause",tc7_subr_1,props_make_nonground_clause);
  make_subr((char *)"props-make-nonground-lit",tc7_subr_1,props_make_nonground_lit);
  make_subr((char *)"props-make-nonground-term",tc7_subr_1,props_make_nonground_term);
  make_subr((char *)"props-var-nr",tc7_subr_1,props_var_nr);
  make_subr((char *)"props-make-const-nr",tc7_subr_1,props_make_const_nr);
  make_subr((char *)"props-make-fun-nr",tc7_subr_2,props_make_fun_nr);
  make_subr((char *)"props-make-pred-nr",tc7_subr_2,props_make_pred_nr);
  make_subr((char *)"print-props-nonground-clause",tc7_subr_1,print_props_nonground_clause);
  make_subr((char *)"print-props-ground-clause",tc7_subr_1,print_props_ground_clause);
  make_subr((char *)"print-props-nonground-term",tc7_subr_1,print_props_nonground_term);
  make_subr((char *)"print-props-ground-term",tc7_subr_1,print_props_ground_term);
  make_subr((char *)"print-props-model-term",tc7_subr_1,print_props_model_term);
  make_subr((char *)"props-print-vectors",tc7_subr_0,props_print_vectors);
  make_subr((char *)"props-check-model",tc7_subr_2,props_check_model);
  make_subr((char *)"props-check-saturate-clause",tc7_subr_2,props_check_saturate_clause);
  make_subr((char *)"props-check-make-ground-clause",tc7_subr_2,props_check_make_ground_clause);
  make_subr((char *)"props-check-make-ground-term",tc7_subr_2,props_check_make_ground_term);
  make_subr((char *)"props-check-compute-term",tc7_subr_2,props_check_compute_term);
  make_subr((char *)"props-eq-pred?",tc7_subr_1,props_eq_pred_pred_);
  make_subr((char *)"props-is-pred?",tc7_subr_1,props_is_pred_pred_);
  make_subr((char *)"props-term-is-surely-lit?",tc7_subr_1,props_term_is_surely_lit_pred_);
  make_subr((char *)"props-pos-pred?",tc7_subr_1,props_pos_pred_pred_);
  make_subr((char *)"props-pure-fun",tc7_subr_1,props_pure_fun);
  make_subr((char *)"int-power",tc7_subr_2,int_power);
  make_subr((char *)"slow-int-power",tc7_subr_2,slow_int_power);
  GLOBAL(props_cterm_max_arg)=top_actions_29_resbase_cl4_clproc0;
  make_subr((char *)"props-cterm-sum-arg",tc7_subr_1,props_cterm_sum_arg);
  make_subr((char *)"make-list",tc7_subr_2,make_list);
  make_subr((char *)"remove-one-from-list",tc7_subr_2,remove_one_from_list);
  make_subr((char *)"props-no-intersection",tc7_subr_2,props_no_intersection);
  GLOBAL(user_interrupt)=GLOBAL(quit_nonkeyword);
  return make_subr((char *)"top-level-actions",tc7_subr_0,top_level_actions);
}

SCM top_actions_29_resbase_cl4(cterm)
SCM cterm;
{
  SCM tmp,res,len,i;

  len=VECTOR_LENGTH(cterm);
  res=MAKINUM(-1);
  tmp=MAKINUM(-1);
  for(i=MAKINUM(2);!(i>=len);i=MAKINUM(1+INUM(i))) {
    tmp=VECTOR_REF(cterm,i);
    if(tmp>res) {
      res=tmp;
    }
  }
  return res;
}

SCM top_actions_resbase()
{
  top_actions_1_resbase();
  top_actions_2_resbase();
  top_actions_3_resbase();
  top_actions_4_resbase();
  top_actions_5_resbase();
  top_actions_6_resbase();
  top_actions_7_resbase();
  top_actions_8_resbase();
  top_actions_9_resbase();
  top_actions_10_resbase();
  top_actions_11_resbase();
  top_actions_12_resbase();
  top_actions_13_resbase();
  top_actions_14_resbase();
  top_actions_15_resbase();
  top_actions_16_resbase();
  top_actions_17_resbase();
  top_actions_18_resbase();
  top_actions_19_resbase();
  top_actions_20_resbase();
  top_actions_21_resbase();
  top_actions_22_resbase();
  top_actions_23_resbase();
  top_actions_24_resbase();
  top_actions_25_resbase();
  top_actions_26_resbase();
  top_actions_27_resbase();
  top_actions_28_resbase();
  return top_actions_29_resbase();
}

SCM map1(fn,lst)
SCM (*fn) ();
SCM lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM map1_inst6(npar__56,npar__57,npar__58,fn,lst)
SCM (*fn) ();
SCM npar__56,npar__57,npar__58,lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(npar__56,npar__57,npar__58,CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(npar__56,npar__57,npar__58,CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM map1_inst5(npar__54,npar__55,fn,lst)
SCM *npar__55;
SCM (*fn) ();
SCM npar__54,lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(npar__54,npar__55,CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(npar__54,npar__55,CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM map1_inst4(npar__50,fn,lst)
SCM *npar__50;
SCM (*fn) ();
SCM lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(npar__50,CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(npar__50,CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM map1_inst3(npar__10,npar__11,fn,lst)
SCM *npar__10,*npar__11;
SCM (*fn) ();
SCM lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(npar__10,npar__11,CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(npar__10,npar__11,CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM map1_inst2(npar__8,npar__9,fn,lst)
SCM (*fn) ();
SCM npar__8,npar__9,lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(npar__8,npar__9,CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(npar__8,npar__9,CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM map1_inst1(npar__6,fn,lst)
SCM (*fn) ();
SCM npar__6,lst;
{
  SCM res,res_end;

  res=EOL;
  res_end=res;
  for(;PAIR_P(lst);) {
    if(NULL_P(res)) {
      res=cons((*fn)(npar__6,CAR(lst)),EOL);
      res_end=res;
    }
    else {
      SET_CDR(res_end,cons((*fn)(npar__6,CAR(lst)),EOL));
      res_end=CDR(res_end);
    }
    lst=CDR(lst);
  }
  return res;
}

SCM for_each1(fn,lst)
SCM (*fn) ();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst7(npar__51,npar__52,npar__53,fn,lst)
SCM *npar__51,*npar__52,*npar__53;
SCM (*fn) ();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__51,npar__52,npar__53,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst6(npar__44,npar__45,fn,lst)
SCM *npar__44,*npar__45;
SCM (*fn) ();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__44,npar__45,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst5(npar__34,npar__35,fn,lst)
SCM (*fn) ();
SCM npar__34,npar__35,lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__34,npar__35,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst4(npar__25,npar__26,npar__27,npar__28,npar__29,npar__30,fn,lst)
SCM *npar__25,*npar__26,*npar__27,*npar__28,*npar__29,*npar__30;
SCM (*fn) ();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__25,npar__26,npar__27,npar__28,npar__29,npar__30,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst3(npar__24,fn,lst)
SCM (*fn) ();
SCM npar__24,lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__24,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst2(npar__23,fn,lst)
SCM *npar__23;
SCM (*fn) ();
SCM lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__23,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM for_each1_inst1(npar__12,npar__13,npar__14,npar__15,npar__16,npar__17,npar__18,npar__19,npar__20,npar__21,npar__22,fn,lst)
SCM *npar__14,*npar__15,*npar__16,*npar__17,*npar__18,*npar__19,*npar__20,*npar__21,*npar__22;
SCM (*fn) ();
SCM npar__12,npar__13,lst;
{
  for(;PAIR_P(lst);) {
    (*fn)(npar__12,npar__13,npar__14,npar__15,npar__16,npar__17,npar__18,npar__19,npar__20,npar__21,npar__22,CAR(lst));
    lst=CDR(lst);
  }
  return UNSPECIFIED;
}

SCM derive_from_nterm_with_cells_wrapper(x)
SCM x;
{
  return derive_from_nterm_with_cells(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM props_restrict_nterm_excl__wrapper(x)
SCM x;
{
  return props_restrict_nterm_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM props_assign_nterm_excl__wrapper(x)
SCM x;
{
  return props_assign_nterm_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM remove_term_occurrences_excl__wrapper(x)
SCM x;
{
  return remove_term_occurrences_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM remove_term_occurrences_old_excl__wrapper(x)
SCM x;
{
  return remove_term_occurrences_old_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_rewrite_with_assignment_excl__wrapper(x)
SCM x;
{
  return props_rewrite_with_assignment_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM props_restrict_cell_excl__wrapper(x)
SCM x;
{
  return props_restrict_cell_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_assign_cell_excl__wrapper(x)
SCM x;
{
  return props_assign_cell_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_select_split_cell_occurrences_wrapper(x)
SCM x;
{
  return props_select_split_cell_occurrences(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_select_split_cell_unrestricted_wrapper(x)
SCM x;
{
  return props_select_split_cell_unrestricted(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_select_split_cell_restricted_secondary_experiment_wrapper(x)
SCM x;
{
  return props_select_split_cell_restricted_secondary_experiment(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_select_split_cell_restricted_secondary_wrapper(x)
SCM x;
{
  return props_select_split_cell_restricted_secondary(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_select_split_cell_restricted_initial_wrapper(x)
SCM x;
{
  return props_select_split_cell_restricted_initial(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_select_split_cell_restricted_initial_experiment_wrapper(x)
SCM x;
{
  return props_select_split_cell_restricted_initial_experiment(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_select_split_cell_wrapper(x)
SCM x;
{
  return props_select_split_cell(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM props_split_cells_incremental_wrapper(x)
SCM x;
{
  return props_split_cells_incremental(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM random_random_wrapper(x)
SCM x;
{
  return random_random(CAR(x),CDR(x));
}

SCM make_prop_infile_wrapper(x)
SCM x;
{
  return make_prop_infile(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM check_prop_interpretations_incremental_aux_wrapper(x)
SCM x;
{
  return check_prop_interpretations_incremental_aux(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM check_prop_flatten_interpretations_wrapper(x)
SCM x;
{
  return check_prop_flatten_interpretations(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM make_prop_interpretation_lists_aux_wrapper(x)
SCM x;
{
  return make_prop_interpretation_lists_aux(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM make_raw_inf_cl_pair_typet_hyper_wrapper(x)
SCM x;
{
  return make_raw_inf_cl_pair_typet_hyper(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM history__grtr_answer_binstep_wrapper(x)
SCM x;
{
  return history__grtr_answer_binstep(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))));
}

SCM insert_discr_tree_excl__wrapper(x)
SCM x;
{
  return insert_discr_tree_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM insert_clause_discr_tree_excl__wrapper(x)
SCM x;
{
  return insert_clause_discr_tree_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM insert_partial_discr_tree_excl__wrapper(x)
SCM x;
{
  return insert_partial_discr_tree_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM full_unit_cutoff_double_excl__wrapper(x)
SCM x;
{
  return full_unit_cutoff_double_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM full_unit_cutoff_aux_excl__wrapper(x)
SCM x;
{
  return full_unit_cutoff_aux_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM subst_deco_cl_wrapper(x)
SCM x;
{
  return subst_deco_cl(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM make_raw_inf_cl_pair_aux_wrapper(x)
SCM x;
{
  return make_raw_inf_cl_pair_aux(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM make_raw_inf_cl_pair_wrapper(x)
SCM x;
{
  return make_raw_inf_cl_pair(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM handle_derived_inf_cl_pair_wrapper(x)
SCM x;
{
  return handle_derived_inf_cl_pair(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM paramodulate_into_ycl_wrapper(x)
SCM x;
{
  return paramodulate_into_ycl(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))))))))));
}

SCM make_chain_history_for_resolution_wrapper(x)
SCM x;
{
  return make_chain_history_for_resolution(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM make_binres_history_wrapper(x)
SCM x;
{
  return make_binres_history(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))));
}

SCM make_hyper_history_aux_complex_wrapper(x)
SCM x;
{
  return make_hyper_history_aux_complex(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))));
}

SCM make_hyper_history_aux_wrapper(x)
SCM x;
{
  return make_hyper_history_aux(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))));
}

SCM make_hyper_history_wrapper(x)
SCM x;
{
  return make_hyper_history(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))))));
}

SCM two_posunits_typet_para_wrapper(x)
SCM x;
{
  return two_posunits_typet_para(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM unit_and_final_nuc_res_wrapper(x)
SCM x;
{
  return unit_and_final_nuc_res(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))))));
}

SCM final_nuc_res_wrapper(x)
SCM x;
{
  return final_nuc_res(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))));
}

SCM two_clause_binres_loop_wrapper(x)
SCM x;
{
  return two_clause_binres_loop(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM insert_to_best_res_wrapper(x)
SCM x;
{
  return insert_to_best_res(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM select_best_clauses_wrapper(x)
SCM x;
{
  return select_best_clauses(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM prove_one_pass_after_proving_combinedstrat_wrapper(x)
SCM x;
{
  return prove_one_pass_after_proving_combinedstrat(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))));
}

SCM prove_one_pass_after_proving_wrapper(x)
SCM x;
{
  return prove_one_pass_after_proving(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))));
}

SCM prove_one_pass_actually_prove_wrapper(x)
SCM x;
{
  return prove_one_pass_actually_prove(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(CDR(x)))))))));
}

SCM prove_one_pass_wrapper(x)
SCM x;
{
  return prove_one_pass(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM build_split_stratlist_wrapper(x)
SCM x;
{
  return build_split_stratlist(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM build_strat_list_wrapper(x)
SCM x;
{
  return build_strat_list(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM prove_all_passes_single_strategy_wrapper(x)
SCM x;
{
  return prove_all_passes_single_strategy(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM prove_all_passes_split_strategy_wrapper(x)
SCM x;
{
  return prove_all_passes_split_strategy(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))));
}

SCM prove_all_passes_loop_strategies_wrapper(x)
SCM x;
{
  return prove_all_passes_loop_strategies(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM prove_all_passes_wrapper(x)
SCM x;
{
  return prove_all_passes(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM prove_show_input_clauses_wrapper(x)
SCM x;
{
  return prove_show_input_clauses(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM prove_make_initial_clauses_wrapper(x)
SCM x;
{
  return prove_make_initial_clauses(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM report_error_wrapper(x)
SCM x;
{
  return report_error(CAR(x),CDR(x));
}

SCM subsumed_pure_clause_aux_pred__wrapper(x)
SCM x;
{
  return subsumed_pure_clause_aux_pred_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM funlist_can_subsume_pred__wrapper(x)
SCM x;
{
  return funlist_can_subsume_pred_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM subsumed_clause_aux_pred__wrapper(x)
SCM x;
{
  return subsumed_clause_aux_pred_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))),CAR(CDR(CDR(CDR(CDR(CDR(x)))))),CAR(CDR(CDR(CDR(CDR(CDR(CDR(x))))))));
}

SCM resolve_unify_cutoff_wrapper(x)
SCM x;
{
  return resolve_unify_cutoff(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM resolve_unify_ordinary_wrapper(x)
SCM x;
{
  return resolve_unify_ordinary(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM decorate_vars_lit_excl__wrapper(x)
SCM x;
{
  return decorate_vars_lit_excl_(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))),CAR(CDR(CDR(CDR(CDR(x))))));
}

SCM intersection_union_wrapper(x)
SCM x;
{
  return intersection_union(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM subst_deco_replace_term_nodemodulate_wrapper(x)
SCM x;
{
  return subst_deco_replace_term_nodemodulate(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM subst_deco_replace_term_wrapper(x)
SCM x;
{
  return subst_deco_replace_term(CAR(x),CAR(CDR(x)),CAR(CDR(CDR(x))),CAR(CDR(CDR(CDR(x)))));
}

SCM init_1_resbase()
{
  top_actions_29_resbase_cl4_clproc0=make_subr((char *)"top_actions_29_resbase_cl4",tc7_subr_1,top_actions_29_resbase_cl4);
  top_actions_28_resbase_cl3_clproc0=make_subr((char *)"top_actions_28_resbase_cl3",tc7_subr_1,top_actions_28_resbase_cl3);
  top_actions_17_resbase_cl2_clproc0=make_subr((char *)"top_actions_17_resbase_cl2",tc7_subr_0,top_actions_17_resbase_cl2);
  top_actions_17_resbase_cl1_clproc0=make_subr((char *)"top_actions_17_resbase_cl1",tc7_subr_0,top_actions_17_resbase_cl1);
  quit_nonkeyword=&CDR(intern((char *)"quit",4));
  batch=&CDR(intern((char *)"batch",5));
  props_cterm_max_arg=&CDR(intern((char *)"props-cterm-max-arg",19));
  most_positive_fixnum=&CDR(intern((char *)"most-positive-fixnum",20));
  vector_fill_excl_=&CDR(intern((char *)"vector-fill!",12));
  print_full_int_clause=&CDR(intern((char *)"print-full-int-clause",21));
  show_history_simple_propclauses=&CDR(intern((char *)"show-history-simple-propclauses",31));
  unsprop_history_global=&CDR(intern((char *)"*unsprop-history*",17));
  non_ground=&CDR(intern((char *)"non-ground",10));
  _grtr__depth_pred_=&CDR(intern((char *)">-depth?",8));
  ground_pred_=&CDR(intern((char *)"ground?",7));
  get_fun_term_lex=&CDR(intern((char *)"get-fun-term-lex",16));
  make_var_depth_occurrences_aux=&CDR(intern((char *)"make-var-depth-occurrences-aux",30));
  get_const_term_lex=&CDR(intern((char *)"get-const-term-lex",18));
  order_equality_litinfo_lex_real=&CDR(intern((char *)"order-equality-litinfo-lex-real",31));
  insert_partial_discr_tree_leaf_excl_=&CDR(intern((char *)"insert-partial-discr-tree-leaf!",31));
  res=&CDR(intern((char *)"res",3));
  use_all_single_premiss_rules=&CDR(intern((char *)"use-all-single-premiss-rules",28));
  int_prohibited_pr_pred_=&CDR(intern((char *)"int-prohibited-pr?",18));
  factor_clproc0=&CDR(intern((char *)"factor",6));
  int_usable_clauses_fast_loop=&CDR(intern((char *)"int-usable-clauses-fast-loop",28));
  call_with_input_string=&CDR(intern((char *)"call-with-input-string",22));
  string_port_handler_clproc0=&CDR(intern((char *)"string-port-handler",19));
  call_with_output_string=&CDR(intern((char *)"call-with-output-string",23));
  preprocess_otter_file_aux_clproc0=&CDR(intern((char *)"preprocess-otter-file-aux",25));
  set=&CDR(intern((char *)"set",3));
  flatter_prefix_formula=&CDR(intern((char *)"flatter-prefix-formula",22));
  pretty_print=&CDR(intern((char *)"pretty-print",12));
  program_arguments=&CDR(intern((char *)"program-arguments",17));
  current_time=&CDR(intern((char *)"current-time",12));
  internal_time_units_per_second=&CDR(intern((char *)"internal-time-units-per-second",30));
  get_internal_real_time=&CDR(intern((char *)"get-internal-real-time",22));
  greater_clause_occ_depth_pred_=&CDR(intern((char *)"greater-clause-occ-depth?",25));
  user_interrupt=&CDR(intern((char *)"user-interrupt",14));
  props_nonground_vars_tmp_global=&CDR(intern((char *)"*props-nonground-vars-tmp*",26));
  props_fun_counter_global=&CDR(intern((char *)"*props-fun-counter*",19));
  props_const_nr_table_global=&CDR(intern((char *)"*props-const-nr-table*",22));
  props_fun_nr_table_global=&CDR(intern((char *)"*props-fun-nr-table*",20));
  props_pred_nr_table_global=&CDR(intern((char *)"*props-pred-nr-table*",21));
  props_ground_clauses_global=&CDR(intern((char *)"*props-ground-clauses*",22));
  props_cell_measures_vector_global=&CDR(intern((char *)"*props-cell-measures-vector*",28));
  props_stop_search_flag_global=&CDR(intern((char *)"*props-stop-search-flag*",24));
  props_clause_count_global=&CDR(intern((char *)"*props-clause-count*",20));
  props_nterm_derive_count_global=&CDR(intern((char *)"*props-nterm-derive-count*",26));
  props_nterm_restrict_count_global=&CDR(intern((char *)"*props-nterm-restrict-count*",28));
  props_nterm_assign_count_global=&CDR(intern((char *)"*props-nterm-assign-count*",26));
}

SCM init_2_resbase()
{
  props_rewrite_count_global=&CDR(intern((char *)"*props-rewrite-count*",21));
  props_restrict_count_global=&CDR(intern((char *)"*props-restrict-count*",22));
  props_assign_count_global=&CDR(intern((char *)"*props-assign-count*",20));
  props_split_sel_count_global=&CDR(intern((char *)"*props-split-sel-count*",23));
  props_use_nterms_strat_global=&CDR(intern((char *)"*props-use-nterms-strat*",24));
  props_remove_terms_strat_global=&CDR(intern((char *)"*props-remove-terms-strat*",26));
  props_debug_selectcell_global=&CDR(intern((char *)"*props-debug-selectcell*",24));
  props_small_debug_global=&CDR(intern((char *)"*props-small-debug*",19));
  props_debug_global=&CDR(intern((char *)"*props-debug*",13));
  props_selection_strategy_global=&CDR(intern((char *)"*props-selection-strategy*",26));
  props_funnr_mask_global=&CDR(intern((char *)"*props-funnr-mask*",18));
  props_isconst_mask_global=&CDR(intern((char *)"*props-isconst-mask*",20));
  props_islit_mask_global=&CDR(intern((char *)"*props-islit-mask*",18));
  props_isneglit_mask_global=&CDR(intern((char *)"*props-isneglit-mask*",21));
  props_purefun_mask_global=&CDR(intern((char *)"*props-purefun-mask*",20));
  props_timecheck_counter_global=&CDR(intern((char *)"*props-timecheck-counter*",25));
  props_nterm_fun_basenr_vector_global=&CDR(intern((char *)"*props-nterm-fun-basenr-vector*",31));
  props_nterm_clauses_vector_global=&CDR(intern((char *)"*props-nterm-clauses-vector*",28));
  props_nterm_matchcells_vector_global=&CDR(intern((char *)"*props-nterm-matchcells-vector*",31));
  props_nterm_originals_vector_global=&CDR(intern((char *)"*props-nterm-originals-vector*",30));
  props_nterm_vector_global=&CDR(intern((char *)"*props-nterm-vector*",20));
  props_nterm_nr_global=&CDR(intern((char *)"*props-nterm-nr*",16));
  props_fun_basenr_vector_global=&CDR(intern((char *)"*props-fun-basenr-vector*",25));
  props_cell_order_vector_global=&CDR(intern((char *)"*props-cell-order-vector*",25));
  props_cell_range_vector_global=&CDR(intern((char *)"*props-cell-range-vector*",25));
  props_cell_occurrences_vector_global=&CDR(intern((char *)"*props-cell-occurrences-vector*",31));
  props_cell_cterm_vector_global=&CDR(intern((char *)"*props-cell-cterm-vector*",25));
  props_cell_nr_global=&CDR(intern((char *)"*props-cell-nr*",15));
  props_fun_ispred_vector_global=&CDR(intern((char *)"*props-fun-ispred-vector*",25));
  props_fun_originalsymb_vector_global=&CDR(intern((char *)"*props-fun-originalsymb-vector*",31));
  props_fun_originals_vector_global=&CDR(intern((char *)"*props-fun-originals-vector*",28));
  props_fun_arities_vector_global=&CDR(intern((char *)"*props-fun-arities-vector*",26));
  props_max_allowed_clauses_global=&CDR(intern((char *)"*props-max-allowed-clauses*",27));
  props_max_allowed_cells_global=&CDR(intern((char *)"*props-max-allowed-cells*",25));
  props_nonground_clauses_global=&CDR(intern((char *)"*props-nonground-clauses*",25));
  props_ground_clauses_global=&CDR(intern((char *)"*props-ground-clauses*",22));
  props_domain_size_global=&CDR(intern((char *)"*props-domain-size*",19));
  props_eq_fun_global=&CDR(intern((char *)"*props-eq-fun*",14));
  props_dynamic_vectors_global=&CDR(intern((char *)"*props-dynamic-vectors*",23));
  prop_groundprocess_term_const_pairs_global=&CDR(intern((char *)"*prop-groundprocess-term-const-pairs*",37));
  prop_groundprocess_const_nr_global=&CDR(intern((char *)"*prop-groundprocess-const-nr*",29));
  random_state_global=&CDR(intern((char *)"*random-state*",14));
  random_mask=&CDR(intern((char *)"random-mask",11));
  random_chunk_size=&CDR(intern((char *)"random-chunk-size",17));
  random_size=&CDR(intern((char *)"random-size",11));
  random_tap=&CDR(intern((char *)"random-tap",10));
  prop_maxvar_global=&CDR(intern((char *)"*prop-maxvar*",13));
  prop_internal_clauses_global=&CDR(intern((char *)"*prop-internal-clauses*",23));
  prop_in_global=&CDR(intern((char *)"*prop-in*",9));
  prop_conversion_output_clause_nr_global=&CDR(intern((char *)"*prop-conversion-output-clause-nr*",34));
}

SCM init_3_resbase()
{
  prop_conversion_result_file_name_global=&CDR(intern((char *)"*prop-conversion-result-file-name*",34));
  prop_conversion_header_file_name_global=&CDR(intern((char *)"*prop-conversion-header-file-name*",34));
  prop_conversion_temp_file_name_global=&CDR(intern((char *)"*prop-conversion-temp-file-name*",32));
  prop_conversion_file_name_global=&CDR(intern((char *)"*prop-conversion-file-name*",27));
  prop_conversion_result_file_name_start_global=&CDR(intern((char *)"*prop-conversion-result-file-name-start*",40));
  prop_conversion_header_file_name_start_global=&CDR(intern((char *)"*prop-conversion-header-file-name-start*",40));
  prop_conversion_temp_file_name_start_global=&CDR(intern((char *)"*prop-conversion-temp-file-name-start*",38));
  prop_conversion_file_name_start_global=&CDR(intern((char *)"*prop-conversion-file-name-start*",33));
  prop_conversion_temp_file_port_global=&CDR(intern((char *)"*prop-conversion-temp-file-port*",32));
  prop_conversion_file_port_global=&CDR(intern((char *)"*prop-conversion-file-port*",27));
  prop_conversion_to_file_global=&CDR(intern((char *)"*prop-conversion-to-file*",25));
  global_prop_prover_global=&CDR(intern((char *)"*global-prop-prover*",20));
  prop_unsat_found_occlistpart_global=&CDR(intern((char *)"*prop-unsat-found-occlistpart*",30));
  prop_assigned_varvalpairs_global=&CDR(intern((char *)"*prop-assigned-varvalpairs*",27));
  prop_var_assignment_queue_global=&CDR(intern((char *)"*prop-var-assignment-queue*",27));
  propvar_enqued_value_global=&CDR(intern((char *)"*propvar-enqued-value*",22));
  propvar_positive_occ_clauses_global=&CDR(intern((char *)"*propvar-positive-occ-clauses*",30));
  propvar_negative_occ_clauses_global=&CDR(intern((char *)"*propvar-negative-occ-clauses*",30));
  propvar_value_global=&CDR(intern((char *)"*propvar-value*",15));
  prop_debug_global=&CDR(intern((char *)"*prop-debug*",12));
  prop_flatten_clause_processed_terms_global=&CDR(intern((char *)"*prop-flatten-clause-processed-terms*",37));
  prop_flatten_varslist_global=&CDR(intern((char *)"*prop-flatten-varslist*",23));
  prop_flatten_newlits_global=&CDR(intern((char *)"*prop-flatten-newlits*",22));
  prop_flatten_lastvar_global=&CDR(intern((char *)"*prop-flatten-lastvar*",22));
  prop_funinfolist_global=&CDR(intern((char *)"*prop-funinfolist*",18));
  prop_pred_maxval_pairs_global=&CDR(intern((char *)"*prop-pred-maxval-pairs*",24));
  prop_clauses_generated_global=&CDR(intern((char *)"*prop-clauses-generated*",24));
  prop_pre_evalres_global=&CDR(intern((char *)"*prop-pre-evalres*",18));
  incremental_model_flag_global=&CDR(intern((char *)"*incremental-model-flag*",24));
  prop_orig_constants_to_flat_domainels_global=&CDR(intern((char *)"*prop-orig-constants-to-flat-domainels*",39));
  max_var_stat_post_global=&CDR(intern((char *)"*max-var-stat-post*",19));
  max_var_stat_pre_global=&CDR(intern((char *)"*max-var-stat-pre*",18));
  prop_time_ran_out_global=&CDR(intern((char *)"*prop-time-ran-out*",19));
  propclause_tree_global=&CDR(intern((char *)"*propclause-tree*",17));
  propclauses_global=&CDR(intern((char *)"*propclauses*",13));
  prop_last_enum_value_global=&CDR(intern((char *)"*prop-last-enum-value*",22));
  prop_orig_preds_enum_global=&CDR(intern((char *)"*prop-orig-preds-enum*",22));
  prop_orig_funs_enum_global=&CDR(intern((char *)"*prop-orig-funs-enum*",21));
  prop_orig_constants_enum_global=&CDR(intern((char *)"*prop-orig-constants-enum*",26));
  tmp_varlist_global=&CDR(intern((char *)"*tmp-varlist*",13));
  prop_interp_termlist_global=&CDR(intern((char *)"*prop-interp-termlist*",22));
  prop_interp_value_pairs_global=&CDR(intern((char *)"*prop-interp-value-pairs*",25));
  prop_atom_maxnr_global=&CDR(intern((char *)"*prop-atom-maxnr*",17));
  prop_lit_mappings_global=&CDR(intern((char *)"*prop-lit-mappings*",19));
  prop_fun_mappings_global=&CDR(intern((char *)"*prop-fun-mappings*",19));
  prop_constants_mapping_global=&CDR(intern((char *)"*prop-constants-mapping*",24));
  prop_constants_global=&CDR(intern((char *)"*prop-constants*",16));
  prop_flat_eq_symb_global=&CDR(intern((char *)"*prop-flat-eq-symb*",19));
  prop_orig_preds_global=&CDR(intern((char *)"*prop-orig-preds*",17));
  prop_orig_funs_global=&CDR(intern((char *)"*prop-orig-funs*",16));
}

SCM init_4_resbase()
{
  prop_orig_constants_global=&CDR(intern((char *)"*prop-orig-constants*",21));
  prop_clauses_generation_limited_flag_global=&CDR(intern((char *)"*prop-clauses-generation-limited-flag*",38));
  prop_clauses_generation_limit_global=&CDR(intern((char *)"*prop-clauses-generation-limit*",31));
  partial_model_check_global=&CDR(intern((char *)"*partial-model-check*",21));
  lit_split_varlist_tmp_global=&CDR(intern((char *)"*lit-split-varlist-tmp*",23));
  input_split_constant_nr_global=&CDR(intern((char *)"*input-split-constant-nr*",25));
  flat_split_literal_nr_global=&CDR(intern((char *)"*flat-split-literal-nr*",23));
  prop_const_min_global=&CDR(intern((char *)"*prop-const-min*",16));
  mult_rule_clauses_list_global=&CDR(intern((char *)"*mult-rule-clauses-list*",24));
  single_rule_clauses_list_global=&CDR(intern((char *)"*single-rule-clauses-list*",26));
  single_reduction_rule_clauses_list_global=&CDR(intern((char *)"*single-reduction-rule-clauses-list*",36));
  all_history_clauses_list_global=&CDR(intern((char *)"*all-history-clauses-list*",26));
  simple_history_clausenr_stack_global=&CDR(intern((char *)"*simple-history-clausenr-stack*",31));
  simple_prepared_history_global=&CDR(intern((char *)"*simple-prepared-history*",25));
  otter_prepared_history_global=&CDR(intern((char *)"*otter-prepared-history*",24));
  shown_clausenrs_global=&CDR(intern((char *)"*shown-clausenrs*",17));
  simple_history_stratflag_global=&CDR(intern((char *)"*simple-history-stratflag*",26));
  tmp_var_depth_table_global=&CDR(intern((char *)"*tmp-var-depth-table*",21));
  lex_symbol_orderlst_global=&CDR(intern((char *)"*lex-symbol-orderlst*",21));
  tmp_var_occurrences_table_global=&CDR(intern((char *)"*tmp-var-occurrences-table*",27));
  lex_order_prefer_bigger_arity_global=&CDR(intern((char *)"*lex-order-prefer-bigger-arity*",31));
  fun_lex_order_vector_global=&CDR(intern((char *)"*fun-lex-order-vector*",22));
  const_lex_order_vector_global=&CDR(intern((char *)"*const-lex-order-vector*",24));
  fun_kb_order_vector_global=&CDR(intern((char *)"*fun-kb-order-vector*",21));
  const_kb_order_vector_global=&CDR(intern((char *)"*const-kb-order-vector*",23));
  order_equality_kb_strat_global=&CDR(intern((char *)"*order-equality-kb-strat*",25));
  ttt4_global=&CDR(intern((char *)"*ttt4*",6));
  ttt3_global=&CDR(intern((char *)"*ttt3*",6));
  ttt2_global=&CDR(intern((char *)"*ttt2*",6));
  ttt1_global=&CDR(intern((char *)"*ttt1*",6));
  factorpool_global=&CDR(intern((char *)"*factorpool*",12));
  locfactorpool_global=&CDR(intern((char *)"*locfactorpool*",15));
  handle_derived_inf_cl_pair_return_directly_global=&CDR(intern((char *)"*handle-derived-inf-cl-pair-return-directly*",44));
  stop_fast_loop_flag_global=&CDR(intern((char *)"*stop-fast-loop-flag*",21));
  last_best_clausesize_global=&CDR(intern((char *)"*last-best-clausesize*",22));
  last_best_weight_global=&CDR(intern((char *)"*last-best-weight*",18));
  slow_passed_time_global=&CDR(intern((char *)"*slow-passed-time*",18));
  slow_start_time_global=&CDR(intern((char *)"*slow-start-time*",17));
  new_demodulators_list_global=&CDR(intern((char *)"*new-demodulators-list*",23));
  given_clause_nr_global=&CDR(intern((char *)"*given-clause-nr*",17));
  sos_preference_cur_exp_global=&CDR(intern((char *)"*sos-preference-cur-exp*",24));
  sos_preference_exp_ratio_global=&CDR(intern((char *)"*sos-preference-exp-ratio*",26));
  sos_preference_cur_distance_global=&CDR(intern((char *)"*sos-preference-cur-distance*",29));
  sos_preference_distance_ratio_global=&CDR(intern((char *)"*sos-preference-distance-ratio*",31));
  sos_preference_cur_ratio_global=&CDR(intern((char *)"*sos-preference-cur-ratio*",26));
  sos_preference_ratio_global=&CDR(intern((char *)"*sos-preference-ratio*",22));
  groundprocess_term_const_pairs_global=&CDR(intern((char *)"*groundprocess-term-const-pairs*",32));
  groundprocess_const_nr_global=&CDR(intern((char *)"*groundprocess-const-nr*",24));
  curried_apfun_arities_global=&CDR(intern((char *)"*curried-apfun-arities*",23));
  curried_appred_arities_global=&CDR(intern((char *)"*curried-appred-arities*",24));
}

SCM init_5_resbase()
{
  curried_max_orig_fun_arity_global=&CDR(intern((char *)"*curried-max-orig-fun-arity*",28));
  curried_max_orig_pred_arity_global=&CDR(intern((char *)"*curried-max-orig-pred-arity*",29));
  not_curried_funs_global=&CDR(intern((char *)"*not-curried-funs*",18));
  not_curried_fun_nr_global=&CDR(intern((char *)"*not-curried-fun-nr*",20));
  curry_fun_arity_table_global=&CDR(intern((char *)"*curry-fun-arity-table*",23));
  curried_fun_nr_global=&CDR(intern((char *)"*curried-fun-nr*",16));
  curried_fun_const_table_global=&CDR(intern((char *)"*curried-fun-const-table*",25));
  not_curried_preds_global=&CDR(intern((char *)"*not-curried-preds*",19));
  curry_pred_arity_table_global=&CDR(intern((char *)"*curry-pred-arity-table*",24));
  curried_pred_nr_global=&CDR(intern((char *)"*curried-pred-nr*",17));
  not_curried_pred_nr_global=&CDR(intern((char *)"*not-curried-pred-nr*",21));
  curried_pred_const_table_global=&CDR(intern((char *)"*curried-pred-const-table*",26));
  special_orig_curry_funsymbs_global=&CDR(intern((char *)"*special-orig-curry-funsymbs*",29));
  special_curry_funsymbs_global=&CDR(intern((char *)"*special-curry-funsymbs*",24));
  special_orig_curry_predsymbs_global=&CDR(intern((char *)"*special-orig-curry-predsymbs*",30));
  special_curry_predsymbs_global=&CDR(intern((char *)"*special-curry-predsymbs*",25));
  max_curry_fun_nr_global=&CDR(intern((char *)"*max-curry-fun-nr*",18));
  max_curry_pred_nr_global=&CDR(intern((char *)"*max-curry-pred-nr*",19));
  absolute_max_curry_fun_nr_global=&CDR(intern((char *)"*absolute-max-curry-fun-nr*",27));
  absolute_max_curry_pred_nr_global=&CDR(intern((char *)"*absolute-max-curry-pred-nr*",28));
  show_uncurry_input_predfuns_global=&CDR(intern((char *)"*show-uncurry-input-predfuns*",29));
  heq_class_flag_global=&CDR(intern((char *)"*heq-class-flag*",16));
  hne_class_flag_global=&CDR(intern((char *)"*hne-class-flag*",16));
  input_avgsize_nr_global=&CDR(intern((char *)"*input-avgsize-nr*",18));
  input_avgdepth_nr_global=&CDR(intern((char *)"*input-avgdepth-nr*",19));
  input_maxdepth_nr_global=&CDR(intern((char *)"*input-maxdepth-nr*",19));
  input_maxsize_nr_global=&CDR(intern((char *)"*input-maxsize-nr*",18));
  sos_maxdepth_nr_global=&CDR(intern((char *)"*sos-maxdepth-nr*",17));
  input_posun_d_global=&CDR(intern((char *)"*input-posun-d*",15));
  input_negun_d_global=&CDR(intern((char *)"*input-negun-d*",15));
  input_contains_eq_global=&CDR(intern((char *)"*input-contains-eq*",19));
  input_maxdepth_nr_global=&CDR(intern((char *)"*input-maxdepth-nr*",19));
  input_maxlen_nonground_nr_global=&CDR(intern((char *)"*input-maxlen-nonground-nr*",27));
  input_maxlen_nr_global=&CDR(intern((char *)"*input-maxlen-nr*",17));
  input_wellhyper_nr_global=&CDR(intern((char *)"*input-wellhyper-nr*",20));
  input_somewhat_ordered_nr_global=&CDR(intern((char *)"*input-somewhat-ordered-nr*",27));
  input_wellorderedcl_nr_global=&CDR(intern((char *)"*input-wellorderedcl-nr*",24));
  input_negdhorncl_nr_global=&CDR(intern((char *)"*input-negdhorncl-nr*",21));
  input_invhorncl_nr_global=&CDR(intern((char *)"*input-invhorncl-nr*",20));
  input_horncl_nr_global=&CDR(intern((char *)"*input-horncl-nr*",17));
  input_mixcl_nr_global=&CDR(intern((char *)"*input-mixcl-nr*",16));
  input_poscl_nr_global=&CDR(intern((char *)"*input-poscl-nr*",16));
  input_negcl_nr_global=&CDR(intern((char *)"*input-negcl-nr*",16));
  input_unitcl_nr_global=&CDR(intern((char *)"*input-unitcl-nr*",17));
  input_cl_nr_global=&CDR(intern((char *)"*input-cl-nr*",13));
  input_eqlit_nr_global=&CDR(intern((char *)"*input-eqlit-nr*",16));
  input_lit_nr_global=&CDR(intern((char *)"*input-lit-nr*",14));
  enumerate_sos_literals_nr_global=&CDR(intern((char *)"*enumerate-sos-literals-nr*",27));
  combinedstrat_flag_global=&CDR(intern((char *)"*combinedstrat-flag*",20));
  split_search_active_flag_global=&CDR(intern((char *)"*split-search-active-flag*",26));
}

SCM init_6_resbase()
{
  all_passes_selected_clauses_global=&CDR(intern((char *)"*all-passes-selected-clauses*",29));
  strat_left_time_global=&CDR(intern((char *)"*strat-left-time*",17));
  strat_passed_time_global=&CDR(intern((char *)"*strat-passed-time*",19));
  strat_start_time_global=&CDR(intern((char *)"*strat-start-time*",18));
  strat_given_time_global=&CDR(intern((char *)"*strat-given-time*",18));
  strat_selected_global=&CDR(intern((char *)"*strat-selected*",16));
  all_passes_time_global=&CDR(intern((char *)"*all-passes-time*",17));
  no_passes_started_global=&CDR(intern((char *)"*no-passes-started*",19));
  run_forever_flag_global=&CDR(intern((char *)"*run-forever-flag*",18));
  use_real_time_global=&CDR(intern((char *)"*use-real-time*",15));
  last_got_time_global=&CDR(intern((char *)"*last-got-time*",15));
  checkpoint_keptnrs_global=&CDR(intern((char *)"*checkpoint-keptnrs*",20));
  given_checkpoint_keptnrs_global=&CDR(intern((char *)"*given-checkpoint-keptnrs*",26));
  strat_list_global=&CDR(intern((char *)"*strat-list*",12));
  one_pass_time_global=&CDR(intern((char *)"*one-pass-time*",15));
  total_time_given_global=&CDR(intern((char *)"*total-time-given*",18));
  total_time_start_global=&CDR(intern((char *)"*total-time-start*",18));
  internal_time_units_per_second_global=&CDR(intern((char *)"*internal-time-units-per-second*",32));
  nr_var_table_global=&CDR(intern((char *)"*nr-var-table*",14));
  comma_output_global=&CDR(intern((char *)"*comma-output*",14));
  list_output_global=&CDR(intern((char *)"*list-output*",13));
  min_var_num_sub1_global=&CDR(intern((char *)"*min-var-num-sub1*",18));
  var_num_global=&CDR(intern((char *)"*var-num*",9));
  var_num_table_global=&CDR(intern((char *)"*var-num-table*",15));
  max_nr_of_preds_global=&CDR(intern((char *)"*max-nr-of-preds*",17));
  min_pred_num_sub1_global=&CDR(intern((char *)"*min-pred-num-sub1*",19));
  pred_num_global=&CDR(intern((char *)"*pred-num*",10));
  pred_num_table_global=&CDR(intern((char *)"*pred-num-table*",16));
  max_nr_of_funs_global=&CDR(intern((char *)"*max-nr-of-funs*",16));
  min_fun_num_sub1_global=&CDR(intern((char *)"*min-fun-num-sub1*",18));
  fun_num_global=&CDR(intern((char *)"*fun-num*",9));
  fun_num_arity_table_global=&CDR(intern((char *)"*fun-num-arity-table*",21));
  fun_num_table_global=&CDR(intern((char *)"*fun-num-table*",15));
  min_const_num_sub1_global=&CDR(intern((char *)"*min-const-num-sub1*",20));
  curry_const_num_global=&CDR(intern((char *)"*curry-const-num*",17));
  const_num_global=&CDR(intern((char *)"*const-num*",11));
  const_num_table_global=&CDR(intern((char *)"*const-num-table*",17));
  prolog_style_variables_global=&CDR(intern((char *)"*prolog-style-variables*",24));
  ans_prohibited_prednrs_global=&CDR(intern((char *)"*ans-prohibited-prednrs*",24));
  ans_prohibited_constnrs_global=&CDR(intern((char *)"*ans-prohibited-constnrs*",25));
  ans_prohibited_funnrs_global=&CDR(intern((char *)"*ans-prohibited-funnrs*",23));
  ans_prohibited_predsymbs_global=&CDR(intern((char *)"*ans-prohibited-predsymbs*",26));
  ans_prohibited_constsymbs_global=&CDR(intern((char *)"*ans-prohibited-constsymbs*",27));
  ans_prohibited_funsymbs_global=&CDR(intern((char *)"*ans-prohibited-funsymbs*",25));
  usable_list_symbol_global=&CDR(intern((char *)"*usable-list-symbol*",20));
  sos_list_symbol_global=&CDR(intern((char *)"*sos-list-symbol*",17));
  lit_demodulator_list_symbol_global=&CDR(intern((char *)"*lit-demodulator-list-symbol*",29));
  demodulator_list_symbol_global=&CDR(intern((char *)"*demodulator-list-symbol*",25));
  classicsynth_speclit_global=&CDR(intern((char *)"*classicsynth-speclit*",22));
  typet_speclit_global=&CDR(intern((char *)"*typet-speclit*",15));
}

SCM init_7_resbase()
{
  lambda_dummypar_symbol_global=&CDR(intern((char *)"*lambda-dummypar-symbol*",24));
  lambda_fun_symbol_global=&CDR(intern((char *)"*lambda-fun-symbol*",19));
  id_refl_fun_symbol_global=&CDR(intern((char *)"*id-refl-fun-symbol*",20));
  subst_prim_fun_symbol_global=&CDR(intern((char *)"*subst-prim-fun-symbol*",23));
  subst_fun_symbol_global=&CDR(intern((char *)"*subst-fun-symbol*",18));
  inhabited_symbol_global=&CDR(intern((char *)"*inhabited-symbol*",18));
  splitpred1_symbol_global=&CDR(intern((char *)"*splitpred1-symbol*",19));
  splitpred0_symbol_global=&CDR(intern((char *)"*splitpred0-symbol*",19));
  if_fun_symbol_global=&CDR(intern((char *)"*if-fun-symbol*",15));
  case_fun_symbol_global=&CDR(intern((char *)"*case-fun-symbol*",17));
  eq_fun_symbol_global=&CDR(intern((char *)"*eq-fun-symbol*",15));
  eq_symbol_global=&CDR(intern((char *)"*eq-symbol*",11));
  ans_symbol_global=&CDR(intern((char *)"*ans-symbol*",12));
  otter_inport_global=&CDR(intern((char *)"*otter-inport*",14));
  otter_tmpfile_global=&CDR(intern((char *)"*otter-tmpfile*",15));
  otter_outputfile_suffix_global=&CDR(intern((char *)"*otter-outputfile-suffix*",25));
  otter_tmpfile_prefix_global=&CDR(intern((char *)"*otter-tmpfile-prefix*",22));
  otter_tmpfile_suffix_global=&CDR(intern((char *)"*otter-tmpfile-suffix*",22));
  otter_dot_repl_global=&CDR(intern((char *)"*otter-dot-repl*",16));
  otter_comma_repl_global=&CDR(intern((char *)"*otter-comma-repl*",18));
  otter_uppercase_prefix_global=&CDR(intern((char *)"*otter-uppercase-prefix*",24));
  all_symbol_global=&CDR(intern((char *)"*all-symbol*",12));
  exists_symbol_global=&CDR(intern((char *)"*exists-symbol*",15));
  equivalent_symbol_global=&CDR(intern((char *)"*equivalent-symbol*",19));
  not_symbol_global=&CDR(intern((char *)"*not-symbol*",12));
  imp_symbol_global=&CDR(intern((char *)"*imp-symbol*",12));
  or_symbol_global=&CDR(intern((char *)"*or-symbol*",11));
  and_symbol_global=&CDR(intern((char *)"*and-symbol*",12));
  false_symbol_global=&CDR(intern((char *)"*false-symbol*",14));
  true_symbol_global=&CDR(intern((char *)"*true-symbol*",13));
  const_bindings_global=&CDR(intern((char *)"*const-bindings*",16));
  last_free_var_nr_global=&CDR(intern((char *)"*last-free-var-nr*",18));
  last_skolemfn_nr_global=&CDR(intern((char *)"*last-skolemfn-nr*",18));
  unfold_finite_types_flag_global=&CDR(intern((char *)"*unfold-finite-types-flag*",26));
  type_pred_name_global=&CDR(intern((char *)"*type-pred-name*",16));
  skolemfn_base_string_global=&CDR(intern((char *)"*skolemfn-base-string*",22));
  free_var_base_string_global=&CDR(intern((char *)"*free-var-base-string*",22));
  type_alist_global=&CDR(intern((char *)"*type-alist*",12));
  parse_formula_context_global=&CDR(intern((char *)"*parse-formula-context*",23));
  otter_or_symbol_global=&CDR(intern((char *)"*otter-or-symbol*",17));
  gandalf_pid_global=&CDR(intern((char *)"*gandalf-pid*",13));
  intepreter_mode_global=&CDR(intern((char *)"*intepreter-mode*",17));
  gandalf_program_arguments_global=&CDR(intern((char *)"*gandalf-program-arguments*",27));
  run_id_global=&CDR(intern((char *)"*run-id*",8));
  subs_reg_subs_fail_nr_global=&CDR(intern((char *)"*subs-reg-subs-fail-nr*",23));
  subs_reg_subs_tried_nr_global=&CDR(intern((char *)"*subs-reg-subs-tried-nr*",24));
  subs_funlist_fail_nr_global=&CDR(intern((char *)"*subs-funlist-fail-nr*",22));
  subs_gclpreds_fail_nr_global=&CDR(intern((char *)"*subs-gclpreds-fail-nr*",23));
  subs_aux_strength_fail_nr_global=&CDR(intern((char *)"*subs-aux-strength-fail-nr*",27));
  subs_strength_fail_nr_global=&CDR(intern((char *)"*subs-strength-fail-nr*",23));
}

SCM init_8_resbase()
{
  subs_length_fail_nr_global=&CDR(intern((char *)"*subs-length-fail-nr*",21));
  subs_tried_nr_global=&CDR(intern((char *)"*subs-tried-nr*",15));
  proof_start_run_time_global=&CDR(intern((char *)"*proof-start-run-time*",22));
  proof_start_real_time_global=&CDR(intern((char *)"*proof-start-real-time*",23));
  double_unit_cutoff_nr_global=&CDR(intern((char *)"*double-unit-cutoff-nr*",23));
  full_unit_cutoff_nr_global=&CDR(intern((char *)"*full-unit-cutoff-nr*",21));
  simple_unit_cutoff_nr_global=&CDR(intern((char *)"*simple-unit-cutoff-nr*",23));
  back_subsumed_nr_global=&CDR(intern((char *)"*back-subsumed-nr*",18));
  forward_subsumed_nonunit_nr_global=&CDR(intern((char *)"*forward-subsumed-nonunit-nr*",29));
  forward_subsumed_overdouble_nr_global=&CDR(intern((char *)"*forward-subsumed-overdouble-nr*",32));
  forward_subsumed_double_nr_global=&CDR(intern((char *)"*forward-subsumed-double-nr*",28));
  forward_subsumed_unit_nr_global=&CDR(intern((char *)"*forward-subsumed-unit-nr*",26));
  kept_new_demodulators_nr_global=&CDR(intern((char *)"*kept-new-demodulators-nr*",26));
  kept_mid_nucleus_nr_global=&CDR(intern((char *)"*kept-mid-nucleus-nr*",21));
  kept_size_sum_nr_global=&CDR(intern((char *)"*kept-size-sum-nr*",18));
  kept_clauses_nr_global=&CDR(intern((char *)"*kept-clauses-nr*",17));
  derived_clauses_nr_global=&CDR(intern((char *)"*derived-clauses-nr*",20));
  one_pass_kept_clauses_firstnr_global=&CDR(intern((char *)"*one-pass-kept-clauses-firstnr*",31));
  answer_litinf_global=&CDR(intern((char *)"*answer-litinf*",15));
  special_insertion_place_global=&CDR(intern((char *)"*special-insertion-place*",25));
  global_sos_preference_ratio_global=&CDR(intern((char *)"*global-sos-preference-ratio*",29));
  order_strategy_sos_flag_global=&CDR(intern((char *)"*order-strategy-sos-flag*",25));
  clause_keeplength_limit_global=&CDR(intern((char *)"*clause-keeplength-limit*",25));
  clause_uselength_limit_global=&CDR(intern((char *)"*clause-uselength-limit*",24));
  clause_keepdepth_limit_global=&CDR(intern((char *)"*clause-keepdepth-limit*",24));
  clause_finalkeepsize_limit_global=&CDR(intern((char *)"*clause-finalkeepsize-limit*",28));
  clause_midsearch_keepsize_limit_global=&CDR(intern((char *)"*clause-midsearch-keepsize-limit*",33));
  clause_keepsize_limit_global=&CDR(intern((char *)"*clause-keepsize-limit*",23));
  clause_usestruct_limits_global=&CDR(intern((char *)"*clause-usestruct-limits*",25));
  clause_usedepth_limits_global=&CDR(intern((char *)"*clause-usedepth-limits*",24));
  clause_usenr_limits_global=&CDR(intern((char *)"*clause-usenr-limits*",21));
  user_criterias_pre_flag_global=&CDR(intern((char *)"*user-criterias-pre-flag*",25));
  user_criterias_post_flag_global=&CDR(intern((char *)"*user-criterias-post-flag*",26));
  new_demodulators_flag_global=&CDR(intern((char *)"*new-demodulators-flag*",23));
  demodulate_constants_flag_global=&CDR(intern((char *)"*demodulate-constants-flag*",27));
  demodulate_flag_global=&CDR(intern((char *)"*demodulate-flag*",17));
  back_demodulate_flag_global=&CDR(intern((char *)"*back-demodulate-flag*",22));
  demodulate_lit_flag_global=&CDR(intern((char *)"*demodulate-lit-flag*",21));
  dynamic_demodulation_flag_global=&CDR(intern((char *)"*dynamic-demodulation-flag*",27));
  ordered_paramodulation_flag_global=&CDR(intern((char *)"*ordered-paramodulation-flag*",29));
  discr_depth_first_global=&CDR(intern((char *)"*discr-depth-first*",19));
  random_model_strat_global=&CDR(intern((char *)"*random-model-strat*",20));
  sem_model_strat_global=&CDR(intern((char *)"*sem-model-strat*",17));
  mace_model_strat_global=&CDR(intern((char *)"*mace-model-strat*",18));
  simple_model_strat_global=&CDR(intern((char *)"*simple-model-strat*",20));
  mace_nofuns_model_strat_global=&CDR(intern((char *)"*mace-nofuns-model-strat*",25));
  discr_tree_subsume_stratflag_global=&CDR(intern((char *)"*discr-tree-subsume-stratflag*",30));
  int_use_hyperres_flag_global=&CDR(intern((char *)"*int-use-hyperres-flag*",23));
  classical_synth_stratflag_global=&CDR(intern((char *)"*classical-synth-stratflag*",27));
  int_use_binres_flag_global=&CDR(intern((char *)"*int-use-binres-flag*",21));
}

SCM init_9_resbase()
{
  int_logic_flag_global=&CDR(intern((char *)"*int-logic-flag*",16));
  type_theory_stratflag_global=&CDR(intern((char *)"*type-theory-stratflag*",23));
  neg_hyper_strategy_flag_global=&CDR(intern((char *)"*neg-hyper-strategy-flag*",25));
  ordered_factor_flag_global=&CDR(intern((char *)"*ordered-factor-flag*",21));
  negweight_order_strategy_flag_global=&CDR(intern((char *)"*negweight-order-strategy-flag*",31));
  posweight_order_strategy_flag_global=&CDR(intern((char *)"*posweight-order-strategy-flag*",31));
  poslitpref_order_strategy_flag_global=&CDR(intern((char *)"*poslitpref-order-strategy-flag*",32));
  firstlitpref_order_strategy_flag_global=&CDR(intern((char *)"*firstlitpref-order-strategy-flag*",34));
  epr_order_strategy_flag_global=&CDR(intern((char *)"*epr-order-strategy-flag*",25));
  exp_order_strategy_flag_global=&CDR(intern((char *)"*exp-order-strategy-flag*",25));
  name_order_strategy_flag_global=&CDR(intern((char *)"*name-order-strategy-flag*",26));
  order_sos_strategy_flag_global=&CDR(intern((char *)"*order-sos-strategy-flag*",25));
  order_strategy_flag_global=&CDR(intern((char *)"*order-strategy-flag*",21));
  bliksem_strategy_flag_global=&CDR(intern((char *)"*bliksem-strategy-flag*",23));
  hyper_strategy_flag_global=&CDR(intern((char *)"*hyper-strategy-flag*",21));
  double_strategy_flag_global=&CDR(intern((char *)"*double-strategy-flag*",22));
  unit_strategy_flag_global=&CDR(intern((char *)"*unit-strategy-flag*",20));
  para_unit_strategy_global=&CDR(intern((char *)"*para-unit-strategy*",20));
  para_pos_unit_strategy_global=&CDR(intern((char *)"*para-pos-unit-strategy*",24));
  paramodulate_from_vars_stratflag_global=&CDR(intern((char *)"*paramodulate-from-vars-stratflag*",34));
  paramodulation_strategy_flag_global=&CDR(intern((char *)"*paramodulation-strategy-flag*",30));
  paramodulation_allowed_flag_global=&CDR(intern((char *)"*paramodulation-allowed-flag*",29));
  remove_identical_lit_stratflag_global=&CDR(intern((char *)"*remove-identical-lit-stratflag*",32));
  havealready_timecounter_global=&CDR(intern((char *)"*havealready-timecounter*",25));
  demodulate_with_clauses_stratflag_global=&CDR(intern((char *)"*demodulate-with-clauses-stratflag*",35));
  back_subsume_stratflag_global=&CDR(intern((char *)"*back-subsume-stratflag*",24));
  factors_stratflag_global=&CDR(intern((char *)"*factors-stratflag*",19));
  unit_clash_flag_global=&CDR(intern((char *)"*unit-clash-flag*",17));
  hyper_contradiction_strategy_global=&CDR(intern((char *)"*hyper-contradiction-strategy*",30));
  binary_hyper_sos_strategy_global=&CDR(intern((char *)"*binary-hyper-sos-strategy*",27));
  hyper_wos_strategy_flag_global=&CDR(intern((char *)"*hyper-wos-strategy-flag*",25));
  prop_unsat_strat_global=&CDR(intern((char *)"*prop-unsat-strat*",18));
  remove_all_tautologies_stratflag_global=&CDR(intern((char *)"*remove-all-tautologies-stratflag*",34));
  display_debug_info_flag_global=&CDR(intern((char *)"*display-debug-info-flag*",25));
  display_info_char_flag_global=&CDR(intern((char *)"*display-info-char-flag*",24));
  display_info_level_global=&CDR(intern((char *)"*display-info-level*",20));
  max_size_sum_nr_global=&CDR(intern((char *)"*max-size-sum-nr*",17));
  max_kept_clauses_nr_global=&CDR(intern((char *)"*max-kept-clauses-nr*",21));
  splitting_allowed_flag_global=&CDR(intern((char *)"*splitting-allowed-flag*",24));
  stop_res_real_time_global=&CDR(intern((char *)"*stop-res-real-time*",20));
  auto_mode_flag_global=&CDR(intern((char *)"*auto-mode-flag*",16));
  keep_all_old_clauses_flag_global=&CDR(intern((char *)"*keep-all-old-clauses-flag*",27));
  sos_strategy_flag_global=&CDR(intern((char *)"*sos-strategy-flag*",19));
  order_equality_firstpref_strat_global=&CDR(intern((char *)"*order-equality-firstpref-strat*",32));
  order_equality_lex_strat_global=&CDR(intern((char *)"*order-equality-lex-strat*",26));
  unit_para_flag_global=&CDR(intern((char *)"*unit-para-flag*",16));
  root_para_strat_global=&CDR(intern((char *)"*root-para-strat*",17));
  unit_equality_strat_global=&CDR(intern((char *)"*unit-equality-strat*",21));
  split_strategy_flag_global=&CDR(intern((char *)"*split-strategy-flag*",21));
  sos_exhausted_flag_global=&CDR(intern((char *)"*sos-exhausted-flag*",20));
}

SCM init_10_resbase()
{
  full_proof_strategy_flag_global=&CDR(intern((char *)"*full-proof-strategy-flag*",26));
  sat_strategy_flag_global=&CDR(intern((char *)"*sat-strategy-flag*",19));
  complete_sat_strategy_global=&CDR(intern((char *)"*complete-sat-strategy*",23));
  complete_unsat_strategy_global=&CDR(intern((char *)"*complete-unsat-strategy*",25));
  int_outmost_label_fun_nr_global=&CDR(intern((char *)"*int-outmost-label-fun-nr*",26));
  int_outmost_symb_labelfun_global=&CDR(intern((char *)"*int-outmost-symb-labelfun*",27));
  lambda_dummypar_nr_global=&CDR(intern((char *)"*lambda-dummypar-nr*",20));
  lambda_fun_nr_global=&CDR(intern((char *)"*lambda-fun-nr*",15));
  subst_prim_fun_nr_global=&CDR(intern((char *)"*subst-prim-fun-nr*",19));
  subst_fun_nr_global=&CDR(intern((char *)"*subst-fun-nr*",14));
  if_fun_nr_global=&CDR(intern((char *)"*if-fun-nr*",11));
  case_fun_nr_global=&CDR(intern((char *)"*case-fun-nr*",13));
  eq_fun_nr_global=&CDR(intern((char *)"*eq-fun-nr*",11));
  eq_pred_nr_global=&CDR(intern((char *)"*eq-pred-nr*",12));
  ans_pred_nr_global=&CDR(intern((char *)"*ans-pred-nr*",13));
  make_inside_subset_tmp_lst_global=&CDR(intern((char *)"*make-inside-subset-tmp-lst*",28));
  make_inside_subset_tmp_global=&CDR(intern((char *)"*make-inside-subset-tmp*",24));
  intersection_tmp_global=&CDR(intern((char *)"*intersection-tmp*",18));
  discr_tree_demod_atoms_global=&CDR(intern((char *)"*discr-tree-demod-atoms*",24));
  discr_tree_demod_terms_global=&CDR(intern((char *)"*discr-tree-demod-terms*",24));
  discr_tree_list_global=&CDR(intern((char *)"*discr-tree-list*",17));
  nonunit_discr_tree_global=&CDR(intern((char *)"*nonunit-discr-tree*",20));
  discr_tree_global=&CDR(intern((char *)"*discr-tree*",12));
  all_back_subsumed_clauses_global=&CDR(intern((char *)"*all-back-subsumed-clauses*",27));
  usable_clauses_list_list_global=&CDR(intern((char *)"*usable-clauses-list-list*",26));
  sos_clauses_list_list_global=&CDR(intern((char *)"*sos-clauses-list-list*",23));
  unit_alist_list_global=&CDR(intern((char *)"*unit-alist-list*",17));
  unit_alist_global=&CDR(intern((char *)"*unit-alist*",12));
  subsumption_list_global=&CDR(intern((char *)"*subsumption-list*",18));
  usable_clauses_list_end_global=&CDR(intern((char *)"*usable-clauses-list-end*",25));
  usable_clauses_list_global=&CDR(intern((char *)"*usable-clauses-list*",21));
  ans_input_sos_global=&CDR(intern((char *)"*ans-input-sos*",15));
  sos_clauses_list_end_global=&CDR(intern((char *)"*sos-clauses-list-end*",22));
  sos_clauses_list_global=&CDR(intern((char *)"*sos-clauses-list*",18));
  litinf_classnr_mask_global=&CDR(intern((char *)"*litinf-classnr-mask*",21));
  litinf_ordernr_mask_global=&CDR(intern((char *)"*litinf-ordernr-mask*",21));
  litinf_reductionrulelit_mask_global=&CDR(intern((char *)"*litinf-reductionrulelit-mask*",30));
  litinf_rightimplrulelit_mask_global=&CDR(intern((char *)"*litinf-rightimplrulelit-mask*",30));
  litinf_leftorrulelit_mask_global=&CDR(intern((char *)"*litinf-leftorrulelit-mask*",27));
  litinf_rulelit_mask_global=&CDR(intern((char *)"*litinf-rulelit-mask*",21));
  litinf_noparafromright_mask_global=&CDR(intern((char *)"*litinf-noparafromright-mask*",29));
  litinf_noparafromleft_mask_global=&CDR(intern((char *)"*litinf-noparafromleft-mask*",28));
  litinf_noparainto_mask_global=&CDR(intern((char *)"*litinf-noparainto-mask*",24));
  litinf_isanswer_mask_global=&CDR(intern((char *)"*litinf-isanswer-mask*",22));
  litinf_nofactor_mask_global=&CDR(intern((char *)"*litinf-nofactor-mask*",22));
  litinf_noresolve_mask_global=&CDR(intern((char *)"*litinf-noresolve-mask*",23));
  last_usable_cl_nr_global=&CDR(intern((char *)"*last-usable-cl-nr*",19));
  kept_cl_nr_global=&CDR(intern((char *)"*kept-cl-nr*",12));
  cl_predsymbs_pos_mask_global=&CDR(intern((char *)"*cl-predsymbs-pos-mask*",23));
  cl_predsymbs_pos_max_global=&CDR(intern((char *)"*cl-predsymbs-pos-max*",22));
}

SCM init_11_resbase()
{
  cl_predsymbs_neg_mask_global=&CDR(intern((char *)"*cl-predsymbs-neg-mask*",23));
  cl_predsymbs_neg_shift_global=&CDR(intern((char *)"*cl-predsymbs-neg-shift*",24));
  cl_predsymbs_area_mask_global=&CDR(intern((char *)"*cl-predsymbs-area-mask*",24));
  cl_pred_overflow_mask_global=&CDR(intern((char *)"*cl-pred-overflow-mask*",23));
  cl_rep_predsymbs_mask_global=&CDR(intern((char *)"*cl-rep-predsymbs-mask*",23));
  predsymb_bit_vector_global=&CDR(intern((char *)"*predsymb-bit-vector*",21));
  cl_len_mask_global=&CDR(intern((char *)"*cl-len-mask*",13));
  cl_len_shift_global=&CDR(intern((char *)"*cl-len-shift*",14));
  cl_maxlen_global=&CDR(intern((char *)"*cl-maxlen*",11));
  cl_maxvar_mask_global=&CDR(intern((char *)"*cl-maxvar-mask*",16));
  cl_maxvar_shift_global=&CDR(intern((char *)"*cl-maxvar-shift*",17));
  cl_ground_flag_global=&CDR(intern((char *)"*cl-ground-flag*",16));
  cl_maxvar_global=&CDR(intern((char *)"*cl-maxvar*",11));
  cl_strength_mask_global=&CDR(intern((char *)"*cl-strength-mask*",18));
  const_strength_global=&CDR(intern((char *)"*const-strength*",16));
  var_strength_global=&CDR(intern((char *)"*var-strength*",14));
  g_and_const_mask_global=&CDR(intern((char *)"*g-and-const-mask*",18));
  const_number_max_global=&CDR(intern((char *)"*const-number-max*",18));
  const_number_mask_global=&CDR(intern((char *)"*const-number-mask*",19));
  term_size_1_shift_global=&CDR(intern((char *)"*term-size-1-shift*",19));
  term_size_max_shift_global=&CDR(intern((char *)"*term-size-max-shift*",21));
  term_size_max_global=&CDR(intern((char *)"*term-size-max*",15));
  term_size_shift_global=&CDR(intern((char *)"*term-size-shift*",17));
  term_size_mask_global=&CDR(intern((char *)"*term-size-mask*",16));
  term_size_strength_mask_global=&CDR(intern((char *)"*term-size-strength-mask*",25));
  term_depth_1_shift_global=&CDR(intern((char *)"*term-depth-1-shift*",20));
  term_depth_shift_global=&CDR(intern((char *)"*term-depth-shift*",18));
  term_depth_max_shift_global=&CDR(intern((char *)"*term-depth-max-shift*",22));
  term_depth_max_global=&CDR(intern((char *)"*term-depth-max*",16));
  term_depth_mask_global=&CDR(intern((char *)"*term-depth-mask*",17));
  term_depth_strength_mask_global=&CDR(intern((char *)"*term-depth-strength-mask*",26));
  strength_mask_global=&CDR(intern((char *)"*strength-mask*",15));
  ground_mask_global=&CDR(intern((char *)"*ground-mask*",13));
  repeated_vars_mask_global=&CDR(intern((char *)"*repeated-vars-mask*",20));
  fun_except_varinf_mask_global=&CDR(intern((char *)"*fun-except-varinf-mask*",24));
  maxvar_mask_global=&CDR(intern((char *)"*maxvar-mask*",13));
  predsymb_mask_global=&CDR(intern((char *)"*predsymb-mask*",15));
  fnsymb_shift_global=&CDR(intern((char *)"*fnsymb-shift*",14));
  fnsymb_mask_global=&CDR(intern((char *)"*fnsymb-mask*",13));
  signedfnsymb_mask_global=&CDR(intern((char *)"*signedfnsymb-mask*",19));
  sgn_mask_global=&CDR(intern((char *)"*sgn-mask*",10));
  var_touched_table_global=&CDR(intern((char *)"*var-touched-table*",19));
  var_val_table_global=&CDR(intern((char *)"*var-val-table*",15));
  z_var_mask_global=&CDR(intern((char *)"*z-var-mask*",12));
  y_var_mask_global=&CDR(intern((char *)"*y-var-mask*",12));
  var_nr_mask_global=&CDR(intern((char *)"*var-nr-mask*",13));
  no_occ_folllit_var_mask_global=&CDR(intern((char *)"*no-occ-folllit-var-mask*",25));
  single_occ_clause_var_mask_global=&CDR(intern((char *)"*single-occ-clause-var-mask*",28));
  no_occ_otherlit_var_mask_global=&CDR(intern((char *)"*no-occ-otherlit-var-mask*",26));
  single_occ_lit_var_mask_global=&CDR(intern((char *)"*single-occ-lit-var-mask*",25));
}

SCM init_12_resbase()
{
  var_info_mask_global=&CDR(intern((char *)"*var-info-mask*",15));
  param_tolitnr_global=&CDR(intern((char *)"*param-tolitnr*",15));
  param_fromlitnr_global=&CDR(intern((char *)"*param-fromlitnr*",17));
  param_tohist_global=&CDR(intern((char *)"*param-tohist*",14));
  param_fromhist_global=&CDR(intern((char *)"*param-fromhist*",16));
  param_xclmaxvar_global=&CDR(intern((char *)"*param-xclmaxvar*",17));
  param_yclmaxvar_global=&CDR(intern((char *)"*param-yclmaxvar*",17));
  param_from_is_y_flag_global=&CDR(intern((char *)"*param-from-is-y-flag*",22));
  param_frominf_global=&CDR(intern((char *)"*param-frominf*",15));
  param_toinf_global=&CDR(intern((char *)"*param-toinf*",13));
  param_right_arg_global=&CDR(intern((char *)"*param-right-arg*",17));
  param_left_arg_global=&CDR(intern((char *)"*param-left-arg*",16));
  param_fromfullinf_global=&CDR(intern((char *)"*param-fromfullinf*",19));
  param_tofullinf_global=&CDR(intern((char *)"*param-tofullinf*",17));
  param_fromcl_global=&CDR(intern((char *)"*param-fromcl*",14));
  param_tocl_global=&CDR(intern((char *)"*param-tocl*",12));
  param_eqlit_global=&CDR(intern((char *)"*param-eqlit*",13));
  param_tolit_global=&CDR(intern((char *)"*param-tolit*",13));
  nonunit_res_global=&CDR(intern((char *)"*nonunit-res*",13));
  nonunit_discr_flag_global=&CDR(intern((char *)"*nonunit-discr-flag*",20));
  overdouble_discr_flag_global=&CDR(intern((char *)"*overdouble-discr-flag*",23));
  cur_clause_global=&CDR(intern((char *)"*cur-clause*",12));
  cur_lit_global=&CDR(intern((char *)"*cur-lit*",9));
  noncomputable_ans_preds_global=&CDR(intern((char *)"*noncomputable-ans-preds*",25));
  noncomputable_ans_funs_global=&CDR(intern((char *)"*noncomputable-ans-funs*",24));
  one_step_hyper_phase_global=&CDR(intern((char *)"*one-step-hyper-phase*",22));
  compare_ground_litcdr_equal_flag_global=&CDR(intern((char *)"*compare-ground-litcdr-equal-flag*",34));
  ground_check_res_global=&CDR(intern((char *)"*ground-check-res*",18));
  used_demodulators_global=&CDR(intern((char *)"*used-demodulators*",19));
  subsumed_clauses_global=&CDR(intern((char *)"*subsumed-clauses*",18));
  subs_factor_derived_flag_global=&CDR(intern((char *)"*subs-factor-derived-flag*",26));
  prohibit_subs_clnr_global=&CDR(intern((char *)"*prohibit-subs-clnr*",20));
  stopsubsuming_flag_global=&CDR(intern((char *)"*stopsubsuming-flag*",20));
  subsuming_clause_global=&CDR(intern((char *)"*subsuming-clause*",18));
  collected_vars_global=&CDR(intern((char *)"*collected-vars*",16));
  gcl_varsstack_global=&CDR(intern((char *)"*gcl-varsstack*",15));
  cut_clauses_global=&CDR(intern((char *)"*cut-clauses*",13));
  new_var_names_global=&CDR(intern((char *)"*new-var-names*",15));
  too_many_vars_flag_global=&CDR(intern((char *)"*too-many-vars-flag*",20));
  answer_history_global=&CDR(intern((char *)"*answer-history*",16));
  answer_cl_global=&CDR(intern((char *)"*answer-cl*",11));
  sat_found_flag_global=&CDR(intern((char *)"*sat-found-flag*",16));
  foundflag_global=&CDR(intern((char *)"*foundflag*",11));
  listofnull_global=&CDR(intern((char *)"*listofnull*",12));
  args_timelimit_global=&CDR(intern((char *)"*args-timelimit*",16));
  timelimit_global=&CDR(intern((char *)"*timelimit*",11));
  default_time_limit_global=&CDR(intern((char *)"*default-time-limit*",20));
  unassigned_global=&CDR(intern((char *)"*unassigned*",12));
  maxconst_global=&CDR(intern((char *)"*maxconst*",10));
  mincurryconst_global=&CDR(intern((char *)"*mincurryconst*",15));
}

SCM init_13_resbase()
{
  minconst_global=&CDR(intern((char *)"*minconst*",10));
  max_y_var_global=&CDR(intern((char *)"*max-y-var*",11));
  max_x_var_global=&CDR(intern((char *)"*max-x-var*",11));
  maxvar_global=&CDR(intern((char *)"*maxvar*",8));
  max_nr_of_vars_in_clause_global=&CDR(intern((char *)"*max-nr-of-vars-in-clause*",26));
  input_symb=scm_gc_protect(CAR(intern((char *)"input",5)));
  hyper_symb=scm_gc_protect(CAR(intern((char *)"hyper",5)));
  literal_symb=scm_gc_protect(CAR(intern((char *)"literal",7)));
  para_symb=scm_gc_protect(CAR(intern((char *)"para",4)));
  fact_symb=scm_gc_protect(CAR(intern((char *)"fact",4)));
  not_enough_time_symb=scm_gc_protect(CAR(intern((char *)"not-enough-time",15)));
  set_symb=scm_gc_protect(CAR(intern((char *)"set",3)));
  clear_symb=scm_gc_protect(CAR(intern((char *)"clear",5)));
  assign_symb=scm_gc_protect(CAR(intern((char *)"assign",6)));
  preference_ratio_symb=scm_gc_protect(CAR(intern((char *)"preference_ratio",16)));
  checkpoints_symb=scm_gc_protect(CAR(intern((char *)"checkpoints",11)));
  max_kept_symb=scm_gc_protect(CAR(intern((char *)"max_kept",8)));
  max_size_sum_symb=scm_gc_protect(CAR(intern((char *)"max_size_sum",12)));
  max_seconds_symb=scm_gc_protect(CAR(intern((char *)"max_seconds",11)));
  print_level_symb=scm_gc_protect(CAR(intern((char *)"print_level",11)));
  max_literals_symb=scm_gc_protect(CAR(intern((char *)"max_literals",12)));
  max_weight_symb=scm_gc_protect(CAR(intern((char *)"max_weight",10)));
  max_depth_symb=scm_gc_protect(CAR(intern((char *)"max_depth",9)));
  prolog_style_variables_symb=scm_gc_protect(CAR(intern((char *)"prolog_style_variables",22)));
  split_symb=scm_gc_protect(CAR(intern((char *)"split",5)));
  paramodulate_symb=scm_gc_protect(CAR(intern((char *)"paramodulate",12)));
  demodulate_symb=scm_gc_protect(CAR(intern((char *)"demodulate",10)));
  binary_exporder_res_symb=scm_gc_protect(CAR(intern((char *)"binary_exporder_res",19)));
  binary_eprorder_res_symb=scm_gc_protect(CAR(intern((char *)"binary_eprorder_res",19)));
  binary_posweight_kb_big_symb=scm_gc_protect(CAR(intern((char *)"binary_posweight_kb_big",23)));
  binary_posweight_kb_small_symb=scm_gc_protect(CAR(intern((char *)"binary_posweight_kb_small",25)));
  binary_posweight_lex_big_symb=scm_gc_protect(CAR(intern((char *)"binary_posweight_lex_big",24)));
  binary_posweight_lex_small_symb=scm_gc_protect(CAR(intern((char *)"binary_posweight_lex_small",26)));
  binary_posweight_firstpred_symb=scm_gc_protect(CAR(intern((char *)"binary_posweight_firstpred",26)));
  hyper_order_uniteq_res_symb=scm_gc_protect(CAR(intern((char *)"hyper_order_uniteq_res",22)));
  binary_unit_uniteq_res_symb=scm_gc_protect(CAR(intern((char *)"binary_unit_uniteq_res",22)));
  binary_nameorder_uniteq_res_symb=scm_gc_protect(CAR(intern((char *)"binary_nameorder_uniteq_res",27)));
  binary_order_uniteq_res_symb=scm_gc_protect(CAR(intern((char *)"binary_order_uniteq_res",23)));
  binary_order_sos_res_symb=scm_gc_protect(CAR(intern((char *)"binary_order_sos_res",20)));
  binary_nameorder_sos_res_symb=scm_gc_protect(CAR(intern((char *)"binary_nameorder_sos_res",24)));
  binary_uniteq_res_symb=scm_gc_protect(CAR(intern((char *)"binary_uniteq_res",17)));
  binary_posweightorder_sos_res_symb=scm_gc_protect(CAR(intern((char *)"binary_posweightorder_sos_res",29)));
  binary_negweightorder_sos_res_symb=scm_gc_protect(CAR(intern((char *)"binary_negweightorder_sos_res",29)));
  binary_order_fulleq_res_symb=scm_gc_protect(CAR(intern((char *)"binary_order_fulleq_res",23)));
  auto_symb=scm_gc_protect(CAR(intern((char *)"auto",4)));
  hyper_res_symb=scm_gc_protect(CAR(intern((char *)"hyper_res",9)));
  hyper_order_res_symb=scm_gc_protect(CAR(intern((char *)"hyper_order_res",15)));
  binary_res_symb=scm_gc_protect(CAR(intern((char *)"binary_res",10)));
  binary_order_res_symb=scm_gc_protect(CAR(intern((char *)"binary_order_res",16)));
  binary_nameorder_res_symb=scm_gc_protect(CAR(intern((char *)"binary_nameorder_res",20)));
}

SCM init_14_resbase()
{
  binary_weightorder_sos_res_symb=scm_gc_protect(CAR(intern((char *)"binary_weightorder_sos_res",26)));
  binary_weightorder_res_symb=scm_gc_protect(CAR(intern((char *)"binary_weightorder_res",22)));
  binary_posweightorder_res_symb=scm_gc_protect(CAR(intern((char *)"binary_posweightorder_res",25)));
  binary_negweightorder_res_symb=scm_gc_protect(CAR(intern((char *)"binary_negweightorder_res",25)));
  binary_hypersos_res_symb=scm_gc_protect(CAR(intern((char *)"binary_hypersos_res",19)));
  binary_unit_res_symb=scm_gc_protect(CAR(intern((char *)"binary_unit_res",15)));
  binary_double_res_symb=scm_gc_protect(CAR(intern((char *)"binary_double_res",17)));
  binary_posweightunit_res_symb=scm_gc_protect(CAR(intern((char *)"binary_posweightunit_res",24)));
  binary_negweightunit_res_symb=scm_gc_protect(CAR(intern((char *)"binary_negweightunit_res",24)));
  binary_synth_res_symb=scm_gc_protect(CAR(intern((char *)"binary_synth_res",16)));
  eq_order_lex_symb=scm_gc_protect(CAR(intern((char *)"eq_order_lex",12)));
  eq_order_kb_symb=scm_gc_protect(CAR(intern((char *)"eq_order_kb",11)));
  eq_order_firstpref_symb=scm_gc_protect(CAR(intern((char *)"eq_order_firstpref",18)));
  eq_order_depth_symb=scm_gc_protect(CAR(intern((char *)"eq_order_depth",14)));
  check_hypercontra_symb=scm_gc_protect(CAR(intern((char *)"check_hypercontra",17)));
  back_demodulate_symb=scm_gc_protect(CAR(intern((char *)"back_demodulate",15)));
  wall_time_symb=scm_gc_protect(CAR(intern((char *)"wall_time",9)));
  run_forever_symb=scm_gc_protect(CAR(intern((char *)"run_forever",11)));
  print_tracechar_symb=scm_gc_protect(CAR(intern((char *)"print_tracechar",15)));
  print_debug_symb=scm_gc_protect(CAR(intern((char *)"print_debug",11)));
  otter_style_variables_symb=scm_gc_protect(CAR(intern((char *)"otter_style_variables",21)));
  end_of_list_symb=scm_gc_protect(CAR(intern((char *)"end_of_list",11)));
  prohibit_ans_pred_symb=scm_gc_protect(CAR(intern((char *)"prohibit_ans_pred",17)));
  prohibit_ans_fun_symb=scm_gc_protect(CAR(intern((char *)"prohibit_ans_fun",16)));
  prohibit_ans_const_symb=scm_gc_protect(CAR(intern((char *)"prohibit_ans_const",18)));
  list_symb=scm_gc_protect(CAR(intern((char *)"list",4)));
  sos_symb=scm_gc_protect(CAR(intern((char *)"sos",3)));
  usable_symb=scm_gc_protect(CAR(intern((char *)"usable",6)));
  formula_list_symb=scm_gc_protect(CAR(intern((char *)"formula_list",12)));
  sosformula_symb=scm_gc_protect(CAR(intern((char *)"sosformula",10)));
  usableformula_symb=scm_gc_protect(CAR(intern((char *)"usableformula",13)));
  axioms_symb=scm_gc_protect(CAR(intern((char *)"axioms",6)));
  demodulators_symb=scm_gc_protect(CAR(intern((char *)"demodulators",12)));
  command_symb=scm_gc_protect(CAR(intern((char *)"command",7)));
  _equal__symb=scm_gc_protect(CAR(intern((char *)"=",1)));
  _excl__equal__symb=scm_gc_protect(CAR(intern((char *)"!=",2)));
  _excl__symb=scm_gc_protect(CAR(intern((char *)"!",1)));
  binary_symb=scm_gc_protect(CAR(intern((char *)"binary",6)));
  hyper_order_symb=scm_gc_protect(CAR(intern((char *)"hyper-order",11)));
  binary_nameorder_symb=scm_gc_protect(CAR(intern((char *)"binary-nameorder",16)));
  binary_order_symb=scm_gc_protect(CAR(intern((char *)"binary-order",12)));
  binary_unit_symb=scm_gc_protect(CAR(intern((char *)"binary-unit",11)));
  binary_epr_order_symb=scm_gc_protect(CAR(intern((char *)"binary-epr-order",16)));
  binary_posweight_kb_big_order_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-kb-big-order",29)));
  binary_posweight_kb_small_order_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-kb-small-order",31)));
  binary_posweight_order_kb_small_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-order-kb-small",31)));
  binary_posweight_order_kb_small_fulleq_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-order-kb-small-fulleq",38)));
  binary_posweight_lex_big_order_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-lex-big-order",30)));
  binary_posweight_lex_small_order_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-lex-small-order",32)));
  binary_posweight_firstpref_order_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-firstpref-order",32)));
}

SCM init_15_resbase()
{
  binary_posweight_order_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-order",22)));
  hyper_order_uniteq_symb=scm_gc_protect(CAR(intern((char *)"hyper-order-uniteq",18)));
  binary_unit_uniteq_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-uniteq",18)));
  binary_bliksem_symb=scm_gc_protect(CAR(intern((char *)"binary-bliksem",14)));
  binary_rootpara_symb=scm_gc_protect(CAR(intern((char *)"binary-rootpara",15)));
  binary_nameorder_uniteq_symb=scm_gc_protect(CAR(intern((char *)"binary-nameorder-uniteq",23)));
  binary_order_uniteq_symb=scm_gc_protect(CAR(intern((char *)"binary-order-uniteq",19)));
  binary_uniteq_symb=scm_gc_protect(CAR(intern((char *)"binary-uniteq",13)));
  binary_nameorder_sos_symb=scm_gc_protect(CAR(intern((char *)"binary-nameorder-sos",20)));
  binary_order_sos_symb=scm_gc_protect(CAR(intern((char *)"binary-order-sos",16)));
  binary_posweightorder_sos_symb=scm_gc_protect(CAR(intern((char *)"binary-posweightorder-sos",25)));
  binary_order_fulleq_symb=scm_gc_protect(CAR(intern((char *)"binary-order-fulleq",19)));
  binary_weightorder_symb=scm_gc_protect(CAR(intern((char *)"binary-weightorder",18)));
  binary_weightorder_sos_symb=scm_gc_protect(CAR(intern((char *)"binary-weightorder-sos",22)));
  prop_unsat_nofun_strat_symb=scm_gc_protect(CAR(intern((char *)"prop-unsat-nofun-strat",22)));
  sat_hyper_strat_symb=scm_gc_protect(CAR(intern((char *)"sat-hyper-strat",15)));
  sat_ordered_binres_strat_symb=scm_gc_protect(CAR(intern((char *)"sat-ordered-binres-strat",24)));
  sat_posweight_order_symb=scm_gc_protect(CAR(intern((char *)"sat-posweight-order",19)));
  sat_weight_ordered_binres_strat_symb=scm_gc_protect(CAR(intern((char *)"sat-weight-ordered-binres-strat",31)));
  simple_model_strat_symb=scm_gc_protect(CAR(intern((char *)"simple-model-strat",18)));
  mace_model_strat_symb=scm_gc_protect(CAR(intern((char *)"mace-model-strat",16)));
  sem_model_strat_symb=scm_gc_protect(CAR(intern((char *)"sem-model-strat",15)));
  sem_model_strat_0_symb=scm_gc_protect(CAR(intern((char *)"sem-model-strat-0",17)));
  sem_model_strat_1_symb=scm_gc_protect(CAR(intern((char *)"sem-model-strat-1",17)));
  sem_model_strat_2_symb=scm_gc_protect(CAR(intern((char *)"sem-model-strat-2",17)));
  sem_model_strat_3_symb=scm_gc_protect(CAR(intern((char *)"sem-model-strat-3",17)));
  sem_model_strat_4_symb=scm_gc_protect(CAR(intern((char *)"sem-model-strat-4",17)));
  sem_model_strat_5_symb=scm_gc_protect(CAR(intern((char *)"sem-model-strat-5",17)));
  mace_nofuns_model_strat_symb=scm_gc_protect(CAR(intern((char *)"mace-nofuns-model-strat",23)));
  random_model_strat_symb=scm_gc_protect(CAR(intern((char *)"random-model-strat",18)));
  binary_hyper_sos_symb=scm_gc_protect(CAR(intern((char *)"binary-hyper-sos",16)));
  hyper_wos_symb=scm_gc_protect(CAR(intern((char *)"hyper-wos",9)));
  binary_double_symb=scm_gc_protect(CAR(intern((char *)"binary-double",13)));
  binary_unit_depth_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-depth",17)));
  binary_unit_depth_sospref_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-depth-sospref",25)));
  binary_unit_depth_backdemod_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-depth-backdemod",27)));
  binary_unit_depth_sospref_alt_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-depth-sospref-alt",29)));
  binary_unit_depth_backdemod_alt_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-depth-backdemod-alt",31)));
  binary_unit_lex_backdemod_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-lex-backdemod",25)));
  binary_unit_lex_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-lex",15)));
  binary_unit_firstpref_backdemod_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-firstpref-backdemod",31)));
  binary_unit_firstpref_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-firstpref",21)));
  binary_posweight_order_kb_big_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-order-kb-big",29)));
  binary_posweight_order_sos_symb=scm_gc_protect(CAR(intern((char *)"binary-posweight-order-sos",26)));
  binary_unit_sos_symb=scm_gc_protect(CAR(intern((char *)"binary-unit-sos",15)));
  quit_symb=scm_gc_protect(CAR(intern((char *)"quit",4)));
  _dollar_ganappred70_symb=scm_gc_protect(CAR(intern((char *)"$ganappred70",12)));
  _dollar_ganappred69_symb=scm_gc_protect(CAR(intern((char *)"$ganappred69",12)));
  _dollar_ganappred68_symb=scm_gc_protect(CAR(intern((char *)"$ganappred68",12)));
  _dollar_ganappred67_symb=scm_gc_protect(CAR(intern((char *)"$ganappred67",12)));
}

SCM init_16_resbase()
{
  _dollar_ganappred66_symb=scm_gc_protect(CAR(intern((char *)"$ganappred66",12)));
  _dollar_ganappred65_symb=scm_gc_protect(CAR(intern((char *)"$ganappred65",12)));
  _dollar_ganappred64_symb=scm_gc_protect(CAR(intern((char *)"$ganappred64",12)));
  _dollar_ganappred63_symb=scm_gc_protect(CAR(intern((char *)"$ganappred63",12)));
  _dollar_ganappred62_symb=scm_gc_protect(CAR(intern((char *)"$ganappred62",12)));
  _dollar_ganappred61_symb=scm_gc_protect(CAR(intern((char *)"$ganappred61",12)));
  _dollar_ganappred60_symb=scm_gc_protect(CAR(intern((char *)"$ganappred60",12)));
  _dollar_ganappred59_symb=scm_gc_protect(CAR(intern((char *)"$ganappred59",12)));
  _dollar_ganappred58_symb=scm_gc_protect(CAR(intern((char *)"$ganappred58",12)));
  _dollar_ganappred57_symb=scm_gc_protect(CAR(intern((char *)"$ganappred57",12)));
  _dollar_ganappred56_symb=scm_gc_protect(CAR(intern((char *)"$ganappred56",12)));
  _dollar_ganappred55_symb=scm_gc_protect(CAR(intern((char *)"$ganappred55",12)));
  _dollar_ganappred54_symb=scm_gc_protect(CAR(intern((char *)"$ganappred54",12)));
  _dollar_ganappred53_symb=scm_gc_protect(CAR(intern((char *)"$ganappred53",12)));
  _dollar_ganappred52_symb=scm_gc_protect(CAR(intern((char *)"$ganappred52",12)));
  _dollar_ganappred51_symb=scm_gc_protect(CAR(intern((char *)"$ganappred51",12)));
  _dollar_ganappred50_symb=scm_gc_protect(CAR(intern((char *)"$ganappred50",12)));
  _dollar_ganappred49_symb=scm_gc_protect(CAR(intern((char *)"$ganappred49",12)));
  _dollar_ganappred48_symb=scm_gc_protect(CAR(intern((char *)"$ganappred48",12)));
  _dollar_ganappred47_symb=scm_gc_protect(CAR(intern((char *)"$ganappred47",12)));
  _dollar_ganappred46_symb=scm_gc_protect(CAR(intern((char *)"$ganappred46",12)));
  _dollar_ganappred45_symb=scm_gc_protect(CAR(intern((char *)"$ganappred45",12)));
  _dollar_ganappred44_symb=scm_gc_protect(CAR(intern((char *)"$ganappred44",12)));
  _dollar_ganappred43_symb=scm_gc_protect(CAR(intern((char *)"$ganappred43",12)));
  _dollar_ganappred42_symb=scm_gc_protect(CAR(intern((char *)"$ganappred42",12)));
  _dollar_ganappred41_symb=scm_gc_protect(CAR(intern((char *)"$ganappred41",12)));
  _dollar_ganappred40_symb=scm_gc_protect(CAR(intern((char *)"$ganappred40",12)));
  _dollar_ganappred39_symb=scm_gc_protect(CAR(intern((char *)"$ganappred39",12)));
  _dollar_ganappred38_symb=scm_gc_protect(CAR(intern((char *)"$ganappred38",12)));
  _dollar_ganappred37_symb=scm_gc_protect(CAR(intern((char *)"$ganappred37",12)));
  _dollar_ganappred36_symb=scm_gc_protect(CAR(intern((char *)"$ganappred36",12)));
  _dollar_ganappred35_symb=scm_gc_protect(CAR(intern((char *)"$ganappred35",12)));
  _dollar_ganappred34_symb=scm_gc_protect(CAR(intern((char *)"$ganappred34",12)));
  _dollar_ganappred33_symb=scm_gc_protect(CAR(intern((char *)"$ganappred33",12)));
  _dollar_ganappred32_symb=scm_gc_protect(CAR(intern((char *)"$ganappred32",12)));
  _dollar_ganappred31_symb=scm_gc_protect(CAR(intern((char *)"$ganappred31",12)));
  _dollar_ganappred30_symb=scm_gc_protect(CAR(intern((char *)"$ganappred30",12)));
  _dollar_ganappred29_symb=scm_gc_protect(CAR(intern((char *)"$ganappred29",12)));
  _dollar_ganappred28_symb=scm_gc_protect(CAR(intern((char *)"$ganappred28",12)));
  _dollar_ganappred27_symb=scm_gc_protect(CAR(intern((char *)"$ganappred27",12)));
  _dollar_ganappred26_symb=scm_gc_protect(CAR(intern((char *)"$ganappred26",12)));
  _dollar_ganappred25_symb=scm_gc_protect(CAR(intern((char *)"$ganappred25",12)));
  _dollar_ganappred24_symb=scm_gc_protect(CAR(intern((char *)"$ganappred24",12)));
  _dollar_ganappred23_symb=scm_gc_protect(CAR(intern((char *)"$ganappred23",12)));
  _dollar_ganappred22_symb=scm_gc_protect(CAR(intern((char *)"$ganappred22",12)));
  _dollar_ganappred21_symb=scm_gc_protect(CAR(intern((char *)"$ganappred21",12)));
  _dollar_ganappred20_symb=scm_gc_protect(CAR(intern((char *)"$ganappred20",12)));
  _dollar_ganappred19_symb=scm_gc_protect(CAR(intern((char *)"$ganappred19",12)));
  _dollar_ganappred18_symb=scm_gc_protect(CAR(intern((char *)"$ganappred18",12)));
  _dollar_ganappred17_symb=scm_gc_protect(CAR(intern((char *)"$ganappred17",12)));
}

SCM init_17_resbase()
{
  _dollar_ganappred16_symb=scm_gc_protect(CAR(intern((char *)"$ganappred16",12)));
  _dollar_ganappred15_symb=scm_gc_protect(CAR(intern((char *)"$ganappred15",12)));
  _dollar_ganappred14_symb=scm_gc_protect(CAR(intern((char *)"$ganappred14",12)));
  _dollar_ganappred13_symb=scm_gc_protect(CAR(intern((char *)"$ganappred13",12)));
  _dollar_ganappred12_symb=scm_gc_protect(CAR(intern((char *)"$ganappred12",12)));
  _dollar_ganappred11_symb=scm_gc_protect(CAR(intern((char *)"$ganappred11",12)));
  _dollar_ganappred10_symb=scm_gc_protect(CAR(intern((char *)"$ganappred10",12)));
  _dollar_ganappred9_symb=scm_gc_protect(CAR(intern((char *)"$ganappred9",11)));
  _dollar_ganappred8_symb=scm_gc_protect(CAR(intern((char *)"$ganappred8",11)));
  _dollar_ganappred7_symb=scm_gc_protect(CAR(intern((char *)"$ganappred7",11)));
  _dollar_ganappred6_symb=scm_gc_protect(CAR(intern((char *)"$ganappred6",11)));
  _dollar_ganappred5_symb=scm_gc_protect(CAR(intern((char *)"$ganappred5",11)));
  _dollar_ganappred4_symb=scm_gc_protect(CAR(intern((char *)"$ganappred4",11)));
  _dollar_ganappred3_symb=scm_gc_protect(CAR(intern((char *)"$ganappred3",11)));
  _dollar_ganappred2_symb=scm_gc_protect(CAR(intern((char *)"$ganappred2",11)));
  _dollar_ganappred1_symb=scm_gc_protect(CAR(intern((char *)"$ganappred1",11)));
  _dollar_ganapfun70_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun70",11)));
  _dollar_ganapfun69_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun69",11)));
  _dollar_ganapfun68_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun68",11)));
  _dollar_ganapfun67_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun67",11)));
  _dollar_ganapfun66_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun66",11)));
  _dollar_ganapfun65_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun65",11)));
  _dollar_ganapfun64_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun64",11)));
  _dollar_ganapfun63_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun63",11)));
  _dollar_ganapfun62_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun62",11)));
  _dollar_ganapfun61_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun61",11)));
  _dollar_ganapfun60_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun60",11)));
  _dollar_ganapfun59_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun59",11)));
  _dollar_ganapfun58_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun58",11)));
  _dollar_ganapfun57_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun57",11)));
  _dollar_ganapfun56_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun56",11)));
  _dollar_ganapfun55_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun55",11)));
  _dollar_ganapfun54_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun54",11)));
  _dollar_ganapfun53_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun53",11)));
  _dollar_ganapfun52_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun52",11)));
  _dollar_ganapfun51_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun51",11)));
  _dollar_ganapfun50_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun50",11)));
  _dollar_ganapfun49_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun49",11)));
  _dollar_ganapfun48_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun48",11)));
  _dollar_ganapfun47_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun47",11)));
  _dollar_ganapfun46_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun46",11)));
  _dollar_ganapfun45_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun45",11)));
  _dollar_ganapfun44_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun44",11)));
  _dollar_ganapfun43_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun43",11)));
  _dollar_ganapfun42_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun42",11)));
  _dollar_ganapfun41_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun41",11)));
  _dollar_ganapfun40_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun40",11)));
  _dollar_ganapfun39_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun39",11)));
  _dollar_ganapfun38_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun38",11)));
  _dollar_ganapfun37_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun37",11)));
}

SCM init_18_resbase()
{
  _dollar_ganapfun36_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun36",11)));
  _dollar_ganapfun35_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun35",11)));
  _dollar_ganapfun34_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun34",11)));
  _dollar_ganapfun33_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun33",11)));
  _dollar_ganapfun32_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun32",11)));
  _dollar_ganapfun31_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun31",11)));
  _dollar_ganapfun30_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun30",11)));
  _dollar_ganapfun29_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun29",11)));
  _dollar_ganapfun28_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun28",11)));
  _dollar_ganapfun27_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun27",11)));
  _dollar_ganapfun26_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun26",11)));
  _dollar_ganapfun25_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun25",11)));
  _dollar_ganapfun24_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun24",11)));
  _dollar_ganapfun23_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun23",11)));
  _dollar_ganapfun22_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun22",11)));
  _dollar_ganapfun21_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun21",11)));
  _dollar_ganapfun20_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun20",11)));
  _dollar_ganapfun19_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun19",11)));
  _dollar_ganapfun18_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun18",11)));
  _dollar_ganapfun17_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun17",11)));
  _dollar_ganapfun16_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun16",11)));
  _dollar_ganapfun15_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun15",11)));
  _dollar_ganapfun14_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun14",11)));
  _dollar_ganapfun13_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun13",11)));
  _dollar_ganapfun12_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun12",11)));
  _dollar_ganapfun11_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun11",11)));
  _dollar_ganapfun10_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun10",11)));
  _dollar_ganapfun9_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun9",10)));
  _dollar_ganapfun8_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun8",10)));
  _dollar_ganapfun7_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun7",10)));
  _dollar_ganapfun6_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun6",10)));
  _dollar_ganapfun5_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun5",10)));
  _dollar_ganapfun4_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun4",10)));
  _dollar_ganapfun3_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun3",10)));
  _dollar_ganapfun2_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun2",10)));
  _dollar_ganapfun1_symb=scm_gc_protect(CAR(intern((char *)"$ganapfun1",10)));
  _exp_x_symb=scm_gc_protect(CAR(intern((char *)"^x",2)));
  x_symb=scm_gc_protect(CAR(intern((char *)"x",1)));
  equal_symb=scm_gc_protect(CAR(intern((char *)"equal",5)));
  endofline_symb=scm_gc_protect(CAR(intern((char *)"endofline",9)));
  _vbar__symb=scm_gc_protect(CAR(intern((char *)"|",1)));
  binres_symb=scm_gc_protect(CAR(intern((char *)"binres",6)));
  chain_symb=scm_gc_protect(CAR(intern((char *)"chain",5)));
  binres_demod_symb=scm_gc_protect(CAR(intern((char *)"binres_demod",12)));
  factor_symb=scm_gc_protect(CAR(intern((char *)"factor",6)));
  demod_symb=scm_gc_protect(CAR(intern((char *)"demod",5)));
  unknown_symb=scm_gc_protect(CAR(intern((char *)"unknown",7)));
  backdemod_symb=scm_gc_protect(CAR(intern((char *)"backdemod",9)));
  binarydemod_symb=scm_gc_protect(CAR(intern((char *)"binarydemod",11)));
  cut_symb=scm_gc_protect(CAR(intern((char *)"cut",3)));
}

SCM init_19_resbase()
{
  slowcut_symb=scm_gc_protect(CAR(intern((char *)"slowcut",7)));
  binarycut_symb=scm_gc_protect(CAR(intern((char *)"binarycut",9)));
  c_symb=scm_gc_protect(CAR(intern((char *)"c",1)));
  propositional_from_input_symb=scm_gc_protect(CAR(intern((char *)"propositional-from-input",24)));
  _pred__symb=scm_gc_protect(CAR(intern((char *)"?",1)));
  contradiction_symb=scm_gc_protect(CAR(intern((char *)"contradiction",13)));
  _pred__pred__symb=scm_gc_protect(CAR(intern((char *)"??",2)));
  factor_s_symb=scm_gc_protect(CAR(intern((char *)"factor_s",8)));
  hyper_s_symb=scm_gc_protect(CAR(intern((char *)"hyper_s",7)));
  binary_s_symb=scm_gc_protect(CAR(intern((char *)"binary_s",8)));
  old_symb=scm_gc_protect(CAR(intern((char *)"old",3)));
  dummy_symb=scm_gc_protect(CAR(intern((char *)"dummy",5)));
  b_symb=scm_gc_protect(CAR(intern((char *)"b",1)));
  a_symb=scm_gc_protect(CAR(intern((char *)"a",1)));
  g_symb=scm_gc_protect(CAR(intern((char *)"g",1)));
  f_symb=scm_gc_protect(CAR(intern((char *)"f",1)));
  r_symb=scm_gc_protect(CAR(intern((char *)"r",1)));
  p_symb=scm_gc_protect(CAR(intern((char *)"p",1)));
  hastype_symb=scm_gc_protect(CAR(intern((char *)"hastype",7)));
  true_symb=scm_gc_protect(CAR(intern((char *)"true",4)));
  false_symb=scm_gc_protect(CAR(intern((char *)"false",5)));
  _and__symb=scm_gc_protect(CAR(intern((char *)"&",1)));
  _equal__grtr__symb=scm_gc_protect(CAR(intern((char *)"=>",2)));
  __symb=scm_gc_protect(CAR(intern((char *)"-",1)));
  _less__equal__grtr__symb=scm_gc_protect(CAR(intern((char *)"<=>",3)));
  exists_symb=scm_gc_protect(CAR(intern((char *)"exists",6)));
  all_symb=scm_gc_protect(CAR(intern((char *)"all",3)));
  _dot__dot__dot__symb=scm_gc_protect(CAR(intern((char *)"...",3)));
  _dollar__dollar_ans_symb=scm_gc_protect(CAR(intern((char *)"$$ans",5)));
  _dollar__dollar_eq_symb=scm_gc_protect(CAR(intern((char *)"$$eq",4)));
  _dollar__dollar_case_symb=scm_gc_protect(CAR(intern((char *)"$$case",6)));
  _dollar__dollar_if_symb=scm_gc_protect(CAR(intern((char *)"$$if",4)));
  splitpred0_symb=scm_gc_protect(CAR(intern((char *)"splitpred0",10)));
  splitpred1_symb=scm_gc_protect(CAR(intern((char *)"splitpred1",10)));
  _dollar__dollar_inh_symb=scm_gc_protect(CAR(intern((char *)"$$inh",5)));
  _dollar__dollar_idsubst_symb=scm_gc_protect(CAR(intern((char *)"$$idsubst",9)));
  _dollar__dollar_idsubst_prim_symb=scm_gc_protect(CAR(intern((char *)"$$idsubst-prim",14)));
  _dollar__dollar_idrefl_symb=scm_gc_protect(CAR(intern((char *)"$$idrefl",8)));
  _dollar__dollar_lambda_symb=scm_gc_protect(CAR(intern((char *)"$$lambda",8)));
  _dollar__dollar__star__symb=scm_gc_protect(CAR(intern((char *)"$$*",3)));
  lit_demodulators_symb=scm_gc_protect(CAR(intern((char *)"lit-demodulators",16)));
  w_symb=scm_gc_protect(CAR(intern((char *)"w",1)));
  v_symb=scm_gc_protect(CAR(intern((char *)"v",1)));
  u_symb=scm_gc_protect(CAR(intern((char *)"u",1)));
  z_symb=scm_gc_protect(CAR(intern((char *)"z",1)));
  y_symb=scm_gc_protect(CAR(intern((char *)"y",1)));
  ans_symb=scm_gc_protect(CAR(intern((char *)"ans",3)));
  _equal_symb=scm_gc_protect(CAR(intern((char *)"-equal",6)));
  zchaff_symb=scm_gc_protect(CAR(intern((char *)"zchaff",6)));
  const_1=scm_gc_protect(makfromstr((char *)"clauses back-subsumed:",22));
}

SCM init_20_resbase()
{
  const_2=scm_gc_protect(makfromstr((char *)"*",1));
  const_3=scm_gc_protect(makfromstr((char *)"splittable clause: ",19));
  const_4=scm_gc_protect(makfromstr((char *)"the derived clause removed as a tautology",41));
  const_5=scm_gc_protect(makfromstr((char *)"T",1));
  const_6=scm_gc_protect(makfromstr((char *)"Global statistics over all passes: ",35));
  const_7=scm_gc_protect(makfromstr((char *)" given clauses:    ",19));
  const_8=scm_gc_protect(makfromstr((char *)" derived clauses:   ",20));
  const_9=scm_gc_protect(makfromstr((char *)" kept clauses:      ",20));
  const_10=scm_gc_protect(makfromstr((char *)" kept size sum:     ",20));
  const_11=scm_gc_protect(makfromstr((char *)" kept mid-nuclei:   ",20));
  const_12=scm_gc_protect(makfromstr((char *)" kept new demods:   ",20));
  const_13=scm_gc_protect(makfromstr((char *)" forw unit-subs:    ",20));
  const_14=scm_gc_protect(makfromstr((char *)" forw double-subs: ",19));
  const_15=scm_gc_protect(makfromstr((char *)" forw overdouble-subs: ",23));
  const_16=scm_gc_protect(makfromstr((char *)" backward subs:     ",20));
  const_17=scm_gc_protect(makfromstr((char *)" fast unit cutoff:  ",20));
  const_18=scm_gc_protect(makfromstr((char *)" full unit cutoff:  ",20));
  const_19=scm_gc_protect(makfromstr((char *)" dbl  unit cutoff:  ",20));
  const_20=scm_gc_protect(makfromstr((char *)" real runtime    :  ",20));
  const_21=scm_gc_protect(makfromstr((char *)" process. runtime:  ",20));
  const_22=scm_gc_protect(makfromstr((char *)"specific non-discr-tree subsumption statistics: ",48));
  const_23=scm_gc_protect(makfromstr((char *)" tried:           ",18));
  const_24=scm_gc_protect(makfromstr((char *)" length fails:    ",18));
  const_25=scm_gc_protect(makfromstr((char *)" strength fails:  ",18));
  const_26=scm_gc_protect(makfromstr((char *)" predlist fails:  ",18));
  const_27=scm_gc_protect(makfromstr((char *)" aux str. fails:  ",18));
  const_28=scm_gc_protect(makfromstr((char *)" by-lit fails:    ",18));
  const_29=scm_gc_protect(makfromstr((char *)" full subs tried: ",18));
  const_30=scm_gc_protect(makfromstr((char *)" full subs fail:  ",18));
  const_31=scm_gc_protect(makfromstr((char *)".",1));
  const_32=scm_gc_protect(makfromstr((char *)"",0));
  const_33=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_34=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_35=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_36=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_37=scm_gc_protect(makfromstr((char *)"scmlit",6));
  const_38=scm_gc_protect(makfromstr((char *)"scmlit.exe",10));
  const_39=scm_gc_protect(makfromstr((char *)"answer-clause: ",15));
  const_40=scm_gc_protect(makfromstr((char *)"***GANDALF_FOUND_A_REFUTATION***",32));
  const_41=scm_gc_protect(makfromstr((char *)"Clause set found to be **SATISFIABLE** (satisfiable).",53));
  const_42=scm_gc_protect(makfromstr((char *)"time limit exhausted: proof search terminated.",46));
  const_43=scm_gc_protect(makfromstr((char *)"search space exhausted.",23));
  const_44=scm_gc_protect(makfromstr((char *)"clause set was found to be satisfiable (**SATISFIABLE**).",57));
  const_45=scm_gc_protect(makfromstr((char *)"",0));
  const_46=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_47=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_48=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_49=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_50=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_51=scm_gc_protect(makfromstr((char *)"-",1));
}

SCM init_21_resbase()
{
  const_52=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_53=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_54=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_55=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_56=scm_gc_protect(makfromstr((char *)"arguments to quantifier lacking",31));
  const_57=scm_gc_protect(makfromstr((char *)"incorrect bound variable syntax",31));
  const_58=scm_gc_protect(makfromstr((char *)"too many arguments to quantifier",32));
  const_59=scm_gc_protect(makfromstr((char *)"arguments to NOT lacking",24));
  const_60=scm_gc_protect(makfromstr((char *)"incorrect argument to NOT ",26));
  const_61=scm_gc_protect(makfromstr((char *)"connective has too few arguments",32));
  const_62=scm_gc_protect(makfromstr((char *)"connective has too few arguments",32));
  const_63=scm_gc_protect(makfromstr((char *)"period symbol prohibited",24));
  const_64=scm_gc_protect(makfromstr((char *)"Syntax error in input formula (",31));
  const_65=scm_gc_protect(makfromstr((char *)"):",2));
  const_66=scm_gc_protect(makfromstr((char *)"-",1));
  const_67=scm_gc_protect(makfromstr((char *)"lifsch.in",9));
  const_68=scm_gc_protect(makfromstr((char *)"-",1));
  const_69=scm_gc_protect(makfromstr((char *)"-",1));
  const_70=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_71=scm_gc_protect(makfromstr((char *)"syntax error in input file",26));
  const_72=scm_gc_protect(makfromstr((char *)"r",1));
  const_73=scm_gc_protect(makfromstr((char *)"could not open file: ",21));
  const_74=scm_gc_protect(makfromstr((char *)"could not open string for temporary output",42));
  const_75=scm_gc_protect(makfromstr((char *)"Too many predicate symbs in the clause set",42));
  const_76=scm_gc_protect(makfromstr((char *)"Too many function symbs in the clause set",41));
  const_77=scm_gc_protect(makfromstr((char *)"Too many vars in the encountered clause",39));
  const_78=scm_gc_protect(cons(MAKICHR('x'),cons(MAKICHR('y'),cons(MAKICHR('z'),cons(MAKICHR('u'),cons(MAKICHR('v'),cons(MAKICHR('w'),EOL)))))));
  const_79=scm_gc_protect(makfromstr((char *)"resobits: ",10));
  const_80=scm_gc_protect(makfromstr((char *)"factbits: ",10));
  const_81=scm_gc_protect(makfromstr((char *)"parabits: ",10));
  const_82=scm_gc_protect(makfromstr((char *)"EMPTY CLAUSE.",13));
  const_83=scm_gc_protect(makfromstr((char *)" | ",3));
  const_84=scm_gc_protect(makfromstr((char *)"(",1));
  const_85=scm_gc_protect(makfromstr((char *)",",1));
  const_86=scm_gc_protect(makfromstr((char *)")",1));
  const_87=scm_gc_protect(makfromstr((char *)"v",1));
  const_88=scm_gc_protect(makfromstr((char *)"-",1));
  const_89=scm_gc_protect(makfromstr((char *)"v",1));
  const_90=scm_gc_protect(makfromstr((char *)"*unassigned*",12));
  const_91=scm_gc_protect(makfromstr((char *)"'",1));
  const_92=scm_gc_protect(makfromstr((char *)"''",2));
  const_93=scm_gc_protect(makfromstr((char *)"'x",2));
  const_94=scm_gc_protect(makfromstr((char *)"''x",3));
  const_95=scm_gc_protect(makfromstr((char *)"x",1));
  const_96=scm_gc_protect(makfromstr((char *)"xvars and immediate refs and touched/not:",41));
  const_97=scm_gc_protect(makfromstr((char *)" : ",3));
  const_98=scm_gc_protect(makfromstr((char *)" : ",3));
  const_99=scm_gc_protect(makfromstr((char *)"yvars and immediate refs and touched/not:",41));
  const_100=scm_gc_protect(makfromstr((char *)" : ",3));
  const_101=scm_gc_protect(makfromstr((char *)" : ",3));
}

SCM init_22_resbase()
{
  const_102=scm_gc_protect(makfromstr((char *)"zvars and immediate refs:",25));
  const_103=scm_gc_protect(makfromstr((char *)" : ",3));
  const_104=scm_gc_protect(makfromstr((char *)"ERROR: ",7));
  const_105=scm_gc_protect(makfromstr((char *)" ",1));
  const_106=scm_gc_protect(makfromstr((char *)"Using automatic strategy selection.",35));
  const_107=scm_gc_protect(makfromstr((char *)"Using a user-selected strategy.",31));
  const_108=scm_gc_protect(makfromstr((char *)"Time limit in seconds: ",23));
  const_109=scm_gc_protect(makfromstr((char *)"Time limit in seconds: ",23));
  const_110=scm_gc_protect(makfromstr((char *)"Time limit in seconds: none",27));
  const_111=scm_gc_protect(makfromstr((char *)"input demodulators: ",20));
  const_112=scm_gc_protect(makfromstr((char *)"input literal demodulators: ",28));
  const_113=scm_gc_protect(makfromstr((char *)"input sos: ",11));
  const_114=scm_gc_protect(makfromstr((char *)"input usable: ",14));
  const_115=scm_gc_protect(cons(cons(hyper_symb,cons(MAKINUM(3),EOL)),cons(cons(binary_symb,cons(MAKINUM(4),EOL)),EOL)));
  const_116=scm_gc_protect(makfromstr((char *)"starting to make-input-clause on sos:",37));
  const_117=scm_gc_protect(makfromstr((char *)"finished make-input-clause:",27));
  const_118=scm_gc_protect(makfromstr((char *)"Error: no sos-list given.",25));
  const_119=scm_gc_protect(makfromstr((char *)"demodulators: ",14));
  const_120=scm_gc_protect(makfromstr((char *)"demodulators in debug form: ",28));
  const_121=scm_gc_protect(makfromstr((char *)"literal demodulators: ",22));
  const_122=scm_gc_protect(makfromstr((char *)"literal demodulators in debug form: ",36));
  const_123=scm_gc_protect(makfromstr((char *)"clauses in usable: ",19));
  const_124=scm_gc_protect(makfromstr((char *)"usable in debug form: ",22));
  const_125=scm_gc_protect(makfromstr((char *)"clauses in sos: ",16));
  const_126=scm_gc_protect(makfromstr((char *)"sos in debug form: ",19));
  const_127=scm_gc_protect(makfromstr((char *)"prove-all-passes started",24));
  const_128=scm_gc_protect(cons(cons(hyper_symb,cons(MAKINUM(5),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_T,EOL))),cons(cons(binary_unit_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_order_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(binary_nameorder_symb,cons(MAKINUM(10),cons(BOOL_F,EOL))),cons(cons(hyper_order_symb,cons(MAKINUM(30),cons(BOOL_F,EOL))),cons(cons(binary_symb,cons(MAKINUM(30),cons(BOOL_T,EOL))),cons(cons(binary_symb,cons(MAKINUM(50),cons(BOOL_F,EOL))),EOL))))))))));
  const_129=scm_gc_protect(makfromstr((char *)"Starting a split proof attempt with ",36));
  const_130=scm_gc_protect(makfromstr((char *)" components.",12));
  const_131=scm_gc_protect(makfromstr((char *)"Split component ",16));
  const_132=scm_gc_protect(makfromstr((char *)" started.",9));
  const_133=scm_gc_protect(makfromstr((char *)"Split attempt finished with ",28));
  const_134=scm_gc_protect(makfromstr((char *)"FAILURE.",8));
  const_135=scm_gc_protect(makfromstr((char *)"SUCCESS.",8));
  const_136=scm_gc_protect(makfromstr((char *)"START OF PROOFPART",18));
  const_137=scm_gc_protect(makfromstr((char *)"Making new sos for split:",25));
  const_138=scm_gc_protect(makfromstr((char *)"Original clause to be split: ",29));
  const_139=scm_gc_protect(makfromstr((char *)"Split part used next: ",22));
  const_140=scm_gc_protect(makfromstr((char *)"END OF PROOFPART",16));
  const_141=scm_gc_protect(makfromstr((char *)"Orig sos clause for pseudosplit: ",33));
  const_142=scm_gc_protect(makfromstr((char *)"Pseudo-split-input-clause results in: ",38));
  const_143=scm_gc_protect(makfromstr((char *)"SOS clause ",11));
  const_144=scm_gc_protect(makfromstr((char *)"was split for some strategies as: ",34));
  const_145=scm_gc_protect(makfromstr((char *)"new stratlist computed by split strat fun:",42));
  const_146=scm_gc_protect(makfromstr((char *)"Clause set found to be **SATISFIABLE** (satisfiable)",52));
  const_147=scm_gc_protect(makfromstr((char *)"prop search time ran out",24));
  const_148=scm_gc_protect(makfromstr((char *)"***GANDALF_FOUND_A_REFUTATION***",32));
  const_149=scm_gc_protect(makfromstr((char *)"Clause set found to be **SATISFIABLE** (satisfiable)",52));
  const_150=scm_gc_protect(makfromstr((char *)"***GANDALF_FOUND_A_REFUTATION***",32));
  const_151=scm_gc_protect(makfromstr((char *)"***** INCONCLUSIVE RESULT ********",34));
}

SCM init_23_resbase()
{
  const_152=scm_gc_protect(makfromstr((char *)"Clause set found to be **SATISFIABLE** (satisfiable)",52));
  const_153=scm_gc_protect(makfromstr((char *)"Clause set found to be **SATISFIABLE** (satisfiable)",52));
  const_154=scm_gc_protect(makfromstr((char *)"Clause set found to be  **SATISFIABLE** (satisfiable)",53));
  const_155=scm_gc_protect(makfromstr((char *)"Clause set found to be **SATISFIABLE** (satisfiable)",52));
  const_156=scm_gc_protect(makfromstr((char *)"answer-clause: ",15));
  const_157=scm_gc_protect(makfromstr((char *)"Clause set found to be **SATISFIABLE** (satisfiable)",52));
  const_158=scm_gc_protect(makfromstr((char *)"old unit clauses discarded",26));
  const_159=scm_gc_protect(makfromstr((char *)"--------------------",20));
  const_160=scm_gc_protect(makfromstr((char *)"--------------------",20));
  const_161=scm_gc_protect(makfromstr((char *)" ",1));
  const_162=scm_gc_protect(makfromstr((char *)" cnstnr: ",9));
  const_163=scm_gc_protect(makfromstr((char *)" tdepth: ",9));
  const_164=scm_gc_protect(makfromstr((char *)"using propositional strategy",28));
  const_165=scm_gc_protect(makfromstr((char *)"using simple model building",27));
  const_166=scm_gc_protect(makfromstr((char *)"using sem-type model building",29));
  const_167=scm_gc_protect(makfromstr((char *)"solving nofuns-problem with mace-type model building",52));
  const_168=scm_gc_protect(makfromstr((char *)"using mace-type model building",30));
  const_169=scm_gc_protect(makfromstr((char *)"using random model building",27));
  const_170=scm_gc_protect(makfromstr((char *)"using hyperresolution",21));
  const_171=scm_gc_protect(makfromstr((char *)"using binary resolution",23));
  const_172=scm_gc_protect(makfromstr((char *)"using satisfiability checking strategy",38));
  const_173=scm_gc_protect(makfromstr((char *)"using delayed iteration on clause size",38));
  const_174=scm_gc_protect(makfromstr((char *)"using term-depth-order strategy",31));
  const_175=scm_gc_protect(makfromstr((char *)"using first neg lit preferred strategy",38));
  const_176=scm_gc_protect(makfromstr((char *)"using weight-order strategy",27));
  const_177=scm_gc_protect(makfromstr((char *)"using sos version of order strategy",35));
  const_178=scm_gc_protect(makfromstr((char *)"using pred-name-order strategy",30));
  const_179=scm_gc_protect(makfromstr((char *)"using experimental ordering strategy",36));
  const_180=scm_gc_protect(makfromstr((char *)"using sos strategy",18));
  const_181=scm_gc_protect(makfromstr((char *)"not using sos strategy",22));
  const_182=scm_gc_protect(makfromstr((char *)"using positive unit paramodulation strategy",43));
  const_183=scm_gc_protect(makfromstr((char *)"using unit paramodulation strategy",34));
  const_184=scm_gc_protect(makfromstr((char *)"using unit strategy",19));
  const_185=scm_gc_protect(makfromstr((char *)"using double strategy",21));
  const_186=scm_gc_protect(makfromstr((char *)"using dynamic demodulation",26));
  const_187=scm_gc_protect(makfromstr((char *)"using unit equality specials",28));
  const_188=scm_gc_protect(makfromstr((char *)"limiting paramodulation to term root",36));
  const_189=scm_gc_protect(makfromstr((char *)"using back demodulation",23));
  const_190=scm_gc_protect(makfromstr((char *)"using ordered paramodulation",28));
  const_191=scm_gc_protect(makfromstr((char *)"using kb ordering for equality",30));
  const_192=scm_gc_protect(makfromstr((char *)"using lex ordering for equality",31));
  const_193=scm_gc_protect(makfromstr((char *)"using first arg depth ordering for equality",43));
  const_194=scm_gc_protect(makfromstr((char *)"preferring bigger arities for lex ordering",42));
  const_195=scm_gc_protect(makfromstr((char *)"preferring smaller arities for lex ordering",43));
  const_196=scm_gc_protect(makfromstr((char *)"using clause demodulation",25));
  const_197=scm_gc_protect(makfromstr((char *)"clause length limited to ",25));
  const_198=scm_gc_protect(makfromstr((char *)"clause size limited to ",23));
  const_199=scm_gc_protect(makfromstr((char *)"clause depth limited to ",24));
  const_200=scm_gc_protect(makfromstr((char *)"clause size limited (after delay) to ",37));
  const_201=scm_gc_protect(makfromstr((char *)"initial sos preference ratio is ",32));
}

SCM init_24_resbase()
{
  const_202=scm_gc_protect(makfromstr((char *)"seconds given: ",15));
  const_203=scm_gc_protect(makfromstr((char *)"strategies selected: ",21));
  const_204=scm_gc_protect(makfromstr((char *)"using equality",14));
  const_205=scm_gc_protect(makfromstr((char *)"not using equality",18));
  const_206=scm_gc_protect(makfromstr((char *)"========= stats concerning the input clauses: =========",55));
  const_207=scm_gc_protect(makfromstr((char *)"*input-lit-nr* ",15));
  const_208=scm_gc_protect(makfromstr((char *)"*input-eqlit-nr* ",17));
  const_209=scm_gc_protect(makfromstr((char *)"*input-cl-nr* ",14));
  const_210=scm_gc_protect(makfromstr((char *)"*input-unitcl-nr* ",18));
  const_211=scm_gc_protect(makfromstr((char *)"*input-negcl-nr* ",17));
  const_212=scm_gc_protect(makfromstr((char *)"*input-poscl-nr* ",17));
  const_213=scm_gc_protect(makfromstr((char *)"*input-mixcl-nr* ",17));
  const_214=scm_gc_protect(makfromstr((char *)"*input-horncl-nr* ",18));
  const_215=scm_gc_protect(makfromstr((char *)"*input-invhorncl-nr* ",21));
  const_216=scm_gc_protect(makfromstr((char *)"*input-negdhorncl-nr* ",22));
  const_217=scm_gc_protect(makfromstr((char *)"*input-wellorderedcl-nr* ",25));
  const_218=scm_gc_protect(makfromstr((char *)"*input-wellhyper-nr* ",21));
  const_219=scm_gc_protect(makfromstr((char *)"*input-somewhat-ordered-nr* ",28));
  const_220=scm_gc_protect(makfromstr((char *)"*input-maxlen-nr* ",18));
  const_221=scm_gc_protect(makfromstr((char *)"*input-maxlen-nonground-nr* ",28));
  const_222=scm_gc_protect(makfromstr((char *)"*input-maxdepth-nr* ",20));
  const_223=scm_gc_protect(makfromstr((char *)"*input-contains-eq* ",20));
  const_224=scm_gc_protect(makfromstr((char *)"=======================",23));
  const_225=scm_gc_protect(makfromstr((char *)"detected problem class: sat",27));
  const_226=scm_gc_protect(makfromstr((char *)"detected subclass: epr",22));
  const_227=scm_gc_protect(makfromstr((char *)"detected subclass: sat with eq",30));
  const_228=scm_gc_protect(makfromstr((char *)"detected subclass: sat without eq",33));
  const_229=scm_gc_protect(makfromstr((char *)"detected problem class: neq",27));
  const_230=scm_gc_protect(makfromstr((char *)"detected subclass: big",22));
  const_231=scm_gc_protect(makfromstr((char *)"detected subclass: medium",25));
  const_232=scm_gc_protect(makfromstr((char *)"detected subclass: small",24));
  const_233=scm_gc_protect(makfromstr((char *)"detected problem class: nne",27));
  const_234=scm_gc_protect(makfromstr((char *)"detected subclass: big",22));
  const_235=scm_gc_protect(makfromstr((char *)"detected subclass: medium",25));
  const_236=scm_gc_protect(makfromstr((char *)"detected subclass: small",24));
  const_237=scm_gc_protect(makfromstr((char *)"detected problem class: heq",27));
  const_238=scm_gc_protect(makfromstr((char *)"detected subclass: big",22));
  const_239=scm_gc_protect(makfromstr((char *)"detected subclass: long",23));
  const_240=scm_gc_protect(makfromstr((char *)"detected subclass: short",24));
  const_241=scm_gc_protect(makfromstr((char *)"detected subclass: medium",25));
  const_242=scm_gc_protect(makfromstr((char *)"detected subclass: long",23));
  const_243=scm_gc_protect(makfromstr((char *)"detected subclass: short",24));
  const_244=scm_gc_protect(makfromstr((char *)"detected subclass: small",24));
  const_245=scm_gc_protect(makfromstr((char *)"detected subclass: long",23));
  const_246=scm_gc_protect(makfromstr((char *)"detected subclass: short",24));
  const_247=scm_gc_protect(makfromstr((char *)"detected problem class: hne",27));
  const_248=scm_gc_protect(makfromstr((char *)"detected subclass: big",22));
  const_249=scm_gc_protect(makfromstr((char *)"detected subclass: long",23));
  const_250=scm_gc_protect(makfromstr((char *)"detected subclass: short",24));
  const_251=scm_gc_protect(makfromstr((char *)"detected subclass: medium",25));
}

SCM init_25_resbase()
{
  const_252=scm_gc_protect(makfromstr((char *)"detected subclass: long",23));
  const_253=scm_gc_protect(makfromstr((char *)"detected subclass: short",24));
  const_254=scm_gc_protect(makfromstr((char *)"detected subclass: small",24));
  const_255=scm_gc_protect(makfromstr((char *)"detected subclass: long",23));
  const_256=scm_gc_protect(makfromstr((char *)"detected subclass: short",24));
  const_257=scm_gc_protect(makfromstr((char *)"detected problem class: peq",27));
  const_258=scm_gc_protect(makfromstr((char *)"detected problem class: ueq",27));
  const_259=scm_gc_protect(makfromstr((char *)"|",1));
  const_260=scm_gc_protect(makfromstr((char *)"Some predicates or functions were curried and renamed.",54));
  const_261=scm_gc_protect(cons(sos_symb,cons(usable_symb,EOL)));
  const_262=scm_gc_protect(cons(cons(_dollar_ganappred1_symb,MAKINUM(1)),cons(cons(_dollar_ganappred2_symb,MAKINUM(2)),cons(cons(_dollar_ganappred3_symb,MAKINUM(3)),cons(cons(_dollar_ganappred4_symb,MAKINUM(4)),cons(cons(_dollar_ganappred5_symb,MAKINUM(5)),cons(cons(_dollar_ganappred6_symb,MAKINUM(6)),cons(cons(_dollar_ganappred7_symb,MAKINUM(7)),cons(cons(_dollar_ganappred8_symb,MAKINUM(8)),cons(cons(_dollar_ganappred9_symb,MAKINUM(9)),cons(cons(_dollar_ganappred10_symb,MAKINUM(10)),cons(cons(_dollar_ganappred11_symb,MAKINUM(11)),cons(cons(_dollar_ganappred12_symb,MAKINUM(12)),cons(cons(_dollar_ganappred13_symb,MAKINUM(13)),cons(cons(_dollar_ganappred14_symb,MAKINUM(14)),cons(cons(_dollar_ganappred15_symb,MAKINUM(15)),cons(cons(_dollar_ganappred16_symb,MAKINUM(16)),cons(cons(_dollar_ganappred17_symb,MAKINUM(17)),cons(cons(_dollar_ganappred18_symb,MAKINUM(18)),cons(cons(_dollar_ganappred19_symb,MAKINUM(19)),cons(cons(_dollar_ganappred20_symb,MAKINUM(20)),cons(cons(_dollar_ganappred21_symb,MAKINUM(21)),cons(cons(_dollar_ganappred22_symb,MAKINUM(22)),cons(cons(_dollar_ganappred23_symb,MAKINUM(23)),cons(cons(_dollar_ganappred24_symb,MAKINUM(24)),cons(cons(_dollar_ganappred25_symb,MAKINUM(25)),cons(cons(_dollar_ganappred26_symb,MAKINUM(26)),cons(cons(_dollar_ganappred27_symb,MAKINUM(27)),cons(cons(_dollar_ganappred28_symb,MAKINUM(28)),cons(cons(_dollar_ganappred29_symb,MAKINUM(29)),cons(cons(_dollar_ganappred30_symb,MAKINUM(30)),cons(cons(_dollar_ganappred31_symb,MAKINUM(31)),cons(cons(_dollar_ganappred32_symb,MAKINUM(32)),cons(cons(_dollar_ganappred33_symb,MAKINUM(33)),cons(cons(_dollar_ganappred34_symb,MAKINUM(34)),cons(cons(_dollar_ganappred35_symb,MAKINUM(35)),cons(cons(_dollar_ganappred36_symb,MAKINUM(36)),cons(cons(_dollar_ganappred37_symb,MAKINUM(37)),cons(cons(_dollar_ganappred38_symb,MAKINUM(38)),cons(cons(_dollar_ganappred39_symb,MAKINUM(39)),cons(cons(_dollar_ganappred40_symb,MAKINUM(40)),cons(cons(_dollar_ganappred41_symb,MAKINUM(41)),cons(cons(_dollar_ganappred42_symb,MAKINUM(42)),cons(cons(_dollar_ganappred43_symb,MAKINUM(43)),cons(cons(_dollar_ganappred44_symb,MAKINUM(44)),cons(cons(_dollar_ganappred45_symb,MAKINUM(45)),cons(cons(_dollar_ganappred46_symb,MAKINUM(46)),cons(cons(_dollar_ganappred47_symb,MAKINUM(47)),cons(cons(_dollar_ganappred48_symb,MAKINUM(48)),cons(cons(_dollar_ganappred49_symb,MAKINUM(49)),cons(cons(_dollar_ganappred50_symb,MAKINUM(50)),cons(cons(_dollar_ganappred51_symb,MAKINUM(51)),cons(cons(_dollar_ganappred52_symb,MAKINUM(52)),cons(cons(_dollar_ganappred53_symb,MAKINUM(53)),cons(cons(_dollar_ganappred54_symb,MAKINUM(54)),cons(cons(_dollar_ganappred55_symb,MAKINUM(55)),cons(cons(_dollar_ganappred56_symb,MAKINUM(56)),cons(cons(_dollar_ganappred57_symb,MAKINUM(57)),cons(cons(_dollar_ganappred58_symb,MAKINUM(58)),cons(cons(_dollar_ganappred59_symb,MAKINUM(59)),cons(cons(_dollar_ganappred60_symb,MAKINUM(60)),cons(cons(_dollar_ganappred61_symb,MAKINUM(61)),cons(cons(_dollar_ganappred62_symb,MAKINUM(62)),cons(cons(_dollar_ganappred63_symb,MAKINUM(63)),cons(cons(_dollar_ganappred64_symb,MAKINUM(64)),cons(cons(_dollar_ganappred65_symb,MAKINUM(65)),cons(cons(_dollar_ganappred66_symb,MAKINUM(66)),cons(cons(_dollar_ganappred67_symb,MAKINUM(67)),cons(cons(_dollar_ganappred68_symb,MAKINUM(68)),cons(cons(_dollar_ganappred69_symb,MAKINUM(69)),cons(cons(_dollar_ganappred70_symb,MAKINUM(70)),EOL)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
  const_263=scm_gc_protect(cons(cons(_dollar_ganapfun1_symb,MAKINUM(1)),cons(cons(_dollar_ganapfun2_symb,MAKINUM(2)),cons(cons(_dollar_ganapfun3_symb,MAKINUM(3)),cons(cons(_dollar_ganapfun4_symb,MAKINUM(4)),cons(cons(_dollar_ganapfun5_symb,MAKINUM(5)),cons(cons(_dollar_ganapfun6_symb,MAKINUM(6)),cons(cons(_dollar_ganapfun7_symb,MAKINUM(7)),cons(cons(_dollar_ganapfun8_symb,MAKINUM(8)),cons(cons(_dollar_ganapfun9_symb,MAKINUM(9)),cons(cons(_dollar_ganapfun10_symb,MAKINUM(10)),cons(cons(_dollar_ganapfun11_symb,MAKINUM(11)),cons(cons(_dollar_ganapfun12_symb,MAKINUM(12)),cons(cons(_dollar_ganapfun13_symb,MAKINUM(13)),cons(cons(_dollar_ganapfun14_symb,MAKINUM(14)),cons(cons(_dollar_ganapfun15_symb,MAKINUM(15)),cons(cons(_dollar_ganapfun16_symb,MAKINUM(16)),cons(cons(_dollar_ganapfun17_symb,MAKINUM(17)),cons(cons(_dollar_ganapfun18_symb,MAKINUM(18)),cons(cons(_dollar_ganapfun19_symb,MAKINUM(19)),cons(cons(_dollar_ganapfun20_symb,MAKINUM(20)),cons(cons(_dollar_ganapfun21_symb,MAKINUM(21)),cons(cons(_dollar_ganapfun22_symb,MAKINUM(22)),cons(cons(_dollar_ganapfun23_symb,MAKINUM(23)),cons(cons(_dollar_ganapfun24_symb,MAKINUM(24)),cons(cons(_dollar_ganapfun25_symb,MAKINUM(25)),cons(cons(_dollar_ganapfun26_symb,MAKINUM(26)),cons(cons(_dollar_ganapfun27_symb,MAKINUM(27)),cons(cons(_dollar_ganapfun28_symb,MAKINUM(28)),cons(cons(_dollar_ganapfun29_symb,MAKINUM(29)),cons(cons(_dollar_ganapfun30_symb,MAKINUM(30)),cons(cons(_dollar_ganapfun31_symb,MAKINUM(31)),cons(cons(_dollar_ganapfun32_symb,MAKINUM(32)),cons(cons(_dollar_ganapfun33_symb,MAKINUM(33)),cons(cons(_dollar_ganapfun34_symb,MAKINUM(34)),cons(cons(_dollar_ganapfun35_symb,MAKINUM(35)),cons(cons(_dollar_ganapfun36_symb,MAKINUM(36)),cons(cons(_dollar_ganapfun37_symb,MAKINUM(37)),cons(cons(_dollar_ganapfun38_symb,MAKINUM(38)),cons(cons(_dollar_ganapfun39_symb,MAKINUM(39)),cons(cons(_dollar_ganapfun40_symb,MAKINUM(40)),cons(cons(_dollar_ganapfun41_symb,MAKINUM(41)),cons(cons(_dollar_ganapfun42_symb,MAKINUM(42)),cons(cons(_dollar_ganapfun43_symb,MAKINUM(43)),cons(cons(_dollar_ganapfun44_symb,MAKINUM(44)),cons(cons(_dollar_ganapfun45_symb,MAKINUM(45)),cons(cons(_dollar_ganapfun46_symb,MAKINUM(46)),cons(cons(_dollar_ganapfun47_symb,MAKINUM(47)),cons(cons(_dollar_ganapfun48_symb,MAKINUM(48)),cons(cons(_dollar_ganapfun49_symb,MAKINUM(49)),cons(cons(_dollar_ganapfun50_symb,MAKINUM(50)),cons(cons(_dollar_ganapfun51_symb,MAKINUM(51)),cons(cons(_dollar_ganapfun52_symb,MAKINUM(52)),cons(cons(_dollar_ganapfun53_symb,MAKINUM(53)),cons(cons(_dollar_ganapfun54_symb,MAKINUM(54)),cons(cons(_dollar_ganapfun55_symb,MAKINUM(55)),cons(cons(_dollar_ganapfun56_symb,MAKINUM(56)),cons(cons(_dollar_ganapfun57_symb,MAKINUM(57)),cons(cons(_dollar_ganapfun58_symb,MAKINUM(58)),cons(cons(_dollar_ganapfun59_symb,MAKINUM(59)),cons(cons(_dollar_ganapfun60_symb,MAKINUM(60)),cons(cons(_dollar_ganapfun61_symb,MAKINUM(61)),cons(cons(_dollar_ganapfun62_symb,MAKINUM(62)),cons(cons(_dollar_ganapfun63_symb,MAKINUM(63)),cons(cons(_dollar_ganapfun64_symb,MAKINUM(64)),cons(cons(_dollar_ganapfun65_symb,MAKINUM(65)),cons(cons(_dollar_ganapfun66_symb,MAKINUM(66)),cons(cons(_dollar_ganapfun67_symb,MAKINUM(67)),cons(cons(_dollar_ganapfun68_symb,MAKINUM(68)),cons(cons(_dollar_ganapfun69_symb,MAKINUM(69)),cons(cons(_dollar_ganapfun70_symb,MAKINUM(70)),EOL)))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
  const_264=scm_gc_protect(makfromstr((char *)"Too many predicates with too many arguments.",44));
  const_265=scm_gc_protect(makfromstr((char *)"Too many predicates with too many arguments.",44));
  const_266=scm_gc_protect(makfromstr((char *)"-",1));
  const_267=scm_gc_protect(makfromstr((char *)"Too many functions with too many arguments.",43));
  const_268=scm_gc_protect(makfromstr((char *)"Too many functions with too many arguments.",43));
  const_269=scm_gc_protect(makfromstr((char *)"$ganc",5));
  const_270=scm_gc_protect(makfromstr((char *)"Some ground terms were converted.",33));
  const_271=scm_gc_protect(cons(sos_symb,cons(usable_symb,EOL)));
  const_272=scm_gc_protect(makfromstr((char *)"$gnew",5));
  const_273=scm_gc_protect(makfromstr((char *)"gandalf",7));
  const_274=scm_gc_protect(makfromstr((char *)"--------------------------",26));
  const_275=scm_gc_protect(makfromstr((char *)"*sos-clauses-list*:",19));
  const_276=scm_gc_protect(makfromstr((char *)"*usable-clauses-list*:",22));
  const_277=scm_gc_protect(makfromstr((char *)"tst.in",6));
  const_278=scm_gc_protect(makfromstr((char *)"tst.in",6));
  const_279=scm_gc_protect(makfromstr((char *)"tst0.in",7));
  const_280=scm_gc_protect(makfromstr((char *)"r",1));
  const_281=scm_gc_protect(makfromstr((char *)"list was read in, length: ",26));
  const_282=scm_gc_protect(makfromstr((char *)"list analysed fully",19));
  const_283=scm_gc_protect(makfromstr((char *)"nr:",3));
  const_284=scm_gc_protect(makfromstr((char *)"literals:",9));
  const_285=scm_gc_protect(makfromstr((char *)"clauses:",8));
  const_286=scm_gc_protect(makfromstr((char *)"p cnf ",6));
  const_287=scm_gc_protect(makfromstr((char *)" ",1));
  const_288=scm_gc_protect(makfromstr((char *)" ",1));
  const_289=scm_gc_protect(makfromstr((char *)"0",1));
  const_290=scm_gc_protect(makfromstr((char *)"!!!!!!! ",8));
  const_291=scm_gc_protect(makfromstr((char *)"!!!!!!! ",8));
  const_292=scm_gc_protect(makfromstr((char *)"switching to mixed prefer-short strategy",40));
  const_293=scm_gc_protect(makfromstr((char *)"switching to pure prefer-short strategy",39));
  const_294=scm_gc_protect(makfromstr((char *)"switching to hyper-sos strategy",31));
  const_295=scm_gc_protect(makfromstr((char *)"switching to unit restriction, pure short pref",46));
  const_296=scm_gc_protect(makfromstr((char *)"switching to backward hyper-analysis",36));
  const_297=scm_gc_protect(makfromstr((char *)"switching to full hyper-contradiction-check",43));
  const_298=scm_gc_protect(makfromstr((char *)"continuing search with hyper-contradiction-check",48));
  const_299=scm_gc_protect(makfromstr((char *)"******* ",8));
  const_300=scm_gc_protect(makfromstr((char *)"-th given clause: ",18));
  const_301=scm_gc_protect(makfromstr((char *)"distance: ",10));
}

SCM init_26_resbase()
{
  const_302=scm_gc_protect(makfromstr((char *)"kept size sum: ",15));
  const_303=scm_gc_protect(makfromstr((char *)"++++++ given clause in debug form: ",35));
  const_304=scm_gc_protect(makfromstr((char *)"proof attempt stopped: time limit",33));
  const_305=scm_gc_protect(makfromstr((char *)"proof attempt stopped: sos exhausted",36));
  const_306=scm_gc_protect(cons(cons(cons(MAKINUM(0),EOL),EOL),EOL));
  const_307=scm_gc_protect(makfromstr((char *)"Given cl candidate ",19));
  const_308=scm_gc_protect(makfromstr((char *)" is subsumed by ",16));
  const_309=scm_gc_protect(makfromstr((char *)"...... usable clause in pure form: ",35));
  const_310=scm_gc_protect(makfromstr((char *)",,,,,, usable  clause in debug form: ",37));
  const_311=scm_gc_protect(makfromstr((char *)"two-clause-binres-loop entered",30));
  const_312=scm_gc_protect(makfromstr((char *)"raw cl by binary; parents: ",27));
  const_313=scm_gc_protect(makfromstr((char *)"raw cl by binary; parents: ",27));
  const_314=scm_gc_protect(makfromstr((char *)"vars after one-step res:",24));
  const_315=scm_gc_protect(makfromstr((char *)"raw prepcl by hyper: parents: ",30));
  const_316=scm_gc_protect(makfromstr((char *)"raw clause derived by param; ",29));
  const_317=scm_gc_protect(makfromstr((char *)"to and from parents, fromlit:",29));
  const_318=scm_gc_protect(makfromstr((char *)"handle-derived-inf-cl-pair entered with:",40));
  const_319=scm_gc_protect(makfromstr((char *)"fac-gen-flag: ",14));
  const_320=scm_gc_protect(makfromstr((char *)"distance: ",10));
  const_321=scm_gc_protect(makfromstr((char *)"********* EMPTY CLAUSE DERIVED *********",40));
  const_322=scm_gc_protect(makfromstr((char *)"after exiting unit-handle-cl!:",30));
  const_323=scm_gc_protect(makfromstr((char *)"removed for failing user limits",31));
  const_324=scm_gc_protect(makfromstr((char *)"********* EMPTY CLAUSE DERIVED *********",40));
  const_325=scm_gc_protect(makfromstr((char *)"derived clause nr ",18));
  const_326=scm_gc_protect(makfromstr((char *)" after 2-nd order deco:",23));
  const_327=scm_gc_protect(makfromstr((char *)"**** EMPTY CLAUSE DERIVED ****",30));
  const_328=scm_gc_protect(makfromstr((char *)"**** EMPTY CLAUSE DERIVED ****",30));
  const_329=scm_gc_protect(makfromstr((char *)"By given clause simplification.",31));
  const_330=scm_gc_protect(makfromstr((char *)"remaining part of nucleon in pure form:",39));
  const_331=scm_gc_protect(makfromstr((char *)"kept clause in debug form:",26));
  const_332=scm_gc_protect(makfromstr((char *)"kept clause in pure form:",25));
  const_333=scm_gc_protect(makfromstr((char *)"kept clause in debug form:",26));
  const_334=scm_gc_protect(makfromstr((char *)"demodulator in debug form:",26));
  const_335=scm_gc_protect(cons(EOL,EOL));
  const_336=scm_gc_protect(makfromstr((char *)"splittable clause: ",19));
  const_337=scm_gc_protect(makfromstr((char *)"back-demodulate-usable started",30));
  const_338=scm_gc_protect(makfromstr((char *)"back-demodulate-usable ended",28));
  const_339=scm_gc_protect(makfromstr((char *)"back-demodulation parent: ",26));
  const_340=scm_gc_protect(makfromstr((char *)"back-demodulation result: ",26));
  const_341=scm_gc_protect(makfromstr((char *)"used demodulators: ",19));
  const_342=scm_gc_protect(makfromstr((char *)"backdemod result in debug form:",31));
  const_343=scm_gc_protect(makfromstr((char *)"raw cl by literal demodulation -  parent, demodulators, result: ",64));
  const_344=scm_gc_protect(makfromstr((char *)"******* starting to factor input sos ******",43));
  const_345=scm_gc_protect(makfromstr((char *)"******* input sos has been factored ******",42));
  const_346=scm_gc_protect(cons(EOL,BOOL_F));
  const_347=scm_gc_protect(cons(EOL,BOOL_F));
  const_348=scm_gc_protect(cons(EOL,BOOL_F));
  const_349=scm_gc_protect(cons(EOL,BOOL_F));
  const_350=scm_gc_protect(makfromstr((char *)"the derived clause subsumed by unit:",36));
  const_351=scm_gc_protect(makfromstr((char *)"_",1));
}

SCM init_27_resbase()
{
  const_352=scm_gc_protect(makfromstr((char *)"discr tree used for unit cutoff:",32));
  const_353=scm_gc_protect(makfromstr((char *)"starting resolve-unify-cutoff with:",35));
  const_354=scm_gc_protect(makfromstr((char *)":",1));
  const_355=scm_gc_protect(makfromstr((char *)" ",1));
  const_356=scm_gc_protect(makfromstr((char *)":",1));
  const_357=scm_gc_protect(makfromstr((char *)" ",1));
  const_358=scm_gc_protect(makfromstr((char *)"proper unit cutoff with the following unit(s):",46));
  const_359=scm_gc_protect(makfromstr((char *)"double cutoff with the following cls:",37));
  const_360=scm_gc_protect(cons(BOOL_F,cons(BOOL_F,EOL)));
  const_361=scm_gc_protect(makfromstr((char *)"order-equality-litinfo-lex ended",32));
  const_362=scm_gc_protect(makfromstr((char *)"check Y2",8));
  const_363=scm_gc_protect(makfromstr((char *)"timer checkpoints: ",19));
  const_364=scm_gc_protect(makfromstr((char *)"START OF PROOF",14));
  const_365=scm_gc_protect(makfromstr((char *)"END OF PROOF",12));
  const_366=scm_gc_protect(makfromstr((char *)"Proof found by the following strategy:",38));
  const_367=scm_gc_protect(makfromstr((char *)" [",2));
  const_368=scm_gc_protect(makfromstr((char *)"] ",2));
  const_369=scm_gc_protect(makfromstr((char *)"para:",5));
  const_370=scm_gc_protect(makfromstr((char *)".1",2));
  const_371=scm_gc_protect(makfromstr((char *)".2",2));
  const_372=scm_gc_protect(makfromstr((char *)",",1));
  const_373=scm_gc_protect(makfromstr((char *)".",1));
  const_374=scm_gc_protect(makfromstr((char *)",",1));
  const_375=scm_gc_protect(makfromstr((char *)":",1));
  const_376=scm_gc_protect(makfromstr((char *)",",1));
  const_377=scm_gc_protect(makfromstr((char *)",",1));
  const_378=scm_gc_protect(makfromstr((char *)",",1));
  const_379=scm_gc_protect(makfromstr((char *)".",1));
  const_380=scm_gc_protect(cons(_pred__symb,EOL));
  const_381=scm_gc_protect(makfromstr((char *)"timer checkpoints: ",19));
  const_382=scm_gc_protect(makfromstr((char *)" [",2));
  const_383=scm_gc_protect(makfromstr((char *)"] ",2));
  const_384=scm_gc_protect(makfromstr((char *)"contradiction.",14));
  const_385=scm_gc_protect(makfromstr((char *)",",1));
  const_386=scm_gc_protect(makfromstr((char *)",",1));
  const_387=scm_gc_protect(makfromstr((char *)",",1));
  const_388=scm_gc_protect(makfromstr((char *)".",1));
  const_389=scm_gc_protect(makfromstr((char *)"unknown history-constructor: ",29));
  const_390=scm_gc_protect(makfromstr((char *)"by ",3));
  const_391=scm_gc_protect(makfromstr((char *)" from ",6));
  const_392=scm_gc_protect(makfromstr((char *)" with ",6));
  const_393=scm_gc_protect(makfromstr((char *)"by binary from ",15));
  const_394=scm_gc_protect(makfromstr((char *)" and ",5));
  const_395=scm_gc_protect(makfromstr((char *)"by para from ",13));
  const_396=scm_gc_protect(makfromstr((char *)" into ",6));
  const_397=scm_gc_protect(makfromstr((char *)" at place ",10));
  const_398=scm_gc_protect(makfromstr((char *)"by factor from ",15));
  const_399=scm_gc_protect(makfromstr((char *)" literals ",10));
  const_400=scm_gc_protect(makfromstr((char *)"by binary demod from ",21));
  const_401=scm_gc_protect(makfromstr((char *)"input: ",7));
}

SCM init_28_resbase()
{
  const_402=scm_gc_protect(makfromstr((char *)": ",2));
  const_403=scm_gc_protect(makfromstr((char *)"unknown history-constructor: ",29));
  const_404=scm_gc_protect(makfromstr((char *)" we get:",8));
  const_405=scm_gc_protect(makfromstr((char *)": ",2));
  const_406=scm_gc_protect(makfromstr((char *)"input clause not found: ",24));
  const_407=scm_gc_protect(makfromstr((char *)"cannot unify for paramodulation:",32));
  const_408=scm_gc_protect(makfromstr((char *)"cannot unify for paramodulation:",32));
  const_409=scm_gc_protect(makfromstr((char *)"unification during answer-construction failed:",46));
  const_410=scm_gc_protect(makfromstr((char *)"hyper-contradiction? entered: ",30));
  const_411=scm_gc_protect(makfromstr((char *)"full-hyper-contradiction? entered: ",35));
  const_412=scm_gc_protect(makfromstr((char *)"$spltprd0",9));
  const_413=scm_gc_protect(makfromstr((char *)"$spltprd1",9));
  const_414=scm_gc_protect(makfromstr((char *)"$spltprd0",9));
  const_415=scm_gc_protect(makfromstr((char *)"$spltprd1",9));
  const_416=scm_gc_protect(makfromstr((char *)"$spltcnst",9));
  const_417=scm_gc_protect(makfromstr((char *)"Splitting created too many predicate symbs in the clause set",60));
  const_418=scm_gc_protect(makfromstr((char *)"error in sos splitting, aborting!",33));
  const_419=scm_gc_protect(makfromstr((char *)"splittable clause: ",19));
  const_420=scm_gc_protect(makfromstr((char *)"splitting preres is: ",21));
  const_421=scm_gc_protect(makfromstr((char *)"no function symbols, starting search for domain size ",53));
  const_422=scm_gc_protect(makfromstr((char *)"allocated model search time has run out",39));
  const_423=scm_gc_protect(makfromstr((char *)"starting search for domain size ",32));
  const_424=scm_gc_protect(makfromstr((char *)"*prop-interp-value-pairs*: ",27));
  const_425=scm_gc_protect(makfromstr((char *)"*prop-constants-mapping*: ",26));
  const_426=scm_gc_protect(makfromstr((char *)"*prop-fun-mappings*: ",21));
  const_427=scm_gc_protect(makfromstr((char *)"*prop-lit-mappings*: ",21));
  const_428=scm_gc_protect(makfromstr((char *)"*prop-atom-maxnr*: ",19));
  const_429=scm_gc_protect(makfromstr((char *)"allocated model search time has run out",39));
  const_430=scm_gc_protect(makfromstr((char *)"mace-style model building with nonground splitting starts.",58));
  const_431=scm_gc_protect(makfromstr((char *)"starting search for domain size ",32));
  const_432=scm_gc_protect(makfromstr((char *)"*prop-interp-value-pairs*: ",27));
  const_433=scm_gc_protect(makfromstr((char *)"*prop-constants-mapping*: ",26));
  const_434=scm_gc_protect(makfromstr((char *)"*prop-fun-mappings*: ",21));
  const_435=scm_gc_protect(makfromstr((char *)"*prop-lit-mappings*: ",21));
  const_436=scm_gc_protect(makfromstr((char *)"*prop-atom-maxnr*: ",19));
  const_437=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_438=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_439=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_440=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_441=scm_gc_protect(makfromstr((char *)"allocated model search time has run out",39));
  const_442=scm_gc_protect(makfromstr((char *)"domain size: ",13));
  const_443=scm_gc_protect(makfromstr((char *)"*prop-interp-value-pairs*: ",27));
  const_444=scm_gc_protect(makfromstr((char *)"*prop-constants-mapping*: ",26));
  const_445=scm_gc_protect(makfromstr((char *)"*prop-fun-mappings*: ",21));
  const_446=scm_gc_protect(makfromstr((char *)"*prop-lit-mappings*: ",21));
  const_447=scm_gc_protect(makfromstr((char *)"*prop-atom-maxnr*: ",19));
  const_448=scm_gc_protect(makfromstr((char *)"Instance satisfiable",20));
  const_449=scm_gc_protect(makfromstr((char *)"Instance unsatisfiable",22));
  const_450=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_451=scm_gc_protect(makfromstr((char *)"rm ",3));
}

SCM init_29_resbase()
{
  const_452=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_453=scm_gc_protect(makfromstr((char *)"rm ",3));
  const_454=scm_gc_protect(makfromstr((char *)"starting search for domain size ",32));
  const_455=scm_gc_protect(makfromstr((char *)"*prop-interp-value-pairs*: ",27));
  const_456=scm_gc_protect(makfromstr((char *)"*prop-constants-mapping*: ",26));
  const_457=scm_gc_protect(makfromstr((char *)"*prop-fun-mappings*: ",21));
  const_458=scm_gc_protect(makfromstr((char *)"*prop-lit-mappings*: ",21));
  const_459=scm_gc_protect(makfromstr((char *)"*prop-atom-maxnr*: ",19));
  const_460=scm_gc_protect(makfromstr((char *)"allocated model search time has run out",39));
  const_461=scm_gc_protect(makfromstr((char *)"no function symbols, starting search for domain size ",53));
  const_462=scm_gc_protect(makfromstr((char *)"allocated model search time has run out",39));
  const_463=scm_gc_protect(makfromstr((char *)"-------------------------------------",37));
  const_464=scm_gc_protect(makfromstr((char *)"starting search for domain size ",32));
  const_465=scm_gc_protect(makfromstr((char *)"-------------------------------------",37));
  const_466=scm_gc_protect(makfromstr((char *)"*prop-interp-value-pairs*: ",27));
  const_467=scm_gc_protect(makfromstr((char *)"*prop-constants-mapping*: ",26));
  const_468=scm_gc_protect(makfromstr((char *)"*prop-fun-mappings*: ",21));
  const_469=scm_gc_protect(makfromstr((char *)"*prop-lit-mappings*: ",21));
  const_470=scm_gc_protect(makfromstr((char *)"*prop-atom-maxnr*: ",19));
  const_471=scm_gc_protect(makfromstr((char *)"allocated model search time has run out",39));
  const_472=scm_gc_protect(makfromstr((char *)" check-prop-one-interpretation called on domainsize: ",53));
  const_473=scm_gc_protect(makfromstr((char *)"valuations: ",12));
  const_474=scm_gc_protect(makfromstr((char *)"starting to check satisfiability for symbol interp:",51));
  const_475=scm_gc_protect(makfromstr((char *)"conversion to prop did not find unsatisfiability",48));
  const_476=scm_gc_protect(makfromstr((char *)"conversion to prop found unsatisfiability",41));
  const_477=scm_gc_protect(makfromstr((char *)"pre-evalres: ",13));
  const_478=scm_gc_protect(makfromstr((char *)"full prop evaluation found prop satisfiable",43));
  const_479=scm_gc_protect(makfromstr((char *)"full prop evaluation found prop unsatisfiable",45));
  const_480=scm_gc_protect(makfromstr((char *)"funsymb interp vals: ",21));
  const_481=scm_gc_protect(makfromstr((char *)"evalres: ",9));
  const_482=scm_gc_protect(makfromstr((char *)" = ",3));
  const_483=scm_gc_protect(makfromstr((char *)"*prop-pred-maxval-pairs*:",25));
  const_484=scm_gc_protect(makfromstr((char *)"conversion to prop did not find unsatisfiability",48));
  const_485=scm_gc_protect(makfromstr((char *)"conversion to prop found unsatisfiability",41));
  const_486=scm_gc_protect(makfromstr((char *)"pre-evalres: ",13));
  const_487=scm_gc_protect(makfromstr((char *)"full prop evaluation found prop satisfiable",43));
  const_488=scm_gc_protect(makfromstr((char *)"full prop evaluation found prop unsatisfiable",45));
  const_489=scm_gc_protect(makfromstr((char *)"evalres: ",9));
  const_490=scm_gc_protect(makfromstr((char *)"valuations: ",12));
  const_491=scm_gc_protect(makfromstr((char *)" *prop-interp-termlist* and valuations: ",40));
  const_492=scm_gc_protect(makfromstr((char *)"starting to check satisfiability for symbol interp:",51));
  const_493=scm_gc_protect(makfromstr((char *)"conversion to prop did not find unsatisfiability",48));
  const_494=scm_gc_protect(makfromstr((char *)"conversion to prop found unsatisfiability",41));
  const_495=scm_gc_protect(makfromstr((char *)"pre-evalres: ",13));
  const_496=scm_gc_protect(makfromstr((char *)"full prop evaluation found prop satisfiable",43));
  const_497=scm_gc_protect(makfromstr((char *)"full prop evaluation found prop unsatisfiable",45));
  const_498=scm_gc_protect(makfromstr((char *)"funsymb interp vals: ",21));
  const_499=scm_gc_protect(makfromstr((char *)"evalres: ",9));
  const_500=scm_gc_protect(makfromstr((char *)" = ",3));
  const_501=scm_gc_protect(makfromstr((char *)" *prop-interp-termlist* and valuations: ",40));
}

SCM init_30_resbase()
{
  const_502=scm_gc_protect(makfromstr((char *)" *prop-interp-termlist* and valuations: ",40));
  const_503=scm_gc_protect(makfromstr((char *)"+",1));
  const_504=scm_gc_protect(makfromstr((char *)"-",1));
  const_505=scm_gc_protect(makfromstr((char *)"*",1));
  const_506=scm_gc_protect(makfromstr((char *)"%",1));
  const_507=scm_gc_protect(makfromstr((char *)" = ",3));
  const_508=scm_gc_protect(makfromstr((char *)" = ",3));
  const_509=scm_gc_protect(makfromstr((char *)"bad random: ",12));
  const_510=scm_gc_protect(makfromstr((char *)"predclauses before conversion: ",31));
  const_511=scm_gc_protect(makfromstr((char *)"now convert: ",13));
  const_512=scm_gc_protect(makfromstr((char *)"tmp: ",5));
  const_513=scm_gc_protect(makfromstr((char *)"unsatisfiable:",14));
  const_514=scm_gc_protect(makfromstr((char *)"varslist:",9));
  const_515=scm_gc_protect(makfromstr((char *)"varvaluations:",14));
  const_516=scm_gc_protect(makfromstr((char *)"varlimits:",10));
  const_517=scm_gc_protect(makfromstr((char *)"curproplit generated: ",22));
  const_518=scm_gc_protect(makfromstr((char *)"curproplit pos value so far: ",29));
  const_519=scm_gc_protect(makfromstr((char *)"maxvar: ",8));
  const_520=scm_gc_protect(makfromstr((char *)"varvaluations: ",15));
  const_521=scm_gc_protect(makfromstr((char *)"make-prop-pred-maxval-pairs called:",35));
  const_522=scm_gc_protect(makfromstr((char *)"flatclauses:",12));
  const_523=scm_gc_protect(makfromstr((char *)"domainsize:",11));
  const_524=scm_gc_protect(makfromstr((char *)"*prop-orig-constants-enum*:",27));
  const_525=scm_gc_protect(makfromstr((char *)"*prop-orig-funs-enum*:",22));
  const_526=scm_gc_protect(makfromstr((char *)"create-prop-flat-varlimits called:",34));
  const_527=scm_gc_protect(makfromstr((char *)"varslist:",9));
  const_528=scm_gc_protect(makfromstr((char *)"fullpredclause:",15));
  const_529=scm_gc_protect(makfromstr((char *)"domainsize:",11));
  const_530=scm_gc_protect(makfromstr((char *)"extraclauses:",13));
  const_531=scm_gc_protect(makfromstr((char *)"add-new-prop-cl: ",17));
  const_532=scm_gc_protect(makfromstr((char *)"term: ",6));
  const_533=scm_gc_protect(makfromstr((char *)"fun-may-cont-vars: ",19));
  const_534=scm_gc_protect(makfromstr((char *)"inner term: ",12));
  const_535=scm_gc_protect(makfromstr((char *)"fun-may-cont-vars: ",19));
  const_536=scm_gc_protect(makfromstr((char *)"curlit: ",8));
  const_537=scm_gc_protect(makfromstr((char *)"*prop-lit-mappings*: ",21));
  const_538=scm_gc_protect(makfromstr((char *)"treepart: ",10));
  const_539=scm_gc_protect(makfromstr((char *)"error in pred-to-prop pred evaluation",37));
  const_540=scm_gc_protect(makfromstr((char *)"curlit: ",8));
  const_541=scm_gc_protect(makfromstr((char *)"treepart: ",10));
  const_542=scm_gc_protect(makfromstr((char *)"error in pred-to-prop pred evaluation",37));
  const_543=scm_gc_protect(makfromstr((char *)"make-flat-pred-to-proplit called on: ",37));
  const_544=scm_gc_protect(makfromstr((char *)"curlit: ",8));
  const_545=scm_gc_protect(makfromstr((char *)"*prop-flat-eq-symb*: ",21));
  const_546=scm_gc_protect(makfromstr((char *)"treepart: ",10));
  const_547=scm_gc_protect(makfromstr((char *)"error in pred-to-prop pred evaluation",37));
  const_548=scm_gc_protect(makfromstr((char *)"funargs: ",9));
  const_549=scm_gc_protect(makfromstr((char *)"argval: ",8));
  const_550=scm_gc_protect(makfromstr((char *)"error in pred-to-prop fun evaluation",36));
  const_551=scm_gc_protect(makfromstr((char *)"funargs: ",9));
}

SCM init_31_resbase()
{
  const_552=scm_gc_protect(makfromstr((char *)"argval: ",8));
  const_553=scm_gc_protect(makfromstr((char *)"argspart: ",10));
  const_554=scm_gc_protect(makfromstr((char *)"argval: ",8));
  const_555=scm_gc_protect(makfromstr((char *)"treepart: ",10));
  const_556=scm_gc_protect(makfromstr((char *)"error in pred-to-prop fun evaluation",36));
  const_557=scm_gc_protect(makfromstr((char *)"error in pred-to-prop fun evaluation",36));
  const_558=scm_gc_protect(makfromstr((char *)"error in pred-to-prop fun evaluation",36));
  const_559=scm_gc_protect(makfromstr((char *)"too large clause for flattening satisfiability check",52));
  const_560=scm_gc_protect(makfromstr((char *)"too many vars (over 40) in the clause for the sat checker",57));
  const_561=scm_gc_protect(makfromstr((char *)"too many vars (over 250) in the clause for the sat checker",58));
  const_562=scm_gc_protect(makfromstr((char *)"equality has two non-var args in flatten-composite-term",55));
  const_563=scm_gc_protect(makfromstr((char *)"error in pred-to-prop fun evaluation",36));
  const_564=scm_gc_protect(makfromstr((char *)"too large clause for flattening satisfiability check",52));
  const_565=scm_gc_protect(makfromstr((char *)"too many vars (over 40) in the clause for the sat checker",57));
  const_566=scm_gc_protect(makfromstr((char *)"too many vars (over 250) in the clause for the sat checker",58));
  const_567=scm_gc_protect(makfromstr((char *)"ERROR: function symbol detected",31));
  const_568=scm_gc_protect(makfromstr((char *)"-- prop values initialised",26));
  const_569=scm_gc_protect(makfromstr((char *)"-- prop internal structure built",32));
  const_570=scm_gc_protect(makfromstr((char *)" propositional clauses containing ",34));
  const_571=scm_gc_protect(makfromstr((char *)" variables were built.",22));
  const_572=scm_gc_protect(makfromstr((char *)"clauses for full prop evaluation: ",34));
  const_573=scm_gc_protect(makfromstr((char *)"-- initial-prop-unit-propagate finished:",40));
  const_574=scm_gc_protect(makfromstr((char *)"  satisfiable?: ",16));
  const_575=scm_gc_protect(makfromstr((char *)"-- newsplitvar: ",16));
  const_576=scm_gc_protect(makfromstr((char *)".",1));
  const_577=scm_gc_protect(makfromstr((char *)"p",1));
  const_578=scm_gc_protect(makfromstr((char *)" | ",3));
  const_579=scm_gc_protect(makfromstr((char *)"-",1));
  const_580=scm_gc_protect(makfromstr((char *)"p",1));
  const_581=scm_gc_protect(makfromstr((char *)" | ",3));
  const_582=scm_gc_protect(makfromstr((char *)"-- solve-prop-clauses-branch called: ",37));
  const_583=scm_gc_protect(makfromstr((char *)"  splitvar, splitvalue: ",24));
  const_584=scm_gc_protect(makfromstr((char *)" ",1));
  const_585=scm_gc_protect(makfromstr((char *)"-- newsplitvar: ",16));
  const_586=scm_gc_protect(makfromstr((char *)"-- prop-give-next-split-called, splittable: ",44));
  const_587=scm_gc_protect(makfromstr((char *)"  ",2));
  const_588=scm_gc_protect(makfromstr((char *)"-- prop-give-next-split-called, splittable: ",44));
  const_589=scm_gc_protect(makfromstr((char *)"  ",2));
  const_590=scm_gc_protect(makfromstr((char *)"-- loop-prop-unit-queue called",30));
  const_591=scm_gc_protect(makfromstr((char *)"++ assign-prop-var called: ",27));
  const_592=scm_gc_protect(makfromstr((char *)" ++ prop-resolve-clause called: ",32));
  const_593=scm_gc_protect(makfromstr((char *)" ",1));
  const_594=scm_gc_protect(makfromstr((char *)" ",1));
  const_595=scm_gc_protect(makfromstr((char *)"prop-subsumption started: ",26));
  const_596=scm_gc_protect(makfromstr((char *)".",1));
  const_597=scm_gc_protect(makfromstr((char *)"prop-subsumption ended, subsumed: ",34));
  const_598=scm_gc_protect(makfromstr((char *)"",0));
  const_599=scm_gc_protect(makfromstr((char *)"w",1));
  const_600=scm_gc_protect(makfromstr((char *)"p cnf ",6));
  const_601=scm_gc_protect(makfromstr((char *)" ",1));
}

SCM init_32_resbase()
{
  const_602=scm_gc_protect(makfromstr((char *)"\n",1));
  const_603=scm_gc_protect(makfromstr((char *)"cat ",4));
  const_604=scm_gc_protect(makfromstr((char *)" ",1));
  const_605=scm_gc_protect(makfromstr((char *)" > ",3));
  const_606=scm_gc_protect(makfromstr((char *)"external: ",10));
  const_607=scm_gc_protect(makfromstr((char *)"",0));
  const_608=scm_gc_protect(makfromstr((char *)"3600",4));
  const_609=scm_gc_protect(makfromstr((char *)" ",1));
  const_610=scm_gc_protect(makfromstr((char *)" -t ",4));
  const_611=scm_gc_protect(makfromstr((char *)" > ",3));
  const_612=scm_gc_protect(makfromstr((char *)"external: ",10));
  const_613=scm_gc_protect(makfromstr((char *)"Instance satisfiable",20));
  const_614=scm_gc_protect(makfromstr((char *)"Instance unsatisfiable",22));
  const_615=scm_gc_protect(makfromstr((char *)"r",1));
  const_616=scm_gc_protect(makfromstr((char *)"",0));
  const_617=scm_gc_protect(makfromstr((char *)"",0));
  const_618=scm_gc_protect(makfromstr((char *)"ERROR: cannot read prop prover outputfile",41));
  const_619=scm_gc_protect(makfromstr((char *)"w",1));
  const_620=scm_gc_protect(makfromstr((char *)"p cnf ",6));
  const_621=scm_gc_protect(makfromstr((char *)" ",1));
  const_622=scm_gc_protect(makfromstr((char *)"propclauses: ",13));
  const_623=scm_gc_protect(makfromstr((char *)" ",1));
  const_624=scm_gc_protect(makfromstr((char *)" ",1));
  const_625=scm_gc_protect(makfromstr((char *)" ",1));
  const_626=scm_gc_protect(makfromstr((char *)" ",1));
  const_627=scm_gc_protect(makfromstr((char *)" ",1));
  const_628=scm_gc_protect(makfromstr((char *)" ",1));
  const_629=scm_gc_protect(makfromstr((char *)"w",1));
  const_630=scm_gc_protect(makfromstr((char *)"-- res is: ",11));
  const_631=scm_gc_protect(makfromstr((char *)"showing vars 1 to ",18));
  const_632=scm_gc_protect(makfromstr((char *)" : val, queue, pos, neg",23));
  const_633=scm_gc_protect(makfromstr((char *)": ",2));
  const_634=scm_gc_protect(makfromstr((char *)", ",2));
  const_635=scm_gc_protect(makfromstr((char *)", ",2));
  const_636=scm_gc_protect(makfromstr((char *)"  pos: ",7));
  const_637=scm_gc_protect(makfromstr((char *)"  neg: ",7));
  const_638=scm_gc_protect(makfromstr((char *)"showing clauses: ",17));
  const_639=scm_gc_protect(makfromstr((char *)"*prop-var-assignment-queue* : ",30));
  const_640=scm_gc_protect(makfromstr((char *)"  ",2));
  const_641=scm_gc_protect(makfromstr((char *)"*prop-assigned-varvalpairs* : ",30));
  const_642=scm_gc_protect(makfromstr((char *)"  ",2));
  const_643=scm_gc_protect(makfromstr((char *)"*prop-unsat-found-occlistpart* : ",33));
  const_644=scm_gc_protect(makfromstr((char *)"  ",2));
  const_645=scm_gc_protect(cons(a_symb,cons(b_symb,EOL)));
  const_646=scm_gc_protect(cons(cons(f_symb,MAKINUM(2)),cons(cons(g_symb,MAKINUM(1)),EOL)));
  const_647=scm_gc_protect(cons(cons(p_symb,MAKINUM(1)),cons(cons(r_symb,MAKINUM(0)),EOL)));
  const_648=scm_gc_protect(makfromstr((char *)"Some ground terms were converted.",33));
  const_649=scm_gc_protect(makfromstr((char *)"sem-type finite model building: maximise lnh, trivial order",59));
  const_650=scm_gc_protect(makfromstr((char *)"sem-type finite model building: maximise lnh, standard order",60));
  const_651=scm_gc_protect(makfromstr((char *)"sem-type finite model building: maximise lnh, occurrences order",63));
}

SCM init_33_resbase()
{
  const_652=scm_gc_protect(makfromstr((char *)"sem-type finite model building: maximise lnh, look-ahead order",62));
  const_653=scm_gc_protect(makfromstr((char *)"sem-type finite model building: pure occurrences order",54));
  const_654=scm_gc_protect(makfromstr((char *)"sem-type finite model building: pure look-ahead order",53));
  const_655=scm_gc_protect(makfromstr((char *)"sem-type finite model building: pure look-ahead order",53));
  const_656=scm_gc_protect(makfromstr((char *)"props-build-model called",24));
  const_657=scm_gc_protect(makfromstr((char *)"predclauses: ",13));
  const_658=scm_gc_protect(makfromstr((char *)"nonground prop clauses: ",24));
  const_659=scm_gc_protect(makfromstr((char *)"starting search for domain size ",32));
  const_660=scm_gc_protect(makfromstr((char *)"ground prop clauses initially made: ",36));
  const_661=scm_gc_protect(makfromstr((char *)"ground prop clauses after occ storage: ",39));
  const_662=scm_gc_protect(makfromstr((char *)"clauses after initial propagation of cells: ",44));
  const_663=scm_gc_protect(makfromstr((char *)"clauses after initial analysis: ",32));
  const_664=scm_gc_protect(makfromstr((char *)"clauses after split cells: ",27));
  const_665=scm_gc_protect(makfromstr((char *)"vectors after split cells: ",27));
  const_666=scm_gc_protect(makfromstr((char *)"**** SATISFIABLE ****",21));
  const_667=scm_gc_protect(makfromstr((char *)"allocated model search time has run out",39));
  const_668=scm_gc_protect(makfromstr((char *)"propagating assignment: cell ",29));
  const_669=scm_gc_protect(makfromstr((char *)" becomes ",9));
  const_670=scm_gc_protect(makfromstr((char *)"assignres: ",11));
  const_671=scm_gc_protect(makfromstr((char *)"clauses after assignment: ",26));
  const_672=scm_gc_protect(makfromstr((char *)"vectors after assignment: ",26));
  const_673=scm_gc_protect(makfromstr((char *)"satisfiability found after initial propagation! ",48));
  const_674=scm_gc_protect(makfromstr((char *)"props-split-cells-incremental called with depth: ",49));
  const_675=scm_gc_protect(makfromstr((char *)"| ",2));
  const_676=scm_gc_protect(makfromstr((char *)"selcell:",8));
  const_677=scm_gc_protect(makfromstr((char *)"| ",2));
  const_678=scm_gc_protect(makfromstr((char *)"maxsplitvalue: ",15));
  const_679=scm_gc_protect(makfromstr((char *)"clauses before assignment: ",27));
  const_680=scm_gc_protect(makfromstr((char *)"vectors before assignment: ",27));
  const_681=scm_gc_protect(makfromstr((char *)"| ",2));
  const_682=scm_gc_protect(makfromstr((char *)"value in loop: ",15));
  const_683=scm_gc_protect(makfromstr((char *)"| ",2));
  const_684=scm_gc_protect(makfromstr((char *)"assignres: ",11));
  const_685=scm_gc_protect(makfromstr((char *)"clauses after assignment: ",26));
  const_686=scm_gc_protect(makfromstr((char *)"vectors after assignment: ",26));
  const_687=scm_gc_protect(makfromstr((char *)"satisfiability found after assignment! ",39));
  const_688=scm_gc_protect(makfromstr((char *)"clauses after assignment: ",26));
  const_689=scm_gc_protect(makfromstr((char *)"vectors after assignment: ",26));
  const_690=scm_gc_protect(makfromstr((char *)"| ",2));
  const_691=scm_gc_protect(makfromstr((char *)"recres: ",8));
  const_692=scm_gc_protect(makfromstr((char *)"Cell selection found all cells to have assigned values!",55));
  const_693=scm_gc_protect(makfromstr((char *)"model size: ",12));
  const_694=scm_gc_protect(makfromstr((char *)"nr of cells: ",13));
  const_695=scm_gc_protect(makfromstr((char *)"model found at split search depth: ",35));
  const_696=scm_gc_protect(makfromstr((char *)"split selections done: ",23));
  const_697=scm_gc_protect(makfromstr((char *)"assignments done: ",18));
  const_698=scm_gc_protect(makfromstr((char *)"restrictions done: ",19));
  const_699=scm_gc_protect(makfromstr((char *)"terms rewritten: ",17));
  const_700=scm_gc_protect(makfromstr((char *)"nterms assigned: ",17));
  const_701=scm_gc_protect(makfromstr((char *)"nterms restricted: ",19));
}

SCM init_34_resbase()
{
  const_702=scm_gc_protect(makfromstr((char *)"new derivations from nterm: ",28));
  const_703=scm_gc_protect(makfromstr((char *)"clauses generated: ",19));
  const_704=scm_gc_protect(makfromstr((char *)"MODEL STARTS",12));
  const_705=scm_gc_protect(makfromstr((char *)"=",1));
  const_706=scm_gc_protect(makfromstr((char *)"t",1));
  const_707=scm_gc_protect(makfromstr((char *)"f",1));
  const_708=scm_gc_protect(makfromstr((char *)"MODEL ENDS",10));
  const_709=scm_gc_protect(makfromstr((char *)"nr of cells: ",13));
  const_710=scm_gc_protect(makfromstr((char *)"split selections done: ",23));
  const_711=scm_gc_protect(makfromstr((char *)"assignments done: ",18));
  const_712=scm_gc_protect(makfromstr((char *)"restrictions done: ",19));
  const_713=scm_gc_protect(makfromstr((char *)"terms rewritten: ",17));
  const_714=scm_gc_protect(makfromstr((char *)"nterms assigned: ",17));
  const_715=scm_gc_protect(makfromstr((char *)"nterms restricted: ",19));
  const_716=scm_gc_protect(makfromstr((char *)"new derivations from nterm: ",28));
  const_717=scm_gc_protect(makfromstr((char *)"clauses generated: ",19));
  const_718=scm_gc_protect(makfromstr((char *)"***** props-select-split-cell called ***** ",43));
  const_719=scm_gc_protect(makfromstr((char *)"maxsplitvalue: ",15));
  const_720=scm_gc_protect(makfromstr((char *)" domainsize: ",13));
  const_721=scm_gc_protect(makfromstr((char *)"ordered cell vectors used in props-select-split-cell: ",54));
  const_722=scm_gc_protect(makfromstr((char *)" : ",3));
  const_723=scm_gc_protect(makfromstr((char *)" : ",3));
  const_724=scm_gc_protect(makfromstr((char *)"orig=",5));
  const_725=scm_gc_protect(makfromstr((char *)" cterm=",7));
  const_726=scm_gc_protect(makfromstr((char *)" range=",7));
  const_727=scm_gc_protect(makfromstr((char *)" occs=",6));
  const_728=scm_gc_protect(makfromstr((char *)"props-select-split-cell-restricted-initial called:",50));
  const_729=scm_gc_protect(makfromstr((char *)"props-select-split-cell-restricted-initial called:",50));
  const_730=scm_gc_protect(makfromstr((char *)"props-select-split-cell-restricted-secondary called:",52));
  const_731=scm_gc_protect(makfromstr((char *)"bestnr found: ",14));
  const_732=scm_gc_protect(makfromstr((char *)"maxarg found: ",14));
  const_733=scm_gc_protect(makfromstr((char *)"props-select-split-cell-restricted-secondary called:",52));
  const_734=scm_gc_protect(makfromstr((char *)"bestnr found: ",14));
  const_735=scm_gc_protect(makfromstr((char *)"maxarg found: ",14));
  const_736=scm_gc_protect(makfromstr((char *)"props-select-split-cell-unrestricted called:",44));
  const_737=scm_gc_protect(makfromstr((char *)"props-select-split-cell-occurrences called:",43));
  const_738=scm_gc_protect(makfromstr((char *)"--- pre-assign comparison starts --- ",37));
  const_739=scm_gc_protect(makfromstr((char *)"trying cell: ",13));
  const_740=scm_gc_protect(makfromstr((char *)" : ",3));
  const_741=scm_gc_protect(makfromstr((char *)" : ",3));
  const_742=scm_gc_protect(makfromstr((char *)"with value: ",12));
  const_743=scm_gc_protect(makfromstr((char *)"assignres : ",12));
  const_744=scm_gc_protect(makfromstr((char *)" new assigns: ",14));
  const_745=scm_gc_protect(makfromstr((char *)" new restricts: ",16));
  const_746=scm_gc_protect(makfromstr((char *)" measure: ",10));
  const_747=scm_gc_protect(makfromstr((char *)"selection found cell with FALSE values!",39));
  const_748=scm_gc_protect(makfromstr((char *)"selection found cell with one OK value!",39));
  const_749=scm_gc_protect(makfromstr((char *)"- - pre-assign comparison selects cell nr: ",43));
  const_750=scm_gc_protect(makfromstr((char *)"props-assign-cell! called on: ",30));
  const_751=scm_gc_protect(makfromstr((char *)" ",1));
}

SCM init_35_resbase()
{
  const_752=scm_gc_protect(makfromstr((char *)"props-restrict-cell! called on: ",32));
  const_753=scm_gc_protect(makfromstr((char *)" ",1));
  const_754=scm_gc_protect(makfromstr((char *)"props-analyze-clause! called on: ",33));
  const_755=scm_gc_protect(makfromstr((char *)"clause analysis about to end: ",30));
  const_756=scm_gc_protect(makfromstr((char *)"falseflag: ",11));
  const_757=scm_gc_protect(makfromstr((char *)"stopflag: ",10));
  const_758=scm_gc_protect(makfromstr((char *)"foundtype: ",11));
  const_759=scm_gc_protect(makfromstr((char *)"foundres: ",10));
  const_760=scm_gc_protect(makfromstr((char *)"props-analyze-clause! called on: ",33));
  const_761=scm_gc_protect(makfromstr((char *)"clause analysis about to end: ",30));
  const_762=scm_gc_protect(makfromstr((char *)"falseflag: ",11));
  const_763=scm_gc_protect(makfromstr((char *)"stopflag: ",10));
  const_764=scm_gc_protect(makfromstr((char *)"foundtype: ",11));
  const_765=scm_gc_protect(makfromstr((char *)"foundres: ",10));
  const_766=scm_gc_protect(makfromstr((char *)"Too many possible combinations for model finder.",48));
  const_767=scm_gc_protect(makfromstr((char *)"props-assign-nterm! called on: ",31));
  const_768=scm_gc_protect(makfromstr((char *)"ntermnr: ",9));
  const_769=scm_gc_protect(makfromstr((char *)"ctermnr: ",9));
  const_770=scm_gc_protect(makfromstr((char *)"value: ",7));
  const_771=scm_gc_protect(makfromstr((char *)"props-restrict-nterm! called on: ",33));
  const_772=scm_gc_protect(makfromstr((char *)"ntermnr: ",9));
  const_773=scm_gc_protect(makfromstr((char *)"ctermnr: ",9));
  const_774=scm_gc_protect(makfromstr((char *)"value: ",7));
  const_775=scm_gc_protect(makfromstr((char *)" : ",3));
  const_776=scm_gc_protect(makfromstr((char *)" | ",3));
  const_777=scm_gc_protect(makfromstr((char *)".",1));
  const_778=scm_gc_protect(makfromstr((char *)" : ",3));
  const_779=scm_gc_protect(makfromstr((char *)"clause literal does not point to clause",39));
  const_780=scm_gc_protect(makfromstr((char *)" | ",3));
  const_781=scm_gc_protect(makfromstr((char *)".",1));
  const_782=scm_gc_protect(makfromstr((char *)"v",1));
  const_783=scm_gc_protect(makfromstr((char *)"c",1));
  const_784=scm_gc_protect(makfromstr((char *)"-",1));
  const_785=scm_gc_protect(makfromstr((char *)"l",1));
  const_786=scm_gc_protect(makfromstr((char *)"f",1));
  const_787=scm_gc_protect(makfromstr((char *)"(",1));
  const_788=scm_gc_protect(makfromstr((char *)",",1));
  const_789=scm_gc_protect(makfromstr((char *)")",1));
  const_790=scm_gc_protect(makfromstr((char *)"c",1));
  const_791=scm_gc_protect(makfromstr((char *)"(",1));
  const_792=scm_gc_protect(makfromstr((char *)"term does not point to superterm",32));
  const_793=scm_gc_protect(makfromstr((char *)",",1));
  const_794=scm_gc_protect(makfromstr((char *)")",1));
  const_795=scm_gc_protect(makfromstr((char *)"c",1));
  const_796=scm_gc_protect(makfromstr((char *)"-",1));
  const_797=scm_gc_protect(makfromstr((char *)"(",1));
  const_798=scm_gc_protect(makfromstr((char *)"term does not point to superterm",32));
  const_799=scm_gc_protect(makfromstr((char *)",",1));
  const_800=scm_gc_protect(makfromstr((char *)")",1));
  const_801=scm_gc_protect(makfromstr((char *)"function vectors: ",18));
}

SCM init_36_resbase()
{
  const_802=scm_gc_protect(makfromstr((char *)" : ",3));
  const_803=scm_gc_protect(makfromstr((char *)" orig=",6));
  const_804=scm_gc_protect(makfromstr((char *)" orignr=",8));
  const_805=scm_gc_protect(makfromstr((char *)" ispred=",8));
  const_806=scm_gc_protect(makfromstr((char *)" arity=",7));
  const_807=scm_gc_protect(makfromstr((char *)" base=",6));
  const_808=scm_gc_protect(makfromstr((char *)"cell vectors: ",14));
  const_809=scm_gc_protect(makfromstr((char *)" : ",3));
  const_810=scm_gc_protect(makfromstr((char *)"orig=",5));
  const_811=scm_gc_protect(makfromstr((char *)" cterm=",7));
  const_812=scm_gc_protect(makfromstr((char *)" range=",7));
  const_813=scm_gc_protect(makfromstr((char *)" occs=",6));
  const_814=scm_gc_protect(makfromstr((char *)"nterm vectors: ",15));
  const_815=scm_gc_protect(makfromstr((char *)" : ",3));
  const_816=scm_gc_protect(makfromstr((char *)"orig=",5));
  const_817=scm_gc_protect(makfromstr((char *)" values=",8));
  const_818=scm_gc_protect(makfromstr((char *)" matchcells=",12));
  const_819=scm_gc_protect(makfromstr((char *)"NB! wrong model found, not accepted, search stopped.",52));
  const_820=scm_gc_protect(makfromstr((char *)"-time",5));
  const_821=scm_gc_protect(makfromstr((char *)"Wrong time format: use a number.",32));
  const_822=scm_gc_protect(makfromstr((char *)"Gandalf c-2.6 r1 starting, but no input files given:",52));
  const_823=scm_gc_protect(makfromstr((char *)"halting.",8));
  const_824=scm_gc_protect(makfromstr((char *)"-sat",4));
  const_825=scm_gc_protect(makfromstr((char *)"Gandalf c-2.6 r1 starting to show satisfiability: ",50));
  const_826=scm_gc_protect(makfromstr((char *)"-proof",6));
  const_827=scm_gc_protect(makfromstr((char *)"Gandalf c-2.6 r1 starting to prove (full proof mode): ",54));
  const_828=scm_gc_protect(makfromstr((char *)"Gandalf c-2.6 r1 starting to prove: ",36));
  const_829=scm_gc_protect(cons(EOL,EOL));
  const_830=scm_gc_protect(makfromstr((char *)"11111111",8));
  const_831=scm_gc_protect(makfromstr((char *)"1111",4));
  const_832=scm_gc_protect(cons(cons(MAKINUM(0),EOL),EOL));
  const_833=scm_gc_protect(cons(EOL,EOL));
  const_834=scm_gc_protect(cons(EOL,EOL));
  const_835=scm_gc_protect(cons(EOL,EOL));
  const_836=scm_gc_protect(cons(EOL,EOL));
  const_837=scm_gc_protect(makfromstr((char *)"",0));
  const_838=scm_gc_protect(makfromstr((char *)"|",1));
  const_839=scm_gc_protect(makfromstr((char *)"x@",2));
  const_840=scm_gc_protect(makfromstr((char *)"$",1));
  const_841=scm_gc_protect(makfromstr((char *)".tmp",4));
  const_842=scm_gc_protect(makfromstr((char *)"",0));
  const_843=scm_gc_protect(makfromstr((char *)".res",4));
  const_844=scm_gc_protect(makfromstr((char *)" ",1));
  const_845=scm_gc_protect(cons(cons(MAKINUM(1),x_symb),cons(cons(MAKINUM(2),y_symb),cons(cons(MAKINUM(3),z_symb),cons(cons(MAKINUM(4),u_symb),cons(cons(MAKINUM(5),v_symb),cons(cons(MAKINUM(6),w_symb),EOL)))))));
  const_846=scm_gc_protect(makfromstr((char *)"No argument file name given: going interactive.",47));
  const_847=scm_gc_protect(makfromstr((char *)"tmp2.in",7));
  const_848=scm_gc_protect(makfromstr((char *)"/tmp/ganprglin",14));
  const_849=scm_gc_protect(makfromstr((char *)"/tmp/ganprgltmp",15));
  const_850=scm_gc_protect(makfromstr((char *)"/tmp/ganprhdrtmp",16));
  const_851=scm_gc_protect(makfromstr((char *)"/tmp/ganprrslt",14));
}

SCM init_37_resbase()
{
  const_852=scm_gc_protect(makfromstr((char *)"",0));
  const_853=scm_gc_protect(makfromstr((char *)"",0));
  const_854=scm_gc_protect(makfromstr((char *)"",0));
  const_855=scm_gc_protect(makfromstr((char *)"",0));
  const_856=scm_gc_protect(cons(cons(cons(MAKINUM(1),cons(MAKINUM(2),cons(MAKINUM(3),EOL))),EOL),cons(cons(cons(MAKINUM(1),cons(MAKINUM(2),EOL)),cons(MAKINUM(3),EOL)),cons(cons(cons(MAKINUM(1),cons(MAKINUM(3),EOL)),cons(MAKINUM(2),EOL)),cons(cons(cons(MAKINUM(2),cons(MAKINUM(3),EOL)),cons(MAKINUM(1),EOL)),cons(cons(cons(MAKINUM(1),EOL),cons(MAKINUM(2),cons(MAKINUM(3),EOL))),cons(cons(cons(MAKINUM(2),EOL),cons(MAKINUM(1),cons(MAKINUM(3),EOL))),cons(cons(cons(MAKINUM(3),EOL),cons(MAKINUM(1),cons(MAKINUM(2),EOL))),cons(cons(EOL,cons(MAKINUM(1),cons(MAKINUM(2),cons(MAKINUM(3),EOL)))),EOL)))))))));
  const_858=scm_gc_protect(makfromstr((char *)"27f3571a",8));
  const_859=scm_gc_protect(makfromstr((char *)"a7b690e2",8));
  const_860=scm_gc_protect(makfromstr((char *)"e024fd90",8));
  const_861=scm_gc_protect(makfromstr((char *)"0068a7b5",8));
  const_862=scm_gc_protect(makfromstr((char *)"a0befc36",8));
  const_863=scm_gc_protect(makfromstr((char *)"daf805ab",8));
  const_864=scm_gc_protect(makfromstr((char *)"b12278d6",8));
  const_865=scm_gc_protect(makfromstr((char *)"13efa13a",8));
  const_866=scm_gc_protect(makfromstr((char *)"851fa9ab",8));
  const_867=scm_gc_protect(makfromstr((char *)"5890abcb",8));
  const_868=scm_gc_protect(makfromstr((char *)"e67890a5",8));
  const_869=scm_gc_protect(makfromstr((char *)"845678c5",8));
  const_870=scm_gc_protect(makfromstr((char *)"823ef5ef",8));
  const_871=scm_gc_protect(makfromstr((char *)"28274ef6",8));
  const_872=scm_gc_protect(makfromstr((char *)"578ef23f",8));
  const_873=scm_gc_protect(makfromstr((char *)"8b0a3233",8));
  const_874=scm_gc_protect(makfromstr((char *)"d1e67bda",8));
  const_875=scm_gc_protect(makfromstr((char *)"871c9cd1",8));
  const_876=scm_gc_protect(makfromstr((char *)"5b892496",8));
  const_877=scm_gc_protect(makfromstr((char *)"57798841",8));
  const_878=scm_gc_protect(makfromstr((char *)"9cdd1404",8));
  const_879=scm_gc_protect(makfromstr((char *)"4ad6829b",8));
  const_880=scm_gc_protect(makfromstr((char *)"907abcbb",8));
  const_881=scm_gc_protect(makfromstr((char *)"61222224",8));
  const_882=scm_gc_protect(makfromstr((char *)"2678e141",8));
  const_883=scm_gc_protect(makfromstr((char *)"6912bccc",8));
  const_884=scm_gc_protect(makfromstr((char *)"e6690270",8));
  const_885=scm_gc_protect(makfromstr((char *)"1891c1d4",8));
  const_886=scm_gc_protect(makfromstr((char *)"fe2acd8d",8));
  const_887=scm_gc_protect(makfromstr((char *)"1ea055e1",8));
  const_888=scm_gc_protect(makfromstr((char *)"5f0cccba",8));
  const_889=scm_gc_protect(makfromstr((char *)"105996a0",8));
  const_890=scm_gc_protect(makfromstr((char *)"a982efa9",8));
  const_891=scm_gc_protect(makfromstr((char *)"616c5a86",8));
  const_892=scm_gc_protect(makfromstr((char *)"1bbdac53",8));
  const_893=scm_gc_protect(makfromstr((char *)"70abcddc",8));
  const_894=scm_gc_protect(makfromstr((char *)"54734567",8));
  const_895=scm_gc_protect(makfromstr((char *)"c0366273",8));
  const_896=scm_gc_protect(makfromstr((char *)"4c519210",8));
  const_897=scm_gc_protect(makfromstr((char *)"85444454",8));
  const_898=scm_gc_protect(makfromstr((char *)"34444292",8));
  const_899=scm_gc_protect(makfromstr((char *)"dddecc08",8));
  const_900=scm_gc_protect(makfromstr((char *)"e064ef27",8));
  const_901=scm_gc_protect(makfromstr((char *)"3fd3efcd",8));
  const_902=scm_gc_protect(makfromstr((char *)"9cbd3efd",8));
}

SCM init_38_resbase()
{
  const_903=scm_gc_protect(makfromstr((char *)"fabcdef8",8));
  const_904=scm_gc_protect(makfromstr((char *)"0bcd56d3",8));
  const_905=scm_gc_protect(makfromstr((char *)"a6794679",8));
  const_906=scm_gc_protect(makfromstr((char *)"0be45590",8));
  const_907=scm_gc_protect(makfromstr((char *)"b54ef879",8));
  const_908=scm_gc_protect(makfromstr((char *)"f3675fb3",8));
  const_909=scm_gc_protect(makfromstr((char *)"76783fbd",8));
  const_910=scm_gc_protect(makfromstr((char *)"e33f7843",8));
  const_911=scm_gc_protect(makfromstr((char *)"fd330ab3",8));
  const_912=scm_gc_protect(makfromstr((char *)"d909ef3e",8));
  const_857=scm_gc_protect(vector(cons(const_912,cons(const_911,cons(const_910,cons(const_909,cons(const_908,cons(const_907,cons(const_906,cons(const_905,cons(const_904,cons(const_903,cons(const_902,cons(const_901,cons(const_900,cons(const_899,cons(const_898,cons(const_897,cons(const_896,cons(const_895,cons(const_894,cons(const_893,cons(const_892,cons(const_891,cons(const_890,cons(const_889,cons(const_888,cons(const_887,cons(const_886,cons(const_885,cons(const_884,cons(const_883,cons(const_882,cons(const_881,cons(const_880,cons(const_879,cons(const_878,cons(const_877,cons(const_876,cons(const_875,cons(const_874,cons(const_873,cons(const_872,cons(const_871,cons(const_870,cons(const_869,cons(const_868,cons(const_867,cons(const_866,cons(const_865,cons(const_864,cons(const_863,cons(const_862,cons(const_861,cons(const_860,cons(const_859,cons(const_858,cons(MAKINUM(0),EOL))))))))))))))))))))))))))))))))))))))))))))))))))))))))));
  top_actions_resbase();
  _star_var_val_table_star__velts0=VELTS(GLOBAL(var_val_table_global));
  _star_var_touched_table_star__velts0=VELTS(GLOBAL(var_touched_table_global));
}

SCM init_resbase()
{
  init_1_resbase();
  init_2_resbase();
  init_3_resbase();
  init_4_resbase();
  init_5_resbase();
  init_6_resbase();
  init_7_resbase();
  init_8_resbase();
  init_9_resbase();
  init_10_resbase();
  init_11_resbase();
  init_12_resbase();
  init_13_resbase();
  init_14_resbase();
  init_15_resbase();
  init_16_resbase();
  init_17_resbase();
  init_18_resbase();
  init_19_resbase();
  init_20_resbase();
  init_21_resbase();
  init_22_resbase();
  init_23_resbase();
  init_24_resbase();
  init_25_resbase();
  init_26_resbase();
  init_27_resbase();
  init_28_resbase();
  init_29_resbase();
  init_30_resbase();
  init_31_resbase();
  init_32_resbase();
  init_33_resbase();
  init_34_resbase();
  init_35_resbase();
  init_36_resbase();
  init_37_resbase();
  init_38_resbase();
}

